C
C     SFCHECK
C     Copyright (C) 1999-2007 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C --- SFCHECK ---
C ------------------------------------------------------------
      INTEGER IARGC
C
C --- MEMORY - memory for densities, gradients, coordinates, ...
      INTEGER MEMORY
      PARAMETER ( MEMORY=80 000 000)
C-MEM-
C      REAL      POOL(MEMORY)
C-MEM-
      REAL, ALLOCATABLE :: POOL(:)
C-MEM-
C --- NCRDMAX - maximal number of coordinates
      INTEGER  NCRDMAX
      PARAMETER ( NCRDMAX=800000)
C --- IPRSYM - maximal number of symmetry operators
      INTEGER IPRSYM
      PARAMETER ( IPRSYM=96    )
      INTEGER*2 ISYM(5,3,IPRSYM)
c
      INTEGER   MEM,MEMORY_IN,NCRDMAX_IN,NOMIT,NARGC,ISTAT,IMEM
      INTEGER   INVER
      REAL      DSCALE,BOFF_IN
      INTEGER   I,II,L1,L2,LEN
      CHARACTER TXT(2)*512
C
      CHARACTER FILE_F_IN*256,FILE_CRD_IN*256
      CHARACTER PATH_OUT*256,PATH_SCR*256,VCCP4*1
      CHARACTER KEY_INF*1,KEY_REST*1,KEY_OUT*1,NOMIT_TXT*60
      CHARACTER KEY_F*30,KEY_SIGF*30,KEY_I*30,KEY_SIGI*30
      CHARACTER KEY_MAP*1,KEY_FREE*30,KEY_P*30
      CHARACTER MEMORY_TXT*256,NCRDMAX_TXT*256,VERS*1
      CHARACTER SCALE_TXT*256,BOFF_TXT*256
c ---------------------------------------------
      NCRDMAX_TXT  = ' '
      MEMORY_TXT   = ' '
      FILE_F_IN    = ' '
      FILE_CRD_IN  = ' '
      PATH_OUT     = ' '
      PATH_SCR     = ' '
      KEY_INF      = ' '
      KEY_REST     = ' '
      KEY_OUT      = ' '
      KEY_F        = ' '
      KEY_P        = ' '
      KEY_SIGF     = ' '
      KEY_I        = ' '
      KEY_SIGI     = ' '
      KEY_MAP      = ' '
      KEY_FREE     = ' '
      NOMIT_TXT    = ' '
      VCCP4        = 'N'
      VERS         = ' '
      SCALE_TXT    = ' '
      BOFF_TXT     = ' '
      IORIGIN      = 0
      INVER        = 0
      DSCALE       = 0.0
      BOFF_IN      = 0.0
      IOCC         = 0
C ----
      CALL GETARG(0,TXT(1))
C
c      WRITE(*,'(A,A,A)') 'TXT0:',TXT(1)(1:50),';'
c      WRITE(*,'(A,I8)') 'IARG:',IARGC()
C
      IADD = 0
      II   = 0
      NARGC = IARGC()

      IF(NARGC.GT.0) THEN
        DO I=1,NARGC
          III = I + IADD
          II = MOD(III,2)
          IF(II.EQ.0) II = 2
          CALL GETARG(I,TXT(II))
          CALL LENSTR_BL(TXT(II),L)
          IF(II.EQ.1) L1 = L
          IF(II.EQ.2) L2 = L

c          WRITE(*,'(A,I3,i3,i3,i3)') 'i,ii,ii,iadd:',i,ii,ii,iadd    
c          WRITE(*,'(A,I3,A,A,A)') 'TXTii',II,':',TXT(II)(1:50),';'
          
          IF(II.EQ.2) THEN
            CALL LENSTR_BL(TXT(1),L1)
            CALL LENSTR_BL(TXT(2),L2)
            IF(     TXT(1)(1:L1).EQ.'HKLIN'.OR.
     *              TXT(1)(1:L1).EQ.'hklin'.OR.
     *              TXT(1)(1:L1).EQ.'-f'      ) THEN
              FILE_F_IN = TXT(2)(1:L2)
              IF(TXT(1)(1:L1).EQ.'-f') THEN
                VCCP4 = 'C'
              ELSE
                VCCP4 = 'Y'
              ENDIF

            ELSE IF(TXT(1)(1:L1).EQ.'MAPIN'.OR.
     *              TXT(1)(1:L1).EQ.'mapin') THEN
              FILE_F_IN = TXT(2)(1:L2)
              VCCP4 = 'Y'

            ELSE IF(TXT(1)(1:L1).EQ.'XYZIN'.OR.
     *              TXT(1)(1:L1).EQ.'xyzin'.OR.
     *              TXT(1)(1:L1).EQ.'-m'      ) THEN
              FILE_CRD_IN = TXT(2)(1:L2)
              IF(TXT(1)(1:L1).EQ.'-m') THEN
                VCCP4 = 'C'
              ELSE
                VCCP4 = 'Y'
              ENDIF
            ELSE IF(TXT(1)(1:L1).EQ.'PATH_OUT'.OR.
     *              TXT(1)(1:L1).EQ.'path_out'.OR.
     *              TXT(1)(1:L1).EQ.'-po'      ) THEN
              PATH_OUT = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'PATH_SCR'.OR.
     *              TXT(1)(1:L1).EQ.'path_scr'.OR.
     *              TXT(1)(1:L1).EQ.'-ps'      ) THEN
              PATH_SCR = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-out'      ) THEN
              KEY_OUT = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-nomit'      ) THEN
              NOMIT_TXT = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-lf'      ) THEN
              KEY_F = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-lp'      ) THEN
              KEY_P = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-lsf'      ) THEN
              KEY_SIGF = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-li'      ) THEN
              KEY_I = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-lsi'      ) THEN
              KEY_SIGI = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-lfree'      ) THEN
              KEY_FREE = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-mem'     ) THEN
              MEMORY_TXT = TXT(2)(1:L2)
              VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'-na'      ) THEN
              NCRDMAX_TXT = TXT(2)(1:L2)
              VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'-scl'      ) THEN
              SCALE_TXT = TXT(2)(1:L2)
              VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'-boff'      ) THEN
              BOFF_TXT = TXT(2)(1:L2)
              VCCP4 = 'C'
            ELSE
              WRITE(*,*) 'input command line error: unknown keyword:'
     *                   //TXT(1)(1:L1)
              GO TO 1000
            ENDIF
            IF(TXT(2)(1:1).EQ.'-') THEN
              WRITE(*,*) 'input command line error: keyword:'
     *                   //TXT(1)(1:L1)//'  without parameter'
                GO TO 1000
            ENDIF
          ELSE IF(TXT(1)(1:L1).EQ.'-h'       ) THEN
            KEY_INF = 'Y'
            VCCP4 = 'C'
            IADD  = IADD + 1
            II    = 2
          ELSE IF(TXT(1)(1:L1).EQ.'-r'       ) THEN
            KEY_REST = 'Y'
            VCCP4 = 'C'
            IADD  = IADD + 1
            II    = 2
          ELSE IF(TXT(1)(1:L1).EQ.'-invert'  ) THEN
            INVER = 1
            VCCP4 = 'C'
            IADD  = IADD + 1
            II    = 2
          ELSE IF(TXT(1)(1:L1).EQ.'-origin'  ) THEN
            IORIGIN = 1
            VCCP4 = 'C'
            IADD  = IADD + 1
            II    = 2
          ELSE IF(TXT(1)(1:L1).EQ.'-map'      ) THEN
            KEY_MAP = 'Y'
            VCCP4 = 'C'
            IADD  = IADD + 1
            II    = 2
          ELSE IF(TXT(1)(1:L1).EQ.'-occ'      ) THEN
            IOCC = 1
            VCCP4 = 'C'
            IADD  = IADD + 1
            II    = 2
          ENDIF
        ENDDO
        IF(II.EQ.1.AND.NARGC.GT.1) THEN
          WRITE(*,*) ' wrong input command line'
          GO TO 1000
        ENDIF
      ENDIF

      CALL LENSTR_BL(NCRDMAX_TXT,LEN)
      IF(LEN.GT.0) THEN
        READ(NCRDMAX_TXT(1:LEN),*) NCRDMAX_IN
        NCRDMAX_IN = NCRDMAX_IN*8
      ELSE
        NCRDMAX_IN = NCRDMAX
      ENDIF

      CALL LENSTR_BL(SCALE_TXT,LEN)
      IF(LEN.GT.0) THEN
        READ(SCALE_TXT(1:LEN),*) DSCALE
      ENDIF

      CALL LENSTR_BL(BOFF_TXT,LEN)
      IF(LEN.GT.0) THEN
        READ(BOFF_TXT(1:LEN),*) BOFF_IN
      ENDIF

      IMEM = 0
      CALL LENSTR_BL(MEMORY_TXT,LEN)
      IF(LEN.GT.0) THEN
        READ(MEMORY_TXT(1:LEN),*) MEM
        MEMORY_IN = MEM * 1 000 000
        IMEM = 1
      ELSE
        MEMORY_IN = MEMORY
        MEM = MEMORY_IN/1 000 000
      ENDIF

      ISTAT = 0
C-MEM-
      VERS = 'M'
      IF(.NOT.ALLOCATED(POOL)) ALLOCATE(POOL(MEMORY_IN),STAT=ISTAT)
C-MEM-
      IF(ISTAT.NE.0) THEN
        WRITE(*,*) 'ERROR: in memory allocation'
        WRITE(*,*) '       memory :',MEM,'Mb  not available'
        WRITE(*,*) '       use option -mem N , where N memory in Mb'
        STOP
      ENDIF
      IF(VERS.EQ.' '.AND.IMEM.NE.0) THEN
        WRITE(*,*) 'WARNING: this option (-mem) for fortran f90 only'
        MEMORY_IN = MEMORY
      ENDIF

c      CALL LENSTR_BL(FILE_F_IN,L1)
c      IF(L1.GT.0) WRITE(*,*) 'FILE_F_IN    :',FILE_F_IN(1:L1)
c      CALL LENSTR_BL(FILE_CRD_IN,L1)
c      IF(L1.GT.0) WRITE(*,*) 'FILE_CRD_IN  :',FILE_CRD_IN(1:L1)
c      CALL LENSTR_BL(PATH_OUT,L1)
c      IF(L1.GT.0) WRITE(*,*) 'PATH_OUT     :',PATH_OUT(1:L1)
c      CALL LENSTR_BL(PATH_SCR,L1)
c      IF(L1.GT.0) WRITE(*,*) 'PATH_SCR     :',PATH_SCR(1:L1)

C ---
      CALL LENSTR_BL(NOMIT_TXT,LEN)
      IF(LEN.GT.0) THEN
        READ(NOMIT_TXT(1:LEN),*) NOMIT
      ELSE
        NOMIT = 0
      ENDIF
C ---
      CALL MAIN_SFCHECK(MEMORY_IN,POOL,NCRDMAX_IN,IPRSYM,ISYM
     *   ,IORIGIN,INVER,DSCALE,BOFF_IN
     *   ,KEY_P,KEY_INF,KEY_REST,KEY_OUT,NOMIT,IOCC
     *   ,KEY_F,KEY_SIGF,KEY_I,KEY_SIGI,KEY_FREE,KEY_MAP,VERS
     *   ,FILE_F_IN,FILE_CRD_IN,PATH_OUT,PATH_SCR,VCCP4)
C-MEM-
      DEALLOCATE(POOL)
C-MEM-
C ---
 1000 CONTINUE
      END

      SUBROUTINE MAIN_SFCHECK(MEMORY,POOL,NCRDMAX,IPRSYM,ISYM
     *   ,IORIGIN,INVER,DSCALE,BOFF_IN
     *   ,KEY_P,KEY_INF,KEY_REST,KEY_OUT,NOMIT,IOCC
     *   ,KEY_F,KEY_SIGF,KEY_I,KEY_SIGI,KEY_FREE,KEY_MAP,VERS
     *   ,FILE_F_IN,FILE_CRD_IN,PATH_OUT,PATH_SCR,VCCP4)
C ------------------------------------------------------------
      INTEGER   MEMORY
      REAL      POOL(MEMORY)
      INTEGER   NCRDMAX,NOMIT,INVER
      REAL      DSCALE,BOFF_IN
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER FILE_F_IN*(*),FILE_CRD_IN*(*)
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),VCCP4*1,VERS*1
      CHARACTER KEY_P*30,KEY_INF*1,KEY_REST*1,KEY_OUT*1
      CHARACTER KEY_F*30,KEY_SIGF*30,KEY_I*30,KEY_SIGI*30,KEY_FREE*30
      CHARACTER KEY_MAP*1
C ----
      PARAMETER ( IPRROW=21    )
      REAL      RESULT (IPRROW,45)
      REAL      RESULTA(IPRROW,21)
      REAL      RESULTB(IPRROW,21)
      REAL      RESULTC(IPRROW,21)
C ---
      INTEGER   MDOC,IERR,NGROUP,NSETT
      CHARACTER LINE*256,PATH*256,EXT*3
      CHARACTER FILE_PDB*256,FILE_CIF*256,FILE_PH*256,FILE_MAP*256
      CHARACTER MSG*1,GROUP*20,MAP*1,OUT*1,TEST*1,PHASES*1,P1*1

      CHARACTER NAME_MTZ_OUT*256,FILE_PH_OMIT*256,NAME*256,NAMEF*256
      CHARACTER NAME_MAP_OUT*256,NAMES*256

      CHARACTER STAT*1,CFREE*1,CSIG*1,CFOM*1,ANOM*1,MTZ*1,CCP4*1

      CHARACTER LABEL(20)*30
      CHARACTER DEFAULT_F*30,DEFAULT_SIGF*30,DEFAULT_FREE*30
      CHARACTER LINE_CCP4*600
C
C      1  2   3   4    5  6   7     8    9    10    11
C     F  SF F(-) SF(-) DP SDP INTP SINTP INTM SINTM FREE   
C ---
      INCLUDE 'sfch_version.fh'
C ---
C==================================================================
C-CCP4 
      IF(VCCP4.EQ.'Y') THEN
        CALL SFCHECK_INIT_CCP4
C---- Initialize ccp4 like file organization
C      CALL CCPFYP
C      ISYSW = 6
C      CALL CCPRCS(ISYSW,'Sfcheck '//VERSNO,
C     + '$Date: 2008/07/16 08:31:46 $')
C      WRITE (ISYSW, 6000)
C6000  FORMAT (  
C     +' $TEXT:Reference1: $$ comment $$ '/2x,
C     +' SFCHECK: a unified set of procedure for evaluating'/2x,
C     +' the quality of macromolecular stracture-factor data'/2x,
C     +' and their agreement with atomic model.'/2x,
C     +' A.A.Vaguine, J.Richelle, S.J.Wodak.'/2x,
C     +' Acta Cryst.(1999). D55, 191-205 ',//,' $$',/,
C     +' $SUMMARY :Reference1:  $$ SFCHECK: $$'/
C     +' :TEXT:Reference1: $$'/)
C ---
      ENDIF
C-CCP4

      CALL SFCHECK_CCP4_VERSION_CORRECTION(CCP4)

C ----------------------------------
      IERR  = 0
      M     = 0
      LINE  = ' '
      CALL START(0,M,'sfcheck',PATH_OUT,VCCP4)
C ---------------------------
      LINE = '   +-----------------------------------------------+'
      CALL MSGDOC(M,LINE)
      LINE = '   |                                               |'
      CALL MSGDOC(M,LINE)
      LINE = VERSION
      CALL LENSTR_BL(LINE,LEN)
      LINE = '   |  '//LINE(1:LEN)//'   |'
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.79) LEN = 79
      LINE = LINE(1:LEN)
      CALL MSGDOC(M,LINE)
      MEMORY_MB  = MEMORY/1000000
      NCRDMAX_MD = NCRDMAX/8
      WRITE(LINE,'(A,I5,A,I7,A)')
     * '   |          Memory:',MEMORY_MB,' Mb  N_atom_max:'
     * ,NCRDMAX_MD,'  |' 
      CALL MSGDOC(M,LINE)
      CALL LENSTR_BL(VERS,L)
      IF(L.GT.0) THEN
        LINE = 
     *       '   |          This version with memory allocation  |'
        CALL MSGDOC(M,LINE)
      ENDIF
      LINE = '   |                                               |'
      CALL MSGDOC(M,LINE)
      LINE = '   +-----------------------------------------------+'
      CALL MSGDOC(M,LINE)
C ----
      IF(KEY_INF.EQ.'Y') THEN
        CALL MSGDOC(M,' ')
        LINE ='You can use program by command string with options:'
        CALL MSGDOC(M,LINE)
        CALL MSGDOC(M,' ')
        LINE =
     *' sfcheck -f <file_sf_mtz_or_cif_or_map>  -m <model_pdb_or_cif>' 
        CALL MSGDOC(M,LINE)
        LINE ='         -out <out>    -nomit <Nomit>'
        CALL MSGDOC(M,LINE)
        LINE ='         -mem <Nm>     -na <Na>    '
        CALL MSGDOC(M,LINE)
        LINE ='         -scl <map_scale_factor>  -map -invert -origin'
        CALL MSGDOC(M,LINE)
        LINE ='         -h             -r    '
        CALL MSGDOC(M,LINE)
        LINE ='         -po <path_out> -ps <path_scrath>'
        CALL MSGDOC(M,LINE)
        LINE ='         -lf <label_F>  -lsf <label_sigF>'
        CALL MSGDOC(M,LINE)
        LINE ='         -li <label_I>  -lsi <label_sigI>'
        CALL MSGDOC(M,LINE)
        LINE ='         -lfree <label_free_flag> -lp <label_PH>'
        CALL MSGDOC(M,LINE)
        LINE ='    h      = help and information about mtz labels'
        CALL MSGDOC(M,LINE)
        LINE ='    r      = rest some special files(.dst,...)'
        CALL MSGDOC(M,LINE)
        LINE ='    out    = y - see nomit option'
        CALL MSGDOC(M,LINE)
        LINE ='             a - program creates CIFile '//
     *        '(sfcheck.hkl)'
        CALL MSGDOC(M,LINE)
        LINE ='                 with anisothermal corrected Fobs'
        CALL MSGDOC(M,LINE)
        LINE ='             u - CIFile with detwinned data'
        CALL MSGDOC(M,LINE)
        LINE ='    map    = 2Fobs-Fcal density map will be created '//
     *        '(sfcheck_ext.map)'
        CALL MSGDOC(M,LINE)
        LINE ='             or new map if input was map (sfcheck.map).'
        CALL MSGDOC(M,LINE)
        LINE ='             Useful to prepare mirror or/and scaled map'
        CALL MSGDOC(M,LINE)
        LINE ='    invert = mirror map will be used'
        CALL MSGDOC(M,LINE)
        LINE ='    origin = set origin of map 0 0 0'
        CALL MSGDOC(M,LINE)
        LINE ='    nomit  = number of cycles of omit procedure.'
        CALL MSGDOC(M,LINE) 
        LINE ='             2 is a good choice.It takes time'
        CALL MSGDOC(M,LINE) 
        LINE ='             if OUT = Y, program creates CIFile '//
     *        '(sfcheck.hkl)'
        CALL MSGDOC(M,LINE) 
        LINE ='             with omit phases '
        CALL MSGDOC(M,LINE)
        LINE ='    Nm     = memory request in Mb (for f90 only)'
        CALL MSGDOC(M,LINE)
        LINE ='    Na     = maximal number of atoms in the model'
        CALL MSGDOC(M,LINE)
        LINE ='    label_* = labels for mtz_file'
        CALL MSGDOC(M,LINE)
        CALL MSGDOC(M,' ')
      ENDIF
C ----
      IF(VCCP4.NE.'Y') THEN
      IF(VCCP4.NE.'C') THEN
        WRITE(*,'(A)')
     *  ' Do you want to have FILE-DOCUMENT /sfcheck.log/ ? /<Y>/N/'
        WRITE(*,'(A)')
     *  ' Also you can redirect output files to special directory'
        WRITE(*,'(A)')
     *  '                               answer: Y>path/ or >path/' 
        CALL DISPL_BL('_DOC:')
      ENDIF
      ENDIF
C ---------------------------
      IF(VCCP4.EQ.'C') THEN
        LINE = '_DOC Y'
        GO TO 1110 
      ENDIF
 1120 CONTINUE
      READ(*,'(A)',END=1100) LINE
      GO TO 1110
 1100 CONTINUE
      LINE = '_DOC Y'
 1110 CONTINUE
      IF(LINE(1:1).EQ.'#') GO TO 1120

      IBATCH   = 0
      MSG      = ' '
      LLL      = 0
      IF(LINE(1:4).EQ.'_DOC'.OR.LINE(1:4).EQ.'_doc'.OR.
     *   LINE(1:3).EQ.'DOC' .OR.LINE(1:3).EQ.'doc') THEN
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.6) THEN
          DO I=6,LEN
            IF(LINE(I:I).NE.' ') THEN
              MSG = LINE(I:I)
              LLL = I
              GO TO 10
            ENDIF
          ENDDO
        ENDIF
  10    CONTINUE
        IBATCH = 1
      ELSE
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0) THEN
          DO I=1,LEN
            IF(LINE(I:I).NE.' ') THEN
              LLL = I
              MSG = LINE(I:I)
              GO TO 20
            ENDIF
          ENDDO
        ENDIF
  20    CONTINUE
      ENDIF

      IF(LLL.GT.0) THEN
        LINE = LINE(LLL:LEN)
        LEN  = LEN - LLL + 1
        IF(LINE(1:1).NE.'>'.AND.LEN.GT.1) THEN
          LINE = LINE(2:LEN)
          LEN  = LEN - 1
        ENDIF
        CALL GET_PATH_OUT(LINE,PATH_OUT)
      ENDIF

      IF(MSG.EQ.'n') MSG='N'
      IF(MSG.NE.'N'.AND.MSG.NE.'#') MSG='Y'

      IF(MSG.NE.'N'.OR.MSG.EQ.'#') THEN
        IF(MSG.EQ.'Y') MDOC = 999
        IF(MSG.EQ.'#') MDOC = 997
        CALL START(0,MDOC,'sfcheck',PATH_OUT,VCCP4)
      ELSE
        MDOC=0
      ENDIF
      IF(IBATCH.EQ.1) CALL SET_BATCH(IBATCH)
      CALL MSGDOC(M,' ')
C ---------------------------
      MD = 0
      M  = 99
      DEFAULT_F     = ' '
      DEFAULT_SIGF  = ' '
      IDEFAULT_F    = 0
      IDEFAULT_SIGF = 0
      LINE_CCP4     = ' '
      MTZ  = 'N'
C ---
C     NOMIT = 0
      RESOL_D = 0.0
      A     = 0.0
      B     = 0.0
      C     = 0.0
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      NGROUP= 0
      NSETT = 0   
      GROUP = ' '
      TEST  = ' '

      DO I=1,20
        LABEL(I)=' '
      ENDDO

      PHASES   = ' '
      FILE_PH  = ' '
      NAME_MAP_OUT = ' '
      FILE_PDB = ' '
C      PATH_OUT = ' '
c      PATH_SCR = ' '
C ---
      CALL CORR_NAME_ALL(FILE_F_IN)
      FILE_CIF = FILE_F_IN
      MTZ  = 'N'
      CALL LENSTR_BL(FILE_F_IN,LEN)
      IF(LEN.GT.0) THEN

        CALL CHECK_SF_FILE(MDOC,FILE_F_IN,LINE,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,'ERROR: check SF_file')
C          IERR_XML     = IERR
          GO TO 500
        ENDIF

        IF(LEN.GT.4.AND.FILE_F_IN(LEN-3:LEN).EQ.'.mtz') THEN
C         MTZ file 
          IF(CCP4.NE.'Y') GO TO 910
          MTZ  = 'Y'
          FILE_CIF = FILE_F_IN(1:LEN)
C ---
          CALL GET_DEFAULT_LABEL(MDOC,FILE_CIF
     *       ,IDEFAULT_F,DEFAULT_F,DEFAULT_SIGF,IDEFAULT_SIGF
     *       ,IDEFAULT_FREE,DEFAULT_FREE,IERR)
          IF(IERR.NE.0) GO TO 500
C ---

        ELSE IF(((LEN.GT.5.AND.FILE_F_IN(LEN-4:LEN).EQ.'.ccp4').OR.
     *          (LEN.GT.4.AND.FILE_F_IN(LEN-3:LEN).EQ.'.map' )).AND.
     *           VCCP4.EQ.'C') THEN
C         ccp4 map file 
          IF(CCP4.NE.'Y') GO TO 910
          MTZ  = 'Y'
          FILE_CIF = FILE_F_IN(1:LEN)
          FILE_MAP = FILE_CIF
          P1   = 'N'
          RMAX = 0.0
          MEM2 = MEMORY/2
          NAMES = 'sfcheck_dns'
          CALL ADD_PATH(PATH_SCR,NAMES)
          IF(KEY_INF.NE.'Y') THEN
            CALL CCP42DNS(MDOC,FILE_CIF,NAMES,RMAX,RESOL_D,P1,DSCALE
     *      ,IORIGIN,POOL(1),POOL(MEM2+1),MEM2,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 500
C/////            MTZ='D'
            CALL LENSTR_BL(NAMES,LEN)
            FILE_CIF = NAMES(1:LEN)//'.dat'
          ENDIF

        ELSE
          FILE_CIF = FILE_F_IN(1:LEN)
        ENDIF
      ENDIF

      IF(KEY_INF.EQ.'Y') GO TO 500

      IF(VCCP4.EQ.'C') THEN

        FILE_PDB=' '
        CALL LENSTR_BL(FILE_CRD_IN,LEN)
        IF(LEN.GT.0) FILE_PDB = FILE_CRD_IN(1:LEN)

        MAP  = KEY_MAP
        OUT  = KEY_OUT
        TEST = KEY_REST
C ---  
        LABEL(12)= KEY_P

        LABEL(1) = KEY_F
        IF(IDEFAULT_F.EQ.1.AND.LABEL(1)(1:1).EQ.' ') THEN
          LABEL(1) = DEFAULT_F
        ENDIF
C ---  
        LABEL(2)=KEY_SIGF
        IF(IDEFAULT_SIGF.EQ.1.AND.LABEL(2)(1:1).EQ.' '.AND.
     *                   LABEL(12)(1:1).EQ.' ') THEN
          LABEL(2) = DEFAULT_SIGF
        ENDIF

C ---  
        LABEL(11)= KEY_FREE
        IF(IDEFAULT_FREE.EQ.1.AND.LABEL(11)(1:1).EQ.' ') THEN
          LABEL(11) = DEFAULT_FREE
        ENDIF

        LABEL(7) = KEY_I
        IF(IDEFAULT_F.EQ.2.AND.LABEL(7)(1:1).EQ.' ') THEN
          LABEL(7) = DEFAULT_F
        ENDIF
        LABEL(8) = KEY_SIGI
        IF(IDEFAULT_SIGF.EQ.1.AND.LABEL(8)(1:1).EQ.' '.AND.
     *     IDEFAULT_F.EQ.2   .AND.LABEL(12)(1:1).EQ.' ') THEN
          LABEL(8) = DEFAULT_SIGF
        ENDIF

        IF(LABEL(7)(1:1).NE.' ') THEN
          LABEL(1) = ' '
          LABEL(2) = ' '
        ENDIF

        IF(FILE_CIF(1:1).EQ.' '.AND.FILE_PDB(1:1).EQ.' ') THEN
          CALL MSGERR(MD,' ERROR: WRONG NAMES OF INPUT_FILES.')
          IERR=0
          GO TO 500
        ENDIF

        GO TO 600
      ENDIF 
C ---------------------------
      CALL SET_DEFAULT('#')
      CALL SET_DEFAULT(
     * '#  You can define some input files in command string:')
      CALL SET_DEFAULT('#')
       LINE = '#  sfcheck -f <sf_file> -m <coords file>'//
     *        ' -po <path_out> -ps <path_scratch>'
      CALL SET_DEFAULT(LINE)
       LINE = '#  use "sfcheck -h" to see other options'
      CALL SET_DEFAULT(LINE)
      CALL SET_DEFAULT('#')
      CALL SET_DEFAULT('#     Keywords:')
      CALL SET_DEFAULT('#')
      CALL SET_DEFAULT(
     *'FILE_F: < > - Input file with Fobs')
      CALL SET_DEFAULT(
     *'               (format  CIF or MAP or BLANC or MTZ)')
      CALL SET_DEFAULT(
     *'                Extention "dat" - BLANC, "mtz" - MTZ')
      CALL SET_DEFAULT(
     *'FILE_C: < > - Input model file (format PDB or CIF or BLANC)') 
      CALL SET_DEFAULT(
     *'              Extention "crd" means BLANC file,"cif" - CIFile')
      CALL SET_DEFAULT(
     *'NOMIT:   <0>        - number of cycles of omit procedure, 2 is a 
     *good')
      CALL SET_DEFAULT(
     *'                      choice. Note: omit procedure takes time!')
       CALL SET_DEFAULT(
     *'                      if OUT = Y program creates new CIFile')
      CALL SET_DEFAULT(
     *'                      with omit phases')
      CALL SET_DEFAULT(
     *'MAP:    <N>/Y       - Y - extract density map will be created')
      CALL SET_DEFAULT(
     *'OUT:   <N>/Y/A/U    - Y - create new Fobs CIFile (for omit)')
      CALL SET_DEFAULT(
     *'                      A - with anisothermal correction')
      CALL SET_DEFAULT(
     *'                      U - CIFile with detwinned data')
      CALL SET_DEFAULT(
     *'SCL:    <1.0>       - map scale factor')
      CALL SET_DEFAULT(
     *'INVER:  <N>,Y       - Y mirror map will be used')
      CALL MSGDOC(MD,'#')
      CALL MSGDOC(MD,
     *'#     Next keywords are necessary if there is only Fobs file and
     *')
      CALL MSGDOC(MD,
     *'#     this file has not information about space group and cell pa
     *rameters') 
      CALL MSGDOC(MD,
     *'#     In this case you must define cell parameters and space grou
     *p name')
      CALL MSGDOC(MD,
     *'#     or space group number and setting') 
      CALL MSGDOC(MD,'#')
      CALL SET_DEFAULT(
     *'GROUP:   < >        - space group name, use capital letter')
      CALL SET_DEFAULT(
     *'CELL: <0,0,0,0,0,0> - cell parameters: a,b,c,alpha,beta,gamma')
      CALL SET_DEFAULT(
     *'NSG:     <1>        - space group number /from <1> to 230 /')
      CALL SET_DEFAULT(
     *'SETT:    <2>        - setting /1 or 2,for monoclinic and trigonal
     * groups only/')

C      CALL SET_DEFAULT(
C     *'PATH_OUT:    < >    - path to output files')
      CALL SET_DEFAULT(
     *'PATH_SCR:    < >    - path to scratch files')
      CALL SET_DEFAULT(
     *'TEST:        <N>,Y  - to save special files (.dst,...)')

      CALL MSGDOC(MD,'#')
      CALL MSGDOC(MD,
     *'#     Next keywords are necessary only for MTZ file
     *')
      CALL MSGDOC(MD,'#')
      CALL SET_DEFAULT(
     *'LABIN:              ')
      CALL SET_DEFAULT(
     *'F:        < >       - label of F or F(+)')
      IF(IDEFAULT_F.EQ.1) THEN
        LINE = '#                     default:'//DEFAULT_F
        CALL SET_DEFAULT(LINE)
      ENDIF
      CALL SET_DEFAULT(
     *'SIGF:     < >       - label of sigma F or sigma F(+)')
      IF(IDEFAULT_SIGF.EQ.1) THEN
        LINE = '#                     default:'//DEFAULT_SIGF
        CALL SET_DEFAULT(LINE)
      ENDIF
      CALL SET_DEFAULT(
     *'F(-):     < >       - label of F(+)')
      CALL SET_DEFAULT(
     *'SIGF(-):  < >       - label of sigma F(-)')
      CALL SET_DEFAULT(
     *'FREE:     < >       - label of Free_flag')
      CALL SET_DEFAULT(
     *'I:        < >       - label of I or I(+)')
      CALL SET_DEFAULT(
     *'SIGI:     < >       - label of sigma I or  sigma I(+)')
      CALL SET_DEFAULT(
     *'I(-):     < >       - label of I(-)')
      CALL SET_DEFAULT(
     *'SIGI(-):  < >       - label of sigma I(-)')

      CALL MSGDOC(MD,'#')
      CALL SET_DEFAULT(
     *'     Program creates:')
      CALL SET_DEFAULT(
     *'      (OUT=A) new CIFile of corrected Fobs : sfcheck.hkl')
      CALL SET_DEFAULT(
     *'      (OUT=U) new CIFile(detwinned data)   : sfcheck.hkl')
      CALL SET_DEFAULT(
     *'      (NOMIT>0,OUT=Y) new CIFile(omit_ph)  : sfcheck.hkl')
      CALL SET_DEFAULT(
     *'      (MAP=Y) 2Fobs-Fcal density           : sfcheck_ext.map')
      CALL SET_DEFAULT(
     *'              or (if input was map) new map: sfcheck.map ')
      CALL SET_DEFAULT(
     *'                                          /both CCP4 format/')
      CALL MSGDOC(MD,'#')
      CALL MSGDOC(MD,' ')
C ---
      CALL SET_DEFAULT('?')
C ---------------------------
      LINE='FILE_F'
      CALL ASK(LINE)
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN
        FILE_CIF=' '
        CALL LENSTR_BL(FILE_F_IN,LEN)
        IF(LEN.GT.0) FILE_CIF = FILE_F_IN(1:LEN)
      ELSE
        FILE_CIF=LINE(1:LEN)        
        CALL CLEAR_LINE(FILE_CIF)
        CALL CORR_NAME_BL(FILE_CIF)
      ENDIF
C ---
      LINE='FILE_C'
      CALL ASK(LINE)
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN
        FILE_PDB=' '
        CALL LENSTR_BL(FILE_CRD_IN,LEN)
        IF(LEN.GT.0) FILE_PDB = FILE_CRD_IN(1:LEN)
      ELSE
        FILE_PDB=LINE(1:LEN)
        CALL CLEAR_LINE(FILE_PDB)
      ENDIF
C ---
      LINE='LABIN'
      CALL ASK(LINE)
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN
        LINE_CCP4 = ' ' 
      ELSE
        LINE_CCP4 = 'LABIN '//LINE(1:LEN)
        CALL CLEAR_LINE(LINE_CCP4)
      ENDIF
C ---
      LINE='SCL'
      CALL ASK(LINE)
      READ(LINE,*)  DSCALE
C ---
      LINE='NOMIT'
      CALL ASK(LINE)
      READ(LINE,*)  NOMIT
C ---
      LINE='MAP'
      CALL ASK(LINE)
      MAP=LINE(1:1)
C ---
      LINE='INVER'
      CALL ASK(LINE)
      IF(LINE(1:1).EQ.'y'.OR.LINE(1:1).EQ.'Y') INVER = 1
C ---
      LINE='OUT'
      CALL ASK(LINE)
      OUT=LINE(1:1)
C ---
      LINE='GROUP'
      CALL ASK(LINE)
      GROUP=LINE
C ---
      LINE='NSG'
      CALL ASK(LINE)
      READ(LINE,*) NGROUP
C ---
      LINE='SETT'
      CALL ASK(LINE)
      READ(LINE,*) NSETT
C ---
      LINE='CELL'
      CALL ASK(LINE)
      READ(LINE,*) A,B,C,ALPHA,BETA,GAMMA
C ---
C      LINE='PATH_OUT'
C      CALL ASK(LINE)
C      PATH_OUT = LINE
C ---
      LINE='PATH_SCR'
      CALL ASK(LINE)
      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN
      ELSE
        PATH_SCR = LINE
      ENDIF
C ---
      LINE='TEST'
      CALL ASK(LINE)
      TEST = LINE(1:1)
C ---------------------------
C      1  2   3   4    5  6   7     8    9    10    11
C     F  SF F(-) SF(-) DP SDP INTP SINTP INTM SINTM FREE   
      LINE='F'
      CALL ASK(LINE)
      LABEL(1)=LINE
      IF(IDEFAULT_F.EQ.1.AND.LABEL(1)(1:1).EQ.',') THEN
        LABEL(1) = DEFAULT_F
      ENDIF
C ---  
      LINE='SIGF'
      CALL ASK(LINE)
      LABEL(2)=LINE
      IF(IDEFAULT_SIGF.EQ.1.AND.LABEL(2)(1:1).EQ.',') THEN
        LABEL(2) = DEFAULT_SIGF
      ENDIF
C ---  
      LINE='FREE'
      CALL ASK(LINE)
      LABEL(11)=LINE
C ---
      LINE='F(-)'
      CALL ASK(LINE)
      LABEL(3)=LINE
C ---
      LINE='SIGF(-)'
      CALL ASK(LINE)
      LABEL(4)=LINE
C ---
      LINE='I'
      CALL ASK(LINE)
      LABEL(7)=LINE
      IF(IDEFAULT_F.EQ.2.AND.LABEL(7)(1:1).EQ.',') THEN
        LABEL(7) = DEFAULT_F
      ENDIF
      IF(LABEL(7)(1:1).NE.',') THEN
        LABEL(1) = ' '
        LABEL(2) = ' '
      ENDIF
C ---
      LINE='SIGI'
      CALL ASK(LINE)
      LABEL(8)=LINE
      IF(IDEFAULT_SIGF.EQ.1.AND.LABEL(8)(1:1).EQ.','.AND.
     *                          IDEFAULT_F.EQ.2) THEN
        LABEL(8) = DEFAULT_SIGF
      ENDIF
C ---
      LINE='I(-)'
      CALL ASK(LINE)
      LABEL(9)=LINE
C ---
      LINE='SIGI(-)'
      CALL ASK(LINE)
      LABEL(10)=LINE
C ---
C     VCCP4 = 'N'
C ---
      
      IF(FILE_CIF(1:1).EQ.' '.AND.FILE_PDB(1:1).EQ.' ') THEN
        CALL MSGERR(MD,' ERROR: WRONG NAMES OF INPUT_FILES.')
        IERR=0
        GO TO 500
      ENDIF

C-CCP4 
      IF(VCCP4.EQ.'Y') THEN
        CALL SFCHECK_CCP4_UGTENV(FILE_CIF,FILE_PDB,FILE_MAP
     *    ,PATH_OUT,PATH_SCR,MTZ)
      ENDIF
C-CCP4 

        CALL CORR_NAME_BL(FILE_CIF)
        CALL LENSTR_BL(FILE_CIF,LEN)
        IF(LEN.GT.0) THEN
          CALL CHECK_SF_FILE(MDOC,FILE_CIF,LINE,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,'ERROR: check SF_file')
C            IERR_XML     = IERR
            GO TO 500
          ENDIF
        ENDIF

        IF((LEN.GT.5.AND.FILE_CIF(LEN-4:LEN).EQ.'.ccp4').OR.
     *          (LEN.GT.4.AND.FILE_CIF(LEN-3:LEN).EQ.'.map' )) THEN
C         ccp4 map file 
          IF(CCP4.NE.'Y') GO TO 910
          MTZ  = 'Y'
          P1   = 'N'
          RMAX = 0.0
          MEM2 = MEMORY/2
          NAMES = 'sfcheck_dns'
          CALL ADD_PATH(PATH_SCR,NAMES)
          IF(KEY_INF.NE.'Y') THEN
            CALL CCP42DNS(MDOC,FILE_CIF,NAMES,RMAX,RESOL_D,P1,DSCALE
     *      ,IORIGIN,POOL(1),POOL(MEM2+1),MEM2,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 500
C/////            MTZ='D'
            CALL LENSTR_BL(NAMES,LEN)
            FILE_CIF = NAMES(1:LEN)//'.dat'
          ENDIF
        ENDIF

      IF(MTZ.EQ.'Y') THEN
      ELSE
        CALL LENSTR_BL(FILE_CIF,LEN)
        IF(LEN.GT.4.AND.FILE_CIF(LEN-3:LEN).EQ.'.mtz') THEN
          IF(CCP4.NE.'Y') GO TO 910
          MTZ = 'Y'
C ---
          CALL GET_DEFAULT_LABEL(MDOC,FILE_CIF
     *       ,IDEFAULT_F,DEFAULT_F,DEFAULT_SIGF,IDEFAULT_SIGF
     *       ,IDEFAULT_FREE,DEFAULT_FREE,IERR)
          IF(IERR.NE.0) GO TO 500
          IF(IDEFAULT_F.EQ.1.AND.LABEL(1)(1:1).EQ.',') THEN
            LABEL(1) = DEFAULT_F
          ENDIF
          IF(IDEFAULT_SIGF.EQ.1.AND.LABEL(2)(1:1).EQ.',') THEN
            LABEL(2) = DEFAULT_SIGF
          ENDIF
          IF(IDEFAULT_F.EQ.2.AND.LABEL(7)(1:1).EQ.',') THEN
            LABEL(7) = DEFAULT_F
          ENDIF
          IF(IDEFAULT_SIGF.EQ.1.AND.LABEL(8)(1:1).EQ.','.AND.
     *                              IDEFAULT_F.EQ.2) THEN
            LABEL(8) = DEFAULT_SIGF
          ENDIF
          IF(IDEFAULT_FREE.EQ.1.AND.LABEL(11)(1:1).EQ.',') THEN
            LABEL(11) = DEFAULT_FREE
          ENDIF
C ---
        ENDIF
      ENDIF

 600  CONTINUE

      CALL CORR_NAME_ALL(FILE_PDB)
      CALL LENSTR_BL(FILE_PDB,LEN)
      IF(LEN.GT.0) THEN
        CALL CHECK_COORD_FILE(MDOC,FILE_PDB,LINE,IERR)
        IF(IERR.EQ.0) THEN
          IF(LINE(1:3).EQ.'MAP') THEN
            LINE = ' ERROR: model cannot be a MAP'
            CALL MSGERR(MD,LINE)
            IERR = 1
          ENDIF
        ENDIF
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,'ERROR: check coord_file')
C          IERR_XML     = IERR
          GO TO 500
        ENDIF
      ENDIF
C ---------------------------
      CALL SFCHECK(MDOC,FILE_PDB,FILE_CIF,FILE_PH,FILE_PH_OMIT,NAMEF
     * ,NAME_MAP_OUT,KEY_P,IOCC
     * ,NOMIT,MAP,OUT,TEST,PHASES,VCCP4
     * ,INVER,DSCALE,RESOL_D,BOFF_IN
     * ,GROUP,NGROUP,NSETT,A,B,C,ALPHA,BETA,GAMMA
     * ,LABEL,LINE_CCP4,RESULT,RESULTA,RESULTB,RESULTC,IPRROW
     * ,PATH_OUT,PATH_SCR 
     * ,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C ---------------------------
      IF(IERR.NE.0) THEN
        GO TO 500
      ENDIF

      MTZ = 'N'

c     IF(((NOMIT.GT.0.AND.OUT.EQ.'Y').OR.OUT.EQ.'U').AND.MTZ.EQ.'Y')THEN
      IF((NOMIT.GT.0.AND.OUT.EQ.'Y').OR.OUT.EQ.'U') THEN

C        CALL CCPFYP 
C        CALL MTZINI

        EXT = 'mtz'
        IF(MTZ.EQ.'N') EXT = 'hkl'

        IF(NOMIT.GT.0) THEN
          LINE = '   OMIT Phases in : sfcheck.'//
     *           EXT//' (Fp,Ph,FOM)'
          CALL MSGDOC(MDOC,LINE)
          CFOM  = 'Y'
        ELSE
          FILE_PH_OMIT = ' '
          CFOM  = 'Y'
          LINE = '   detwinned Fobs in : sfcheck.'//
     *           EXT//' (F,sigF)'
          CALL MSGDOC(MDOC,LINE)
        ENDIF

        CALL LENSTR_BL(PATH_OUT,LEN)
        IF(LEN.GT.0) THEN
          NAME_MTZ_OUT = PATH_OUT(1:LEN)//'sfcheck.'//EXT
        ELSE
          NAME_MTZ_OUT = 'sfcheck.'//EXT
        ENDIF

        NAME  = ' '
        STAT  = 'N' 
        CFREE = 'N'
        CSIG  = 'Y'
        ANOM  = 'N'
        RESN  = 0.0
        RESX  = 0.0

        IF(MTZ.EQ.'N') THEN
          CALL F2CIF(M,NAMEF,NAME,FILE_PH_OMIT,NAME_MTZ_OUT
     *        ,CFOM,CFREE,CSIG
     *        ,RESN,RESX,ISYM,IPRSYM,RESULT,IPRROW,IERR)
        ELSE
          CALL BLANC2MTZ(M,NAMEF,NAME,FILE_PH_OMIT,NAME_MTZ_OUT
     *       ,CFOM,CFREE,CSIG,ANOM
     *       ,RESN,RESX,ISYM,IPRSYM,RESULT,IPRROW,IERR)
        ENDIF
        IF(IERR.NE.0) GO TO 500

      ENDIF
      GO TO 500

  910 CONTINUE
      IF(CCP4.EQ.'P') THEN
        CALL MSGERR(MDOC,
     *  'ERROR: it is not CCP4 version of program,')
        CALL MSGERR(MDOC,
     *  '       please, setup CCP4 and recompile program')
      ELSE
        CALL MSGERR(MD,
     *  'ERROR: Probably you forgot setup CCP4')
      ENDIF
      GO TO 920

 500  CONTINUE

      IF(TEST.NE.'Y') THEN
        PATH = PATH_OUT
        IF(VCCP4.EQ.'Y') PATH = PATH_SCR
        NAME = 'sfcheck_fob.dat'
        CALL DELETE_FILE(PATH,NAME)
        NAME = 'sfcheck_ph.dat'
        CALL DELETE_FILE(PATH,NAME)
        NAME = 'sfcheck_omit_ph.dat'
        CALL DELETE_FILE(PATH,NAME)
        NAME='sfcheck_fmd.dat'
        CALL DELETE_FILE(PATH_SCR,NAME)
c        IF(OUT.EQ.'U'.AND.MTZ.EQ.'N') THEN
c          LINE = '   detwinned Fobs in : sfcheck_detwin.dat'
c          CALL MSGDOC(MDOC,LINE)
c        ELSE
          NAME = 'sfcheck_detwin.dat'
          CALL DELETE_FILE(PATH_OUT,NAME)
c        ENDIF
      ENDIF

  920 CONTINUE

      IF(VCCP4.EQ.'Y') THEN
        CALL FINISH_CCP4(IERR)
      ELSE
        CALL FINISH
      ENDIF

      RETURN

      END

      SUBROUTINE FINISH_CCP4(IERR)
      IF(IERR.EQ.0) THEN
        CALL CCPERR(0,'Normal termination')
      ELSE
        CALL CCPERR(1,'Failure')
      ENDIF
      END          

      SUBROUTINE GET_DEFAULT_LABEL(MDOC,FILE_CIF
     *   ,IDEFAULT_F,DEFAULT_F,DEFAULT_SIGF,IDEFAULT_SIGF
     *   ,IDEFAULT_FREE,DEFAULT_FREE,IERR)
C ------------------------------------------
      CHARACTER FILE_CIF*(*)
      CHARACTER DEFAULT_F*(*),DEFAULT_SIGF*(*),DEFAULT_FREE*(*)
      CHARACTER DEFAULT_I*30,DEFAULT_SIGI*30
C ---
      PARAMETER (MCOLS=500)
      INTEGER   NCOL
      CHARACTER CTPRG(MCOLS)*1,LSPRG(MCOLS)*30
C ---
      CHARACTER LINE*256,PATH*1,EXT*1
C ------------------------------------------
      DEFAULT_F     = ' '
      DEFAULT_SIGF  = ' '
      DEFAULT_I     = ' '
      DEFAULT_SIGI  = ' '
      DEFAULT_FREE  = ' '
      IDEFAULT_F    = 0
      IDEFAULT_SIGF = 0
      IDEFAULT_I    = 0
      IDEFAULT_SIGI = 0
      IDEFAULT_FREE = 0

      MD = 0
      M  = 99
      EXT  = ' '
      PATH = ' '
      IN   = 10     
      CALL  OPENFR(IN,MD,PATH,FILE_CIF,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(M,' ERROR: can not open input MTZ file') 
        RETURN
      ENDIF
      CLOSE(IN)
C
c      CALL CCPFYP 
      CALL MTZINI
      IPRNT = 0
      MTZIN = 1
      IFAIL = 0
      CALL LENSTR_BL(FILE_CIF,L)
      CALL LROPEN(MTZIN,FILE_CIF(1:L),IPRNT,IFAIL)
      IF(IFAIL.EQ.1) THEN
        CALL MSGERR(M,' ERROR: can not open input MTZ file') 
        IERR=1
        RETURN
      ENDIF
      CALL LRCLAB(MTZIN,LSPRG,CTPRG,NCOL)
      IF(NCOL.LE.0) THEN
        CALL MSGERR(M,' ERROR: file is empty') 
        CALL LRCLOS(MTZIN)
        IERR=1
        RETURN
      ENDIF
C ---
      CALL MSGDOC(MDOC,' -----------------------------------')
      LL = L
      IF(L.GT.65) LL = 65
      WRITE(LINE,'(A,A)') '--- MTZ file :',FILE_CIF(1:LL)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC, '  No  Label                       type')
      CALL MSGDOC(MDOC,' ')
      DO I=1,NCOL
        IF(IDEFAULT_F.EQ.0.AND.CTPRG(I).EQ.'F') THEN
          IDEFAULT_F = 1
          DEFAULT_F  = LSPRG(I)
        ENDIF
        IF(IDEFAULT_F.EQ.1.AND.IDEFAULT_SIGF.EQ.0.AND.
     *                                 CTPRG(I).EQ.'Q') THEN
          DEFAULT_SIGF  = LSPRG(I)
          IDEFAULT_SIGF = 1
        ENDIF
        IF(IDEFAULT_I.EQ.0.AND.CTPRG(I).EQ.'J') THEN
          IDEFAULT_I = 1
          DEFAULT_I  = LSPRG(I)
        ENDIF
        IF(IDEFAULT_I.EQ.1.AND.IDEFAULT_SIGI.EQ.0.AND.
     *                                 CTPRG(I).EQ.'Q') THEN
          DEFAULT_SIGI  = LSPRG(I)
          IDEFAULT_SIGI = 1
        ENDIF

        IF(IDEFAULT_FREE.EQ.0.AND.CTPRG(I).EQ.'I') THEN
          IDEFAULT_FREE = 1
          DEFAULT_FREE  = LSPRG(I)
        ENDIF

        WRITE(LINE,'(I5,2X,A,2X,A)') I,LSPRG(I),CTPRG(I)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      IF(IDEFAULT_F.EQ.0.AND.IDEFAULT_I.EQ.1) THEN
        DEFAULT_F     = DEFAULT_I
        DEFAULT_SIGF  = DEFAULT_SIGI
        IDEFAULT_SIGF = IDEFAULT_SIGI
        IDEFAULT_F    = 2
      ENDIF
      CALL MSGDOC(MDOC,' -----------------------------------')
      CALL LRCLOS(MTZIN)
      RETURN
      END
C ======================================================================
C ======================================================================

      SUBROUTINE SFCHECK_CCP4_VERSION_CORRECTION(CHAR)
      CHARACTER CHAR*1,NAME*80,LINE*256
C --------------------------
      NAME = 'CLIB'

      CALL UGTENV(NAME,LINE)
      CALL LENSTR_BL(LINE,LEN)

      IF(LEN.LE.0) THEN
        CHAR = 'N'
      ELSE
        IF(LEN.EQ.6.AND.LINE(1:6).EQ.'NOCCP4') THEN
          CHAR = 'P'
        ELSE
          CHAR = 'Y'
        ENDIF
      ENDIF
      RETURN
      END    

C     CCP4 routines

      SUBROUTINE SFCHECK_CCP4_UGTENV(FILE_CIF,FILE_PDB,FILE_MAP
     *    ,PATH_OUT,PATH_SCR,MTZ)
C ----------------------------
      CHARACTER FILE_CIF*(*),FILE_PDB*(*),FILE_MAP*(*)
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),MTZ*1
C ----------------------------
      CALL UGTENV('XYZIN',FILE_PDB)

      IF(MTZ.EQ.'D') THEN
        CALL UGTENV('MAPIN',FILE_MAP)
      ELSE
        CALL UGTENV('HKLIN',FILE_CIF)
      ENDIF

      CALL UGTENV('PATH_OUT',PATH_OUT)
      CALL UGTENV('PATH_SCR',PATH_SCR)
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.LE.0) THEN
        CALL UGTENV('TEMP1',PATH_SCR)
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.LE.0) THEN
          CALL UGTENV('CCP4_SCR',PATH_SCR)
        ENDIF
      ELSE
        IF(PATH_SCR(1:1).EQ.'.') PATH_SCR = ' '
      ENDIF
      RETURN
      END

      SUBROUTINE SFCHECK_CCPFYP 
C -
      CALL CCPFYP
C -
      RETURN
      END 

      SUBROUTINE SFCHECK_INIT_CCP4
C --------------------------------------------------------------------
C ---
      INCLUDE 'sfch_version.fh'
C --------------------------------------------------------------------
C---- Initialize ccp4 like file organization
      CALL CCPFYP
      ISYSW = 6
c      CALL CCPRCS(ISYSW,'Sfcheck(ccp4) '//VERSNO,
      call ccp4_prog_version(versno,0)
      CALL CCPRCS(ISYSW,'Sfcheck(ccp4) ',
     + '$Date: 2002/02/26 13:29:23 $')
      WRITE (ISYSW, 6000)
6000  FORMAT (  
     +' $TEXT:Reference1: $$ comment $$ '/2x,
     +' SFCHECK: a unified set of procedure for evaluating'/2x,
     +' the quality of macromolecular stracture-factor data'/2x,
     +' and their agreement with atomic model.'/2x,
     +' A.A.Vaguine, J.Richelle, S.J.Wodak.'/2x,
     +' Acta Cryst.(1999). D55, 191-205 ',//,' $$',/,
     +' $SUMMARY :Reference1:  $$ SFCHECK: $$'/
     +' :TEXT:Reference1: $$'/)
C ---
      RETURN
      END

C =========================================================
C --- CCP4 ---  read MTZ file


      SUBROUTINE SFCH_MTZ(MDOC,FILE_MTZ,FILE_CIF
     *    ,LABEL,LINE_CCP4,NO_SPGR,CELL,IERR)
C -------------------------------------------------------
      PARAMETER (MCOLS=500)
C     
      CHARACTER LINE_CCP4*(*)
      INTEGER   NCOL
      REAL      CELL(6)
C
      CHARACTER CTPRG(MCOLS)*1,LSPRG(MCOLS)*30
C --
      CHARACTER FILE_MTZ*(*),FILE_CIF*(*)
      CHARACTER LINE*256,TYPE*1,PATH*1,EXT*1,MSG*1,FMINUS*1,PHASE*1
C --
      CHARACTER LABEL(20)*30
C      1  2   3   4    5  6   7     8    9    10    11
C     F  SF F(-) SF(-) DP SDP INTP SINTP INTM SINTM FREE   
C -----------------------------------------------------
      IERR = 0
      M    = 0
      MD   = 99

C     LINE_CCP4=' ' 
      CALL LENSTR_BL(LINE_CCP4,L)
      IF(L.GT.4.AND.LINE_CCP4(1:5).EQ.'LABIN') THEN
        FMINUS    = 'N'
        DO I=5,L
          IF(LINE_CCP4(I-4:I).EQ.'F(-)='.OR.
     *       LINE_CCP4(I-4:I).EQ.'I(-)=') THEN
            FMINUS = 'Y'
          ENDIF
        ENDDO
        NO_SPGR  = 0
        GO TO 1000
      ENDIF

      NO_SPGR  =0
C ---------------------
      EXT  = ' '
      PATH = ' '
      IN   = 10     
      CALL  OPENFR(IN,MD,PATH,FILE_MTZ,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(M,' ERROR: can not open input MTZ file') 
        RETURN
      ENDIF
      CLOSE(IN)
C ------------------
C      CALL CCPFYP 
      CALL MTZINI

      IPRNT = 0
      MTZIN = 1
      IFAIL = 0

      CALL LENSTR_BL(FILE_MTZ,L)
      CALL LROPEN(MTZIN,FILE_MTZ(1:L),IPRNT,IFAIL)
      IF(IFAIL.EQ.1) THEN
        CALL MSGERR(M,' ERROR: can not open input MTZ file') 
        IERR=1
        RETURN
      ENDIF
      CALL LRCLAB(MTZIN,LSPRG,CTPRG,NCOL)
      IF(NCOL.LE.0) THEN
        CALL MSGERR(M,' ERROR: MTZ file is empty') 
        CALL LRCLOS(MTZIN)
        IERR=1
        RETURN
      ENDIF
C -------------------
      IFP       = 0
      ISIGFP    = 0
      IFPH      = 0
      ISIGFPH   = 0
      IFREE     = 0
      IINTP     = 0
      ISIGIP    = 0
      IINTM     = 0
      ISIGIM    = 0
      IDP       = 0
      ISDP      = 0            
      FMINUS    = 'N'
      PHASE     = 'N'
C ------------------------------------------------------
C      CALL MSGDOC(MDOC,' -----------------------------------')
C      WRITE(LINE,*) '--- MTZ file : ',FILE_MTZ(1:L)
C      CALL MSGDOC(MDOC,LINE)
C      CALL MSGDOC(MDOC,' ')
C      CALL MSGDOC(MDOC, '  No  Label                       type')
C      CALL MSGDOC(MDOC,' ')
C      DO I=1,NCOL
C        WRITE(LINE,'(I5,2X,A,2X,A)') I,LSPRG(I),CTPRG(I)
C        CALL MSGDOC(MDOC,LINE)
C      ENDDO
C      CALL MSGDOC(MDOC,' -----------------------------------')
C
      CALL LRCLOS(MTZIN)
C ---------------------------------------------------------

      LINE=LABEL(1)

      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LFP)
      IF(LFP.GT.0) THEN
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LFP.AND.LINE(1:LFP).EQ.LSPRG(I)(1:L)) THEN
            IFP=I
            GO TO 201
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LFP) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ELSE
        IFP=0
      ENDIF

 201  CONTINUE

c      IF(IFP.LE.3.OR.IFP.GT.NCOL) THEN
c        WRITE(LINE,*) ' ERROR: wrong F label ' 
c        CALL MSGERR(MDOC,LINE)
c        IERR=1
c        RETURN
c      ENDIF
C -------------------------------------------------------------

      LINE=LABEL(2)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LSFP)
      IF(LSFP.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LSFP.AND.LINE(1:LSFP).EQ.LSPRG(I)(1:L)) THEN
            ISIGFP=I
            GO TO 202
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LSFP) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISIGFP=0
       
      ENDIF

 202  CONTINUE
C ---------------------------------------------------------
      LINE=LABEL(3)

      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IFPH=I
            FMINUS = 'Y'
            GO TO 203
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ELSE
        IFPH=0
      ENDIF

 203  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(4)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            ISIGFPH=I
            GO TO 204
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISIGFPH=0
       
      ENDIF

 204  CONTINUE
C -----------------------------------------------------------------
      LINE=LABEL(11)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IFREE=I
            GO TO 211
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ELSE 

        IFREE=0

      ENDIF

 211  CONTINUE
C -------------------------------------------------------------
C      1  2   3   4    5  6   7     8    9    10    11
C     F  SF F(-) SF(-) DP SDP INTP SINTP INTM SINTM FREE   
      LINE=LABEL(7)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IINTP=I
            GO TO 207
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        IINTP=0
       
      ENDIF

 207  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(8)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            ISIGIP=I
            GO TO 208
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISIGIP=0
       
      ENDIF

 208  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(9)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IINTM=I
            FMINUS = 'Y'
            GO TO 209
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        IINTM=0
       
      ENDIF

 209  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(10)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            ISIGIM=I
            GO TO 210
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISIGIM=0
       
      ENDIF

 210  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(12)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IPH=I
            GO TO 212
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        IPH=0
       
      ENDIF

 212  CONTINUE
C ----------------------------

      LINE_CCP4= 'LABIN'

      IF(IFP.GT.0) THEN
        LINE=LSPRG(IFP)
        CALL LENSTR_BL(LINE,LFP)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' F='//LINE(1:LFP)
      ENDIF

      IF(ISIGFP.GT.0) THEN
        LINE=LSPRG(ISIGFP)
        CALL LENSTR_BL(LINE,LSFP)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGF='//LINE(1:LSFP)
      ENDIF

      IF(IFPH.GT.0) THEN
        LINE=LSPRG(IFPH)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' F(-)='//LINE(1:LL)
        FMINUS = 'Y'
      ENDIF

      IF(ISIGFPH.GT.0) THEN
        LINE=LSPRG(ISIGFPH)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGF(-)='//LINE(1:LL)
      ENDIF

      IF(IFREE.GT.0) THEN
        LINE=LSPRG(IFREE)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' FREE='//LINE(1:LL)
      ENDIF

      IF(IINTP.GT.0) THEN
        LINE=LSPRG(IINTP)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' I='//LINE(1:LL)
      ENDIF

      IF(ISIGIP.GT.0) THEN
        LINE=LSPRG(ISIGIP)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGI='//LINE(1:LL)
      ENDIF

      IF(IINTM.GT.0) THEN
        LINE=LSPRG(IINTM)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' I(-)='//LINE(1:LL)
      ENDIF

      IF(ISIGIM.GT.0) THEN
        LINE=LSPRG(ISIGIM)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGI(-)='//LINE(1:LL)
      ENDIF

      IF(IDP.GT.0) THEN
        LINE=LSPRG(IDP)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' DP='//LINE(1:LL)
      ENDIF

      IF(ISDP.GT.0) THEN
        LINE=LSPRG(ISDP)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGDP='//LINE(1:LL)
      ENDIF

      IF(IPH.GT.0) THEN
        PHASE = 'Y'
        LINE=LSPRG(IPH)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' PH='//LINE(1:LL)
      ENDIF

C -----------------

 1000 CONTINUE

      EXT  = ' '
      PATH = ' '
      IN   = 10      
      CALL  OPENFW(IN,M,PATH,FILE_CIF,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: can not open output file') 
        RETURN
      ENDIF
      CLOSE(IN)      

      CALL LENSTR_BL(LINE_CCP4,L)
      IF(L.GT.79) L = 79
      CALL MSGDOC(MDOC,LINE_CCP4(1:L))
C ---------------------------------------------------------
      CALL MTZ2CIF(MDOC,FILE_MTZ,FILE_CIF,LINE_CCP4,NO_SPGR,CELL
     *            ,FMINUS,IERR)
C ---------------------------------------------------------
      RETURN
      END

      SUBROUTINE MTZ2CIF(MDOC,FILE_MTZ,FILE_CIF,LINE,NO_SPGR,CELL
     *                  ,FMINUS,IERR)
C ---------------------------------------------------------
      PARAMETER (NPARM=200)
      PARAMETER (MCOLS=500)
C     
      INTEGER IN(3),MDOC
C     
C---- Mtz file variables
C     
      REAL      ADATA(MCOLS)
      INTEGER   LOOKUP(MCOLS), NSYM
      LOGICAL   LOGMSS(MCOLS)
C     
C---- things for parser
C     
      CHARACTER KEY*4,CVALUE(NPARM)*4,LINE*(*)
      REAL      FVALUE(NPARM)
      LOGICAL   LEND,IPRINT,EOF
      INTEGER   NTOK,IBEG(NPARM),IEND(NPARM),ITYPE(NPARM),IDEC(NPARM)
      CHARACTER CTPRGI(MCOLS)*1,LSPRGI(MCOLS)*30

C      CHARACTER CTPRG_Inf(MCOLS)*1,LSPRG_Inf(MCOLS)*30
C --
      LOGICAL   LANOM

c ___ CIF things
      INTEGER   IUN22
      CHARACTER CODE*8,RSTAT*1
      CHARACTER LINE_CIF*80,CH20*20


      REAL      intens, sigintens, CELL(6)

      COMMON /COM_MTZ_INFO/ nsymx, nsympx, nspgrx,rsym,spgrnx,pgnamx
      integer   nsymx, nsympx, nspgrx
      character spgrnx*10, pgnamx*10
      real      rsym(4,4,192)

c      REAL      RSYM(4,4,192)
c      INTEGER   nsympx,nspgrx
c      CHARACTER spgrnx*10, pgnamx*10

      CHARACTER ltypex*1, symchs(196)*80


      CHARACTER*40 CIF_DATA,CIF_ENTRY,CIF_CELL_ID,CIF_SYMM_ID
      CHARACTER*40 CIF_CELL1,CIF_CELL2,CIF_CELL3
      CHARACTER*40 CIF_CELL4,CIF_CELL5,CIF_CELL6
      CHARACTER*40 CIF_ITNUM,CIF_GROUP,CIF_EQUIV_ID,CIF_EQUIV_XYZ
      CHARACTER*40 CIF_INDH,CIF_INDK,CIF_INDL
      CHARACTER*40 CIF_FP,CIF_SIGF,CIF_STAT
      CHARACTER*40 CIF_FC,CIF_PH,CIF_FOM
      CHARACTER*40 CIF_INT,CIF_SIGI

C---- External Routines
C
      LOGICAL CCPONL
      EXTERNAL CCPDPN,CCPERR,CCPFYP,CCPLWC,CCPONL,CCPRCS,CCPUPC,CENTR,
     +         CENTRIC,GTPINT,GTPREA,LKYIN,LRASSN,LRINFO,LROPEN,LRREFF,
     +         LRREFM,LRRSOL,LRSORT,LRSYMI,LRSYMM,MTZINI,PARSER,RDRESO
C     
C---- Common Blocks
C     
      COMMON /PINOUT/ LUNIN,LUNOUT
      INTEGER   LUNIN,LUNOUT


      CHARACTER FILE_MTZ*(*),FILE_CIF*(*),FMINUS*1

C     
C---- Data Statements
C     
      DATA NLPRGI/42/,
     +     LSPRGI/'H','K','L','F','SIGF','F(-)','SIGF(-)','FC','PH',
     +     'W','FPART','PHIPART','PHIB','FOM','FREE','DP','SIGDP',
     +     'ISYM','DUM1','DUM2','DUM3','DUM4','DUM5','DUM6','DUM7',
     +     'DUM8','DUM9','DUM10','IDUM1','IDUM2','IDUM3','IDUM4',
     +     'IDUM5','IDUM6','IDUM7','IDUM8','IDUM9','IDUM10',
     &     'I', 'SIGI', 'I(-)', 'SIGI(-)', 458*' '/
      DATA CTPRGI/'H','H','H','F','Q','G','L','F','P','W','F','P','P',
     +            'W','I','D','Q','Y',10*'R',10*'I','J','Q','J','Q',
     +            458*' '/

      DATA LOOKUP/-1,-1,-1,0,0,495*0/
C -----------------------------------------------------
      IERR=0
C ----------------
C     CALL CCPFYP 
      CALL MTZINI

      IF(FMINUS.EQ.'Y') THEN
        CTPRGI(4)  = 'G'
        CTPRGI(5)  = 'L'
        CTPRGI(39) = 'K'
        CTPRGI(40) = 'M'
        CTPRGI(41) = 'K'
        CTPRGI(42) = 'M'
      ENDIF

      IPRNT  = 0
      MTZIN  = 1
      IFAIL  = 0
      LANOM  = .FALSE.
      SMAX   = 0.0
      SMIN   = 0.0
      MTZIN  = 1
      LUNIN  = 5
      LUNOUT = 6
      NRFOUT = 0
      NTOK   = NPARM
      IPRINT = .TRUE.
      NO_SPGR= 0
C
C             *********************************************
      CALL PARSER (KEY,LINE,IBEG,IEND,ITYPE,FVALUE,CVALUE,IDEC,NTOK,
     +     LEND,IPRINT)
c            
          CALL LKYIN(MTZIN,LSPRGI,NLPRGI,NTOK,LINE,IBEG,IEND)
C             *********************************************
C     Open output ASCII file
C     
      IUN22 = 22
      IFAIL = 0
      CALL LENSTR_BL(FILE_CIF,L)
      CALL CCPDPN(IUN22,FILE_CIF(1:L),'NEW','F',LL,IFAIL)
      IF(IFAIL.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open output CIFile')
        IERR=1
        RETURN
      ENDIF

      MTZIN = 1
      IFAIL = 0
      IPRNT = 0
C          **********************************
C      CALL LROPEN(MTZIN,'HKLIN',IPRNT,IFAIL)
C          **********************************
      CALL LENSTR_BL(FILE_MTZ,L)
      CALL LROPEN(MTZIN,FILE_MTZ(1:L),IPRNT,IFAIL)
      IF(IFAIL.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open output MTZ file')
        IERR=1
        RETURN
      ENDIF
C          **********************************
      CALL LRASSN(MTZIN,LSPRGI,NLPRGI,LOOKUP,CTPRGI)
C          *****************************************
C
C     Column labels              4     5     6        7
C           LSPRGI/'H','K','L','F','SIGF','F(-)','SIGF(-)',
C             8      9   10     11        12     13    14
C           'FC','PHIC','W','FPART','PHIPART','PHIB','FOM',
C              15   16      17     18
C           'FREE','DP','SIGDP','ISYM','DUM1' .. 'DUM10','IDUM1' .. 'IDUM10'
C              39   40     41     42  
C            'I', 'SIGI', 'I(-)', 'SIGI(-)'
C
C ----------------------
      N_F   =  4
      N_SF  =  5
      N_FM  =  6
      N_SFM =  7
      N_FC  =  8
      N_PH  =  9
      N_FOM = 14
      N_FR  = 15
      N_DP  = 16 
      N_SDP = 17
      N_I   = 39
      N_SI  = 40
      N_IM  = 41
      N_SIM = 42
      
      IF(LOOKUP(N_F) .EQ.0.AND.LOOKUP(N_FC).EQ.0.AND.
     *   LOOKUP(N_I).EQ.0                       ) THEN
        CALL MSGERR(MDOC,
     *  'ERROR: Missing assignment for F or FC or I')
        IERR=1
        RETURN
      ENDIF

      IF(LOOKUP(N_F).NE.0) THEN

C       with FP
CX       FP
C       FP, SIGFP
C X      FP, FC
C X      FP, SIGFP, FC
C       FP, SIGFP , FC , PHASE, FOM
C     --- DP --
C       FP+, SIGFP+
C       FP-, SIGFP-
C      
        IF(LOOKUP(N_I).NE.0.OR.LOOKUP(N_IM).NE.0) THEN
          CALL MSGERR(MDOC,
     *    'WARNING: I+ and I- can not be used with F')
        ENDIF

        LOOKUP(N_I)   = 0
        LOOKUP(N_SI)  = 0
        LOOKUP(N_IM)  = 0
        LOOKUP(N_SIM) = 0
        IF(LOOKUP(N_DP).NE.0.AND.LOOKUP(N_SDP).EQ.0) LOOKUP(N_SF)=0
        IF(LOOKUP(N_DP).NE.0) THEN
          LOOKUP(N_FM) = 0
          LOOKUP(N_SFM)= 0
          LOOKUP(N_FC) = 0
          LOOKUP(N_PH) = 0
          LOOKUP(N_FOM)= 0
        ENDIF

      ELSE

C       without FP          
C       FC , PHASE, FOM
C       I+ sigI+
C       I- sigI-

        LOOKUP(N_F)  = 0
        LOOKUP(N_SF) = 0
        LOOKUP(N_FM) = 0
        LOOKUP(N_SFM)= 0
        LOOKUP(N_DP) = 0
        LOOKUP(N_SDP)= 0

        IF(LOOKUP(N_FC).NE.0) THEN
C         with FC
          IF(LOOKUP(N_I).NE.0.OR.LOOKUP(N_IM).NE.0) THEN
            CALL MSGERR(MDOC,
     *      'WARNING: I+ and I- can not be used with FC')
          ENDIF

          LOOKUP(N_I) = 0
          LOOKUP(N_SI) = 0
          LOOKUP(N_IM) = 0
          LOOKUP(N_SIM) = 0
        ELSE
C         I+ and I-
          LOOKUP(N_FC) = 0
          LOOKUP(N_PH) = 0
          LOOKUP(N_FOM)= 0

          IF((LOOKUP(N_IM).NE.0.AND.LOOKUP(N_I).EQ.0)) THEN
c     *       (LOOKUP(N_I).EQ.0.OR.LOOKUP(N_IM).NE.0)) THEN
            CALL MSGERR(MDOC,
     *      'ERROR: I+ and I- both must be assigned')
            IERR=1
            RETURN
          ENDIF

        ENDIF
      ENDIF
C -----------------------------
C      IF(LOOKUP(N_DP).GT.0.OR.LOOKUP(N_I).GT.0) THEN
C        LANOM=.TRUE.
C      ENDIF

      IF(LOOKUP(N_DP).GT.0) THEN
        LANOM=.TRUE.
      ENDIF

      IF(LOOKUP(N_IM).GT.0) THEN
        LANOM=.TRUE.
      ENDIF

      IF(LOOKUP(N_FM).GT.0) THEN
        LANOM=.TRUE.
      ENDIF
C -----------------------------
C
C Get symmetry for centric/systematically absent tests and symm. operators.
C Need this for CIF output, whether or not we are converting anomalous data

c        CALL LRSYMM(MTZIN, NSYM, RSYM)
c        CALL CENTRIC(NSYM, RSYM, 0)

        call lrsymi(mtzin,nsympx,ltypex,nspgrx,spgrnx,pgnamx)

c        call epsln(nsym,nsympx,rsym,0)
c     
c        nsymx = nsym

C -----------------------------
C
C   --- write CIF titles
C
        CODE='XXXX'
        CIF_DATA      = 'data'
        CIF_ENTRY     = '_entry.id'
        CIF_CELL_ID   = '_cell.entry_id'    
        CIF_CELL1     = '_cell.length_a'
        CIF_CELL2     = '_cell.length_b'
        CIF_CELL3     = '_cell.length_c'
        CIF_CELL4     = '_cell.angle_alpha'
        CIF_CELL5     = '_cell.angle_beta'
        CIF_CELL6     = '_cell.angle_gamma'
        CIF_SYMM_ID   = '_symmetry.entry_id'
        CIF_ITNUM     = '_symmetry.Int_Tables_number'
        CIF_GROUP     = '_symmetry.space_group_name_H-M'
        CIF_EQUIV_ID  = '_symmetry_equiv.id'
        CIF_EQUIV_XYZ = '_symmetry_equiv.pos_as_xyz'
        CIF_INDH      = '_refln.index_h'
        CIF_INDK      = '_refln.index_k'
        CIF_INDL      = '_refln.index_l'
C
        CIF_FP        = '_refln.F_meas_au'
        CIF_SIGF      = '_refln.F_meas_sigma_au'
        CIF_STAT      = '_refln.status'

        CIF_FC        = '_refln.F_calc'
        CIF_PH        = '_refln.phase_calc'
        CIF_FOM       = '_refln.fom'
        CIF_INT       = '_refln.intensity_meas'
        CIF_SIGI      = '_refln.intensity_sigma'
C -------------------------------------------------
C  only mmCIF:
C
C       _refln.F_meas_au         / in arbitrary units /  
C       _refln.F_meas_sigma_au          The standard uncertainty (e.s.d.)
C
C       _refln.F_calc_au
C
C       _refln.fom
C
C   mmCIF and CIF:
C
C       _refln.F_meas          / in electrons / !!!cif_core.dic: _refln_F_sigma
C       _refln.F_meas_sigma'
C
C       _refln.intensity_meas   /in the measured units./ 
C       _refln.intensity_calc
C       _refln.intensity_sigma
C
C       _refln.F_squared_meas    /in electrons squared./
C       _refln.F_squared_calc
C       _refln.F_squared_sigma
C
C       _refln.F_calc
C
C       _refln.phase_calc    / in degrees /
C       _refln.phase_meas
C
C
C
C       _refln.status     !!! cif_core.dic: _refln_observed_status
C
C                                o
C                                   satisfies _refine.ls_d_res_high
C                                   satisfies _refine.ls_d_res_low
C                                   observed by _reflns.observed_criterion
C                                   not flagged as systematically absent
C                                   not flagged as unreliable
C
C                               <
C                                   satisfies _refine.ls_d_res_high
C                                   satisfies _refine.ls_d_res_low
C                                   unobserved by _reflns.observed_criterion
C                                   not flagged as systematically absent
C                                   not flagged as unreliable
C
C                               -  'systematically absent reflection'
C                               x  'unreliable measurement -- not used'
C                               h  'does not satisfy _refine.ls_d_res_high'
C                               l  'does not satisfy _refine.ls_d_res_low'
C                               f
C                                    satisfies _refine.ls_d_res_high
C                                    satisfies _refine.ls_d_res_low
C                                    observed by _reflns.observed_criterion
C                                    not flagged as systematically absent
C                                    not flagged as unreliable
C                                    excluded from refinement so as to be
C                                    included in calculation of "free" R-factor
C -------------------------------------------
C
C       _refln.F_meas_au_(+)
C       _refln.F_meas_au_(+)_sigma
C       _refln.F_meas_au_(-)
C       _refln.F_meas_au_(-)_sigma
C
C       _refln.intensity_(+)_meas
C       _refln.intensity_(+)_meas_sigma
C       _refln.intensity_(-)_meas
C       _refln.intensity_(-)_meas_sigma
C
C       _refln.F_squared_(+)_meas
C       _refln.F_squared_(+)_sigma
C       _refln.F_squared_(-)_meas
C       _refln.F_squared_(-)_sigma
C
C
C       _refln.coef_H_L_a
C       _refln.coef_H_L_b
C       _refln.coef_H_L_c
C       _refln.coef_H_L_d
C
C -----------------------------------------

        CALL LENSTR_BL(CODE,LCD)
C --    data block       
        CALL LENSTR_BL(CIF_DATA,LDB)
        WRITE(IUN22,'(A)')
     *  CIF_DATA(1:LDB)//'_'//CODE(1:LCD)
C ---   cell
        call lrcell(MTZIN,CELL)

         CALL LENSTR_BL(CIF_CELL_ID,LCC)
        WRITE(IUN22,'(A)')
     *  CIF_CELL_ID(1:LCC)//'  '//CODE(1:LCD)
 
        CALL LENSTR_BL(CIF_CELL1,LC1)
        WRITE(IUN22,'(A,5X,F9.2)')
     *  CIF_CELL1(1:LC1),CELL(1)
        CALL LENSTR_BL(CIF_CELL2,LC2)
        WRITE(IUN22,'(A,5X,F9.2)')
     *  CIF_CELL2(1:LC2),CELL(2)
        CALL LENSTR_BL(CIF_CELL3,LC3)
        WRITE(IUN22,'(A,5X,F9.2)')
     *  CIF_CELL3(1:LC3),CELL(3)
        CALL LENSTR_BL(CIF_CELL4,LC4)
        WRITE(IUN22,'(A,2X,F9.2)')
     *  CIF_CELL4(1:LC4),CELL(4)
        CALL LENSTR_BL(CIF_CELL5,LC5)
        WRITE(IUN22,'(A,3X,F9.2)')
     *  CIF_CELL5(1:LC5),CELL(5)
        CALL LENSTR_BL(CIF_CELL6,LC6)
        WRITE(IUN22,'(A,2X,F9.2)')
     *  CIF_CELL6(1:LC6),CELL(6)
C ---   symmetry

        CALL LENSTR_BL(CIF_SYMM_ID,LSD)
        WRITE(IUN22,'(A)')
     *  CIF_SYMM_ID(1:LSD)//'  '//CODE(1:LCD)

        IF(nspgrx.GT.0) THEN
          CALL LENSTR_BL(CIF_ITNUM,LN)
          WRITE(IUN22,'(A,5X,I6)')
     *    CIF_ITNUM(1:LN),nspgrx
          NO_SPGR=nspgrx
        ENDIF

        IF(spgrnx(1:1).NE.' ') THEN
          CALL LENSTR_BL(CIF_GROUP,LG)
          CALL LENSTR_BL(spgrnx,L)
          WRITE(IUN22,'(A,5X,A)')
     *    CIF_GROUP(1:LG),''''//spgrnx(1:L)//''''
         ENDIF 

c        IF(nsym.GT.0) THEN
c
c          WRITE(IUN22,'(''loop_'')')
c          CALL LENSTR_BL(CIF_EQUIV_ID,LID)
c          WRITE(IUN22,'(A)') CIF_EQUIV_ID(1:LID)
c          CALL LENSTR_BL(CIF_EQUIV_XYZ,LXYZ)
c          WRITE(IUN22,'(A)') CIF_EQUIV_XYZ(1:LXYZ)
c
c          CALL symtr3(nsym,rsym,symchs,0)
c
c          DO  II = 1,nsym
c            CALL LENSTR_BL(symchs(II),L)
c            IF(L.LE.0) THEN
c              CALL ccperr(1,' ***Blank symop from symtr3!!!')
c            ENDIF
c            WRITE(IUN22,'(I5,3X,A)') II,''''//symchs(II)(1:L)//''''
c          ENDDO
c        ENDIF
C ---        

        WRITE(IUN22,'(''loop_'')')
        CALL LENSTR_BL(CIF_INDH,LH)
        WRITE(IUN22,'(A)') CIF_INDH(1:LH)
        CALL LENSTR_BL(CIF_INDK,LK)
        WRITE(IUN22,'(A)') CIF_INDK(1:LK)
        CALL LENSTR_BL(CIF_INDL,LL)
        WRITE(IUN22,'(A)') CIF_INDL(1:LL)
        IF(LOOKUP(N_FR).GT.0) THEN
          CALL LENSTR_BL(CIF_STAT,LST)
          WRITE(IUN22,'(A)') CIF_STAT(1:LST)
        ENDIF
        IF(LOOKUP(N_F).GT.0.OR.LOOKUP(N_FC).GT.0.OR.
     *     LOOKUP(N_PH).GT.0) THEN
C         FP         
          IF(LOOKUP(N_F).GT.0) THEN
            CALL LENSTR_BL(CIF_FP,LFP)
            WRITE(IUN22,'(A)') CIF_FP(1:LFP)
          ENDIF
C         SIGFP 
          IF(LOOKUP(N_SF).GT.0) THEN         
            CALL LENSTR_BL(CIF_SIGF,LSF)
            WRITE(IUN22,'(A)') CIF_SIGF(1:LSF)
          ENDIF
C         Fc
          IF(LOOKUP(N_FC).GT.0) THEN
            CALL LENSTR_BL(CIF_FC,L)
            WRITE(IUN22,'(A)') CIF_FC(1:LST)
          ENDIF
C         PH
          IF(LOOKUP(N_PH).GT.0) THEN
            CALL LENSTR_BL(CIF_PH,L)
            WRITE(IUN22,'(A)') CIF_PH(1:L)
          ENDIF
C         FOM
          IF(LOOKUP(N_FOM).GT.0) THEN
            CALL LENSTR_BL(CIF_FOM,L)
            WRITE(IUN22,'(A)') CIF_FOM(1:L)
          ENDIF          
        ELSE
C         I
          CALL LENSTR_BL(CIF_INT,L)
          WRITE(IUN22,'(A)') CIF_INT(1:L)
C         SIGI 
          IF(LOOKUP(N_SI).GT.0) THEN
            CALL LENSTR_BL(CIF_SIGI,L)
            WRITE(IUN22,'(A)') CIF_SIGI(1:L)
          ENDIF
        ENDIF
C==========================================================================
C     Read input reflection file
C     
 410  CONTINUE

      FP    = 0.0
      SIG   = 0.0
      FF    = 0.0
      SDFF  = 0.0
      FC    = 0.0
      PHASE = 0.0
      FOM   = 0.0
      IFLAG = 0

      danom     = 0.0
      sigdanom  = 0.0
      intens    = 0.0
      sigintens = 0.0

      CALL LRREFF(MTZIN,S,ADATA,EOF)
      IF(EOF) GO TO 370

      CALL LRREFM(MTZIN,LOGMSS)

      RSTAT = 'o'
      IF(LOOKUP(N_FR).GT.0) THEN
        IF(LOGMSS(N_FR)) THEN
          GO TO 410
        ELSE
          I= ADATA(N_FR)
          IF(I.LE.0) RSTAT='f'
        ENDIF
      ENDIF

      IF(SMIN.GT.0.00001.AND.S.LT.SMIN)  GO TO 410
      IF(SMAX.GT.0.00001.AND.S.GT.SMAX)  GO TO 410

      DO II = 1,3
        IN(II) = NINT(ADATA(II))
      ENDDO
      
      IF(LOOKUP(N_F).GT.0) THEN
        IF(LOGMSS(N_F)) THEN
          GO TO 410
        ELSE
          T    = ADATA(N_F)
          IF(T.GT.0.00001) THEN
            ff    = ADATA(N_F)
            sdff  = ADATA(N_SF)
            IFLAG = 1
          ENDIF
        ENDIF
      ENDIF

      IF(LOOKUP(N_FC).GT.0) THEN
        IF(LOGMSS(N_FC)) THEN
          GO TO 410
        ELSE
          T    = ADATA(N_FC)
          IF(T.GT.0.00001) THEN
            FC    = ADATA(N_FC)
            IFLAG = 1
          ENDIF
        ENDIF
      ENDIF

      IF(LOOKUP(N_PH).GT.0) THEN
        IF(LOGMSS(N_PH)) THEN
          GO TO 410
        ELSE
          PHASE  = ADATA(N_PH)
          IFLAG  = 1
        ENDIF
      ENDIF

      IF(LOOKUP(N_FOM).GT.0) THEN
        IF(LOGMSS(N_FOM)) THEN
          GO TO 410
        ELSE
          FOM  = ADATA(N_FOM)
        ENDIF
      ENDIF

      IF(LOOKUP(N_I).GT.0) THEN
        IF(LOGMSS(N_I)) THEN
          GO TO 410
        ELSE
          T    = ADATA(N_I)
          IF(T.GT.0.00001) THEN
            intens    = ADATA(N_I)
            sigintens = ADATA(N_SI)
            IFLAG     = 1
          ENDIF
        ENDIF
      ENDIF

      IF(IFLAG.LE.0) THEN
        GO TO 410
      ENDIF
C ----
c      CALL SYSAB(IN,ISYSAB)
c      IF(ISYSAB.EQ.1) THEN
c        GO TO 410
c      ENDIF
C ---     
      fp  = ff
      sig = sdff

      IANOM = 1
      ISYM  = 0

      IF(LANOM) THEN
C
c       ISYM flag (from Truncate, if present):-
c       = 0 if both F+ & F- present
c       = 1 if only F+ (force this for centric reflections)
c       = 2 if only F-

        IF(LOOKUP(18).GT.0) THEN
          IF(LOGMSS(18)) THEN
            GO TO 410
          ELSE
            ISYM = NINT(ADATA(18))
          ENDIF
        ELSE
          ISYM = 0
        ENDIF
c
        IF(LOOKUP(N_DP).GT.0) THEN

          IF(LOGMSS(N_DP)) THEN
            GO TO 410
          ELSE
            T    = ADATA(N_DP)
            IF(T.GT.0.00001) THEN
              danom    = 0.5 * ADATA(N_DP)
              sigdanom = 0.5 * ADATA(N_SDP)
              IFLAG    = 1
            ENDIF
          ENDIF

        ENDIF

        IF(LOOKUP(N_SDP).GT.0.AND.sigdanom .EQ.0.0) THEN
          danom = 0.0
        ENDIF

C       Centric test
c        CALL CENTR(IN,ICEN)
c        IF(ICEN.EQ.1) THEN
c          ISYM = 1
c        ENDIF

        IF(ISYM.EQ.2) THEN
          IANOM = 2
        ENDIF


C          WRITE(*,*) FF,T,isym,LOGMSS(N_DP)

      ENDIF
c
C loop round +h+k+l and -h-k-l
C
 460  IF(LANOM) THEN

        IF(IANOM.EQ.2) THEN

          danom = -danom

          DO II = 1,3
            IN(II) = -IN(II)
          ENDDO

          IF(LOOKUP(N_IM).GT.0) THEN
            IF(LOGMSS(N_IM)) THEN
              GO TO 410
            ELSE
              T    = ADATA(N_IM)
              IF(T.GT.0.00001) THEN
                intens    = ADATA(N_IM)
                sigintens = ADATA(N_SIM)
                IFLAG     = 1
              ENDIF
            ENDIF
          ENDIF

          IF(LOOKUP(N_FM).GT.0) THEN
            IF(LOGMSS(N_FM)) THEN
              GO TO 410
            ELSE
              T    = ADATA(N_FM)
              IF(T.GT.0.00001) THEN
                FP    = ADATA(N_FM)
                SIG   = ADATA(N_SFM)
                IFLAG     = 1
              ENDIF
            ENDIF
          ENDIF

        ENDIF

        IF(LOOKUP(N_DP).GT.0) THEN
          IF(LOGMSS(N_DP)) THEN
            GO TO 410
          ELSE
            T    = ADATA(N_F)
            IF(T.GT.0.00001) THEN
              fp    = ff + danom
              sig   = sqrt(sdff**2 + sigdanom**2)
              IFLAG = 1
            ENDIF
          ENDIF
        ENDIF

        IF(IFLAG.LE.0) THEN
          GO TO 410
        ENDIF

      ENDIF
C ---
      IF(NRFOUT.GT.0.AND.MOD(NRFOUT,5000).EQ.0) THEN     

        IF(LOOKUP(N_I).GT.0.OR.LOOKUP(N_IM).GT.0) THEN
          FTEMP   = intens
          SIGTEMP = sigintens
          WRITE(*,
     *    '(''N,hkl,I,sig,stat :'',I8,1X,3I5,2X,2G16.4,1X,A1)') 
     *    NRFOUT,IN(1),IN(2),IN(3),FTEMP,SIGTEMP,RSTAT
        ELSE
          FTEMP   = FP
          SIGTEMP = SIG
          WRITE(*,
     *    '(''N,hkl,F,sig,stat :'',I8,1X,3I5,2X,2G16.4,1X,A1)') 
     *    NRFOUT,IN(1),IN(2),IN(3),FTEMP,SIGTEMP,RSTAT
        ENDIF

      ENDIF
C        
      NRFOUT = NRFOUT+1
C ---
C     write CIF
C
      WRITE(LINE_CIF(1:15),'(1X,I4,1X,I4,1X,I4)')
     * IN(1),IN(2),IN(3)
      LS=15


C     rstat
      IF(LOOKUP(N_FR).GT.0) THEN
        LINE_CIF=LINE_CIF(1:LS)//' '//RSTAT
        LS=LS+2
      ENDIF

      IF(LOOKUP(N_F).GT.0.OR.LOOKUP(N_FC).GT.0.OR.
     *   LOOKUP(N_PH).GT.0) THEN
C       FP         
        IF(LOOKUP(N_F).GT.0) THEN
          WRITE(CH20,'(2X,F15.2,3X)') FP
          CALL LENSTR_BL(CH20,L)
          LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
          CALL LENSTR_BL(LINE_CIF,LS)
        ENDIF
C       SIGFP 
        IF(LOOKUP(N_SF).GT.0) THEN         
          WRITE(CH20,'(2X,F15.2,3X)') SIG
          CALL LENSTR_BL(CH20,L)
          LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
          CALL LENSTR_BL(LINE_CIF,LS)
        ENDIF
C       Fc
        IF(LOOKUP(N_FC).GT.0) THEN
          WRITE(CH20,'(2X,F15.2,3X)') FC
          CALL LENSTR_BL(CH20,L)
          LT=LS+L
          IF(LT.GT.78) THEN
            WRITE(IUN22,'(A)') LINE_CIF(1:LS)
            LINE_CIF='  '//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)            
          ELSE
            LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)
          ENDIF
        ENDIF
C       PH
        IF(LOOKUP(N_PH).GT.0) THEN
          WRITE(CH20,'(2X,F8.2,10X)') PHASE
          CALL LENSTR_BL(CH20,L)
          LT=LS+L
          IF(LT.GT.78) THEN
            WRITE(IUN22,'(A)') LINE_CIF(1:LS)
            LINE_CIF='  '//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)            
          ELSE
            LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)
          ENDIF
        ENDIF
C       FOM
        IF(LOOKUP(N_FOM).GT.0) THEN
          WRITE(CH20,'(2X,F6.3,12X)') FOM
          CALL LENSTR_BL(CH20,L)
          LT=LS+L
          IF(LT.GT.78) THEN
            WRITE(IUN22,'(A)') LINE_CIF(1:LS)
            LINE_CIF='  '//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)            
          ELSE
            LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)
          ENDIF
        ENDIF          
      ELSE
C       I
        WRITE(CH20,'(2X,F15.2,3X)') intens
        CALL LENSTR_BL(CH20,L)
        LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
        CALL LENSTR_BL(LINE_CIF,LS)
C       SIGI 
        IF(LOOKUP(N_SI).GT.0) THEN
          WRITE(CH20,'(2X,F15.2,3X)') sigintens
          CALL LENSTR_BL(CH20,L)
          LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
          CALL LENSTR_BL(LINE_CIF,LS)
        ENDIF
      ENDIF

      IF(LS.GT.0) THEN
        WRITE(IUN22,'(A)') LINE_CIF(1:LS)
      ENDIF

      IF(LANOM) THEN
        IF(IANOM.EQ.1.AND.ISYM.NE.1) THEN
          IANOM = 2
          IFLAG = 0
          GO TO 460
        ENDIF
      ENDIF

      GO TO 410
C ------------------------------------------------------------
  370 CONTINUE

C ---
c      WRITE(*,*) ' -----------------------------'
c      WRITE(*,'(''Number of reflections output :'',I9)') NRFOUT
      END FILE IUN22
      CLOSE(UNIT=IUN22,STATUS='KEEP')
c      WRITE(*,*)

      CALL LRCLOS(MTZIN)
C     CALL CCPERR(0,'Normal termination')

      RETURN
      END

C -I-
      SUBROUTINE DNS2CCP4(MDOC,NAME1,NAMEW,SCALE
     *    ,POOL,MEMORY,IERR)
C ---------------------------------------------
C -P- DNS2CCP4 : converts density map to CCP4 format 
C -S-
C      Dialog and Batch:
C
C   FILE_1:       - name of input dens-file.
C   FILE_O:       - output_file 
C   SCALE: <1.0>  - Dout = Dinput * SCALE')
C
C      SUBROUTINE DNS2CCP4(MDOC,NAME1,NAMEW,SCALE
C     *    ,POOL,MEMORY,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAME1  - name of input dens-file.
C      NAMEW  - name of output dens-file.
C      SCALE  <1.0>  - Dout = Dinput * SCALE')
C      POOL   -  real array POOL(MEMORY).
C      MEMORY -  is memory for one Z-section of electron
C                density NX x NY.
C      IERR   - signal of error / =1 -error , =o - OK / 
C -I-
C ----------------------
      REAL      POOL(MEMORY)
      CHARACTER NAME1*(*),NAMEW*(*)
      CHARACTER TTT1*80,TYPE*4
      CHARACTER LINE*256
      CHARACTER CODE*4,STR_TITLE*40,STR_DATE*9,SPGR*24 
      CHARACTER TITLE*80
C -------------------------------
      INTEGER    IUVW(3),MXYZ(3)
      REAL       CELL(6)
      CHARACTER  MAPTITLE*80
C ----------------------------------------------------------------------
      PI      = 4.0*ATAN(1.0)
      CONV    = 180./PI
      MD      = -ABS(MDOC)-1
      M       = 99
      M0      = 0
      IPRSYM  = 96
      IERR    = 0
      IF(SCALE.LT.0.0000001) SCALE =1.0
C ----------------------
C     READ OF TITLE OF INPUT FILE-
C
      ITYPE  =  0
      MTIN1  = 40
       CALL RDENS(MTIN1,NAME1,MD,ITYPE,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     * IZMIN1,RMAX1,RMIN1,POOL,A1,B1,C1,AL1,BE1,GA1,DRMS1,
     * RAVER,RESOL1,IX01,IY01,IZ01,ITR1,TTT1,NSYM,POOL,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: FILE-DENS')
        IERR=1
        RETURN
      ENDIF
      CALL C_RD_CR
      NXY1 = NX1*NY1
      IF(NXY1.GT.MEMORY) THEN
        WRITE(LINE,
     *  '('' ERROR: not memory '',I4,'' x'',I4,'' >'',I8)')
     *             NX1,NY1,MEMORY
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      CALL GET_CELL(CELL,CODE,STR_TITLE,STR_DATE,TITLE
     *      ,NGROUP,NSETT,SPGR,NSM,IERR)
C--------------------------------------------------------
      CALL LENSTR_BL(NAMEW,LEN)
      IF(LEN.LE.0.OR.NAMEW(1:1).EQ.','.OR.NAMEW.EQ.' ') THEN
        CALL MSGERR(MD,' ERR: OPEN OUTPUT-FILE-DENS')
        CLOSE(MTIN1)
        IERR=1
        RETURN
      ENDIF 
      CALL CLEAR_LINE(NAMEW)
      CALL LENSTR_BL(NAMEW,LENW)
C ---------------------------------------------------------------
C INITIALIZE CCP4 ROUTINES

C     CALL CCPFYP

C     CALL MTZINI
      IUVW(1)  = 1
      IUVW(2)  = 2
      IUVW(3)  = 3

c      NW1      = IZMIN1
      NW1      = IZ01
      NU1      = IX01
      NU2      = IX01+NX1-1
      NV1      = IY01
      NV2      = IY01+NY1-1
      LMODE    = 2
      MXYZ(1)  = NX1
      MXYZ(2)  = NY1
      MXYZ(3)  = NZ1
      NSEC     = IZMAX1-IZMIN1+1
      CELL(1)  = A1
      CELL(2)  = B1
      CELL(3)  = C1
      CELL(4)  = AL1*CONV
      CELL(5)  = BE1*CONV
      CELL(6)  = GA1*CONV
      MAPTITLE = TTT1
      IUN      = 1
      IF(ITR1.EQ.0) THEN
        LSPGRP   = NGROUP
      ELSE
        LSPGRP   = 1
      ENDIF
C  Open MAPOUT for writing and write map header
      call mwrhdl(IUN,NAMEW(1:LENW),MAPTITLE,NSEC,IUVW
     * ,mxyz,nw1,nu1,nu2,nv1,nv2,cell,lspgrp,lmode)
C --------------------------------------------------------------
      ICNTZ1 = -999
      ITYP1  = 1
C---------------------------------------------------------------
      DO  IZ=IZMIN1,IZMAX1
C -----------------------
        CALL RDENS(MTIN1,NAME1,MDOC,ITYP1,ICNTZ1,NX1,NY1,NZ1,IZMAX1
     *  ,IZMIN1,RMAX1,RMIN1,POOL,A1,B1,C1,AL1,BE1,GA1,DRMS1
     *  ,RAVER,RESOL1,IX01,IY01,IZ01,ITR1,TTT1,NSYM,POOL,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: FILE-DENS-1')
          IERR=1
C          CLOSE(MTS)
          RETURN
        ENDIF

c        WRITE(LINE,*) ' Z = ',IZ
c        CALL MSGDOC(M0,LINE)
C ---
        DO IY=0,NY1-1
          IND0 = IY*NX1
          DO  IX=0,NX1-1
            IND  = IND0+IX+1
            D1   = POOL(IND)
            DOUT = D1*SCALE
            POOL(IND) = DOUT
C ---
          ENDDO
        ENDDO

        call mspew(iun,pool)

C -----------
      ENDDO
C---------------------
      CLOSE(MTIN1)
      call mwclose(iun)
C      CLOSE(MTS)
      RETURN
      END

      SUBROUTINE SET_NAME_CCP4(FILE_SC,PATH_SCR,IERR)
      CHARACTER FILE_SC*(*),PATH_SCR*(*)
      INTEGER   IERR,LEN
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_SC  = PATH_SCR(1:LEN)//'sfcheck_map'
      ELSE
        FILE_SC='sfcheck_map'
      ENDIF
      IERR = 0
      RETURN
      END

      SUBROUTINE BLANC2MTZ(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
     *        ,CFOM,CFREE,CSIG,ANOM
     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ----------------------------------------------------
C  
C BLANC2MTZ writes a contents of internal BLANC files: Fobs, Fcalc, Phases 
C           to new MTZ file. The exit from program suite BLANC.
C 
C          This program reads contents of files: 
C                 Fobs              or  
C                 Fobs and Fcalc    or
C                 Fobs and Phases   or  
C                 Fobs and Fcalc and Phases
C
C   Dialogue and Batch:
C  
C     FILE_F:  - input file_Fobs  of the modules of structure factors.
C     FILE_C:  - input file_Fcalc of the modules of structure factors.
C     FILE_PH: - input file_Phases.
C     RESOL: MIN,MAX - resolution <default from files>
C     FOM:   <Y>,N   - Y means to write FOM'
C     FREE:  <N>,Y   - Y means to write FREE-flag'
C     SIG:   <Y>,N   - Y means to write sigmas of F'
C     FILE_O: <blanc2mtz.mtz> - output_file 
C
C  Parameters of subroutine BLANC2MTZ: 
C
C      SUBROUTINE BLANC2MTZ(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
C     *        ,CFOM,CFREE,CSIG
C     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C    MDOC   - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    F_NAME:  - input file_Fobs  of the modules of structure factors.
C    F2_NAME: - input file_Fcalc of the modules of structure factors.
C    PH_NAME: - input file_Phases.
C    RESMINR: - resolution <default from files>
C    RESMAXR:  
C    CFOM:  /character*1/ <Y>,N   - Y means to write FOM'
C    CFREE: /character*1/ <N>,Y   - Y means to write FREE-flag'
C    CSIG:  /character*1/ <Y>,N   - Y means to write sigmas of F'
C    FO_NAME: <blanc2mtz.mtz> - output_file 
C    ISYM     - integer*2 array for cryst.symmetry operators.
C    IPRSYM   - dimension of integer*2 array ISYM(5,3,IPRSYM),
C               number of cryst. symm. operators.
C    IERR     - output signal of error / = 1 -error , = 0 - OK / 
C
C    RESULT /real RESULT(IPRROW)/ - array for output information:
C
C    RESULT(1) - 
C    RESULT(2) - 
C 
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
      INTEGER*4 MDOC,IERR
      CHARACTER F_NAME*(*),F2_NAME*(*),PH_NAME*(*),FO_NAME*(*),CFOM*1
      CHARACTER STAT*1,CFREE*1,CSIG*1,ANOM*1
C ==============================
      INTEGER*4 MTIN,MTNAT,MTOUT
      CHARACTER ITYPE*4,ITYP*4,ITF1*4,ITF2*4,ITF3*4,ITFW*4
      CHARACTER LINE*256,TTT*80,TTT1*80,TITLE*80,PATH*80,EXT*80
      CHARACTER LINE1*256
C --- ccp4  
      integer maxlab, maxtok
C Max number of labels
      parameter (maxlab = 80)
C Max number of tokens for 'parser'
      parameter (maxtok = 2*maxlab+1)
      real adata(maxtok-1)      
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1

      md = mdoc

      IERR = 0
      PI   = 4.0*ATAN(1.0)
C
C     ITYP  ='FF  '  means 'F   ' or 'FS  '
C     ITYP  ='F   '
C     ITYP  ='FS  '
C     ITYP  ='    '  means ALL  
C     ITYP  ='ABCD'
C     ITYP  ='COEF'
C     ITYP  ='PH  '
C     ITYP  ='RI  '
C
C     Subroutine ORFILE returns actual type by ITYP
C
      MT1 = 20
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        IERR=1
        RETURN
      ENDIF
      ITYP = 'FF  '
C
C     ORFILE - 1.open file FNAME 
C              2.reads title of file,return file parameters,fill /COMRDF/.
C                copy file_parameters to /COMRDF/.
C
      CALL ORFILE(MD,MT1,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN FILE-F-1')
        RETURN
      ENDIF
C
C     GET_TITLE - gets information from /COMRDF/
C
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RN,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      ITF1 = ITYP
C
C     for 'COEF':   TITLE(1:4)='FOUR' or 'PATT'
C
C -------------------------------------------------------------
C
C     C_RD_CR - copy parameters from common/COMRDF/ to common/CRYSTL/
C               also using CELL parameters from common/CRYSTL/ calculates
C               reciprocal cell parameters and volume and put its 
C               to common/CRYSTL/
C               
      CALL C_RD_CR
C -------------------------------------------------------------
      MT2   = 21
      ITYPE = 'FF  '
      CALL LENSTR_BL(F2_NAME,LEN)
      IF(LEN.LE.0.OR.F2_NAME(1:1).EQ.' '.OR.F2_NAME(1:1).EQ.',') THEN
        MT2=0
      ELSE
        CALL ORFILE(MD,MT2,F2_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A1,B1,C1,AL1,BE1,GA1
     *  ,DM1,DM2,RN1,RX1,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
        ITF2=ITYPE
      ENDIF
C ------------------
      MT3   = 22
      ITYPE = 'PH  '
      CALL LENSTR_BL(PH_NAME,LEN)
      IF(LEN.LE.0.OR.PH_NAME(1:1).EQ.' '.OR.PH_NAME(1:1).EQ.',') THEN
        MT3=0
      ELSE
        CALL ORFILE(MD,MT3,PH_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-PH')
          CLOSE(MT1)
          IF(MT2.GT.0) CLOSE(MT2)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A2,B2,C2,AL2,BE2,GA2
     *  ,DM1,DM2,RN2,RX2,IDM,IDM,IDM,IDM,IDM,TTT1,IERR)
        ITF3=ITYPE
      ENDIF
C -----------------
      IF(CFOM .EQ.'n') CFOM  = 'N'
      IF(CFOM .NE.'N') CFOM  = 'Y'
      IF(CFREE.EQ.'y') CFREE = 'Y'
      IF(CFREE.NE.'Y') CFREE = 'N'
      IF(CSIG .EQ.'n') CSIG  = 'N'
      IF(CSIG .NE.'N') CSIG  = 'Y'
      IF(ANOM .EQ.'y') ANOM  = 'Y'
      IF(ANOM .NE.'Y') ANOM  = 'N'
C ---
      RESMIN = RESMINR
      RESMAX = RESMAXR
      IF(RESMIN.LE.0.0)   RESMIN = RN
      IF(RESMAX.LE.0.0)   RESMAX = RX
      IF(RN .LT.RESMIN)   RESMIN = RN
      IF(RX .GT.RESMAX)   RESMAX = RX
      IF(MT2.GT.0) THEN
        IF(RN1.LT.RESMIN)   RESMIN = RN1
        IF(RX1.GT.RESMAX)   RESMAX = RX1
      ENDIF
      IF(MT3.GT.0) THEN
        IF(RN2.LT.RESMIN)   RESMIN = RN2
        IF(RX2.GT.RESMAX)   RESMAX = RX2
      ENDIF
      WRITE(LINE,'(''RESOLUTION MIN,MAX '',2F7.2)') RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      RHMIN = 1.0/(RESMIN)
      RHMAX = 1.0/(RESMAX)
C ---------------
      MTOUT = 0
      CALL LENSTR_BL(FO_NAME,LEN)
      IF(LEN.GT.0.AND.FO_NAME(1:1).NE.' '.AND.FO_NAME(1:1).NE.',') THEN
      ELSE
        FO_NAME = 'blanc2mtz.mtz'
      ENDIF
C --- ccp4
c/////
c      call ccpfyp
c/////

      call mtzini
C     CALL CCPRCS(-1,'mir2mtz','$Date: 1999/10/10 13:09:42 $')
C Open mtz file 
      MTOUT = 1
      call lwopen(MTOUT,FO_NAME)       

      CALL WR_TITLE_MTZ(M,MTOUT,ITYP,TITLE
     *   ,MT2,MT3,CSIG,CFOM,CFREE,ANOM
     *   ,NSYM,ISYM,IPRSYM,IERR)

C --- ccp4

c       MTOUT=30
c
C ---
C       C_CR_WR - copy parameters from common/CRYSTL/ to common/COMWRF/
C
C        CALL C_CR_WR
C ---
C       SET_TITLE - sets information to  /COMWRF/
C 
C        CALL SET_TITLE(MD,A,B,C,
C     *  AL,BE,GA,COEF1,BET1,RESMIN,RESMAX,
C     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
C        ITFW = 'F   '
C
C       OWFILE - 1.open file 
C                2.writes title to file, parameters from common /COMRDF/
C
C        CALL OWFILE(MD,MTOUT,FO_NAME,ITFW,NSYM,ISYM,IPRSYM,IERR)
c
c        PATH  = ' '
c        EXT   = ' '      
c        CALL OPENFW(MTOUT,MD,PATH,FO_NAME,EXT,IERR)
c        IF(IERR.NE.0) THEN
c          CLOSE (MT1)
c          IF(MT2.GT.0) CLOSE (MT2)
c          IF(MT3.GT.0) CLOSE (MT3)
c          CALL MSGERR(MDOC,' ERR: OPEN FILE-OUTPUT')
c          IERR=1
c          RETURN
c        ENDIF
c
c        CALL WR_TITLE_CIF(M,MTOUT,ITYP,TITLE
c     *   ,MT2,MT3,CSIG,CFOM,CFREE
c     *   ,NSYM,ISYM,IPRSYM,IERR)
c
c      ENDIF

C ----------------------------------------------------------
C ---
C 
C     initialization for CENTR_BL and ANOMSC
C
      CALL INIT_CENTR(NSYM,ISYM)
      CALL ANOMF(M,NSYM,ISYM)
C
C     calc limits H,k,l and grid for RESMAX
C
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)

C ---
      SUMA   = 0.0
      SUMB   = 0.0
      SUMFOM = 0.0
      NTOT   = 0
C ----
      IEND1 =-1
      IEND2 =-1
      IEND3 =-1
      IENDW =-1
      JH    =-200
      JK    =-200
      JL    =-200
      KH    =-200
      KK    =-200
      KL    =-200
      LH    =-200
      LK    =-200
      LL    =-200
C -----------------------------------------
      DO     IL=0,ILMAX
      DO     IK=-IKMAX,IKMAX
      DO     IH=-IHMAX,IHMAX
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 100
        IHP = IH
        IKP = IK
        ILP = IL
C
C        ANOMSC - transforms h,k,l to asymmetrycal part of reciprocal space.
C        output : IH,IK,IL -   indices h,k,l from asymmetrycal part
C                 IANOM    - 0   +h,+k,+l
C                            1   -h,-k,-l
C                 JJSYM    - number operator of symmetry :
C                                 in(h,k,l) -- JJSYM --> out(h,k,l)
C
        CALL ANOMSC(IHP,IKP,ILP,IANOM,JJSYM,NSYM,ISYM)
        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 100

        IF(NSYM.GT.1) THEN
C
C         SYSABS - check systematic absent for h,k,l: 1 - absent, 0 - no.
C
          CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        ELSE
          ICND = 0
        ENDIF
C
C ---   ICND NE 0 systematic absent
C
        IF(ICND.NE.0) GO TO 100
C 
C       DSTAR - gives value of (4pi*sin(theta))/lambda for H,K,L
C
        CALL DSTAR_BL(IH,IK,IL,RSQ)
        RH = SQRT(RSQ)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 100
C ---
C       CENTR_BL - Determine whether a reflection (IH,IK,IL) is centric or not

        CALL CENTR_BL(IH,IK,IL,JCENT)
C
C ---   JCENT = 1 centric reflection, JCENT = 0 acentric reflection
C ---
C ------
  200   CONTINUE
        IMISS1 = 1

C         You can default data to `missing' with free format.
c         adata(i) = nan
C         before call qnan(nan)

        IF(IEND1.GT.0)                    GO TO 110

C        IF(JL-IL) 240,210,300
C  210   IF(JK-IK) 240,220,300
C  220   IF(JH-IH) 240,230,300

        IF((JL-IL).LT.0) THEN
          GO TO 240
        ELSE IF((JL-IL).EQ.0) THEN
          GO TO 210
        ELSE 
          GO TO 100
        ENDIF

 210    IF((JK-IK).LT.0) THEN
          GO TO 240
        ELSE IF((JK-IK).EQ.0) THEN
          GO TO 220
        ELSE 
          GO TO 100
        ENDIF

 220    IF((JH-IH).LT.0) THEN
          GO TO 240
        ELSE IF((JH-IH).EQ.0) THEN
          GO TO 230
        ELSE 
          GO TO 100
        ENDIF

C ------
  240   CONTINUE
C
C        RD1 - read from MT1 ; type of file :"F   ","PH  ","COEF","ALMN"
C        RRD1- read from MT1 ; type of file :"FS  "
C 
        IF(ITF1.EQ.'FS  ') THEN
          CALL RRD1(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
        ELSE
          CALL RD1(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C
C        IF(ITF2.EQ.'COEF') THEN
C          CALL RD1(MT1,JH,JK,JL,FA,FB,KEY1,IEND1)
C        IF(ITF2.EQ.'ABCD') THEN
c          CALL RABCD(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C        IF(ITF2.EQ.'PH  ') THEN
c          CALL RD1(MT1,JH,JK,JL,COSFOM,SINFOM,KEY1,IEND1)
C
C Possible to use:
C          CALL RD(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD2(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD2(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD3(MT1,JH,JK,JL,FN,FNA,NUMB,IEND)
C          CALL RRD3(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD4(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD4(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RABCD1(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C

C         SIG-DUMMY
          SN  = 0.04*FN
          SNA = 0.04*FNA
        ENDIF

        IT1 = KEY1/2        
        IFLAG_FREE = KEY1 - IT1*2 
        IT3  = IT1/2
        IT3  = IT3-IT1*2
C       if IFLAG_FREE = 1 - free reflection
C       use program COPYFL to set "free flag".
        STAT = 'o'
        IF(IFLAG_FREE.EQ.1) STAT = 'f'
        IF(IT3       .EQ.1) STAT = 'r'


 
        IF(MT1.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_1')
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND1.GT.0)                   GO TO 110
        IF(FN.LE.1.E-6.AND.FNA.LE.1.E-6) GO TO 100

        IF(ANOM.NE.'Y') THEN
         IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
            WT1 = 1./(SN*SN)
            WT2 = 1./(SNA*SNA)
            WT  = WT1+WT2
            FN  = FN*WT1+FNA*WT2
            FN  = FN/WT
            SN  = 1./SQRT(WT)
          ELSE IF(FNA.GT.1.E-6) THEN
            FN = FNA
            SN = SNA
          ENDIF
        ENDIF

        GO TO 200

  230   IMISS1 = 0
C ------
  300   CONTINUE
        IMISS2=1
        IF(IEND2.LT.0.AND.MT2.LE.0)                   GO TO 400
        IF(IEND2.GT.0.OR.MT2.LE.0)                    GO TO 110

C        IF(KL-IL) 340,310,400
C  310   IF(KK-IK) 340,320,400
C  320   IF(KH-IH) 340,330,400

        IF((KL-IL).LT.0) THEN
          GO TO 340
        ELSE IF((KL-IL).EQ.0) THEN
          GO TO 310
        ELSE 
          GO TO 100
        ENDIF

 310    IF((KK-IK).LT.0) THEN
          GO TO 340
        ELSE IF((KK-IK).EQ.0) THEN
          GO TO 320
        ELSE 
          GO TO 100
        ENDIF

 320    IF((KH-IH).LT.0) THEN
          GO TO 340
        ELSE IF((KH-IH).EQ.0) THEN
          GO TO 330
        ELSE 
          GO TO 100
        ENDIF

C ------
  340   CONTINUE
        IF(ITF2.EQ.'FS  ') THEN
          CALL RRD2(MT2,KH,KK,KL,FD,FDA,SF,SFA,KEY2,IEND2)
        ELSE
          CALL RD2(MT2,KH,KK,KL,FD,FDA,KEY2,IEND2)
C         SIG-DUMMY
          SF  = 0.04*FD
          SFA = 0.04*FDA
        ENDIF
        IF(MT2.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_2')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND2.GT.0)                   GO TO 110
        IF(FD.LE.1.E-6.AND.FDA.LE.1.E-6) GO TO 100
        IF(FD.GT.1.E-6.AND.FDA.GT.1.E-6) THEN
          WT1 = 1./(SF*SF)
          WT2 = 1./(SFA*SFA)
          WT  = WT1+WT2
          FD  = FD*WT1+FDA*WT2
          FD  = FD/WT
          SF  = 1./SQRT(WT)
        ELSE IF(FDA.GT.1.E-6) THEN
          FD = FDA
          SF = SFA
        ENDIF
        GO TO 300

  330   IMISS2 = 0
C --------------------------------------------
  400   CONTINUE

        IMISS3 = 1
        IF(IEND3.LT.0.AND.MT3.LE.0)                   GO TO 500
        IF(IEND3.GT.0.OR.MT3.LE.0)                    GO TO 110

        IF((LL-IL).LT.0) THEN
          GO TO 440
        ELSE IF((LL-IL).EQ.0) THEN
          GO TO 410
        ELSE 
          GO TO 100
        ENDIF

 410    IF((LK-IK).LT.0) THEN
          GO TO 440
        ELSE IF((LK-IK).EQ.0) THEN
          GO TO 420
        ELSE 
          GO TO 100
        ENDIF

 420    IF((LH-IH).LT.0) THEN
          GO TO 440
        ELSE IF((LH-IH).EQ.0) THEN
          GO TO 430
        ELSE 
          GO TO 100
        ENDIF
C ------
  440   CONTINUE
        CALL RD3(MT3,LH,LK,LL,COSFOM,SINFOM,KEY3,IEND3)
        IF(MT3.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_PH')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND3.GT.0)                   GO TO 110

        TEMP = (COSFOM*COSFOM+SINFOM*SINFOM)
        FOM  = SQRT(TEMP)
C       WRITE(*,*) FOM,TEMP
        IF(FOM.LE.0.00001) GO TO 440
        COPH = COSFOM/FOM
        SIPH = SINFOM/FOM
        IF(ABS(COPH).LT.1.E-5) THEN
          PHI = 90.
          IF(SIPH.LT.0.) PHI = PHI+180.
        ELSE
          PHI = (ATAN(SIPH/COPH))*57.29578
          IF(PHI.LT.0.) THEN
            IF(SIPH.LE.0.) THEN
              PHI = PHI + 360.
            ELSE
              PHI = PHI + 180.
            ENDIF
          ELSE IF(PHI.EQ.0.) THEN
            IF(COPH.LT.0.) PHI = PHI + 180.
          ELSE
            IF(SIPH.LE.0.) PHI = PHI + 180.
          ENDIF
        ENDIF

C       SUMFOM = SUMFOM+FOM

        GO TO 400

  430   IMISS3 = 0
C --------------------------------------------
  500   CONTINUE
C -----------------------------------------------------
C       SUMFOM = SUMFOM+FOM

        NTOT = NTOT+1

C ---
C        IF(MTOUT.GT.0) THEN

           
          IF(CSIG.EQ.'Y') THEN
C            WRITE(LINE1,
C     *      '(3I4,1X,F12.4,1X,F10.4)') 
C     *      IH,IK,IL,FN,SN
            adata(1) = IH
            adata(2) = IK
            adata(3) = IL
            adata(4) = FN
            adata(5) = SN
            IP       = 6
          ELSE
C            WRITE(LINE1,
C     *      '(3I4,1X,F12.4,1)') 
C     *      IH,IK,IL,FN
            adata(1) = IH
            adata(2) = IK
            adata(3) = IL
            adata(4) = FN
            IP       = 5
          ENDIF
   
          IF(ANOM.EQ.'Y') THEN
            IF(CSIG.EQ.'Y') THEN
              adata(IP  ) = FNA
              adata(IP+1) = SNA
              IP          = IP + 2
            ELSE
              adata(IP) = FNA
              IP        = IP + 1
            ENDIF
          ENDIF

C         LINE = LINE1
          IF(MT2.GT.0) THEN
C            IF(CSIG.EQ.'Y') THEN
C              WRITE(LINE,
C     *        '(F12.4,1X,F10.4)') 
C     *        FD,SF
C              adata(IP  ) = FD
C              adata(IP+1) = SF
C              IP        = IP + 2
C            ELSE
C              WRITE(LINE,
C     *        '(F12.4)') 
C     *        FD
              adata(IP) = FD
              IP        = IP + 1
C            ENDIF
C            CALL LENSTR_BL(LINE ,LEN)
C            CALL LENSTR_BL(LINE1,LEN1)
C            LINE = LINE(1:LEN)//' '//LINE1(1:LEN1)
          ENDIF
          IF(MT3.GT.0) THEN
            IF(CFOM.EQ.'Y') THEN
C              WRITE(LINE1,
C     *        '(F8.3,1X,F6.3)') 
C     *        PHI,FOM
              adata(IP  ) = PHI
              adata(IP+1) = FOM
              IP          = IP + 2
            ELSE
C              WRITE(LINE1,
C     *        '(F8.3)') 
C     *        PHI
              adata(IP) = PHI
              IP        = IP + 1
            ENDIF
C            CALL LENSTR_BL(LINE ,LEN)
C            CALL LENSTR_BL(LINE1,LEN1)
C            LINE = LINE(1:LEN)//' '//LINE1(1:LEN1)
          ENDIF

          IF(CFREE.EQ.'Y') THEN
C           CALL LENSTR_BL(LINE ,LEN)
C           LINE = LINE(1:LEN)//' '//STAT
            IF(STAT.EQ.'o') THEN
C             include
              adata(IP) = 1.0
              IP        = IP + 1
            ELSE
C             exclude
              adata(IP) = 0.0
              IP        = IP + 1
            ENDIF
          ENDIF

C          CALL WRTSTR(MTOUT,M,LINE,IERR)
C        ENDIF

         call lwrefl (MTOUT, adata)

C ----
 100  CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ---------------------------------------
  110 CONTINUE

      CLOSE (MT1)
      IF(MT2.GT.0) CLOSE (MT2)
      IF(MT3.GT.0) CLOSE (MT3)

c      IF(MTOUT.GT.0) THEN

      IF(NTOT.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: number of reflections = 0')
c       CLOSE(MTOUT)
        close(unit=MTOUT,status='keep')
        IERR=1
        RETURN
      ENDIF
C ---
 50   call lwclos (MTOUT, 0)
      close(unit=MTOUT,status='keep')

c      write (*,'(i7, '' input reflections processed'')') NTOT
c      call ccperr(0,'Normal termination')

C        END FILE MTOUT
C        CLOSE(MTOUT)
c      ENDIF

C ----------------------------------------------
      RESULT(1) = NTOT
      RESULT(2) = RESMIN
      RESULT(3) = RESMAX
C -----------------------------------------------------------
      WRITE(LINE,1000) NTOT
 1000 FORMAT('Number of reflections = ',I8)
      CALL MSGDOC(MDOC,LINE)
      RETURN
      END

      SUBROUTINE WR_TITLE_MTZ(MDOC,IOUT,TYPE,TTT
     * ,MT2,MT3,CSIG,CFOM,CFREE,ANOM
     * ,NSYM,ISYM,NSMAX,IERR)
C ----------------------------------------------------------
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER TYPE*4,TTT*(*)
C ------------------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*11,USER_TITLE*80
C -------
      CHARACTER LINE*256,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C ---
      CHARACTER SYMOP*24,CH10*10,CODE*8,TEMPER*5,WAVE*5,CODE_NDB*8
      CHARACTER TITLE*80,CSIG*1,CFOM*1,CFREE*1,ANOM*1
C --- ccp4
      real      cell(6)
      integer   maxlab
C Max number of labels
      parameter (maxlab = 80)
C Max number of tokens for 'parser'
      parameter (maxtok = 2*maxlab+1)

      integer   ntok
      integer   nlprgo
      integer   ibeg(maxtok), iend(maxtok), ityp(maxtok)
      real      fvalue(maxtok)

      COMMON /COM_MTZ_INFO/ nsymx, nsympx, nspgrx,rsymx,spgrnx,pgnamx
      integer   nsymx, nsympx, nspgrx
      character spgrnx*10, pgnamx*10
      real      rsymx(4,4,192)
c      integer   nsymx, nsympx, nspgrx
c      real      rsymx(4,4,192)
c      character spgrnx*10, pgnamx*10

      real      nan
      character lsprgo(maxlab)*30, ctprgo(maxlab)
      character str*500
C -------------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.0
      IERR  = 0
C --------------------------------

C cell parameters

      cell(1) = A_CELL
      cell(2) = B_CELL
      cell(3) = C_CELL
      cell(4) = (AL_CELL*180.0)/PI
      cell(5) = (BE_CELL*180.0)/PI
      cell(6) = (GA_CELL*180.0)/PI

      call lwcell(1, cell)

C  SYMMETRY 

c      WRITE(str,'(I6)') NSP_GROUP
C      str       = 'SYMM 19'
      str       = ' '
      ibeg(1)   = 1
      iend(1)   = 4
      ityp(1)   = 1
      fvalue(1) = 0
      ibeg(2)   = 6
      iend(2)   = 7
      ityp(2)   = 2
      fvalue(2) = NSP_GROUP
c      fvalue(2) = 19

      ntok      = 2
      nsymx     = 0
cc      spgrnx    = 'P212121'
      spgrnx    = ' '
      pgnamx    = ' '
      nspgrx  = 0
      nsympx  = 0

      call rdsymm (2, str, ibeg, iend, ityp, fvalue, ntok,
     $        spgrnx, nspgrx, pgnamx, nsymx, nsympx, rsymx)

C -------------------------
c      WRITE(LINE,'(''loop_'')')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      LINE='_refln.index_h'
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      LINE='_refln.index_k'
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      LINE='_refln.index_l'
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C -------------------------
C     LABOUT 
c      lsprgo(k) = str(ibeg(i):iend(i))
c      nlprgo = (ntok-1)
C    CTYPOUT 
c      ctprgo(k) = str(ibeg(i):iend(i))

 
c      LINE='_refln.F_meas_au'
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      nlprgo         = 1
      lsprgo(nlprgo) = 'H'
      ctprgo(nlprgo) = 'H'

      nlprgo         = 2
      lsprgo(nlprgo) = 'K'
      ctprgo(nlprgo) = 'H'

      nlprgo         = 3
      lsprgo(nlprgo) = 'L'
      ctprgo(nlprgo) = 'H'

      nlprgo         = nlprgo + 1
      lsprgo(nlprgo) = 'FP'
      ctprgo(nlprgo) = 'F'

      IF(CSIG.EQ.'Y') THEN
c        LINE='_refln.F_meas_au_sigma'
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'SIGFP'
        ctprgo(nlprgo) = 'Q'
      ENDIF

      IF(ANOM.EQ.'Y') THEN
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'FPM'
        ctprgo(nlprgo) = 'F'
        IF(CSIG.EQ.'Y') THEN
          nlprgo         = nlprgo + 1
          lsprgo(nlprgo) = 'SIGFPM'
          ctprgo(nlprgo) = 'Q'
        ENDIF
      ENDIF

      IF(MT2.GT.0) THEN
c        LINE='_refln.F_calc'
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'FC'
        ctprgo(nlprgo) = 'F'
C        IF(CSIG.EQ.'Y') THEN
c          LINE='_refln.F_sigma'
c          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C          nlprgo         = nlprgo + 1
C          lsprgo(nlprgo) = 'SIGFC'
C          ctprgo(nlprgo) = 'Q'
C        ENDIF
      ENDIF
      IF(MT3.GT.0) THEN
c        LINE='_refln.phase_calc'
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'PH'
        ctprgo(nlprgo) = 'P'
        IF(CFOM.EQ.'Y') THEN
c          LINE='_refln.fom'
c          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          nlprgo         = nlprgo + 1
          lsprgo(nlprgo) = 'FOM'
          ctprgo(nlprgo) = 'W'
        ENDIF
      ENDIF
      IF(CFREE.EQ.'Y') THEN
c        LINE='_refln.status'
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'FreeR_flag'
        ctprgo(nlprgo) = 'I'
      ENDIF
C     H-L:
C     HLA   A
C     HLB   A
C     HLC   A
C     HLD   A
C ----------------------------------------
C Store the column labels in the mtz header:
      call lwclab(IOUT, lsprgo, nlprgo, ctprgo, 0)
C Store the symmetry in the mtz header:
      call lwsymm (IOUT, nsymx, nsympx, rsymx, spgrnx(1:1), nspgrx,
     $     spgrnx, pgnamx)
C Store a history header:
      call lwhstl (IOUT, ' ')
C -----------------------------------------
      RETURN
      END

C -I-
      SUBROUTINE CCP42DNS(MDOC,NAME1,NAMEW,RMAX,RESOL,P1,DSCALE
     *    ,IORIGIN,POOL,POOLW,MEMORY,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P-
C CCP42DNS converts CCP4 density map to BLANC format 
C -S-
C      Dialogue and Batch:
C
C   FILE_1:       - name of input dens-file.
C   FILE_O:       - output_file 
C
C      SUBROUTINE CCP42DNS(MDOC,NAME1,NAMEW
C     *    ,POOL,MEMORY,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAME1  - name of input dens-file.
C      NAMEW  - name of output dens-file.
C      POOL   -  real array POOL(MEMORY).
C      MEMORY -  is memory for one Z-section of electron
C                density NX x NY.
C      IERR   - signal of error / =1 -error , =o - OK / 
C -I-
C ----------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      POOL(MEMORY),POOLW(MEMORY)
      CHARACTER NAME1*(*),NAMEW*(*)
      CHARACTER TTTW*80,TYPE*4,SGNAME*24
      CHARACTER LINE*256
      CHARACTER CODE*4,STR_TITLE*40,STR_DATE*9,SPGR*24,P1*1
C -------------------------------
      INTEGER    IUVW(3),MXYZ(3)
      REAL       CELL(6)
      CHARACTER  MAPTITLE*80
C ----------------------------------------------------------------------
      PI      = 4.0*ATAN(1.0)
      CONV    = 180./PI
      MD      =-ABS(MDOC)-1
      M       = 99
      M0      = 0
      IERR    = 0
      IF(P1.EQ.'y') P1 = 'Y'
      IF(P1.NE.'Y') P1 = 'N'
c      IF(SCALE.LT.0.0000001) SCALE =1.0
C ----------------------
C INITIALIZE CCP4 ROUTINES
C      CALL CCPFYP
C  Open MAPIN and read map header
      IUN = 10
      CALL CORR_NAME_BL(NAME1)
      CALL LENSTR_BL(NAME1,LEN)
      IPRINT = 0
      IFAIL  = 0
C -------------
      call mrdhds(IUN,NAME1(1:LEN),MAPTITLE,NSEC,IUVW
     * ,mxyz,nw1,nu1,nu2,nv1,nv2,cell,lspgrp,lmode
     * ,RHMIN,RHMAX,RHMEAN,RHRMS,IFAIL,IPRINT)
C --------------
c      write(*,*)  'nsec,iuvw:',NSEC,IUVW(1),IUVW(2),IUVW(3)
c      write(*,*)  'nw1,nu1,nu2,nv1,nv2:',nw1,nu1,nu2,nv1,nv2
c      write(*,*)  'mxyz:',MXYZ(1),MXYZ(2),MXYZ(3)        
c      write(*,*)'cell:',CELL(1),CELL(2),CELL(3),CELL(4),CELL(5),CELL(6)
c      write(*,*)  'gr:',lspgrp,lmode
c      write(*,*)  'title:',MAPTITLE
c      write(*,*)   RHMIN,RHMAX,RHMEAN,RHRMS
C ---------------------
c  IUVW (O)   3 word array with fast, medium, slow axes (1=X, 2=Y, 3=Z)
c  MXYZ (O)   3 word array with sampling intervals along whole cell on X, Y,
c             Z
c   NW1 (O)   No. of first section
c   NU1 (O)   Start of section on fast axis (grid units)
c   NU2 (O)   End of section on fast axis
c   NV1 (O)   Start of section on medium axis
c   NV2 (O)   End of section on medium axis
C LMODE (O)   Map data mode =0, byte
C                           =1, INTEGER*2
C                           =2, REAL
C                           =3, COMPLEX INTEGER*2
C                           =4, COMPLEX REAL
C                           =5, Treated as mode 0
C             Only mode 2 and 0 should occur with CCP4 programs
C IFAIL (I/O)  On input:     =0, stop on error
C                             =1, return on error
C              On output:    unchanged if no error
C                             =-1, error
C  IPRINT (I)                 = 0; silent
C                          .ne. 0; print file name, header info etc
C ---------------------
      MTS       = 11
      TYPE      = 'RI  '
      IPRINT    = 1
      ISETT     = 0
      NSETT     = 0
      IF(LMODE.NE.2) THEN
        IERR = 1
        WRITE(LINE,
     *  '('' ERROR: lmode='',I4,''  Only mode 2 should occur'')')
     *             LMODE
        CALL MSGERR(MDOC,LINE)
        GO TO 900
      ENDIF
C     CALL C_CR_WR
C      C1     = CELL(IUVW(1))
C      C2     = CELL(IUVW(2))
C      C3     = CELL(IUVW(3))
C      C4     = CELL(IUVW(1)+3)
C      C5     = CELL(IUVW(2)+3)
C      C6     = CELL(IUVW(3)+3)
      C1     = CELL(1)
      C2     = CELL(2)
      C3     = CELL(3)
      C4     = CELL(4)
      C5     = CELL(5)
      C6     = CELL(6)
      CELL(4)= C4/CONV
      CELL(5)= C5/CONV
      CELL(6)= C6/CONV
      ALW    = CELL(4)
      BEW    = CELL(5)
      GAW    = CELL(6)
C      DX     = C1/ABS(MXYZ(IUVW(1)))
C      DY     = C2/ABS(MXYZ(IUVW(2)))
C      DZ     = C3/ABS(MXYZ(IUVW(3)))
      DX     = C1/MXYZ(1)
      DY     = C2/MXYZ(2)
      DZ     = C3/MXYZ(3)
      IF(IUVW(3).NE.3) THEN
        LINE = ' WARNING: slow axes must be Z (IUVW(3)=3)'
        CALL MSGERR(MDOC,LINE)
        LINE = '          now 1=Xnew, 2=Ynew, 3=Znew'
        CALL MSGERR(MDOC,LINE)
C        IERR = 1
C        GO TO 900   
        INVERT = 0
        NU1W = NU1
        NU2W = NU2
        NV1W = NV1
        NV2W = NV2
      ELSE IF(IUVW(1).EQ.2) THEN
        INVERT = 1
        NU1W = NV1
        NU2W = NV2
        NV1W = NU1
        NV2W = NU2
      ELSE
        INVERT = 0
        NU1W = NU1
        NU2W = NU2
        NV1W = NV1
        NV2W = NV2
      ENDIF      

      NX     = NU2-NU1+1
      NY     = NV2-NV1+1
      NXW    = NU2W-NU1W+1
      NYW    = NV2W-NV1W+1
      IF(NXW.LT.MXYZ(1).OR.NYW.LT. MXYZ(2)) THEN
        IPART = 1
c        IXADD = NXW/4
c        IYADD = NYW/4
        IXADD  = 0
        IYADD  = 0
        NXW    = NXW + IXADD*2
        NYW    = NYW + IYADD*2
      ELSE
        IPART  = 0
        IXADD  = 0
        IYADD  = 0
        NXW    = MXYZ(1)
        NYW    = MXYZ(2)
      ENDIF


C     NZ     = NSEC
C     NZ     = ABS(MXYZ(IUVW(3)))
      NZ     = MXYZ(3)
      NXY    = NX*NY
      IF(NXY.GT.MEMORY) THEN
        WRITE(LINE,'('' ERROR: not memory '',I4,'' x'',I4,'' >'',I8)')
     *             NX,NY,MEMORY
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      IF(lspgrp.GT.1.AND.P1.NE.'Y') THEN

C        CALL MSGERR(MDOC,
C     *'WARNING: only P1 space group can be managed')
C        CALL MSGERR(MDOC,
C     *'         space group will be changed to P1')
C ---
            NOSPGR = lspgrp
            IF(NOSPGR.GT.1000) THEN

              ISETT  = NOSPGR/1000
              NOSPGR = NOSPGR - ISETT*1000
              ISETT  = ISETT + 1
              NOSG   = NOSPGR

              IF(NOSG.EQ.3.OR.NOSG.EQ.4.OR.NOSG.EQ.146.OR.
     *           NOSG.EQ.155) THEN
                IF(ISETT.EQ.1) THEN
                  ISETT = 2
                ELSE IF(ISETT.EQ.2) THEN  
                  ISETT = 1
c                ELSE IF(ISTT.EQ.4) THEN  
c                  ISTT = 3
                ENDIF
              ELSE IF(NOSG.EQ.  5) THEN
                IF(ISETT.EQ.1) THEN
                  ISETT = 2
                ELSE IF(ISETT.EQ.2) THEN  
                  ISETT = 1
c                ELSE IF(ISETT.EQ.3) THEN  
c                  ISETT = 4
c                ELSE IF(ISETT.EQ.4) THEN  
c                  ISETT = 3
                ENDIF
              ENDIF
            ENDIF

            IF(NOSPGR.LT.1.OR.NOSPGR.GT.230) THEN
              CALL MSGERR(MDOC
     *        ,' WARNING: wrong card "CRYST1" of PDB_file')
              CALL MSGERR(MDOC
     *        ,'          default space group: "P 1"')
              NOSPRG = 1
              ISETT  = 1
            ENDIF
            IF(NOSPRG.EQ.146.OR.NOSPRG.EQ.155) THEN
              T= (PI*2.0)/3.0
              IF(ABS(CELL(6)-T).LE.0.0001) ISETT = 2
            ENDIF
            IF(NOSPGR.GE.3.AND.NOSPGR.LE.5) THEN
              IF(ISETT.LE.0) ISETT  = 2
              IF(ISETT.EQ.2) THEN
                T = PI/2.0
                IF(ABS(CELL(6)-T).GT.0.0001) ISETT=1
              ELSE IF(ISETT.EQ.1) THEN
                T = PI/2.0
                IF(ABS(CELL(5)-T).GT.0.0001) ISETT=2
              ENDIF
            ENDIF
            IF(ISETT.LE.0) ISETT  = 1
            SGNAME = ' '
            NSETT  = ISETT
            NSG    = NOSPGR 


          CALL GET_SYMM(MDOC,NSG,NSETT,SGNAME,NSYM,ISYM
     *                                            ,IPRSYM,IERR)

C ---
        SPGR   = SGNAME 
        NSETT  = ISETT
        NGROUP = NSG    

      ELSE
        NSYM    = 1
        DO I=1,5
        DO J=1,3
          ISYM(I,J,1) = 0
        ENDDO
        ENDDO
        ISYM(1,1,1) = 1
        ISYM(2,2,1) = 1
        ISYM(3,3,1) = 1
        ISYM(5,1,1) = 1
        ISYM(5,2,1) = 1
        ISYM(5,3,1) = 1
        NGROUP    = 1
        NSETT     = 1
        SPGR      = 'P 1'
      ENDIF

      IZMIN  = 0
      IZMAX  = NSEC-1
C ---
      CELL(1) = NXW*DX 
      CELL(2) = NYW*DY
      CELL(3) = NZ*DZ
      AW      = CELL(1)
      BW      = CELL(2)
      CW      = CELL(3)
c      IX0     = -NU1
c      IY0     = -NV1
c      IZ0     = -NW1
      IX0     = NU1W
      IY0     = NV1W
      IZ0     = NW1
C ---
      DDM     = 0.0
      CODE      = 'XXXX'
      CALL LENSTR_BL(MAPTITLE,LT) 
      L = LT
      IF(L.GT.40) THEN
        IF(L.GT.40) L = 40
        J = 0
        CALL CHECK_LINE(J,MAPTITLE(1:L))
        STR_TITLE = MAPTITLE(1:L)
        CALL LENSTR_BL(STR_TITLE,L) 
        IF(L.LE.0) THEN
          STR_TITLE = '----------------'
          L = 16
        ENDIF
      ELSE           
        STR_TITLE = '----------------'
        L = 16
      ENDIF
      STR_DATE  = 'XX-XXX-XX'
      DO I=1,80
        TTTW(I:I) = ' '
      ENDDO
c                    9012345678
      TTTW(69:78) = '?    ?    '
      TTTW(1:4)   = 'CCP4'
      TTTW(5:8)   = '    '
      TTTW(9:8+L) = STR_TITLE(1:L)      
C ----
      IF(ABS(DSCALE).LT.0.0001) THEN
        DSCALE = 1.0
      ELSE
        WRITE(LINE,
     *  '('' input Cell:'',3F10.3,3F8.2)') AW,BW,CW,C4,C5,C6
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     *  '('' scale     :'',3F8.3)') DSCALE 
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      AW = AW*DSCALE
      BW = BW*DSCALE
      CW = CW*DSCALE
      CELL(1) = AW
      CELL(2) = BW
      CELL(3) = CW

C     RESOL  = 3.0
      CR     = 3.0
      CR     = 2.5
      RESOL  = (AW*CR)/NXW
      T      = (BW*CR)/NYW
      IF(T.GT.RESOL) RESOL = T
      T      = (CW*CR)/NZ
      IF(T.GT.RESOL.AND.NZ.GT.1) RESOL = T
      RESOL = RESOL + 0.001
      ITR    = 0
      IF(IPART.NE.0) THEN
        IX0     = 0
        IY0     = 0 
        ITR = 1
      ENDIF
C ----
      WRITE(LINE,
     *  '('' Cell      :'',3F8.3,3F8.2)') AW,BW,CW,C4,C5,C6
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Grid      :'',3I5)') NX,NY,NZ
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Origin    :'',3I5)') IX0,IY0,IZ0
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *     '('' Resolution from grid:'',F8.1)') RESOL
      CALL MSGDOC(MDOC,LINE)
C ---
      CALL SET_CELL(CELL,CODE,STR_TITLE,STR_DATE,TTTW
     *      ,NGROUP,NSETT,SPGR,IERR)

      CALL C_CR_WR
      CALL SET_TITLE(M,AW,BW,CW,ALW,BEW,GAW
     *  ,DDM,DDM,DDM,DDM,NXW,NYW,NZ,IZMIN,IZMAX,TTTW,IERR)

      CALL OWFILE(M,MTS,NAMEW,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
      ITR    = 0
      IF(IORIGIN.NE.0) THEN
        IX0 = 0
        IY0 = 0
        IZ0 = 0
      ENDIF
C ----
      ICNTZ3 =-999
      NXY    = NX*NY
      NXYW   = NXW*NYW
      DO IZ=1,NSEC

        DO I=1,NXYW
          POOLW(I) = 0.0
        ENDDO

        CALL MGULP(IUN,POOL,IERR)
c        CALL MGULPr(IUN,POOL,IERR)

        DO IY=NV1,NV2
          INDY = (IY-NV1)*NX
          DO IX=NU1,NU2
           IND = INDY + IX - NU1 + 1
           IF(INVERT.LE.0) THEN  
              POOLW(IND) = POOL(IND)
           ELSE
             JNDY = (IX-NU1+IYADD)*NXW
             JND = JNDY + IY - NV1 + 1 + IXADD
             POOLW(JND) = POOL(IND)
           ENDIF
         ENDDO
        ENDDO 

        CALL WDENS(MTS,M,ICNTZ3,NXW,NYW,NZ,IZMIN,IZMAX,
     *               RMAX,RMIN,POOLW,RESOL,IX0,IY0,IZ0,ITR)
      ENDDO
C ---------------------
      CLOSE(MTS)
 900  CONTINUE
      call mrclos(iun)
C ---------------------
      RETURN
      END
