C-----------------------------------------------------------------------
C
C      SUBROUTINE BYRESPLOT
C
C-----------------------------------------------------------------------
      SUBROUTINE BYRESPLOT(MDOC,IN,IERR)

      INCLUDE 'sfch_graph.inc'
      INCLUDE 'sfch_graph_2.inc'

      INTEGER MDOC,IN,IERR,IEND
      INTEGER JCELL
      INTEGER STATUS
      INTEGER CHAINNB

      REAL*4 YTR
      REAL*4 XL

      INTEGER PAGENB
      INTEGER OLDCHNB

C --- Open and Initialize the HTML file with Local Estimation results
C      CALL HTMLOPEN (FILLOHTML,CODE_NDB,IERR)
C      CALL HTMLCENTER
C      CALL HTMLH3 ('Local Estimation')
C      CALL HTMLECENTER

C --- Define the value of (invariable) parameters
      MAXDENSID = 1.5
      MAXBFACT = 60.0
c      MAXDCORR = 0.5
      MAXDCORR = 0.8

      BMH = 20.0
      XL = 155.0

      XW = 5.0

      YW = 5.0

      XT = XL-110.0
      X2T = XT + 45.0
      YIT = -1.0

      TLEN = 3.0

      IMGID = 1

C      TOTNBRES = 417
C      YL1 = 580.0
C      YL1 = 860.0

C --- Define initial value of variables
      PAGENB = 1

      OLDCHNB = 1
      ISTRT = 1
      XCHSTRT = -1

      XR = XL

      IEND  = -1
      JCELL = 1

      DO I = 1, TOTNBRES+1
         IF (I .NE. TOTNBRES+1) THEN
C ---    Get info for each residue in turn
C ---    don't try to get info after last residue
         CALL ONEROW (IN,STATUS,RESCODE,SHIFT,SHIFTSD,DCORR,DCORRSD
     +     ,CONNECT,DENSID,DENSIDSD,BFACT,BFACTSD,RESNB,INS_CODE
     +     ,CHAINNB,CHAINID,IEND,IERR)
         ENDIF

C ---   Exit in case of reading problem
        IF (STATUS.NE.1) GOTO 1001

c       write(*,*) RESCODE,SHIFT,SHIFTSD,DCORR,DCORRSD,CONNECT,
c     +     DENSID,DENSIDSD,BFACT,BFACTSD

         IF (I .EQ. 1) OLDCHID = CHAINID

         IF (OLDCHNB .NE. CHAINNB) THEN
C ---    A new chain starts
            CALL CHAINBOX (XCHSTRT,XR,YL,OLDCHID)
C            CALL HTML_NC
c            IF (JMOD(JCELL,75).NE.1) JCELL = JCELL + 1
            IF (MOD(JCELL,75).NE.1) JCELL = JCELL + 1
            IF (MOD(JCELL,75).NE.1) THEN
               JCELL = JCELL + 1
               XC = XR + XW
               XR = XC + XW
            ENDIF
            OLDCHNB = CHAINNB
            OLDCHID = CHAINID
            ISTRT = I
            XCHSTRT = XR
         ENDIF

         IF ((MOD(JCELL,75).EQ.1) .OR. (I .EQ. TOTNBRES+1)) THEN
            IF (JCELL .NE. 1) THEN
C ---          we reached the right hand limit - draw right scales
               CALL RIGHTSIDE
C               CALL HTML_RS
            ENDIF
         ENDIF

C ---    The last residue were read in the previous round
C ---     -> nothing else to do
         IF (I .EQ. TOTNBRES+1) GOTO 1001

         IF ((MOD(JCELL,150).EQ.1)) THEN
C ---       A new page must be used
            CALL LESTPAGE (PAGENB)
c            YL1 = 950.0
c            YTR = 960.0
c            YTR = -320.0
            YTR = -(LOBOXY2-LOBOXY1)
         ENDIF

         IF (MOD(JCELL,75).EQ.1) THEN
            XR = XL
            XCHSTRT = XL
c            YL1 = YL1 - 315.0
C            YTR = YTR - 640.0
            YTR = -YTR
            CALL PSTRANSLATE (0.0, YTR)
            YL1 = 320.0
            YH1 = YL1 + BMH
            YL2 = YL1 - 22.0
            YH2 = YL2 + BMH
            YL3 = YL2 - 30.0
            YH3 = YL3 + BMH
            YL4 = YL3 - 22.0
            YH4 = YL4 + BMH
            YL5 = YL4 - 30.0
            YH5 = YL5 + BMH
            YL6 = YL5 - 22.0
            YH6 = YL6 + BMH
            YL7 = YL6 - 30.0
            YH7 = YL7 + BMH
            YL8 = YL7 - 22.0
            YH8 = YL8 + BMH
            YL9 = YL8 - 30.0
            YH9 = YL9 + BMH
            YL = YL9 - 10.0
            YF1 = (YH1-YL1)/3.0
            YF2 = (YH2-YL2)/3.0
            YF3 = (YH3-YL3)/(1.0-MAXDCORR)
            YF4 = (YH4-YL4)/(1.0-MAXDCORR)
            YF5 = (YH5-YL5)/MAXDENSID
            YF6 = (YH6-YL6)/MAXDENSID
            YF7 = (YH7-YL7)/MAXBFACT
            YF8 = (YH8-YL8)/MAXBFACT
            YF9 = (YH9-YL9)/1.0

C ---       Boxes layout and left scales
            CALL LEFTSIDE
C            CALL HTML_LS
         ENDIF

         XC = XR
         XR = XC + XW

C ---    Draw the bars describing the different measure associated to
C ---    the current residue         
         CALL RESIDUEBARS
C         CALL HTML_RB

         JCELL = JCELL + 1
         
      ENDDO


 1001 CONTINUE

C      CALL HTMLCLOSE

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE LESTPAGE
C
C-----------------------------------------------------------------------
C     Local Estimation Summary Page
C-----------------------------------------------------------------------

      SUBROUTINE LESTPAGE (PAGENB)

      INCLUDE 'sfch_graph.inc'

      INTEGER PAGENB, NBDIG

C      REAL*4 YL,XL
      CHARACTER TEXT*10, TEXT1*10, FORMT*20
c       CHARACTER TEXT*10, FORMT*20

      CALL NEWPAGEPS

      IF (PAGENB .NE. 1) THEN
         NBDIG = LOG10(REAL(PAGENB))+1
         WRITE (FORMT, '(A,I5,A)') '(I',NBDIG,')'
         WRITE (TEXT,FORMT) PAGENB
         IF (NOMIT .EQ. 0) THEN
            CALL PSCTXT (292.0,708.0, 20.0, 'Local estimation ('//
     +           TEXT(1:NBDIG)//')')
         ELSE
            WRITE (TEXT1, '(I2)') NOMIT
            CALL PSCTXT (292.0,708.0, 20.0, 'Local estimation ('//
     +           TEXT(1:NBDIG)//') [N_omit ='//TEXT1(1:2)//']')
         ENDIF
      ELSE
         IF (NOMIT .EQ. 0) THEN
            CALL PSCTXT (292.0,708.0, 20.0, 'Local estimation')
         ELSE
            WRITE (TEXT1, '(I2)') NOMIT
            CALL PSCTXT (292.0,708.0, 20.0, 
     +           'Local estimation [N_omit ='//TEXT1(1:2)//']')
         ENDIF
      ENDIF
      PAGENB = PAGENB + 1

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE CHAINBOX
C
C-----------------------------------------------------------------------
      SUBROUTINE CHAINBOX (XCHSTRT,XR,YL,CHAINID)

      IMPLICIT NONE

      REAL*4 XCHSTRT, XR, YL
      CHARACTER CHAINID

      CALL PSLINE (XCHSTRT,YL-25.0,XR,YL-25.0)
      CALL PSLINE (XR,YL-25.0,XR,YL+3.0)
      CALL PSLINE (XR,YL+3.0,XCHSTRT,YL+3.0)
      CALL PSLINE (XCHSTRT,YL+3.0,XCHSTRT,YL-25.0)

      CALL PSTEXT (XCHSTRT,YL-22.0,7.0,CHAINID)

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE LSCALE
C
C-----------------------------------------------------------------------
      SUBROUTINE LSCALE (X,Y,H,T,NT,LOWY,HIGHY,LABEL)

      IMPLICIT NONE

      REAL*4 X,Y,H,T,S,YTEMP,LOWY,HIGHY
      INTEGER NT, I, LOCNT
      CHARACTER TEXT*10,FORM*10
      LOGICAL LABEL

      LOCNT = IABS(NT)
      S = H / LOCNT

      IF (HIGHY.GT.10.0) THEN
         FORM = '(F4.0)'
      ELSE IF (HIGHY .GT. 1.0) THEN
         FORM = '(F4.1)'
      ELSE
         FORM = '(F4.2)'
      ENDIF

      CALL PSLINE (X,Y,X,Y+H)
      CALL PSLINE (X,Y,X-T,Y)
      YTEMP = Y
      DO I=1,LOCNT
         YTEMP = YTEMP + S
         CALL PSLINE (X,YTEMP,X-T,YTEMP)
         IF (LABEL) THEN
            WRITE (TEXT,FORM) LOWY+(HIGHY-LOWY)*REAL(I)/LOCNT
            CALL PSCTXT (X-10.0,YTEMP,7.0,TEXT(1:4))
         ENDIF
      ENDDO

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE PSNAMARK
C
C-----------------------------------------------------------------------
      SUBROUTINE PSNAMARK (X1,Y1,X2,Y2,X3,Y3)

      IMPLICIT NONE

      REAL X1,Y1,X2,Y2,X3,Y3

      CALL PSLINE (X1,Y1,X2,Y2)
      CALL PSLINE (X2,Y2,X3,Y3)
      CALL PSLINE (X1,Y1,X3,Y3)

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE LEFTSIDE
C
C-----------------------------------------------------------------------
      SUBROUTINE LEFTSIDE

      INCLUDE 'sfch_graph.inc'
      INCLUDE 'sfch_graph_2.inc'

C ---       Boxes layout
            CALL PSLWID (1.0)
C            CALL PSLINE (REAL(BBOXX1),YL1+30,REAL(BBOXX2),YL1+30)
            CALL PSLINE (REAL(BBOXX1),YL1+50,REAL(BBOXX2),YL1+50)
            CALL PSLWID (0.0)
C     -- "1. Shift" box
            CALL PSHBOX (XT-5.0,XR+75*XW+10.0,YH1+3.0,YL2-3.0,0.95)
            CALL PSBTEXT (XT,YL1+YIT,9.0,'1. Shift')
            CALL PSTEXT (X2T,YL1+BMH/2,6.0,'Backbone')
            CALL PSTEXT (X2T,YL1-2.0-BMH/2,6.0,'Side chain or base')
            WRITE (TEXT,'(F7.4)') DISPSIG
            CALL PSSYMB (XT,YL2,5.0,'s')
c            CALL PSTEXT (XT+3.0,YL2-1.0,4.0,'displacement')
c            CALL PSTEXT (XT+20.0,YL2,5.0,'='//TEXT(1:7)//ARING)
            CALL PSTEXT (XT+5.0,YL2,5.0,'='//TEXT(1:7)//ARING)
            CALL PSNAMARK (XT,YH1,XT+XW/2.0,YH1-YW,XT+XW,YH1)
            CALL PSTEXT (XT+XW,YH1-YW+2.0,6.0,' N.A. (GLY)')
C     -- "2. Density correlation" box
            CALL PSHBOX (XT-5.0,XR+75*XW+10.0,YH3+3.0,YL4-3.0,0.95)
            CALL PSBTEXT (XT,YL3+YIT,9.0,'2. Density correlation')
            CALL PSTEXT (X2T,YL3+BMH/2,6.0,'Backbone')
            CALL PSTEXT (X2T,YL3-2.0-BMH/2,6.0,'Side chain or base')
            CALL PSHBOX (XT,XT+XW,YH3-YW,YH3,0.50)
            WRITE (TEXT,'(F3.1)') MAXDCORR
            CALL PSTEXT (XT+XW,YH3-YW+2.0,6.0,' < '//TEXT(1:3))
C     -- "3. Density index" box
            CALL PSHBOX (XT-5.0,XR+75*XW+10.0,YH5+3.0,YL6-3.0,0.95)
            CALL PSBTEXT (XT,YL5+YIT,9.0,'3. Density index')
            CALL PSTEXT (X2T,YL5+BMH/2,6.0,'Backbone')
            CALL PSTEXT (X2T,YL5-2.0-BMH/2,6.0,'Side chain or base')
            WRITE (TEXT,'(F7.4)') AVERDENS
            CALL PSTEXT (XT,YL6,5.0,'<Dens> ='//TEXT(1:7)//',')
            CALL PSSYMB (XT+40.0,YL6,5.0,'s')
            WRITE (TEXT,'(F7.4)') SIGMADENS
            CALL PSTEXT (XT+45.0,YL6,5.0,'= '//TEXT(1:7)) 
            CALL PSHBOX (XT,XT+XW,YH5-YW,YH5,0.25)
            WRITE (TEXT,'(F3.1)') MAXDENSID*2
            CALL PSTEXT (XT+XW,YH5-YW+2.0,6.0,' > '//TEXT(1:3))
            CALL PSHBOX (XT+25.0,XT+25.0+XW,YH5-YW,YH5,0.50)
            WRITE (TEXT,'(F3.1)') MAXDENSID
            CALL PSTEXT (XT+25.0+XW,YH5-YW+2.0,6.0,' > '//TEXT(1:3))
C     -- "4. B-factor" box
            CALL PSHBOX (XT-5.0,XR+75*XW+10.0,YH7+3.0,YL8-3.0,0.95)
            CALL PSBTEXT (XT,YL7+YIT,9.0,'4. B-factor')
            CALL PSTEXT (X2T,YL7+BMH/2,6.0,'Backbone')
            CALL PSTEXT (X2T,YL7-2.0-BMH/2,6.0,'Side chain or base')
            CALL PSHBOX (XT,XT+XW,YH7-YW,YH7,0.25)
            WRITE (TEXT,'(F3.0)') MAXBFACT
            CALL PSTEXT (XT+XW,YH7-YW+2.0,6.0,' > '//TEXT(1:3))
C     -- "5. Connect" box
            CALL PSHBOX (XT-5.0,XR+75*XW+10.0,YH9+3.0,YL9-3.0,0.95)
            CALL PSBTEXT (XT,YL9+BMH/2,9.0,'5. Connect')
C     -- Draw left scales
            CALL PSTEXT (XR-50.0,YL-7.0,6.0,'residue number')
            CALL PSTEXT (XR-50.0,YL-22.0,6.0,'chain identifier')
C     --
            CALL PSLWID (0.1)
            CALL LSCALE (XR,YL1,BMH,TLEN,3,0.0,3.0,.TRUE.)
            CALL LSCALE (XR,YH2,-BMH,TLEN,3,0.0,3.0,.TRUE.)
            CALL LSCALE (XR,YL3,BMH,TLEN,2,1.0,MAXDCORR,.TRUE.)
            CALL LSCALE (XR,YH4,-BMH,TLEN,2,1.0,MAXDCORR,.TRUE.)
            CALL LSCALE (XR,YL5,BMH,TLEN,3,0.0,MAXDENSID,.TRUE.)
            CALL LSCALE (XR,YH6,-BMH,TLEN,3,0.0,MAXDENSID,.TRUE.)
            CALL LSCALE (XR,YL7,BMH,TLEN,2,0.0,MAXBFACT,.TRUE.)
            CALL LSCALE (XR,YH8,-BMH,TLEN,2,0.0,MAXBFACT,.TRUE.)
            CALL LSCALE (XR,YL9,BMH,TLEN,2,0.0,1.0,.TRUE.)

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE RIGHTSIDE
C
C-----------------------------------------------------------------------
      SUBROUTINE RIGHTSIDE

      INCLUDE 'sfch_graph.inc'
      INCLUDE 'sfch_graph_2.inc'

               CALL LSCALE (XR,YL1,BMH,-TLEN,3,0.0,3.0,.FALSE.)
               CALL LSCALE (XR,YH2,-BMH,-TLEN,3,0.0,3.0,.FALSE.)
               CALL LSCALE (XR,YL3,BMH,-TLEN,2,1.0,MAXDCORR,.FALSE.)
               CALL LSCALE (XR,YH4,-BMH,-TLEN,2,1.0,MAXDCORR,.FALSE.)
               CALL LSCALE (XR,YL5,BMH,-TLEN,3,0.0,MAXDENSID,.FALSE.)
               CALL LSCALE (XR,YH6,-BMH,-TLEN,3,0.0,MAXDENSID,.FALSE.)
               CALL LSCALE (XR,YL7,BMH,-TLEN,2,0.0,MAXBFACT,.FALSE.)
               CALL LSCALE (XR,YH8,-BMH,-TLEN,2,0.0,MAXBFACT,.FALSE.)
               CALL LSCALE (XR,YL9,BMH,-TLEN,2,0.0,1.0,.FALSE.)
               IF ((XCHSTRT .GT. 0).AND.(XCHSTRT.NE.XR)) THEN
                  CALL CHAINBOX (XCHSTRT,XR,YL,CHAINID)
               ENDIF
      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE RESIDUEBARS
C
C-----------------------------------------------------------------------
      SUBROUTINE RESIDUEBARS

      INCLUDE 'sfch_graph.inc'
      INCLUDE 'sfch_graph_2.inc'

      IF (SHIFT.GT.VNULL) THEN
         CALL PSHBOX(XC,XR,YL1,YL1+SHIFT*YF1,0.75)
      ENDIF
      IF (DCORR.GT.VNULL) THEN
         IF (DCORR.LT.MAXDCORR) THEN
            CALL PSHBOX(XC,XR,YL3,YL3+(1.0-MAXDCORR)*YF3,0.50)
         ELSE
            CALL PSHBOX(XC,XR,YL3,YL3+(1.0-DCORR)*YF3,0.75)
         ENDIF
      ENDIF
      IF (DENSID.GT.VNULL) THEN
         IF (DENSID.GT.MAXDENSID) THEN
            IF (DENSID.GT.2*MAXDENSID) THEN
               CALL PSHBOX(XC,XR,YL5,YL5+MAXDENSID*YF5,0.25)
            ELSE
               CALL PSHBOX(XC,XR,YL5,YL5+MAXDENSID*YF5,0.50)
            ENDIF
         ELSE
            CALL PSHBOX(XC,XR,YL5,YL5+DENSID*YF5,0.75)
         ENDIF
      ENDIF
      IF (BFACT.GT.VNULL) THEN
         IF (BFACT.GT.MAXBFACT) THEN
            CALL PSHBOX(XC,XR,YL7,YL7+MAXBFACT*YF7,0.25)
         ELSE
            CALL PSHBOX(XC,XR,YL7,YL7+BFACT*YF7,0.75)
         ENDIF
      ENDIF
      IF (CONNECT.GT.VNULL) THEN
C     Ceil CONNECT to 1.0
         IF (CONNECT .LE. 1.0 ) THEN
            CALL PSHBOX(XC,XR,YL9,YL9+CONNECT*YF9,0.75)
         ELSE
            CALL PSHBOX(XC,XR,YL9,YL9+YF9,0.75)
         ENDIF
      ENDIF
C     -- Side chain info
      IF (RESCODE .NE. 'G') THEN
         IF (SHIFTSD.GT.VNULL) THEN
            CALL PSHBOX(XC,XR,YH2,YH2-SHIFTSD*YF2,0.75)
         ENDIF
         IF (DCORRSD.GT.VNULL) THEN
            IF (DCORRSD.LT.MAXDCORR) THEN
               CALL PSHBOX(XC,XR,YH4,YH4-(1.0-MAXDCORR)*YF4,0.50)
            ELSE
               CALL PSHBOX(XC,XR,YH4,YH4-(1.0-DCORRSD)*YF4,0.75)
            ENDIF
         ENDIF
         IF (DENSIDSD.GT.VNULL) THEN
            IF (DENSIDSD.GT.MAXDENSID) THEN
               IF (DENSID.GT.2*MAXDENSID) THEN
                  CALL PSHBOX(XC,XR,YH6,YH6-MAXDENSID*YF6,0.25)
               ELSE
                  CALL PSHBOX(XC,XR,YH6,YH6-MAXDENSID*YF6,0.50)
               ENDIF
            ELSE
               CALL PSHBOX(XC,XR,YH6,YH6-DENSIDSD*YF6,0.75)
            ENDIF
         ENDIF
         IF (BFACTSD.GT.VNULL) THEN
            IF (BFACTSD.GT.MAXBFACT) THEN
               CALL PSHBOX(XC,XR,YH8,YH8-MAXBFACT*YF8,0.25)
            ELSE
               CALL PSHBOX(XC,XR,YH8,YH8-BFACTSD*YF8,0.75)
            ENDIF
         ENDIF
      ELSE
         CALL PSNAMARK(XC,YH2,(XC+XR)/2,YH2-YW,XR,YH2)
         CALL PSNAMARK(XC,YH4,(XC+XR)/2,YH4-YW,XR,YH4)
         CALL PSNAMARK(XC,YH6,(XC+XR)/2,YH6-YW,XR,YH6)
         CALL PSNAMARK(XC,YH8,(XC+XR)/2,YH8-YW,XR,YH8)
      ENDIF
C     --
         CALL PSCTXT((XC+XR)/2,YL,5.0,RESCODE)
         IF (MOD(I-ISTRT,10).EQ.0) THEN
            IF (INS_CODE.EQ.'.') THEN
               WRITE (CRESNB,'(I4)')RESNB
               CALL PSRCTX((XC+XR)/2,YL-10.0,7.0,CRESNB(1:4))
            ELSE
               WRITE (CRESNB,'(I4,A1)')RESNB,INS_CODE
               CALL PSRCTX((XC+XR)/2,YL-10.0,7.0,CRESNB(1:5))
            ENDIF
         ENDIF

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE HTML_LS
C
C-----------------------------------------------------------------------
      SUBROUTINE HTML_LS

      INCLUDE 'sfch_graph.inc'
      INCLUDE 'sfch_graph_2.inc'
      INCLUDE 'sfch_html.inc'

      INTEGER IERR
      INTEGER*4 TS, TE, US, UE
      CHARACTER*4 STRING

      IF (.NOT.HTMLF) RETURN

      CALL TRIM (CODE_NDB,TS,TE)
      WRITE (STRING,'(I4)') IMGID
      CALL TRIM (STRING,US,UE)
      IMGID = IMGID + 1

      CALL PSFUNIT (54)
      CALL HTMLURL(CODE_NDB(TS:TE)//'_lo'//STRING(US:UE)//'.jpg',
     +     'Picture '//STRING(US:UE))
      CALL HTMLTEXT ('<BR>')
      CALL PSOPEN (CODE_NDB(TS:TE)//'_lo'//STRING(US:UE)//'.ps',
     +     LOBOXX1,LOBOXX2,LOBOXY1,LOBOXY2,MXCOLR,RGB,.FALSE.,1,IERR)
      CALL LEFTSIDE
      CALL PSFUNIT (51)

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE HTML_RS
C
C-----------------------------------------------------------------------
      SUBROUTINE HTML_RS

      IMPLICIT NONE
      INCLUDE 'sfch_graph_2.inc'
      INCLUDE 'sfch_html.inc'

      IF (.NOT.HTMLF) RETURN

      CALL PSFUNIT (54)
      CALL RIGHTSIDE
      CALL PSCLOS(LOBOXX1,LOBOXX2,LOBOXY1,LOBOXY2)
      CALL PSFUNIT (51)

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE HTML_RB
C
C-----------------------------------------------------------------------
      SUBROUTINE HTML_RB

      IMPLICIT NONE

      INCLUDE 'sfch_html.inc'

      IF (.NOT.HTMLF) RETURN

      CALL PSFUNIT (54)
      CALL RESIDUEBARS
      CALL PSFUNIT (51)

      END

C-----------------------------------------------------------------------
C
C      SUBROUTINE HTML_NC
C
C-----------------------------------------------------------------------
      SUBROUTINE HTML_NC

      IMPLICIT NONE
      INCLUDE 'sfch_graph_2.inc'
      INCLUDE 'sfch_html.inc'

      IF (.NOT.HTMLF) RETURN

      CALL PSFUNIT (54)
      CALL CHAINBOX (XCHSTRT,XR,YL,OLDCHID)
      CALL PSFUNIT (51)

      END
