C -------------------------
C  subr.f
C -------------------------
      SUBROUTINE FIRSTSTEP(MDOC,IN,TOTNBRES,NBOFCHAIN,DISPSIG
     *                ,AVERDENS,SIGMADENS,IERR,CODE_NDB,SFCH_FNAME)
C --------------------------------------------------------------
      INTEGER   IN,MDOC,IERR
      INTEGER   TOTNBRES,NBOFCHAIN
      REAL      DISPSIG,AVERDENS,SIGMADENS
      CHARACTER FNAME*256,EXT*3,SFCH_FNAME*(*)
      INTEGER*4 TS, TE, LEN
      CHARACTER CODE_NDB*8
C --------------------------------------------------------------
      IERR  = 0
      EXT   = ' '
c     FNAME = 'sfcheck.dst'
      CALL TRIM (CODE_NDB,TS,TE)

      CALL LENSTR_BL(SFCH_FNAME,LEN)

C      FNAME  = 'sfcheck_' // CODE_NDB(TS:TE) // '.dst'

C      FNAME  = SFCH_FNAME(1:LEN)//'_'// CODE_NDB(TS:TE)//'.dst'
      FNAME = SFCH_FNAME(1:LEN)//'.dst'  
      CALL OPEN_CIF(MDOC,IN,FNAME,EXT,IERR)
      IF(IERR.NE.0) RETURN

      CALL RD_TITLE_CIF(MDOC,IN,
     *      TOTNBRES,NBOFCHAIN,DISPSIG,AVERDENS,SIGMADENS,IERR)
      IF(IERR.EQ.2) GO TO 9200
      IF(IERR.EQ.3) GO TO 9000
      IF(IERR.GT.0) THEN
        IERR=4
        CLOSE(IN)
      ENDIF
      RETURN

9000  CONTINUE
      CALL MSGERR(MDOC,' ERR: READ CIFile')
      CLOSE(IN)
      IERR=3
      RETURN
9200  CONTINUE
      CALL MSGERR(MDOC,' ERR: END OF CIFile')
      IERR=2
      RETURN
      END

      SUBROUTINE OPEN_CIF(MDOC,IN,FNAME,EXT,IERR)
C
C -P- OPEN_CIF - OPEN CIFile
C
C
      INTEGER   IN,MDOC,IERR,M
      CHARACTER FNAME*(*),EXT*(*)
C ******
C ----------
      CHARACTER PATH*1,LINE*80
C -------------------------------------------------------------
      IERR = 0
      PATH = ' '
      M    = 99
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      CALL LENSTR_BL(EXT,LENE)
      IF(LENE.GT.8) LENE=8
C      WRITE(LINE,10) FNAME(1:LEN),EXT(1:LENE)
C 10   FORMAT('input file :',A,':',A)
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('input file :',A)

      CALL OPENFR(IN,M,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN CIFile')
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      CALL MSGDOC(M,LINE)

      RETURN
      END

      SUBROUTINE RD_TITLE_CIF(MDOC,IN,
     *      TOTNBRES,NBOFCHAIN,DISPSIG,AVERDENS,SIGMADENS,IERR)
C
C -P- RD_TITLE_CIF - reads CIFile
C ----------------------------------------------------------------------------
      INTEGER   MDOC,IN,IERR,IEND
      INTEGER   TOTNBRES,NBOFCHAIN
      REAL      DISPSIG,AVERDENS,SIGMADENS
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
C -------------------------------------------------
C --------------------------------------------------------------
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C ---
      CHARACTER LINE*80
C -------------------------------------------------------------------
      IERR=0
C -------------------------------------------------------------------
C --
      IEND = -1
C -------
  300 CONTINUE   
      CALL GETCIF_CRD(IN,MDOC,IERR,IEND)

      IF(IEND.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        GO TO 300
      ELSE IF(IEND.NE.0) THEN
        IERR=2
        RETURN
      ENDIF
      IF(N_CIF.LE.0) GO TO 300

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF(ITEM(1:10).EQ.'_displ_sig') THEN
          DISPSIG=FDATA
        ELSE IF(ITEM(1:10).EQ.'_aver_dens') THEN
          AVERDENS=FDATA
        ELSE IF(ITEM(1:11).EQ.'_sigma_dens') THEN
          SIGMADENS=FDATA
        ELSE IF(ITEM(1:11).EQ.'_tot_nb_res') THEN
          TOTNBRES=IDATA
        ELSE IF(ITEM(1:12).EQ.'_nb_of_chain') THEN
          NBOFCHAIN=IDATA
        ELSE IF(ITEM(1:11).EQ.'_res_number') THEN
          GO TO 400
        ENDIF

      ENDDO

      GO TO 300

 400  CONTINUE

      RETURN
      END


      SUBROUTINE LASTSTEP(IN,IERR)
C ------------------------------------------------------------
      INTEGER   IN,IERR
C -------------------------------------------------------------
c     END FILE IN
      CLOSE(IN)
      RETURN
      END

      SUBROUTINE ONEROW(IN,STATUS,RESCODE,SHIFT,SHIFTSD,DCORR,DCORRSD
     +     ,CONNECT,DENSID,DENSIDSD,BFACT,BFACTSD,RESNB,INS_CODE
     +     ,CHAINNB,CHAINID,IEND,IERR)
C --------------------------
      INTEGER IN,IERR,IEND,MDOC
      INTEGER STATUS,IFLAG
      INTEGER RESNB, CHAINNB
      CHARACTER CHAINID
      REAL*4 SHIFT,SHIFTSD,DCORR,DCORRSD,CONNECT,DENSID,DENSIDSD
      REAL*4 BFACT,BFACTSD
      CHARACTER RESCODE, INS_CODE
      REAL*4 MAXDENSID,MAXBFACT,MAXDCORR
C --------------------------
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ------------------------------------------------------------
      COMMON/COM_CRD_CIF/ IEND_CIF      
C --
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C --
      CHARACTER LINE*80
C --------------------------------------------------------------
      MDOC=0
      IERR =0
      IF(IEND.EQ.-1) THEN
        REWIND IN
        IEND_CIF = -1
        IEND=0
      ENDIF

  300 CONTINUE   
      CALL GETCIF_CRD(IN,MDOC,IERR,IEND_CIF)
      IF(IERR.NE.0) THEN
        GO TO 1200
      ENDIF

      IF(IEND_CIF.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        GO TO 300
      ELSE IF(IEND_CIF.NE.0) THEN

        GO TO 1300

      ENDIF

      IF(N_CIF.LE.0) GO TO 300
      IFLAG=0

      DO I=1,N_CIF

        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF(ITEM(1:10).EQ.'_res_code1') THEN
          RESCODE=DATA    
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:11).EQ.'_shift_side') THEN
          SHIFTSD=FDATA
C          IF(SHIFTSD.LT.0.0) SHIFTSD=0.0
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:6).EQ.'_shift') THEN
          SHIFT=FDATA
C          IF(SHIFT.LT.0.0) SHIFT=0.0
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:11).EQ.'_dcorr_side') THEN
          DCORRSD=FDATA
C          IF(DCORRSD.LT.0.0) DCORRSD=0.0
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:6).EQ.'_dcorr') THEN
          DCORR=FDATA
C          IF(DCORR.LT.0.0) DCORR=0.0
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:8).EQ.'_connect') THEN
          CONNECT=FDATA
C          IF(CONNECT.LT.0.0) CONNECT=0.0
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:20).EQ.'_dens_index_backbone') THEN
          DENSID=FDATA
C          IF(DENSID.LT.0.0) DENSID=0.0
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:16).EQ.'_dens_index_side') THEN
          DENSIDSD=FDATA
C          IF(DENSIDSD.LT.0.0) DENSIDSD=0.0
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:18).EQ.'_B_factor_backbone') THEN
          BFACT=FDATA
C          IF(BFACT.LT.0.0) BFACT=0.0
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:14).EQ.'_B_factor_side') THEN
          BFACTSD=FDATA
C          IF(BFACTSD.LT.0.0) BFACTSD=0.0
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:11).EQ.'_res_number') THEN
          RESNB=IDATA
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:15).EQ.'_insertion_code') THEN
          INS_CODE=DATA         
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:13).EQ.'_chain_number') THEN
          CHAINNB=IDATA
          IFLAG=IFLAG+1
        ELSE IF(ITEM(1:13).EQ.'_chain_PDB_id') THEN
          CHAINID=DATA
          IFLAG=IFLAG+1
        ENDIF

      ENDDO

      IF(IFLAG.LE.0) GO TO 300
C ---
      STATUS=1
      RETURN
C ---
1200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ CIFile')
      STATUS=0
      CLOSE(IN)
      IERR=1
      RETURN
C ---
1300  CONTINUE 
      STATUS=0
      CLOSE(IN)
      IEND=1
      RETURN
      END
C =================================================================
C =========================
