C**************************************************************************
C
C  PS.F    - PostScript subroutines
C
C            Written by Roman Laskowski, University College, London,
C            November 1993.
C
C            Original version was part of v.3.0 of the PROCHECK suite
C            of programs. (Previously the routines were incorporated in
C            pplot.f).
C
C            Subsequent amendments will be labelled by CHECK v.m.n-->
C            and CHECK v.m.n<-- where m.n is the version number
C            corresponding to the change
C
C  v.3.0.1 - Change of plot-file names. All plot-file names now have the
C            form: <filename>_nn.ps  where <filename> is the name of the
C            input data file, and nn is a sequential number 01, 02, ...
C                                             Roman Laskowski (29 Mar 1994)
C
C  v.4.0   - Modification for allowing the call from SFCHECK, and various
C            improvements:
C            Use of latin1_encoding, hijacked from a PostScript file
C            generated by genscript by Markku Rossi <mtr@iki.fi>
C            <http://iki.fi/~mtr/>.
C            Creation of multipage PostScript files.
C            Right justified text; use of the Courier and Symbol fonts.
C                                             Jean Richelle (Oct 1996)
C                                             Alexei Vagin (Dec 1996)
C  v.4.0.1 - Add new routines, DrawSect, ArrowHead, OrthoBox.
C            Other small changes
c                                             Jean Richelle (20 Mar 1997)
C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSSETPG  -  Set page specifications
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSSETPG(TOTALNBPAGES)

      INCLUDE 'sfcheck_ps.inc'

      INTEGER TOTALNBPAGES

      TOTPAG = TOTALNBPAGES
      CURPAG = 1

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSOPEN  -  Open PostScript file and write out header records
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSOPEN(FNAME,BBOXX1,BBOXX2,BBOXY1,BBOXY2,MXCOLR,RGB,
     -    INCOL,BAKCOL,IERR)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER      FNAME*(*)
      CHARACTER      COLNO*2
      INTEGER        BAKCOL, BBOXX1, BBOXX2, BBOXY1, BBOXY2, I, ICOL,
     -               MXCOLR
      LOGICAL        INCOL
      REAL           RGB(3,MXCOLR)
      CHARACTER      PATH*1,EXT*1
C---- Open output file
      PATH = ' '
      EXT  = ' '
      M    = 99
      IERR = 0

      CALL OPENFW(UNPS,M,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) GO TO 900

C      OPEN(UNIT=UNPS, FILE=FNAME, STATUS='UNKNOWN',
C     -     FORM='FORMATTED', ACCESS='SEQUENTIAL',
C     -     ERR=900)
CCVAX     -     CARRIAGECONTROL = 'LIST',


C---- Write out headings to PostScript file
      WRITE(UNPS,10) TOTPAG
 10   FORMAT(
     -    '%!PS-Adobe-3.0',/,
     -    '%%Creator: SfCheck',/,
     -'%%DocumentNeededResources: font Times-Roman Symbol Times-Bold',
     -    ' Courier',/,
     -    '%%BoundingBox: (atend)',/,
     -    '%%Pages:',I5,/,
     -    '%%EndComments',/,
     -    '%%BeginProlog')

      CALL PSRESOURCE (UNPS)

      WRITE(UNPS,20)
 20   FORMAT(
     -    '/L { moveto lineto stroke } bind def',/,
     -    '/Col { setrgbcolor } bind def')

C---- Loop to define the colours
      IF (INCOL) THEN
          DO 100, ICOL = 1, MXCOLR
              WRITE(COLNO,40) ICOL
 40           FORMAT(I2)
              IF (COLNO(1:1).EQ.' ') COLNO(1:1) = '0'
              WRITE(UNPS,60) COLNO, (RGB(I,ICOL), I = 1, 3)
 60           FORMAT('/Col',A2,' {gsave ',3F8.4,' setrgbcolor } def')
 100      CONTINUE
      ENDIF

      WRITE(UNPS,120)
 120  FORMAT(
c     -    '/Poly3 { moveto lineto lineto fill grestore } bind ',
     -    '/Poly3 { moveto lineto lineto fill } bind ',
     -    'def',/,
c     -    '/Pl3 { 6 copy Poly3 moveto moveto moveto closepath ',
c     -    'stroke } bind def',/,
     -    '/Pl3 { gsave newpath 6 copy Poly3 moveto moveto moveto ',
     -    'closepath stroke grestore } bind def',/,
c     -    '/Pline3 { 6 copy Poly3 moveto lineto lineto closepa',
c     -    'th stroke } bind def')
     -    '/Pline3 { gsave newpath 6 copy Poly3 moveto lineto lineto ',
     -    'closepath stroke grestore } bind def')
      WRITE(UNPS,250)
 250  FORMAT(
     -    '/Poly4 { moveto lineto lineto lineto fill grestore } bind ',
     -    'def',/,
     -    '/Pl4 { 8 copy Poly4 moveto moveto moveto moveto closepath ',
     -    'stroke } bind def',/,
     -    '/Pline4 { 8 copy Poly4 moveto lineto lineto lineto closepa',
     -    'th stroke } bind def',/,
     -    '/Circle { gsave newpath 0.0 setgray 3 copy 0 360 arc fill ',
     -    'stroke grestore }',/
     -    'bind def',/,
     -    '/Circleu { gsave newpath 3 copy 0 360 arc ',
     -    'stroke grestore }',/
     -    'bind def')
      WRITE(UNPS,302)
 302  FORMAT(
     -     '/DrawSect',/,
     -     '  { /grayshade exch def',/,
     -     '    /endangle exch def',/,
     -     '    /startangle exch def',/,
     -     '    /radhigh exch def',/,
     -     '    /radlow exch def',/,
     -     '    /cy exch def',/,
     -     '    /cx exch def',/,
     -     '    newpath cx cy radlow startangle endangle arc',/,
     -     '    cx cy radhigh endangle startangle arcn closepath',/,
     -     '    1.415 setmiterlimit',/,
     -     '    gsave grayshade setgray fill grestore',/,
     -     '    stroke',/,
     -     '  } def')
      WRITE(UNPS,312)
 312  FORMAT(
     -     '/DrawUSect',/,
     -     '  { /grayshade exch def',/,
     -     '    /endangle exch def',/,
     -     '    /startangle exch def',/,
     -     '    /radhigh exch def',/,
     -     '    /radlow exch def',/,
     -     '    /cy exch def',/,
     -     '    /cx exch def',/,
     -     '    newpath cx cy radlow startangle endangle arc',/,
     -     '    cx cy radhigh endangle startangle arcn closepath',/,
     -     '    1.415 setmiterlimit',/,
     -     '    gsave grayshade setgray fill grestore',/,
     -     '  } def')
      WRITE(UNPS,303)
 303  FORMAT(
     -     '/DrawBadSect',/,
     -     '  { /endangle exch def',/,
     -     '    /startangle exch def',/,
     -     '    /radhigh exch def',/,
     -     '    /radlow exch def',/,
     -     '    /cy exch def',/,
     -     '    /cx exch def',/,
     -     '    newpath cx cy radlow startangle endangle arc',/,
     -     '    cx cy radhigh startangle endangle arc closepath',/,
     -     '    1.415 setmiterlimit',/,
     -     '    stroke',/,
     -     '  } def')
      WRITE(UNPS,304)
 304  FORMAT(
     -     '/OrthoBox',/,
     -     '  { /grayshade exch def',/,
     -     '    /YHigh exch def',/,
     -     '    /YLow exch def',/,
     -     '    /XRight exch def',/,
     -     '    /XLeft exch def',/,
     -     '    newpath XLeft YHigh moveto XRight YHigh lineto',/,
     -     '    XRight YLow lineto XLeft YLow lineto closepath',/,
     -     '    gsave grayshade setgray fill grestore',/,
     -     '    stroke',/,
     -     '  } def')
      WRITE(UNPS,305)
 305  FORMAT(
     -     '/ArrowHead',/,
     -     '  { /WidthHalf exch def',/,
     -     '    /Length exch def',/,
     -     '    /Angle exch def',/,
     -     '    /YBase exch def',/,
     -     '    /XBase exch def',/,
     -     '    gsave XBase YBase translate Angle rotate',/,
     -     '    newpath 0 0 moveto 0 WidthHalf neg lineto',/,
     -     '    Length 0 lineto 0 WidthHalf lineto 0 0 lineto',/,
     -     '    closepath 0 setgray fill grestore',/,
     -     '  } def')
      WRITE(UNPS,301)
 301  FORMAT(
     -    '/RightJ {',/,
     -    '  dup /Times-Roman-Extd findfont exch scalefont setfont',/,
     -    '  exch stringwidth pop -1 mul exch pop 0 rmoveto',/,
     -    ' } bind def',/,
     -    '/CCenterRot90 {',/,
     -    '  dup /Courier findfont exch scalefont setfont',/,
     -    '  exch stringwidth pop -2 div exch 3 div exch rmoveto',/,
     -    ' } bind def',/,
     -    '/Rot45 { gsave currentpoint translate 45 rotate } bind def',
     -    /,'/CPrint { /Courier findfont exch scalefont setfont show',
     -    ' } bind def',/)
      WRITE(UNPS,300)
 300  FORMAT(
     - '/Print { /Times-Roman-Extd findfont exch scalefont setfont',
     -    ' show } bind def',/,
     -    '/Bprint { /Times-Bold findfont exch scalefont setfont show',
     -    ' } bind def',/,
     -    '/Gprint { /Symbol findfont exch scalefont setfont show }',
     -    ' bind def',/,
     -    '/Center {',/,
     -    '  dup /Times-Roman-Extd findfont exch scalefont setfont',/,
     -    '  exch stringwidth pop -2 div exch -3 div rmoveto',/,
     -    ' } bind def',/,
     -    '/CenterRot90 {',/,
     -    '  dup /Times-Roman-Extd findfont exch scalefont setfont',/,
     -    '  exch stringwidth pop -2 div exch 3 div exch rmoveto',/,
     -    ' } bind def',/,
     -    '/UncenterRot90 {',/,
     -    '  dup /Times-Roman-Extd findfont exch scalefont setfont',/,
     -    '  exch stringwidth } bind def',/,
     -    '/Rot90 { gsave currentpoint translate 90 rotate } bind def'
     -    ,/,'%%EndProlog')
      WRITE(UNPS,400) CURPAG, TOTPAG
 400  FORMAT(
     -    '%%BeginSetup',/,
     -    '1 setlinecap 1 setlinejoin 1 setlinewidth 0 setgray [ ] 0 ',
     -    'setdash newpath',/,
     -    '/Times-Roman /Times-Roman-Extd encode_vector ReEncodeSmall'
     -    ,/,'%%EndSetup',/,
     -    '%%Page:',I5,I5)
      WRITE(UNPS,500) REAL(BBOXX1), REAL(BBOXY1), REAL(BBOXX2),
     -     REAL(BBOXY1), REAL(BBOXX2), REAL(BBOXY2), REAL(BBOXX1),
     -     REAL(BBOXY2)
 500  FORMAT(
     -    '/SfCheckSave save def',/,
     -    2F6.2,' moveto',2(2F7.2,' lineto'),/,
     -    2F7.2,' lineto closepath gsave',/,
     -    'gsave 1.0000 setgray fill grestore',/,
     -    'clip newpath')

C---- Draw in the background colour
      IF (INCOL) THEN
          CALL PSHADE(0.0,BAKCOL,RGB,MXCOLR,INCOL)
          CALL PSUBOX(REAL(BBOXX1), REAL(BBOXY1), REAL(BBOXX2),
     -        REAL(BBOXY1), REAL(BBOXX2), REAL(BBOXY2), REAL(BBOXX1),
     -        REAL(BBOXY2))
      ENDIF

      GO TO 999

C---- Errors on parameter file
 900  CONTINUE
      MDOC=0
      CALL MSGERR(MDOC,'WARNING: Unable to open Postscript file')
      IERR=1
      GO TO 999

 999  CONTINUE
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSRESOURCE  -  Write resource to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSRESOURCE(UN)
C --------------------------------------
      INTEGER       UN
      CHARACTER LINE*80
C --------------------------------------
      WRITE(UN,'(A)')
     *'%%BeginResource: latin1_prolog'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'% ReEncodeSmall from Adobe Postscript Tutorial and Cookbook'
      WRITE(UN,'(A)')
     *'/reencsmalldict 12 dict def'
      WRITE(UN,'(A)')
     *'/ReEncodeSmall'
      WRITE(UN,'(A)')
     *' {reencsmalldict begin'
      WRITE(UN,'(A)')
     *'  /newcodesandnames exch def'
      WRITE(UN,'(A)')
     *'  /newfontname exch def'
      WRITE(UN,'(A)')
     *'  /basefontname exch def'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  /basefontdict basefontname findfont def'
      WRITE(UN,'(A)')
     *'  /newfont basefontdict maxlength dict def'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  basefontdict'
      WRITE(UN,'(A)')
     *'   {exch dup /FID ne'
      WRITE(UN,'(A)')
     *'     {dup /Encoding eq'
      WRITE(UN,'(A)')
     *'       {exch dup length array copy'
      WRITE(UN,'(A)')
     *'	 newfont 3 1 roll put}'
      WRITE(UN,'(A)')
     *'       {exch newfont 3 1 roll put}'
      WRITE(UN,'(A)')
     *'       ifelse'
      WRITE(UN,'(A)')
     *'     }'
      WRITE(UN,'(A)')
     *'     {pop pop}'
      WRITE(UN,'(A)')
     *'     ifelse'
      WRITE(UN,'(A)')
     *'   }forall'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  newfont /FontName newfontname put'
      WRITE(UN,'(A)')
     *'  newcodesandnames aload pop'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  newcodesandnames length 2 idiv'
      WRITE(UN,'(A)')
     *'   {newfont /Encoding get 3 1 roll put}'
      WRITE(UN,'(A)')
     *'   repeat'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  newfontname newfont definefont pop'
      WRITE(UN,'(A)')
     *'  end'
      WRITE(UN,'(A)')
     *'}def'
      WRITE(UN,'(A)')
     *'%%EndResource'
      WRITE(UN,'(A)')
     *'%%BeginResource: latin1_encoding'
      WRITE(UN,'(A)')
     *'/encode_vector ['
      WRITE(UN,'(A)')
     *'8#040  /space        8#041  /exclam       8#042  /quotedbl     '
      WRITE(UN,'(A)')
     *'8#043  /numbersign   8#044  /dollar       8#045  /percent      '
      WRITE(UN,'(A)')
     *'8#046  /ampersand    8#047  /quoteright   8#050  /parenleft    '
      WRITE(UN,'(A)')
     *'8#051  /parenright   8#052  /asterisk     8#053  /plus         '
      WRITE(UN,'(A)')
     *'8#054  /comma        8#055  /minus        8#056  /period       '
      WRITE(UN,'(A)')
     *'8#057  /slash        8#060  /zero         8#061  /one          '
      WRITE(UN,'(A)')
     *'8#062  /two          8#063  /three        8#064  /four         '
      WRITE(UN,'(A)')
     *'8#065  /five         8#066  /six          8#067  /seven        '
      WRITE(UN,'(A)')
     *'8#070  /eight        8#071  /nine         8#072  /colon        '
      WRITE(UN,'(A)')
     *'8#073  /semicolon    8#074  /less         8#075  /equal        '
      WRITE(UN,'(A)')
     *'8#076  /greater      8#077  /question     8#100  /at           '
      WRITE(UN,'(A)')
     *'8#101  /A            8#102  /B            8#103  /C            '
      WRITE(UN,'(A)')
     *'8#104  /D            8#105  /E            8#106  /F            '
      WRITE(UN,'(A)')
     *'8#107  /G            8#110  /H            8#111  /I            '
      WRITE(UN,'(A)')
     *'8#112  /J            8#113  /K            8#114  /L            '
      WRITE(UN,'(A)')
     *'8#115  /M            8#116  /N            8#117  /O            '
      WRITE(UN,'(A)')
     *'8#120  /P            8#121  /Q            8#122  /R            '
      WRITE(UN,'(A)')
     *'8#123  /S            8#124  /T            8#125  /U            '
      WRITE(UN,'(A)')
     *'8#126  /V            8#127  /W            8#130  /X            '
      WRITE(UN,'(A)')
     *'8#131  /Y            8#132  /Z            8#133  /bracketleft  '
      WRITE(UN,'(A)')
     *'8#134  /backslash    8#135  /bracketright 8#136  /asciicircum  '
      WRITE(UN,'(A)')
     *'8#137  /underscore   8#140  /quoteleft    8#141  /a            '
      WRITE(UN,'(A)')
     *'8#142  /b            8#143  /c            8#144  /d            '
      WRITE(UN,'(A)')
     *'8#145  /e            8#146  /f            8#147  /g            '
      WRITE(UN,'(A)')
     *'8#150  /h            8#151  /i            8#152  /j            '
      WRITE(UN,'(A)')
     *'8#153  /k            8#154  /l            8#155  /m            '
      WRITE(UN,'(A)')
     *'8#156  /n            8#157  /o            8#160  /p            '
      WRITE(UN,'(A)')
     *'8#161  /q            8#162  /r            8#163  /s            '
      WRITE(UN,'(A)')
     *'8#164  /t            8#165  /u            8#166  /v            '
      WRITE(UN,'(A)')
     *'8#167  /w            8#170  /x            8#171  /y            '
      WRITE(UN,'(A)')
     *'8#172  /z            8#173  /braceleft    8#174  /bar          '
      WRITE(UN,'(A)')
     *'8#175  /braceright   8#176  /tilde        8#240  /space        '
      WRITE(UN,'(A)')
     *'8#241  /exclamdown   8#242  /cent         8#243  /sterling     '
      WRITE(UN,'(A)')
     *'8#244  /currency     8#245  /yen          8#246  /brokenbar    '
      WRITE(UN,'(A)')
     *'8#247  /section      8#250  /dieresis     8#251  /copyright    '
      WRITE(UN,'(A)')
     *'8#252  /ordfeminine  8#253  /guillemotleft 8#254  /logicalnot  '
      WRITE(UN,'(A)')
     *'8#255  /hyphen       8#256  /registered   8#257  /macron       '
      WRITE(UN,'(A)')
     *'8#260  /degree       8#261  /plusminus    8#262  /twosuperior  '
      WRITE(UN,'(A)')
     *'8#263  /threesuperior 8#264  /acute       8#265  /mu           '
      WRITE(UN,'(A)')
     *'8#266  /paragraph    8#267  /bullet       8#270  /cedilla      '
      WRITE(UN,'(A)')
     *'8#271  /dotlessi    8#272  /ordmasculine 8#273  /guillemotright'
      WRITE(UN,'(A)')
     *'8#274  /onequarter   8#275  /onehalf      8#276  /threequarters'
      WRITE(UN,'(A)')
     *'8#277  /questiondown 8#300  /Agrave       8#301  /Aacute       '
      WRITE(UN,'(A)')
     *'8#302  /Acircumflex  8#303  /Atilde       8#304  /Adieresis    '
      WRITE(UN,'(A)')
     *'8#305  /Aring        8#306  /AE           8#307  /Ccedilla     '
      WRITE(UN,'(A)')
     *'8#310  /Egrave       8#311  /Eacute       8#312  /Ecircumflex  '
      WRITE(UN,'(A)')
     *'8#313  /Edieresis    8#314  /Igrave       8#315  /Iacute       '
      WRITE(UN,'(A)')
     *'8#316  /Icircumflex  8#317  /Idieresis    8#320  /Eth          '
      WRITE(UN,'(A)')
     *'8#321  /Ntilde       8#322  /Ograve       8#323  /Oacute       '
      WRITE(UN,'(A)')
     *'8#324  /Ocircumflex  8#325  /Otilde       8#326  /Odieresis    '
      WRITE(UN,'(A)')
     *'8#327  /multiply     8#330  /Oslash       8#331  /Ugrave       '
      WRITE(UN,'(A)')
     *'8#332  /Uacute       8#333  /Ucircumflex  8#334  /Udieresis    '
      WRITE(UN,'(A)')
     *'8#335  /Yacute       8#336  /Thorn        8#337  /germandbls   '
      WRITE(UN,'(A)')
     *'8#340  /agrave       8#341  /aacute       8#342  /acircumflex  '
      WRITE(UN,'(A)')
     *'8#343  /atilde       8#344  /adieresis    8#345  /aring        '
      WRITE(UN,'(A)')
     *'8#346  /ae           8#347  /ccedilla     8#350  /egrave       '
      WRITE(UN,'(A)')
     *'8#351  /eacute       8#352  /ecircumflex  8#353  /edieresis    '
      WRITE(UN,'(A)')
     *'8#354  /igrave       8#355  /iacute       8#356  /icircumflex  '
      WRITE(UN,'(A)')
     *'8#357  /idieresis    8#360  /eth          8#361  /ntilde       '
      WRITE(UN,'(A)')
     *'8#362  /ograve       8#363  /oacute       8#364  /ocircumflex  '
      WRITE(UN,'(A)')
     *'8#365  /otilde       8#366  /odieresis    8#367  /divide       '
      WRITE(UN,'(A)')
     *'8#370  /oslash       8#371  /ugrave       8#372  /uacute       '
      WRITE(UN,'(A)')
     *'8#373  /ucircumflex  8#374  /udieresis    8#375  /yacute       '
      WRITE(UN,'(A)')
     *'8#376  /thorn        8#377  /ydieresis    	'
      WRITE(UN,'(A)')
     *'] def'
      WRITE(UN,'(A)')
     *'%%EndResource'
C -----------------------
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSNWPAG  -  Write new page lines to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSNWPAG(BBOXX1,BBOXX2,BBOXY1,BBOXY2,MXCOLR,RGB,
     -    INCOL,BAKCOL)

      INCLUDE 'sfcheck_ps.inc'

      INTEGER        BAKCOL, BBOXX1, BBOXX2, BBOXY1, BBOXY2,
     -               MXCOLR
      LOGICAL        INCOL
      REAL           RGB(3,MXCOLR)

C---- Write out new page lines to PostScript file

      CURPAG = CURPAG + 1
      WRITE(UNPS,500) CURPAG, TOTPAG,
     -     REAL(BBOXX1), REAL(BBOXY1), REAL(BBOXX2),
     -     REAL(BBOXY1), REAL(BBOXX2), REAL(BBOXY2), REAL(BBOXX1),
     -     REAL(BBOXY2)
 500  FORMAT(
     -    'grestore stroke',/,
     -    'SfCheckSave restore',/,
     -    'showpage',/,
     -    '%%Page:',I5,I5,/,
     -    '/SfCheckSave save def',/,
     -    2F6.2,' moveto',2(2F7.2,' lineto'),/,
     -    2F7.2,' lineto closepath gsave',/,
     -    'gsave 1.0000 setgray fill grestore',/,
     -    'clip newpath')

C---- Draw in the background colour
      IF (INCOL) THEN
          CALL PSHADE(0.0,BAKCOL,RGB,MXCOLR,INCOL)
          CALL PSUBOX(REAL(BBOXX1), REAL(BBOXY1), REAL(BBOXX2),
     -        REAL(BBOXY1), REAL(BBOXX2), REAL(BBOXY2), REAL(BBOXX1),
     -        REAL(BBOXY2))
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCLOS  -  Write final lines to PostScript file and close
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSCLOS(BBOXX1,BBOXX2,BBOXY1,BBOXY2)

      INCLUDE 'sfcheck_ps.inc'

      INTEGER       BBOXX1, BBOXX2, BBOXY1, BBOXY2

C---- Write out closing lines to PostScript file
      WRITE(UNPS,100) BBOXX1 - 1, BBOXY1 - 1, BBOXX2 + 1, BBOXY2 + 1
 100  FORMAT(
     -    'grestore stroke',/,
     -    'SfCheckSave restore',/,
     -    'showpage',/,
     -    '%%Trailer',/,
     -    '%%BoundingBox:',4I4,/,
     -    '%%EOF')


C---- Close the file
      CLOSE(UNPS)

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSBBOX  -  Write out bounded box to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSBBOX(X1,Y1,X2,Y2,X3,Y3,X4,Y4)

      INCLUDE 'sfcheck_ps.inc'

      REAL          X1, X2, Y1, Y2, X3, Y3, X4, Y4

      WRITE(UNPS,100) X1, Y1, X2, Y2, X3, Y3, X4, Y4
 100  FORMAT(8F7.2,' Pline4')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCOLB  -  Write background colour level
C
C----------------------------------------------------------------------+--- 

      SUBROUTINE PSCOLB(R,G,B)

      INCLUDE 'sfcheck_ps.inc'

      REAL          R, G, B

      WRITE(UNPS,100) R, G, B
 100  FORMAT(3F8.4,' Col')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCOLR  -  Write colour level
C
C----------------------------------------------------------------------+--- 

      SUBROUTINE PSCOLR(R,G,B)

      INCLUDE 'sfcheck_ps.inc'

      REAL          R, G, B

      WRITE(UNPS,100) R, G, B
 100  FORMAT('gsave ',3F8.4,' Col')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCIRC  -  Write out a black circle to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSCIRC(X,Y,RADIUS)

      INCLUDE 'sfcheck_ps.inc'

      REAL          X, Y, RADIUS

      R=RADIUS
      IF(R.LT.0.5.OR.R.GT.999.9) R=1.0
      IF(ABS(X).GT.999.9) X=1.0
      IF(ABS(Y).GT.999.9) Y=1.0
      WRITE(UNPS,100) X, Y, R
 100  FORMAT(3F7.2,' Circle')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCIRCLE  -  Write out a circle to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSCIRCLE(X,Y,RADIUS)

      INCLUDE 'sfcheck_ps.inc'

      REAL          X, Y, RADIUS

      R=RADIUS
      IF(R.LT.0.5.OR.R.GT.999.9) R=1.0
      IF(ABS(X).GT.999.9) X=1.0
      IF(ABS(Y).GT.999.9) Y=1.0
      WRITE(UNPS,100) X, Y, R
 100  FORMAT(3F7.2,' Circleu')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSJTXT  -  Write out right justified text to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSJTXT(X,Y,SIZE,TEXT)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      WRITE(UNPS,100) X, Y - SIZE / 4.0
 100  FORMAT(2F7.2,' moveto')
      WRITE(UNPS,200) TEXT, SIZE
 200  FORMAT('(',A,')',/,F4.1,' RightJ')
      WRITE(UNPS,300) TEXT, SIZE
 300  FORMAT('(',A,')',/,F4.1,' Print')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCTXT  -  Write out centred text to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSCTXT(X,Y,SIZE,TEXT)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      WRITE(UNPS,100) X, Y
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      SZ=SIZE
      IF(SZ.LT.0.0.OR.SZ.GT.99.9) SZ=0.0
      WRITE(UNPS,200) TEXT(1:LEN), SZ
 200  FORMAT('(',A,')',/,F4.1,' Center')
      WRITE(UNPS,300) TEXT(1:LEN), SZ
 300  FORMAT('(',A,')',/,F4.1,' Print')
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSLINE  -  Write line out to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSLINE(X1,Y1,X2,Y2)

      INCLUDE 'sfcheck_ps.inc'

      REAL          X1, X2, Y1, Y2

      IF(ABS(X1).GT.999.0) X1=0.0
      IF(ABS(X2).GT.999.0) X2=0.0
      IF(ABS(Y1).GT.999.0) Y1=0.0
      IF(ABS(Y2).GT.999.0) Y2=0.0

      WRITE(UNPS,100) X1, Y1, X2, Y2
 100  FORMAT(4F7.2,' L')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSLWID  -  Write line-width out to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSLWID(LWIDTH)

      INCLUDE 'sfcheck_ps.inc'

      REAL          LWIDTH

      WRITE(UNPS,100) LWIDTH
 100  FORMAT(F5.2,' setlinewidth')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSMARK  -  Write point-marker to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSMARK(X,Y,MARKER,HWIDX,HWIDY)

      INTEGER       MARKER
      REAL          HWIDX, HWIDY, X, Y

C---- Print appropriate marker

C---- Oridnary residue
      IF (MARKER.EQ.1) THEN
           CALL PSBBOX(X - HWIDX,Y - HWIDY,X - HWIDX,Y + HWIDY,
     -                 X + HWIDX,Y + HWIDY,X + HWIDX,Y - HWIDY)

C---- Glycine
      ELSE IF (MARKER.EQ.2) THEN
          CALL PSTRIA(X - HWIDX,Y - 0.6 * HWIDY,X + HWIDX,
     -        Y - 0.6 * HWIDY,X,Y + 1.2 * HWIDY)

C---- Residue in disallowed region
      ELSE IF (MARKER.EQ.3) THEN
           CALL PSBBOX(X - HWIDX,Y - HWIDY,X - HWIDX,Y + HWIDY,
     -                 X + HWIDX,Y + HWIDY,X + HWIDX,Y - HWIDY)
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSRCTX  -  Write out text centred and rotated through 90
C                        degrees to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSRCTX(X,Y,SIZE,TEXT)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      WRITE(UNPS,100) X, Y
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      WRITE(UNPS,200) TEXT(1:LEN), SIZE
 200  FORMAT('(',A,') ',F4.1,' CenterRot90 Rot90')
      WRITE(UNPS,300) TEXT(1:LEN), SIZE
 300  FORMAT('(',A,') ',F4.1,' Print')
      WRITE(UNPS,400)
 400  FORMAT('grestore')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSRCTXC  -  Write out text centred and rotated through 90
C                        degrees to PostScript file with Courier font
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSRCTXC(X,Y,SIZE,TEXT)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      WRITE(UNPS,100) X, Y
 100  FORMAT(2F7.2,' moveto')
      WRITE(UNPS,200) TEXT, SIZE
 200  FORMAT('(',A,') ',F4.1,' CCenterRot90 Rot90')
      WRITE(UNPS,300) TEXT, SIZE
 300  FORMAT('(',A,') ',F4.1,' CPrint')
      WRITE(UNPS,400)
 400  FORMAT('grestore')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSRTXT  -  Write out text rotated through 90 degrees to
C                        PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSRTXT(X,Y,SIZE,TEXT)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      WRITE(UNPS,100) X, Y
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      WRITE(UNPS,200) TEXT(1:LEN), SIZE
 200  FORMAT('(',A,') ',F4.1,' UncenterRot90 Rot90')
      WRITE(UNPS,300) TEXT(1:LEN), SIZE
 300  FORMAT('(',A,') ',F4.1,' Print')
      WRITE(UNPS,400)
 400  FORMAT('grestore')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSRDTXT  -  Write out text rotated through 45 degrees to
C                        PostScript file
C     This routine should be made more general to allow rotation for any angle
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSRDTXT(X,Y,SIZE,TEXT)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      WRITE(UNPS,100) X, Y
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      WRITE(UNPS,200) TEXT(1:LEN), SIZE
 200  FORMAT('(',A,') ',F4.1,' UncenterRot90 Rot45')
      WRITE(UNPS,300) TEXT(1:LEN), SIZE
 300  FORMAT('(',A,') ',F4.1,' Print')
      WRITE(UNPS,400)
 400  FORMAT('grestore')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSDASH  -  Switch dashed lines on/off
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSDASH(ONOFF)

      INCLUDE 'sfcheck_ps.inc'

      INTEGER       ONOFF

      IF (ONOFF.EQ.0) THEN
          WRITE(UNPS,100)
 100      FORMAT('[]  0 setdash')
      ELSE
          WRITE(UNPS,120) ONOFF, ONOFF
 120      FORMAT('[ ', I2, ' ', I2, ' ]  0 setdash')
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PS_CALE  -  Write out colour or black-and-white shading
C                        level to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PS_CALE(SHADE,INCOL,MXCOLR,RGB,MINCOL,MAXCOL)

      INCLUDE 'sfcheck_ps.inc'

      INTEGER       ICOL, MAXCOL, MINCOL, MXCOLR
      LOGICAL       INCOL
      REAL          COLOUR(3), RGB(3,MXCOLR), SHADE

C---- If black-and-white PostScript file, then write out grey-level
      IF (.NOT.INCOL) THEN
          WRITE(UNPS,100) SHADE
 100      FORMAT('gsave',F7.4,' setgray')

C---- Otherwise, if in colour, determine the right mix of colours
      ELSE
          DO 200, ICOL = 1, 3
              COLOUR(ICOL) = RGB(ICOL,MINCOL) + (1.0 - SHADE)
     -            * (RGB(ICOL,MAXCOL) - RGB(ICOL,MINCOL))
 200      CONTINUE

C----     Write out the 3 RGB values
          WRITE(UNPS,220) (COLOUR(ICOL), ICOL = 1, 3)
 220      FORMAT('gsave ',3F8.4,' Col')
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSHADE  -  Write shading level out to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSHADE(SHADE,COLOUR,RGB,MXCOLR,INCOL)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*2   COLNO
      INTEGER       COLOUR, MXCOLR
      LOGICAL       INCOL
      REAL          RGB(3,MXCOLR), SHADE

      IF (.NOT.INCOL) THEN
          WRITE(UNPS,100) SHADE
 100      FORMAT('gsave',F7.4,' setgray')
      ELSE
          WRITE(COLNO,140) COLOUR
 140      FORMAT(I2.0)
          IF (COLNO(1:1).EQ.' ') COLNO(1:1) = '0'
          WRITE(UNPS,200) COLNO
 200      FORMAT('Col',A2)
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSTEXT  -  Write out text to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSTEXT(X,Y,SIZE,TEXT)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      T1=X
      T2=Y - SIZE / 4.0
      IF(ABS(T1).GT.999.0) T1=1.0
      IF(ABS(T2).GT.999.0) T2=1.0
      WRITE(UNPS,100) T1,T2 
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      SZ=SIZE
      IF(SZ.LT.0.5.OR.SZ.GT.99.9) SZ=1.0
      WRITE(UNPS,300) TEXT(1:LEN), SZ
 300  FORMAT('(',A,')',/,F4.1,' Print')
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSBTEXT  -  Write out text to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSBTEXT(X,Y,SIZE,TEXT)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      T1=X
      T2=Y - SIZE / 4.0
      IF(ABS(T1).GT.999.0) T1=1.0
      IF(ABS(T2).GT.999.0) T2=1.0
      WRITE(UNPS,100) T1,T2 
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      SZ=SIZE
      IF(SZ.LT.0.5.OR.SZ.GT.99.9) SZ=1.0
      WRITE(UNPS,300) TEXT(1:LEN), SZ
 300  FORMAT('(',A,')',/,F4.1,' Bprint')
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSSYMB  -  Write out symbol text to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSSYMB(X,Y,SIZE,TEXT)

      INCLUDE 'sfcheck_ps.inc'

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      T1=X
      T2=Y - SIZE / 4.0
      IF(ABS(T1).GT.999.0) T1=1.0
      IF(ABS(T2).GT.999.0) T2=1.0
      WRITE(UNPS,100) T1,T2 
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      SZ=SIZE
      IF(SZ.LT.0.5.OR.SZ.GT.99.9) SZ=1.0
      WRITE(UNPS,300) TEXT(1:LEN), SZ
 300  FORMAT('(',A,')',/,F4.1,' Gprint')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSTRIA  -  Write out bounded triangle to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSTRIA(X1,Y1,X2,Y2,X3,Y3)

      INCLUDE 'sfcheck_ps.inc'

      REAL          X1, X2, Y1, Y2, X3, Y3


      IF(ABS(X1).GT.999.0) X1=0.0
      IF(ABS(X2).GT.999.0) X2=0.0
      IF(ABS(Y1).GT.999.0) Y1=0.0
      IF(ABS(Y2).GT.999.0) Y2=0.0

      IF(ABS(X3).GT.999.0) X3=0.0
      IF(ABS(Y3).GT.999.0) Y3=0.0

      WRITE(UNPS,100) X1, Y1, X2, Y2, X3, Y3
 100  FORMAT(6F7.2,' Pline3')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSUBOX  -  Write out unbounded box to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSUBOX(X1,Y1,X2,Y2,X3,Y3,X4,Y4)

      INCLUDE 'sfcheck_ps.inc'

      REAL          X1, X2, Y1, Y2, X3, Y3, X4, Y4


      IF(ABS(X1).GT.999.0) X1=0.0
      IF(ABS(X2).GT.999.0) X2=0.0
      IF(ABS(Y1).GT.999.0) Y1=0.0
      IF(ABS(Y2).GT.999.0) Y2=0.0

      IF(ABS(X3).GT.999.0) X3=0.0
      IF(ABS(X4).GT.999.0) X4=0.0
      IF(ABS(Y3).GT.999.0) Y3=0.0
      IF(ABS(Y4).GT.999.0) Y4=0.0

      WRITE(UNPS,100) X1, Y1, X2, Y2, X3, Y3, X4, Y4
 100  FORMAT(8F7.2,' Pl4')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSUTRI  -  Write out unbounded triangle to PostScript file
C
C----------------------------------------------------------------------+--- 

      SUBROUTINE PSUTRI(X1,Y1,X2,Y2,X3,Y3)

      INCLUDE 'sfcheck_ps.inc'

      REAL          X1, X2, X3, Y1, Y2, Y3

      WRITE(UNPS,100) X1, Y1, X2, Y2, X3, Y3
 100  FORMAT(6F7.2,' Pl3')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE AXES  -  Draw graph axes and axis-labels, writing out to
C                      PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE AXES(XLIM1,XLIM2,YLIM1,YLIM2,NPTSX,NPTSY,XMIN,XMAX,
     -    YMIN,YMAX,SIZLAB,INTRLX,INTRLY,TSIZE,NUMBEX,NUMBEY,ZEROS,
     -    NOENDX,NOENDY,FULTIC)

      CHARACTER*5    LABEL
      INTEGER        IFROM, IMARK, INTRLX, INTRLY, IVALUE, NPTSX, NPTSY
      LOGICAL        FULTIC, NOENDX, NOENDY, NUMBEX, NUMBEY, ZEROS
      REAL           SIZLAB, TSIZE, UGAP, VALUE, VGAP, X, XCENTR, XGAP,
     -               XLIM1, XLIM2, XMAX, XMIN, X1, X2, Y, YCENTR, YGAP,
     -               YLIM1, YLIM2, YMAX, YMIN, Y1, Y2

C Routine parameters:-
C ------------------
C XLIM1, XLIM2, YLIM1, YLIM2 - x- and y-extent of graph area (ie coords
C          of graph-box). In PostScript coords.
C NPTSX, NPTSY - Numbers of ticks along x- and y-axes
C XMIN, XMAX, YMIN, YMAX - Minimum and maximum x- and y-values on plotted
C          axes
C SIZLAB - Label-size for numbers on the axis (in PostScript coords).
C INTRLX, INTRLY - Integer values indicating how the numbers on the axes
C          are to be formatted. (O=format as integer,1=format as real with
C          1 number after decimal point,2=real with 2 numbers after decimal
C          point.
C TSIZE  - A measure of the distance of axis labels from the axis (in
C          PostScript coords).
C NUMBEX, NUMBEY - Flags indicating whether numbers are actually required
C          on the x- and y-axes
C ZEROS  - Flag indicating whether zero value on the y-axis is required
C NOEND  - Flag indicating whether the last numbers on the x- and y-axes
C          are required
C FULTIC - Flag indicating whether axis ticks are to be full-ticks,
C          extending a little to the other side of the axis, or half-ticks
C          only.

C---- Initialise variables
      IF (NPTSX.GT.0) THEN
          XGAP = (XLIM2 - XLIM1) / NPTSX
          UGAP = (XMAX - XMIN) / NPTSX
      ENDIF
      IF (NPTSY.GT.0) THEN
          YGAP = (YLIM2 - YLIM1) / NPTSY
          VGAP = (YMAX - YMIN) / NPTSY
      ENDIF
      XCENTR = (XLIM1 + XLIM2) / 2.0
      YCENTR = (YLIM1 + YLIM2) / 2.0

C---- Draw box round graph
      CALL PSLWID(0.6)
      CALL PSLINE(XLIM1,YLIM1,XLIM1,YLIM2)
      CALL PSLINE(XLIM1,YLIM2,XLIM2,YLIM2)
      CALL PSLINE(XLIM2,YLIM2,XLIM2,YLIM1)
      CALL PSLINE(XLIM2,YLIM1,XLIM1,YLIM1)

C---- x-axis point markers and labels
      X = XLIM1
      Y = YLIM1 - TSIZE / 2.0
      IF (NPTSX.GT.0) THEN
          DO 100, IMARK = 1, NPTSX + 1
              VALUE = XMIN + (IMARK - 1) * UGAP
              IF (VALUE.GE.0.0) THEN
                  IVALUE = VALUE + 0.5
              ELSE
                  IVALUE = VALUE - 0.5
              ENDIF
              IF (INTRLX.EQ.0) THEN
                  WRITE(LABEL,20) IVALUE
 20               FORMAT(I5)
              ELSE IF (INTRLX.EQ.1) THEN
                  WRITE(LABEL,40) VALUE
 40               FORMAT(F5.1)
              ELSE IF (INTRLX.EQ.2) THEN
                  WRITE(LABEL,60) VALUE
 60               FORMAT(F5.2)
              ENDIF
              IFROM = 1
              IF (LABEL(1:1).EQ.' ') IFROM = 2
              IF (LABEL(2:2).EQ.' ') IFROM = 3
              IF (LABEL(3:3).EQ.' ') IFROM = 4
              IF (LABEL(4:4).EQ.' ') IFROM = 5
              IF (NUMBEX) THEN
                  IF (.NOT.(NOENDX .AND. IMARK.EQ.NPTSX + 1)) THEN
                      Y1 = YLIM1
                      Y2 = YLIM1 - SIZLAB / 3.0
                      IF (FULTIC) Y1 = Y1 + SIZLAB / 6.0
                      CALL PSCTXT(X,Y,SIZLAB,LABEL(IFROM:5))
                      CALL PSLINE(X,Y1,X,Y2)
                  ENDIF
              ENDIF
              X = X + XGAP
 100      CONTINUE
      ENDIF

C---- y-axis point markers and labels
      X = XLIM1 - TSIZE
      Y = YLIM1
      IF (NPTSY.GT.0) THEN
          DO 200, IMARK = 1, NPTSY + 1
              VALUE = YMIN + (IMARK - 1) * VGAP
              IF (VALUE.GE.0.0) THEN
                  IVALUE = VALUE + 0.5
              ELSE
                  IVALUE = VALUE - 0.5
              ENDIF
              IF (INTRLY.EQ.0) THEN
                  WRITE(LABEL,20) IVALUE
              ELSE IF (INTRLY.EQ.1) THEN
                  WRITE(LABEL,40) VALUE
              ELSE
                  WRITE(LABEL,60) VALUE
              ENDIF
              IFROM = 1
              IF (NUMBEY .AND. (ZEROS .OR. IMARK.GT.1)) THEN
                  IF (.NOT.(NOENDY .AND. IMARK.EQ.NPTSY + 1)) THEN
                      X1 = XLIM1 - SIZLAB / 3.0
                      X2 = XLIM1
                      IF (FULTIC) X2 = X2 + SIZLAB / 6.0
                      CALL PSCTXT(X,Y,SIZLAB,LABEL(1:5))
                      CALL PSLINE(X1,Y,X2,Y)
                  ENDIF
              ENDIF
              Y = Y + YGAP
 200      CONTINUE
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C      SUBROUTINE PSHBOX - Draw a shaded bounded rectangle parallel to
C                          the x and y direction of the page
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSHBOX (XL,XR,YL,YH,SHADE)

      INCLUDE 'sfcheck_ps.inc'

      REAL*4 XL,XR,YL,YH,SHADE

      WRITE(UNPS,100) XL, XR, YL, YH, SHADE
 100  FORMAT(5F7.2,' OrthoBox')

      RETURN

      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSSECTOR  -  Draw a circle sector
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSSECTOR(CENTERX,CENTERY,RADIUSLOW,RADIUSHIGH,
     -     STARTANGLE,ENDANGLE,SHADE)

      INCLUDE 'sfcheck_ps.inc'

      REAL          CENTERX,CENTERY,RADIUSLOW,RADIUSHIGH,
     -     STARTANGLE,ENDANGLE,SHADE


      WRITE(UNPS,100) CENTERX,CENTERY,RADIUSLOW,RADIUSHIGH,
     -     STARTANGLE,ENDANGLE,SHADE

 100  FORMAT(7F7.2,' DrawUSect')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSBSECTOR  -  Draw a circle sector
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSBSECTOR(CENTERX,CENTERY,RADIUSLOW,RADIUSHIGH,
     -     STARTANGLE,ENDANGLE,SHADE)

      INCLUDE 'sfcheck_ps.inc'

      REAL          CENTERX,CENTERY,RADIUSLOW,RADIUSHIGH,
     -     STARTANGLE,ENDANGLE,SHADE


      WRITE(UNPS,100) CENTERX,CENTERY,RADIUSLOW,RADIUSHIGH,
     -     STARTANGLE,ENDANGLE,SHADE

 100  FORMAT(7F7.2,' DrawSect')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSBADSECTOR  -  Draw a "crossed" circle sector
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSBADSECTOR(CENTERX,CENTERY,RADIUSLOW,RADIUSHIGH,
     -     STARTANGLE,ENDANGLE)

      INCLUDE 'sfcheck_ps.inc'

      REAL          CENTERX,CENTERY,RADIUSLOW,RADIUSHIGH,
     -     STARTANGLE,ENDANGLE


      WRITE(UNPS,100) CENTERX,CENTERY,RADIUSLOW,RADIUSHIGH,
     -     STARTANGLE,ENDANGLE

 100  FORMAT(6F7.2,' DrawBadSect')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C      SUBROUTINE PSARROWHEAD - Draw an arrow head at some position pointig
C                               to a given direction
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSARROWHEAD (X,Y,ANGLE,LEN,WIDTH)

      INCLUDE 'sfcheck_ps.inc'

      REAL*4 X,Y,ANGLE,LEN,WIDTH

      WRITE(UNPS,100) X,Y,ANGLE,LEN,WIDTH/2.0
 100  FORMAT(5F7.2,' ArrowHead')

      RETURN

      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C      SUBROUTINE PSTRANSLATE - Translate user coordinates to position
C                               x and y of the page
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSTRANSLATE (X,Y)

      INCLUDE 'sfcheck_ps.inc'

      REAL*4 X,Y

      WRITE(UNPS,100) X, Y
 100  FORMAT(2F10.2,' translate')

      RETURN

      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C      SUBROUTINE PSFUNIT - Define the value Unit to be used
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSFUNIT (UN)

      INCLUDE 'sfcheck_ps.inc'

      INTEGER UN

      UNPS = UN

      RETURN

      END

C--------------------------------------------------------------------------
