C -------------
      SUBROUTINE GET_SYMM(MDOC,NOSPGR,ISETT,SGNAME,NSYM,ISYM
     *                              ,MAXNSO,IERR)
C -------------------------------------------------------
C -P- GET_SYMM - generate cryst.symm. oparators from space group name or space
C -P-            group number.
C -------------------------------------------------------
C --
C           input
C         nsg  sett  --> nsg sett' --> nsg+sett
C          3    1         3   2        1003
C          3    2         3   1           3
C          4    1         4   2        1004
C          4    2         4   1           4
C          5    1         5   4        3005               
C          5    2         5   1           5       
C          5    3         5   2        1005  
C          5    4         5   3        2005  
C        146    1 R     146   2        1146 R
C        146    2 H     146   1         146 H
C        155    1 R     155   2        1155 R
C        155    2 H     155   1         155 H
C --------------------------------------        
C
c      ISTT = NSG/1000
c      NOSG = NSG - ISTT*1000
c      ISTT = ISTT + 1
c
c      IF(NOSG.EQ.3.OR.NOSG.EQ.4.OR.NOSG.EQ.146.OR.NOSG.EQ.155) THEN
c        IF(ISTT.EQ.1) THEN
c          ISTT = 2
c        ELSE IF(ISTT.EQ.2) THEN  
c          ISTT = 1
c        ENDIF
c      ELSE IF(NOSG.EQ.  5) THEN
c        IF(ISTT.EQ.1) THEN
c          ISTT = 2
c        ELSE IF(ISTT.EQ.2) THEN  
c          ISTT = 3
c        ELSE IF(ISTT.EQ.3) THEN  
c          ISTT = 4
c        ELSE IF(ISTT.EQ.4) THEN  
c          ISTT = 1
c        ENDIF
c      ENDIF
c
c      NOSPGR = NOSG
c      ISETT  = ISTT 
C ---
C ---
C -------------------------------------------------------
      INTEGER   MDOC,IERR,MAXNSO
C --
      INTEGER*2 ISYM(5,3,MAXNSO)
      INTEGER   NOSPGR,ISETT,NSYM
      CHARACTER SGNAME*(*)
C -----------------------------------
      CHARACTER LINE*80
C -----------------------------------
      INTEGER   L,M,LENS,LEN
      INTEGER   NO_CCP4
C -------------------------------------------------------
      IERR = 0
      M    = 99
C ------------------------------------
      NSYM  = 0
C ------------------------------------
      CALL LENSTR_BL(SGNAME,LENS)
      IF(LENS.LE.0) THEN
        IF(NOSPGR.LE.0) THEN
C         default P1
          GO TO 100
        ELSE
C          --> use space group number
          CALL NSG_STAND_TO_CCP4(NOSPGR,ISETT,NO_CCP4,IERR)
          IF(IERR.NE.0) GO TO 100      
        ENDIF
      ELSE
c        IF(NOSPGR.GT.0) THEN
c          CALL NSG_STAND_TO_CCP4(NOSPGR,ISETT,NO_CCP4,IERR)
c          IF(IERR.NE.0) GO TO 100      
c        ENDIF
        NO_CCP4 = 0 
C         use space group name
      ENDIF
C ------------------------------------------
      CALL GET_SYMM_NB_NEW(MDOC,NO_CCP4,SGNAME,NSYM
     *                              ,ISYM,MAXNSO,IERR)
      IF(IERR.NE.0) GO TO 100      
C --
      CALL NSG_CCP4_TO_STAND(NO_CCP4,NOSPGR,ISETT,IERR)
C ------------------------------------------
      RETURN
 100  CONTINUE
      NOSPGR      = 1
      ISETT       = 1
      NSYM        = 1
      ISYM(1,1,1) = 1
      ISYM(2,1,1) = 0
      ISYM(3,1,1) = 0
      ISYM(4,1,1) = 0
      ISYM(5,1,1) = 1
      ISYM(1,2,1) = 0
      ISYM(2,2,1) = 1
      ISYM(3,2,1) = 0
      ISYM(4,2,1) = 0
      ISYM(5,2,1) = 1
      ISYM(1,3,1) = 0
      ISYM(2,3,1) = 0
      ISYM(3,3,1) = 1
      ISYM(4,3,1) = 0
      ISYM(5,3,1) = 1

      LINE = ' WARNING: can''t find space group name'
      CALL MSGERR(MDOC,LINE)
      CALL LENSTR_BL(SGNAME,L)
      IF(L.GT.0) THEN
        IF(L.GT.12) L = 12
      ELSE
        L      = 1
        SGNAME = ' '
      ENDIF 
      LINE = '              -->'//SGNAME(1:L)//'<--'
      CALL MSGERR(MDOC,LINE)
      CALL MSGERR(MDOC,'        default space group is "P 1"')

      SGNAME     = 'P 1'
      IERR=-1
      RETURN
      END

      SUBROUTINE GET_SYMM_NB_NEW(MDOC,NOSPGR,SGNAME,NSYM
     *                              ,ISYM,MAXNSO,IERR)
C -------------------------------------------------------
C -P- GET_SYMM - generate cryst.symm. oparators from space group name or space
C -P-            group number.
C
C     input:  NOSPGR,SGNAME
C
C     output: CS_NSYM,SYM,TRANS  
C             IERR
C             NOSPGR        if SGNAME is input
C             SGNAME        if NOSPGR  are input
C -------------------------------------------------------
      IMPLICIT NONE
      INTEGER   MDOC,IERR
      INTEGER   MAXNSO
      INTEGER*2 ISYM(5,3,MAXNSO)
C      REAL      SYM(3,3,MAXNSO)
C      REAL      TRANS(3,MAXNSO)
      INTEGER   NOSPGR,NSYM
      CHARACTER SGNAME*(*)
      
      CHARACTER NAMSPG_CIFS*20,NAMPG*20

      INTEGER ISYM_UNIT,NSYMP,J,I,IS
C
      INTEGER NumSymmetry
      REAL RealSymmMatrx(4,4,192),T
C ---------------------------------------------------------
      IERR = 0
C
C---Read symetry operators and remaining identifiers of the space
C---group

      ISYM_UNIT = 0
      CALL MSYMLB3(ISYM_UNIT,NOSPGR,SGNAME,NAMSPG_CIFS,
     +                   NAMPG,NSYMP,NumSymmetry,RealSymmMatrx)

C
C---Store symmetry operators in SYM and TRANS as Alexei wants
      NSYM = NumSymmetry
      DO    IS=1,NSYM
        DO   J=1,3
          DO   I=1,3
            ISYM(I,J,IS) = NINT(RealSymmMatrx(J,I,IS))
          ENDDO
          T              = RealSymmMatrx(J,4,IS)*24
          ISYM(4,J,IS) = NINT(T)
          ISYM(5,J,IS) = 24
        ENDDO
      ENDDO
c     SGNAME = NAMSPG_CIFS 
      RETURN
      END
