C -I-
      SUBROUTINE EXTRACT(MDOC,POOL,NX,NY,NZ,F000,NAMEF1
     * ,NAMEC,NAMED,NAMEPH,NAMEF2,RESMIN,RESMAX,BADD,BOFF,SCALE
     * ,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P- EXTRACT  : creats density map around model.
C -S-
C      Dialog:
C
C   FILE_1:  -   input file-1 of the structure factors.
C   FILE_2:  -   name of FILE-DERIV, if you want it 
C   FILE_PH: -   name of FILE-PHASE, if you want it
C   FILE_C:  -   name of file of model
C   FILE_D:  <extract> -   output file of density.
C   RESOL:   MIN,MAX , <from files> - resolution
C   SCALE:   <1.0>
C   BOFF     <0> , 240 corresponds to RESmin=10 /aprox./
C                For suppressing low resolutin reflections, kind of 
C                modeling desordered solvent: Fnew=(1-exp(-Boff*s**2))*Fold    
C   BADD:    <0.0>
C                     SCALE and BADD will be applyed:
C                     DEL = (Fder*SCALE-Fnat)*EXP(-Badd*RSQ
C                     or F = ( Fnat*SCALE )*EXP(-Badd*RSQ)
C
C
C      SUBROUTINE EXTRACT(MDOC,POOL,NX,NY,NZ,F000,NAMEF1
C     * ,NAMEC,NAMED,NAMEPH,NAMEF2,RESMIN,RESMAX,BADD,BOFF,SCALE
C     * ,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAMEF1 - name of input file F_1
C      NAMEF2 - name oF input file F_2 / or " "/
C      NAMEPH - name oF input file PHASE / or " "/
C      NAMED  <extract> - name of output dens-file.
C      SCALE,BOFF,BADD -  - see above.
C      NX,NY,NZ - numbers of points of grid corresponding axises X,Y,Z
C                 if NX=NY=NZ=0 program will define minimal values 
C                 suitable for calculation struture factors.
C      F000:    <0.0>   - value of F(0,0,0)
C               > 0   - use this value
C               < 0   - use value from input coef_file.
C      POOL    - real array POOL(MEMORY) for
C                one Z-sections of electron density NX x NY 
C                and one Z-sections of electron density of box of model
C                if model will be used.
C      MEMORY  - dimension of real array POOL.
C      ISYM    - integer*2 array for cryst.symmetry operators 
C      IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM)
C                We need not to define contents of array ISYM
C                Here is only reservation of memory.
C      IERR    - signal of error / =1 -error , =o - OK / 
C
C      Output information:
C
C      RESULT(IPRROW) /real/ :
C
C      RESULT(1,1) = number of points
C      RESULT(2,1) = Dmax
C      RESULT(3,1) = Dmin
C      RESULT(4,1) = RMS
C      RESULT(5,1) = <D>
C      RESULT(6,1) = N_positive points
C      RESULT(7,1) = N_negative points
C      RESULT(8,1) = RMS for positive and =0 density
C      RESULT(9,1) = RMS for negative and =0 density
C      RESULT(10,1) = <D> for positive and =0 density
C      RESULT(11,1) = <D> for negative and =0 density
C      IF(IPRROW.GE.15) THEN
C        RESULT(12,1) = 3-moment of density 
C        RESULT(13,1) = 4-moment of density
C        RESULT(14,1) = P_000 - value of origine Patterson peak.
C        RESULT(15,1) = N points with density = 0
C      ENDIF    
C -I-
C ---------------------------------------------
CMS      : POOL
      REAL      POOL(MEMORY)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*4 MDOC,MEMORY,IPRSYM,IERR
      CHARACTER NAMEF1*(*),NAMEF2*(*),NAMED*(*),NAMEPH*(*)
     *         ,NAMEC*(*)
      REAL      F000
      INTEGER*4 NX,NY,NZ
      REAL      RESULT(IPRROW,*)
C --------------
      IERR=0
      NCRES=MEMORY-IPRSYM*5
      IF(NCRES.LE.1) THEN
        CALL MSGERR(MDOC,' ERROR: NOT MEMORY')
        IERR=1
      ENDIF
      I0=NCRES+1
      NCRES2=NCRES/2
      NCRES4=NCRES2/2
C -----------
      CALL EXFFTS(MDOC,POOL,POOL(NCRES2+1)
     * ,NX,NY,NZ,F000,NAMEF1,NAMEF2,NAMED
     * ,NCRES2,RESULT,IPRROW,ISYM,POOL(I0),POOL(IPRSYM+I0)
     * ,POOL(IPRSYM*2+I0),POOL(IPRSYM*3+I0),POOL(IPRSYM*4+I0)
     * ,RESMIN,RESMAX,IPRSYM,NAMEPH,BADD,BOFF,SCALE,NAMEC,IERR)
C -----------
      RETURN
      END

      SUBROUTINE EXFFTS(MDOC,POOL,POOLW
     * ,NX,NY,NZ,F000,NAMEF1
     * ,NAMEF2,NAMED,NCRES2,RESULT,IPRROW,ISYM,IH,IK,IL,FA,FB
     * ,RESMIN,RESMAX,IPRSYM,NAMEPH,BADD,BOFF,SCALE,NAMEC,IERR)
C ---------------------------------------------
CMS      : POOL
      COMPLEX   POOL(*)
      REAL      POOLW(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*4 IH(IPRSYM),IK(IPRSYM),IL(IPRSYM)
      INTEGER*4 NX,NY,NZ
      INTEGER*4 MDOC,NCRES2,IPRSYM,IERR
      REAL      F000,FA(IPRSYM),FB(IPRSYM)
      CHARACTER NAMEF1*(*),NAMEF2*(*),NAMED*(*),NAMEPH*(*)
     *         ,NAMEC*(*)
      REAL      RESULT(IPRROW,*)
C ----------------------------------------------------------------------
      COMMON/COM_VLD/ DMAX1T,DMIN1T,SUM1,SUM21,NUMB1,NPOS,NNEG,NZER
     * ,SUMP,SUMN,SUMP2,SUMN2,SUM31,SUM41,P000
C ----------------------------------------------------------------------
      INTEGER*4 IDIM(3)
      COMPLEX   CDM,SM
      REAL      RLATT(6)
      REAL      CZL(512),SZL(512)
      CHARACTER TITLE*80,ITP*4,ITPH*4,LINE*80,MSG*1,ITP2*4
      CHARACTER LAP*1,ASYM*1 
      INTEGER*4 IZMIN,IZMAX,MX,MY,MZ
C -
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAME*40,DATE*9,SPGR*24
C ==============================================================
      IERR =0
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      M    =99
      FOURPI2=-4.0*PI*PI
C -------------------------------
      LAP='N'
      ASYM='N'
      IF(ABS(SCALE).LT.0.0001) SCALE=1.0
C -------------------------------   
      MTIN  = 8
      ITP   ='FF  '
      MD=-ABS(MDOC)-1
      CALL ORFILE(MD,MTIN,NAMEF1,ITP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN FILE-F_1')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,RN,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)

C      CALL RTITLE(MTIN,NAMEF1,MDOC,ITP,IPRINT,DM,DM,DM,DM,DM,DM,
C     *            F1,F2,F3,RX,IDM,IDM,IDM,IDM,IDM,TITLE)

       CALL C_RD_CR
C ----
      A    =RLATT(1)
      B    =RLATT(2)
      C    =RLATT(3)
      ALPHA=RLATT(4)
      BETA =RLATT(5)
      GAMMA=RLATT(6)
      CALL DSTARF(RLATT,AS,BS,CS,ALS,BES,GAS,VOL)
C ----
C     VOLUME OF CELL
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
C -----------------------------------------------
      CALL LENSTR_BL(NAMEPH,LEN)
      IF(LEN.LE.0.OR.NAMEPH(1:1).EQ.' '.OR.NAMEPH(1:1).EQ.',') THEN
        MTPH=0
      ELSE
        ITPH='PH  '
        MTPH= 9
        CALL ORFILE(MD,MTPH,NAMEPH,ITPH,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: OPEN FILE-PH')
          CLOSE(MTIN)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     *  ,RLATT(6),CF,BT,RN3,RX3,IDM,IDM,IDM,IDM,IDM,LINE,IERR)
      ENDIF
C ----
      CALL LENSTR_BL(NAMEF2,LEN)
      IF(LEN.LE.0.OR.NAMEF2(1:1).EQ.' '.OR.NAMEF2(1:1).EQ.',') THEN
        MTF=0
      ELSE
        MTF= 10
        ITP2='FF  '
        CALL ORFILE(MD,MTF,NAMEF2,ITP2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: OPEN FILE-F_2')
          CLOSE(MTIN)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     *  ,RLATT(6),CF,BT,RN2,RX2,IDM,IDM,IDM,IDM,IDM,LINE,IERR)
      ENDIF
C ---------------------------------------
      IF(RESMIN.LE.0.0) RESMIN=RN
      IF(RESMAX.LE.0.0) RESMAX=RX
      IF(MTF.GT.0) THEN
        IF(RESMIN.GT.RN2) RESMIN=RN2
      ENDIF
      IF(MTPH.GT.0) THEN
        IF(RESMIN.GT.RN3) RESMIN=RN3
      ENDIF
      IF(MTF.GT.0) THEN
        IF(RESMAX.LT.RX2) RESMAX=RX2
      ENDIF
      IF(MTPH.GT.0) THEN
        IF(RESMAX.LT.RX3) RESMAX=RX3
      ENDIF
      WRITE(LINE,'(''RESOLUTIOM: MIN,MAX '',2F7.2)') 
     *  RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      IF(RESMAX.GT.RESMIN) THEN
        STOR=RESMIN
        RESMIN=RESMAX
        RESMAX=STOR
      ELSE IF(RESMAX.EQ.RESMIN) THEN
        IERR=1
        RETURN
      ENDIF
      RSMIN=1./RESMIN
      RSMAX=1./RESMAX
C ----
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----
      CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
      WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000 FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,1020) IHMAX,IKMAX,ILMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MD,LINE)
      IF(NX.LE.0) NX=NXMIN
      IF(NY.LE.0) NY=NYMIN
      IF(NZ.LE.0) NZ=NZMIN
      NX   =(NX/2)*2
      NY   =(NY/2)*2
      NZ   =(NZ/2)*2
      IF(NX.LT.2*IHMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nx < 2Hmax+1')
      IF(NY.LT.2*IKMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Ny < 2Kmax+1')
      IF(NZ.LT.2*ILMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nz < 2Lmax+1')
      WRITE(LINE,1030) NX,NY,NZ
 1030 FORMAT('GRID: NX=',I3,', NY=',I3,', NZ=',I3) 
      CALL MSGDOC(MD,LINE)

      IF(ILMAX.LT.0)  ILMAX=0
      IF(ILMAX.GT.511) ILMAX=511

      NX2  = NX/2
      NXY  = NX*NY
      NCRES= NCRES2*2

      IF(NXY.GT.NCRES2) THEN
        WRITE(LINE,
     * '('' ERROR: not enough memory for one section of dens.'')')
        CALL MSGERR(MDOC,LINE)
        WRITE(LINE,'('' NX='',I4,'' NY='',I4,'' MEMORY-SIZE='',I6)')
     *                  NX,NY,NCRES2
        CALL MSGERR(MDOC,LINE)
        WRITE(LINE,'('' must by: NX x NY < '',I6)') NCRES2
        CALL MSGERR(MDOC,LINE)
        IERR=1
        CLOSE(MTIN)
        IF(MTF.GT.0)  CLOSE(MTF)
        IF(MTPH.GT.0) CLOSE(MTPH)
        RETURN
      ENDIF
      NXY=NXY/2

      CALL SET_LIMZ(NSYM,ISYM,NZ,IZMAXD)
      IZMIN=0
      IZMAX=IZMAXD
      IF(MTPH.EQ.0) IZMAX=NZ/2

      IF(F000.EQ.0.0) THEN
        MSG='N'
      ELSE IF(F000.GT.0.0) THEN
        MSG='I'
      ELSE
        MSG='Y'
      ENDIF

      IF(MTPH.EQ.0) THEN
        IPATT=1
        ITP  ='PATT'
      ELSE
        IPATT=0
        ITP  ='FOUR'
      ENDIF

      TITLE(1:4)=ITP
      IF(MTF.LE.0) THEN
        IF(LAP.EQ.'Y') THEN
          TITLE(5:8)='LAPL'
        ELSE
          TITLE(5:8)='    '
        ENDIF
      ELSE
        IF(LAP.EQ.'Y') THEN
          TITLE(5:8)='LDIF'
        ELSE
          TITLE(5:8)=' DIF'
        ENDIF
      ENDIF
C ----
      ITRANS=0
      MTC   =0
      CALL LENSTR_BL(NAMEC,LEN)
      IF(LEN.LE.0.OR.NAMEC(1:1).EQ.' '.OR.NAMEC(1:1).EQ.',') THEN
        CALL MSGERR(MD,' ERROR: wrong file name')
        IERR=1
        RETURN
      ELSE

        MTC=11

        CALL EXTRACT_CRD_LIM(MDOC,NAMEC
     *  ,RESULT,ISYM,IPRSYM,IERR)

        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: OPEN FILE-COORD')
          CLOSE(MTIN)
          IF(MTF.GT.0)  CLOSE(MTF)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF

        XFMIN=RESULT(12,1) 
        XFMAX=RESULT(13,1) 
        YFMIN=RESULT(14,1) 
        YFMAX=RESULT(15,1) 
        ZFMIN=RESULT(16,1)
        ZFMAX=RESULT(17,1) 

        IXWMIN=XFMIN*NX-1
        IYWMIN=YFMIN*NY-1
        IZWMIN=ZFMIN*NZ-1
        IXWMAX=XFMAX*NX+1
        IYWMAX=YFMAX*NY+1
        IZWMAX=ZFMAX*NZ+1

        MX=IXWMAX-IXWMIN+1
        MY=IYWMAX-IYWMIN+1
        MZ=IZWMAX-IZWMIN+1

        AW=(A/NX)*MX
        BW=(B/NY)*MY
        CW=(C/NZ)*MZ

        ITRANS=1

        CLOSE(MTC)

        CALL MSGDOC(MDOC,' --- Box of model ---')
        WRITE(LINE,*) 'MX,MY,MZ:',MX,MY,MZ
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) 'X       :',IXWMIN,IXWMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) 'Y       :',IYWMIN,IYWMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) 'Z       :',IZWMIN,IZWMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) 'CELL    :',AW,BW,CW
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,' --------------------')

        MXY=MX*MY
        IF(MXY.GT.NCRES2) THEN
          WRITE(LINE,
     * '('' ERROR: not enough memory for one section of box'')')
          CALL MSGERR(MDOC,LINE)
          WRITE(LINE,'('' must by: MX x MY < '',I6)') NCRES2
          CALL MSGERR(MDOC,LINE)
          IERR=1
          CLOSE(MTIN)
          IF(MTF.GT.0)  CLOSE(MTF)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF


      ENDIF

C ----
C     WRITE(*,*) '      OUTPUT-FILE /DENS/'
      MTOUT=0
      CALL LENSTR_BL(NAMED,LEN)
      IF(LEN.GT.0.AND.NAMED(1:1).NE.' '.AND.NAMED(1:1).NE.',') THEN

      ELSE
        NAMED='extract'
      ENDIF

      MTOUT = 12
      ITP   ='RI  '

      IF(MTC.GT.0) THEN

        CALL GET_CELL(RLATT,CODE,NAME,DATE,TITLE
     *           ,NSPGROUP,NOSETT,SPGR,NSM,IERR)

        CALL C_CR_WR

        NSPGROUP=1
        NOSETT  =1
        SPGR    ='P 1'

        CALL SET_WRF(NSPGROUP,NOSETT,SPGR,CODE
     *                  ,NAME,DATE,TITLE)

        CALL SET_TITLE(MD,AW,BW,CW,RLATT(4),RLATT(5)
     *  ,RLATT(6),F1,F2,F3,F4,MX,MY,MZ,IZWMIN,IZWMAX,TITLE,IERR)
        NSYMW=1
        CALL OWFILE(MD,MTOUT,NAMED,ITP,NSYMW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
          CLOSE(MTIN)
          IF(MTF.GT.0)  CLOSE(MTF)
          IF(MTPH.GT.0) CLOSE(MTPH)
          CLOSE(MTOUT)
          RETURN
        ENDIF

      ELSE

        CALL C_CR_WR
        CALL SET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        CALL OWFILE(MD,MTOUT,NAMED,ITP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
          CLOSE(MTIN)
          IF(MTF.GT.0)  CLOSE(MTF)
          IF(MTPH.GT.0) CLOSE(MTPH)
          CLOSE(MTOUT)
          RETURN
        ENDIF

      ENDIF

      AD    =0.0
      SAD   =0.0
      ZERO  =0.0
      CDM   =CMPLX(ZERO,ZERO)
      ITP   ='    '
      IPRINT=0
      IX0   =0
      IY0   =0
      IZ0   =IZMIN
      ITR   =0
      ICNTZ =-999
      IDIM(1)=NX2
      IDIM(2)=NY
      IDIM(3)=0
      IFIRST =0
C -------------------------------------------------
      DMAX1T=-1.E30
      DMIN1T= 1.E30
      SUM1 =0.0
      SUM21=0.0
      NUMB1=0
      NPOS =0
      NNEG =0
      NZER =0
      SUMP =0.0
      SUMN =0.0
      SUMP2=0.0
      SUMN2=0.0
      SUM31=0.0
      SUM41=0.0      
C =================================================
      DO     IZ=IZWMIN,IZWMAX
        Z=FLOAT(IZ)/FLOAT(NZ)
        ANG=TWOPI*Z
        CSZ=COS(ANG)
        SNZ=SIN(ANG)
        CZL(1)=1.0
        SZL(1)=0.0
        DO     I=2,512
          CZL(I)=CZL(I-1)*CSZ-SZL(I-1)*SNZ
          SZL(I)=SZL(I-1)*CSZ+CZL(I-1)*SNZ
        ENDDO
        DO     I=1,NXY
          POOL(I)=CDM
        ENDDO
        IF(MSG.EQ.'I') THEN
          TEMP=F000
          SM=CMPLX(TEMP,ZERO)
          POOL(1)=SM
C ---
          IF(IFIRST.EQ.0) THEN
            WRITE(LINE,'(''input F000 ='',G16.4)') F000
            CALL MSGDOC(MDOC,LINE)
            IFIRST=1
          ENDIF
C -----
        ENDIF
C---------------
        REWIND MTIN
        IF(MTF .GT.0) REWIND MTF
        IF(MTPH.GT.0) REWIND MTPH
        M   = 99
        ITP = 'FF  '
        CALL OPFILE(M,MTIN,NAMEF1,ITP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-F_1.')
          CLOSE(MTIN)
          IF(MTF.GT.0)   CLOSE(MTF)
          IF(MTPH.GT.0)  CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(MTF.GT.0) THEN
          ITP2 = 'FF  '
          CALL OPFILE(M,MTF,NAMEF2,ITP2,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: FILE-F_2.')
            CLOSE(MTIN)
            IF(MTF.GT.0)   CLOSE(MTF)
            IF(MTPH.GT.0)  CLOSE(MTPH)
            IF(MTOUT.GT.0) CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF
        IF(MTPH.GT.0) THEN
          ITPH='PH  '
          CALL OPFILE(M,MTPH,NAMEPH,ITPH,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: FILE-PH')
            CLOSE(MTIN)
            IF(MTF.GT.0)   CLOSE(MTF)
            IF(MTPH.GT.0)  CLOSE(MTPH)
            IF(MTOUT.GT.0) CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF
        IEND =-1
        IENDF=-1
        IENDP=-1
        LL=-1
        LK=0
        LH=0
        LLF=-1
        LKF=0
        LHF=0
C----------------------------------------------------------------
  300   CONTINUE

        IF(IEND.GT.0) GO TO 200
        IF(ITP.EQ.'F   ') THEN
          CALL RD1(MTIN,IH(1),IK(1),IL(1),AP,BP,NUMB,IEND)
C         SIG-DUMMY
          SAP=0.04*AP
          SBP=0.04*BP
        ELSE
          CALL RRD1(MTIN,IH(1),IK(1),IL(1),AP,BP,SAP,SBP
     *   ,NUMB,IEND)
          IF(SAP.LT.0.000001) SAP=0.04*AP
          IF(SBP.LT.0.000001) SBP=0.04*BP
        ENDIF
        IF(AP.GT.1.E-6.AND.BP.GT.1.E-6) THEN
          WT1=1./(SAP*SAP)
          WT2=1./(SBP*SBP)
          WT =WT1+WT2
          AP =AP*WT1+BP*WT2
          AP =AP/WT
          SAP=1./SQRT(WT)
        ELSE IF(BP.GT.1.E-6) THEN
          AP =BP
          SAP=SBP
        ENDIF
        IF(MTIN.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-F_1')
          CLOSE(MTIN)
          IF(MTF.GT.0)   CLOSE(MTF)
          IF(MTPH.GT.0)  CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0) GO TO 200
C ----------------------------------
C       USE F000
C
        IF(IH(1).EQ.0.AND.IK(1).EQ.0.AND.IL(1).EQ.0) THEN

          IF(MSG.EQ.'Y')THEN
            IF(LAP.EQ.'Y') GO TO 300
            IF(MTF.GT.0)   GO TO 300
            TEMP=AP*SCALE
            IF(MTPH.LE.0) THEN
              TEMP = TEMP*TEMP
            ENDIF
            F000 = TEMP/(VOL)
            TEMP = F000
            SM   = CMPLX(TEMP,ZERO)
            POOL(1)=SM
C ---
            IF(IFIRST.EQ.0) THEN
              WRITE(LINE,'('' F000 ='',G16.4)') F000
              CALL MSGDOC(MDOC,LINE)
              IFIRST=1
            ENDIF
          ENDIF
          GO TO 300
        ENDIF
        CALL DSTAR_BL(IH(1),IK(1),IL(1),RSQ)
        RH=SQRT(RSQ)
        IF(RH.LT.RSMIN.OR.RH.GT.RSMAX) GO TO 300        

        IF(BOFF.GT.0.0) THEN
          BT=BOFF/4.0
          CBOFF=1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF=1.0
        ENDIF

        IF(BADD.GT.0.0) THEN
          BT=BADD/4.0
          CBADD=EXP(-BT*RSQ)
        ELSE
          CBADD=1.0
        ENDIF
C
  550   IF(IEND.GT.0.OR.IENDF.GT.0) GO TO 200
        IF(MTF.LE.0) GO TO 360

c        IF(LLF-IL(1)) 370,340,300
c  340   IF(LKF-IK(1)) 370,350,300
c  350   IF(LHF-IH(1)) 370,360,300

        IF(LLF.LT.IL(1)) GO TO 370
        IF(LLF.GT.IL(1)) GO TO 300
        IF(LKF.LT.IK(1)) GO TO 370
        IF(LKF.GT.IK(1)) GO TO 300
        IF(LHF.LT.IH(1)) GO TO 370
        IF(LHF.GT.IH(1)) GO TO 300
        GO TO 360
 
  370   IF(IENDF.GT.0) GO TO 200
        IF(ITP2.EQ.'F   ') THEN
          CALL RD2(MTF,LHF,LKF,LLF,AD,BD,NUMBF,IENDF)
C         SIG-DUMMY
          SAD=0.04*AD
          SBD=0.04*BD
        ELSE
          CALL RRD2(MTF,LHF,LKF,LLF,AD,BD,SAD,SBD,NUMBF,IENDF)
          IF(SAD.LT.0.000001) SAD=0.04*AD
          IF(SBD.LT.0.000001) SBD=0.04*BD
        ENDIF
        IF(AD.LE.1.E-6.AND.BD.LE.1.E-6) GO TO 370
        IF(AD.GT.1.E-6.AND.BD.GT.1.E-6) THEN
          WT1=1./(SAD*SAD)
          WT2=1./(SBD*SBD)
          WT =WT1+WT2
          AD =AD*WT1+BD*WT2
          AD =AD/WT
          SAD=1./SQRT(WT)
        ELSE IF(BD.GT.1.E-6) THEN
          AD =BD
          SAD=SBD
        ENDIF
        IF(MTF.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-F_2')
          CLOSE(MTIN)
          IF(MTF.GT.0)   CLOSE(MTF)
          IF(MTPH.GT.0)  CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        GO TO 550
 360    CONTINUE
C ---------------------------
        AP =AP *CBOFF*CBADD
        SAP=SAP*CBOFF*CBADD

        AD =AD *CBOFF*CBADD
        SAD=SAD*CBOFF*CBADD
C ----------------------
  
        IF(MTPH.GT.0) THEN
C         READ PHASE FOR THIS REFL.
C
  500     CONTINUE
          IF(IENDP.GT.0) GO TO 200

C          IF(LL-IL(1)) 2030,2010, 300
C 2010     IF(LK-IK(1)) 2030,2020, 300
C 2020     IF(LH-IH(1)) 2030,2000, 300

          IF(LL.LT.IL(1))  GO TO 2030
          IF(LL.GT.IL(1))  GO TO 300
          IF(LK.LT.IK(1))  GO TO 2030
          IF(LK.GT.IK(1))  GO TO 300
          IF(LH.LT.IH(1))  GO TO 2030
          IF(LH.GT.IH(1))  GO TO 300
          GO TO 2000

 2030     CONTINUE
          CALL RD3(MTPH,LH,LK,LL,COPH,SIPH,NUMBPH,IENDP)
          GO TO 500
        ENDIF
 2000   CONTINUE
C ------------------------
        IF(MTF.GT.0) THEN
          AP =AD*SCALE-AP
          SAP=SQRT(ABS(SAP*SAP+SAD*SAD*SCALE*SCALE))
        ENDIF
        IF(LAP.EQ.'Y') THEN
          IF(MTPH.GT.0) THEN
            FAA  = AP  *(RSQ)*FOURPI2
            FA(1)= FAA*COPH
            FB(1)= FAA*SIPH
          ELSE
            FA(1)= (AP*AP)      *(RSQ)*FOURPI2
            FB(1)= (2.0*AP*SAP) *(RSQ)*FOURPI2
          ENDIF
        ELSE
          IF(MTPH.GT.0) THEN
            FA(1)= AP*COPH
            FB(1)= AP*SIPH
          ELSE
            FA(1)=AP*AP
            FB(1)=2.0*AP*SAP
          ENDIF
        ENDIF
        FA(1)=FA(1)/(VOL)
        FB(1)=FB(1)/(VOL)
C ----------------------
        CALL GENER(IPATT,N,IH,IK,IL,FA,FB,NSYM,ISYM,IPRSYM)
C ------------------------
        DO     I=1,N
          JH =IH(I)
          JK =IK(I)
          JL =IL(I)
          FAA=FA(I)
          FBB=FB(I)
C         WRITE(*,'('' H,K,L,A,B:'',3I5,2F12.4)') JH,JK,JL,FAA,FBB
          IF(IABS(JL).LE.ILMAX.AND.
     *       IABS(JK).LE.IKMAX.AND.
     *       IABS(JH).LT.IHMAX     ) THEN
            IHD=JH+1
            IF(JK.LT.0) JK=NY+JK
            IKD=JK+1
            ILD=IABS(JL)+1
            IF(ILD.LE.512) THEN
              PCOS=CZL(ILD)
              PSIN=SZL(ILD)
              IF(JL.LT.0 ) PSIN=-PSIN
              AP = FAA * PCOS + FBB * PSIN
              BP = FBB * PCOS - FAA * PSIN
              SM=CMPLX(AP,BP)
              IND=(IKD-1)*NX2+IHD
              POOL(IND)=POOL(IND)+SM
            ENDIF
          ENDIF
        ENDDO
        GO TO 300
C--------------------------------------------
  200   CONTINUE
        CALL MDHFT(POOL,IDIM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: IN KERNEL-FFT')
          CLOSE(MTIN)
          IF(MTF.GT.0)   CLOSE(MTF)
          IF(MTPH.GT.0)  CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        CALL VLD_SECT_EXT(MDOC,MTOUT
     *               ,IPATT,ASYM,POOL,NX,NY,NZ,IZ,NSYM,ISYM,IERR)
C--------------------------------------------------------------
        IF(MTOUT.GT.0) THEN
          
          IF(MTC.LE.0) THEN

            CALL WDENS(MTOUT,MDOC,ICNTZ,NX,NY,NZ,IZWMIN,IZWMAX
     *               ,RMAX,RMIN,POOL,RESMAX,IX0,IY0,IZ0,ITR)
            IF(MTOUT.LE.0) THEN
              CALL MSGERR(MDOC,' ERR: FILE-DENS')
              CLOSE(MTIN)
              IF(MTF.GT.0)   CLOSE(MTF)
              IF(MTPH.GT.0)  CLOSE(MTPH)
              IF(MTOUT.GT.0) CLOSE(MTOUT)
              IERR=1
              RETURN
            ENDIF

          ELSE

            CALL EXTR_DENS(POOL,NX,NY,POOLW,MX,MY,IXWMIN,IYWMIN)

            CALL WDENS(MTOUT,MDOC,ICNTZ,MX,MY,MZ,IZWMIN,IZWMAX
     *               ,RMAX,RMIN,POOLW,RESMAX
     *               ,IXWMIN,IYWMIN,IZWMIN,ITRANS)

            IF(MTOUT.LE.0) THEN
              CALL MSGERR(MDOC,' ERR: FILE-DENS')
              CLOSE(MTIN)
              IF(MTF.GT.0)   CLOSE(MTF)
              IF(MTPH.GT.0)  CLOSE(MTPH)
              IF(MTOUT.GT.0) CLOSE(MTOUT)
              IERR=1
              RETURN
            ENDIF

          ENDIF
        ENDIF
      ENDDO

      CALL SET_DINF_EXT(MDOC,IPATT,VOL,NX,NY,NZ,RESULT,IPRROW,IERR)
C------------------------------------------------------------------
C      ICPU=1
C      CALL CPU(ICPU)
C ------------------------------------
      CLOSE(MTIN)
      IF(MTF.GT.0)   CLOSE(MTF)
      IF(MTPH.GT.0)  CLOSE(MTPH)
      IF(MTOUT.GT.0) CLOSE(MTOUT)
      RETURN
      END
      
      SUBROUTINE EXTR_DENS(POOL,NX,NY,POOLW,MX,MY,IXWMIN,IYWMIN)
      REAL     POOL(*),POOLW(*)
C ---------------------------------
            DO JY=1,MY
              JND0 =(JY-1)*MX
              IY=(JY-1)+IYWMIN
 10           CONTINUE
              IF(IY.LT.0) THEN
                IY=IY+NY
                GO TO 10 
              ENDIF 
 20           CONTINUE
              IF(IY.GE.NY) THEN
                IY=IY-NY
                GO TO 20 
              ENDIF 
              IY=IY+1
              IND0 =(IY-1)*NX
              DO JX=1,MX
                JND =JND0+JX
                IX=(JX-1)+IXWMIN
 30             CONTINUE
                IF(IX.LT.0) THEN
                  IX=IX+NX
                  GO TO 30 
                ENDIF 
 40             CONTINUE
                IF(IX.GE.NX) THEN
                  IX=IX-NX
                  GO TO 40 
                ENDIF 
                IX=IX+1
                IND =IND0+IX
                POOLW(JND)=POOL(IND)
              ENDDO
            ENDDO

      RETURN
      END

      SUBROUTINE VLD_SECT_EXT(MDOC,MTOUT
     * ,IPATT,ASYM,POOL1,NX1,NY1,NZ1,IZ,NSYM,ISYM,IERR)
C --------------------------------------------------------------------
CMS      : POOL1
      REAL POOL1(*)
      INTEGER*2 ISYM(5,3,*)
C --------------------------------------------------------------
      CHARACTER LINE*80,ASYM*1
C ----------------------------------------------------------------------
      COMMON/COM_VLD/ DMAX1T,DMIN1T,SUM1,SUM21,NUMB1,NPOS,NNEG,NZER
     * ,SUMP,SUMN,SUMP2,SUMN2,SUM31,SUM41,P000
C ----------------------------------------------------------------------
      REAL      XS(3),XT(3),AX(3)
      EQUIVALENCE (X,XS(1)),(Y,XS(2)),(Z,XS(3))
C-----------------------------------------------
        DMAX1=-1.E30
        DMIN1= 1.E30
        IXN=0
        IYN=0
        IXM=0
        IYM=0
        Z=IZ/FLOAT(NZ1)
        DO     IY=1,NY1
          Y=(IY-1)/FLOAT(NY1)
          IND0 =(IY-1)*NX1
          DO     IX=1,NX1
            X=(IX-1)/FLOAT(NX1)
            IND =IND0+IX
            D1=POOL1(IND)
            IT=1
            NN=1
C ---
            IF(ASYM.EQ.'Y') THEN
              IF(IPATT.NE.1) THEN
                DO     I=2,NSYM
                  DO     J=1,3
                    IF(ISYM(5,J,I).EQ. 0) ISYM(5,J,I)=1
                    XT(J)=ISYM(4,J,I)/REAL(ISYM(5,J,I))
                    DO     K=1,3
                      XT(J)=XT(J)+ISYM(K,J,I)*XS(K)
                    ENDDO
                  ENDDO
                  DO     J=1,3
                    T=ABS(XT(J))
                    IAX=T
                    AX(J)=T-IAX
                    IF(XT(J).LT.0) AX(J)=1.-AX(J)
                    IF(AX(J).GE.1.0) AX(J)=0.
                    AX(J)=XS(J)-AX(J)
                    IF(ABS(AX(J)).LT.1.E-5) AX(J)=0.
                  ENDDO
C                  IF(AX(3)) 160,150,140
C 150              IF(AX(2)) 160,151,140
C 151              IF(AX(1)) 160,152,140

                  IF(AX(3).LT.0.0) GO TO 160
                  IF(AX(3).GT.0.0) GO TO 140
                  IF(AX(2).LT.0.0) GO TO 160
                  IF(AX(2).GT.0.0) GO TO 140
                  IF(AX(1).LT.0.0) GO TO 160
                  IF(AX(1).GT.0.0) GO TO 140

 152              CONTINUE
                  NN=NN+1
                  GO TO 160
 140              CONTINUE
                  IT=0
                  GO TO 170
 160              CONTINUE
                ENDDO
 170            CONTINUE
              ELSE
                DO     I=2,NSYM
                  DO     J=1,3
                    XT(J)=0.0
                    DO     K=1,3
                      XT(J)=XT(J)+ISYM(K,J,I)*XS(K)
                    ENDDO
                  ENDDO
                  DO     J=1,3
                    T=ABS(XT(J))
                    IAX=T
                    AX(J)=T-IAX
                    IF(XT(J).LT.0) AX(J)=1.-AX(J)
                    IF(AX(J).GE.1.0) AX(J)=0.
                    AX(J)=XS(J)-AX(J)
                    IF(ABS(AX(J)).LT.1.E-5) AX(J)=0.
                  ENDDO
C                  IF(AX(3)) 260,250,240
C 250              IF(AX(2)) 260,251,240
C 251              IF(AX(1)) 260,252,240

                  IF(AX(3).LT.0.0) GO TO 260
                  IF(AX(3).GT.0.0) GO TO 240
                  IF(AX(2).LT.0.0) GO TO 260
                  IF(AX(2).GT.0.0) GO TO 240
                  IF(AX(1).LT.0.0) GO TO 260
                  IF(AX(1).GT.0.0) GO TO 240

 252              CONTINUE
                  NN=NN+1
                  GO TO 260
 240              CONTINUE
                  IT=0
                  GO TO 270
 260              CONTINUE
                ENDDO
 270            CONTINUE
              ENDIF
            ENDIF
C ---
            IF(IT.LE.0) GO TO 100
            D1=D1/FLOAT(NN)
            IF(IZ.EQ.0.AND.(IX-1).EQ.0.AND.(IY-1).EQ.0) THEN
              P000=D1
            ENDIF
            IF(DMAX1.LE.D1) THEN
              DMAX1=D1
              IXM=IX-1
              IYM=IY-1
            ENDIF
            IF(DMIN1.GE.D1) THEN
              DMIN1=D1
              IXN=IX-1
              IYN=IY-1
            ENDIF
            IF(DMAX1T.LE.D1) DMAX1T=D1
            IF(DMIN1T.GE.D1) DMIN1T=D1
            NUMB1=NUMB1 +1
            SUM1 =SUM1  +D1
            SUM21=SUM21 +D1*D1
            SUM31=SUM31 +D1*D1*D1
            SUM41=SUM41 +D1*D1*D1*D1
            IF(D1.GT.0.0) THEN
              NPOS=NPOS+1
              SUMP=SUMP+D1
              SUMP2=SUMP2+D1*D1
            ELSE IF(D1.LT.0.0) THEN
              NNEG=NNEG+1
              SUMN=SUMN+D1
              SUMN2=SUMN2+D1*D1
            ELSE
              NZER=NZER+1
            ENDIF
 100        CONTINUE
          ENDDO
        ENDDO
        IF(MTOUT.LE.0) THEN
          WRITE(LINE,10) IXM,IYM,IZ,DMAX1,IXN,IYN,IZ,DMIN1
          CALL MSGDOC(MDOC,LINE)
   10     FORMAT(1X,3I4,1X,G12.4,' , ',3I4,1X,G12.4)
        ENDIF
C ----------------------------------------------------------
      RETURN
      END

      SUBROUTINE SET_DINF_EXT(MDOC,IPATT,VOL,NX,NY,NZ
     * ,RESULT,IPRROW,IERR)
C --------------------------------------------------------------------
      REAL      RESULT(IPRROW,*)
C --------------------------------------------------------------
      CHARACTER LINE*80,ITP*4
C ----------------------------------------------------------------------
      COMMON/COM_VLD/ DMAX1T,DMIN1T,SUM1,SUM21,NUMB1,NPOS,NNEG,NZER
     * ,SUMP,SUMN,SUMP2,SUMN2,SUM31,SUM41,P000
C ----------------------------------------------------------------------
      COEF=(VOL)/(NX*NY*NZ)

      SUM1 =SUM1 *COEF
      SUM21=SUM21*COEF
      SUMP =SUMP *COEF
      SUMN =SUMN *COEF
      SUMP2=SUMP2*COEF
      SUMN2=SUMN2*COEF
      SUM31=SUM31*COEF
      SUM41=SUM41*COEF
      CFVOL=(VOL*NUMB1)/(NX*NY*NZ)

      AVER1 =SUM1 /CFVOL
      AVER21=SUM21/CFVOL
      RMS1  =SQRT(ABS((AVER21-AVER1*AVER1)))
      IF(RMS1.GT.0.00000001) THEN
        AMOM31=SUM31/(CFVOL*RMS1*RMS1*RMS1)
        AMOM41=SUM41/(CFVOL*RMS1*RMS1*RMS1*RMS1)
      ELSE
        AMOM31=0.0
        AMOM41=0.0
      ENDIF
c      AVER1=SUM1/NUMB1
c      RMS1=SQRT(ABS((SUM21+NUMB1*AVER1*AVER1-2.0*AVER1*SUM1)/NUMB1))
c      AMOM31=SUM31/(NUMB1*RMS1*RMS1*RMS1)
c      AMOM41=SUM41/(NUMB1*RMS1*RMS1*RMS1*RMS1)

      WRITE(LINE,20)
   20 FORMAT(' ---------------------')
      CALL MSGDOC(MDOC,LINE)


      WRITE(LINE,50) NUMB1,RMS1
   50 FORMAT(' NUMB, RMS:',I12,G18.5)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,30) AVER1,DMAX1T,DMIN1T
   30 FORMAT(' <D>,RMAX,RMIN:',3G18.5)
      CALL MSGDOC(MDOC,LINE)

      IF(IPATT.EQ.1) THEN
        WRITE(LINE,31) P000
 31     FORMAT(' Patterson(000) :',G18.5)
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      WRITE(LINE,55) AMOM31,AMOM41
 55   FORMAT(' Moment_3, Moment_4:',2G18.5)
      CALL MSGDOC(MDOC,LINE)

      AVERP=0.0
      IF(NPOS.GT.0) THEN
        CF=(VOL*NPOS)/(NX*NY*NZ)
        AVERP=SUMP/CF
      ENDIF
      WRITE(LINE,80) NPOS,AVERP
   80 FORMAT(' NUMB D>0 , <D> :',I10,G18.5)
      CALL MSGDOC(MDOC,LINE)
      AVERN=0.0
      IF(NNEG.GT.0) THEN
        CF=(VOL*NNEG)/(NX*NY*NZ)
        AVERN=SUMN/CF
      ENDIF
      WRITE(LINE,82) NNEG,AVERN
   82 FORMAT(' NUMB D<0 , <D> :',I10,G18.5)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,84) NZER
   84 FORMAT(' NUMB D=0 :',I10)
      CALL MSGDOC(MDOC,LINE)
      NUMB1P=NPOS+NZER
      RMSP =0.0
      RMSN =0.0
      AVERN0=0.0
      AVERP0=0.0
      IF(NUMB1P.GT.0) THEN
        CF=(VOL*NUMB1P)/(NX*NY*NZ)
        AVERP0=SUMP /CF
        SUMP2 =SUMP2/CF
        RMSP =
     *  SQRT(ABS((SUMP2-AVERP0*AVERP0)))
      ENDIF
      NUMB1N=NNEG+NZER
      IF(NUMB1N.GT.0) THEN
        CF=(VOL*NUMB1N)/(NX*NY*NZ)
        AVERN0=SUMN/CF
        SUMN2=SUMN2/CF
        RMSN =
     *  SQRT(ABS((SUMN2-AVERN0*AVERN0)))
      ENDIF
      IF(RMSN.GT.0.0000001) THEN
        RPN=RMSP/RMSN
      ELSE
        RPN=0.0
      ENDIF
      WRITE(LINE,90) RMSP,AVERP0,RPN
   90 FORMAT(' for D >= 0 : RMS,<D> :',3G14.5)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,92) RMSN,AVERN0
   92 FORMAT(' for D = <0 : RMS,<D> :',2G14.5)
      CALL MSGDOC(MDOC,LINE)

      RESULT(1,1) = NUMB1
      RESULT(2,1) = DMAX1T
      RESULT(3,1) = DMIN1T
      RESULT(4,1) = RMS1
      RESULT(5,1) = AVER1
      RESULT(6,1) = NPOS
      RESULT(7,1) = NNEG
      RESULT(8,1) = RMSP
      RESULT(9,1) = RMSN
      RESULT(10,1) = AVERP0
      RESULT(11,1) = AVERN0
      IF(IPRROW.GE.15) THEN
        RESULT(12,1) = AMOM31
        RESULT(13,1) = AMOM41
        RESULT(14,1) = P000
        RESULT(15,1) = NZER
      ENDIF    
      RETURN
      END


C -I-
      SUBROUTINE EXTRACT_CRD_LIM(MDOC,NAME1
     *,RESULT,ISYM,IPRSYM,IERR)
C --------------------------------------
C -I-
C --------------------------------------
      INTEGER   MDOC,IERR
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(*)
      CHARACTER NAME1*(*)
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of atom from the file.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C --------------
C -------------------------------------------------------------------
      INTEGER   MODE,NSYM
      REAL      X(3),Y(3),Z(3)
      CHARACTER LINE*80
C=====================================================================
      IERR=0
      PI=4.0*ATAN(1.0)
      XS=0.
      YS=0.
      ZS=0.
      XS2=0.
      YS2=0.
      ZS2=0.
      XMAX=-1.E 30
      YMAX=-1.E 30
      ZMAX=-1.E 30
      XMIN= 1.E 30
      YMIN= 1.E 30
      ZMIN= 1.E 30
      XFMIN= 1.E 30
      YFMIN= 1.E 30
      ZFMIN= 1.E 30
      XFMAX=-1.E 30
      YFMAX=-1.E 30
      ZFMAX=-1.E 30
C -----------------------------------------------------------------
      MD =-ABS(MDOC)-1
      M  = 99
      IN = 11
      CALL ORCRD(MD,IN,NAME1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT_FILE')
        CLOSE(IN) 
        RETURN
      ENDIF
C -------------------------------------------
      CALL C_AT_CR
      NA   = 0
      NTOT = 0
      IEND =-1
      IENDW=-1
C ----------------------
 200  CONTINUE
        CALL RDCRD(M,IN,MODE,IEND,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ INPUT_FILE')
          CLOSE(IN)
          RETURN
        ENDIF
        IF(IEND.NE.0) GO TO 300
        IF(MODE.EQ.0) THEN
          X(1)=CR_XYZ(1)
          X(2)=CR_XYZ(2)
          X(3)=CR_XYZ(3)
          NA=NA+1

          IF((CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *        CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *        CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R').AND.
     *        CR_OCC .GT.0.0001                        ) THEN

            IF(X(1).GT.XMAX) XMAX=X(1)
            IF(X(2).GT.YMAX) YMAX=X(2)
            IF(X(3).GT.ZMAX) ZMAX=X(3)
            IF(X(1).LT.XMIN) XMIN=X(1)
            IF(X(2).LT.YMIN) YMIN=X(2)
            IF(X(3).LT.ZMIN) ZMIN=X(3)
            XS=XS+X(1)
            YS=YS+X(2)
            ZS=ZS+X(3)
            XS2=XS2+X(1)*X(1)
            YS2=YS2+X(2)*X(2)
            ZS2=ZS2+X(3)*X(3)
            NTOT=NTOT+1

          ENDIF

        ELSE


        ENDIF

      GO TO 200
C ---------------------------------------------------------
  300 CONTINUE
      WRITE(LINE,'('' NUMBER OF COORDS :'',I6)') NTOT
      CALL MSGDOC(MDOC,LINE)
      CLOSE(IN)
      IF(NTOT.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS = 0')
        IERR=1
        RETURN
      ENDIF

        XS=XS/NTOT
        YS=YS/NTOT
        ZS=ZS/NTOT
        XS2=XS2/NTOT
        YS2=YS2/NTOT
        ZS2=ZS2/NTOT
        WRITE(LINE,'('' X :'',2F10.3)') XMIN,XMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Y :'',2F10.3)') YMIN,YMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Z :'',2F10.3)') ZMIN,ZMAX
        CALL MSGDOC(MDOC,LINE)
        RAD=(XMAX-XMIN)
        RT =(YMAX-YMIN)
        IF(RAD.LT.RT) RAD=RT
        RT =(ZMAX-ZMIN)
        IF(RAD.LT.RT) RAD=RT
        WRITE(LINE,'('' SIZE_max :'',F10.3)') RAD
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' CENTRE OF COORDS :'',3F10.3)') XS,YS,ZS
        CALL MSGDOC(MDOC,LINE)
        RX=XS2-XS*XS
        RY=YS2-YS*YS
        RZ=ZS2-ZS*ZS
        RI=SQRT(RX+RY+RZ)
        WRITE(LINE,'('' Radius of inertia :'',F10.3)') RI
        CALL MSGDOC(MDOC,LINE)


      RESULT(1) = NTOT
      RESULT(2) = XMIN
      RESULT(3) = XMAX
      RESULT(4) = YMIN
      RESULT(5) = YMAX
      RESULT(6) = ZMIN
      RESULT(7) = ZMAX
      RESULT(8) = XS
      RESULT(9) = YS
      RESULT(10)= ZS
      RESULT(11)= RI

      X(1) = XMIN -5.0
      X(2) = YMIN -5.0
      X(3) = ZMIN -5.0
      CALL MVMULT(CR_ORT_TO_FRAC,X,Y)
      IF(Y(1).LT.XFMIN) XFMIN=Y(1)     
      IF(Y(2).LT.YFMIN) YFMIN=Y(2)     
      IF(Y(3).LT.ZFMIN) ZFMIN=Y(3)     

      X(1) = XMAX +5.0
      X(2) = YMAX +5.0
      X(3) = ZMAX +5.0
      CALL MVMULT(CR_ORT_TO_FRAC,X,Y)
      IF(Y(1).GT.XFMAX) XFMAX=Y(1)     
      IF(Y(2).GT.YFMAX) YFMAX=Y(2)     
      IF(Y(3).GT.ZFMAX) ZFMAX=Y(3)     

      RESULT(12) = XFMIN
      RESULT(13) = XFMAX
      RESULT(14) = YFMIN
      RESULT(15) = YFMAX
      RESULT(16) = ZFMIN
      RESULT(17) = ZFMAX
C -------------------------------------------
      RETURN
      END

C -I-
      SUBROUTINE FFT(MDOC,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEC
     * ,NAMED,MEMORY,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P- FFT  : fast fourie transform: complex --> real.
C            Program applies coefficients supplied by COEF or TRPACK
C            to produce density map. For all space groups.
C -S-
C      Dialog and Batch:
C    
C    FILE_C:  name of input coef-file.
C    FILE_D:  name of output dens-file.
C    GRID:    NX,NY,NZ  - grid spacing. Default are the values 
C                 suitable for calculation of structure factors.
C    LIMZ:    MIN MAX numbers of Z-section /default for SF calculation/
C    F000:    <0.0>  - don"t use F000
C              > 0   - use this value
C              < 0   - use value from FILE_coef
C
C      SUBROUTINE FFT(MDOC,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEC
C     *              ,NAMED,MEMORY,ISYM,IPRSYM,IERR)
C
C      Parameters of subroutine FFT:
C
C      MDOC     - mode of writting messages to DOC-file
C                0 - only terminal , < - 0 only file, 0 < < 99 - both
C                >= 99 - don't write  
C      NAMEC    - name of input coef-file.
C      NAMED    - name of output dens-file.
C      NX,NY,NZ - numbers of points of grid corresponding axises X,Y,Z
C                 if NX=NY=NZ=0 program will define minimal values 
C                 suitable for calculation structure factors.
C      IZMIN,IZMAX - serial numbers for first and last Z-section
C                    of electron density.
C                    <0,-1> mean default for SF calculation.
C      F000:  <0.0>   - value of F(0,0,0)
C               > 0   - use this value
C               < 0   - use value from input coef_file.
C      POOL   - real array POOL(MEMORY) for
C               one Z-section of electron density NX x NY < MEMORY.
C      MEMORY - dimension of real array POOL.
C      ISYM   - integer*2 array for cryst.symmetry operators 
C      IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM)
C               We need not to define contents of array ISYM
C               Here is only reservation of memory.
C      IERR   - signal of error / =1 -error , =o - OK / 
C -I-
C ---------------------------------------------
CMS      : POOL
      REAL      POOL(MEMORY)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*4 MDOC,MEMORY,IPRSYM,IERR
      CHARACTER NAMEC*(*),NAMED*(*)
      REAL      F000
      INTEGER*4 NX,NY,NZ,IZMIN,IZMAX
C --------------
      IERR=0
      NCRES=MEMORY-IPRSYM*5
      IF(NCRES.LE.1) THEN
        CALL MSGERR(MDOC,' ERR: NOT MEMORY')
        IERR=1
      ENDIF
      I0=NCRES+1
      NCRES2=NCRES/2

C -----------
      CALL SFFT(MDOC,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEC
     * ,NAMED,NCRES2,ISYM,POOL(I0),POOL(IPRSYM+I0),POOL(IPRSYM*2+I0)
     * ,POOL(IPRSYM*3+I0),POOL(IPRSYM*4+I0),IPRSYM,IERR)
C -----------
      RETURN
      END

      SUBROUTINE SFFT(MDOC,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEC
     * ,NAMED,NCRES2,ISYM,IH,IK,IL,FA,FB,IPRSYM,IERR)
C ---------------------------------------------
CMS      : POOL
      COMPLEX   POOL(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*4 IH(IPRSYM),IK(IPRSYM),IL(IPRSYM)
      INTEGER*4 NX,NY,NZ,IZMIN,IZMAX
      INTEGER*4 MDOC,NCRES2,IPRSYM,IERR
      REAL      F000,FA(IPRSYM),FB(IPRSYM)
      CHARACTER NAMEC*(*),NAMED*(*)
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
C --------------
      INTEGER*4 IDIM(3)
      COMPLEX   CDM,SM
      REAL      RLATT(6)
      REAL      CZL(512),SZL(512)
      CHARACTER TITLE*80,ITP*4,LINE*80,MSG*1
C ==============================================================
      IERR=0
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
C --------------------
C      WRITE(*,'(''       INPUT-FILE /COEF/'')')
      MTIN  =25
      ITP   ='COEF'
      MD=-ABS(MDOC)-1
      CALL ORFILE(MD,MTIN,NAMEC,ITP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-coef')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,F3,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)


      IF(TITLE(5: 8).EQ.'TRNS'.OR.TITLE(5: 8).EQ.'REAL'.OR.
     *   TITLE(5: 8).EQ.'MULT'.OR.TITLE(5: 8).EQ.'PACK') THEN  
        NSYM=1
        NS_RD=1
        SG_RD='P 1'
      ENDIF      
      CALL C_RD_CR
C ----
      A    =RLATT(1)
      B    =RLATT(2)
      C    =RLATT(3)
      ALPHA=RLATT(4)
      BETA =RLATT(5)
      GAMMA=RLATT(6)
C ----
C     VOLUME OF CELL
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
C ----
      CALL LIMHKL(RX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----
      MD=-ABS(MDOC)-1
      CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
      WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000 FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,1020) IHMAX,IKMAX,ILMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MD,LINE)
      IF(NX.LE.0) NX=NXMIN
      IF(NY.LE.0) NY=NYMIN
      IF(NZ.LE.0) NZ=NZMIN
      NX   =(NX/2)*2
      NY   =(NY/2)*2
      NZ   =(NZ/2)*2
      IF(NX.LT.2*IHMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nx < 2Hmax+1')
      IF(NY.LT.2*IKMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Ny < 2Kmax+1')
      IF(NZ.LT.2*ILMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nz < 2Lmax+1')
      WRITE(LINE,1030) NX,NY,NZ
 1030 FORMAT('GRID: NX=',I3,', NY=',I3,', NZ=',I3) 
      CALL MSGDOC(MD,LINE)
      IF(ILMAX.LT.0)  ILMAX=0

c     IF(ILMAX.GT.99) ILMAX=99

      NX2  =NX/2
      NXY=NX*NY
      NCRES=NCRES2*2
      IF(NXY.GT.NCRES) THEN
        WRITE(LINE,
     * '('' ERR: not enough memory for one section of dens.'')')
        CALL MSGERR(MDOC,LINE)
        WRITE(LINE,'('' NX='',I4,'' NY='',I4,'' MEMORY-SIZE='',I6)')
     *                  NX,NY,NCRES
        CALL MSGERR(MDOC,LINE)
        WRITE(LINE,'('' must by: NX x NY < '',I6)') NCRES
        CALL MSGERR(MDOC,LINE)
        IERR=1
        CLOSE(MTIN)
        RETURN
      ENDIF
      NXY=NXY/2

      IIZMIN=0
      IIZMAX=0
      CALL SET_LIMZ(NSYM,ISYM,NZ,IZMAXD)
      IF(IZMIN.EQ.0.AND.IZMAX.LT.0) THEN
        IIZMIN=0
        IIZMAX=IZMAXD
        IF(IZMAX.LT.-1) IIZMAX = NZ/2 
      ELSE
        IIZMAX=IZMAX
        IIZMIN=IZMIN
        IF(IIZMAX.LT.IIZMIN) THEN
          T=IIZMAX
          IIZMAX=IIZMIN
          IIZMIN=T
        ENDIF
      ENDIF
      IZMIN=IIZMIN
      IZMAX=IIZMAX

      IF(F000.EQ.0.0) THEN
        MSG='N'
      ELSE IF(F000.GT.0.0) THEN
        MSG='I'
      ELSE
        MSG='Y'
      ENDIF
      IF(TITLE(1:4).EQ.'PATT') THEN
        IPATT=1
        ITP  ='PATT'
      ELSE
        IPATT=0
        ITP  ='FOUR'
      ENDIF
      TITLE(1:4)=ITP
C ----
C     WRITE(*,*) '      OUTPUT-FILE /DENS/'
      MTOUT=0
      CALL LENSTR_BL(NAMED,LEN)
      IF(LEN.GT.0.AND.NAMED(1:1).NE.' '.AND.NAMED(1:1).NE.',') THEN
        MTOUT =43
        ITP   ='RI  '
        MD=-ABS(MDOC)-1
        CALL C_CR_WR
        CALL SET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)

c        CALL WTITLE(MTOUT,NAMED,MDOC,ITP,IPRINT,A,B,C,ALPHA,BETA,
c     .  GAMMA,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE)

        CALL OWFILE(MD,MTOUT,NAMED,ITP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
          CLOSE(MTIN)
          CLOSE(MTOUT)
          RETURN
        ENDIF
      ELSE
        CALL MSGERR(MDOC,' ERR: OUTPUT-DENS-FILE')
        IERR=1
        CLOSE(MTIN)
        RETURN
      ENDIF
C ----
c      ICPU=0
c      CALL CPU(ICPU)
C ----
      ZERO  =0.0
      CDM   =CMPLX(ZERO,ZERO)
      ITP   ='    '
      IPRINT=0
      IX0   =0
      IY0   =0
      IZ0   =IZMIN
      ITR   =0
      ICNTZ =-999
      IDIM(1)=NX2
      IDIM(2)=NY
      IDIM(3)=0
      IFIRST=0
C =================================================
      DO     IZ=IZMIN,IZMAX
        Z=FLOAT(IZ)/FLOAT(NZ)
        ANG=TWOPI*Z
        CSZ=COS(ANG)
        SNZ=SIN(ANG)
        CZL(1)=1.0
        SZL(1)=0.0
        DO     I=2,512
          CZL(I)=CZL(I-1)*CSZ-SZL(I-1)*SNZ
          SZL(I)=SZL(I-1)*CSZ+CZL(I-1)*SNZ
        ENDDO
        DO     I=1,NXY
          POOL(I)=CDM
        ENDDO
        IF(MSG.EQ.'I') THEN
          TEMP=F000
          SM=CMPLX(TEMP,ZERO)
          POOL(1)=SM
C ---
          IF(IFIRST.EQ.0) THEN
            WRITE(LINE,'(''input F000 ='',G16.4)') F000
            CALL MSGDOC(MDOC,LINE)
            IFIRST=1
          ENDIF
C -----
        ENDIF
C---------------
        REWIND MTIN
        MD=99
        CALL OPFILE(MD,MTIN,NAMEC,ITP,NSYM,ISYM,IPRSYM,IERR)
C        CALL PTITLE(MTIN,NAMEC,MDOC,ITP,IPRINT,DM,DM,DM,DM,DM,DM,
C     *            F1,F2,F3,F4,IDM,IDM,IDM,IDM,IDM,TITLE)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-COEF')
          CLOSE(MTIN)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IEND=-1
C----------------------------------------------------------------
  300   CONTINUE
        CALL RD1(MTIN,IH(1),IK(1),IL(1),FA(1),FB(1),NUMB,IEND)
        IF(MTIN.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-COEF')
          CLOSE(MTIN)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0) GO TO 200
C ----------------------------------
C       USE F000
C
        IF(IH(1).EQ.0.AND.IK(1).EQ.0.AND.IL(1).EQ.0) THEN

          IF(MSG.EQ.'Y')THEN
            F000=FA(1)/(VOL)
            TEMP=F000
            SM=CMPLX(TEMP,ZERO)
            POOL(1)=SM
C ---
            IF(IFIRST.EQ.0) THEN
              WRITE(LINE,'('' F000 ='',G16.4)') F000
              CALL MSGDOC(MDOC,LINE)
              IFIRST=1
            ENDIF
          ENDIF
          GO TO 300
        ENDIF
C ------------------------
        FA(1)=FA(1)/(VOL)
        FB(1)=FB(1)/(VOL)
C ----------------------
        CALL GENER(IPATT,N,IH,IK,IL,FA,FB,NSYM,ISYM,IPRSYM)
C ------------------------
        DO     I=1,N
          JH =IH(I)
          JK =IK(I)
          JL =IL(I)
          FAA=FA(I)
          FBB=FB(I)
C         WRITE(*,'('' H,K,L,A,B:'',3I5,2F12.4)') JH,JK,JL,FAA,FBB
          IF(IABS(JL).LE.ILMAX.AND.
     *       IABS(JK).LE.IKMAX.AND.
     *       IABS(JH).LT.IHMAX     ) THEN
            IHD=JH+1
            IF(JK.LT.0) JK=NY+JK
            IKD=JK+1
            ILD=IABS(JL)+1
            IF(ILD.LE.512) THEN
              PCOS=CZL(ILD)
              PSIN=SZL(ILD)
              IF(JL.LT.0 ) PSIN=-PSIN
              AP = FAA * PCOS + FBB * PSIN
              BP = FBB * PCOS - FAA * PSIN
              SM=CMPLX(AP,BP)
              IND=(IKD-1)*NX2+IHD
              POOL(IND)=POOL(IND)+SM
            ENDIF
          ENDIF
        ENDDO
        GO TO 300
C--------------------------------------------
  200   CONTINUE
        CALL MDHFT(POOL,IDIM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: IN KERNEL-FFT')
          CLOSE(MTIN)
          CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
C--------------------------------------------------------------
        IF(MTOUT.GT.0) THEN
          CALL WDENS(MTOUT,MDOC,ICNTZ,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     *             ,POOL,RX,IX0,IY0,IZ0,ITR)
          IF(MTOUT.LE.0) THEN
            CALL MSGERR(MDOC,' ERR: FILE-DENS')
            CLOSE(MTIN)
            CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF
      ENDDO
C------------------------------------------------------------------
C      ICPU=1
C      CALL CPU(ICPU)
C ------------------------------------
      CLOSE(MTIN)
      IF(MTOUT.GT.0) CLOSE(MTOUT)
      RETURN
      END
      
C -I-
      SUBROUTINE RFT(MDOC,POOL,MEMORY,RESMAX
     * ,NAMED,NAMEF,NAMEPH,PATH_SCR,ISYM,IPRSYM,RESULT,IERR)
C ---------------------------------------------
C -P- RFT  : fast fourie transform: real --> complex.
C            Program transforms contents of DENS-file to F and PH files.
C            For all space groups.
C -S-
C      Dialog and Batch:
C
C      FILE_D:  -  name of input dens-file.
C      FILE_F:  -  name of output file of modules of SF
C      FILE_PH: -  name of output file of phases  of SF
C      RESOL:  MAX <default from DENS-file> resolution
C
C      It possible to use subroutine RFT by program:
C
C      SUBROUTINE RFT(MDOC,POOL,MEMORY,RESMAX
C     * ,NAMED,NAMEF,NAMEPH,ISYM,IPRSYM,RESULT,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAMED - name of input dens-file.
C              Symmetry operators will be taken from this file.
C      NAMEF - name of output file of modules of SF
C      NAMEPH- name of output file of phases  of SF
C      RESMAX - resolution. Default values from DENS-file.
C      POOL   - real array (MEMORY)
C      MEMORY - is dimension of real array POOL.
C               NCRES= (MEMORY-IPRSYM*9-2)/2 is memory for
C               the one Z-section of electron density NX x NY < NCRES.
C      ISYM  - integer*2 array for cryst.symmetry operators 
C      IPRSYM- dimension of integer*2 array ISYM(5,3,IPRSYM)
C      IERR  - signal of error / =1 -error , =o - OK / 
C
C      RESULT /real RESULT(11)/ - array for output information:
C
C      RESULT(1) - number of refls
C      RESULT(2) - min resolution
C      RESULT(3) - max resolution
C      RESULT(4) - F(0,0,0)
C      RESULT(5) - <!F!> = sqrt(<I>)
C      RESULT(6) - < I > 
C -I-
C ---------------------------------------------
CMS      : POOL
      REAL POOL(*)
      REAL RESULT(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMED*(*),NAMEF*(*),NAMEPH*(*),PATH_SCR*(*),NAME*256
C--------------------------------------------------------------
      IPRSM  = IPRSYM*9
      IPRSM0 = MEMORY-IPRSM+1
      NCRES  = (MEMORY-IPRSM-2)/2
      NCRESF = (MEMORY-IPRSM-2)/3
      IF(NCRES.LE.1) THEN
        CALL MSGERR(MDOC,' ERR: --- RFT --- NOT MEMORY')
        IERR=1
        RETURN
      ENDIF
      NAME = ' '
      CALL RFT1(MDOC,POOL(2),POOL(1),POOL(2),NCRES,RESMAX
     * ,NAMED,NAMEF,NAMEPH,IPRSYM
     * ,POOL(IPRSM0),POOL(IPRSM0+IPRSYM),POOL(IPRSM0+IPRSYM*2)
     * ,POOL(IPRSM0+IPRSYM*5),POOL(IPRSM0+IPRSYM*6)
     * ,POOL(IPRSM0+IPRSYM*7),POOL(IPRSM0+IPRSYM*8),ISYM
     * ,RESULT,IERR)
      IF(IERR.EQ.-1) THEN
        IERR=0
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          NAME = PATH_SCR(1:LEN)//'scratch_rft'
        ELSE
          NAME = 'scratch_rft'
        ENDIF
        CALL RFT2(MDOC,POOL(2),POOL(1),POOL(2),NCRES,RESMAX
     *  ,NAMED,NAMEF,NAMEPH,NAME,IPRSYM
     *  ,POOL(IPRSM0),POOL(IPRSM0+IPRSYM),POOL(IPRSM0+IPRSYM*2)
     *  ,POOL(IPRSM0+IPRSYM*5),POOL(IPRSM0+IPRSYM*6)
     *  ,POOL(IPRSM0+IPRSYM*7),POOL(IPRSM0+IPRSYM*8),ISYM
     *  ,POOL(NCRESF+1),POOL(NCRESF*2+1),NCRESF
     *  ,RESULT,IERR)
      ENDIF

      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.0) THEN
        MT   = 10
C       NAME = 'scratch_rft'
        OPEN(UNIT=MT,FILE=NAME,ACCESS='SEQUENTIAL',ERR=16)
        CLOSE(MT,STATUS='DELETE',ERR=16)
 16     CONTINUE
      ENDIF

      RETURN
      END

      SUBROUTINE RFT1(MDOC,POOL8,POOLA,POOLB,NCRES,RESMAX
     * ,NAMED,NAMEF,NAMEPH,IPRSYM
     * ,SFA,SFB,SYM,JHS,JKS,JLS,LSYM,ISYM
     * ,RESULT,IERR)
C ---------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   ID(3),IDT(7)
CMS      : POOL8,POOLA,POOLB
      REAL      RESULT(*)
      COMPLEX   POOL8(*)
      REAL      POOLA(*),POOLB(*)
      REAL      RLATT(6)
      REAL      SFA(IPRSYM),SFB(IPRSYM)
      INTEGER   JHS(IPRSYM),JKS(IPRSYM),JLS(IPRSYM),LSYM(IPRSYM)
      REAL      SYM(3,IPRSYM)
      CHARACTER LINE*80
      CHARACTER NAMED*(*),NAMEF*(*),NAMEPH*(*)
      CHARACTER TITLE*80,ITYPE*4,PATT*4
C--------------------------------------------------------------
      TWOPI =8.0*ATAN(1.0)
c     ierr # 0 iverted phases
      INVER = IERR
      IERR=0
C --------------------
      MTIN  =40
      ITYPE ='RI  '
      MD=-ABS(MDOC)-1
C     WRITE(*,*) '       INPUT-FILE /DENS/'
      ITYP  =0
      CALL IRDENS(MTIN,NAMED,MD,ITYP,ICNTZ,NX,NY,NZ,IZM,
     * IZN,RMAX,RMIN,POOLA,SCALE,A,B,C,AL,BE,GA,DRMS,
     * RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE
     * ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE--DENS')
        CLOSE(MTIN)
        IERR=1
        RETURN
      ENDIF
C      CALL ORFILE(MD,MTIN,NAMED,ITYPE,NSYM,ISYM,IPRSYM,IERR)
C      IF(IERR.NE.0) THEN
C        CALL MSGERR(MDOC,' ERR: OPEN FILE--DENS')
C        RETURN
C      ENDIF
C      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
C     *  ,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TITLE,IERR)
      CALL C_RD_CR
      NXY=NX*NY
      IF(IZN.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: IZMIN # 0')
        IERR=1
        RETURN
      ENDIF
      IF(NXY.GT.NCRES) THEN
        WRITE(LINE,'('' ERR: not memory '',I4,'' x'',I4,'' >'',I8)')
     *             NX,NY,NCRES
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(TITLE(1:4).EQ.'PATT') THEN
        PATT='Y'
      ELSE
        PATT='N'
      ENDIF
C  ------------------------------------
      RLATT(1)=A
      RLATT(2)=B
      RLATT(3)=C
      RLATT(4)=AL
      RLATT(5)=BE
      RLATT(6)=GA
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      M=99
      CALL ANOMF(M,NSYM,ISYM)
      IF(RESMAX.LT.1.E-4) RESMAX=RESOL
      DO     I=1,NSYM
        IT = ISYM(3,3,I) 
        IF(ISYM(3,1,I).NE.0.OR.ISYM(3,2,I).NE.0.OR.IABS(IT).NE.1) THEN
          IERR=-1
          CLOSE(MTIN)
          RETURN
        ENDIF
        DO     J=1,3
          SYM(J,I)=(TWOPI*ISYM(4,J,I))/FLOAT( ISYM(5,J,I))
        ENDDO
      ENDDO
C ---------------------------------------------------
      RHMIN=10.0
      IH=1
      IK=0
      IL=0
      CALL DSTAR_BL(IH,IK,IL,RH)
      RH=SQRT(RH)
      IF(RH.LT.RHMIN) RHMIN=RH
      IH=0
      IK=1
      IL=0
      CALL DSTAR_BL(IH,IK,IL,RH)
      RH=SQRT(RH)
      IF(RH.LT.RHMIN) RHMIN=RH
      IH=0
      IK=0
      IL=1
      CALL DSTAR_BL(IH,IK,IL,RH)
      RH=SQRT(RH)
      IF(RH.LT.RHMIN) RHMIN=RH
      RESMIN=1./RHMIN
C     WRITE(*,*) '      OUTPUT FILE-FMOD'
      MTF=30
      TITLE(1:4)='F   '
      ITYPE='F   '
      TITLE(5:8)='RFT '
      F1   =1.0
      F2   =0.0
      MD=MDOC
      CALL C_CR_WR
      CALL SET_TITLE(MD,A,B,C,
     *  AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      CALL OWFILE(MD,MTF,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE-F')
        CLOSE(MTIN)
        RETURN
      ENDIF
C      WRITE(*,*) '      OUTPUT FILE-PHAS'
      MTPH=33
      TITLE(1:4)='PH  '
      TITLE(5:8)='RFT '
      ITYPE='PH  '
      MD=-ABS(MDOC)-1
      CALL SET_TITLE(MD,A,B,C,
     *  AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      CALL OWFILE(MD,MTPH,NAMEPH,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE-PH')
        CLOSE(MTIN)
        CLOSE(MTF)
        RETURN
      ENDIF
C -------------------------------------------------------

      RHMAX=1./RESMAX
      WRITE(LINE,'('' RESOLUTION:'',F7.3)') RESMAX
      CALL MSGDOC(MDOC,LINE)
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,LMAX,NXMIN,NYMIN,NZMIN)
      CALL MSGDOC(MDOC,' For this resolution:')
      WRITE(LINE,1020) IHMAX,IKMAX,LMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,1021) NXMIN,NYMIN,NZMIN
 1021 FORMAT(' NXmin,NYmin,NZmin :',3I4)
      CALL MSGDOC(MDOC,LINE)
c      IHMAX  =(NX+2)/2
c      IKMAX  =(NY+2)/2
c      LMAX   =(NZ+2)/2
c      WRITE(LINE,1022) IHMAX,IKMAX,LMAX
c 1022 FORMAT(
c     * ' From NX,NY,NZ of dens-file Hmax,Kmax,Lmax are :',3I4)
c      CALL MSGDOC(MDOC,LINE)


      LMAX1 =LMAX+1
      NZ1   =IZM+1
      NX1   =NX+1
      NX2   =NX+2
      NXB2  =NX/2
      NYB2  =NY/2
      ZER   =0.0
      COEF  =(NX*NY*NZ)/(VOL)
      FMIN =0.0
C ------
      DELANG=TWOPI/FLOAT(NZ)
      DELSN =SIN(DELANG)
      DELCS =COS(DELANG)
      CSAN  =1.0
      SNAN  =0.0
C ------
      NBL  =0
      NBL11=0
      IENDN=-1
      IEND =-1
      IEND1=-1
      NUMB =0
C ---
      SUMF =0.
      SF2C =0.
C ---
      ID(1)=NX
      ID(2)=NY
      ID(3)=0
C ---
      N000 =0
C -----------------------------------
      CALL RDINDX(IHN,IKN,ILN,IHMAX,IKMAX,LMAX
     * ,RHMIN,RHMAX,NSYM,ISYM,IPRSYM,IENDN)
      IF(IENDN.EQ.1) GO TO 200
C ==============================================
      LINE=' '
      CALL MSGDOC(MDOC,LINE)
      DO     IL=1,LMAX1
C -------------------------------------
        CALL CLOCK(IDT)
        ILR=IL-1
        WRITE(LINE,'(''    L='',I5,10X,I2,''.'',I2,''.'',I2)')
     .           ILR,IDT(4),IDT(3),IDT(2)
        M=99         
        IF(MDOC.GE.0.AND.MDOC.LT.99) M=0
        CALL MSGDOC(M,LINE)
C ----------------------------
        CALL INDENS(MTIN,NAMED,NSYM,ISYM,IPRSYM
     *    ,NZ1,NXY,POOLA,POOLB,POOL8,CSAN,SNAN,
     *             DELCS,DELSN,MDOC,IERR)
        IF(IERR.GT.0) THEN
          CLOSE(MTIN)
          CLOSE(MTF)
          CLOSE(MTPH)
          RETURN
        ENDIF
C  ---------------------------
        CALL MDCFT2(POOL8,ID,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERR: IN MDCFT2')
          CLOSE(MTIN)
          CLOSE(MTF)
          CLOSE(MTPH)
          RETURN
        ENDIF
C -----------------------------------------------------
        IF(ILR.EQ.0) THEN
          F000=(POOLA(2)*NSYM)/(COEF)
          FMIN=F000*0.000001
          IF0=0
          MH=0
          MK=0
          ML=0
          FA=1.
          FB=0.
          CALL WRT (MTF ,MH,MK,ML,F000,ZER,NBL  ,IEND )
          CALL WRT1(MTPH,MH,MK,ML,FA  ,FB ,NBL11,IEND1)
          N000=1
        ENDIF
C------------------------------------------------------
  500   IF(ILN.LT.ILR) GO TO 400
        IF(ILN.GT.ILR) GO TO 300
        IF(IABS(IHN).GE.NXB2.OR.IABS(IKN).GE.NYB2) GO TO 400
        MH=IHN
        MK=IKN
        ML=ILN
        NS =0
C---------------
        DO     I=1,NSYM
          IHS=ISYM(1,1,I)*IHN+ISYM(1,2,I)*IKN+ISYM(1,3,I)*ILN
          IKS=ISYM(2,1,I)*IHN+ISYM(2,2,I)*IKN+ISYM(2,3,I)*ILN
          ILS=ISYM(3,1,I)*IHN+ISYM(3,2,I)*IKN+ISYM(3,3,I)*ILN
          LSYM(I)=1
          IF(ILS.LT.0) THEN
            IHS=-IHS
            IKS=-IKS
            ILS=-ILS
            LSYM(I)=-LSYM(I)
          ENDIF
C
          IF(IABS(IKS).GE.NYB2) GO TO 400
          IF(IABS(IHS).GE.NXB2) GO TO 400
C
c          IF(NS.GT.0) THEN
c            IF(ILS.EQ.0.AND.IKS.LT.0) THEN
c              IKS=-IKS
c              IHS=-IHS
c              LSYM(I)=-LSYM(I)
c            ENDIF
c            IF(ILS.EQ.0.AND.IKS.EQ.0.AND.IHS.LT.0) THEN
c              IHS=-IHS
c              LSYM(I)=-LSYM(I)
c            ENDIF
C
c            IF(IKS.GE.0.AND.MK.GE.0) THEN
c              IF(MH.LT.IHS) THEN
c                MH=IHS
c                MK=IKS
c                GO TO 400
c              ENDIF
c            ELSE
c              IF((IKS.GT.MK).OR.(IKS.EQ.MK.AND.MH.LT.IHS)) THEN
c                MH=IHS
c                MK=IKS
c                GO TO 400
c              ENDIF
c            ENDIF
c          ENDIF
          NS=NS+1
          JHS(NS)=IHS
          JKS(NS)=IKS
          JLS(NS)=ILS
        ENDDO
C ---------------------
        IF(NS.EQ.0) GO TO 400
C ---------------------
        FA=0.
        FB=0.
        DO     I=1,NS
          IHS =JHS(I)
          IKS =JKS(I)
          ILS =JLS(I)
          IF(IKS.LT.0) IKS=IKS+NY
          IKSS=IKS
          IKS =IKS*NX
          IF(IHS.LT.0) IHS=IHS+NX
          IND1=IKS+IHS+1
          IND =IND1*2
          IF(ABS(ILS).EQ.ML) THEN
            SFA(I)= POOLA(IND)/COEF
            SFB(I)=-POOLB(IND)/COEF
            IF(LSYM(I).LT.0) SFB(I)=-SFB(I)
            ARG   =MH*SYM(1,I)+MK*SYM(2,I)+ML*SYM(3,I)
            COSD  =COS(ARG)
            SIND  =SIN(ARG)
            STOR  =SFA(I)*COSD-SFB(I)*SIND
            SFB(I)=SFB(I)*COSD+SFA(I)*SIND
            SFA(I)=STOR
            FA    =FA+SFA(I)
            FB    =FB+SFB(I)
          ENDIF
        ENDDO
C----------------------------------------
        FD =FA*FA+FB*FB
        FD2=FD
        FD =SQRT(FD)
        FDD=FD
        IF(FDD.GE.FMIN) THEN
          SF2C=SF2C+FD2
          SUMF=SUMF+FDD
          NUMB=NUMB+1
C
          FA  =FA/FD
          FB  =FB/FD
          IF(PATT.EQ.'Y') THEN
            FDD=SQRT(FDD)
          ENDIF
          CALL WRT(MTF  ,MH,MK,ML,FDD,ZER,NBL  ,IEND )

          IF(INVER.NE.0) FB = -FB
          CALL WRT1(MTPH,MH,MK,ML,FA ,FB ,NBL11,IEND1)
C
        ENDIF
C --------------------------------
  400   CONTINUE
        CALL RDINDX(IHN,IKN,ILN,IHMAX,IKMAX,LMAX
     *  ,RHMIN,RHMAX,NSYM,ISYM,IPRSYM,IENDN)
        IF(IENDN.GT.0) GO TO 200
        GO TO 500
C ------------------------------------------------
  300   CONTINUE
      ENDDO
C  ===============================================
  200 CONTINUE
      IEND =2
      IEND1=2
      CALL WRT (MTF ,MH,MK,ML,FD,ZER,NBL  ,IEND )
      CALL WRT1(MTPH,MH,MK,ML,FA,FB ,NBL11,IEND1)
      CLOSE(MTF)
      CLOSE(MTPH)
      CLOSE(MTIN)
C------------------------
      IF(NUMB.GT.0) THEN
        SUMF=SUMF/NUMB
        SF2C=SF2C/NUMB
      ENDIF
      SUMF=SQRT(SF2C)  
      NUMB=NUMB+N000
      WRITE(LINE,1010) NUMB,SUMF,SF2C
 1010 FORMAT(' WRITE NUMB OF REFLS=',I8,' <F-MOD>=',G15.4,
     * ' <F**2>=',G15.4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' F000,VOL :'',2G15.4)') F000,VOL
      CALL MSGDOC(MDOC,LINE)
      RESMIN=1./RHMIN
      WRITE(LINE,'('' RESOLUTION:'',2F7.3)') RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
C -------------------------------------------------
      RESULT(1)=NUMB
      RESULT(2)=RESMIN
      RESULT(3)=RESMAX
      RESULT(4)=F000
      RESULT(5)=SUMF
      RESULT(6)=SF2C
      RESULT(7)=NX
      RESULT(8)=NY
      RESULT(9)=NZ
      RESULT(10)=VOL
      IF(NUMB.LE.0) THEN
        CALL MSGERR(MDOC,' Number of reflections = 0')
        IERR=1
      ENDIF
      RETURN
      END

      SUBROUTINE INDENS(MTIN,NAMED,NSYM,ISYM,IPRSYM
     *  ,NZ1,NXY,POOLA,POOLB,POOL8,CSAN,SNAN,
     *             DELCS,DELSN,MDOC,IERR)
C --------------------------------------------------------
CMS      : POOL8,POOLA,POOLB
      COMPLEX   POOL8(*)
      REAL      POOLA(*),POOLB(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
C --------------------------------
      REAL      RLINE(20)
      INTEGER*2 IBLOCK(1024)
      COMPLEX   DM
      CHARACTER NAMED*(*),TYPE*4
      DATA      NRMAX/1024/,NW4/4/,NW20/20/
C -------------------------------------------------------------
      IERR=0
      REWIND MTIN
      ZERO    =0.0
      DM      =CMPLX(ZERO,ZERO)
      POOLA(1)=0.0
      DO     I=1,NXY
        POOL8(I)=DM
      ENDDO
      CSZL=1.
      SNZL=0.
C-------------
C      CALL RBLOCK(MTIN,RLINE,NW20,IERR)
C      IF(IERR.NE.0) THEN
C        CALL MSGDOC(MDOC,' ERR: READ FILE-DENS')
C        RETURN
C      ENDIF
C      CALL RBLOCK(MTIN,RLINE,NW20,IERR)
C      IF(IERR.NE.0) THEN
C        CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
C        RETURN
C      ENDIF
      TYPE='RI  '
      MD=99
      CALL OPFILE(MD,MTIN,NAMED,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        IERR=4
        CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
        MTIN=0
        RETURN
      ENDIF
C-------------
      DO     IZ=1,NZ1
        CALL RBLOCK(MTIN,RLINE,NW4,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
          RETURN
        ENDIF
C ::::::
C ----- CALL RBLOCK(MTIN,IPOOL,NXY2,IERR)
C ::::::
        IXY=0
        NR0=0
        NR1=1
77710   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2
        READ(MTIN,ERR=9) (IBLOCK(II),II=1,NRR)
        DO     I=1,NRR
          IXY=IXY+2
          POOLA(IXY)=POOLA(IXY)+IBLOCK(I)*CSZL/RLINE(2)
          POOLB(IXY)=POOLB(IXY)-IBLOCK(I)*SNZL/RLINE(2)
        ENDDO
C:::::::::
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 77710
C:::::::::
        STOR=SNZL*CSAN+CSZL*SNAN
        CSZL=CSZL*CSAN-SNZL*SNAN
        SNZL=STOR
      ENDDO
      STOR=SNAN*DELCS+CSAN*DELSN
      CSAN=CSAN*DELCS-SNAN*DELSN
      SNAN=STOR
      RETURN
C --------------------------------------------------
    9 CALL MSGERR(MDOC,' ERR: READ INPUT-FILE-DENS')
      IERR=1
      RETURN
      END

      SUBROUTINE RDINDX(IH,IK,IL,IHMAX,IKMAX,ILMAX
     * ,RSMIN,RSMAX,NSYM,ISYM,IPRSYM,IEND)
C ----------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----------------------------------------------------
 100  CONTINUE
      IF(IEND.EQ.-1) THEN
        IL=0
        IK=-IKMAX
        IH=-IHMAX-1
        IEND=0
      ENDIF
      IH=IH+1
      IF(IH.GT.IHMAX) THEN
        IH=-IHMAX
        IK=IK+1
        IF(IK.GT.IKMAX) THEN
          IK=-IKMAX
          IL=IL+1
          IF(IL.GT.ILMAX) THEN
            IEND=1
            RETURN
          ENDIF
        ENDIF
      ENDIF
      IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 100
      CALL DSTAR_BL(IH,IK,IL,RS)
      RS=SQRT(RS)
      IF(RS.GT.RSMAX)      GO TO 100
      CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
      IF(ICND.NE.0) GO TO 100
      NH=IH
      NK=IK
      NL=IL
      CALL ANOMSC(NH,NK,NL,KANOM,JJSYM,NSYM,ISYM)
      IF(JJSYM.NE.1.OR.KANOM.NE.1) GO TO 100
      IF(RS.LT.RSMIN) RSMIN=RS
      RETURN
      END

      SUBROUTINE RFT2(MDOC,POOL8,POOLA,POOLB,NCRES,RESMAX
     * ,NAMED,NAMEF,NAMEPH,NAME,IPRSYM
     * ,SFA,SFB,SYM,JHS,JKS,JLS,LSYM,ISYM
     * ,POOLC,IPOOL,NCRESF  
     * ,RESULT,IERR)
C ---------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   ID(3),IDT(7)
CMS      : POOL8,POOLA,POOLB
      REAL      RESULT(*)
      COMPLEX   POOL8(*)
      REAL      POOLA(*),POOLB(*),POOLC(*)
      INTEGER   IPOOL(*)
      REAL      RLATT(6)
      REAL      SFA(IPRSYM),SFB(IPRSYM)
      INTEGER   JHS(IPRSYM),JKS(IPRSYM),JLS(IPRSYM),LSYM(IPRSYM)
      REAL      SYM(3,IPRSYM)
      CHARACTER LINE*80
      CHARACTER NAMED*(*),NAMEF*(*),NAMEPH*(*)
      CHARACTER TITLE*80,ITYPE*4,NAME*(*),PATH*1,EXT*1,PATT*1
      EXTERNAL  PACK,UNPACK
C--------------------------------------------------------------
      TWOPI =8.0*ATAN(1.0)
      IERR=0
C --------------------
      MTIN  =40
      ITYPE ='RI  '
      MD=-ABS(MDOC)-1
      M=99
C     WRITE(*,*) '       INPUT-FILE /DENS/'
      ITYP  =0
      CALL IRDENS(MTIN,NAMED,MD,ITYP,ICNTZ,NX,NY,NZ,IZM,
     * IZN,RMAX,RMIN,POOLA,SCALE,A,B,C,AL,BE,GA,DRMS,
     * RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE
     * ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE--DENS')
        CLOSE(MTIN)
        IERR=1
        RETURN
      ENDIF
C      CALL ORFILE(M,MTIN,NAMED,ITYPE,NSYM,ISYM,IPRSYM,IERR)
C      IF(IERR.NE.0) THEN
C        CALL MSGERR(MDOC,' ERR: OPEN FILE---DENS')
C        RETURN
C      ENDIF
C      CALL GET_TITLE(M,A,B,C,AL,BE,GA
C     *  ,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TITLE,IERR)
      NXY=NX*NY
      IF(IZN.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: IZMIN # 0')
        IERR=1
        RETURN
      ENDIF
      CALL C_RD_CR
      IF(NXY.GT.NCRES) THEN
        WRITE(LINE,'('' ERR: not memory '',I4,'' x'',I4,'' >'',I8)')
     *             NX,NY,NCRES
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(TITLE(1:4).EQ.'PATT') THEN
        PATT='Y'
      ELSE
        PATT='N'
      ENDIF
C  ------------------------------------
      RLATT(1)=A
      RLATT(2)=B
      RLATT(3)=C
      RLATT(4)=AL
      RLATT(5)=BE
      RLATT(6)=GA
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      M=99
      CALL ANOMF(M,NSYM,ISYM)
      RESMIN=1000.
      IF(RESMAX.LT.1.E-4) RESMAX=RESOL
      DO     I=1,NSYM
        DO     J=1,3
          SYM(J,I)=(TWOPI*ISYM(4,J,I))/FLOAT( ISYM(5,J,I))
        ENDDO
      ENDDO
C ---------------------------------------------------
C     WRITE(*,*) '      OUTPUT FILE-FMOD'
      MTF=30
      TITLE(1:4)='FOUR'
      ITYPE='COEF'
      TITLE(5:8)='RFT '
      F1   =1.0
      F2   =0.0
      CALL C_CR_WR
      CALL SET_TITLE(M,A,B,C,
     *  AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)

C     NAME='scratch_rft'

      CALL OWFILE(M,MTF,NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE-F')
        CLOSE(MTIN)
        RETURN
      ENDIF

C      WRITE(*,*) '      OUTPUT FILE-PHAS'
      MTPH=33
      TITLE(1:4)='PH  '
      TITLE(5:8)='RFT '
      ITYPE='PH  '
      CALL SET_TITLE(M,A,B,C,
     *  AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      CALL OWFILE(M,MTPH,NAMEPH,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE-PH')
        CLOSE(MTIN)
        CLOSE(MTF)
        RETURN
      ENDIF
      CLOSE(MTPH)
      CLOSE(MTF)
C -----------------------------------------------------
      PATH = ' '
      EXT  = ' '
      M    = 99
      CALL OPENUW(MTF,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN SCRATCH_FILE.')
        RETURN
      ENDIF
C -------------------------------------------------------
      RHMIN=1000.0
      RHMAX=1./RESMAX
      WRITE(LINE,'('' RESOLUTION:'',F7.3)') RESMAX
      CALL MSGDOC(MDOC,LINE)
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,LMAX,NXMIN,NYMIN,NZMIN)
      CALL MSGDOC(MDOC,' For this resolution:')
      WRITE(LINE,1020) IHMAX,IKMAX,LMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,1021) NXMIN,NYMIN,NZMIN
 1021 FORMAT(' NXmin,NYmin,NZmin :',3I4)
      CALL MSGDOC(MDOC,LINE)
c      IHMAX  =(NX+2)/2
c      IKMAX  =(NY+2)/2
c      LMAX   =(NZ+2)/2
c      WRITE(LINE,1022) IHMAX,IKMAX,LMAX
c 1022 FORMAT(
c     * ' From NX,NY,NZ of dens-file Hmax,Kmax,Lmax are :',3I4)
c      CALL MSGDOC(MDOC,LINE)
      LMAX1 =LMAX+1
      NZ1   =IZM+1
      NX1   =NX+1
      NX2   =NX+2
      NXB2  =NX/2
      NYB2  =NY/2
      ZER   =0.0
      COEF  =(NX*NY*NZ)/(VOL)
      FMIN =0.0
C ------
      DELANG=TWOPI/FLOAT(NZ)
      DELSN =SIN(DELANG)
      DELCS =COS(DELANG)
      CSAN  =1.0
      SNAN  =0.0
C ------
      NBL  =0
      NBL11=0
      IENDN=-1
      IEND =-1
      IEND1=-1
      NUMB =0
      NUMBS=0
C ---
      SUMF =0.
      SF2C =0.
C ---
      ID(1)=NX
      ID(2)=NY
      ID(3)=0
C ---
      N000 =0
C ==============================================
      LINE=' '
      CALL MSGDOC(MDOC,LINE)
      DO     IL=1,LMAX1
C -------------------------------------
        CALL CLOCK(IDT)
        ILR=IL-1
        WRITE(LINE,'(''    L='',I5,10X,I2,''.'',I2,''.'',I2)')
     .           ILR,IDT(4),IDT(3),IDT(2)
        MM=99         
        IF(MDOC.GE.0.AND.MDOC.LT.99) MM=0
        CALL MSGDOC(MM,LINE)
C ----------------------------
        CALL INDENS(MTIN,NAMED,NSYM,ISYM,IPRSYM
     *    ,NZ1,NXY,POOLA,POOLB,POOL8,CSAN,SNAN,
     *             DELCS,DELSN,MDOC,IERR)
        IF(IERR.GT.0) THEN
          CLOSE(MTIN)
          CLOSE(MTF)
          RETURN
        ENDIF
C  ---------------------------
        CALL MDCFT2(POOL8,ID,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERR: IN MDCFT2')
          CLOSE(MTIN)
          CLOSE(MTF)
          RETURN
        ENDIF
C -----------------------------------------------------
        IF(ILR.EQ.0) THEN
          F000=(POOLA(2)*NSYM)/(COEF)
          FMIN=F000*0.000001
          IF0=0
          MH=0
          MK=0
          ML=0
          FA=1.
          FB=0.
C         CALL WRT (MTF ,MH,MK,ML,F000,ZER,NBL  ,IEND )
C         WRITE(MTF) MH,MK,ML,F000,ZER
          CALL PACK(INDX,MH,MK,ML)
          WRITE(MTF) INDX,F000,ZER
          N000=1
        ENDIF
        ILN=ILR
C---------------
        DO IKN=-IKMAX,IKMAX
        DO IHN=-IHMAX,IHMAX
          IF(IHN.EQ.0.AND.IKN.EQ.0.AND.ILN.EQ.0)     GO TO 400
          IF(IABS(IHN).GE.NXB2.OR.IABS(IKN).GE.NYB2) GO TO 400
          MH=IHN
          MK=IKN
          ML=ILN
          CALL SYSABS_BL(MH,MK,ML,NSYM,ISYM,ICND)
          IF(ICND.NE.0) GO TO 400
          CALL ANOMSC(MH,MK,ML,KANOM,JJSYM,NSYM,ISYM)
          CALL DSTAR_BL(MH,MK,ML,RH)
          RH=SQRT(RH)
          IF(RH.GT.RHMAX)      GO TO 400
          IF(RH.LT.RHMIN) RHMIN=RH
          IKNN=IKN
          IF(IKNN.LT.0) IKNN=IKNN+NY
          IKNIND =IKNN*NX
          IHNN=IHN
          IF(IHNN.LT.0) IHNN=IHNN+NX
          IND1=IKNIND+IHNN+1
          IND =IND1*2
          FAI= POOLA(IND)/COEF
          FBI=-POOLB(IND)/COEF
          JHN= IHN
          JKN= IKN
          JLN= ILN
          FAT= FAI
          FBT= FBI
          FA=0.0
          FB=0.0
          IWRITE=0
          IF(KANOM.EQ.1) THEN
CD            WRITE(*,'('' --- M H,K,L,FNOM:'',5I5)') 
CD     *      MH,MK,ML,KANOM,JJSYM
CD            WRITE(*,'(''    N H,K,L,FA,FB:'',3I5,2X,2F12.3)')
CD     *      JHN,JKN,JLN,FAT,FBT

C----
            DO     I=1,NSYM
C              FA=0.0
C              FB=0.0
              IHS=ISYM(1,1,I)*MH+ISYM(1,2,I)*MK+ISYM(1,3,I)*ML
              IKS=ISYM(2,1,I)*MH+ISYM(2,2,I)*MK+ISYM(2,3,I)*ML
              ILS=ISYM(3,1,I)*MH+ISYM(3,2,I)*MK+ISYM(3,3,I)*ML
              IF(IHS.EQ.JHN.AND.IKS.EQ.JKN.AND.ILS.EQ.JLN) THEN
                FFAT=FAT
                FFBT=FBT
c                LSS=LS*KANOM
c                IF(LS.NE.1) FFBT=-FFBT
                ARG   =MH*SYM(1,I)+MK*SYM(2,I)+ML*SYM(3,I)
                COSD  =COS(ARG)
                SIND  =SIN(ARG)
                FA=FA+FFAT*COSD-FFBT*SIND
                FB=FB+FFBT*COSD+FFAT*SIND
                IWRITE=1
CD                WRITE(*,'(''      I H,K,:'',5I5,2F12.3)') 
CD     *          I,IHS,IKS,ILS,LS,FA,FB
CD                NUMBS=NUMBS+1
CD                WRITE(MTF) MH,MK,ML,FA,FB
              ENDIF
            ENDDO
          ENDIF

C         ARG   =MH*SYM(1,JJSYM)+MK*SYM(2,JJSYM)+ML*SYM(3,JJSYM)
C         COSD  =COS(ARG)
C         SIND  =SIN(ARG)
C         STOR  =FA*COSD-FB*SIND
C         FB    =FB*COSD+FA*SIND
C         FA    =STOR
C         NUMBS=NUMBS+1
C         CALL WRT(MTF,MH,MK,ML,FA,FB,NBL,IEND )
c         WRITE(MTF) MH,MK,ML,FA,FB

          IF(ILN.GT.0) THEN
            MMH=-IHN
            MMK=-IKN
            MML=-ILN
            CALL ANOMSC(MMH,MMK,MML,KANOM,JJSYM,NSYM,ISYM)
            IF(MMH.EQ.MH.AND.MMK.EQ.MK.AND.MML.EQ.ML.AND.KANOM.EQ.1)
     *      THEN
              JHN=-IHN
              JKN=-IKN
              JLN=-ILN
              FAT= FAI
              FBT=-FBI
CD              WRITE(*,'('' --- M H,K,L,FNOM:'',5I5)') 
CD     *        MH,MK,ML,KANOM,JJSYM
CD              WRITE(*,'(''    N H,K,L,FA,FB:'',3I5,2X,2F12.3)')
CD     *        JHN,JKN,JLN,FAT,FBT

C----
              DO     I=1,NSYM
CD                FA=0.0
CD                FB=0.0
                IHS=ISYM(1,1,I)*MH+ISYM(1,2,I)*MK+ISYM(1,3,I)*ML
                IKS=ISYM(2,1,I)*MH+ISYM(2,2,I)*MK+ISYM(2,3,I)*ML
                ILS=ISYM(3,1,I)*MH+ISYM(3,2,I)*MK+ISYM(3,3,I)*ML
                IF(IHS.EQ.JHN.AND.IKS.EQ.JKN.AND.ILS.EQ.JLN) THEN
                  FFAT=FAT
                  FFBT=FBT
                  ARG   =
     *            MH*SYM(1,I)+MK*SYM(2,I)+ML*SYM(3,I)
                  COSD  =COS(ARG)
                  SIND  =SIN(ARG)
                  FA=FA+FFAT*COSD-FFBT*SIND
                  FB=FB+FFBT*COSD+FFAT*SIND
                  IWRITE=1 
CD                  WRITE(*,'(''      I H,K,:'',5I5,2F12.3)') 
CD     *            I,IHS,IKS,ILS,LS,FA,FB
CD                  NUMBS=NUMBS+1
CD                  WRITE(MTF) MH,MK,ML,FA,FB
                ENDIF

              ENDDO
            ENDIF
          ENDIF
          IF(IWRITE.EQ.1) THEN
            NUMBS=NUMBS+1
C           WRITE(MTF) MH,MK,ML,FA,FB
            CALL PACK(INDX,MH,MK,ML)
            WRITE(MTF) INDX,FA,FB
          ENDIF
  400     CONTINUE
        ENDDO
        ENDDO
      ENDDO

C  ===============================================
      RESMIN=1./RHMIN
      IEND =2
C      CALL WRT (MTF ,MH,MK,ML,FD,ZER,NBL  ,IEND )
      END FILE MTF
      CLOSE(MTF)
      CLOSE(MTIN)
C -----------------------------------------------
      PATH=' '
      EXT=' '
      M=99
      MTN=41
      CALL OPENUR(MTN,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN SCRATCH-FILE')
        RETURN
      ENDIF

C      M=99
C      MTN=41
C      ITYPE='COEF'
C      CALL ORFILE(M,MTN,NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
C      IF(IERR.NE.0) THEN
C        CALL MSGERR(MDOC,' ERR: OPEN FILE-F')
C        RETURN
C      ENDIF
C ----
      IENDN=-1
      NUMBS=0
 600  CONTINUE
C      CALL RD1(MTN,IH,IK,IL,FA,FB,NBLN,IENDN)
C     READ(MTN,END=700) IH,IK,IL,FA,FB
      READ(MTN,END=700) IND,FA,FB
      IF(MTN.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ SCRATCH_FILE')
        IERR=1
        RETURN
      ENDIF
      IF(IENDN.GT.0) GO TO 700
       

      IF(NUMBS.GE.NCRESF) THEN
        CALL RFT_SUM(MDOC,NUMBS,IPOOL,POOLA,POOLC)        
        IF(NUMBS.GE.NCRESF) THEN
          WRITE(LINE
     *    ,'('' ERR: not memory for scratch_F >'',I8)') NCRESF
          CALL MSGERR(MDOC,LINE)
          IERR=1
          CLOSE(MTN)
          RETURN
        ENDIF
      ENDIF

      NUMBS=NUMBS+1
C     CALL PACK(IND,IH,IK,IL)
      IPOOL(NUMBS)=IND
      POOLA(NUMBS)=FA
      POOLC(NUMBS)=FB
      GO TO 600

 700  CONTINUE
      IF(NUMBS.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: NUMBER OF REFLS = 0')
        IERR=1
        CLOSE(MTN)
        RETURN
      ENDIF
      CLOSE(MTN)
C -----------------------
      CALL RFT_SUM(MDOC,NUMBS,IPOOL,POOLA,POOLC)        
C -----------------------
C     WRITE(*,*) '      OUTPUT FILE-FMOD'
      MTF=30
      TITLE(1:4)='F   '
      ITYPE='F   '
      TITLE(5:8)='RFT '
      F1   =1.0
      F2   =0.0
      CALL C_CR_WR
      CALL SET_TITLE(MD,A,B,C,
     *AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      CALL OWFILE(MD,MTF,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-F')
        RETURN
      ENDIF
C      WRITE(*,*) '      OUTPUT FILE-PHAS'
      MTPH=33
      TITLE(1:4)='PH  '
      TITLE(5:8)='RFT '
      ITYPE='PH  '
      CALL SET_TITLE(MD,A,B,C,
     *  AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      CALL OWFILE(MD,MTPH,NAMEPH,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-PH')
        CLOSE(MTF)
        RETURN
      ENDIF
C-----------------------
      N000=0
      NUMB=0
      SF2C=0.0
      SUMF=0.0
      IEND = -1
      IEND1= -1
      NBL  =0
      NBL11=0
      DO     I=1,NUMBS
        IND=IPOOL(I)
        SA =POOLA(I)
        SB =POOLC(I)
        CALL UNPACK(IND,IH,IK,IL)
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) THEN
          N000=1
          F000=SA
          CALL WRT(MTF  ,IH,IK,IL,SA,ZER,NBL  ,IEND )
          IF(MTF.LE.0) THEN
            CALL MSGERR(MDOC,' ERR: WRITE TO FILE-F')
            CLOSE(MTPH)
            IERR=1
            RETURN
          ENDIF
          SA=1.
          SB=0.
          CALL WRT1(MTPH,IH,IK,IL,SA ,SB ,NBL11,IEND1)
          IF(MTPH.LE.0) THEN
            CALL MSGERR(MDOC,' ERR: WRITE TO FILE-PH')
            IERR=1
            CLOSE(MTF)
            RETURN
          ENDIF
        ELSE
          FD =SA*SA+SB*SB
          FD2=FD
          FD =SQRT(FD)
          FDD=FD
          IF(FDD.GE.FMIN) THEN
            SF2C=SF2C+FD2
            SUMF=SUMF+FDD
            SA  =SA/FD
            SB  =SB/FD
            NUMB=NUMB+1
            IF(PATT.EQ.'Y') THEN
              FDD=SQRT(FDD)
            ENDIF
            CALL WRT(MTF  ,IH,IK,IL,FDD,ZER,NBL  ,IEND )
            IF(MTF.LE.0) THEN
              CALL MSGERR(MDOC,' ERR: WRITE TO FILE_F')
              CLOSE(MTPH)
              IERR=1
              RETURN
            ENDIF
            CALL WRT1(MTPH,IH,IK,IL,SA ,SB ,NBL11,IEND1)
            IF(MTPH.LE.0) THEN
              CALL MSGERR(MDOC,' ERR: WRITE TO FILE_PH')
              CLOSE(MTF)
              IERR=1
              RETURN
            ENDIF
          ENDIF
        ENDIF
      ENDDO     
C     CLOSE(MTN)
C --------------------------------------------
CC
C
C      N000=0
C      SA=0.0
C      SB=0.0
C      INDOLD=-1
C      NUMB=0
C      SF2C=0.0
C      SUMF=0.0
C      IEND = -1
C      DO     I=1,NUMBS
C        IND=IPOOL(I)
C        FA =POOLA(I)
C        FB =POOLC(I)
C        CALL UNPACK(IND,IH,IK,IL)
C        IF(I.NE.1.AND.IND.NE.INDOLD) THEN
C
C          CALL UNPACK(INDOLD,IHO,IKO,ILO)
C          IF(IHO.EQ.0.AND.IKO.EQ.0.AND.ILO.EQ.0) THEN
C            N000=1
C            F000=SA
C            CALL WRT(MTF  ,IHO,IKO,ILO,SA,ZER,NBL  ,IEND )
C            SA=1.
C            SB=0.
C            CALL WRT1(MTPH,IHO,IKO,ILO,SA ,SB ,NBL11,IEND1)
C            WRITE(*,'('' ->'',4I5,3F16.3)') 
C     *      NUMB,IHO,IKO,ILO,FDD,SA,SB
C          ELSE
C            FD =SA*SA+SB*SB
C            FD2=FD
C            FD =SQRT(FD)
C            FDD=FD
C            IF(FDD.GE.FMIN) THEN
C              SF2C=SF2C+FD2
C              SUMF=SUMF+FDD
C              SA  =SA/FD
C              SB  =SB/FD
C              NUMB=NUMB+1
C              WRITE(*,'('' ->'',4I5,3F16.3)') 
C     *        NUMB,IHO,IKO,ILO,FDD,SA,SB
C              CALL WRT(MTF  ,IHO,IKO,ILO,FDD,ZER,NBL  ,IEND )
C              CALL WRT1(MTPH,IHO,IKO,ILO,SA ,SB ,NBL11,IEND1)
C            ENDIF
C          ENDIF
C          WRITE(*,'(''   '',4I5,2F16.3)') I,IH,IK,IL,FA,FB
C          SA=FA
C          SB=FB
C        ELSE
C          WRITE(*,'(''   '',4I5,2F16.3)') I,IH,IK,IL,FA,FB
C          SA=SA+FA
C          SB=SB+FB
C        ENDIF
C        INDOLD=IND
C        IF(I.EQ.NUMBS) THEN
C          CALL UNPACK(INDOLD,IHO,IKO,ILO)
C          IF(IHO.EQ.0.AND.IKO.EQ.0.AND.ILO.EQ.0) THEN
C            N000=1
C            F000=SA
C            CALL WRT(MTF  ,IHO,IKO,ILO,SA,ZER,NBL  ,IEND )
C            SA=1.
C            SB=0.
C            CALL WRT1(MTPH,IHO,IKO,ILO,SA ,SB ,NBL11,IEND1)
C            WRITE(*,'('' ->'',4I5,3F16.3)') 
C     *      NUMB,IHO,IKO,ILO,FDD,SA,SB
C          ELSE
C            FD =SA*SA+SB*SB
C            FD2=FD
C            FD =SQRT(FD)
C            FDD=FD
C            IF(FDD.GE.FMIN) THEN
C              SF2C=SF2C+FD2
C              SUMF=SUMF+FDD
C              SA  =SA/FD
C              SB  =SB/FD
C              NUMB=NUMB+1
C              CALL WRT(MTF  ,IHO,IKO,ILO,FDD,ZER,NBL  ,IEND )
C              CALL WRT1(MTPH,IHO,IKO,ILO,SA ,SB ,NBL11,IEND1)
C              WRITE(*,'('' ->'',4I5,3F16.3)') 
C     *        NUMB,IHO,IKO,ILO,FDD,SA,SB
C            ENDIF
C          ENDIF
C        ENDIF
C      ENDDO     
C      CLOSE(MTN)
C --------------------------------------------
      IEND =2
      IEND1=2
      CALL WRT (MTF ,MH,MK,ML,FD,ZER,NBL  ,IEND )
      CALL WRT1(MTPH,MH,MK,ML,FA,FB ,NBL11,IEND1)
      CLOSE(MTF)
      CLOSE(MTPH)
C------------------------
      IF(NUMB.GT.0) THEN
        SUMF=SUMF/NUMB
        SF2C=SF2C/NUMB
      ENDIF
      SUMF=SQRT(SF2C)  
      NUMB=NUMB+N000
      WRITE(LINE,1010) NUMB,SUMF,SF2C
 1010 FORMAT(' WRITE NUMB OF REFLS=',I8,' <F-MOD>=',G15.4,
     * ' <F**2>=',G15.4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' F000,VOL :'',2G15.4)') F000,VOL
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' RESOLUTION:'',2F7.3)') RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
C -------------------------------------------------
      RESULT(1)=NUMB
      RESULT(2)=RESMIN
      RESULT(3)=RESMAX
      RESULT(4)=F000
      RESULT(5)=SUMF
      RESULT(6)=SF2C
      RESULT(7)=NX
      RESULT(8)=NY
      RESULT(9)=NX
      RESULT(10)=VOL
      IF(NUMB.LE.0) THEN
        CALL MSGERR(MDOC,' Number of reflections = 0')
        IERR=1
      ENDIF
      RETURN
      END

      SUBROUTINE RFT_SUM(MDOC,NUMBS,IPOOL,POOLA,POOLC)
      INTEGER IPOOL(*)
      REAL POOLA(*),POOLC(*)
      CHARACTER LINE*80
C -----------------------
      M=99
      CALL MSGDOC(M,' --- SORT ---')
      WRITE(LINE,'('' Number of refls for sort   :'',I12)') NUMBS
      CALL MSGDOC(M,LINE)
      CALL ISORT2(IPOOL,NUMBS,POOLA,POOLC)
      WRITE(LINE,'('' Number of refls after sort :'',I12)') NUMBS
      CALL MSGDOC(M,LINE)
      CALL MSGDOC(M,' ------------')
C -----------------------
      SA=0.0
      SB=0.0
      INDOLD=-1
      NUMB=0
      DO     I=1,NUMBS
        IND=IPOOL(I)
        FA =POOLA(I)
        FB =POOLC(I)
        IF(I.NE.1.AND.IND.NE.INDOLD) THEN
          NUMB=NUMB+1
          IPOOL(NUMB)=INDOLD
          POOLA(NUMB)=SA
          POOLC(NUMB)=SB
          SA=FA
          SB=FB
        ELSE
          SA=SA+FA
          SB=SB+FB
        ENDIF
        INDOLD=IND
        IF(I.EQ.NUMBS) THEN
          NUMB=NUMB+1
          IPOOL(NUMB)=INDOLD
          POOLA(NUMB)=SA
          POOLC(NUMB)=SB
        ENDIF
      ENDDO     
      NUMBS=NUMB
      RETURN
      END


C -I-
      SUBROUTINE REDUCT(MDOC,NAMED,NAMEO,RESULT
     *    ,POOL,MEMORY,MODE,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P- REDUCT : check asymmetric part, other part will be equaled to zero.
C              Program reads file type of "RI" (electron density),
C              and writes output file only asymmetric part of input file 
C              and to equal to zero remaining part of informations.
C -S-
C
C  Dialog and Batch: 
C
C      FILE_D: - name of input dens-file.
C      MODE:   - <R> - /default/  reduct for all space groups.
C                 C  -  for C2221
C                 P  -  for P212121
C                 4  -  for P43212
C                 I  -  for I4
C      FILE_O: - name of output dens-file /'' '' - means without this file/.
C
C      Parameters of subroutine REDUCT:
C
C      SUBROUTINE REDUCT(MDOC,NAMED,NAMEO,RESULT
C                       ,POOL,MEMORY,MODE,ISYM,IPRSYM,IERR)
C
C      MDOC   -  mode of writting messages to DOC-file
C                0 - only terminal , < - 0 only file, 0 < < 99 - both
C                >= 99 - don't write  
C      NAMED  -  name of input dens-file .
C      NAMEO  -  name of output dens-file /'' '' - means without this file/.
C      POOL   -  real array POOL(MEMORY).
C      MEMORY -  (MEMORY*2)/3 is memory for one Z-section of electron
C                density NX x NY.
C      MODE   -  <R> - /default/  reduct for all space groups.
C   /character*1/         
C                 C  -  for C2221
C                 P  -  for P212121
C                 4  -  for P43212
C                 I  -  for I4
C      ISYM   - integer*2 array for cryst.symmetry operators 
C      IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM)
C               Number of cryst. symm. operators.
C               We need not to define contents of arrays ISYM.
C               Here is only reservation of memory.
C      IERR   - signal of error / =1 -error , =o - OK / 
C
C      RESULT /real RESULT(11)/ - array for output information:
C
C      RESULT(7) - number of points
C      RESULT(8) - number of points of asymm. part
C      RESULT(9) - asymm. part for X : NX / NXasym.part  
C      RESULT(10) - asymm. part for Y : NY / NYasym.part
C      RESULT(11) - asymm. part for Z : NZ / NZasym.part
C
C -I-
C ----------------------
CMS      : POOL
C     INTEGER*2 POOL(1)
      REAL POOL(*)
      REAL RESULT(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*4 NCRES,NCREST,MEMORY
      CHARACTER NAMED*(*),NAMEO*(*),MODE*1
      CHARACTER LINE*80,TYPE*4
C -------------------------------------------------------------
        NCREST=MEMORY*2
        NCRES=NCREST/3
        IF(MODE.EQ.'c') MODE='C'
        IF(MODE.EQ.'p') MODE='P'
        IF(MODE.EQ.'i') MODE='I'
        IF(MODE.NE.'C'.AND.MODE.NE.'I'.AND.MODE.NE.'P'.AND.MODE.NE.'4')
     *  THEN
          MODE='R'
        ENDIF
        M=-ABS(MDOC)-1
        WRITE(LINE,*) ' REDUCT FOR :',MODE
        CALL MSGDOC(M,LINE)
C ------------------------------------------------------------      
C      CALL REDCT1(MDOC,NAMED,NAMEO,RESULT
C     *    ,POOL(1),POOL(2*NCRES+1),NCRES
C     *    ,MODE,ISYM,IPRSYM,IERR)
      CALL REDCT1(MDOC,NAMED,NAMEO,RESULT
     *    ,POOL(1),POOL(NCRES+1),NCRES
     *    ,MODE,ISYM,IPRSYM,IERR)
      RETURN
      END

      SUBROUTINE REDCT1(MDOC,NAME1,NAMEW,RESULT
     *    ,POOLC,IPOOLA,NCRES
     *    ,MODE,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
CMS      : IPOOLA,POOLC
      INTEGER*2 IPOOLA(NCRES)
      REAL      POOLC(NCRES)
      REAL RESULT(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      XS(3),XT(3),AX(3)
      CHARACTER NAME1*(*),NAMEW*(*),MODE*1
      CHARACTER TTT1*80
      CHARACTER TTTW*80,TYPE*4
      CHARACTER LINE*80
      EQUIVALENCE (X,XS(1)),(Y,XS(2)),(Z,XS(3))
C ----------------------------------------------------------------------
      IERR=0
      NSYM=1
C--------------------------------------
      ITYPE  = 0
      MTIN1  =40
      M=-ABS(MDOC)-1
      CALL IRDENS(MTIN1,NAME1,M,ITYPE,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     * IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS,
     * RAVER,RESOL,IX01,IY01,IZ01,ITR1,TTT1
     * ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MDOC,' ERR: INPUT-DENS-FILE')
        IERR=1
        RETURN
      ENDIF
c      CLOSE(MTIN1)
      IF(MODE.EQ.'R') THEN
        IF(NSYM.EQ.2) THEN
          IF(ISYM(1,2,2).EQ.0.AND.
     *       ISYM(2,2,2).EQ.1.AND.
     *       ISYM(3,2,2).EQ.0     ) THEN
            MODE = 'B'
            WRITE(LINE,*) ' NOW MODE:',MODE
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
      ENDIF

      CALL C_RD_CR
      CALL C_CR_WR
      NXY1=NX1*NY1
      IXMIN1=0
      IXMAX1=NX1-1
      IYMIN1=0
      IYMAX1=NY1-1
      IX0W=IX01
      IY0W=IY01
      IZ0W=IZ01
      DO I=1,80
        TTTW(I:I)=' '
      ENDDO
      TTTW=TTT1
C--------------------------------------------------------
      ALW=AL1
      BEW=BE1
      GAW=GA1
      AW =A1
      BW =B1
      CW =C1
      NXW=NX1
      NYW=NY1
      NZW=NZ1
      IXMINW=0
      IXMAXW=NXW-1
      IYMINW=0
      IYMAXW=NYW-1
      IZMINW=IZMIN1
      IZMAXW=IZMAX1
C--------------------------------------------------------
      MD=-ABS(MDOC)-1
      MTS      = 0
      TTTW(1:4)='REDU'
      TTTW(5:8)='    '
      TYPE     ='RI  '
      CALL LENSTR_BL(NAMEW,LEN)
      IF(LEN.GT.0.AND.NAMEW(1:1).NE.','.AND.NAMEW(1:1).NE.' ') THEN 
        MTS      =43
        CALL SET_TITLE(MD,AW,BW,CW,ALW,BEW,GAW
     *  ,F1,F2,F3,F4,NXW,NYW,NZW,IZMINW,IZMAXW,TTTW,IERR)
        CALL OWFILE(MD,MTS,NAMEW,TYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERR: OUTPUT-DENS-FILE')
          CLOSE(MTIN1)
          RETURN
        ENDIF
      ENDIF
C ----------------------
C---------------------------------------------------------------
      ICNTZ3=-999
      ITYPE=-1
C---------------------------------------------------------------
      NXMAX=0
      NYMAX=0
      NZMAX=0
      DSUM1=0.0
      DSUM2=0.0
      DSUMO=0.0
      DSUMP=0.0
      DSUMN=0.0
      DSUMO2=0.0
      NUMB=0
      IERR=0
      DO     IZ=IZMIN1,IZMAX1
        Z=IZ/FLOAT(NZ1)
C-----------------------
        CALL IRDENS(MTIN1,NAME1,MDOC,ITYPE,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     *  IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS,
     *  RAVER,RESOL,IX01,IY01,IZ01,ITR1,TTT1
     *  ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERR: INPUT-DENS-FILE')
          IERR=1
          CLOSE(MTS)
          RETURN
        ENDIF
C-----------------------
        N=0
        DO     IY=1,NY1
          Y=(IY-1)/FLOAT(NY1)
          IND0 =(IY-1)*NX1
          DO     IX=1,NX1
            X=(IX-1)/FLOAT(NX1)
            IND =IND0+IX
            D1=IPOOLA(IND)/SCALE1
            IFLAG=0
C              -------  GENERAL ----------
            IF(MODE.EQ.'R') THEN
              IT=1
              NN=1
              IF(NSYM.GT.1) THEN
              DO     I=2,NSYM
                DO     J=1,3
                  IF(ISYM(5,J,I).EQ. 0) ISYM(5,J,I)=1
                  XT(J)=ISYM(4,J,I)/REAL(ISYM(5,J,I))
                  DO     K=1,3
                    XT(J)=XT(J)+ISYM(K,J,I)*XS(K)
                  ENDDO
                ENDDO
                DO     J=1,3
                  T=ABS(XT(J))
                  IAX=T
                  AX(J)=T-IAX
                  IF(XT(J).LT.0) AX(J)=1.-AX(J)
                  IF(AX(J).GE.1.0) AX(J)=0.
                  AX(J)=XS(J)-AX(J)
                  IF(ABS(AX(J)).LT.1.E-5) AX(J)=0.
                ENDDO
C                IF(AX(3)) 160,150,140
C 150            IF(AX(2)) 160,151,140
C 151            IF(AX(1)) 160,152,140

                IF(AX(3).LT.0.0) GO TO 160
                IF(AX(3).GT.0.0) GO TO 140
                IF(AX(2).LT.0.0) GO TO 160
                IF(AX(2).GT.0.0) GO TO 140
                IF(AX(1).LT.0.0) GO TO 160
                IF(AX(1).GT.0.0) GO TO 140
 152            CONTINUE
                NN=NN+1
                GO TO 160
 140            CONTINUE
                IT=0
                GO TO 170
 160            CONTINUE
              ENDDO
 170          CONTINUE
              ENDIF
              IF(IT.GE.1) THEN
                N=N+1
                DOUT=D1/FLOAT(NN)
                IFLAG=1
              ELSE
                DOUT=0.
              ENDIF
C              -------  P1 21 1 or P 1 2 1 ----------
            ELSE IF(MODE.EQ.'B') THEN
              IDT=1
              DOUT=D1
              IF(X.LE.0.5) THEN
                IF(X.EQ.0.0) THEN
                  IF(Z.GT.0.5) THEN
                    IDT=0
                  ELSE
                    IF(Y.EQ.0.0.OR.Y.EQ.0.5) DOUT=DOUT/2.
                  ENDIF
                ELSE IF(X.EQ.0.5) THEN
                  IF(Z.GT.0.5) THEN
                    IDT=0
                  ELSE
                    IF(Y.EQ.0.0.OR.Y.EQ.0.5) DOUT=DOUT/2.
                  ENDIF
                ENDIF
              ELSE
                IDT=0
              ENDIF
              IF(IDT.EQ.0) THEN
                DOUT=0.0
              ELSE
                IFLAG=1
                N=N+1
              ENDIF
C              -------  P212121 ----------
            ELSE IF(MODE.EQ.'P') THEN
              IDT=1
              DOUT=D1
              IF(Z.LE.0.25) THEN
                IF(Z.EQ.0.0) THEN
                  IF(Y.GE.0.0.AND.Y.LE.0.25) THEN
                    IF(Y.EQ.0.25.AND.X.GE.0.5) IDT=0
                  ELSE IF(Y.GT.0.5.AND.Y.LE.0.75) THEN
                    IF(Y.EQ.0.75.AND.X.GE.0.5) IDT=0
                  ELSE
                    IDT=0
                  ENDIF
                ELSE IF(Z.EQ.0.25) THEN
                  IF(X.GE.0.0.AND.X.LE.0.5) THEN
                    IF(X.EQ.0.0.AND.Y.GE.0.5) IDT=0
                    IF(X.EQ.0.5.AND.Y.GE.0.5) IDT=0
                  ELSE
                    IDT=0
                  ENDIF
                ENDIF
              ELSE
                IDT=0
              ENDIF
              IF(IDT.EQ.0) THEN
                DOUT=0.0
              ELSE
                IFLAG=1
                N=N+1
              ENDIF
C              -------  P43212 ----------
            ELSE IF(MODE.EQ.'4') THEN
                IDT=1
                DOUT=D1
                IF(Z.LE.0.125) THEN
                  IF(Z.EQ.0.0) THEN
                    IF(Y.EQ.X) DOUT=DOUT/2.
                    IF(Y.GT.X) IDT=0
                  ELSE IF(Z.EQ.0.125) THEN
                    IF(Y.GE.0.0.AND.Y.LE.0.25) THEN
                      IF(Y.EQ.0.0 .AND.X.GE.0.5) IDT=0
                      IF(Y.EQ.0.25.AND.X.GE.0.5) IDT=0
                    ELSE IF(Y.GT.0.5.AND.Y.LE.0.75) THEN
                      IF(Y.EQ.0.5 .AND.X.GE.0.5) IDT=0
                      IF(Y.EQ.0.75.AND.X.GE.0.5) IDT=0
                    ELSE
                      IDT=0
                    ENDIF
                  ENDIF
                ELSE
                  IDT=0
                ENDIF
                IF(IDT.EQ.0) THEN
                  DOUT=0.0
                ELSE
                  IFLAG=1
                  N=N+1
                ENDIF
C              -------  C2221 ----------
            ELSE IF(MODE.EQ.'C') THEN
                IDT=1
                DOUT=D1
                IF(Y.LE.0.5) THEN
                  IF(Z.EQ.0.0) THEN
                    IF(Y.EQ.0.0) DOUT=DOUT/2.
                    IF(Y.LE.0.25) THEN
                      IF(Y.EQ.0.25.AND.X.LE.0.5) IDT=0
                    ELSE
                      IDT=0
                    ENDIF
                  ELSE IF(Z.EQ.0.25) THEN
                    IF(X.LE.0.5) THEN
                      IF(X.EQ.0.0) DOUT=DOUT/2.
                      IF(X.EQ.0.5) DOUT=DOUT/2.
                      IF(Y.EQ.0.25) IDT=0
                    ELSE
                      IDT=0
                    ENDIF
                  ELSE IF(Z.GT.0.25) THEN
                    IDT=0
                  ELSE
                    IF(Y.EQ.0.5) IDT=0
                  ENDIF
                ELSE
                  IDT=0
                ENDIF
                IF(IDT.EQ.0) THEN
                  DOUT=0.0
                ELSE
                  IFLAG=1
                  N=N+1
                ENDIF
C              -------  I4 ----------
            ELSE IF(MODE.EQ.'I') THEN
                DOUT=D1
                XN=1.-X
                IFLAG=1
                IF(((Y.GT.X).OR.(Y.GE.XN)).OR.
     *             (X.GT.0.5.AND.Y.EQ.0.0).OR.(Z.GE.0.5)) THEN
                  DOUT=0.0
                  IFLAG=0
                ELSE
                  IF(Y.EQ.0.0.AND.X.EQ.0.0) DOUT=DOUT/4.
                  IF(Y.EQ.0.5.AND.X.EQ.0.5) DOUT=DOUT/4.
                  IF(Y.EQ.0.0.AND.X.EQ.0.5) DOUT=DOUT/2.
                  N=N+1
                ENDIF
            ENDIF
            
            POOLC(IND)=DOUT
            IF(IFLAG.EQ.1) THEN
              DSUM1 =DSUM1+D1
              DSUMO =DSUMO+DOUT
              DSUMO2=DSUMO2+DOUT*DOUT
              NUMB=NUMB+1
              IF((IX-1).GT.NXMAX) NXMAX=IX-1
              IF((IY-1).GT.NYMAX) NYMAX=IY-1
              IF( IZ   .GT.NZMAX) NZMAX=IZ
            ENDIF
C----XXXX---YYYY-------
  500       CONTINUE
          ENDDO
  400     CONTINUE
        ENDDO
        IF(N.GT.0) NZN=IZ
C---------------------
        IF(MTS.GT.0) THEN
          CALL WDENS(MTS,MDOC,ICNTZ3,NXW,NYW,NZW,IZMINW,IZMAXW,
     *             RMAXD,RMIND,POOLC,RESOL,IX01,IY01,IZ01,ITR1)
          IF(MTS.LE.0) THEN
            CALL MSGERR(MDOC,' ERR: OUTPUT-DENS-FILE')
            IERR=1
            CLOSE(MTIN1)
            RETURN
          ENDIF
        ENDIF
  300 CONTINUE
C---ZZZZZZZZZ----------
      ENDDO
C----------------------
  100 CONTINUE
      AVER=0.0
      RMS=0.0
      NTOT=NX1*NY1*(IZMAX1-IZMIN1+1)
      IF(NUMB.GT.0) THEN
        AVER=DSUMO/NUMB
        RMS=SQRT((DSUMO2+NUMB*AVER*AVER-2.0*AVER*DSUMO)/NUMB)
      ENDIF
      WRITE(LINE,'('' <D>,RMS(D),N,Ntot ='',2G16.4,2I10)') 
     * AVER,RMS,NUMB,NTOT
      CALL MSGDOC(MDOC,LINE)
      M=-ABS(MDOC)-1
      WRITE(LINE,40) DSUMO,DSUMO2
   40 FORMAT(' SUM-R, SUM-R**2 :',2G18.5)
      CALL MSGDOC(M,LINE)

      IF(NXMAX.GT.0) NXMAX=NX1/NXMAX
      IF(NYMAX.GT.0) NYMAX=NY1/NYMAX
      IF(NZMAX.GT.0) NZMAX=NZ1/NZMAX

      WRITE(LINE,'(''Asymm.part N/Na.p (x,y,z) :'',3I6)') 
     * NXMAX,NYMAX,NZMAX
      CALL MSGDOC(MDOC,LINE)
      RESULT(7) = NTOT
      RESULT(8) = NUMB
      RESULT(9) = NXMAX  
      RESULT(10) = NYMAX
      RESULT(11) = NZMAX
C---------------------
      CLOSE(MTIN1)
      IF(MTS.GT.0) CLOSE(MTS)
      RETURN
      END

C -I-
      SUBROUTINE CFFT(MDOC,LAP,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEF1
     * ,NAMED,NAMEPH,NAMEF2,RESMIN,RESMAX,BADD,BOFF,ASYM,SCALE
     * ,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P- CFFT  : COEF ( without anom. scatt.) + FFT
C -S-
C      Dialog:
C
C   FILE_1:  -   input file-1 of the structure factors.
C   FILE_2:  -   name of FILE-DERIV, if you want it 
C   FILE_PH: -   name of FILE-PHASE, if you want it
C   FILE_O:  -   output file of the coefficients.
C   RESOL:   MIN,MAX , <from files> - resolution
C   SCALE:   <1.0>
C   BOFF     <0> , 240 corresponds to RESmin=10 /aprox./
C                For suppressing low resolutin reflections, kind of 
C                modeling desordered solvent: Fnew=(1-exp(-Boff*s**2))*Fold    
C   BADD:    <0.0>
C                     SCALE and BADD will be applyed:
C                     DEL = (Fder*SCALE-Fnat)*EXP(-Badd*RSQ
C                     or F = ( Fnat*SCALE )*EXP(-Badd*RSQ)
C   LAP:     <N>,Y  - coefficients of the curvature (second derivative)
C                     will be calculated: COEF = 4 * PI**2 * S**2 * F(hkl) 
C   ASYM:    <N>/Y , Y means to calculate only asymm.part of unit cell.
C   LIMZ:  MIN MAX numbers of Z-section /default for SF calculation/
C
C
C      SUBROUTINE CFFT(MDOC,LAP,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEF1
C     * ,NAMED,NAMEPH,NAMEF2,RESMIN,RESMAX,BADD,BOFF,ASYM,SCALE
C     * ,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAMEF1 - name of input file F_1
C      NAMEF2 - name oF input file F_2 / or " "/
C      NAMEPH - name oF input file PHASE / or " "/
C      NAMED  - name of output dens-file / or " "/.
C      SCALE,BOFF,BADD -  - see above.
C      LAP,ASYM  - see above.
C      NX,NY,NZ - numbers of points of grid corresponding axises X,Y,Z
C                 if NX=NY=NZ=0 program will define minimal values 
C                 suitable for calculation struture factors.
C      IZMIN,IZMAX - serial numbers for first and last Z-section of density.
C                  "0,-1"  mean to get default value for SF calculation.
C      F000:    <0.0>   - value of F(0,0,0)
C               > 0   - use this value
C               < 0   - use value from input coef_file.
C      POOL    - real array POOL(MEMORY) for
C                one Z-section of electron density NX x NY < MEMORY.
C      MEMORY  - dimension of real array POOL.
C      ISYM    - integer*2 array for cryst.symmetry operators 
C      IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM)
C                We need not to define contents of array ISYM
C                Here is only reservation of memory.
C      IERR    - signal of error / =1 -error , =o - OK / 
C
C      Output information:
C
C      RESULT(IPRROW) /real/ :
C
C      RESULT(1,1) = number of points
C      RESULT(2,1) = Dmax
C      RESULT(3,1) = Dmin
C      RESULT(4,1) = RMS
C      RESULT(5,1) = <D>
C      RESULT(6,1) = N_positive points
C      RESULT(7,1) = N_negative points
C      RESULT(8,1) = RMS for positive and =0 density
C      RESULT(9,1) = RMS for negative and =0 density
C      RESULT(10,1) = <D> for positive and =0 density
C      RESULT(11,1) = <D> for negative and =0 density
C      IF(IPRROW.GE.15) THEN
C        RESULT(12,1) = 3-moment of density 
C        RESULT(13,1) = 4-moment of density
C        RESULT(14,1) = P_000 - value of origine Patterson peak.
C        RESULT(15,1) = N points with density = 0
C      ENDIF    
C -I-
C ---------------------------------------------
CMS      : POOL
      REAL      POOL(MEMORY)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*4 MDOC,MEMORY,IPRSYM,IERR
      CHARACTER NAMEF1*(*),NAMEF2*(*),NAMED*(*),NAMEPH*(*)
     *         ,LAP*1,ASYM*1
      REAL      F000
      INTEGER*4 NX,NY,NZ,IZMIN,IZMAX
      REAL      RESULT(IPRROW,11)
C --------------
      IERR=0
      NCRES=MEMORY-IPRSYM*5
      IF(NCRES.LE.1) THEN
        CALL MSGERR(MDOC,' ERR: NOT MEMORY')
        IERR=1
      ENDIF
      I0=NCRES+1
      NCRES2=NCRES/2

C -----------
      CALL CFFTS(MDOC,LAP,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEF1
     * ,NAMEF2,NAMED,NCRES2,RESULT,IPRROW,ISYM,POOL(I0),POOL(IPRSYM+I0)
     * ,POOL(IPRSYM*2+I0),POOL(IPRSYM*3+I0),POOL(IPRSYM*4+I0)
     * ,RESMIN,RESMAX,IPRSYM,NAMEPH,BADD,BOFF,ASYM,SCALE,IERR)
C -----------
      RETURN
      END

      SUBROUTINE CFFTS(MDOC,LAP,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEF1
     * ,NAMEF2,NAMED,NCRES2,RESULT,IPRROW,ISYM,IH,IK,IL,FA,FB
     * ,RESMIN,RESMAX,IPRSYM,NAMEPH,BADD,BOFF,ASYM,SCALE,IERR)
C ---------------------------------------------
CMS      : POOL
      COMPLEX   POOL(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*4 IH(IPRSYM),IK(IPRSYM),IL(IPRSYM)
      INTEGER*4 NX,NY,NZ,IZMIN,IZMAX
      INTEGER*4 MDOC,NCRES2,IPRSYM,IERR
      REAL      F000,FA(IPRSYM),FB(IPRSYM)
      CHARACTER NAMEF1*(*),NAMEF2*(*),NAMED*(*),NAMEPH*(*)
     *         ,LAP*1,ASYM*1
      REAL      RESULT(IPRROW,11)
C ----------------------------------------------------------------------
      COMMON/COM_VLD/ DMAX1T,DMIN1T,SUM1,SUM21,NUMB1,NPOS,NNEG,NZER
     * ,SUMP,SUMN,SUMP2,SUMN2,SUM31,SUM41,P000
C ----------------------------------------------------------------------
      INTEGER*4 IDIM(3)
      COMPLEX   CDM,SM
      REAL      RLATT(6)
      REAL      CZL(512),SZL(512)
      CHARACTER TITLE*80,ITP*4,ITPH*4,LINE*80,MSG*1,ITP2*4
C ==============================================================
      IERR=0
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      M=99
      FOURPI2=-4.0*PI*PI
C -------------------------------
      IF(LAP.EQ.'y') LAP='Y'
      IF(LAP.NE.'Y') LAP='N'
      IF(ASYM.EQ.'y') ASYM='Y'
      IF(ASYM.NE.'Y') ASYM='N'
      IF(ABS(SCALE).LT.0.0001) SCALE=1.0
C -------------------------------   
      MTIN  =25
      ITP   ='FF  '
      MD=-ABS(MDOC)-1
      CALL ORFILE(MD,MTIN,NAMEF1,ITP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-F')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,RN,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)

C      CALL RTITLE(MTIN,NAMEF1,MDOC,ITP,IPRINT,DM,DM,DM,DM,DM,DM,
C     *            F1,F2,F3,RX,IDM,IDM,IDM,IDM,IDM,TITLE)

       CALL C_RD_CR
C ----
      A    =RLATT(1)
      B    =RLATT(2)
      C    =RLATT(3)
      ALPHA=RLATT(4)
      BETA =RLATT(5)
      GAMMA=RLATT(6)
      CALL DSTARF(RLATT,AS,BS,CS,ALS,BES,GAS,VOL)
C ----
C     VOLUME OF CELL
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
C -----------------------------------------------
      CALL LENSTR_BL(NAMEPH,LEN)
      IF(LEN.LE.0.OR.NAMEPH(1:1).EQ.' '.OR.NAMEPH(1:1).EQ.',') THEN
        MTPH=0
      ELSE
        ITPH='PH  '
        MTPH=26
        CALL ORFILE(MD,MTPH,NAMEPH,ITPH,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-PH')
          CLOSE(MTIN)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     *  ,RLATT(6),CF,BT,RN3,RX3,IDM,IDM,IDM,IDM,IDM,LINE,IERR)
      ENDIF
C ----
      CALL LENSTR_BL(NAMEF2,LEN)
      IF(LEN.LE.0.OR.NAMEF2(1:1).EQ.' '.OR.NAMEF2(1:1).EQ.',') THEN
        MTF=0
      ELSE
        MTF=27
        ITP2='FF  '
        CALL ORFILE(MD,MTF,NAMEF2,ITP2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-F_2')
          CLOSE(MTIN)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     *  ,RLATT(6),CF,BT,RN2,RX2,IDM,IDM,IDM,IDM,IDM,LINE,IERR)
      ENDIF
C ---------------------------------------
      IF(RESMIN.LE.0.0) RESMIN=RN
      IF(RESMAX.LE.0.0) RESMAX=RX
      IF(MTF.GT.0) THEN
        IF(RESMIN.GT.RN2) RESMIN=RN2
      ENDIF
      IF(MTPH.GT.0) THEN
        IF(RESMIN.GT.RN3) RESMIN=RN3
      ENDIF
      IF(MTF.GT.0) THEN
        IF(RESMAX.LT.RX2) RESMAX=RX2
      ENDIF
      IF(MTPH.GT.0) THEN
        IF(RESMAX.LT.RX3) RESMAX=RX3
      ENDIF
      WRITE(LINE,'(''RESOLUTIOM: MIN,MAX '',2F7.2)') 
     *  RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      IF(RESMAX.GT.RESMIN) THEN
        STOR=RESMIN
        RESMIN=RESMAX
        RESMAX=STOR
      ELSE IF(RESMAX.EQ.RESMIN) THEN
        IERR=1
        RETURN
      ENDIF
      RSMIN=1./RESMIN
      RSMAX=1./RESMAX
C ----
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----
      CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
      WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000 FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,1020) IHMAX,IKMAX,ILMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MD,LINE)
      IF(NX.LE.0) NX=NXMIN
      IF(NY.LE.0) NY=NYMIN
      IF(NZ.LE.0) NZ=NZMIN
      NX   =(NX/2)*2
      NY   =(NY/2)*2
      NZ   =(NZ/2)*2
      IF(NX.LT.2*IHMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nx < 2Hmax+1')
      IF(NY.LT.2*IKMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Ny < 2Kmax+1')
      IF(NZ.LT.2*ILMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nz < 2Lmax+1')
      WRITE(LINE,1030) NX,NY,NZ
 1030 FORMAT('GRID: NX=',I3,', NY=',I3,', NZ=',I3) 
      CALL MSGDOC(MD,LINE)

      IF(ILMAX.LT.0)  ILMAX=0

      IF(ILMAX.GT.511) ILMAX=511

      NX2  =NX/2
      NXY=NX*NY
      NCRES=NCRES2*2
      IF(NXY.GT.NCRES) THEN
        WRITE(LINE,
     * '('' ERR: not enough memory for one section of dens.'')')
        CALL MSGERR(MDOC,LINE)
        WRITE(LINE,'('' NX='',I4,'' NY='',I4,'' MEMORY-SIZE='',I6)')
     *                  NX,NY,NCRES
        CALL MSGERR(MDOC,LINE)
        WRITE(LINE,'('' must by: NX x NY < '',I6)') NCRES
        CALL MSGERR(MDOC,LINE)
        IERR=1
        CLOSE(MTIN)
        IF(MTF.GT.0) CLOSE(MTF)
        RETURN
      ENDIF
      NXY=NXY/2

      IIZMIN=0
      IIZMAX=0
      CALL SET_LIMZ(NSYM,ISYM,NZ,IZMAXD)
      IF(IZMIN.EQ.0.AND.IZMAX.LT.-1) THEN
        IIZMIN=0
        IIZMAX=NZ-1
      ELSE IF(IZMIN.EQ.0.AND.IZMAX.LT.0) THEN
        IIZMIN=0
        IIZMAX=IZMAXD
        IF(MTPH.EQ.0) IIZMAX=NZ/2
      ELSE
        IIZMAX=IZMAX
        IIZMIN=IZMIN
        IF(IIZMAX.LT.IIZMIN) THEN
          T=IIZMAX
          IIZMAX=IIZMIN
          IIZMIN=T
        ENDIF
      ENDIF
      IZMIN=IIZMIN
      IZMAX=IIZMAX

      IF(F000.EQ.0.0) THEN
        MSG='N'
      ELSE IF(F000.GT.0.0) THEN
        MSG='I'
      ELSE
        MSG='Y'
      ENDIF

      IF(MTPH.EQ.0) THEN
        IPATT=1
        ITP  ='PATT'
      ELSE
        IPATT=0
        ITP  ='FOUR'
      ENDIF

      TITLE(1:4)=ITP
      IF(MTF.LE.0) THEN
        IF(LAP.EQ.'Y') THEN
          TITLE(5:8)='LAPL'
        ELSE
          TITLE(5:8)='    '
        ENDIF
      ELSE
        IF(LAP.EQ.'Y') THEN
          TITLE(5:8)='LDIF'
        ELSE
          TITLE(5:8)=' DIF'
        ENDIF
      ENDIF
C ----
C     WRITE(*,*) '      OUTPUT-FILE /DENS/'
      MTOUT=0
      CALL LENSTR_BL(NAMED,LEN)
      IF(LEN.GT.0.AND.NAMED(1:1).NE.' '.AND.NAMED(1:1).NE.',') THEN
        MTOUT =43
        ITP   ='RI  '
        CALL C_CR_WR
        CALL SET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        CALL OWFILE(MD,MTOUT,NAMED,ITP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
          CLOSE(MTIN)
          IF(MTF.GT.0)  CLOSE(MTF)
          IF(MTPH.GT.0) CLOSE(MTPH)
          CLOSE(MTOUT)
          RETURN
        ENDIF
      ELSE
        WRITE(LINE,'(''Resolution:'',2F8.3)') RESMIN,RESMAX
        CALL MSGDOC(MD,LINE)
        CALL LENSTR_BL(TITLE,LEN)
        IF(LEN.GT.0) THEN
          IF(LEN.GT.80) LEN=80
          CALL MSGDOC(MD,TITLE(1:LEN))
        ENDIF
      ENDIF
C ----
c      ICPU=0
c      CALL CPU(ICPU)
C ----
      AD    =0.0
      SAD   =0.0
      ZERO  =0.0
      CDM   =CMPLX(ZERO,ZERO)
      ITP   ='    '
      IPRINT=0
      IX0   =0
      IY0   =0
      IZ0   =IZMIN
      ITR   =0
      ICNTZ =-999
      IDIM(1)=NX2
      IDIM(2)=NY
      IDIM(3)=0
      IFIRST=0
C -------------------------------------------------
      DMAX1T=-1.E30
      DMIN1T= 1.E30
      SUM1=0.0
      SUM21=0.0
      NUMB1=0
      NPOS =0
      NNEG=0
      NZER=0
      SUMP=0.0
      SUMN=0.0
      SUMP2=0.0
      SUMN2=0.0
      SUM31=0.0
      SUM41=0.0      
C =================================================
      DO     IZ=IZMIN,IZMAX
        Z=FLOAT(IZ)/FLOAT(NZ)
        ANG=TWOPI*Z
        CSZ=COS(ANG)
        SNZ=SIN(ANG)
        CZL(1)=1.0
        SZL(1)=0.0
        DO     I=2,512
          CZL(I)=CZL(I-1)*CSZ-SZL(I-1)*SNZ
          SZL(I)=SZL(I-1)*CSZ+CZL(I-1)*SNZ
        ENDDO
        DO     I=1,NXY
          POOL(I)=CDM
        ENDDO
        IF(MSG.EQ.'I') THEN
          TEMP=F000
          SM=CMPLX(TEMP,ZERO)
          POOL(1)=SM
C ---
          IF(IFIRST.EQ.0) THEN
            WRITE(LINE,'(''input F000 ='',G16.4)') F000
            CALL MSGDOC(MDOC,LINE)
            IFIRST=1
          ENDIF
C -----
        ENDIF
C---------------
        REWIND MTIN
        IF(MTF .GT.0) REWIND MTF
        IF(MTPH.GT.0) REWIND MTPH
        M=99
        CALL OPFILE(M,MTIN,NAMEF1,ITP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-F_1')
          CLOSE(MTIN)
          IF(MTF.GT.0)   CLOSE(MTF)
          IF(MTPH.GT.0)  CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(MTF.GT.0) THEN
          CALL OPFILE(M,MTF,NAMEF2,ITP2,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: FILE-F_2')
            CLOSE(MTIN)
            IF(MTF.GT.0)   CLOSE(MTF)
            IF(MTPH.GT.0)  CLOSE(MTPH)
            IF(MTOUT.GT.0) CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF
        IF(MTPH.GT.0) THEN
          CALL OPFILE(M,MTPH,NAMEPH,ITPH,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: FILE-PH')
            CLOSE(MTIN)
            IF(MTF.GT.0)   CLOSE(MTF)
            IF(MTPH.GT.0)  CLOSE(MTPH)
            IF(MTOUT.GT.0) CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF
        IEND =-1
        IENDF=-1
        IENDP=-1
        LL=-1
        LK=0
        LH=0
        LLF=-1
        LKF=0
        LHF=0
C----------------------------------------------------------------
  300   CONTINUE

        IF(IEND.GT.0) GO TO 200
        IF(ITP.EQ.'F   ') THEN
          CALL RD1(MTIN,IH(1),IK(1),IL(1),AP,BP,NUMB,IEND)
C         SIG-DUMMY
          SAP=0.04*AP
          SBP=0.04*BP
        ELSE
          CALL RRD1(MTIN,IH(1),IK(1),IL(1),AP,BP,SAP,SBP
     *   ,NUMB,IEND)
        ENDIF
        IF(AP.GT.1.E-6.AND.BP.GT.1.E-6) THEN
          IF(SAP.LE.0.0000001) SAP=1.0
          IF(SBP.LE.0.0000001) SBP=1.0
          WT1=1./(SAP*SAP)
          WT2=1./(SBP*SBP)
          WT =WT1+WT2
          AP =AP*WT1+BP*WT2
          AP =AP/WT
          SAP=1./SQRT(WT)
        ELSE IF(BP.GT.1.E-6) THEN
          AP =BP
          SAP=SBP
        ENDIF
        IF(MTIN.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-F_1')
          CLOSE(MTIN)
          IF(MTF.GT.0)   CLOSE(MTF)
          IF(MTPH.GT.0)  CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0) GO TO 200
C ----------------------------------
C       USE F000
C
        IF(IH(1).EQ.0.AND.IK(1).EQ.0.AND.IL(1).EQ.0) THEN

          IF(MSG.EQ.'Y')THEN
            IF(LAP.EQ.'Y') GO TO 300
            IF(MTF.GT.0)   GO TO 300
            TEMP=AP*SCALE
            IF(MTPH.LE.0) THEN
              TEMP = TEMP*TEMP
            ENDIF
            F000=TEMP/(VOL)
            TEMP=F000
            SM=CMPLX(TEMP,ZERO)
            POOL(1)=SM
C ---
            IF(IFIRST.EQ.0) THEN
              WRITE(LINE,'('' F000 ='',G16.4)') F000
              CALL MSGDOC(MDOC,LINE)
              IFIRST=1
            ENDIF
          ENDIF
          GO TO 300
        ENDIF
        CALL DSTAR_BL(IH(1),IK(1),IL(1),RSQ)
        RH=SQRT(RSQ)
        IF(RH.LT.RSMIN.OR.RH.GT.RSMAX) GO TO 300        

        IF(BOFF.GT.0.0) THEN
          BT=BOFF/4.0
          CBOFF=1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF=1.0
        ENDIF

        IF(BADD.GT.0.0) THEN
          BT=BADD/4.0
          CBADD=EXP(-BT*RSQ)
        ELSE
          CBADD=1.0
        ENDIF
C
  550   IF(IEND.GT.0.OR.IENDF.GT.0) GO TO 200
        IF(MTF.LE.0) GO TO 360

C        IF(LLF-IL(1)) 370,340,300
C  340   IF(LKF-IK(1)) 370,350,300
C  350   IF(LHF-IH(1)) 370,360,300

        IF(LLF.LT.IL(1)) GO TO 370
        IF(LLF.GT.IL(1)) GO TO 300
        IF(LKF.LT.IK(1)) GO TO 370
        IF(LKF.GT.IK(1)) GO TO 300
        IF(LHF.LT.IH(1)) GO TO 370
        IF(LHF.GT.IH(1)) GO TO 300
        GO TO 360

  370   IF(IENDF.GT.0) GO TO 200
        IF(ITP2.EQ.'F   ') THEN
          CALL RD2(MTF,LHF,LKF,LLF,AD,BD,NUMBF,IENDF)
C         SIG-DUMMY
          SAD=0.04*AD
          SBD=0.04*BD
        ELSE
          CALL RRD2(MTF,LHF,LKF,LLF,AD,BD,SAD,SBD,NUMBF,IENDF)
        ENDIF
        IF(AD.LE.1.E-6.AND.BD.LE.1.E-6) GO TO 370
        IF(AD.GT.1.E-6.AND.BD.GT.1.E-6) THEN
          IF(SAD.LE.0.0000001) SAD=1.0
          IF(SBD.LE.0.0000001) SBD=1.0
          WT1=1./(SAD*SAD)
          WT2=1./(SBD*SBD)
          WT =WT1+WT2
          AD =AD*WT1+BD*WT2
          AD =AD/WT
          SAD=1./SQRT(WT)
        ELSE IF(BD.GT.1.E-6) THEN
          AD =BD
          SAD=SBD
        ENDIF
        IF(MTF.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-F_2')
          CLOSE(MTIN)
          IF(MTF.GT.0)   CLOSE(MTF)
          IF(MTPH.GT.0)  CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        GO TO 550
 360    CONTINUE
C ---------------------------
        AP =AP *CBOFF*CBADD
        SAP=SAP*CBOFF*CBADD

        AD =AD *CBOFF*CBADD
        SAD=SAD*CBOFF*CBADD
C ----------------------
  
        IF(MTPH.GT.0) THEN
C         READ PHASE FOR THIS REFL.
C
  500     CONTINUE
          IF(IENDP.GT.0) GO TO 200
C          IF(LL-IL(1)) 2030,2010, 300
C 2010     IF(LK-IK(1)) 2030,2020, 300
C 2020     IF(LH-IH(1)) 2030,2000, 300

          IF(LL.LT.IL(1)) GO TO 2030
          IF(LL.GT.IL(1)) GO TO 300
          IF(LK.LT.IK(1)) GO TO 2030
          IF(LK.GT.IK(1)) GO TO 300
          IF(LH.LT.IH(1)) GO TO 2030
          IF(LH.GT.IH(1)) GO TO 2030
          GO TO 2000

 2030     CONTINUE
          CALL RD3(MTPH,LH,LK,LL,COPH,SIPH,NUMBPH,IENDP)
          GO TO 500
        ENDIF
 2000   CONTINUE
C ------------------------
        IF(MTF.GT.0) THEN
          AP =AD*SCALE-AP
          SAP=SQRT(SAP*SAP+SAD*SAD*SCALE*SCALE)
        ENDIF
        IF(LAP.EQ.'Y') THEN
          IF(MTPH.GT.0) THEN
            FAA  = AP  *(RSQ)*FOURPI2
            FA(1)= FAA*COPH
            FB(1)= FAA*SIPH
          ELSE
            FA(1)= (AP*AP)      *(RSQ)*FOURPI2
            FB(1)= (2.0*AP*SAP) *(RSQ)*FOURPI2
          ENDIF
        ELSE
          IF(MTPH.GT.0) THEN
            FA(1)= AP*COPH
            FB(1)= AP*SIPH
          ELSE
            FA(1)=AP*AP
            FB(1)=2.0*AP*SAP
          ENDIF
        ENDIF
        FA(1)=FA(1)/(VOL)
        FB(1)=FB(1)/(VOL)
C ----------------------
        CALL GENER(IPATT,N,IH,IK,IL,FA,FB,NSYM,ISYM,IPRSYM)
C ------------------------
        DO     I=1,N
          JH =IH(I)
          JK =IK(I)
          JL =IL(I)
          FAA=FA(I)
          FBB=FB(I)
C         WRITE(*,'('' H,K,L,A,B:'',3I5,2F12.4)') JH,JK,JL,FAA,FBB
          IF(IABS(JL).LE.ILMAX.AND.
     *       IABS(JK).LE.IKMAX.AND.
     *       IABS(JH).LT.IHMAX     ) THEN
            IHD=JH+1
            IF(JK.LT.0) JK=NY+JK
            IKD=JK+1
            ILD=IABS(JL)+1
            IF(ILD.LE.512) THEN
              PCOS=CZL(ILD)
              PSIN=SZL(ILD)
              IF(JL.LT.0 ) PSIN=-PSIN
              AP = FAA * PCOS + FBB * PSIN
              BP = FBB * PCOS - FAA * PSIN
              SM=CMPLX(AP,BP)
              IND=(IKD-1)*NX2+IHD
              POOL(IND)=POOL(IND)+SM
            ENDIF
          ENDIF
        ENDDO
        GO TO 300
C--------------------------------------------
  200   CONTINUE
        CALL MDHFT(POOL,IDIM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: IN KERNEL-FFT')
          CLOSE(MTIN)
          IF(MTF.GT.0)   CLOSE(MTF)
          IF(MTPH.GT.0)  CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        CALL VLD_SECT(MDOC,MTOUT
     *               ,IPATT,ASYM,POOL,NX,NY,NZ,IZ,NSYM,ISYM,IERR)
C--------------------------------------------------------------
        IF(MTOUT.GT.0) THEN
          CALL WDENS(MTOUT,MDOC,ICNTZ,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     *             ,POOL,RESMAX,IX0,IY0,IZ0,ITR)
          IF(MTOUT.LE.0) THEN
            CALL MSGERR(MDOC,' ERR: FILE-DENS')
            CLOSE(MTIN)
            IF(MTF.GT.0)   CLOSE(MTF)
            IF(MTPH.GT.0)  CLOSE(MTPH)
            IF(MTOUT.GT.0) CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF
      ENDDO
      CALL SET_DINF(MDOC,IPATT,VOL,NX,NY,NZ,RESULT,IPRROW,IERR)
C------------------------------------------------------------------
C      ICPU=1
C      CALL CPU(ICPU)
C ------------------------------------
      CLOSE(MTIN)
      IF(MTF.GT.0)   CLOSE(MTF)
      IF(MTPH.GT.0)  CLOSE(MTPH)
      IF(MTOUT.GT.0) CLOSE(MTOUT)
      RETURN
      END
      

      SUBROUTINE VLD_SECT(MDOC,MTOUT
     * ,IPATT,ASYM,POOL1,NX1,NY1,NZ1,IZ,NSYM,ISYM,IERR)
C --------------------------------------------------------------------
CMS      : POOL1
      REAL POOL1(*)
      INTEGER*2 ISYM(5,3,*)
C --------------------------------------------------------------
      CHARACTER LINE*80,ASYM*1
C ----------------------------------------------------------------------
      COMMON/COM_VLD/ DMAX1T,DMIN1T,SUM1,SUM21,NUMB1,NPOS,NNEG,NZER
     * ,SUMP,SUMN,SUMP2,SUMN2,SUM31,SUM41,P000
C ----------------------------------------------------------------------
      REAL      XS(3),XT(3),AX(3)
      EQUIVALENCE (X,XS(1)),(Y,XS(2)),(Z,XS(3))
C-----------------------------------------------
        DMAX1=-1.E30
        DMIN1= 1.E30
        IXN=0
        IYN=0
        IXM=0
        IYM=0
        Z=IZ/FLOAT(NZ1)
        DO     IY=1,NY1
          Y=(IY-1)/FLOAT(NY1)
          IND0 =(IY-1)*NX1
          DO     IX=1,NX1
            X=(IX-1)/FLOAT(NX1)
            IND =IND0+IX
            D1=POOL1(IND)
            IT=1
            NN=1
C ---
            IF(ASYM.EQ.'Y') THEN
              IF(IPATT.NE.1) THEN
                DO     I=2,NSYM
                  DO     J=1,3
                    IF(ISYM(5,J,I).EQ. 0) ISYM(5,J,I)=1
                    XT(J)=ISYM(4,J,I)/REAL(ISYM(5,J,I))
                    DO     K=1,3
                      XT(J)=XT(J)+ISYM(K,J,I)*XS(K)
                    ENDDO
                  ENDDO
                  DO     J=1,3
                    T=ABS(XT(J))
                    IAX=T
                    AX(J)=T-IAX
                    IF(XT(J).LT.0) AX(J)=1.-AX(J)
                    IF(AX(J).GE.1.0) AX(J)=0.
                    AX(J)=XS(J)-AX(J)
                    IF(ABS(AX(J)).LT.1.E-5) AX(J)=0.
                  ENDDO

C                  IF(AX(3)) 160,150,140
C 150              IF(AX(2)) 160,151,140
C 151              IF(AX(1)) 160,152,140

                  IF(AX(3).LT.0.0) GO TO 160
                  IF(AX(3).GT.0.0) GO TO 140
                  IF(AX(2).LT.0.0) GO TO 160
                  IF(AX(2).GT.0.0) GO TO 140
                  IF(AX(1).LT.0.0) GO TO 160
                  IF(AX(1).GT.0.0) GO TO 140

 152              CONTINUE
                  NN=NN+1
                  GO TO 160
 140              CONTINUE
                  IT=0
                  GO TO 170
 160              CONTINUE
                ENDDO
 170            CONTINUE
              ELSE
                DO     I=2,NSYM
                  DO     J=1,3
                    XT(J)=0.0
                    DO     K=1,3
                      XT(J)=XT(J)+ISYM(K,J,I)*XS(K)
                    ENDDO
                  ENDDO
                  DO     J=1,3
                    T=ABS(XT(J))
                    IAX=T
                    AX(J)=T-IAX
                    IF(XT(J).LT.0) AX(J)=1.-AX(J)
                    IF(AX(J).GE.1.0) AX(J)=0.
                    AX(J)=XS(J)-AX(J)
                    IF(ABS(AX(J)).LT.1.E-5) AX(J)=0.
                  ENDDO

C                  IF(AX(3)) 260,250,240
C 250              IF(AX(2)) 260,251,240
C 251              IF(AX(1)) 260,252,240

                  IF(AX(3).LT.0.0) GO TO 260
                  IF(AX(3).GT.0.0) GO TO 240
                  IF(AX(2).LT.0.0) GO TO 260
                  IF(AX(2).GT.0.0) GO TO 240
                  IF(AX(1).LT.0.0) GO TO 260
                  IF(AX(1).GT.0.0) GO TO 240

 252              CONTINUE
                  NN=NN+1
                  GO TO 260
 240              CONTINUE
                  IT=0
                  GO TO 270
 260              CONTINUE
                ENDDO
 270            CONTINUE
              ENDIF
            ENDIF
C ---
            IF(IT.LE.0) GO TO 100
            D1=D1/FLOAT(NN)
            IF(IZ.EQ.0.AND.(IX-1).EQ.0.AND.(IY-1).EQ.0) THEN
              P000=D1
            ENDIF
            IF(DMAX1.LE.D1) THEN
              DMAX1=D1
              IXM=IX-1
              IYM=IY-1
            ENDIF
            IF(DMIN1.GE.D1) THEN
              DMIN1=D1
              IXN=IX-1
              IYN=IY-1
            ENDIF
            IF(DMAX1T.LE.D1) DMAX1T=D1
            IF(DMIN1T.GE.D1) DMIN1T=D1
            NUMB1=NUMB1 +1
            SUM1 =SUM1  +D1
            SUM21=SUM21 +D1*D1
            SUM31=SUM31 +D1*D1*D1
            SUM41=SUM41 +D1*D1*D1*D1
            IF(D1.GT.0.0) THEN
              NPOS=NPOS+1
              SUMP=SUMP+D1
              SUMP2=SUMP2+D1*D1
            ELSE IF(D1.LT.0.0) THEN
              NNEG=NNEG+1
              SUMN=SUMN+D1
              SUMN2=SUMN2+D1*D1
            ELSE
              NZER=NZER+1
            ENDIF
 100        CONTINUE
          ENDDO
        ENDDO
        IF(MTOUT.LE.0) THEN
          WRITE(LINE,10) IXM,IYM,IZ,DMAX1,IXN,IYN,IZ,DMIN1
          CALL MSGDOC(MDOC,LINE)
   10     FORMAT(1X,3I4,1X,G12.4,' , ',3I4,1X,G12.4)
        ENDIF
C ----------------------------------------------------------
      RETURN
      END

      SUBROUTINE SET_DINF(MDOC,IPATT,VOL,NX,NY,NZ,RESULT,IPRROW,IERR)
C --------------------------------------------------------------------
      REAL      RESULT(IPRROW,11)
C --------------------------------------------------------------
      CHARACTER LINE*80,ITP*4
C ----------------------------------------------------------------------
      COMMON/COM_VLD/ DMAX1T,DMIN1T,SUM1,SUM21,NUMB1,NPOS,NNEG,NZER
     * ,SUMP,SUMN,SUMP2,SUMN2,SUM31,SUM41,P000
C ----------------------------------------------------------------------
      COEF=(VOL)/(NX*NY*NZ)

      SUM1 =SUM1 *COEF
      SUM21=SUM21*COEF
      SUMP =SUMP *COEF
      SUMN =SUMN *COEF
      SUMP2=SUMP2*COEF
      SUMN2=SUMN2*COEF
      SUM31=SUM31*COEF
      SUM41=SUM41*COEF
      CFVOL=(VOL*NUMB1)/(NX*NY*NZ)

      AVER1 =SUM1 /CFVOL
      AVER21=SUM21/CFVOL
      RMS1  =SQRT((AVER21-AVER1*AVER1))
      AMOM31=SUM31/(CFVOL*RMS1*RMS1*RMS1)
      AMOM41=SUM41/(CFVOL*RMS1*RMS1*RMS1*RMS1)

c      AVER1=SUM1/NUMB1
c      RMS1=SQRT((SUM21+NUMB1*AVER1*AVER1-2.0*AVER1*SUM1)/NUMB1)
c      AMOM31=SUM31/(NUMB1*RMS1*RMS1*RMS1)
c      AMOM41=SUM41/(NUMB1*RMS1*RMS1*RMS1*RMS1)

      WRITE(LINE,20)
   20 FORMAT(' ---------------------')
      CALL MSGDOC(MDOC,LINE)


      WRITE(LINE,50) NUMB1,RMS1
   50 FORMAT(' NUMB, RMS:',I12,G18.5)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,30) AVER1,DMAX1T,DMIN1T
   30 FORMAT(' <D>,RMAX,RMIN:',3G18.5)
      CALL MSGDOC(MDOC,LINE)

      IF(IPATT.EQ.1) THEN
        WRITE(LINE,31) P000
 31     FORMAT(' Patterson(000) :',G18.5)
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      WRITE(LINE,55) AMOM31,AMOM41
 55   FORMAT(' Moment_3, Moment_4:',2G18.5)
      CALL MSGDOC(MDOC,LINE)

      AVERP=0.0
      IF(NPOS.GT.0) THEN
        CF=(VOL*NPOS)/(NX*NY*NZ)
        AVERP=SUMP/CF
      ENDIF
      WRITE(LINE,80) NPOS,AVERP
   80 FORMAT(' NUMB D>0 , <D> :',I10,G18.5)
      CALL MSGDOC(MDOC,LINE)
      AVERN=0.0
      IF(NNEG.GT.0) THEN
        CF=(VOL*NNEG)/(NX*NY*NZ)
        AVERN=SUMN/CF
      ENDIF
      WRITE(LINE,82) NNEG,AVERN
   82 FORMAT(' NUMB D<0 , <D> :',I10,G18.5)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,84) NZER
   84 FORMAT(' NUMB D=0 :',I10)
      CALL MSGDOC(MDOC,LINE)
      NUMB1P=NPOS+NZER
      RMSP =0.0
      RMSN =0.0
      AVERN0=0.0
      AVERP0=0.0
      IF(NUMB1P.GT.0) THEN
        CF=(VOL*NUMB1P)/(NX*NY*NZ)
        AVERP0=SUMP /CF
        SUMP2 =SUMP2/CF
        RMSP =
     *  SQRT((SUMP2-AVERP0*AVERP0))
      ENDIF
      NUMB1N=NNEG+NZER
      IF(NUMB1N.GT.0) THEN
        CF=(VOL*NUMB1N)/(NX*NY*NZ)
        AVERN0=SUMN/CF
        SUMN2=SUMN2/CF
        RMSN =
     *  SQRT((SUMN2-AVERN0*AVERN0))
      ENDIF
      IF(RMSN.GT.0.0) THEN
        RPN=RMSP/RMSN
      ELSE
        RPN=0.0
      ENDIF
      WRITE(LINE,90) RMSP,AVERP0,RPN
   90 FORMAT(' for D >= 0 : RMS,<D> :',3G14.5)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,92) RMSN,AVERN0
   92 FORMAT(' for D = <0 : RMS,<D> :',2G14.5)
      CALL MSGDOC(MDOC,LINE)

      RESULT(1,1) = NUMB1
      RESULT(2,1) = DMAX1T
      RESULT(3,1) = DMIN1T
      RESULT(4,1) = RMS1
      RESULT(5,1) = AVER1
      RESULT(6,1) = NPOS
      RESULT(7,1) = NNEG
      RESULT(8,1) = RMSP
      RESULT(9,1) = RMSN
      RESULT(10,1) = AVERP0
      RESULT(11,1) = AVERN0
      IF(IPRROW.GE.15) THEN
        RESULT(12,1) = AMOM31
        RESULT(13,1) = AMOM41
        RESULT(14,1) = P000
        RESULT(15,1) = NZER
      ENDIF    
      RETURN
      END


C -I-
      SUBROUTINE RFFT(MDOC,POOL,MEMORY,RESMAX
     * ,NAMED,NAMEF,NAMEPH,PATH_SCR,ISYM,IPRSYM,RESULT,IERR)
C ---------------------------------------------
C -P- RFFT : REDUCT + RFT : fast fourie transform: real --> complex.
C            If space group isn't P1 program creates the scratch file 
C                                                      "scratch_rdc"
C -S-
C      Dialog and Batch:
C
C      FILE_D:  -  name of input dens-file.
C      FILE_F:  -  name of output file of modules of SF
C      FILE_PH: -  name of output file of phases  of SF
C      RESOL:  MAX <default from DENS-file> resolution
C
C      It possible to use subroutine RFFT by program:
C
C      SUBROUTINE RFFT(MDOC,POOL,MEMORY,RESMAX
C     * ,NAMED,NAMEF,NAMEPH,ISYM,IPRSYM,RESULT,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAMED - name of input dens-file.
C              Symmetry operators will be taken from this file.
C      NAMEF - name of output file of modules of SF
C      NAMEPH- name of output file of phases  of SF
C      RESMAX - resolution. Default values from DENS-file.
C      POOL   -  real array POOL(MEMORY).
C      MEMORY -  (MEMORY*2)/3 is memory for one Z-section of electron
C                density NX x NY.
C                     or
C                NCRES= (MEMORY-IPRSYM*9-2)/2 is memory for
C                the one Z-section of electron density NX x NY < NCRES.
C      ISYM  - integer*2 array for cryst.symmetry operators 
C      IPRSYM- dimension of integer*2 array ISYM(5,3,IPRSYM)
C      IERR  - signal of error / =1 -error , =o - OK / 
C
C      RESULT /real RESULT(11)/ - array for output information:
C
C      RESULT(1) - number of refls
C      RESULT(2) - min resolution
C      RESULT(3) - max resolution
C      RESULT(4) - F(0,0,0)
C      RESULT(5) - <!F!> = sqrt(<I>)
C      RESULT(6) - < I > 
C      RESULT(7) - number of points of density.
C      RESULT(8) - number of points of asymm. part
C      RESULT(9) - asymm. part for X : NX / NXasym.part  
C      RESULT(10) - asymm. part for Y : NY / NYasym.part
C      RESULT(11) - asymm. part for Z : NZ / NZasym.part
C -I-
C -------------------------------------------------------------
CMS      : POOL
      REAL POOL(MEMORY)
      REAL RESULT(11)
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMED*(*),NAMEF*(*),NAMEPH*(*),PATH_SCR*(*),NAME*256
      CHARACTER LINE*80,TYPE*4,MODE*1,PATH*1,EXT*3,TITLE*80,NAMES*256
C--------------------------------------------------------------
C      NCRESTR=MEMORY*2
C      NCRESR =NCREST/3
C ---
C      IPRSM = IPRSYM*9
C      IPRSM0= MEMORY-IPRSM+1
C      NCRES = (MEMORY-IPRSM-2)/2
C      NCRESF= (MEMORY-IPRSM-2)/3
C -----------------------------------------------------
      MTIN  = 40
      TYPE  = 'RI  '
      M     = 99
      ITYP  = 0
      CALL IRDENS(MTIN,NAMED,M,ITYP,ICNTZ,NX,NY,NZ,IZM,
     * IZN,RMAX,RMIN,POOL,SCALE,A,B,C,AL,BE,GA,DRMS,
     * RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE
     * ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT FILE--DENS')
        CLOSE(MTIN)
        RETURN
      ENDIF
      CLOSE(MTIN)
C ----------------------------------------   
      NAME  = NAMED
      NAMES = ' '
      IF(NSYM.GT.1) THEN
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          NAME = PATH_SCR(1:LEN)//'scratch_rdc'
        ELSE
          NAME = 'scratch_rdc'
        ENDIF
        CALL LENSTR_BL(NAME,LEN)
        NAMES = NAME(1:LEN)//'.dat'
        PATH = ' '
        EXT  = 'dat'
        M    = 99
        MTF  = 43
        CALL OPENUW(MTF,M,PATH,NAME,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR : OPEN SCRATCH_FILE')
          RETURN
        ENDIF
        CLOSE(MTF)
        MODE = 'R'
C ----
        CALL REDUCT(MDOC,NAMED,NAME,RESULT
     *    ,POOL,MEMORY,MODE,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) RETURN  
C ----
      ENDIF
C ----
      CALL RFT(MDOC,POOL,MEMORY,RESMAX
     * ,NAME,NAMEF,NAMEPH,PATH_SCR,ISYM,IPRSYM,RESULT,IERR)
C ----
      CALL LENSTR_BL(NAMES,LEN)
      IF(LEN.GT.0) THEN
        MT   = 43
        OPEN(UNIT=MT,FILE=NAMES,ACCESS='SEQUENTIAL',ERR=10)
        CLOSE(MT,STATUS='DELETE',ERR=10)
 10     CONTINUE
      ENDIF

      RETURN
      END

C -I-
      SUBROUTINE MODDEN(MDOC,NAME1,NAME2,NAMEW
     *    ,POOL,MEMORY,CONST1,CONST2,MSGF,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P- MODDEN : copy, change, modify electron density files.
C -P-          filter /Wangs's procedure/.     
C              This program reads one or two files type of "RI" (electron
C              density), performs on this file necessary operation and creates
C              output file  type of "RI". Program performs on one file: to add
C              to this information any number, to equal to zero if value on
C              this point less than given  number,... Program performs on two
C              input files: to add each other, to apply  filtering using second
C              file as mask,... 
C -S-
C      Dialog and Batch:
C
C FILE_1:   - name of input dens-file_1.
C
C MODE: <A> - add CONST to density. Programm reads from input file
C             value D then value D + CONST will be writen into output file.
C        C  - CUTTING DENS: D=CMIN IF < CMIN ,D=CMAX IF < CMAX
C        U  - CUTTING + ADD:  DENS: D=CMIN IF < CMIN ,D=CMAX IF < CMAX and 
C                             add (-CMIN)
C        T  - sTep function: D=1.0 IF >= CONST , D=0.0 IF < CONST 
C        P  - XY-projection of density / one output Z-section /.
C             IZMIN,IZMAX - numbers of first and
C             last Z-section
C        M  - multiply DENS * CONST
C        *  - DENS ** 2
C        Q  - SQRT(DENS)
C        R  - set DENS=0      : for region: R < CMIN and R > CMAX 
C        B  - soft set DENS=0 : Density of point with distance R will be
C             multiplied by (1-exp(-R^2/2*CMIN)*exp(-R^2/(0.5*CMAX))
C             R is minimal value of four distancies to current point from eight
C             points: 0,0,0; 1,0,0; 0,1,0; 1,1,0; 0,0,1; 1,0,1; 0,1,1; 1,1,1
C             CMIN,CMAX - in angstroms
C
C           If we use two files:
C
C        2  - multiply  DENS-1 * DENS-2
C        D  - division  DENS-1 / DENS-2
C        S  - substract DENS-1 - DENS-2*CONST 
C        F  - filter /Wangs's procedure/
C            If D1 is value of DENS-1 and D2 value of DENS-2 in the same 
C            point, program will write Dnew into output file: 
C                Dnew = D1  if D2 > CONST
C                       0   if D2 < CONST
C                                           DENS-2 is mask-file
C                                     DENS-1 ----------------> DENS-OUT
C                                            if DENS-2 > CONST          
C                                            else  0 -------> DENS-OUT
C   FILE_2:   input_file_2 name
C   FILE_O:   output_file name
C   CONST: <0.0> - for MODE = A - add : DENS + CONST')
C                             M - multiply: DENS * CONST')
C                             S - subtract DENS-1 - DENS-2*CONST')
C                             F - level for mask-file FILE-2')
C   CLIM: CMIN,CMAX <0,0> -   C - cutting ---> CMIN < DENS < CMAX')
C                                 CMAX=0 means without this limit')
C                             R - set DENS=0 : R < CMIN and R > CMAX 
C                             B - soft set DENS=0 
C                                 (1-exp(-R^2/2*CMIN)*exp(-R^2/(0.5*CMAX))
C                                 CMIN,CMAX - in angstroms
C   ZLIM: ZMIN,ZMAX - numbers of Z-section for projection (MODE=P)')
C
C      SUBROUTINE MODDEN(MDOC,NAME1,NAME2,NAMEW
C     *    ,POOL,NCREST,CONST1,CONST2,MSGF,ISYM,IPRSYM,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAME1  - name of input dens-file_1.
C      NAME2  - name of input dens-file_2, if you want it, if not = " ".
C      NAMEW  - name of output dens-file.
C      MSGF   = MODE - function of program, see above / character*1/.
C      CONST1 = CONSTANT or = CMIN or = ZMIN  - see above.
C      CONST2               = CMAX or = ZMAX  
C      POOL   -  real array POOL(MEMORY).
C      MEMORY -  MEMORY/2 is memory for one Z-section of electron
C                density NX x NY.
C      ISYM  - integer*2 array for cryst.symmetry operators.
C      IPRSYM- dimension of integer*2 array ISYM(5,3,IPRSYM)
C      IERR  - signal of error / =1 -error , =o - OK / 
C -I-
C ----------------------
CMS      : POOL
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      POOL(MEMORY)
      INTEGER*4 NCRES,MEMORY,IPRMAP
      CHARACTER NAME1*(*),NAME2*(*),NAMEW*(*),MSGF*1
      CHARACTER LINE*80
C -------------------------------------------------------------
      MD=-ABS(MDOC)-1
      IFLS=2
      IF(NAME2(1:1).EQ.' ') IFLS=1
      IF(MSGF.EQ.'a') MSGF='A'
      IF(MSGF.EQ.'c') MSGF='C'
      IF(MSGF.EQ.'p') MSGF='P'
      IF(MSGF.EQ.'m') MSGF='M'
      IF(MSGF.EQ.'q') MSGF='Q'
      IF(MSGF.EQ.'d') MSGF='D'
      IF(MSGF.EQ.'s') MSGF='S'
      IF(MSGF.EQ.'f') MSGF='F'
      IF(MSGF.EQ.'r') MSGF='R'
      IF(MSGF.EQ.'b') MSGF='B'
      IF(MSGF.EQ.'u') MSGF='U'
      IF(MSGF.EQ.'t') MSGF='T'
      IF(MSGF.NE.'2'.AND.MSGF.NE.'F'.AND.MSGF.NE.'B'.AND.
     *   MSGF.NE.'A'.AND.MSGF.NE.'D'.AND.MSGF.NE.'Q'.AND.
     *   MSGF.NE.'M'.AND.MSGF.NE.'C'.AND.MSGF.NE.'*'.AND.
     *   MSGF.NE.'T'.AND.MSGF.NE.'U'.AND.
     *   MSGF.NE.'S'.AND.MSGF.NE.'P'.AND.MSGF.NE.'R') THEN
        MSGF='A'
      ENDIF
      WRITE(LINE,*) ' FUNCTION :',MSGF
      CALL MSGDOC(MD,LINE)

      IF(MSGF.EQ.'M') THEN
C       M  - MULTIPLY DENS * CONST
        AMLT=CONST1
        IF(AMLT.EQ.0.0) AMLT=1.0
        WRITE(LINE,*) ' COEF /DENS * COEF/ :',AMLT
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'C') THEN
C       C  - CUTTING DENS: D=0 IF < CMIN ,D=CMAX IF < CMAX
        CMIN=CONST1
        CMAX=CONST2
        IF(CMAX.LE.0.0) CMAX=1.E 30
        WRITE(LINE,*) ' CUTTING LEVELS: CMIN,CMAX:',CMIN,CMAX
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'U') THEN
C       U  - CUTTING DENS + (-CMIN)
        CMIN=CONST1
        CMAX=CONST2
        IF(CMAX.LE.0.0) CMAX=1.E 30
        WRITE(LINE,*) ' CUTTING LEVELS: CMIN,CMAX:',CMIN,CMAX
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'R') THEN
        CMIN=CONST1
        CMAX=CONST2
        IF(CMAX.LE.0.0) CMAX=1.E 30
        WRITE(LINE,*) ' SET ZERO: RADII: RMIN,RMAX:',CMIN,CMAX
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'B') THEN
        CMIN=CONST1
        CMAX=CONST2
        WRITE(LINE,*) ' soft SET ZERO: RMIN,RMAX:',CMIN,CMAX
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'A') THEN
C       A  - ADD : DENS + CONST
        ADD=CONST1
        WRITE(LINE,*) ' ADD-CONST :',ADD
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'T') THEN
C       T  - step function : DENS=0 if <CONST; DENS=1.0 if >= CONST
        ADD=CONST1
        WRITE(LINE,*) ' LEVEL-CONST :',ADD
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'P') THEN
C       P  - XY-PROJECTION DENS
        IZMINW=CONST1
        IZMAXW=CONST2
        IF(IZMAXW.LT.IZMINW) THEN
          IT=IZMAXW
          IZMAXW=IZMINW
          IZMINW=IT
        ENDIF
        WRITE(LINE,'('' IZMIN,IZMAX :'',2I5)') IZMINW,IZMAXW
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'S') THEN
C       S  - SUBTRACT DENS-1 - DENS-2
        DSCALE=CONST1
        IF(DSCALE.EQ.0.0) DSCALE=1.0
        WRITE(LINE,*) ' CONST :',DSCALE
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'F') THEN
C       F  - FILTER /WANG''S PROCEDURE/
        ALEVEL=CONST1
        WRITE(LINE,*) ' CONST :',ALEVEL
        CALL MSGDOC(MD,LINE)
      ENDIF
C ------------------------------------------------------------
      NCRES  = MEMORY/4
      IPRMAP = NCRES*2
      CALL MODDN1(MDOC,NAME1,NAME2,NAMEW
     *    ,POOL(1),POOL(NCRES+1),POOL(NCRES*2+1),IPRMAP,DSCALE
     *    ,MSGF,AMLT,IFLS,CMIN,CMAX,ADD
     *    ,IZMINW,IZMAXW,ALEVEL,ISYM,IPRSYM,IERR)
      RETURN
      END

      SUBROUTINE MODDN1(MDOC,NAME1,NAME2,NAMEW
     *    ,IPOOLA,IPOOLB,POOLC,NCRES,DSCALE
     *    ,MSGF,AMLT,IFLS,CMIN,CMAX,ADD
     *    ,IZMINW,IZMAXW,ALEVEL,ISYM,IPRSYM,IERR)
CMS      : IPOOLA,IPOOLB,POOLC
      INTEGER*2 IPOOLA(NCRES),IPOOLB(NCRES)
      REAL      POOLC(NCRES)
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAME1*(*),NAME2*(*),NAMEW*(*),MSGF*1
      CHARACTER TTT1*80
      CHARACTER TTT2*80
      CHARACTER TTTW*80,TYPE*4
      CHARACTER LINE*80
      REAL XF(3),XC(3)
C ----------------------------------------------------------------------
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
C --------------------------------------------------------------------
      IERR=0
C--------------------------------------
C     READ OF TITLE OF FILE-1
C
      ITYPE  = 0
      MTIN1  = 40
      MD     = -ABS(MDOC)-1
C     WRITE(*,*) '      INPUT FILE /DENS/ - 1'
      CALL IRDENS(MTIN1,NAME1,MDOC,ITYPE,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     * IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS1,
     * RAVER,RESOL1,IX01,IY01,IZ01,ITR1,TTT1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE-DENS-1')
        IERR=1
        RETURN
      ENDIF
      CALL C_RD_CR
      NXY1   = NX1*NY1
      IXMIN1 = 0
      IXMAX1 = NX1-1
      IYMIN1 = 0
      IYMAX1 = NY1-1
      IX0W   = IX01
      IY0W   = IY01
      IZ0W   = IZ01
      TTTW   = TTT1
      IF(IZMAXW.GT.IZMAX1) IZMAXW=IZMAX1
      IF(IZMINW.LT.IZMIN1) IZMINW=IZMIN1
C ---
C -----------------------------------------------------------
      IF(IFLS.EQ.2) THEN
        ITYPE = 0
        MTIN2 =41
C       WRITE(*,*) '      INPUT FILE /DENS/ - 2'
        CALL IRDNS2(MTIN2,NAME2,MD,ITYPE,ICNTZ2,NX2,NY2,NZ2,IZMAX2,
     *  IZMIN2,RMAX2,RMIN2,IPOOLB,SCALE2,A2,B2,C2,AL2,BE2,GA2,DRMS2,
     *  RAVER,RESOL2,IX02,IY02,IZ02,ITR2,TTT2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-DENS-2')
          CLOSE(MTIN1)
          IERR=1
          RETURN
        ENDIF
        NXY2 = NX2*NY2
      ELSE
        MTIN2 = 0
      ENDIF
C--------------------------------------------------------
      ALW = AL1
      BEW = BE1
      GAW = GA1
      IF(MSGF.EQ.'P') THEN
        AW    = A1
        BW    = B1
        CW    = C1
        NXW   = NX1
        NYW   = NY1
        NZW   = 1
        IXMINW= 0
        IXMAXW= NXW-1
        IYMINW= 0
        IYMAXW= NYW-1
        IZMINP= IZMINW
        IZMAXP= IZMAXW
        IZMINW= 0
        IZMAXW= 0
      ELSE
        AW    = A1
        BW    = B1
        CW    = C1
        NXW   = NX1
        NYW   = NY1
        NZW   = NZ1
        IXMINW= 0
        IXMAXW= NXW-1
        IYMINW= 0
        IYMAXW= NYW-1
        IZMINW= IZMIN1
        IZMAXW= IZMAX1
      ENDIF
C--------------------------------------------------------
      MTS      = 43
      TTTW(1:4)= 'MODI'
      TTTW(5:8)= 'M '//MSGF//' '
      TYPE     = 'RI  '
      IPRINT   = 1
      CALL C_CR_WR
      NS1 = NSYM
      IF(MSGF.EQ.'R'.OR.MSGF.EQ.'B') THEN
C 
        NS_WR = 1
        SG_WR = 'P 1'
C
        NS1=1

      ENDIF

C     WRITE(*,*) '      OUTPUT-FILE'
      CALL SET_TITLE(MDOC,AW,BW,CW,ALW,BEW,GAW
     *  ,DDM,DDM,DDM,DDM,NXW,NYW,NZW,IZMINW,IZMAXW,TTTW,IERR)

      CALL LENSTR_BL(NAMEW,LEN)
      IF(LEN.LE.0.OR.NAMEW(1:1).EQ.','.OR.NAMEW.EQ.' ') THEN
        CALL MSGERR(MD,' ERR: OPEN OUTPUT-FILE-DENS')
        CLOSE(MTIN1)
        IF(MTIN2.GT.0) CLOSE(MTIN2)
        IERR=1
        RETURN
      ENDIF 
      CALL OWFILE(MDOC,MTS,NAMEW,TYPE,NS1,ISYM,IPRSYM,IERR)
      IF(IERR.EQ.2) GO TO 100
      IF(IERR.GT.0) THEN
        CLOSE(MTIN1)
        IF(MTIN2.GT.0) CLOSE(MTIN2)
        RETURN
      ENDIF
C      CALL WTITLE(MTS,NAMEW,MDOC,TYPE,IPRINT,AW,BW,CW,ALW,BEW,GAW,DDM,
C     * DDM,DDM,DDM,NXW,NYW,NZW,IZMINW,IZMAXW,TTTW)
      IF(MSGF.EQ.'P') THEN
        NXYW = NXW*NYW
        DO     I=1,NXYW
          POOLC(I)=0.0
        ENDDO
      ENDIF
C---------------------------------------------------------------
      ICNTZ3 = -999
      ITYPE  = 1
      ITYPE1 = 1
      ITYPE2 = 1

      IF(MSGF.EQ.'F') THEN
        WRITE(LINE,201)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,200)
 200    FORMAT(3X,'X',3X,'Y',3X,'Z',6X,'R-MAX',7X,'X',3X,'Y',
     *         3X,'Z',6X,'R-MIN',8X,'TIME',8X,'N+/N')
 201    FORMAT(' ')
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,201)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C---------------------------------------------------------------
      PERCNT=0.0
      AVER  =0.0
      RMS   =0.0
      DSUM1 = 0.0
      DSUM2 = 0.0
      DSUMO = 0.0
      DSUMP = 0.0
      DSUMN = 0.0
      DSUMO2= 0.0
      D2    = 0.0
      NUMB  = 0
      NNN1  = 0
      NNN2  = 0
      NNNP  = 0
      NNNN  = 0
      NNNZ  = 0
      N     = 0
      NZN   = 0
C      WRITE(*,*)
      DO     IZ=IZMIN1,IZMAX1
        IF(MSGF.EQ.'P'.AND.IZ.GT.IZMAXP) GO TO 100
        Z   = IZ/FLOAT(NZ1)
        NN1 = 0
        NN2 = 0

C-----------------------
        CALL IRDENS(MTIN1,NAME1,MDOC,ITYPE1,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     *  IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS1,
     *  RAVER,RESOL1,IX01,IY01,IZ01,ITR1,TTT1,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-DENS-1')
          IERR=1
          IF(MTIN2.GT.0)CLOSE(MTIN2)
          CLOSE(MTS)
          RETURN
        ENDIF
        IF(MTIN2.GT.0) THEN
        CALL IRDNS2(MTIN2,NAME2,MDOC,ITYPE2,ICNTZ2,NX2,NY2,NZ2,IZMAX2,
     *  IZMIN2,RMAX2,RMIN2,IPOOLB,SCALE2,A2,B2,C2,AL2,BE2,GA2,DRMS2,
     *  RAVER,RESOL2,IX02,IY02,IZ02,ITR2,TTT2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-DENS-2')
          CLOSE(MTIN1)
          CLOSE(MTS)
          IERR=1
          RETURN
        ENDIF
        ENDIF
C-----------------------
        IF(MSGF.EQ.'P'.AND.IZ.LT.IZMINP) GO TO 300
        N=0
        DO     IY=IYMINW,IYMAXW
          IYY   = IY
          Y     = IY/FLOAT(NY1)
          IND0  = IY*NX1
          INDD0 = IND0
          DO     IX=IXMINW,IXMAXW
            X    = IX/FLOAT(NX1)
            IXX  = IX
            IND  = IND0+IX+1
            INDD = IND
            D1   = IPOOLA(IND)/SCALE1
            IF(MTIN2.GT.0) D2=IPOOLB(IND)/SCALE2
C       -------  F ----------
            IF(MSGF.EQ.'F') THEN
              IF(D2.GT.ALEVEL) THEN
                NN1  = NN1+1
                NNN1 = NNN1+1
                DOUT = D1
              ELSE
                DOUT = 0.0
                NN2  = NN2+1
                NNN2 = NNN2+1
              ENDIF
C       -------  2 ----------
            ELSE IF(MSGF.EQ.'2') THEN
              DOUT = D1*D2
C       -------  M ----------
            ELSE IF(MSGF.EQ.'M') THEN
              DOUT = D1*AMLT
C       -------  * ----------
            ELSE IF(MSGF.EQ.'*') THEN
              DOUT = D1*D1
C       -------  Q ----------
            ELSE IF(MSGF.EQ.'Q') THEN
              IF(D1.LE.0.0) THEN
                DOUT = 0.0
              ELSE
                DOUT = SQRT(D1)
              ENDIF
C       -------  P ----------
            ELSE IF(MSGF.EQ.'P') THEN
              DOUT = D1
C       -------  S ----------
            ELSE IF(MSGF.EQ.'S') THEN
              DOUT = D1-D2*DSCALE
C       -------  D ----------
            ELSE IF(MSGF.EQ.'D') THEN
              IF(ABS(D2).GT.1.E-8) THEN
                DOUT = D1/D2
              ELSE
                DOUT = 0.0
              ENDIF
C       -------  C ----------
            ELSE IF(MSGF.EQ.'C') THEN
              DOUT = D1
              IF(D1.LT.CMIN) DOUT = CMIN
              IF(D1.GT.CMAX) DOUT = CMAX
C       -------  U ----------
            ELSE IF(MSGF.EQ.'U') THEN
              DOUT = D1
              IF(D1.LT.CMIN) DOUT = CMIN
              IF(D1.GT.CMAX) DOUT = CMAX
              DOUT=DOUT+(-CMIN)
C       -------  R ----------
            ELSE IF(MSGF.EQ.'R') THEN
              XX = X
              YY = Y
              ZZ = Z
              IF(XX.GT.0.5) XX = 1.0-XX
              IF(YY.GT.0.5) YY = 1.0-YY
              IF(ZZ.GT.0.5) ZZ = 1.0-ZZ
              XF(1) = XX
              XF(2) = YY
              XF(3) = ZZ
              CALL FTOO(XF,XC,IERR)
              DIST=SQRT(XC(1)*XC(1)+XC(2)*XC(2)+XC(3)*XC(3))   
              DOUT = D1
              IF(DIST.LT.CMIN) DOUT = 0.0
              IF(DIST.GT.CMAX) DOUT = 0.0
C       -------  B ----------
            ELSE IF(MSGF.EQ.'B') THEN
              XX = X
              YY = Y
              ZZ = Z
              IF(XX.GT.0.5) XX = 1.0-XX
              IF(YY.GT.0.5) YY = 1.0-YY
              IF(ZZ.GT.0.5) ZZ = 1.0-ZZ
              XF(1) = XX
              XF(2) = YY
              XF(3) = ZZ
              CALL FTOO(XF,XC,IERR)
              DIST2 = XC(1)*XC(1)+XC(2)*XC(2)+XC(3)*XC(3)   
              IF(CMIN.GT.0.0) THEN
                CINN = 1.0-EXP(-DIST2/(2.0*CMIN*CMIN))
              ELSE
                CINN = 1.0
              ENDIF
              IF(CMAX.GT.0.0) THEN
                COUT = EXP(-DIST2/(0.5*CMAX*CMAX))
              ELSE
                COUT = 1.0
              ENDIF
              DOUT = D1*CINN*COUT
C       -------  T ----------
            ELSE IF(MSGF.EQ.'T') THEN
              IF(D1.LT.ADD) THEN
                DOUT = 0.0
              ELSE
                DOUT = 1.0
              ENDIF
C       -------  A ----------
            ELSE IF(MSGF.EQ.'A') THEN
              DOUT = D1+ADD
            ENDIF
C ---
            IF(MSGF.EQ.'P') THEN
              POOLC(INDD)=POOLC(INDD)+DOUT
            ELSE
              POOLC(INDD)=DOUT
            ENDIF
            DSUM1  = DSUM1  + D1
            DSUM2  = DSUM2  + D2
            DSUMO  = DSUMO  + DOUT
            DSUMO2 = DSUMO2 + DOUT*DOUT
            NUMB=NUMB+1
            IF(MSGF.NE.'F') THEN
              IF(DOUT.GT.0) THEN
                DSUMP = DSUMP+DOUT
                NNN1  = NNN1+1
              ELSE IF(DOUT.LT.0) THEN
                DSUMN = DSUMN+DOUT
                NNN2  = NNN2+1
              ELSE
                NNNZ = NNNZ+1
              ENDIF
            ENDIF
C----XXXX---YYYY-------
  500       CONTINUE
          ENDDO
  400     CONTINUE
        ENDDO
        IF(N.GT.0) NZN=IZ
C---------------------
      IF(MSGF.EQ.'F') THEN
        PERSNT=(NN1*100.)/FLOAT(NN1+NN2)
        CALL WDENSC(MTS,MDOC,ICNTZ3,NXW,NYW,NZW,IZMINW,IZMAXW,
     *       RMAXD,RMIND,POOLC,RESOL1,IX01,IY01,IZ01,ITR1,PERSNT)
      ELSE IF(MSGF.EQ.'P'.AND.IZ.EQ.IZMAXP) THEN
        CALL WDENS(MTS,MDOC,ICNTZ3,NXW,NYW,NZW,IZMINW,IZMAXW,
     *             RMAXD,RMIND,POOLC,RESOL1,IX01,IY01,IZ01,ITR1)
      ELSE IF(MSGF.NE.'P') THEN
        CALL WDENS(MTS,MDOC,ICNTZ3,NXW,NYW,NZW,IZMINW,IZMAXW,
     *             RMAXD,RMIND,POOLC,RESOL1,IX01,IY01,IZ01,ITR1)
      ENDIF
      IF(MTS.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: OUTPUT-FILE-DENS')
        IERR=1
        CLOSE(MTIN1)
        IF(MTIN2.GT.0) CLOSE(MTIN2)
        RETURN
      ENDIF
  300 CONTINUE
C---ZZZZZZZZZ----------
      ENDDO
C----------------------
  100 CONTINUE
      IF(MSGF.EQ.'F') THEN
        PERSNT=(NNN1*100.)/FLOAT(NNN1+NNN2)
        WRITE(LINE,'('' N+,N0,% :'',2I8,F8.2)') NNN1,NNN2,PERSNT
        CALL MSGDOC(MDOC,LINE)
      ELSE
        AVER=0.0
        RMS=0.0
        IF(NUMB.GT.0) THEN
          AVER=DSUMO/NUMB
          RMS=SQRT((DSUMO2+NUMB*AVER*AVER-2.0*AVER*DSUMO)/NUMB)
        ENDIF
        WRITE(LINE,'('' <D>,RMS(R),N ='',2G16.4,I10)') AVER,RMS,NUMB
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,40) DSUMO,DSUMO2
   40   FORMAT(' SUM-R, SUM-R**2 :',2G18.5)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,80) NNN1,DSUMP
   80   FORMAT(' NUMB D>0 , SUM:',I10,G18.5)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,82) NNN2,DSUMN
   82   FORMAT(' NUMB D<0 , SUM:',I10,G18.5)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,84) NNNZ
   84   FORMAT(' NUMB D=0 :',I10)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C---------------------
      CLOSE(MTIN1)
      IF(MTIN2.GT.0) CLOSE(MTIN2)
      CLOSE(MTS)
      RETURN
      END

      SUBROUTINE WDENSC(MTOUT,MDOC,ICNTZ,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,POOL,RESOL,IX0,IY0,IZ0,ITR,PERSNT)
C ------------------------------------------
CMS      : POOL
      REAL POOL(*)
      COMMON/COM_WDC/ AVER,AVER2
C ------------------------------------------
      CALL WSECTC(MTOUT,MDOC,ICNTZ,IZMIN,IZMAX,NX,NY,RMAX,RMIN,POOL
     *          ,POOL,AVER,AVER2,PERSNT)
      IF(MTOUT.EQ.0) RETURN
      IF(ICNTZ.GE.IZMAX) THEN
        CALL WTTL2C(MTOUT,MDOC,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,IX0,IY0,IZ0,ITR,AVER,AVER2,RESOL)
        IF(MTOUT.EQ.0) RETURN
        END FILE MTOUT
        CLOSE(MTOUT)
      ENDIF
      END

      SUBROUTINE WTTL2C(MTOUT,MDOC,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,IX0,IY0,IZ0,ITR,AVER,AVER2,RESOL)
C ------------------------------
      INTEGER*4 NR
      INTEGER ILINE(20)
      CHARACTER LINE*80
      EQUIVALENCE (LINE,ILINE(1))
      DATA NWW/20/
C------------------------------------
      MT=ABS(MTOUT)
      NR=NX*NY
      NR=NR*(IZMAX-IZMIN+1)
C     ----------------
      AVER=AVER/NR
      AVER2=AVER2/NR
      RMS=AVER2-AVER*AVER
      IF(RMS.LT.0.0) RMS=0.0
      IF(RMS.GT.0.0) RMS=SQRT(RMS)  
      DELX=RMS
      DELY=RESOL
      DELZ=AVER
      WRITE(LINE,32) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
32    FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
      CALL WBLOCK(MT,ILINE,NWW,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE FILE-OUT')
        CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
c      IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
        CALL MSGDOC(MDOC,' ------------------------------------ ')
        WRITE(LINE,'('' RMAX :'',G12.4,''  RMIN :'',G12.4)') RMAX,RMIN
        CALL MSGDOC(MDOC,LINE)
c      ENDIF
c      IF(MTOUT.GT.0) THEN
c        MMDOC=0
c        CALL MSGDOC(MMDOC,' ------------------------------------')
c        WRITE(LINE
c     .   ,'('' RMAX :'',G12.4,''  RMIN :'',G12.4)') RMAX,RMIN
c        CALL MSGDOC(MMDOC,LINE)
c      ENDIF
      RETURN
      END

      SUBROUTINE WSECTC(MTOUT,MDOC,IZ,IZMIN,IZMAX,NX,NY,RMAX,RMIN
     *                  ,POOL,IPOOL,AVER,AVER2,PERSNT)
C -----------------------------------------
CMS      : POOL,IPOOL
      REAL POOL(*)
      INTEGER IDATE(7)
      INTEGER*2 IPOOL(*),IDAT(8)
      CHARACTER LINE*80
      EQUIVALENCE (IDAT(1),SCAL1),(IDAT(3),SCAL),(IDAT(5),RM)
      EQUIVALENCE (IDAT(7),RN)
      DATA NW8/4/
C ----------------------------------------
      MT=ABS(MTOUT)
      IF(IZ.EQ.-999) THEN
        RMAX=-1.E 30
        RMIN= 1.E 30
        AVER=0.0
        AVER2=0.0
        IZ=IZMIN
      ELSE
        IZ=IZ+1
      ENDIF
      SCAL1=1.
      RN= 1.E 30
      RM=-1.E 30
      NXY=NX*NY
      DO     J=1,NY
        IY=J-1
        IND=IY*NX
        DO     I=1,NX
          IX=I-1
          INDX=IND+I
          R=POOL(INDX)
          AVER=AVER+ABS(R)
          AVER2=AVER2+R*R
          IF(R.GE.RMAX) RMAX=R
          IF(R.LE.RMIN) RMIN=R
          IF(R.GE.RM) THEN
            RM=R
            IXM=IX
            IYM=IY
          ENDIF
          IF(R.LE.RN) THEN
            RN=R
            IXN=IX
            IYN=IY
          ENDIF
        ENDDO
      ENDDO
      RRMAX=MAX(ABS(RM),ABS(RN))
      IF(ABS(RRMAX).GT.1.E-6) THEN
        SCAL=(32 766.)/RRMAX
      ELSE
        SCAL=1.
      ENDIF
      DO     J=1,NY
        IND=(J-1)*NX
        DO     I=1,NX
          INDX=IND+I
          PL=POOL(INDX)*SCAL
          IF(ABS(PL).GT.32766.) PL=SIGN(32766.,PL)
          IPOOL(INDX)=PL
        ENDDO
      ENDDO

      CALL WBLOCK_I2(MT,IDAT,NW8,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE DATA TO FILE-OUT')
        CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      NXY2=NXY/2

      CALL WBLOCK_I2(MT,IPOOL,NXY2,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE DATA TO FILE-OUT')
        CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      CALL CLOCK(IDATE)
c      IF(MDOC.GT.0) THEN
        WRITE(LINE,1) IXM,IYM,IZ,RM,IXN,IYN,IZ,RN,IDATE(4),IDATE(3)
     *               ,IDATE(2),PERSNT
        CALL MSGDOC(MDOC,LINE)
c      ENDIF
C --------
c      IF(MTOUT.GT.0) THEN
c        MMDOC=0
c        WRITE(LINE,1) IXM,IYM,IZ,RM,IXN,IYN,IZ,RN,IDATE(4),IDATE(3)
c     *               ,IDATE(2),PERSNT
c        CALL MSGDOC(MMDOC,LINE)
c      ENDIF
    1 FORMAT(' ',3I4,1X,G12.4,' , ',3I4,1X,G12.4,' ; ',I2,2('.',I2)
     *    ,' %=',F5.1)
      RETURN
      END


C -I-
      SUBROUTINE GENDEN(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADD,P1
     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C -P- GENDEN  :  generates electron density for the atomic model. 
C                The model may represents atoms as the spheres with inside 
C                density depending on the position of model in the unit cell
C                (usefull to study the packing of the moleculs in the unit).
C                By use the program "modden" you can have the contents of
C                the unit cell with the constant value inside molecules and
C                equal to zero outside. If you want to take into account the
C                surface of area of atoms this value must be written instead
C                of the occupancy ( by the program "surf_pnt" )
C                Program can calculate the distribution of the charges.
C                In this case coordinate's file must have the atomic charge
C                instead of the occupancy. 
C -S-
C
C  Dialog and Batch: 
C
C    FILE_C -  input file of coordinates.
C    FILE_D -  output file of density
C    RESOL  -  <3.0> resolution
C    GRID   -  NX NY NZ /defaults are minimal grid spacing for SF calculation/
C    LIMZ:  -  MIN MAX numbers of Z-section /default are for SF calculation/
C    BADD:  -  <0.0> additional B-factor /default Badd_calc for SF calculation/
C              -1 means Badd_calc will used, 0 means Badd_calc will used (exept
C              case with Bmin > 10 where Badd = - Bmin + 5 )
C    H2O:   -  <0.0> density of solvent
C    P1:    -  calculate density for P1 spase group
C    MODE:  -  <A> - generate atomic density.
C               S  - density for the spheres in the centre of atom with
C                    the radius RAD.
C               C  - distribution of the charges.
C           if MODE = "S" ,value of radii will be used:
C    RAD    -  <0.0>  - radius of sphere. 
C              if RAD > 0 then Radius =  input RAD
C                 RAD = 0 then Radius = Van-der-Waals radius
C                 RAD < 0 then if SURFACE-AREA=0 then Radius =ABS(RAD)
C                                                else Radius =Van-der-Waals_rad
C    TITLE    - title of output file
C
C  Parameters of subroutine GENDEN: 
C
C      SUBROUTINE GENDEN(MDOC,NAMEC,NAMED,TITLE
C     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADD,P1
C     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    MODE   - see above. / character*1 /
C    NAMEC  - name of input file without extention "crd".
C    NAMED  - name of output file of density.
C    RX     -  <3.0> resolution
C    NX,NY,NZ - grid /defaults are minimal grid spacing for SF calculation/
C    BADD    -  <0.0> additional B-factor /default are for SF calculation/
C    H2OBG   -  <0.0> density of solvent
C    P1      -  calculate density for P1 spase group. /character*1/
C    MODE    -  see above. /character*1/
C    RAD     -  <0.0> radius of sphere 
C              if RAD > 0 then Radius = RAD
C                 RAD = 0 then Radius = R-Van-der-Waals
C                 RAD < 0 then if SURFACE-AREA=0 then Radius = ABS(RAD)
C                                                else Radius=R-Van-der-Waals
C    TITLE  -  title of output file, /character*80/
C    IZMIN,IZMAX  -  MIN MAX numbers of Z-section. /if IZMIN=0,IZMAX=-1 
C                    default values for SF calculation will be taken /
C    NCRDMAX - maximal number of atoms.
C    POOL    - real array POOL(MEMORY)
C    MEMORY  - dimension array POOL. 
C              MEMORY = MAPMAX + (NCRDMAX/2)*5 , where MAPMAX - maximal
C                                                size of XY-section ( NX*NY)
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C
C        output information 
C
C      real RESULT(IPRROW)
C
C      NEL   = RESULT(1)  number of electrons
C      SUMFI2= RESULT(2)  sum(Nelectrons**2)
C      BAVER = RESULT(3)  <B>   in the file
C      BMAX  = RESULT(4)   Bmax in the file
C      BMIN  = RESULT(5)   Bmin in the file
C      BAVERW= RESULT(6)   B_water in the file
C      BAVERF= RESULT(7)  <B> / including B from atomic scatt. factor /  
C      SUMDEN= RESULT(8)  sum(DENSITY) =  (sum(D)*volume)/(nx*ny*nz)
C      HH2OBG= RESULT(9)  density in the solvent region which was added.
C      SOLV  = RESULT(10) % of the solvent.
C      BADD  = RESULT(11) additional B-factor which was used.
C -I-
C ----------------------------------------------------------
CMS      : POOL
      REAL             POOL(MEMORY)
      INTEGER*2        ISYM(5,3,IPRSYM)
C---------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),TITLE*(*),MODE*1,P1*1
C==================================================================
      REAL RESULT(IPRROW)
C ----------------------------------------
C --- integer*2 version
C     IPRCRD  = (NCRDMAX/2)*5 
C ---
C --- integer*4 version
      IPRCRD  = (NCRDMAX)*5 
C ---
      IPRMAP  = MEMORY-IPRCRD
      IF(IPRMAP.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: NOT MEMORY')
        IERR=1
        RETURN
      ENDIF
C ---
      CALL SGENDEN(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADD,P1
     * ,RESULT,IPRROW,ISYM,IPRSYM,POOL(IPRMAP+1),NCRDMAX
     * ,POOL(1),IPRMAP,IERR)
C ---
      RETURN
      END

      SUBROUTINE SGENDEN(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDR,P1
     * ,RESULT,IPRROW,ISYM,IPRSYM,ICOORD,NCOORM,X,IPRMAP,IERR)
C ----------------------------------------------------------
      REAL RESULT(IPRROW)
C ----------------------------------------------------------

      COMMON/CELLL/ A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,HH2OBG,ICELL
C ---
      COMMON/DIMM/  DMAX,NNX,NNY,NNZ,IIZMIN,IIZMAX,IHMAX,IKMAX,ILMAX
      COMMON/COM_VOL/ VOL
C ---------------------------------------
C --- integer*2 version
C      INTEGER*2  ICOORD(1)
C --- integer*4 version
      INTEGER  ICOORD(*)
C ---
C      INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C      INTEGER          NCOORD,NCOORM
C --
CMS      : X,ICOORD
c     REAL             X(IPRMAP)
      REAL             X(*)
C --
      INTEGER*2        ISYM(5,3,IPRSYM)
C --------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),TITLE*(*),MODE*1,P1*1
      CHARACTER LINE*80,STR*80,PATH*1,EXT*3
C==================================================================
      IERR=0
      MT  =10
      MD  =-ABS(MDOC)-1
      CALL ORCRD(MD,MT,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN COORD_FILE.')          
        CALL LENSTR_BL(NAMEC,LEN)
        IF(LEN.GT.50) LEN=50
        IF(LEN.GT.0) THEN
          WRITE(LINE,'(''FILE:'',A,'';'')') NAMEC(1:LEN)
          CALL MSGERR(MDOC,LINE)
        ELSE
          CALL MSGERR(MDOC,'FILE: /length=0/')
        ENDIF
        GO TO 500
      ENDIF
      CALL C_AT_CR
      CLOSE(MT)
C ---
c?      MT   =11
c?      PATH =' '
c?      EXT  =' '
c?      MD   = -ABS(MDOC)-1
c?      CALL OPENUW(MT,MD,PATH,NAMED,EXT,IERR)
c?      IF(IERR.NE.0) THEN
c?        CALL MSGERR(MDOC,' ERR: OPEN DENS_FILE')
c?        GO TO 500
c?      ENDIF
c?      CLOSE(MT)
C -------------------------------------------
      STR=TITLE
      CALL LENSTR_BL(STR,LEN)
      IF(LEN.LE.0) THEN
        LEN=1
        STR=' '
      ENDIF
      IF(STR(1:3).EQ.',,,') THEN
        STR=' ---'
        LEN=4
      ENDIF
      IF(LEN.GT.60) LEN=60
      TITLE = 'GEN-DEN '//STR(1:LEN)
      LEN=LEN+8
      IF(LEN.LT.68) THEN
        DO I=LEN+1,68
          TITLE(I:I)=' '
        ENDDO
      ENDIF
      IF(P1.EQ.'y') P1='Y'
      IF(P1.NE.'Y') P1='N'
C ---------------------------------------------
      IF(RX.LE.0.0) RX=3.0 
      DMAX=RX
C ----
      CALL LIMHKL(RX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
      WRITE(LINE,1020) IHMAX,IKMAX,ILMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MD,LINE)
      CALL MSGDOC(MD,
     * 'Defaults are minimal grid spacing for calculation SF')
C ----
      WRITE(LINE,1030) NXMIN,NYMIN,NZMIN
 1030 FORMAT('DEFAULT_GRID: NX,NY,NZ <',I3,',',I3,',',I3,'>') 
      CALL MSGDOC(MD,LINE)
      NNX=NX
      NNY=NY
      NNZ=NZ
      IF(NX.LE.0) NNX=NXMIN
      IF(NY.LE.0) NNY=NYMIN
      IF(NZ.LE.0) NNZ=NZMIN
      NNX   =(NNX/2)*2
      NNY   =(NNY/2)*2
      NNZ   =(NNZ/2)*2
      
      IF(NNX.LT.2*IHMAX+1) 
     * CALL MSGDOC(MDOC,'!!! Warning : Nx < 2Hmax+1')
      IF(NNY.LT.2*IKMAX+1) 
     * CALL MSGDOC(MDOC,'!!! Warning : Ny < 2Kmax+1')
      IF(NNZ.LT.2*ILMAX+1) 
     * CALL MSGDOC(MDOC,'!!! Warning : Nz < 2Lmax+1')
      NXY=NNX*NNY
      IF(NXY.GT.IPRMAP) THEN
        CALL MSGERR(MDOC,
     * ' ERR: not enough memory for one section of dens.')
        WRITE(LINE,'('' NX='',I4,'' NY='',I4,'' MEMORY-SIZE='',I6)')
     *                  NNX,NNY,IPRMAP
        CALL MSGERR(MDOC,LINE)
        WRITE(LINE,'('' must by: NX x NY < '',I6)') IPRMAP
        CALL MSGERR(MDOC,LINE)
        GO TO 500
      ENDIF
C ---
      IIZMIN=0
      IIZMAX=0
      N_SYM=NSYM
      IF(P1.EQ.'Y') N_SYM=1
      CALL SET_LIMZ(N_SYM,ISYM,NNZ,IZMAXD)
      IF(IZMIN.EQ.0.AND.IZMAX.LT.0) THEN
        IIZMIN=0
        IIZMAX=IZMAXD
      ELSE
        IIZMAX=IZMAX
        IIZMIN=IZMIN
        IF(IIZMAX.LT.IIZMIN) THEN
          T=IIZMAX
          IIZMAX=IIZMIN
          IIZMIN=T
        ENDIF
      ENDIF
C ------------------------------------------------
      BADD=BADDR
      ISPHR=0
      ICELL=0
      IF(MODE.EQ.'u') MODE='U'
      IF(MODE.EQ.'s') MODE='S'
      IF(MODE.EQ.'c') MODE='C'
      IF(MODE.EQ.'U') ISPHR=3
      IF(MODE.EQ.'S') ISPHR=2
      IF(MODE.EQ.'C') ISPHR=1
      IF(ISPHR.GE.2) THEN
        DLIM=RAD
        BADD  = 0.0
        HH2OBG= 0.0
        IF(ISPHR.GT.2) THEN
          ICELL=1
          ISPHR=2
        ENDIF
        IF(DLIM.EQ.0.0) THEN
          DLIM =2.8
          ISPHR=3
        ELSE IF(DLIM.LT.0.0) THEN
          DLIM=ABS(DLIM)
          IF(DLIM.GT.32.0) DLIM=32.0
          ISPHR=4
        ELSE
          ISPHR=2
          IF(DLIM.GT.32.0) DLIM=32.0
        ENDIF
      ELSE IF(ISPHR.EQ.1) THEN
        DLIM  = 2.8
        BADD  = 0.0
        HH2OBG= 0.0
      ELSE
        DLIM  = 2.8
        HH2OBG=H2OBG
      ENDIF
C     IF(MDOC.GT.0) THEN
        MD=-ABS(MDOC)-1
        IF(ISPHR.EQ.0) WRITE(LINE,*) ' --- GENERATE ATOM  -DENS ---'
        IF(ISPHR.EQ.1) WRITE(LINE,*) ' --- GENERATE CHARGE-DENS ---'
        IF(ISPHR.GE.2) WRITE(LINE,*) ' --- GENERATE SPHERE-DENS ---'
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' NX,NY,NZ   :',NNX,NNY,NNZ
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' IZMIN,IZMAX:',IIZMIN,IIZMAX
        CALL MSGDOC(MD,LINE)
        IF(ISPHR.EQ.2) THEN
          WRITE(LINE,*) ' RADIUS OF SPHERE  :',DLIM
          CALL MSGDOC(MD,LINE)
        ELSE IF(ISPHR.EQ.3) THEN
          WRITE(LINE,*) ' RADIUS OF SPHERE = RAD-Van-der-Waals'
          CALL MSGDOC(MD,LINE)
        ELSE IF(ISPHR.EQ.4) THEN
          WRITE(LINE,*) ' IF SURFACE-AREA=0 THEN RAD :',DLIM
          CALL MSGDOC(MD,LINE)
          WRITE(LINE,*) '             ELSE       RAD =R-Van-der-Waals'
          CALL MSGDOC(MD,LINE)
        ELSE
C          WRITE(LINE,*) ' ADDITIONAL B-FACTOR :',BADD
C          CALL MSGDOC(MD,LINE)
        ENDIF
        IF(ISPHR.EQ.0) THEN
          WRITE(LINE,*) ' DENSITY OF SOLVENT :',HH2OBG
          CALL MSGDOC(MD,LINE)
        ENDIF
C      ENDIF
C --------------------------------------
C     NCOORM=IPRCRD/5    
      CALL ATSORT(MDOC,NAMEC,BAVER,BMAX,BMIN,BAVERW,BAVERF,BADD
     *  ,SIGMAB,NEL,SUMFI2
     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
     *  ,P1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) GO TO 500
      IF(ISPHR.LT.1) THEN
        WRITE(LINE,*) 'ADDITIONAL B-FACTOR :',BADD
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C ---------------------------------------
      NXY=NNX*NNY
      CALL ATMDEN(MDOC,NAMED,TITLE,BADD,SOLV,X,NXY,IPRMAP
     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1),SUMDEN
     *  ,NSYM,ISYM,IPRSYM,IERR)
C ---------------------------------------
      IF(ISPHR.EQ.0) THEN
        WRITE(LINE,*) ' DENSITY OF SOLVENT :',HH2OBG
        CALL MSGDOC(MD,LINE)
      ENDIF
      NX=NNX
      NX=NNY
      NZ=NNZ
      IZMAX=IIZMAX
      IZMIN=IIZMIN
C     H2OBG=HH2OBG
      RAD=DLIM

      RESULT(1)=NEL
      RESULT(2)=SUMFI2
      RESULT(3)=BAVER
      RESULT(4)=BMAX
      RESULT(5)=BMIN
      RESULT(6)=BAVERW
      RESULT(7)=BAVERF
      RESULT(8)=SUMDEN
      RESULT(9)=HH2OBG
      RESULT(10)=SOLV
      RESULT(11)=BADD
      RESULT(12)=SIGMAB
      RESULT(13)=0.0
      RESULT(14)=0.0
      RESULT(15)=0.0
      RESULT(16)=VOL
      RESULT(17)=NSYM

      RETURN
 500  CONTINUE
      IERR=1
      RETURN
      END

      SUBROUTINE ATMDEN(MDOC,NAME,TITLE,BADD,SOLV,X,NXY,ISIZE
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC,SUMD
     *  ,NSYM,ISYM,IPRSYM,IERR)
C -----------------------------------------------------
CMS      : X
CMS      : IBFACT,IZMOCC,IXC,IYC,IZC
      REAL             X(NXY,*)
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C --- integer*4 version
      INTEGER          IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C ---
      INTEGER          NCOORD,NCOORM
      CHARACTER        NAME*(*),TITLE*(*)
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C --------------------------------------
      COMMON/COMINFF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM
      COMMON/CELLL/   A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
      COMMON/DIMM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
      COMMON/COM_VOL/ VOL
C --------------------------------------
      CHARACTER LINE*80
      CHARACTER TYPE*4
C-----------------------------------------------
      IERR=0
      MT=11
      M =99
      MD=-ABS(MDOC)-1
      TYPE='RI  '
      IPRINT=1
      CALL C_CR_WR
      CALL SET_TITLE(MD,A,B,C,ALPHA,BETA,GAMMA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
      CALL OWFILE(MD,MT,NAME,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) RETURN
C ----------------------------------------------
      IZCNT=-999
      IX0=0
      IY0=0
      IZ0=0
      ITR=0
C ----
      SUMRP =0.
      SUMRM =0.
      NDENSP=0
      NDENSM=0
      NZERO =0
      IZ000 =0
      SOLV=0.0
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
C     COEF=COEF/VOL
      COEF=(VOL)/(NX*NY*NZ)
      H2OBG=(H2OBG*COEF)
C -----------------------------------------------------
      IP1  =ISIZE/NXY
      IR   =IZMIN
      IREND=IZMAX
C -----------------------------------------------------
      RESOL=DMAX
      N1=NX
      N2=NY
100   CONTINUE
      IF(IR+IP1.GT.IREND) IP1 =IREND-IR+1
      N3=IP1

      CALL GENDENN(MDOC,X,N1,N2,N3,IR,IZ000,BADD
     *   ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *   ,VOL,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) RETURN

      DO     K=1,N3
        ISEC=IR+K-1
        CALL WDENS(MT,MDOC,IZCNT,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN,
     *             X(1,K),RESOL,IX0,IY0,IZ0,ITR)
        IF(MT.LE.0) RETURN
      ENDDO
      IR=IR+IP1
      IF(IR.LE.IREND) GO TO 100
C-----------------------------------------------------
      SUMR=SUMRP+SUMRM
      NDENS=NZERO+NDENSP+NDENSM
      SUMD=(SUMR*VOL)/(NX*NY*NZ)
      IF(ISPHR.GE.2) THEN
        WRITE(LINE,*) ' SUM-DENS       :',SUMR
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) ' N-POINT-DENS =1:',NDENSP
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) ' N-POINT-ZERO =0:',NZERO
        CALL MSGDOC(MDOC,LINE)
      ELSE IF(ISPHR.LE.1) THEN
        WRITE(LINE,200) NDENS,SUMR,SUMD
        CALL MSGDOC(MDOC,LINE)
        IF(NDENS.GT.0) SOLV=(FLOAT(NZERO)*100.)/FLOAT(NDENS)
        WRITE(LINE,201) NZERO,SOLV
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,202) NDENSP,SUMRP
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,203) NDENSM,SUMRM
        CALL MSGDOC(MDOC,LINE)
 200    FORMAT(
     *    ' N-POINT-DENS         :',I8,' ; SUM-R,SUM_DENS :',2F12.4)
 201    FORMAT(
     *    ' N-POINT-SOLV-DENS, % :',I8,F8.3)
 202    FORMAT(
     *    ' N-POINT-POSITIV-DENS :',I8,' ; SUM-POSITIV-DENS :',F12.4)
 203    FORMAT(
     *    ' N-POINT-NEGATIV-DENS :',I8,' ; SUM-NEGATIV-DENS :',F12.4)
      ENDIF
      RETURN
      END

      SUBROUTINE ATSORT(MDOC,NAME,BAVER,BPEAK,BMIN,BAVERW,BAVERF
     *  ,BADD,SIGMAB,NEL,SUMFI2
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *  ,P1,NSYM,ISYM,IPRSYM,IERR)
C -------------------------
CMS      : IBFACT,IZMOCC,IXC,IYC,IZC
      INTEGER   MDOC,IERR
      CHARACTER NAME*(*),NCS_FLAG*1,P1*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C --- integer*4 version
      INTEGER        IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C ---
      INTEGER          NCOORD,NCOORM
C ---
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of atom from the file.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMSS/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),CATOM
      CHARACTER       CATOM(15)*2
C ---
      COMMON/DIMM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
      COMMON/CELLL/    A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
C -----------------------------------------------------------------
      INTEGER     NCSOP
      REAL        AMNCS(3,3),TRNCS(3)
C------------------------------------------------------------------
      REAL        XA(3),YA(3),XSU(3),XFU(3)
      REAL        TRNS(3,2),XS(3),XF(3),Y(3)
      INTEGER     IPOINT(3)
c     INTEGER     JXXX(200),JYYY(200),JZZZ(200)
C----------------------------------------------------------------
      INTEGER     MODE
      REAL        FRTOCR(3,3),CRTOFR(3,3)
      REAL        ROT(9),TR(3)
      CHARACTER   ATOM*4,CHAR4*4,CHAR2*2,RES3*3
      CHARACTER   STR*80,NCSF*1,GID*4
C==================================================================
      ICOUNT= 0
      NONH  = 0
      NEL   = 0
      SUMFI2= 0
      NFMFC = 0
C --- integer*2 version
C     IPACK =10000
C --- integer*4 version
      IPACK =100000
C ---
      IERR  = 0
      NIN   = 10
      M     = 99
      MD    = -ABS(MDOC)-1
C --------
      CALL ORCRD(MD,NIN,NAME,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      A     = CR_CELL(1)
      B     = CR_CELL(2)
      C     = CR_CELL(3)
      ALPHA = CR_CELL(4)
      BETA  = CR_CELL(5)
      GAMMA = CR_CELL(6)
      CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *                            ,FRTOCR,CRTOFR,IERR)
C -----------------------------------------
      NCRSYM=0
      NCS_FLAG='N'
      NCSOP=0
      CALL GET_NCS(MDOC,NCMAX,NCSOP,AMNCS,TRNCS,IERR)
      IF(IERR.NE.0) THEN
        WRITE(STR,
     *  '('' ERR: wrong NCS description'')') 
        CALL MSGERR(MDOC,STR)
        RETURN
      ENDIF
      IF(NCSOP.GT.0) THEN
        IGR=0
        CALL GET_ASYMM(MDOC,NASMAX,NGR,NCH,IGR,ICH,INC,MLT,I_ATM
     *                 ,NCSF,GID,IERR)
        IF(IERR.NE.0) THEN
          WRITE(STR,
     *    '('' ERR: wrong NCS description'')') 
          CALL MSGERR(MDOC,STR)
          RETURN
        ENDIF
        IF(NGR.GT.0) THEN
          DO IGR=1,NGR
            CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            IF(NCSF.EQ.'N'.OR.NCSF.EQ.'n') THEN
              NCS_FLAG='Y'
              GO TO 520
            ENDIF
          ENDDO
        ENDIF
      ENDIF
 520  CONTINUE
      IF(NCS_FLAG.EQ.'Y') THEN
        WRITE(STR,
     *  '(''NUMBER OPERATORS OF NON-CRYST.SYMMETRY:'',I5)') NCSOP
        CALL MSGDOC(MDOC,STR)
        IF(NCSOP.GT.0) THEN
          CALL MSGDOC(MD,' ')
          CALL MSGDOC(MD,'  X-NEW           X-0      TX')
          CALL MSGDOC(MD,'  Y-NEW  = [M] *  Y-0  +   TY')
          CALL MSGDOC(MD,'  Z-NEW           Z-0      TZ')
          CALL MSGDOC(MD,' ')
          CALL MSGDOC(MD,' ORTOGONAL COORDINATE SYSTEM')
          CALL MSGDOC(MD,'  COORDINATES IN ANGSTROMS')
          CALL MSGDOC(MD,' ')
          DO     I=1,NCSOP
            CALL GET_NCS(MD,NCMAX,I,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            WRITE(STR,500) I
            CALL MSGDOC(MD,STR)
  500       FORMAT('  OPERATORS OF NON-CRYST.SYMMETRY :',I5)
            CALL ANGFIX(MD,AMNCS,ALPH,BET,GAMM)
            WRITE(STR,510) (TRNCS(L),L=1,3)
            CALL MSGDOC(MD,STR)
  510       FORMAT(' TRANSLATION VECTOR :',3F10.5,' /ANGSTROM/')
          ENDDO
        ELSE
          WRITE(STR,
     *    '('' ERR: NUMBER OF NCS-OPERATORS:'',I5)') NCSOP
          CALL MSGERR(MDOC,STR)
          IERR=1
          RETURN
        ENDIF
      ENDIF
C--------------------------------------------------
      DLM=DLIM+0.5
      XS(1) =0.
      XS(2) =0.
      XS(3) =0.
      XF(1) =1.
      XF(2) =1.
      XF(3) =1.

      ZFFS  =FLOAT(IZMIN)/FLOAT(NZ)-DLM/C
      ZFFF  =FLOAT(IZMAX)/FLOAT(NZ)+DLM/C

      XSU(1)=DLM/A
      XSU(2)=DLM/B
      XSU(3)=DLM/C
      XFU(1)=1.-DLM/A
      XFU(2)=1.-DLM/B
      XFU(3)=1.-DLM/C
C
      BAVER  = 0.0
      BMIN   = 1.E30
      BPEAK  =-1.E30
      BAVERW = 0.0 
      BAVERF = 0.0
      SIGMAB = 0.0
      NBATOM = 0
      MATOMW =0
      NINALL =0
      IATT   =0
      IAT_IN =0
      I      =0
      NSUME  =0.
      NCRSYM =0
      SCHRG=0.0
      CHRGP=0.0
      CHRGM=0.0
      D1=0.0
      D2=0.0
      D3=0.25/(DMAX*DMAX)
C ===========================================
      IEND=-1
1100  CONTINUE
        IF(NCS_FLAG.EQ.'Y'.AND.NCRSYM.GT.NCSOP) NCRSYM=0
        IF(NCRSYM.NE.0) THEN


        ELSE

          MODE = 0
          CALL RDCRD(M,NIN,MODE,IEND,IERR)
          IF(IERR.EQ.1) RETURN
          IF(IEND.NE.0) GO TO 2000
          IF(MODE.GT.0) GO TO 1000    

          IF(CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *       CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *       CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R')
     *    GO TO 1000
          IAT_IN=IAT_IN+1
        ENDIF
C--------------------------------------------------------

        ATOM=CR_ANAME
        IRES=CR_IRES
        RES3=CR_RNAME
        OCC =CR_OCC
        BT  =CR_BISO

        SURF  =CR_BISO
        CHARGE=CR_BISO

        IF(CR_MULT_FACTOR.GT.1) THEN
          OCC = OCC / FLOAT(CR_MULT_FACTOR)
        ENDIF

        RVDW = 1.5
        IF(ISPHR.EQ.1.OR.ISPHR.EQ.4) THEN
          SURF  =CR_OCC
          CHARGE=CR_OCC
          OCC   =1.0
        ENDIF

        IF(ISPHR.EQ.1.AND.CHARGE.EQ.0.0) GO TO 1000
C--------------------------------------------------------
        XA(1)=CR_XYZ(1)
        XA(2)=CR_XYZ(2)
        XA(3)=CR_XYZ(3)


c        WRITE(STR,400) ATOM,IRES,RES3,ICHAIN,
c     *           XA(1),XA(2),XA(3),OCC,BT
c 400    FORMAT(6X,A4,I4,1X,A3,I3,3F10.5,F6.3,F6.1)
c        CALL MSGERR(MDOC,STR)

        IF(NCS_FLAG.EQ.'Y') THEN
          IF(NCRSYM.EQ.0) THEN
            IGR_OLD = CR_IGROUP
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description for chain :'',I5)') 
     *          IGR_OLD
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
              IF(IGOLD.EQ.IGR_OLD.AND.INC.EQ.0) THEN
                ICHAIN=ICHOLD
                NCRSYM=1
                GO TO 410
              ENDIF
            ENDDO
            WRITE(STR,
     *      '('' ERR: wrong NCS description for chain :'',I5)') 
     *      IGR_OLD
            CALL MSGERR(MDOC,STR)
            IERR=1
            RETURN
  410       CONTINUE
          ELSE
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description'')') 
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
c            write(*,*) NCSF,NCRSYM,GID(1:2),CHAIN
              IF((NCSF.EQ.'N'.OR.NCSF.EQ.'n').AND.
     *           INC.EQ.NCRSYM.AND.ICHOLD.EQ.ICHAIN) GO TO 530
            ENDDO
            NCRSYM=NCRSYM+1
            GO TO 1000  
 530        CONTINUE
            CALL GET_NCS(MDOC,NCMAX,INC,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            CALL MVMULT(AMNCS,CR_XYZ,XA)
            XA(1)=XA(1)+TRNCS(1)
            XA(2)=XA(2)+TRNCS(2)
            XA(3)=XA(3)+TRNCS(3)
            NCRSYM=NCRSYM+1
          ENDIF
        ENDIF

        CALL MVMULT(CRTOFR,XA,YA)

c        XA(1)=AMOD(YA(1)/1.,1.)
c        XA(2)=AMOD(YA(2)/1.,1.)
c        XA(3)=AMOD(YA(3)/1.,1.)

        XA(1)=YA(1)
        XA(2)=YA(2)
        XA(3)=YA(3)

C --------------------------------------------------------
        IZZ=1
        CHAR2=CR_ASYMB(1:2)
        CHAR4=CR_ASYMB
 610    CONTINUE
        IF(NFMFC.GT.0) THEN
          DO IM=1,NFMFC
            IF(CHAR2.EQ.CATOM(IM)) THEN
              IZZ=IM
              IZE=IZFMFC(IZZ)
              GO TO 600
            ENDIF
          ENDDO
        ENDIF
        CALL GET_SFA(CHAR4
     *      ,N,NELC,A1,A2,A3,A4,B1,B2,B3,B4,CC,FI,FII,RAD,IERR)
        IF(IERR.NE.0.OR.NFMFC.GE.NFMMAX) THEN
          IF(IERR.NE.0) THEN
            IF(ICOUNT.LT.4) THEN
              WRITE(STR,*) ' ERR: atom"s type "',CHAR4,'" not found'
              CALL MSGERR(MDOC,STR)
              WRITE(STR,
     *        '('' ERR: for atom '',I6,'' name:'',A4,I5,'' '',A3)')
     *        I+1,ATOM,IRES,RES3
              ICOUNT=ICOUNT+1
            ELSE IF(ICOUNT.EQ.4) THEN
              CALL MSGERR(MDOC,'   ... more ...')
              ICOUNT=ICOUNT+1
            ENDIF
            IERR=0
          ELSE IF(NFMFC.GE.NFMMAX) THEN
            IF(ICOUNT.LT.4) THEN
              WRITE(STR,*) ' ERR: too many atom"s type > ',NFMMAX
              CALL MSGERR(MDOC,STR)
              ICOUNT=ICOUNT+1
            ELSE IF(ICOUNT.EQ.4) THEN
              CALL MSGERR(MDOC,'   ... more ...')
              ICOUNT=ICOUNT+1
            ENDIF
          ENDIF
          IF(ICOUNT.LE.4) THEN
            WRITE(STR,*) ' ERR: default type  is "N   "'
            CALL MSGERR(MDOC,STR)
          ENDIF
          CHAR2='N '
          CHAR4='N   '
          GO TO 610
        ENDIF
        NFMFC=NFMFC+1
        IZFMFC(NFMFC)=NELC
        FMFCA(1,NFMFC)=A1
        FMFCB(1,NFMFC)=B1
        FMFCA(2,NFMFC)=A2
        FMFCB(2,NFMFC)=B2
        FMFCA(3,NFMFC)=A3
        FMFCB(3,NFMFC)=B3
        FMFCA(4,NFMFC)=A4
        FMFCB(4,NFMFC)=B4
        FMFCA(5,NFMFC)=CC
        FMFCB(5,NFMFC)=0.0
        CATOM(NFMFC)=CHAR2
        IZZ=NFMFC
        IZE=NELC
        RVDW=RAD
 600    CONTINUE
C ----------------------------------------
        I=I+1
        IF(CR_ASYMB(1:2).NE.'H '.AND.CR_ASYMB(1:2).NE.'D ') THEN
          NONH  = NONH +1
        ENDIF
        NEL=NEL+IZE*OCC
        SUMFI2 = SUMFI2+IZE*IZE*OCC*OCC
C       BT=BT+BADD
        IF(BT.LT.2.0) BT = 2.0
        IF(ISPHR.EQ.3) THEN
          IZR=RVDW*1000.0
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ELSE IF(ISPHR.EQ.4) THEN
          IF(SURF.GT.0.0) THEN
            IZR=RVDW*1000.0
          ELSE
            IZR=DLIM *1000.0
          ENDIF
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ELSE IF(ISPHR.EQ.2) THEN
          IZR=DLIM *1000.0
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ELSE IF(ISPHR.EQ.1) THEN
          BB=BT
          IF(BB.GT.99.0) BB=99.0
          IBB=BB
          IF(ABS(CHARGE).GT.1.50) CHARGE=(ABS(CHARGE)/CHARGE)*1.50
          ICHRG=CHARGE*100.0+160.0
          IZR=ICHRG*100.0+IBB
          SCHRG=SCHRG+CHARGE
          IF(CHARGE.GT.0.0) CHRGP=CHRGP+CHARGE
          IF(CHARGE.LT.0.0) CHRGM=CHRGM+CHARGE
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ELSE
          IF(BT.GT.99.0) BT =99.0
          IZR=BT*10.0
          D2=D2+IZE*IZE*OCC*OCC
          D4=0.0
          DO IGS=1,5
            D4= D4+FMFCA(IGS,IZZ)*EXP(-(BT+FMFCB(IGS,IZZ))*D3)
          ENDDO
          D4= OCC * D4
          D1=D1+D4*D4
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ENDIF
        IF(ABS(INEOCC).GT.32766.0) 
     *  INEOCC=(ABS(INEOCC)/INEOCC)*32766.0
        IF(ABS(IZR).GT.32600.0) IZR=(ABS(IZR)/IZR)*32600.0
C -----
        IF(OCC.GT.0.0000001) THEN
          BAVER   = BAVER+BT
          SIGMAB  = SIGMAB + BT*BT
          IF(CR_RNAME.NE.'HOH') THEN
            BAVERW = BAVERW +BT 
            MATOMW = MATOMW +1
          ENDIF
          IF(BMIN .GT.BT ) BMIN =BT
          IF(BPEAK.LT.BT ) BPEAK=BT
          NBATOM=NBATOM+1
        ENDIF
C ------------------------------
        JJNS=0
        N_SYM=NSYM
        IF(P1.EQ.'Y') N_SYM=1
        DO     ISM=1,N_SYM
          ROT(1) = ISYM(1,1,ISM)
          ROT(2) = ISYM(2,1,ISM)
          ROT(3) = ISYM(3,1,ISM)
          ROT(4) = ISYM(1,2,ISM)
          ROT(5) = ISYM(2,2,ISM)
          ROT(6) = ISYM(3,2,ISM)
          ROT(7) = ISYM(1,3,ISM)
          ROT(8) = ISYM(2,3,ISM)
          ROT(9) = ISYM(3,3,ISM)
          TR(1)  = ISYM(4,1,ISM)/REAL(ISYM(5,1,ISM))
          TR(2)  = ISYM(4,2,ISM)/REAL(ISYM(5,2,ISM))
          TR(3)  = ISYM(4,3,ISM)/REAL(ISYM(5,3,ISM))

          X =ROT(1)*XA(1 ) +ROT(2)*XA(2) +ROT(3)*XA(3)
     .       + TR(1)
          YY=ROT(4)*XA(1 ) +ROT(5)*XA(2) +ROT(6)*XA(3)
     .       + TR(2)
          Z =ROT(7)*XA(1 ) +ROT(8)*XA(2) +ROT(9)*XA(3)
     .       + TR(3)

          Y(1)=X
          Y(2)=YY
          Y(3)=Z

          DO     J=1,3
21          IF(Y(J).LT.XS(J)) THEN
              Y(J)=Y(J)+1.
              GO TO 21
            ENDIF
22          IF(Y(J).GE.XF(J)) THEN
              Y(J)=Y(J)-1.
              GO TO 22
            ENDIF
            IPOINT(J)=1
            TRNS(J,1)=0.
            IF(Y(J).LE.XSU(J)) THEN
              IPOINT(J)=IPOINT(J)+1
              TRNS(J,2)=1.
            ELSE IF(Y(J).GE.XFU(J)) THEN
              IPOINT(J)=IPOINT(J)+1
              TRNS(J,2)=-1.
            ENDIF
          ENDDO

          INALL=0

          DO     IX=1,IPOINT(1)
            DO     IY=1,IPOINT(2)
              DO     IZ=1,IPOINT(3)
c                DO     JZ=1,3
                  JZ=2
                  ZZZ =Y(3)+TRNS(3,IZ)+FLOAT(JZ-2)

                  IF(ZZZ.GE.ZFFS.AND.ZZZ.LE.ZFFF) THEN

                    IXXX=(Y(1)+TRNS(1,IX))*FLOAT(IPACK)
                    IYYY=(Y(2)+TRNS(2,IY))*FLOAT(IPACK)
                    IZZZ= ZZZ             *FLOAT(IPACK)
                    IATT=IATT+1
                    IF(IX.EQ.1.AND.IY.EQ.1.AND.IZ.EQ.1) INALL=1
                    IF(IATT.GT.NCOORM ) THEN
                      WRITE(STR,*) ' ERR: too many atoms > ',NCOORM
                      CALL MSGERR(MDOC,STR)
                      IERR=1
                      RETURN
                    ENDIF
                    NSUME       = NSUME+IZE
                    IBFACT(IATT)  =IZR
                    IZMOCC(IATT)=INEOCC
C --- integer*2 version
c                    IF(IXXX.LT.-32766.OR.IXXX.GT.32766.OR.
c     *                 IYYY.LT.-32766.OR.IYYY.GT.32766.OR.
c     *                 IZZZ.LT.-32766.OR.IZZZ.GT.32766) THEN
c                      CALL MSGERR(MDOC,' ERR: !X,Y,Z!(u.c.) > 3.2766')
c                      IERR=1
c                      RETURN
c                    ENDIF
c --------------------
                    IXC(IATT)   =IXXX
                    IYC(IATT)   =IYYY
                    IZC(IATT)   =IZZZ
                    ITRX=TRNS(1,IX)+1.001
                    ITRY=TRNS(2,IY)+1.001
                    ITRZ=TRNS(3,IZ)+1.001
C                   ISCODE(IATT)=ISM*27+ITRX+ITRY*3+ITRZ*9
C                   IANUMB(IATT)=I        
                    IF(ICELL.EQ.1) THEN
                      INEOCC=ISM*27+ITRX+ITRY*3+ITRZ*9
                      IF(OCC.LE.0.0001) INEOCC=-1
                      IZMOCC(IATT)=INEOCC
                    ENDIF
                  ENDIF

c                ENDDO
              ENDDO
            ENDDO
          ENDDO
        ENDDO
C ------------------------
        NINALL=NINALL+INALL
1000    CONTINUE
      GO TO 1100
C==================================================
 2000 MATOMS =I
      NATOMS =IATT
      IF(NBATOM.GT.0) THEN
        BAVER =BAVER /NBATOM
        SIGMAB=SIGMAB/NBATOM
        SIGMAB=SQRT(ABS(SIGMAB-BAVER*BAVER))
      ELSE
        SIGMAB=0.0
      ENDIF
      IF(MATOMW.GT.0) THEN
        BAVERW=BAVERW/MATOMW
      ENDIF
C ------------------------------------------------------
      M=99
      IF(IATT.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS = 0')
        IERR=1
        CLOSE(NIN)
        RETURN
      ENDIF
      CALL MSGDOC(M,' --- START SORT ---')
      CALL SORT4(IZC,IATT,IBFACT,IZMOCC,IXC,IYC)
      CALL MSGDOC(M,' --- END   SORT ---')
C ------------------------------------------------------
      IF(ISPHR.EQ.0) THEN
        D1=SQRT(D1)
        D2=SQRT(D2)
        BAVE=ALOG(D2/D1)/D3
        BAVERF = BAVE
        CALL SETBADD(DMAX,BAVE,NX,NY,NZ,BCALC)

        WRITE(STR,'('' Baver/include SF/ :'',F8.3)') BAVERF
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,'('' Badd_in,Badd_calc:'',2F8.3)') BADD,BCALC
        CALL MSGDOC(MDOC,STR)

        BADD_IN = BADD
        IF(BADD.LE.0.000001) BADD=BCALC        

c        IF(BMIN.GT.10.0) THEN
c
c          BADD= - BMIN+5.0
c
c          BAVE_NEW=BAVE+BADD
c
c          CALL SETBADD(DMAX,BAVE_NEW,NX,NY,NZ,BCALC_NEW)
c
c          WRITE(STR,'('' Baver/include SF/_NEW :'',F8.3)') BAVE_NEW
c          CALL MSGDOC(MDOC,STR)
c          WRITE(STR,'('' Badd_calc/NEW/:'',F8.3)') BCALC_NEW
c          CALL MSGDOC(MDOC,STR)
c
c          IF(BADD_IN.LT.0.0) BADD=BCALC_NEW        
c  
c        ENDIF

      ENDIF
      WRITE(STR,430) IAT_IN
      CALL MSGDOC(MDOC,STR)
      IF(NCS_FLAG.EQ.'Y') THEN
        WRITE(STR,434) MATOMS
        CALL MSGDOC(MDOC,STR)
      ENDIF
      IF(MATOMS.NE.NONH) THEN
        WRITE(STR,433) NONH
        CALL MSGDOC(MDOC,STR)
      ENDIF
      WRITE(STR,431) NATOMS
      CALL MSGDOC(MDOC,STR)
      WRITE(STR,432) NINALL
      CALL MSGDOC(MDOC,STR)
 430  FORMAT('ATOMS INPUT                       :',I6)
 433  FORMAT('ATOMS INPUT/non H /               :',I6)
 431  FORMAT('ATOMS INCLUDED IN SORT            :',I6)
 432  FORMAT('ATOMS IN ONCE ONLY                :',I6)
 434  FORMAT('ATOMS INPUT/including NCS-atoms / :',I6)
      IF(ISPHR.EQ.0) THEN
        WRITE(STR,440) BMIN,BPEAK,BAVER
        CALL MSGDOC(MDOC,STR)
 440    FORMAT('MINIMUM B - MAXIMUM B - AVERAGE B:',3F10.4)


        WRITE(STR,'('' B_AVER /without water/,sigma(B):'',2F8.3)') 
     *  BAVERW,SIGMAB
        CALL MSGDOC(MDOC,STR)

c        WRITE(STR,442) NSUME
c 442    FORMAT('SUM-ELECTRONS :',I10)
c        CALL MSGDOC(MDOC,STR)
        FAVER=SQRT(SUMFI2*NSYM)
        WRITE(STR,441) NEL,FAVER
 441    FORMAT('SUM-ELECTRONS /IN MODEL/ :',I10,' <!F!> :',F12.0)
        CALL MSGDOC(MDOC,STR)
        AVERI=SUMFI2*NSYM
        WRITE(STR,443) AVERI
 443    FORMAT('                                  <I> :',F12.0)
        CALL MSGDOC(MDOC,STR)
      ELSE IF(ISPHR.EQ.1) THEN
        WRITE(STR,450) BMIN,BPEAK,BAVE
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,451) SCHRG
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,452) CHRGP
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,453) CHRGM
        CALL MSGDOC(MDOC,STR)
 450    FORMAT('MINIMUM B - MAXIMUM B - AVERAGE B:',3F10.4)
 451    FORMAT('SUM-CHARGES           :',F10.4)
 452    FORMAT('SUM-POSITIV-CHARGES   :',F10.4)
 453    FORMAT('SUM-NEGATIV-CHARGES   :',F10.4)
      ENDIF
      NCOORD=IATT
      IF(NCOORD.EQ.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS =0')
        IERR=1
      ENDIF
      CLOSE(NIN)
      RETURN
      END

      SUBROUTINE GENDENN(MDOC,DEN,N1,N2,N3,R,IATRC1,BADD
     * ,NCOORD,NCOORM,IBFACT,IZMOCC,IXCC,IYCC,IZCC
     * ,VOL,NSYM,ISYM,IPRSYM,IERR)
C------------------------------------------------------
CMS      : DEN
CMS      : IBFACT,IZMOCC,IXCC,IYCC,IZCC
      REAL      DEN(N1,N2,N3)
      INTEGER   R,IATRC1
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
C --- integer*4 version
      INTEGER         IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
C ---
      INTEGER          NCOORD,NCOORM
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C------------------------------------------------------
      COMMON/COMINFF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM
C------------------------------------------------------
      COMMON/CELLL/    A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
      COMMON/DIMM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
C --------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMSs/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),CATOM
      CHARACTER       CATOM(15)*2
C-------------------------------------------------------------
      REAL            BLL(5),CLL(5)
C------------------------------------------------------------------
      IERR=0
C --- integer*2 version
C     IPACK=10000
C --- integer*4 version
      IPACK=100000
C --- 
      NATREC=NCOORD
      COEF=(FLOAT(NX)*FLOAT(NY)*FLOAT(NZ))
      IF(R.EQ.IZMIN) IATRC1=0
C
      DLIMIT=DLIM*DLIM
      SX=A/NX
      SY=B/NY
      SZ=C/NZ
C
      PI   =4.0*ATAN(1.0)
      PISQ4=4.0*PI*PI
      COSA =COS(ALPHA)
      SINA =SIN(ALPHA)
      COSG =COS(GAMMA)
      SING =SIN(GAMMA)
      COSB =COS(BETA)
      SINB =SIN(BETA)
      CSA2 =COSA*2.
      CSB2 =COSB*2.
      CSG2 =COSG*2
C      COSZ  DEFINES THE ANGLE BETWEEN C AND CSTAR
      SYCOSG=SY*COSG
      SXSING=SX*SING
      SYSING=SY*SING
      SZCOSB=SZ*COSB
      SZCOSA=SZ*COSA
      COSZ=SQRT(1.-COSA**2-COSB**2-COSG**2+2.*COSA*COSB*COSG)/SING
      DV=8.0*SX*SY*SZ*COSZ*SING*PI**1.5
C
C  CELL VOLUME
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
      COEF=COEF/VOL
      DO     I3=1,N3
      DO     I2=1,N2
      DO     I1=1,N1
        DEN(I1,I2,I3)=-32001.0
      ENDDO
      ENDDO
      ENDDO
      ITETR=0
      ANGSUM=ABS(ALPHA+BETA+GAMMA-(3.0*PI)/2.)
      IF(ANGSUM.GT.0.01) ITETR=1
      IMON=0
C
C  BEWARE - MONOCLINIC SPACE GROUPS MUST BE TREATED AS HAVING C UNIQUE.
C
      ANGSUM=ABS(BETA+ALPHA-PI/2.)
      IF(ANGSUM.GT.0.01) IMON=1
      DLM= SQRT(DLIMIT)
      IF(IMON.EQ.1) DLM=DLM+0.5

      ZSFG  =FLOAT(R)/NZ     -DLM/C
      ZFFG  =FLOAT(R+N3-1)/NZ+DLM/C
      ZSFNXT=ZFFG-2.*DLM/C
C
      IATREC=IATRC1
C==========================================
1     IATREC=IATREC+1
      IF(IATREC.GT.NATREC) GO TO 400
      
      IATM_P=IATREC
      IBOCC=IZMOCC(IATM_P)
      IXIN =IXCC  (IATM_P)
      IYIN =IYCC  (IATM_P)
      IZIN =IZCC  (IATM_P)
      Z=IZIN/FLOAT(IPACK)
C
      IF(Z.LT.ZSFNXT) IATRC1=IATREC
      IF(Z.LT.ZSFG)   GO TO 1
      IF(Z.GT.ZFFG)   GO TO 400
C
      SCALE=1.0
      BT   =1.0
      IF(ISPHR.GE.2) THEN
        DLIMIT=IBFACT(IATM_P)/1000.0
        DLIMIT=DLIMIT*DLIMIT
        IF(ICELL.EQ.1) THEN
          IF(IBOCC.LT.0) THEN
            OCC=0.0
          ELSE
            OCC=1.0
          ENDIF
          IDNS=ABS(IBOCC)
          IZZ=1
        ELSE  
          IZZ=IBOCC/1000
          IT =IBOCC-IZZ*1000
          OCC=IT/10.
        ENDIF
      ELSE IF(ISPHR.EQ.1) THEN
        ICHRG=IBFACT(IATM_P)/100.0
        BT   =IBFACT(IATM_P)-ICHRG*100.0
        CHARGE=(ICHRG-160.0)/100.0
        SCALE=CHARGE/IZFMFC(IZZ)
        IZZ=IBOCC/1000
        IT =IBOCC-IZZ*1000
        OCC=IT/10.
      ELSE IF(ISPHR.EQ.0) THEN
        BT=IBFACT(IATM_P)/10.0
        BT=BT+BADD
        IZZ=IBOCC/1000
        IT =IBOCC-IZZ*1000
        OCC=IT/10.
      ENDIF
      IF(OCC.LT.0.0001) GO TO 1
      X  =IXIN/FLOAT(IPACK)
      Y  =IYIN/FLOAT(IPACK)
      X1=X *A
      Y1=Y *B
      Z1=Z *C
      IF(BT.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: B-FACTOR < 0.0 ')
        IERR=1
        RETURN
      ENDIF
      IF(ISPHR.LE.1) THEN
        IF(IZZ.LE.0.OR.IZZ.GT.NFMFC) THEN 
          CALL MSGERR(MDOC,' ERR: IDENTIFY FORMFACTORS = ?')
          IERR=1
          RETURN
        ENDIF
      ENDIF
      IF(ISPHR.EQ.1) THEN
        SCALE=CHARGE/IZFMFC(IZZ)
      ENDIF
      DVOCC=OCC*DV*SCALE
      DMAXSQ=DLIMIT
      IF(ISPHR.LE.1) THEN
        IM=IZZ
        DO     J=1,5
          BLL(J)=PISQ4/(FMFCB(J,IM)+BT )
          CLL(J)=DVOCC*FMFCA(J,IM)*(FMFCB(J,IM)+BT )**(-1.5)
        ENDDO
      ENDIF
C
      XC=X1/SX
      IXC=NINT(XC)
      YC=Y1/SY
      IYC=NINT(YC)
      ZC=Z1/SZ
      IZC=NINT(ZC)
C
      RRADZ=SQRT(DMAXSQ)/(SZ*COSZ)
      SZL=ZC-RRADZ
      SZU=ZC+RRADZ
      ISZL=INT(SZL+501.)
      ISZU=INT(SZU+500.)
C
C     CALCULATE THE DENSITY AT ALL POINTS TO WHICH ATOM CONTRIBUTES
C     (IE IN SPHERE OF RADIUS RRADZ)
C
      DO     IZ1=ISZL,ISZU
        IZ=IZ1-500
C
C     TEST WHETHER THIS ATOM LIES IN REQUIRED BLOCK OF FOURIER SECTIONS
C
        IZ2=IZ+1-R
        IF(IZ2.GT.N3 .OR. IZ2.LE.0)       GO TO 301
        DZ=IZ*SZ-Z1
        D2=DZ*DZ
        IF(D2.GT.DMAXSQ .AND. ITETR.EQ.1) GO TO 301
        D3=DMAXSQ-DZ*DZ*SINA*SINA
        IF(D3.LE.0.)                      GO TO 301
        RRADY=SQRT(D3)/SYSING
        ZCOSA=DZ*COSA/SY
        SYL=YC-RRADY-ZCOSA
        SYU=YC+RRADY-ZCOSA
        ISYL=INT(SYL+501.)
        ISYU=INT(SYU+500.)
        DELZ1=2.*DZ
        DZCSA2=DZ*CSA2
        DZCOSB=DZ*COSB
        DO     IY1=ISYL,ISYU
          IY=IY1 - 500
          IY2=IY+1
          IF(IY2.LE.N2.AND.IY2.GE.1) THEN
            DY=IY*SY-Y1
            DYZ=D2+DY*(DZCSA2+DY)
            IF(DYZ.LE.DMAXSQ.OR.IMON.EQ.0) THEN
C
C             FOR GIVEN X AND Y  THE MINIMUM DSQ IS GIVEN
C             FOR DX=-DY*COSG-DZCOSB
C
              DXMIN=-DY*COSG-DZCOSB
              DSQMIN=DYZ-DXMIN**2
              IF(DSQMIN.LT.DMAXSQ) THEN
                DFACT2=-2.*DXMIN
                D4=DMAXSQ-DSQMIN
                DELZ2=DELZ1+DY*CSA2
                DELY1=2.*DY+DZCSA2
                DELY=2.*DY
                RRADX=SQRT(D4)/SXSING
                XDELTA=DXMIN/SX
                SXL=XC-RRADX + XDELTA
                SXU=XC+RRADX + XDELTA
                ISXL=INT(SXL+501.)
                ISXU=INT(SXU+500.)
                DO     IX1=ISXL,ISXU
                  IX=IX1-500
                  IX2=IX+1
                  IF(IX2.LE.N1.AND.IX2.GE.1) THEN
                    DX=IX*SX-X1
                    DSQ=DX*(DX+DFACT2) + DYZ
                    IF(DSQ.LE.DMAXSQ) THEN
                      IF(ISPHR.GE.2) THEN
                        IF(ICELL.EQ.0) THEN
                          IF(DEN(IX2,IY2,IZ2).LE.-32000.0)
     *                    DEN(IX2,IY2,IZ2)=0.0
                          DEN(IX2,IY2,IZ2) = 1.
                        ELSE
                          IDOLD=DEN(IX2,IY2,IZ2)+0.001
                          IF(IDOLD.LT.-31000.OR.IDOLD.EQ.IDNS) THEN
                            DEN(IX2,IY2,IZ2)=IDNS+0.0001
                          ELSE
                            DEN(IX2,IY2,IZ2) = -27.0
                          ENDIF
                        ENDIF
                      ELSE
                        IF(DEN(IX2,IY2,IZ2).LE.-32000.0)
     *                  DEN(IX2,IY2,IZ2)=0.0
                        FAC=0.0
                        DO     J=1,5
                          DSQ1=-DSQ*BLL(J)
                          FAC=FAC+CLL(J)*EXP(DSQ1)
                        ENDDO
                        TEMP=FAC*COEF
                        DEN(IX2,IY2,IZ2)=DEN(IX2,IY2,IZ2)+TEMP
                      ENDIF
                    ENDIF
                  ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDIF
        ENDDO
301     CONTINUE
300     CONTINUE
      ENDDO
      GO TO 1
C -----------------------------------------------
400   CONTINUE
      SUMM=0.0
      SUMP=0.0
      DO     I3=1,N3
        DO     I2=1,N2
        DO     I1=1,N1
          IF(DEN(I1,I2,I3).LE.-32000.0) THEN
            DEN(I1,I2,I3)=H2OBG
            NZERO=NZERO+1
          ELSE IF(DEN(I1,I2,I3).GT.0.0) THEN
            NDENSP=NDENSP+1
            SUMP=SUMP+DEN(I1,I2,I3)
          ELSE IF(DEN(I1,I2,I3).LT.0.0.AND.
     *            DEN(I1,I2,I3).GT.-32000.0) THEN
            NDENSM=NDENSM+1
            SUMM=SUMM+DEN(I1,I2,I3)
          ENDIF
        ENDDO
        ENDDO
      ENDDO
      SUMRP=SUMRP+SUMP
      SUMRM=SUMRM+SUMM
      RETURN
      END

      SUBROUTINE WFORMFS(MDOC)
C -------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMSS/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),CATOM
      CHARACTER       CATOM(15)*2
C -------------------
      INTEGER        MDOC
      CHARACTER      LINE*80
C --------------------------------------------------------------------
C ---
      CALL MSGDOC(MDOC,' ---------------------------')
      WRITE(LINE,*) 
     *  ' FORMFACTOR FOR ATOMS /INT TAB VOL 4 TABLE 2.2B/:'
      CALL MSGDOC(MDOC,LINE)
      DO I=1,NFMFC
        WRITE(LINE,10) CATOM(I),IZFMFC(I)
 10     FORMAT(' ----- ',A2,' ---- ',I4)
        CALL MSGDOC(MDOC,LINE)
        DO J=1,5
          WRITE(LINE,20) FMFCA(J,I),FMFCB(J,I)
 20       FORMAT( 5X,2F10.5)
         CALL MSGDOC(MDOC,LINE)
       ENDDO 
      ENDDO
      CALL MSGDOC(MDOC,' ---------------------------')
      RETURN
      END

      SUBROUTINE SORT4(A,N,TAG,TAG1,TAG2,TAG3)
C------------------------------------------
CMS      : TAG,TAG1,TAG2,TAG3
C --- integer*2 version
C      INTEGER*2  TAG,TAG1,TG,TG1,TAG2,TAG3,TG2,TG3,A,T,TT
C --- integer*4 version
      INTEGER  TAG,TAG1,TG,TG1,TAG2,TAG3,TG2,TG3,A,T,TT
C ---
      DIMENSION A(*),IU(16),IL(16),TAG(*),TAG1(*),TAG2(*),TAG3(*)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1
      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2
      TG3=TAG3(IJ)
      TAG3(IJ)=TAG3(I)
      TAG3(I)=TG3
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(J)
      TAG1(J)=TG1
      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(J)
      TAG2(J)=TG2
      TG3=TAG3(IJ)
      TAG3(IJ)=TAG3(J)
      TAG3(J)=TG3
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1
      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2
      TG3=TAG3(IJ)
      TAG3(IJ)=TAG3(I)
      TAG3(I)=TG3
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
      TG1=TAG1(L)
      TAG1(L)=TAG1(K)
      TAG1(K)=TG1
      TG2=TAG2(L)
      TAG2(L)=TAG2(K)
      TAG2(K)=TG2
      TG3=TAG3(L)
      TAG3(L)=TAG3(K)
      TAG3(K)=TG3
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG =TAG (I+1)
      TG1=TAG1(I+1)
      TG2=TAG2(I+1)
      TG3=TAG3(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG (K+1)=TAG (K)
      TAG1(K+1)=TAG1(K)
      TAG2(K+1)=TAG2(K)
      TAG3(K+1)=TAG3(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A   (K+1)=T
      TAG (K+1)=TG
      TAG1(K+1)=TG1
      TAG2(K+1)=TG2
      TAG3(K+1)=TG3
      GO TO 90
      END

C -I-
      SUBROUTINE COPYFL(MDOC,NAME,NAMEI,NAMEO,THRESH,TOP,COEF,BTEMP
     *           ,SCALE,RESMIN,RESMAX,IZMIN,IZMAX,MODE,TITLE
     *           ,POOL,NCRES,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P- COPYFL : copyies files of type 'F   ', 'FS  ','PH  ', 'ABCD','RI  '
C              You may change title of files, cell parameters, resolution,
C              apply coefficient and temperature factor, ...
C              set Rfree flag for reflections
C -S-
C      Dialog:
C
C      FILE_INF: name of inf-file. Symmetry operators will be taken from
C                                  this file.
C      FILE_I:   name of input file which has to be copied..
C      FILE_O:   name of output file.
C      LIMZ:     IZMIN,IZMAX - serial numbers for first and last Z-section
C                               of electron density.
C      TITLE:    text if you want to write into output file new title.
C
C   If you file is type of "F   " or "FS  " then next requests
C   will be :
C
C      COEF:    program will write into out put file
C      BTEMP:                 Fnew=COEF*Fold*EXP(-BTEMP*RSQ)
C
C      THRESH:  program will write into output files only structure factors
C      TOP:                     THRESH < |F| < TOP
C
C      SCALE:   program will write into output file only such
C                structure factors if |Fnew| > sigma * scale   (if scale > 0) 
C
C      MODE:    if MODE = '0' program will write into output file
C                             only reflexes with L = 0 
C
C                         'F' set Rfree flag for reflections.
C
C               default value MODE = 'A' means  all reflections.
C
C      PERC:    percent of Rfree reflections <10>
C
C      RESOL: RESMIN,RESMAX - program will write into output file only reflexes
C                             between these resolutions ( Default values vill
C                             be taken from file).
C   
C      SUBROUTINE COPYFL(MDOC,NAME,NAMEI,NAMEO,THRESH,TOP,COEF,BTEMP
C     *           ,SCALE,RESMIN,RESMAX,IZMIN,IZMAX,MODE,TITLE
C     *           ,POOL,NCRES,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C
C      Parameters:
C
C      MDOC   - mode of writting messages to DOC-file
C               0 - only terminal , < - 0 only file, 0 < < 99 - both
C               >= 99 - don't write  
C      POOL   - real array (NCRES) for
C               one Z-section of electron density NX x NY < NCRES.
C      NCRES  - NCRES dimension of real array POOL.
C      NAMEI  - name of inf-file. Symmetry operators will be taken from
C               this file.
C      NAME   - name of input file which has to be copied..
C      NAMEO  - name of output file.
C      COEF   - program will write into output file:
C      BTEMP  -                      Fnew=COEF*Fold*EXP(-BTEMP*RSQ)
C
C      THRESH  - program will write into output files only structure factors
C      TOP     -                THRESH < |F| < TOP
C
C      SCALE   - program will write into output file only such
C                structure factors if |Fnew| > sigma * scale.
C                (if scale > 0) 
C
C      IZMIN,IZMAX - serial numbers for first and last Z-section
C                    of electron density.
C                    in case MODE = 'F' program use IZMIN as variable PERC 
C      MODE   - /character*1/ if MODE = '0' program will write into output file
C               only reflexes with L = 0 
C               'F' set Rfree flag, percent = IZMIN
C               else default value MODE = 'A' means  all reflexex.
C      TITLE  - /character*80/ - new title of output file.
C      RESMIN - program will write into output file only reflexes
C      RESMAX - between these resolutions ( Default values vill be
C               taken from file).
C      ISYM   - integer*2 array for cryst.symmetry operators /see INF-file/
C      IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM)
C      IERR   - signal of error / =1 -error , =o - OK / 
C      RESULT - real array RESULT(IPRROW) for additional output information
C -I-
C ---------------------------------------------------
C ---
CMS      :POOL
      REAL      POOL(NCRES)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6)
      REAL      RESULT(IPRROW)
      CHARACTER NAMEI*(*),NAME*(*),NAMEO*(*)
C --
      CHARACTER ITYP*4,TTT*160,TITLE*(*),LINE*80
      CHARACTER MSG*1,MODE*1
C ----------------------------------------------------------------------
      IERR   = 0
      MTIN   = 20
      ITYP   = '    '
      IPRINT = 0
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.LE.0.OR.NAME(1:1).EQ.' '.OR.NAME(1:1).EQ.',') THEN
        IERR=1
        RETURN
      ENDIF
      CALL ORFILE(MDOC,MTIN,NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        RETURN
      ENDIF
      CALL GET_TITLE(MDOC,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RESMNN,RESMXX,NX,NY,NZ,IZMNR,IZMXR,TTT,IERR)
      RLATT(1) = A
      RLATT(2) = B
      RLATT(3) = C
      RLATT(4) = AL
      RLATT(5) = BE
      RLATT(6) = GA
C      CALL RTITLE(MTIN,NAME,MDOC,ITYP,IPRINT,A,B,C,AL,BE,GA,
C     *            COEF1,BET1,RESMNN,RESMXX,
C     *            IDMX,IDMY,IDMZ,IDM1,IDM2,TTT)
      IF(ITYP.NE.'F   '.AND.ITYP.NE.'FS  '.AND.ITYP.NE.'PH  '.AND.
     *   ITYP.NE.'ABCD'.AND.ITYP.NE.'RI  ') THEN
        CALL MSGERR(MDOC,' ERR: WRONG TYPE OF FILE')
        IERR=1
        RETURN
      ENDIF
      CALL C_RD_CR
C -------------------------------------------------------------
      M   = -ABS(MDOC)-1
      CALL LENSTR_BL(NAMEI,LEN)
      IF(LEN.GT.0.AND.NAMEI(1:1).NE.' '.AND.NAMEI(1:1).NE.',') THEN
        CALL RD_INF(M,NAMEI,RLATT,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: INF-FILE')
          CLOSE(MTIN)
          RETURN
        ENDIF
        A =RLATT(1)
        B =RLATT(2)
        C =RLATT(3)
        AL=RLATT(4)
        BE=RLATT(5)
        GA=RLATT(6)
      ENDIF
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C ----
      CALL C_CR_WR
C ----
C------------------------------------------------------------------------
      MTOUT = 13
      CALL LENSTR_BL(NAMEO,LN)
      IF(LN.LE.0.OR.NAMEO(1:1).EQ.' '.OR.NAMEO(1:1).EQ.',') MTOUT=0    
C------------------------------------------------------------------------

      CALL LENSTR_BL(TITLE,LN)    
      IF(LN.GT.9.AND.TITLE(1:1).NE.' '.AND.TITLE(1:1).NE.',') 
     * TTT(1:LN)=TITLE(1:LN)

      IF(ITYP.EQ.'RI  ') GO TO 1000
C------------------------------------------------------------------------
      IF(ITYP.EQ.'F   '.OR.ITYP.EQ.'FS  ') THEN
        MSG='N'
        IF(ITYP.EQ.'FS  ') THEN
          IF(ABS(SCALE).GT.1.0E-6) MSG='Y'
          WRITE(LINE,*) ' OMIT F < SIG *',SCALE
          CALL MSGDOC(M,LINE)
        ENDIF
        IF(COEF.LE.1.E-6) COEF=1.
        WRITE(LINE,10) COEF,BTEMP
        CALL MSGDOC(M,LINE)
   10   FORMAT(' SCALE FACTOR =',E12.4,' TEMP FACTOR =',E12.4)
        CALL MSGDOC(M,
     *  ' APPLIED TO INPUT-FILE AND WRITE TO OUT-FILE')
        CALL MSGDOC(M,
     *  ' FNEW=FOLD*SCALE*EXP(-BTEMP*RSQ) ')
        IF(TOP.LT.1.E-6) TOP=1.E 30
        WRITE(LINE,*) 'THRESH,TOP /FOR !F!-OUTPUT/ :',THRESH,TOP
        CALL MSGDOC(M,LINE)
      ENDIF
C ----------------------------------------------
      IF(RESMIN.LT.RESMAX) THEN
        T=RESMIN
        RESMIN=RESMAX
        RESMAX=T
      ENDIF
      IF(RESMIN.LT.1.E-5) RESMIN=RESMNN
      IF(RESMAX.LT.1.E-5) RESMAX=RESMXX
      IF(RESMIN.GE.1.E-5) THEN
        RHMIN=1.0/RESMIN
      ELSE
        RHMIN=0.001
      ENDIF
      IF(RESMAX.GE.1.E-5) THEN
        RHMAX=1.0/RESMAX
      ELSE
        RHMAX=10.0
      ENDIF
C -------------------------------------------------------
      IPRNT = 5000
      IPERC = IZMIN
      IF(IPERC.LE.0.OR.IPERC.GT.100) IPERC=10
C -------------------------------------------------------
      IF(MODE.EQ.'a') MODE='A'
      IF(MODE.EQ.'f') MODE='F'
      IF(MODE.NE.'0'.AND.MODE.NE.'F') MODE='A'
C -------------------------------------------------------
      COEF1 = COEF1 * COEF
      BET1  = BET1  + BTEMP

      IF(MTOUT.GT.0) THEN

        CALL C_CR_WR
        CALL SET_TITLE(MDOC,A,B,C,AL,BE,GA,COEF1,BET1,RESMIN,RESMAX
     *  ,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          CLOSE(MTIN)
          RETURN
        ENDIF
        CALL OWFILE(MDOC,MTOUT,NAMEO,ITYP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          IERR = 2
          CLOSE(MTIN)
          RETURN
        ENDIF
      ENDIF
C ----------------------------------------------------------
      NREF    = 0
      SUMFA   = 0.0
      SUMF    = 0.0
      IEND    = -1
      IEND1   = -1
      NUMB1   = 0
      FNN     = 0.0
      FNA     = 0.0
      SNN     = 0.0
      SNA     = 0.0
      FN      = 0.0
      SN      = 0.0
      N_INPUT = 0
      NBAD_SD = 0
      NOUT    = 0
      NBSIG   = 0
      N1SIG   = 0
      N3SIG   = 0
C -------------------------------------------------------------------
  100 CONTINUE
      IF(ITYP.EQ.'FS  ') THEN
        CALL RRD1(MTIN,IH,IK,IL,FNN,FNA,SNN,SNA,NUMB,IEND)
      ELSE IF(ITYP.EQ.'ABCD') THEN
        CALL RABCD(MTIN,IH,IK,IL,FNN,FNA,SNN,SNA,NUMB,IEND)
      ELSE
        CALL RD1(MTIN,IH,IK,IL,FNN,FNA,NUMB,IEND)
        SNN = 0.04*FNN
        SNA = 0.04*FNA
      ENDIF
      IF(IEND.GT.0)                     GO TO 110

      IF(ITYP.EQ.'F   '.OR.ITYP.EQ.'FS  ') THEN
        IF(FNN.LE.1.E-6.AND.FNA.LE.1.E-6) GO TO 100
        FN=FNN
        SN=SNN
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) THEN
          FMOD= FN *COEF
          SNN = SN *COEF
          FAN = 0.0
          SNA = 0.0
          NREF =NREF +1
          IF(MTOUT.GT.0) THEN
            IF(ITYP.EQ.'F   ') THEN
              CALL WRT(MTOUT,IH,IK,IL,FMOD,FAN,NUMB,IEND1)
            ELSE
              CALL WWRT(MTOUT,IH,IK,IL,FMOD,FAN,SNN,SNA,NUMB,IEND1)
            ENDIF
          ENDIF
          GO TO 100
        ENDIF
      ENDIF
      IF(ITYP.EQ.'F   ') THEN
C       SIG-DUMMY
        SNN = 0.04*FNN
        SNA = 0.04*FNA
      ENDIF
      CALL DSTAR_BL(IH,IK,IL,RSQ)
      RHKL=SQRT(RSQ)
      IF(RHKL.LT.RHMIN.OR.RHKL.GT.RHMAX) THEN
        NOUT=NOUT+1
        GO TO 100
      ENDIF
      IF(MODE.EQ.'0') THEN
        IF(IL.NE.0) GO TO 100
      ENDIF

      N_INPUT=N_INPUT+1

      IF(MODE.EQ.'F') THEN
        CALL HSRD(RAND)
        IRAND = (RAND + 0.5)*100.0
        IT = NUMB/2
        IF(IRAND.LE.IPERC) THEN
          NUMB = IT*2+1
        ELSE
          NUMB = IT*2
        ENDIF
      ENDIF

      IF(ITYP.EQ.'F   '.OR.ITYP.EQ.'FS  ') THEN
        FN=FNN
        SN=SNN
        IF(FNN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
          IF(SNN.LE.0.0000001) SNN=1.0
          IF(SNA.LE.0.0000001) SNA=1.0
          WT1=1./(SNN*SNN)
          WT2=1./(SNA*SNA)
          WT =WT1+WT2
          FN =FNN*WT1+FNA*WT2
          FN =FN/WT
          SN =1./SQRT(WT)
        ELSE IF(FNA.GT.1.E-6) THEN
          FN =FNA
          SN =SNA
        ENDIF
        BT=BTEMP/4.0
        X=COEF*EXP(-BT*RSQ)
        FMOD=FNN*X
        FAN =FNA*X
        SNN =SNN*X
        SNA =SNA*X
        FN  =FN *X
        SN  =SN *X
        IF(FN.LE.THRESH ) GO TO 100
        IF(FN.GT.TOP    ) GO TO 100
        SN3=SN*3.0

        IF(FN.LE.0.0) NBSIG =NBSIG+1
        IF(FN.GE.SN)  N1SIG =N1SIG+1
        IF(FN.GE.SN3) N3SIG =N3SIG+1
   
        IF(MSG.EQ.'Y') THEN
          SSCL1=SCALE*SN
          IF(FN.LT.SSCL1) THEN
            NBAD_SD=NBAD_SD+1
            GO TO 100
          ENDIF
        ELSE
          NGTSIG =NGTSIG+1
        ENDIF
        SUMF =SUMF +FMOD
        SUMFA=SUMFA+FAN
      ELSE
        FMOD=FNN
        FAN =FNA
      ENDIF
      NREF =NREF +1
      IF(MTOUT.GT.0) THEN
        IF(ITYP.EQ.'FS  ') THEN
          CALL WWRT(MTOUT,IH,IK,IL,FMOD,FAN,SNN,SNA,NUMB,IEND1)
        ELSE IF(ITYP.EQ.'ABCD') THEN
          CALL WABCD(MTOUT,IH,IK,IL,FMOD,FAN,SNN,SNA,NUMB,IEND1)
        ELSE
          CALL WRT(MTOUT,IH,IK,IL,FMOD,FAN,NUMB,IEND1)
        ENDIF
      ENDIF
C ----------
      IF(IPRNT.GT.0) THEN
        IF(MOD(NREF,IPRNT).EQ.0) THEN
          IF(ITYP.EQ.'F   '.OR.ITYP.EQ.'FS  ') THEN
            WRITE(LINE,20) NREF,IH,IK,IL,FMOD,FAN
            CALL MSGDOC(MDOC,LINE)
          ELSE IF(ITYP.EQ.'ABCD') THEN
            WRITE(LINE,30)NREF,IH,IK,IL,FMOD,FAN,SNN,SNA
            CALL MSGDOC(MDOC,LINE)
          ELSE
            WRITE(LINE,40) NREF,IH,IK,IL,FMOD,FAN
            CALL MSGDOC(MDOC,LINE)
          ENDIF
   20     FORMAT(' N',I6,' H=',I4,' K=',I4,' L=',I4,' FA=',E12.4,
     *           ' FB=',E12.4)
   30     FORMAT(' N',I5,' H=',I3,' K=',I3,' L=',I3,' A=',F10.4,
     *           ' B=',F10.4,' C=',F10.4,' D=',F10.4)
   40     FORMAT(' N',I6,' H=',I4,' K=',I4,' L=',I4,' mCOS=',E12.4,
     *           ' mSIN=',E12.4)
        ENDIF
      ENDIF
C -----------
      GO TO 100
C -----------------------------------------------------------
  110 CONTINUE
      IEND1=2
      IF(MTOUT.GT.0) THEN
        IF(ITYP.EQ.'ABCD') THEN
          CALL WABCD(MTOUT,IH,IK,IL,FMOD,FAN,SNN,SNA,NUMB,IEND1)
        ELSE
          CALL WRT(MTOUT,IH,IK,IL,FNN,FNA,NUMB,IEND1)
        ENDIF
      ENDIF
C ----------------
      WRITE(LINE,50) NREF
   50 FORMAT(' NUMBER OF REFLS=',I6)
      CALL MSGDOC(MDOC,LINE)
c      IF(ITYP.EQ.'F   '.OR.ITYP.EQ.'FS  ') THEN
c        FAV =0.0
c        FAVA=0.0
c        IF(NREF.GT.0) THEN
c          FAV =SUMF /NREF
c          FAVA=SUMFA/NREF
c        ENDIF
c        WRITE(LINE,60) FAV,FAVA
c        CALL MSGDOC(MDOC,LINE)
c   60   FORMAT(' F-AVER=',E12.4,' FANOM-AVER=',E12.4)
c      ENDIF
      RESULT(1)  = NREF
      RESULT(2)  = RESMIN
      RESULT(3)  = RESMAX
      RESULT(4)  = 0.0
      RESULT(5)  = 0.0
      RESULT(6)  = 0.0
      RESULT(7)  = N3SIG

      IF(IPRROW.GE.21) THEN
        RESULT(11) = 0.0
        RESULT(12) = 0.0
        RESULT(13) = 0.0
        RESULT(14) = 0.0
        RESULT(15) = N1SIG
        RESULT(16) = N_INPUT
        RESULT(17) = NBSIG
        RESULT(18) = NSYM
        RESULT(19) = 0.0
        RESULT(20) = SCALE
        RESULT(21) = NOUT
C        RESULT(11) - R-mult
C        RESULT(12) - number of refls after average.
C        RESULT(13) - number of refls before average.
C        RESULT(14) - R-st(I)
C        RESULT(15) - number of refls with I > sig.
C        RESULT(16) - number of refls in input file.
C        RESULT(17) - NBAD_SD
C        RESULT(18) - NSYM
C        RESULT(19) - NBAD_ABS
C        RESULT(20) = SD_LIM
      ENDIF
      CLOSE(MTIN)

      RETURN
C -----------------------------------------------
 1000 CONTINUE
      CLOSE(MTIN)
      ITYPE  =-2
      MTIN   =10
      IERR=0
      CALL RDENS(MTIN,NAME,M,ITYPE,JZ,NXR,NYR,NZR,IZMR,
     * IZNR,RMAX,RMIN,POOL,AR,BR,CR,ALR,BER,GAR,DRMS,
     * RAVER,RESOL,IX0,IY0,IZ0,ITR,TTT,NS,POOL,IPRSYM,IERR)
      NXYR=NXR*NYR
      IF(IERR.GT.0) RETURN
      IF(NXYR.GT.NCRES) THEN
        WRITE(LINE,'('' ERR: NO MEMORY FOR PLAN-XY :'',I8)') NCRES
        CALL MSGERR(MDOC,LINE)
        IERR=1
        CLOSE(MTIN)
        RETURN
      ENDIF
C--------------------------------------------------------
      ITYP     = 'RI  '
      IPRINT   = 1
      IZMINW   = IZMIN
      IF(IZMINW.LT.IZNR) IZMINW=IZNR
      IZMAXW   = IZMAX
      IF(IZMAXW.GT.IZMR) IZMAXW=IZMR
      NZW=IZMAXW-IZMINW+1
      IF(MTOUT.GT.0) THEN
        CALL LENSTR_BL(TITLE,LN)    
        IF(LN.GT.9.AND.TITLE(1:1).NE.' '.AND.TITLE(1:1).NE.',') 
     *  TTT=TITLE
        CALL C_CR_WR
        CALL SET_TITLE(MDOC,A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM
     *  ,NXR,NYR,NZW,IZMINW,IZMAXW,TTT,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          CLOSE(MTIN)
          RETURN
        ENDIF
        CALL OWFILE(MDOC,MTOUT,NAMEO,ITYP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
          CLOSE(MTIN)
          RETURN
        ENDIF
      ENDIF
C---------------------------------------------------------------
      ICNTZ3=-999
      ITYPE=1
      DO     IZ=IZNR,IZMR
        CALL RDENS(MTIN,NAME,MDOC,ITYPE,JZ,NXR,NYR,NZR,IZMR,
     *  IZNR,RMAX,RMIN,POOL,AR,BR,CR,ALR,BER,GAR,DRMS,
     *  RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE,NS,ISYM,IPRSYM,IERR)
        IF(MTOUT.GT.0) THEN
          CALL WDENS(MTOUT,MDOC,ICNTZ3,NXR,NYR,NZW,IZMINW,IZMAXW,
     *             RMAXD,RMIND,POOL,RESOL,IX0,IY0,IZ0,ITR)
        ENDIF
      ENDDO
C -----------------------------------------------
      CLOSE(MTIN)
      RETURN
      END

C -I-
      SUBROUTINE CONCRD(MDOC,MODE,NAME1,NAME2,NAMEI,SETT,REST
     * ,WAT,P1,HATM,NUM,NOCC,ALT,CONV
     * ,A,B,C,ALPHA,BETA,GAMMA,BOV,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
C -P- CONCRD - copies "BLANC"_file to "BLANC"_file and :
C                changes SETTING for monoclinic space groups; 
C                restores NCS-related atoms; 
C                removes water molecules; 
C                sets new value B_iso or/and occupancies = 1 to all atoms; 
C                changes space group ;
C                sets new atom's number (started from 1); 
C                removes H-atoms;
C                removes alternative position; 
C                removes all atoms except:
C                   -  CA
C                   -  back bond"s atoms + CB
C                   -  P
C                converts fract. coords to ort. or ort. to fract.
C -S-
C
C  Dialog and Batch: 
C
C    FILE_IN  - input file of coordinates.
C    FILE_OUT - output file.
C
C    SETT     - <N>/Y -  change SETTING 
C                        for monoclinic space groups
C    REST     - <N>/Y  - restore NCS-related atoms
C    WAT      - <N>/Y -  remove water molecules
C    HATM     - <N>/Y -  remove H-atoms
C    HATM:    - <N>/Y/Q  Y- remove H_atoms, Q and atoms with name started by Q
C    ALT      - <N>/Y -  remove alternative positions /except "A" or "1"/
C    NUM      - <N>/Y -  set new atom's number.
C    NOCC     - <N>/Y -  set all occupancies = 1.0
C    P1       - <N>/Y -  Y set new space group P1
C                        or P1= new space group name, for example 'P 1 21 1'
C    CELL: <from file> - A,B,C,alpha,beta,gamma/degrees/ if P1="Y"
C    BOV        <0> - Boverall, set this value for all atoms.
C                     0 means not to change 
C    MODE:  <Y>  - all  atoms will be included in output file.
C            A   - only CA
C            B   - only back bond"s atoms + CB
C            P   - only P
C    CONV:  <N>  - 
C            F   - convert to fractional coordinates
C            C   - convert to ortoganal  coordinates
C                        
C
C  Parameters of subroutine CONCRD: 
C
C      SUBROUTINE CONCRD(MDOC,MODE,NAME1,NAME2,NAMEI,SETT,REST
C     * ,WAT,P1,HATM,NUM,NOCC,ALT,CONV
C     * ,A,B,C,ALPHA,BETA,GAMMA,BOV,ISYM,IPRSYM,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    MODE   - see above. / character*1 /
C    NAME1  - name of input file without extention.
C    NAME2  - name of output file without extention.
C    NAMEI  - dummy
C    SETT   - see above. / character*1 /
C    REST   - see above. / character*1 /
C    WAT    - see above. / character*1 /
C    HATM   - see above. / character*1 /
C    ALT    - see above. / character*1 /
C    NUM    - see above. / character*1 /
C    NOCC   - see above. / character*1 /
C    P1     - see above. / character*1 /
C    CONV   - see above. / character*1 /
C    A,B,C  - for P1 ne "N" - new cell parameters.
C    ALPHA,BETA,GAMMA
C    BOV    - Boverall, 0 means not to change / MODE="C"/
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C -I-
C ----------------------------------------------------------
      INTEGER     MDOC,IPRSYM,IERR
      INTEGER*2   ISYM(5,3,IPRSYM)
      CHARACTER   MODE*1,SETT*1,REST*1,WAT*1,P1*(*)
      CHARACTER   HATM*1,NUM*1,NOCC*1,ALT*1,CONV*1
      CHARACTER   NAME1*(*),NAME2*(*),NAMEI*(*)
C==================================================================
      IERR=0

        IF(MODE.EQ.'b') MODE='B'
        IF(MODE.EQ.'p') MODE='P'
        IF(MODE.EQ.'a') MODE='A'
        IF(MODE.NE.'B'.AND.MODE.NE.'P'.AND.MODE.NE.'A') MODE='Y'

        IF(CONV.EQ.'f') CONV='F'
        IF(CONV.EQ.'c') CONV='C'
        IF(CONV.NE.'F'.AND.CONV.NE.'C') CONV='N'

        IF(SETT.EQ.'y') SETT='Y'
        IF(SETT.NE.'Y') SETT='N'
        IF(WAT.EQ.'y') WAT='Y'
        IF(WAT.NE.'Y') WAT='N'
        IF(P1(1:1).EQ.'y') P1='Y'
        IF(P1(1:1).EQ.'n'.OR.P1(1:1).EQ.' '.OR.P1(1:1).EQ.'.') P1='N'
        IF(NUM.EQ.'y')  NUM='Y'
        IF(ALT.EQ.'y')  ALT='Y'
        IF(NOCC.EQ.'y') NOCC='Y'
        IF(HATM.EQ.'y') HATM='Y'
        IF(HATM.EQ.'q') HATM='Q'
        IF(HATM.NE.'Y'.AND.HATM.NE.'Q') HATM='N'
        CALL COPY_CRD(MDOC,MODE,NAME1,NAME2,SETT,REST,WAT,P1,
     *   HATM,NUM,NOCC,ALT,CONV
     *   ,A,B,C,ALPHA,BETA,GAMMA,BOV,ISYM,IPRSYM,IERR)

C ---------------------------
      RETURN
      END


      SUBROUTINE COPY_CRD(MDOC,MOD,NAME1,NAME2,SETT,REST,WAT,P1,
     * HATM,NUM,NOCC,ALT,CONV
     * ,A,B,C,CALPHA,CBETA,CGAMMA,BOV,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAME1*(*),NAME2*(*),MOD*1,CONV*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER SETT*1,REST*1,WAT*1,P1*(*),HATM*1,NUM*1,NOCC*1,ALT*1
C ---
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of atom from the file.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ----------------------
      REAL        X(3),Y(3),Z(3),AMNCS(3,3),TRNCS(3)
      REAL        AM(3,3)
      INTEGER     MODE
      CHARACTER   LINE*80,NCSF*1,GID*4,NCS_FLAG*1,CHAIN*2,STR*80
C --------------------------------------------------------------
      PI  = 4.0*ATAN(1.0)
      IN  = 10
      MD  = -ABS(MDOC)-1
      IF(REST.EQ.'y') REST='Y'
      IF(REST.NE.'Y') REST='N'
      NCS_FLAG='N'
C --------
      CALL ORCRD(MD,IN,NAME1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN IN_FILE')
        CLOSE(IN)
        RETURN
      ENDIF
C ------------------------------------------------
      CALL C_AT_CR
      NCSOP=0
      CALL GET_NCS(MDOC,NCMAX,NCSOP,AMNCS,TRNCS,IERR)
      IF(IERR.NE.0) RETURN      
      IF(NCSOP.GT.0) THEN
        IGR=0
        CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                 ,IGOLD,NCSF,GID,IERR)
        IF(IERR.NE.0) RETURN      
        IF(NGR.GT.0) THEN
          DO IGR=1,NGR
            CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
c            write(*,*) IGR,ICH,INC,MLT
            IF(IERR.NE.0) RETURN      
            IF(NCSF.EQ.'c') NCSF='C'
            IF(NCSF.EQ.'N'.OR.NCSF.EQ.'n') THEN
              NCS_FLAG='Y'
              IF(REST.EQ.'Y') NCSF='c'
            ENDIF
            CALL SET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                 ,IGOLD,NCSF,GID,IERR)
          ENDDO
        ENDIF
        WRITE(STR,
     *  '(''NUMBER OPERATORS OF NON-CRYST.SYMMETRY:'',I5)') NCSOP
        CALL MSGDOC(MDOC,STR)
        IF(NCSOP.GT.0) THEN
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,'  X-NEW           X-0      TX')
          CALL MSGDOC(MDOC,'  Y-NEW  = [M] *  Y-0  +   TY')
          CALL MSGDOC(MDOC,'  Z-NEW           Z-0      TZ')
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,' ORTOGONAL COORDINATE SYSTEM')
          CALL MSGDOC(MDOC,'  COORDINATES IN ANGSTROMS')
          CALL MSGDOC(MDOC,' ')
          DO     I=1,NCSOP
            CALL GET_NCS(MDOC,NCMAX,I,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) RETURN      
            WRITE(STR,600) I
            CALL MSGDOC(MDOC,STR)
  600       FORMAT('  OPERATORS OF NON-CRYST.SYMMETRY :',I5)
            CALL ANGFIX(MDOC,AMNCS,ALPHA,BETA,GAMMA)
            WRITE(STR,610) (TRNCS(L),L=1,3)
            CALL MSGDOC(MDOC,STR)
  610       FORMAT(' TRANSLATION VECTOR :',3F10.5,' /ANGSTROM/')
          ENDDO
        ELSE
          WRITE(STR,
     *    '('' ERR: NUMBER OF NCS-OPERATORS:'',I5)') NCSOP
          CALL MSGDOC(MDOC,STR)
          IERR=1
          RETURN
        ENDIF
      ENDIF
C--------------------------------------------------
      IF(CR_NSPGR.GE.3.AND.CR_NSPGR.LE.15.AND.SETT.EQ.'Y') THEN
        IS=CR_SETT
        IF(IS.EQ.2) THEN
          T     = CR_CELL(1) 
          CR_CELL(1) = CR_CELL(3)
          CR_CELL(3) = CR_CELL(2)
          CR_CELL(2) = T
          T     = CR_CELL(4)
          CR_CELL(4) = CR_CELL(6)
          CR_CELL(6) = CR_CELL(5)
          CR_CELL(5) = T
          GAMMA = CR_CELL(6)-PI/2.0
        ELSE                 
          GAMMA  = -(CR_CELL(6)-PI/2.0)
          T     = CR_CELL(1) 
          CR_CELL(1)  = CR_CELL(2)
          CR_CELL(2)  = CR_CELL(3)
          CR_CELL(3)  = T
          T     = CR_CELL(4)
          CR_CELL(4) = CR_CELL(5)
          CR_CELL(5) = CR_CELL(6)
          CR_CELL(6) = T
        ENDIF
        IN_STRING = CR_SPGR
        CALL FRD_PARM
        IF(WORDS(1)(1:1).EQ.'B') THEN
          WORDS(1)(1:1)='C'
        ELSE IF(WORDS(1)(1:1).EQ.'B') THEN
          WORDS(1)(1:1)='C'
        ENDIF
        CR_SPGR=WORDS(1)(1:LEN_WORDS(1))//' '
     *      //WORDS(2)(1:LEN_WORDS(2))//' '
     *      //WORDS(4)(1:LEN_WORDS(4))//' '
     *      //WORDS(3)(1:LEN_WORDS(3))
        IF(IS.EQ.2) THEN
          CR_SETT=1
        ELSE
          CR_SETT=2
        ENDIF
        ALPHA=0.0
        BETA =0.0
        CALL EULERM(ALPHA,BETA,GAMMA,AM)

        DO I=1,NSYM
          DO K=1,5
            IT         = ISYM(K,2,I)
            ISYM(K,2,I)= ISYM(K,3,I)
            ISYM(K,3,I)= IT
          ENDDO
          DO J=1,3
            IT         = ISYM(2,J,I)
            ISYM(2,J,I)= ISYM(3,J,I)
            ISYM(3,J,I)= IT
          ENDDO
        ENDDO

        IF(NCSOP.GT.0) THEN
          DO I=1,NCSOP

            CALL GET_NCS(MDOC,NCMAX,I,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) RETURN      

            DO K=1,3
              T        = AMNCS(K,2)
              AMNCS(K,2)= AMNCS(K,3)
              AMNCS(K,3)= T
            ENDDO
            DO J=1,3
              T        = AMNCS(2,J)
              AMNCS(2,J)= AMNCS(3,J)
              AMNCS(3,J)= T
            ENDDO

            X(1)=TRNCS(1)
            X(2)=TRNCS(2)
            X(3)=TRNCS(3)
            IF(IS.EQ.2) THEN
              T = X(1) 
              X(1) = X(3) 
              X(3) = X(2)
              X(2) = T
            ENDIF        
            CALL MVMULT(AM,X,Y)
            IF(IS.EQ.1) THEN
              TRNCS(1)=Y(2)
              TRNCS(2)=Y(3)
              TRNCS(3)=Y(1)
            ELSE
              TRNCS(1)=Y(1)
              TRNCS(2)=Y(2)
              TRNCS(3)=Y(3)
            ENDIF
        
            CALL SET_NCS(MDOC,NCMAX,I,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) RETURN      

          ENDDO

        ENDIF
      ENDIF
C -------------------------------------------------
      IOUT=0
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.','.AND.NAME2(1:1).NE.' ') THEN 
        NSM=NSYM
        IF(P1(1:1).EQ.'Y') THEN
          IF(A.GT.0.1.AND.B.GT.0.1.AND.C.GT.0.1.AND.
     *       CALPHA.GT.0.1.AND.CBETA.GT.0.1.AND.CGAMMA.GT.0.1) THEN
            CR_CELL(1)=A
            CR_CELL(2)=B
            CR_CELL(3)=C
            CR_CELL(4)=(CALPHA*PI)/180.0 
            CR_CELL(5)=(CBETA *PI)/180.0
            CR_CELL(6)=(CGAMMA*PI)/180.0
          ENDIF
          CR_NSPGR=1
          CR_SETT =1
          CR_NSYM =1
          CR_SPGR='P 1'
          NSM=1

        ELSE IF(P1(1:1).NE.'N') THEN
          CALL LENSTR_BL(P1,LEN)
          IF(LEN.GT.0.AND.LEN.LE.24) THEN
            IF(A.GT.0.1.AND.B.GT.0.1.AND.C.GT.0.1.AND.
     *         CALPHA.GT.0.1.AND.CBETA.GT.0.1.AND.CGAMMA.GT.0.1) THEN
              CR_CELL(1)= A
              CR_CELL(2)= B
              CR_CELL(3)= C
              CR_CELL(4)= (CALPHA*PI)/180.0 
              CR_CELL(5)= (CBETA *PI)/180.0
              CR_CELL(6)= (CGAMMA*PI)/180.0
              CR_NSPGR  = 0
              CR_SETT   = 0
              CR_NSYM   = 0
              CR_SPGR   = P1(1:LEN)

              IF(CR_SPGR.EQ.'P2' .OR.CR_SPGR.EQ.'P 2' .OR.
     *           CR_SPGR.EQ.'P21'.OR.CR_SPGR.EQ.'P 21'.OR.
     *           CR_SPGR.EQ.'B2' .OR.CR_SPGR.EQ.'B 2' .OR.
     *           CR_SPGR.EQ.'C2' .OR.CR_SPGR.EQ.'C 2'     ) THEN
                T  = PI/2.0
c                CR_SETT = 2
                IF(ABS(CR_CELL(6)-T).GT.0.0001.AND.
     *             ABS(CR_CELL(5)-T).LE.0.0001     ) CR_SETT = 1
                IF(CR_SPGR.EQ.'P2'.OR.CR_SPGR.EQ.'P 2') THEN
                  IF(CR_SETT.EQ.1) THEN
                    CR_SPGR = 'P 1 1 2'
                  ELSE
                    CR_SPGR = 'P 1 2 1'
                  ENDIF
                ELSE IF(CR_SPGR.EQ.'P21'.OR.CR_SPGR.EQ.'P 21') THEN
                  IF(CR_SETT.EQ.1) THEN
                    CR_SPGR = 'P 1 1 21'
                  ELSE
                    CR_SPGR = 'P 1 21 1'
                  ENDIF
                ELSE IF(CR_SPGR.EQ.'B2'.OR.CR_SPGR.EQ.'B 2'.OR.
     *              CR_SPGR.EQ.'C2'.OR.CR_SPGR.EQ.'C 2'    ) THEN
                  IF(CR_SETT.EQ.1) THEN
                    CR_SPGR = 'B 1 1 2'
                  ELSE
                    CR_SPGR = 'C 1 2 1'
                  ENDIF
                ENDIF
              ENDIF

              CALL GET_SYMM(MDOC,CR_NSPGR,CR_SETT,CR_SPGR
     *        ,CR_NSYM,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) RETURN      
              NSM=CR_NSYM
            ENDIF
          ENDIF
        ENDIF          
        IOUT=11
        CALL OWCRD(MD,IOUT,NAME2,NSM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN OUT_FILE')
          CLOSE(IN) 
          RETURN
        ENDIF
      ENDIF
C -------------------------------------------------
      IENDW=-1
C      MODE=0     
C      CALL WRCRD(MDOC,IOUT,MODE,IEND,IERR)
C      IF(IERR.NE.0) THEN
C        CLOSE(IN) 
C        RETURN
C      ENDIF
      NA=0
      IEND=-1
      MD=99
      IF(REST.EQ.'N') NCSOP=0
      N_NCS=NCSOP+1

      DO ISM=1,N_NCS
        NCRSYM=ISM-1
        IF(NCRSYM.GT.0) THEN

          CALL ORCRD(MD,IN,NAME1,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: OPEN IN_FILE')
            CLOSE(IN)
            RETURN
          ENDIF

          IEND=-1
        ENDIF

 200  CONTINUE
C --------------------------------
      CALL RDCRD(MD,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IOUT)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MODE.EQ.0) THEN
        
        IF(WAT.EQ.'Y'.AND.
     *  (CR_RNAME(1:3).EQ.'HOH'.OR.CR_RNAME(1:3).EQ.'DOD')) GO TO 200

        IF(HATM.EQ.'Y'.AND.(CR_ASYMB(1:4).EQ.'H   '.OR.
     *  CR_ASYMB(1:4).EQ.'D   ')) GO TO 200


        IF(HATM.EQ.'Q'.AND.(CR_ASYMB(1:4).EQ.'H   '.OR.
     *  CR_ASYMB(1:4).EQ.'D   ')) GO TO 200

        IF(HATM.EQ.'Q'.AND.CR_ANAME(1:1).EQ.'Q') GO TO 200

        IF(ALT.EQ.'Y'.AND.(CR_ALT.NE.'A'.AND.CR_ALT.NE.'1'.AND.
     *     CR_ALT.NE.'.'.AND.CR_ALT.NE.'0')) GO TO 200

        IF(MOD.EQ.'B') THEN
          IF(CR_ANAME.NE.'C   '.AND.CR_ANAME.NE.'CA  '.AND.
     *    CR_ANAME.NE.'O   '.AND.CR_ANAME.NE.'N   '.AND.
     *    CR_ANAME.NE.'CB  ')
     *    GO TO 200
        ELSE IF(MOD.EQ.'A') THEN
          IF(CR_ANAME.NE.'CA  ') GO TO 200
        ELSE IF(MOD.EQ.'P') THEN
          IF(CR_ANAME.NE.'P   ') GO TO 200
        ENDIF

        IF(ALT.EQ.'Y') THEN
          CR_ALT ='.'
          CR_CORR='.'
        ENDIF
        IF(SETT.EQ.'Y') THEN
          X(1)=CR_XYZ(1)
          X(2)=CR_XYZ(2)
          X(3)=CR_XYZ(3)
          IF(IS.EQ.2) THEN
            T = X(1) 
            X(1) = X(3) 
            X(3) = X(2)
            X(2) = T
          ENDIF        
          CALL MVMULT(AM,X,Y)
          IF(IS.EQ.1) THEN
            CR_XYZ(1)=Y(2)
            CR_XYZ(2)=Y(3)
            CR_XYZ(3)=Y(1)
          ELSE
            CR_XYZ(1)=Y(1)
            CR_XYZ(2)=Y(2)
            CR_XYZ(3)=Y(3)
          ENDIF        
        ENDIF

        IF(REST.EQ.'Y'.AND.NCS_FLAG.EQ.'Y') THEN

          IF(NCRSYM.EQ.0) THEN
            IGR_OLD=CR_IGROUP
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description'')') 
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
              IF(IGOLD.EQ.IGR_OLD.AND.INC.EQ.0) THEN
                GO TO 400
              ENDIF
            ENDDO
            WRITE(STR,
     *      '('' ERR: wrong NCS description'')') 
            CALL MSGERR(MDOC,STR)
            IERR=1
            RETURN

  400       CONTINUE                    
            ICHAIN=ICHOLD
            Z(1)=CR_XYZ(1)
            Z(2)=CR_XYZ(2)
            Z(3)=CR_XYZ(3)
          ELSE
            IGR_OLD=CR_IGROUP
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description'')') 
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
              IF(IGOLD.EQ.IGR_OLD) THEN
                GO TO 410
              ENDIF
            ENDDO
            WRITE(STR,
     *      '('' ERR: wrong NCS description'')') 
            CALL MSGERR(MDOC,STR)
            IERR=1
            RETURN

  410       CONTINUE                    
            ICHAIN=ICHOLD
            Z(1)=CR_XYZ(1)
            Z(2)=CR_XYZ(2)
            Z(3)=CR_XYZ(3)
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description'')') 
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
c             write(*,*) NCSF,NCRSYM,GID(1:2),CHAIN
              IF((NCSF.EQ.'N'.OR.NCSF.EQ.'n').AND.
     *           INC.EQ.NCRSYM.AND.ICHOLD.EQ.ICHAIN) GO TO 730
            ENDDO
            GO TO 710  
 730        CONTINUE
            CR_IGROUP=IGOLD
            CALL GET_NCS(MDOC,NCMAX,INC,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN      
            ENDIF
            CALL MVMULT(AMNCS,Z,Y)
            Y(1)=Y(1)+TRNCS(1)
            Y(2)=Y(2)+TRNCS(2)
            Y(3)=Y(3)+TRNCS(3)
            CR_XYZ(1)=Y(1)
            CR_XYZ(2)=Y(2)
            CR_XYZ(3)=Y(3)
          ENDIF

        ENDIF

        IF(BOV.GT.0.0)  CR_BISO=BOV 
        IF(NOCC.EQ.'Y') CR_OCC=1.0 

        IF(CONV.EQ.'F'.AND.CR_PDB_REC(1:1).NE.'F') THEN

          CR_PDB_REC(1:1)='F'
          Z(1)=CR_XYZ(1)
          Z(2)=CR_XYZ(2)
          Z(3)=CR_XYZ(3)
          CALL MVMULT(CR_ORT_TO_FRAC,Z,Y)
          CR_XYZ(1)=Y(1)
          CR_XYZ(2)=Y(2)
          CR_XYZ(3)=Y(3)

        ELSE IF(CONV.EQ.'C'.AND.CR_PDB_REC(1:1).EQ.'F') THEN

          CR_PDB_REC(1:1)='C'
          Z(1)=CR_XYZ(1)
          Z(2)=CR_XYZ(2)
          Z(3)=CR_XYZ(3)
          CALL MVMULT(CR_FRAC_TO_ORT,Z,Y)
          CR_XYZ(1)=Y(1)
          CR_XYZ(2)=Y(2)
          CR_XYZ(3)=Y(3)

        ENDIF

      ENDIF      
C ----
      IF(MODE.EQ.0) NA=NA+1
      IF(NUM.EQ.'Y') CR_IATOLD=NA

      IF(CONV.EQ.'F') THEN
        CALL WRCRD(MD,IOUT,MODE,IENDW,IERR)
      ELSE
        CALL WRCRD(MD,IOUT,MODE,IENDW,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(IN) 
        RETURN
      ENDIF
 710  CONTINUE


C ------------------------
      GO TO 200
C ------------------------------------------------------
 300  CONTINUE

      ENDDO

      WRITE(LINE,500) NA
  500 FORMAT(' NUMBER OF ATOMS   :',I6)
      CALL MSGDOC(MDOC,LINE)
      CLOSE(IN)
      IEND=1
      MODE=0     
      CALL WRCRD(MDOC,IOUT,MODE,IEND,IERR)
C --------------------------------------
      RETURN
      END


C -I-
      SUBROUTINE WRITEPDB(MDOC,NAME1,NAME2,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
C -P- writePDB - converts cooordinate's file from "BLANC"-system to "PDB"; 
C -S-
C
C  Dialog and Batch: 
C
C    FILE_IN  - input file of coordinates.
C    FILE_OUT - output file.
C
C  Parameters of subroutine WRITEPDB: 
C
C      SUBROUTINE WRITEPDB(MDOC,NAME1,NAME2,ISYM,IPRSYM,IERR)
C
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    NAME1  - name of input file without extention.
C    NAME2  - name of output file without extention.
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C -I-
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAME1*(*),NAME2*(*)
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compound
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of atom from the file.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
      INTEGER     MODE,IANIS(6)
      REAL        FRTOCR(3,3),CRTOFR(3,3),XA(3)
      CHARACTER   ATOM*4,RES*3,ALT*1,CHAIN*2
      CHARACTER   EXT*3,PATH*1,LINE*80,STR*80
      CHARACTER   NCSF*1,GID*4,CH5*5
C --------------------------------------------------------------
      IN  = 10
      IOUT=  0
      MD  = 99
      PATH=' '
C --------
      CALL ORCRD(MD,IN,NAME1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN IN_FILE')
        CLOSE(IN)
        RETURN
      ENDIF
C ---
      IGR=0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
C ---
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.','.AND.NAME2(1:1).NE.' ') THEN 
        EXT ='pdb'
        IOUT=11
        CALL OPENFW(IOUT,MD,PATH,NAME2,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN OUT_FILE')
          CLOSE(IN)
          RETURN
        ENDIF
      ENDIF
C -------------------
      CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *                            ,FRTOCR,CRTOFR,IERR)
C
C                                 ! 11 21 31 !
C            Xo=[FRTOCR] Xf    RO=! 12 22 32 !
C                                 ! 13 23 33 !
C
C ---- PDB-TITLE ----
      CALL LENSTR_BL(CR_NAME_PDB,LEN)
      IF(LEN.GE.13) THEN
        LN=LEN-12
        STR(1:LN)=CR_NAME_PDB(13:LEN)
      ELSE
        STR(1:1)='?'
        LN=1      
      ENDIF
      IF(LN.LT.40) THEN
        DO II=LN+1,40
          STR(II:II)=' '
        ENDDO
      ENDIF
      WRITE(LINE,140) STR(1:40),CR_DATE_PDB,CR_CD_PDB
  140 FORMAT ('HEADER',4X,A40,A9,3X,A4)
      WRITE(IOUT ,'(A80)') LINE
      WRITE(LINE,150) CR_TITLE(9:68)
  150 FORMAT ('COMPND',4X,A60)
      WRITE(IOUT ,'(A80)') LINE
      NCODE=1
      ZERO=0.0
      CR_CELL(4)=(CR_CELL(4)*180.0)/3.1415926
      CR_CELL(5)=(CR_CELL(5)*180.0)/3.1415926
      CR_CELL(6)=(CR_CELL(6)*180.0)/3.1415926
      WRITE(LINE,100) CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6),CR_SPGR
  100 FORMAT ('CRYST1',3F9.3,3F7.2,1X,A11)
      WRITE(IOUT ,'(A80)') LINE
      WRITE(LINE,110) CRTOFR(1,1),CRTOFR(2,1),CRTOFR(3,1),ZERO
  110 FORMAT ('SCALE1',4X,3F10.6,5X,F10.6)
      WRITE(IOUT ,'(A80)') LINE
      WRITE(LINE,120) CRTOFR(1,2),CRTOFR(2,2),CRTOFR(3,2),ZERO
  120 FORMAT ('SCALE2',4X,3F10.6,5X,F10.6)
      WRITE(IOUT ,'(A80)') LINE
      WRITE(LINE,130) CRTOFR(1,3),CRTOFR(2,3),CRTOFR(3,3),ZERO
  130 FORMAT ('SCALE3',4X,3F10.6,5X,F10.6)
      WRITE(IOUT ,'(A80)') LINE
C -------------------
      NA   = 0
      NNA  = 0
      IEND =-1
      MD   =99
  200 CONTINUE
C --------------------------------
      CALL RDCRD(MD,IN,MODE,IEND,IERR)
      IF(IERR.EQ.1) THEN
        CLOSE(IOUT)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MODE.GT.0) GO TO 200    

      IF(CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.CR_ATYPE.NE.'y'.AND.
     *   CR_ATYPE.NE.'Y'.AND.CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R')
     *   GO TO 200

      CALL PDB_ANAME(CR_ANAME,CR_ASYMB,CR_RNAME,ATOM)

      RES   = CR_RNAME
      IRES  = CR_IRES
      ALT   = CR_ALT 
      CHAIN = CR_CHAIN
      XA(1) = CR_XYZ(1)
      XA(2) = CR_XYZ(2)
      XA(3) = CR_XYZ(3)
      OCC   = CR_OCC
      B     = CR_BISO
      CH5   = CR_PNUM(3:7)
      IF(CH5(5:5).EQ.'-') CH5(5:5)=' '             
C ----
      NA  = NA+1
      NNA = NNA+1
      IF(NNA.GE.100000) NNA=1
      IF(ALT.EQ.'.') ALT=' '
      IF(CHAIN(1:1).EQ.'.') CHAIN(1:1)=' '
      IF(CHAIN(2:2).EQ.'.') CHAIN(2:2)=' '
      WRITE(CHAIN,'(I2)') CR_IGROUP
      CHAIN(1:1)=' '
      IF(NGR.GT.0) THEN
        IGR=CR_IGROUP
        IF(IGR.GT.0.AND.IGR.LE.NGR) THEN
          CALL GET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
          IF(IERR.NE.0) RETURN
          CHAIN(2:2)=GID(1:1)
        ENDIF
      ENDIF
      IF(CHAIN(1:1).EQ.'.') CHAIN(1:1)=' ' 
      IF(CHAIN(2:2).EQ.'.') CHAIN(2:2)=' ' 


C      WRITE(LINE,400) NA,ATOM,ALT,RES,CHAIN,IRES
C     *               ,XA(1),XA(2),XA(3),OCC,B
C 400  FORMAT ('ATOM',1X,I6,1X,A4,A1,A3,A2,I4,4X,3F8.3,2F6.2)

      WRITE(LINE,400) NNA,ATOM,ALT,RES,CHAIN,CH5
     *               ,XA(1),XA(2),XA(3),OCC,B
 400  FORMAT ('ATOM',1X,I6,1X,A4,A1,A3,A2,A5,3X,3F8.3,2F6.2)
      CALL LENSTR_BL(LINE,LN)
      IF(LN.GT.0) THEN
        WRITE(IOUT,'(A)') LINE(1:LN)
      ENDIF

      IF(CR_BTYPE.EQ.'A') THEN

        DO I=1,6
          IANIS(I) = CR_ANIS(I)*10000.0
        ENDDO 

C        WRITE(LINE,410) NA,ATOM,ALT,RES,CHAIN,IRES
C     *                  ,(IANIS(L),L=1,6)
C 410    FORMAT ('ANISOU',I5,1X,A4,A1,A3,A2,I4,2X,6I7)

        WRITE(LINE,410) NA,ATOM,ALT,RES,CHAIN,CH5
     *                  ,(IANIS(L),L=1,6)
 410    FORMAT ('ANISOU',I5,1X,A4,A1,A3,A2,A5,1X,6I7)
        CALL LENSTR_BL(LINE,LN)
        IF(LN.GT.0) THEN
          WRITE(IOUT,'(A)') LINE(1:LN)
        ENDIF
      ENDIF

      GO TO 200
C ------------------------------------------------------
 300  CONTINUE
      WRITE(LINE,500) NA
  500 FORMAT(' NUMBER OF ATOMS   :',I6)
      CALL MSGDOC(MDOC,LINE)
      END FILE IOUT
      CLOSE(IOUT)
C --------------------------------------
      RETURN
      END


      SUBROUTINE PDB_ANAME(ANAME,ASYMB,RNAME,ATOM)
C -----------------------------------------------
      CHARACTER ANAME*4,ASYMB*4,ATOM*4,RNAME*3
C ----------------------------------------------
      PARAMETER (N_NAME = 95)
C -----------------------------------------------
      CHARACTER CH2*2
      CHARACTER NAME(N_NAME)*2
C ----
      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
     *          'HG','AL','GD','NA','CD','NI','SR','IN','HO','YB',
     *          'TE','LI','RB','BA','CS','SM','TL','PT','BE','SE',
     *          'MO','SI','I ','NE','AR','SC','TI','CR','GA','GE',
     *          'AS','KR','HE','ZR','NB','TC','RU','RH','PD','AG',
     *          'SN','SB','XE','LA','HF','TA','RE','OS','IR','AU',
     *          'BI','PO','AT','RN','FR','RA','AC','CE','PR','ND',
     *          'PM','EU','TB','DY','ER','TM','LU','TH','PA','NP',
     *          'PU','AM','CM','BK','CF','ES','FM','MD','NO','LR',
     *          'K ','V ','Y ','U ','W '                          /
C 
C ---------------------------------------------
      ATOM= '    '
      CH2=ASYMB(1:2)
      DO  I=1,N_NAME
        IF(NAME(I).EQ.CH2) THEN
          ATOM=ANAME
          RETURN
        ENDIF
      ENDDO
      IF(ASYMB.EQ.'H   '.OR.ASYMB.EQ.'D   ') THEN
        ATOM(2:4) = ANAME(1:3)
        IF(ANAME(4:4).NE.' ') ATOM(1:1)=ANAME(4:4)
      ELSE
        IF(ANAME(4:4).NE.' ') THEN
          IF(ANAME(1:1).EQ.ASYMB(1:1)) THEN
            ATOM(2:4)=ANAME(1:3)
            ATOM(1:1)=ANAME(4:4)
          ELSE
            ATOM(1:4)=ANAME(1:4)
          ENDIF
        ELSE
          IF(ANAME(1:1).EQ.ASYMB(1:1)) THEN
            IF(ANAME(2:2).EQ.ASYMB(1:1)) THEN
              ATOM(1:3)=ANAME(1:3)
            ELSE
              ATOM(2:4)=ANAME(1:3)
            ENDIF
          ELSE
            ATOM(1:4)=ANAME(1:3)
          ENDIF
        ENDIF
      ENDIF
C --- special cases --

      IF(RNAME.EQ.'HEM'.AND.ANAME.EQ.'NA  ') ATOM=' N A'
      IF(RNAME.EQ.'HEM'.AND.ANAME.EQ.'NB  ') ATOM=' N B'
      IF(RNAME.EQ.'HEM'.AND.ANAME.EQ.'NC  ') ATOM=' N C'
      IF(RNAME.EQ.'HEM'.AND.ANAME.EQ.'ND  ') ATOM=' N D'

      RETURN
      END

C -I-
      SUBROUTINE FROMBL(MDOC,MODE,NAMEI,NAMEO
     *                 ,BOVERALL,BETA_ANISO,ISYM,IPRSYM,IERR)
C 
C -P- FROMBL - writes a contents of internal BLANC file to output CIFile. 
C                                         ( exit one from complex BLANC).
C -S-
C              This program writes contents of files type of "F  ", "FS  ", 
C               "PH  ", "ABCD" into formatted output file ( format CIF). 
C
C   Dialog and Batch:
C  
C    FILE_IN:     -        name of input_file.
C    FILE_OUT:    -        name of output_file /formatted CIFile/.
C
C  Parameters of subroutine FROMBL: 
C
C     SUBROUTINE FROMBL(MDOC,NAMEI,NAMEO,ISYM,IPRSYM,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    NAMEI  - name of input file.
C    NAMEO  - name of output file /formatted CIFile/.
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C
C -I-
C ----------------------------------------------------------------------
      INTEGER   MDOC,IERR
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6),S11(6),BETA_ANISO(6)
      CHARACTER NAMEI*(*),NAMEO*(*),MODE*1
      CHARACTER TITLE*160,ITYP*4,PATH*1,EXT*3,STAT*1
      CHARACTER LINE*80
C ----------------------------------------------------------------------
      NREF  =0
      SUMFA =0.
      SUMF  =0.
      FAV   =0.
      FAVA  =0.
      IF(MODE.EQ.'a') MODE='A'
      
C ---
      IERR=0
      MTIN  =10
      ITYP='    '
      MD=-ABS(MDOC)-1      
      CALL ORFILE(MD,MTIN,NAMEI,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT_FILE')
        IERR=2
        RETURN
      ENDIF
      MD=-ABS(MDOC)-1      
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RESMIN,RESMAX,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)

      IF(ITYP.EQ.'RI  ') THEN
        CALL MSGERR(MDOC,' ERR : input-file is EL.DENS-file ')
        CLOSE(MTIN)
        RETURN
      ENDIF
      IF(ITYP.NE.'PH  '.AND.ITYP.NE.'ABCD'.AND.
     *   ITYP.NE.'FS  '.AND.ITYP.NE.'F   '     ) THEN
        CALL MSGERR(MDOC,' ERR : wrong file_type')
        CLOSE(MTIN)
        RETURN
      ENDIF

      CALL C_RD_CR

      RLATT(1) = A
      RLATT(2) = B
      RLATT(3) = C
      RLATT(4) = AL
      RLATT(5) = BE
      RLATT(6) = GA

      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C ---
      IERR=0
      NUMB=0
      MTOUT=11
      M=99
      PATH=' '
      EXT=' '      
      CALL OPENFW(MTOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN OUTPUT_FILE')
        CLOSE(MTIN)
        RETURN
      ENDIF
C -------------------------------------------------
      M=99
      CALL WR_TITLE(M,MTOUT,ITYP,TITLE,NSYM,ISYM,IPRSYM,IERR)
C ------------------------------------------------
      IEND =-1
      NUMB = 0
      KEY  = 0
C -------------------------------------------------
  400 CONTINUE
      IF(ITYP.EQ.'FS  ') THEN
        CALL RRD1(MTIN,IH,IK,IL,FMOD,FAN,SD1,SD2,KEY,IEND)
      ELSE IF(ITYP.EQ.'ABCD') THEN
        CALL RABCD(MTIN,IH,IK,IL,FMOD,FAN,SD1,SD2,KEY,IEND)
      ELSE
        CALL RD1(MTIN,IH,IK,IL,FMOD,FAN,KEY,IEND)
        SD1=0.0
        SD2=0.0
      ENDIF
      IF(IEND.EQ.1) GO TO 420
      NUMB=NUMB+1

      IF(ITYP.EQ.'PH  ') THEN
        TEMP=(FMOD*FMOD+FAN*FAN)
        FOM=SQRT(TEMP)
        COPH=FMOD/FOM
        SIPH=FAN /FOM
        IF(ABS(COPH).LT.1.E-5) THEN
          PHI=90.
          IF(SIPH.LT.0.) PHI=PHI+180.
        ELSE
          PHI=(ATAN(SIPH/COPH))*57.29578
          IF(PHI.LT.0.) THEN
            IF(SIPH.LE.0.) THEN
              PHI=PHI+360.
            ELSE
              PHI=PHI+180.
            ENDIF
          ELSE IF(PHI.EQ.0.) THEN
            IF(COPH.LT.0.) PHI=PHI+180.
          ELSE
            IF(SIPH.LE.0.) PHI=PHI+180.
          ENDIF
        ENDIF
        SUMF=SUMF+FOM
      ELSE IF(ITYP.EQ.'ABCD') THEN
        CONTINUE
      ELSE

        IF(MODE.EQ.'A') THEN

          CALL DSTAR_BL(IH,IK,IL,RSQ)

          S1     = AST*IH 
          S2     = BST*IK
          S3     = CST*IL

          S11(1) = S1*S1
          S11(2) = S2*S2
          S11(3) = S3*S3
          S11(4) = S1*S2*2.0
          S11(5) = S1*S3*2.0
          S11(6) = S2*S3*2.0

          TEMP = 0.0
          DO I=1,6
            T=BETA_ANISO(I)*S11(I)
            TEMP=TEMP+T
          ENDDO

          T=BOVERALL/4.0
          TEMP=TEMP-(T*RSQ)

          X   = EXP(TEMP)

          FMOD=FMOD*X
          FAN =FAN *X
          SD1 =SD1 *X 
          SD2 =SD2 *X
        ENDIF

        SUMF =SUMF +FMOD
        SUMFA=SUMFA+FAN
      ENDIF
      NREF=NREF+1

      IT1=KEY/2
      IT2=KEY-IT1*2
      IT3=IT1/2
      IT3=IT3-IT1*2
      STAT='o'
      IF(IT2.EQ.1) STAT='f'
      IF(IT3.EQ.1) STAT='r'

      IF(ITYP.EQ.'PH  ') THEN
        WRITE(LINE,'(3I4,1X,F6.3,1X,F8.3)') IH,IK,IL,FOM,PHI
        CALL WRTSTR(MTOUT,M,LINE,IERR)
      ELSE IF(ITYP.EQ.'ABCD') THEN
        WRITE(LINE,'(3I4,4(1X,F12.4))') IH,IK,IL,FMOD,FAN,SD1,SD2
        CALL WRTSTR(MTOUT,M,LINE,IERR)
      ELSE IF(ITYP.EQ.'F   ') THEN
        WRITE(LINE,'(3I4,1X,F10.2,1X,A1)') 
     *  IH,IK,IL,FMOD,STAT
        CALL WRTSTR(MTOUT,M,LINE,IERR)
        IF(FAN.GT.0.0000001) THEN
          JH=-IH
          JK=-IK
          JL=-IL
          WRITE(LINE,'(3I4,1X,F10.2,1X,A1)') JH,JK,JL,FAN,STAT
          CALL WRTSTR(MTOUT,M,LINE,IERR)
        ENDIF
      ELSE
        WRITE(LINE,'(3I4,1X,F10.2,1X,F8.2,1X,A1)') 
     *  IH,IK,IL,FMOD,SD1,STAT
        CALL WRTSTR(MTOUT,M,LINE,IERR)
        IF(FAN.GT.0.0000001) THEN
          JH=-IH
          JK=-IK
          JL=-IL
          WRITE(LINE,'(3I4,1X,F10.2,1X,F8.2,1X,A1)') 
     *    JH,JK,JL,FAN,SD2,STAT
          CALL WRTSTR(MTOUT,M,LINE,IERR)
        ENDIF
      ENDIF

      GO TO 400
C ---------------------------------
  420 IEND1=1
      IF(NREF.GT.0) THEN
        FAV=SUMF/NREF
        FAVA=SUMFA/NREF
      ENDIF
      IF(ITYP.EQ.'PH  ') THEN
        WRITE(LINE,63) NREF,FAV
        CALL MSGDOC(MDOC,LINE)
      ELSE IF(ITYP.EQ.'ABCD') THEN
        WRITE(LINE,62) NREF
        CALL MSGDOC(MDOC,LINE)
      ELSE
        WRITE(LINE,61) NREF,FAV,FAVA
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      CLOSE (MTIN)
      END FILE MTOUT
      CLOSE(MTOUT)
   61 FORMAT(' NUMBER OF REFLS=',I6,
     . ' <FA>  =',E12.4,' <FB> =',E12.4)
   62 FORMAT(' NUMBER OF REFLS=',I6)
   63 FORMAT(' NUMBER OF REFLS=',I6,'   < FOM > =',F7.3)
      RETURN
      END

      SUBROUTINE WR_TITLE(MDOC,IOUT,TYPE,STR,NSYM,ISYM,NSMAX,IERR)
C ----------------------------------------------------------
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER TYPE*4,STR*(*)
C ------------------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
      CHARACTER LINE*80,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C ---
      CHARACTER SYMOP*24,CH10*10,CODE*8,TEMPER*5,WAVE*5,CODE_NDB*8
      CHARACTER TITLE*80
C -------------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.0
      IERR  = 0
C --------------------------------
       ICS_CATEGORY   = '_database_PDB.'
       ICS_CD_PDB     = 'code'
       ICS_NAME_PDB   = 'name'
       ICS_DATE_PDB   = 'date'
       ICS_TITLE      = 'compnd'
       ICS_RESL_PDB   = 'remark_resolution'
       ICS_RFAC_PDB   = 'remark_R_factor'
       ICS_MODEL      = 'model'
C
       ICS_CELL(1)    = '_cell.length_a'
       ICS_CELL(2)    = '_cell.length_b'
       ICS_CELL(3)    = '_cell.length_c'
       ICS_CELL(4)    = '_cell.angle_alpha'
       ICS_CELL(5)    = '_cell.angle_beta'
       ICS_CELL(6)    = '_cell.angle_gamma'
C
       ICS_SPGR       = '_symmetry.space_group_name_H-M'
       ICS_NSPGR      = '_symmetry.Int_Tables_number'
       ICS_SETT       = '_symmetry.cell_setting_number'
       ICS_SYMOP      = '_symmetry_equiv.pos_as_xyz'
C
C --------------------------------
      CALL LENSTR_BL(USER_TITLE,LEN)
      IF(LEN.LT.9) THEN 
        TITLE = '?'
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.69) THEN 
        TITLE = USER_TITLE(9:68)
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.74) THEN 
        TITLE = USER_TITLE(9:68)
        WAVE  = USER_TITLE(69:73)
        TEMPER= '?'
      ELSE
        TITLE = USER_TITLE(9:68)
        WAVE  = USER_TITLE(69:73)
        TEMPER= USER_TITLE(74:78)
      ENDIF

      CALL LENSTR_BL(PDB_NAME,LEN)
      IF(LEN.LE.4) THEN
        CODE         ='XXXX    '
        CODE_NDB     ='?'
      ELSE
        IF(LEN.GT.12) LEN=12   
        CODE=PDB_NAME(5:LEN)
        CODE_NDB     = CODE
      ENDIF

      IF(CODE_NDB(1:4).EQ.PDB_CODE.AND.CODE_NDB(5:8).EQ.'    ')
     *  CODE_NDB='?'

      IF(CODE(1:1).EQ.'?'.OR.CODE(1:1).EQ.' '.OR.CODE(1:1).EQ.'.'.OR.
     *   CODE(1:4).EQ.'XXXX') THEN
        CODE    = PDB_CODE//'    '    
        CODE_NDB= '?'
      ENDIF

      CALL LENSTR_BL(CODE,LENCD)

      WRITE(LINE,'(''data_structure_'',A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        CALL LENSTR_BL(ICS_CATEGORY,LENC)
C ---
      WRITE(LINE,
     *'(''_database_2.database_id'',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(PDB_CODE,LEN)
      WRITE(LINE,
     *'(''_database_2.code_PDB   '',2X,A)') PDB_CODE(1:LEN)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      IF(CODE_NDB(1:1).NE.'?') THEN
        WRITE(LINE,
     *'(''_database_2.code_NDB   '',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      WRITE(LINE,'(''_struct_keywords.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(PDB_NAME,LEN)
      IF(LEN.LE.12) THEN
        PDB_NAME(13:13)='?'
        LEN=13
      ENDIF
      IF(LEN.GT.32) LEN=32
      WRITE(LINE,110) PDB_NAME(13:LEN)
  110 FORMAT(       
     * '_struct_keywords.text  ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_struct.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,200) TITLE(1:LEN)
  200 FORMAT(       '_struct.title   ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_database_PDB_rev.num 1'')') 
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL CHNG_DATE(PDB_DATE,CH10)

      WRITE(LINE,'(''_database_PDB_rev.date_original'',2X,A)') 
     * CH10(1:10)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      CALL CHCLOCK(CHAR20)
c      WRITE(LINE,210) CHAR20
c  210 FORMAT(       '_file_creation_date ',2X,'''',A,'''')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      CALL LENSTR_BL(TEMPER,LEN)
      IF(LEN.GT.0.AND.TEMPER(1:1).NE.'.'.AND.TEMPER(1:1).NE.' '.AND.
     *   TEMPER(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn.entry_id             '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,340) TEMPER(1:LEN)
  340   FORMAT('_diffrn.ambient_temperature    ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(WAVE,LEN)
      IF(LEN.GT.0.AND.WAVE(1:1).NE.'.'.AND.WAVE(1:1).NE.' '.AND.
     *   WAVE(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn_radiation.entry_id  '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,350) WAVE(1:LEN)
  350   FORMAT('_diffrn_radiation.wavelength  ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
        AL_CELL=AL_CELL/PI180
        BE_CELL=BE_CELL/PI180
        GA_CELL=GA_CELL/PI180
        WRITE(LINE,'(''_cell.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_a   '',2X,F8.3)') A_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_b   '',2X,F8.3)') B_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_c   '',2X,F8.3)') C_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_alpha'',2X,F8.3)') AL_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_beta '',2X,F8.3)') BE_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_gamma'',2X,F8.3)') GA_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.formula_units_Z  ?'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        WRITE(LINE,'(''_symmetry.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(SP_GROUP,LEN)
        WRITE(LINE,100)  SP_GROUP(1:LEN)
  100   FORMAT('_symmetry.space_group_name_H-M',2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        WRITE(LINE,400)  NSP_GROUP
c  400   FORMAT('_symmetry.Int_Tables_number   ',2X,I5)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C        WRITE(LINE,500)  N_SETT
C  500   FORMAT('_symmetry.cell_setting_number ',2X,I5)
C        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.pos_as_xyz'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ----------------------------------------
C --- SYM ---
      DO     I=1,NSYM
        LINE=' '
C        LINE(1:3)='SYM'
C        WRITE(CH3,'(I3)') I
C        LINE(4:4)=CH3(3:3)
C        LINE(5:5)=' '
        L=0
        DO J=1,3
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1.0
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I))
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          TR=ABS(TR)
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'
            L=L+2
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3'
            L=L+2
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'
            L=L+2
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF
          DO  K=1,3
            IDG=ISYM(K,J,I)
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO
          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO
        CALL LENSTR_BL(LINE,LEN)
        JL=0
        DO IL=1,LEN
          IF(LINE(IL:IL).NE.' ') THEN
            JL=JL+1
            LINE(JL:JL)=LINE(IL:IL)
          ENDIF
        ENDDO
        LEN=JL
        SYMOP = LINE(1:LEN)
        WRITE(LINE,510)  I,SYMOP(1:LEN)
  510   FORMAT('    ',I3,2X,A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDDO
C -------------------------
      WRITE(LINE,'(''loop_'')')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_h'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_k'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_l'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C -------------------------
      IF(TYPE.EQ.'PH  ') THEN
        LINE='_refln.figure_of_merit'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        LINE='_refln.phase_calc'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ELSE IF(TYPE.EQ.'ABCD') THEN
        LINE='_refln.coef_H_L_a'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        LINE='_refln.coef_H_L_b'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        LINE='_refln.coef_H_L_c'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        LINE='_refln.coef_H_L_d'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ELSE
        LINE='_refln.F_meas_au'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(TYPE.NE.'F   ') THEN
c          LINE='_refln.F_meas_au_sigma'
          LINE='_refln.F_meas_sigma_au'
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
        LINE='_refln.status'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C -----------------------------------------
      RETURN
      END


C -I-
      SUBROUTINE CHECK_CRD(MDOC,FILE_I,ISYM,IPRSYM
     *                 ,STR_TITLE,STR_DATE
     *                 ,FILE_O,NATOM,RESULT,IPRROW,IPRMAX,PDB
     *                 ,NO_SPGR,NO_SETT,CELL,IERR)
C --------------------------------------------------------------
C -P- CHECK_CRD - gets information about file "crd".
C -S-
C
C  Dialog and Batch: 
C
C    FILE_I  - BLANC system input coordinate file without extention "crd".
C
C      SUBROUTINE CHECK_CRD(MDOC,FILE_I,ISYM,IPRSYM
C     * ,STR_TITLE,STR_DATE,FILE_O,NATOM,RESULT,IPRMAX,IPRROW,PDB,IERR)
C
C  Parameters of subroutine CHECK_CRD: 
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    FILE   - name of input file without extention "crd".
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C
C    output information: 
C      REAL      RESULT (IPRMAX,IPRROW)
C
C      PDB   /character*1/ "C" for BLANC_system file "crd"
C                          "N" for NDB file "cif"  
C      RESULT(1,1) - PDB_code
C      RESULT(1,2) - number of atoms
C      RESULT(1,3) - number of water molecules
C      RESULT(1,4) - reported resolution
C      RESULT(1,5) - reported R-FAC
C      RESULT(1,6) - (1,11) - CELL parameters
C
C      RESULT(1,12)   
C      RESULT(1,13)  Space group
C      RESULT(1,14)
C
C      RESULT(1,15) - number of H-atoms
C      RESULT(1,16) - number of chains
C      RESULT(1,17) - NCS , number of NCS  operators.
C      RESULT(1,18) - IGIVEN
C      RESULT(1,19) - NRES_TOT
C
C      Coordinates of atoms. Number of atoms = NATOM ( =< IPRROW-10 )
C                            NATOM = 0 means max possible.
C  
C      RESULT(i+10,1)  IX 
C      RESULT(i+10,2)  IY
C      RESULT(i+10,3)  IZ
C      RESULT(i+10,4)  Dens  (occ)
C      RESULT(i+10,5)  sigma (1.0)
C      RESULT(i+10,6)  Xort
C      RESULT(i+10,7)  Yort
C      RESULT(i+10,8)  Zort
C      RESULT(i+10,9)  Xfrac
C      RESULT(i+10,10) Yfrac
C      RESULT(i+10,11) Zfrac
C      RESULT(1+10,12) number of atoms
C
C -I-
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C ----------------------------------------------------------
      INTEGER   MDOC,IERR,NATOM
      CHARACTER FILE_I*(*),PDB*1,FILE_O*(*)
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT (IPRROW,IPRMAX)
      REAL      CELL(6)
C ----------------------
      CHARACTER   EXT*3,PATH*1,LINE*80,FILE*256
      CHARACTER   STR_TITLE*40,STR_DATE*9
C ---
      CHARACTER NAME*256
C --------------------------------------------------------------
      IERR=0
      M=99
      MD=-ABS(MDOC)-1
C -----------
      DO J=1,IPRMAX
      DO I=1,IPRROW
        RESULT(I,J)=0.0
      ENDDO
      ENDDO
C -----------
      FILE=FILE_I
      CALL LENSTR_BL(FILE,LEN)
      IF(LEN.LT.1.OR.FILE(1:1).EQ.','.OR.FILE(1:1).EQ.' ') THEN
        CALL MSGERR(MD,' ERR: WRONG NAME OF INPUT_FILE')
        IERR=1
        RETURN
      ENDIF
      NAME=FILE(1:LEN)
      DO I=LEN,1,-1
        IF(NAME(I:I).EQ.',') THEN
          NAME(I:I)=' '
        ELSE
          IF(NAME(I:I).NE.' ') GO TO 120
        ENDIF 
      ENDDO
 120  CONTINUE
      FILE = NAME

      CALL LENSTR_BL(FILE,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,'(''input COORD_file:'',A)') FILE(1:LEN)
      CALL MSGDOC(MD,LINE)
C ---------------------------
      IF(LEN.GT.4.AND.FILE(LEN-3:LEN).EQ.'.crd') THEN
        PDB='C'
        NAME=FILE(1:LEN-4)
      ELSE IF(LEN.GT.4.AND.FILE(LEN-3:LEN).EQ.'.cif') THEN
        PDB='N'
        NAME=FILE(1:LEN-4)
      ELSE IF(LEN.GT.4.AND.FILE(LEN-3:LEN).EQ.'.pdb') THEN
        PDB='P'
        NAME=FILE(1:LEN-4)
      ELSE IF(PDB.EQ.'N'.OR.PDB.EQ.'n') THEN
        PDB='N'
        NAME=FILE(1:LEN)
      ELSE IF(PDB.EQ.'P'.OR.PDB.EQ.'p') THEN
        PDB='P'
        NAME=FILE(1:LEN)
      ELSE IF(PDB.EQ.'C'.OR.PDB.EQ.'c') THEN
        PDB='C'
        NAME=FILE(1:LEN)
      ELSE
        PDB='C'
        NAME=FILE(1:LEN)
      ENDIF

      IF(PDB.EQ.'C') THEN
        CALL GET_ICRD(MDOC,NAME,ISYM,IPRSYM
     *  ,STR_TITLE,STR_DATE,FILE_O,NATOM,RESULT,IPRROW,IPRMAX,IERR)
      ELSE IF(PDB.EQ.'N') THEN
        CALL GET_ICRD_NDB(MDOC,NAME,ISYM,IPRSYM
     *  ,STR_TITLE,STR_DATE,FILE_O,NATOM,RESULT,IPRROW,IPRMAX,IERR)
      ELSE
        CALL READPDB_C(MDOC,FILE,ISYM,IPRSYM
     *  ,STR_TITLE,STR_DATE,RESULT,IPRMAX,IPRROW,PDB,FILE_O
     *  ,NO_SPGR,NO_SETT,CELL,IERR)
      ENDIF
C ---
      NSYM=CR_NSYM
      IF(NSYM.LE.0) NSYM=1
      CMATTHEWS=0.0 
      NA =RESULT(1,2)
      NAH=RESULT(1,15)
      NANH=NA-NAH

      IF(NANH.GT.0) THEN
        CMATTHEWS=VOLUME/(NSYM*NANH*14.0)
        SOLVENT     =(1.0-1.0/(CMATTHEWS*0.602*1.34))*100.0
        IF(SOLVENT.GT.100.0) SOLVENT=100.0
        IF(SOLVENT.LT.  0.0) SOLVENT=0.0
        WRITE(LINE,'(''  Matthews coefficient     :'',F8.2)') CMATTHEWS  
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''  corresponding % solvent  :'',F8.2)') SOLVENT   
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      RESULT(1,21)=CMATTHEWS
C ---
      RETURN
      END

      SUBROUTINE GET_ICRD(MDOC,NAME,ISYM,IPRSYM
     *  ,STR_TITLE,STR_DATE,FILE_O,NATOM,RESULT,IPRROW,IPRMAX,IERR)
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAME*(*),PDB*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,IPRMAX)
      CHARACTER STR_TITLE*40,STR_DATE*9,FILE_O*(*)
C ----------------------
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
C ---------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB/   CR_TEMPER   ,CR_WAVEL
     *                 ,CR_RES_MIN  ,CR_RES_MAX 
     *                 ,CR_RFAC_ALL ,CR_RFAC_OBS
     *                 ,CR_SIGMA_I  ,CR_SIGMA_F 
     *                 ,CR_CD_NDB   ,CR_CD_CSD
     *                 ,CR_DATE_NDB ,CR_DATE_CREAT
     *                 ,CR_PROGRAM  ,CR_METHOD
      REAL  CR_TEMPER
      REAL  CR_WAVEL
      REAL  CR_RES_MIN
      REAL  CR_RES_MAX 
      REAL  CR_RFAC_ALL
      REAL  CR_RFAC_OBS
      REAL  CR_SIGMA_I
      REAL  CR_SIGMA_F 
      CHARACTER CR_CD_NDB    *8
      CHARACTER CR_CD_CSD    *8
      CHARACTER CR_DATE_NDB  *10
      CHARACTER CR_DATE_CREAT*20
      CHARACTER CR_PROGRAM   *40
      CHARACTER CR_METHOD    *40
C -----------------------------------------------
C   CR_TEMPER        CR_WAVEL
C   CR_RES_MIN       CR_RES_MAX 
C   CR_RFAC_ALL      CR_RFAC_OBS
C   CR_SIGMA_I       CR_SIGMA_F 
C   CR_CD_NDB        CR_CD_CSD
C   CR_DATE_NDB      CR_DATE_CREAT
C   CR_PROGRAM       CR_METHOD
C ----------------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB_2/   CR_RFAC_CUT  ,CR_NMODEL   ,CR_RMEGR_ALL
     *                   ,CR_RES_RMIN  ,CR_RES_RMAX ,CR_RMEGR_OBS
     *                   ,CR_SIGMAR_I,CR_SIGMAR_F 
     *                   ,CR_RMERG_IOBS
     *                   ,CR_RFREE_ALL ,CR_RFREE_OBS,CR_RFREE_CUT
     *                   ,CR_DPI,CR_ERR_CRD_MIN     ,CR_ERR_CRD_MAX
     *                   ,CR_NDB_TITLE ,CR_NDB_NAME 
     *                   ,CR_INFO_FLAG
      REAL  CR_DPI
      REAL  CR_ERR_CRD_MIN
      REAL  CR_ERR_CRD_MAX
      REAL  CR_RMEGR_ALL
      REAL  CR_RMERG_OBS,CR_RMERG_IOBS
      REAL  CR_RES_RMIN
      REAL  CR_RES_RMAX 
      REAL  CR_SIGMAR_I
      REAL  CR_SIGMAR_F 
      REAL  CR_RFAC_CUT
      REAL  CR_RFREE_OBS
      REAL  CR_RFREE_ALL
      REAL  CR_RFREE_CAT
      INTEGER CR_NMODEL
      CHARACTER CR_NDB_TITLE  *80
      CHARACTER CR_NDB_NAME   *80
      CHARACTER CR_INFO_FLAG  *1
C ------------------------------------------
      COMMON /CRDPDB_3/ CR_NREF_REP
      INTEGER CR_NREF_REP
C -----------------
C    CR_RFAC_CUT  
C    CR_NMODEL
C    CR_RMEGR_ALL
C    CR_RMERG_OBS
C    CR_RMERG_IOBS
C    CR_RES_RMIN  
C    CR_RES_RMAX 
C    CR_RFREE_ALL 
C    CR_FREE_OBS
C    CR_FREE_CUT
C    CR_DPI
C    CR_ERR_CRD_MIN
C    CR_ERR_CRD_MAX
C    CR_NDB_TITLE 
C    CR_NDB_NAME
C    CR_INFO_FLAG
C ----------------------------------------------------------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of atom from the file.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
C -----------------------------------------------------------
c      PARAMETER ( NWORDSMAX = 40 )
c      COMMON /COMFREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
c     *                 ,WORDS,IN_STRING
c      REAL      FWORDS   (NWORDSMAX)
c      INTEGER*4 LEN_WORDS(NWORDSMAX)
c      INTEGER*4 IWORDS   (NWORDSMAX)
c      INTEGER*4 NWORDS,IFRD_ERR
c      CHARACTER WORDS(NWORDSMAX)*80
c      CHARACTER IN_STRING*256
C --------------------------------------------------------------
      REAL        AMNCS(3,3),TRNCS(3)
      INTEGER     MODE
      CHARACTER   NCSF*1,GID*4,NCS_FLAG*1,CHAIN*2,STR*80
      CHARACTER   LINE*80
C ---
      REAL        R4,X(3),Y(3)
      INTEGER*4   IEND
      CHARACTER   REC*6,CH7*7
      CHARACTER   CH1*1,CHAR1*1,CH2*2,CH4*4
      CHARACTER   ANAME*4,RNAME*3,ASYMB*4,CTYPE*4
      EQUIVALENCE (R4,CH4)
C --------------------------------------------------------------
      M=99
      MD=-ABS(MDOC)-1
      PI  = 4.0*ATAN(1.0)
      IN  = 10
C --------
      CALL ORCRD(M,IN,NAME,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN IN_FILE')
        CLOSE(IN)
        RETURN
      ENDIF
C -------------------------
      NCSOP=0
      NCS_FLAG='N'
      CALL GET_NCS(MDOC,NCMAX,NCSOP,AMNCS,TRNCS,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: GET NCS-INFORMATION FROM CRD-FILE')
        RETURN      
      ENDIF
      IF(NCSOP.GT.0) THEN
        IGR=0
        CALL GET_ASYMM(MDOC,NASMAX,NGR,NCH,IGR,ICH,INC,MLT,I_ATM
     *                 ,NCSF,GID,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,' ERR: GET INFORMATION ABOUT ASYMM.PART FROM CRD-FILE')
          RETURN      
        ENDIF
        IF(NGR.GT.0) THEN
          DO IGR=1,NGR
            CALL GET_ASYMM(MDOC,NASMAX,NGR,NCH,IGR,ICH,INC,MLT,I_ATM
     *                    ,NCSF,GID,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MDOC
     *        ,' ERR: GET INFORMATION ABOUT ASYMM.PART FROM CRD-FILE')
              RETURN      
            ENDIF
            IF(NCSF.EQ.'N'.OR.NCSF.EQ.'n') THEN
              NCS_FLAG='Y'
            ENDIF
          ENDDO
        ENDIF
      ENDIF
C --------------------------------------------------
      CALL C_AT_CR
C --------------------------------------------------
      CALL LENSTR_BL(FILE_O,LEN)
      IF(LEN.GT.0.AND.FILE_O(1:1).NE.','.AND.FILE_O(1:1).NE.' ') THEN 
        IOUT=11
        CALL OWCRD(M,IOUT,FILE_O,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: can not open output file')
          CLOSE(IN) 
          RETURN
        ENDIF
      ELSE
        IOUT=0
      ENDIF
C ------------------------------------------------
      CR_NREF_REP=0

      NA      =0
      NBAV    =0
      BAVER=0.0
      NRES_TOT=0
      NAH     =0
      NW      =0
      IEND    =-1
      IENDW   =-1
      MD      =99
      IGR_OLD =-100
      IRES_OLD=-100

      NAMAX=NATOM
      IF(NATOM.LE.0.OR.NATOM.GT.(IPRROW-10)) NAMAX=IPRROW-10
      IF(NATOM.LT.0.OR.NAMAX.LT.0) NAMAX=0
C --------------------------------


 200  CONTINUE
      CALL RDCRD(MD,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        IF(IOUT.GT.0) CLOSE(IOUT)
        RETURN
      ENDIF

      IF(IEND.NE.0) GO TO 300
      IF(MODE.EQ.0) THEN

        IF(CR_ASYMB(1:2).EQ.'H '.OR.CR_ASYMB(1:2).EQ.'D ') THEN
          NAH=NAH+1
        ELSE
          IF(CR_RNAME(1:3).EQ.'HOH'.OR.CR_RNAME(1:3).EQ.'DOD') NW=NW+1
        ENDIF
        NA=NA+1
        IF(CR_OCC.GT.0.0) THEN
          BAVER=BAVER+CR_BISO
          NBAV=NBAV+1
        ENDIF
        IF(NA.LE.NAMAX) THEN 
          IND=NA+10                 
          RESULT(IND,6)=CR_XYZ(1)
          RESULT(IND,7)=CR_XYZ(2)
          RESULT(IND,8)=CR_XYZ(3)

          X(1)=CR_XYZ(1)
          X(2)=CR_XYZ(2)
          X(3)=CR_XYZ(3)
          CALL MVMULT(CR_ORT_TO_FRAC,X,Y)
          RESULT(IND,9 )=Y(1)
          RESULT(IND,10)=Y(2)
          RESULT(IND,11)=Y(3)
          RESULT(IND,4)=CR_OCC
          RESULT(IND,5 )=1.0
          RESULT(11,12) =NA
        ENDIF

        NGR=CR_IGROUP
        IF(IGR_OLD.NE.CR_IGROUP.OR.IRES_OLD.NE.CR_IRES) 
     *  NRES_TOT=NRES_TOT+1
        IGR_OLD =CR_IGROUP
        IRES_OLD=CR_IRES

        IF(IOUT.GT.0) THEN
          CALL WRCRD(MD,IOUT,MODE,IENDW,IERR)
          IF(IERR.NE.0) THEN
            CLOSE(IN) 
            RETURN
          ENDIF
        ENDIF

      ENDIF      

      GO TO 200
C ------------------------------------------------------
 300  CONTINUE
      NAHOH=NW
      NHATOM=NAH
      NCHAIN=NGR
      IF(NCS_FLAG.EQ.'Y') THEN
        CP_IGIVEN=0
      ELSE
        CP_IGIVEN=1
      ENDIF
      CLOSE(IN)
      IF(NBAV.GT.0) BAVER=BAVER/NBAV
      IF(IOUT.GT.0) THEN
        END FILE IOUT
        CLOSE(IOUT) 
      ENDIF
C --------------------------------------------------
      WRITE(LINE,'('' PDB_code : '',A4)') CR_CD_PDB
      CALL MSGDOC(MDOC,LINE)

      IF(CR_INFO_FLAG.EQ.'N') THEN
        WRITE(LINE,'('' NDB_code : '',A)') CR_CD_NDB
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      CH4=CR_CD_PDB
      RESULT(1,1)=R4

      CH4=CR_CD_NDB(1:4)
      RESULT(2,1)=R4
      CH4=CR_CD_NDB(5:8)
      RESULT(2,2)=R4

      RESULT(1,2)=NA
      RESULT(1,3)=NAHOH
      RESULT(1,6)=CR_CELL(1)
      RESULT(1,7)=CR_CELL(2)
      RESULT(1,8)=CR_CELL(3)
      CR_CELL(4)=(CR_CELL(4)*180.0)/PI
      CR_CELL(5)=(CR_CELL(5)*180.0)/PI
      CR_CELL(6)=(CR_CELL(6)*180.0)/PI
      RESULT(1,9)  =CR_CELL(4)
      RESULT(1,10) =CR_CELL(5)
      RESULT(1,11) =CR_CELL(6)
      IF(IPRROW.GE.20) THEN
        CH4=CR_SPGR(1:4)
        RESULT(1,12)=R4
        CH4=CR_SPGR(5:8)
        RESULT(1,13)=R4
        CH4=CR_SPGR(9:11)//' '
        RESULT(1,14)=R4
        RESULT(1,15)=NHATOM
        RESULT(1,16)=NCHAIN
        RESULT(1,17)=NCSOP
        RESULT(1,18)=CP_IGIVEN
        RESULT(1,19)=NRES_TOT
        RESULT(1,20)=BAVER
      ENDIF
      WRITE(LINE,'('' Cell: '',3F9.2,3F7.2)') 
     *  RESULT(1,6),RESULT(1,7),RESULT(1,8),RESULT(1,9)
     * ,RESULT(1,10),RESULT(1,11) 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Space group : '',A)') CR_SPGR 
      CALL MSGDOC(MDOC,LINE)
      IF(CR_RESL_PDB(1:1).NE.'.') THEN
        IF(CR_RESL_PDB(21:24).EQ.'ANGS') THEN
          READ(CR_RESL_PDB(13:19),'(F7.2)') RESULT(1,4)
          WRITE(LINE,'('' Resolution: '',A7)') CR_RESL_PDB(13:19) 
        ELSE
          READ(CR_RESL_PDB(13:16),'(F4.2)') RESULT(1,4)
          WRITE(LINE,'('' Resolution: '',A4)') CR_RESL_PDB(13:16) 
        ENDIF
        CALL MSGDOC(MDOC,LINE)
      ELSE
        RESULT(1,4)=0.0
      ENDIF
      IF(CR_RFAC_PDB(1:1).NE.'.') THEN
        READ(CR_RFAC_PDB(30:34),'(F4.2)') RESULT(1,5)
        WRITE(LINE,'('' R_factor  : '',A4)') CR_RFAC_PDB(30:34) 
        CALL MSGDOC(MDOC,LINE)
      ELSE
        RESULT(1,5)=0.0
      ENDIF
      WRITE(LINE,500) NA,NAHOH
  500 FORMAT(' Number of atoms:',I6,' ( ',I6,' water molecules)')
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,520) NCHAIN
  520 FORMAT(' Number of chains:',I6)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,521) NRES_TOT
  521 FORMAT(' Number of residues:',I6)
      CALL MSGDOC(MDOC,LINE)
      IF(NHATOM.GT.0) THEN
        WRITE(LINE,510) NHATOM
  510   FORMAT(' Number of H-atoms:',I6)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(NCSOP.GT.0) THEN
        WRITE(LINE,530) NCSOP
  530   FORMAT(' Number of NCS-operators:',I6)
        CALL MSGDOC(MDOC,LINE)

        IF(CP_IGIVEN.EQ.0) THEN
          CALL MSGDOC(MDOC,
     * '   use NCS-operators for to restore asymm. part of unit cell')
        ELSE
          CALL MSGDOC(MDOC,
     * '   file contents asymm. part of unit cell')
          CALL MSGDOC(MDOC,
     * '   NC-symmetry only for information')
        ENDIF

      ENDIF
      IF(NA.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: Number of atoms = 0')
        IERR=1
      ENDIF
      STR_DATE =CR_DATE_PDB
      STR_TITLE=CR_TITLE(9:80)

        CR_NDB_TITLE=STR_TITLE
        CALL LENSTR_BL(CR_NDB_TITLE,LEN)
        IF(LEN.GT.76) LEN=76
        L=LEN
        IF(L.GT.0) THEN
          L=(L/4)*4+4
          IF(L.GT.76) L=76
          IF(L.GT.LEN) THEN
            DO I=LEN+1,L
              CR_NDB_TITLE(I:I)=' '
            ENDDO           
          ENDIF
          ILEN=L/4
          DO I=1,20
            CH4='    '
            RESULT(4,I)=R4
          ENDDO
          DO I=1,ILEN
            IS=(I-1)*4+1
            IF=IS+4
            CH4=CR_NDB_TITLE(IS:IF)
            RESULT(4,I)=R4
          ENDDO
        ENDIF

        CR_DATE_NDB=STR_DATE
        IF(CR_DATE_NDB(1:1).NE.'?'.AND.CR_DATE_NDB(1:1).NE.'.') THEN
          CH4=CR_DATE_NDB(1:4)
          RESULT(2,3)=R4
          CH4=CR_DATE_NDB(5:8)
          RESULT(2,4)=R4
          CH4(1:1)=CR_DATE_NDB(9:9)
          CH4(2:4)='   '
          RESULT(2,5)=R4
        ENDIF

      IF(CR_PROGRAM(1:1).NE.'?'.AND.CR_PROGRAM(1:1).NE.'.') THEN
        CALL LENSTR_BL(CR_PROGRAM,LEN)
        IF(LEN.GT.16) LEN=16
        IF(LEN.LE. 0) THEN
          CR_PROGRAM(1:1)='?'
          LEN=1
        ENDIF
        IF(LEN.LT.16) THEN
          DO I=LEN+1,16
            CR_PROGRAM(I:I)=' '
          ENDDO
        ENDIF
        CH4=CR_PROGRAM(1:4)
        RESULT(3,1)=R4
        CH4=CR_PROGRAM(5:8)
        RESULT(3,2)=R4
        CH4=CR_PROGRAM(9:12)
        RESULT(3,3)=R4
        CH4=CR_PROGRAM(13:16)
        RESULT(3,4)=R4
        WRITE(LINE,'('' Refinement program : '',A)')CR_PROGRAM(1:LEN) 
        CALL MSGDOC(MDOC,LINE)
      ELSE
        CH4='?   '
        RESULT(3,1)=R4
      ENDIF
      RESULT(3,14)=CR_NREF_REP
      RETURN
      END

      SUBROUTINE GET_ICRD_NDB(MDOC,NAME,ISYM,IPRSYM
     *  ,STR_TITLE,STR_DATE,FILE_O,NATOM,RESULT,IPRROW,IPRMAX,IERR)
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAME*(*),PDB*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,IPRMAX)
      CHARACTER STR_TITLE*40,STR_DATE*9,FILE_O*(*)
C ----------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
C ---------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB/   CR_TEMPER   ,CR_WAVEL
     *                 ,CR_RES_MIN  ,CR_RES_MAX 
     *                 ,CR_RFAC_ALL ,CR_RFAC_OBS
     *                 ,CR_SIGMA_I  ,CR_SIGMA_F 
     *                 ,CR_CD_NDB   ,CR_CD_CSD
     *                 ,CR_DATE_NDB ,CR_DATE_CREAT
     *                 ,CR_PROGRAM  ,CR_METHOD
      REAL  CR_TEMPER
      REAL  CR_WAVEL
      REAL  CR_RES_MIN
      REAL  CR_RES_MAX 
      REAL  CR_RFAC_ALL
      REAL  CR_RFAC_OBS
      REAL  CR_SIGMA_I
      REAL  CR_SIGMA_F 
      CHARACTER CR_CD_NDB    *8
      CHARACTER CR_CD_CSD    *8
      CHARACTER CR_DATE_NDB  *10
      CHARACTER CR_DATE_CREAT*20
      CHARACTER CR_PROGRAM   *40
      CHARACTER CR_METHOD    *40
C -----------------------------------------------
C   CR_TEMPER        CR_WAVEL
C   CR_RES_MIN       CR_RES_MAX 
C   CR_RFAC_ALL      CR_RFAC_OBS
C   CR_SIGMA_I       CR_SIGMA_F 
C   CR_CD_NDB        CR_CD_CSD
C   CR_DATE_NDB      CR_DATE_CREAT
C   CR_PROGRAM       CR_METHOD
C ----------------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB_2/   CR_RFAC_CUT  ,CR_NMODEL   ,CR_RMEGR_ALL
     *                   ,CR_RES_RMIN  ,CR_RES_RMAX ,CR_RMEGR_OBS
     *                   ,CR_SIGMAR_I,CR_SIGMAR_F 
     *                   ,CR_RMERG_IOBS
     *                   ,CR_RFREE_ALL ,CR_RFREE_OBS,CR_RFREE_CUT
     *                   ,CR_DPI,CR_ERR_CRD_MIN     ,CR_ERR_CRD_MAX
     *                   ,CR_NDB_TITLE ,CR_NDB_NAME 
     *                   ,CR_INFO_FLAG
      REAL  CR_DPI
      REAL  CR_ERR_CRD_MIN
      REAL  CR_ERR_CRD_MAX
      REAL  CR_RMEGR_ALL
      REAL  CR_RMERG_OBS,CR_RMERG_IOBS
      REAL  CR_RES_RMIN
      REAL  CR_RES_RMAX 
      REAL  CR_SIGMAR_I
      REAL  CR_SIGMAR_F 
      REAL  CR_RFAC_CUT
      REAL  CR_RFREE_OBS
      REAL  CR_RFREE_ALL
      REAL  CR_RFREE_CAT
      INTEGER CR_NMODEL
      CHARACTER CR_NDB_TITLE  *80
      CHARACTER CR_NDB_NAME   *80
      CHARACTER CR_INFO_FLAG  *1
C ------------------------------------------
      COMMON /CRDPDB_3/ CR_NREF_REP
      INTEGER CR_NREF_REP
C -----------------
C    CR_RFAC_CUT  
C    CR_NMODEL
C    CR_RMEGR_ALL
C    CR_RMERG_OBS
C    CR_RMERG_IOBS
C    CR_RES_RMIN  
C    CR_RES_RMAX 
C    CR_RFREE_ALL 
C    CR_FREE_OBS
C    CR_FREE_CUT
C    CR_DPI
C    CR_ERR_CRD_MIN
C    CR_ERR_CRD_MAX
C    CR_NDB_TITLE 
C    CR_NDB_NAME
C    CR_INFO_FLAG
C ----------------------------------------------------------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of atom from the file.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
      COMMON/COM_STOR_NDB/ FLAG_SC_NDB
      CHARACTER            FLAG_SC_NDB*1
C --------------------------------------------------------------
      REAL        AMNCS(3,3),TRNCS(3)
      INTEGER     MODE
      CHARACTER   NCSF*1,GID*4,NCS_FLAG*1,CHAIN*2,STR*80
      CHARACTER   LINE*80
C ---
      REAL        R4,X(3),Y(3)
      INTEGER*4   IEND
      CHARACTER   REC*6,CH7*7,CP_PNUM_OLD*7,CP_PNUM*7,PNUM*7
      CHARACTER   CH1*1,CHAR1*1,CH2*2,CH4*4
      CHARACTER   ANAME*4,RNAME*3,ASYMB*4,CTYPE*4
      EQUIVALENCE (R4,CH4)
      REAL        CP_NSCALE(3,3),CP_NV(3)
C --------------------------------------------------------------
      M=99
      MD=-ABS(MDOC)-1
      PI  = 4.0*ATAN(1.0)

      IPASS=0
      NCS  =0
      NCSF='N'
      CALL SET_NCS(MDOC,NCMAX,NCS,CP_NSCALE,CP_NV,IERR)
      IF(IERR.NE.0) RETURN
      IGR  =0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
      NCHAIN  =0
      ICP_NAN  =0
C --------------------------------------------------------------
 400  CONTINUE
      IPASS=IPASS+1
C ---
      IF(IPASS.EQ.1) THEN
        IN  = 10

        CALL ORCRD_NDB(M,IN,NAME,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN IN_FILE')
          CLOSE(IN)
          RETURN
        ENDIF

        CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *           ,CR_FRAC_TO_ORT,CR_ORT_TO_FRAC,IERR)

        IF(FLAG_SC_NDB.EQ.'Y') THEN

        ELSE

          DO I=1,3
            DO J=1,3
              CR_SCALE(I,J)=CR_ORT_TO_FRAC(I,J)
            ENDDO
          ENDDO

        ENDIF

        CALL C_AT_CR

      ELSE
        CALL OPEN_NDB(M,IN,NAME,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN IN_FILE/ PASS 2/')
          CLOSE(IN)
          RETURN
        ENDIF
      ENDIF
C ---
      IR         =0
      CH7        ='???????'
      CP_PNUM_OLD='???????'
      CH1        ='N'
      CH2        ='??'
      NA         =0
      NBAV       =0
      BAVER=0.0
      NRES_TOT   =0
      NHATOM     =0
      NAHOH      =0
      ICP_ICH    =0

C --------------------------------------------------
      IF(IPASS.EQ.2) THEN
        CALL LENSTR_BL(FILE_O,LEN)
        IF(LEN.GT.0.AND.FILE_O(1:1).NE.','.AND.FILE_O(1:1).NE.' ') THEN 
          IOUT=11
          CALL OWCRD(M,IOUT,FILE_O,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERROR: can not open output file')
            CLOSE(IN) 
            RETURN
          ENDIF
        ELSE
          IOUT=0
        ENDIF
      ENDIF
C ------------------------------------------------
      NA       = 0
      BAVER=0.0
      NBAV=0
      NRES_TOT = 0
      NAH      = 0
      NW       = 0
      IEND     =-1
      IENDW    =-1
      MD       =99
      IGR_OLD  =-100
      IRES_OLD =-100
      IF(IPASS.EQ.1) THEN
        ICP_NCS  = 0
        ICP_IGIVEN=1
      ENDIF
C --------------------------------


 200  CONTINUE
      CALL RDCRD_NDB(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        IF(IOUT.GT.0) CLOSE(IOUT)
        RETURN
      ENDIF

      IF(IEND.NE.0) GO TO 300
      IF(MODE.EQ.0) THEN

        CP_PNUM=' '
        WRITE(CP_PNUM(3:6),'(I4)') CR_IRES
        CP_PNUM(1:2)=CR_CHAIN(1:2)
        PNUM=CP_PNUM

        IF(CP_PNUM.NE.CH7) THEN
         IF(CP_PNUM(1:2).NE.CH2) THEN
            IF(ICP_ICH.LT.NMAX) ICP_ICH=ICP_ICH+1
            IT=ICP_ICH/10
            IT=IT-ICP_ICH*10
            WRITE(PNUM(2:2),'(I1)') IT
            CH2=CP_PNUM(1:2)

            IF(IPASS.EQ.1) THEN
              IF(NCHAIN.LE.NMAX) THEN
                NCHAIN   = NCHAIN+1
                IGR      = NCHAIN
                ICH      = IGR
                IGOLD    = IGR
                ICHOLD   = IGR
                INC      = 0
                MLT      = 0
                IATM     = 0
                NCSF     = 'Y'
                GID      = '    '
                GID(1:2) = CH2
                CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
                IF(IERR.NE.0) THEN
                  CLOSE(IN)
                  IF(IOUT.GT.0.AND.IPASS.EQ.2) CLOSE(IOUT)
                  RETURN
                ENDIF
              ENDIF
            ENDIF

          ENDIF
          READ(CP_PNUM(3:6),'(I4)') IR
          NRES_TOT = NRES_TOT+1

        ENDIF

c        IF(CR_INFO_FLAG.EQ.'N') THEN
          ANAME    = CR_ANAME
          RNAME    = CR_RNAME
          CALL CORR_NAME_NDB(ANAME,RNAME,ASYMB,CTYPE)
          IF(CR_ASYMB(1:1).EQ.'.'.OR.CR_ASYMB(1:1).EQ.'?'.OR.
     *                               CR_ASYMB(1:1).EQ.' ') THEN
            CR_ASYMB = ASYMB
          ENDIF
          CR_ANAME = ANAME
          CR_RNAME = RNAME
c        ENDIF

        IF(CR_ASYMB(1:2).EQ.'H '.OR.CR_ASYMB(1:2).EQ.'D ') THEN
          NAH=NAH+1
        ELSE
          IF(CR_RNAME(1:3).EQ.'HOH'.OR.CR_RNAME(1:3).EQ.'DOD') NW=NW+1
        ENDIF

        NA=NA+1

        IF(CR_OCC.GT.0.0) THEN
          BAVER = BAVER+CR_BISO
          NBAV  = NBAV+1
        ENDIF


C        NGR=CR_IGROUP
C        IF(IGR_OLD.NE.CR_IGROUP.OR.IRES_OLD.NE.CR_IRES) 
C     *  NRES_TOT=NRES_TOT+1
C        IGR_OLD =CR_IGROUP
C        IRES_OLD=CR_IRES

        CR_PNUM   = PNUM
        CR_IATOM  = NA
C        CR_IRES   = CP_IRES
        CR_IATOLD = NA
        CR_IGROUP = ICP_ICH
        WRITE(CH4,'(I4)') ICP_ICH
        CR_CHAIN  = PNUM(1:2)
        CR_GROUP  = CR_CHAIN//'  '
        CR_ATYPE  = '.'


        IF(IOUT.GT.0.AND.IPASS.EQ.2) THEN
          CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
          IF(IERR.NE.0) THEN
            CLOSE(IN) 
            RETURN
          ENDIF
        ENDIF

        CH7         = CP_PNUM
        CP_PNUM_OLD = CP_PNUM

      ENDIF      

      GO TO 200



C ------------------------------------------------------
 300  CONTINUE

      IF(IPASS.EQ.1) THEN
        NCS=0
        CALL GET_NCS(MDOC,NCMAX,NCS,CP_NSCALE,CP_NV,IERR)
        IF(IERR.NE.0) RETURN
        IGR=0
        CALL GET_ASYMM(MDOC,NMAX,NGRT,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
        IF(IERR.NE.0) RETURN
        IF(NCS.GT.0.AND.ICP_IGIVEN.EQ.0) THEN
          JGR=NGRT
          DO I=1,NGRT
            IGR=I
            CALL GET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) RETURN
            DO J=1,NCS
              INC    = J
              NCSF   = 'N'               
              JGR    = JGR+1
              ICHOLD = ICH
              IGOLD  = JGR
              CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,JGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) RETURN
            ENDDO
          ENDDO
        ENDIF
      ENDIF
C ----
      IF(IPASS.EQ.1) GO TO 400
      IF(IOUT.GT.0) THEN
        END FILE IOUT
        CLOSE(IOUT) 
      ENDIF
C -----------------------
      NAHOH  = NW
      NHATOM = NAH
      NCHAIN = NGR
      IF(NCSF.EQ.'Y') THEN
        ICP_IGIVEN=0
      ELSE
        ICP_IGIVEN=1
      ENDIF
      CLOSE(IN)
      IF(NBAV.GT.0) BAVER=BAVER/NBAV
C --------------------------------------------------
      WRITE(LINE,'('' PDB_code : '',A4)') CR_CD_PDB
      CALL MSGDOC(MDOC,LINE)

      IF(CR_INFO_FLAG.EQ.'N') THEN

        WRITE(LINE,'('' NDB_code : '',A)') CR_CD_NDB
        CALL MSGDOC(MDOC,LINE)


      ENDIF
      CH4          = CR_CD_PDB
      RESULT(1,1)  = R4
      RESULT(1,2)  = NA
      RESULT(1,3)  = NAHOH
      RESULT(1,6)  = A_CELL
      RESULT(1,7)  = B_CELL
      RESULT(1,8)  = C_CELL
      RESULT(1, 9) = (AL_CELL*180.0)/PI
      RESULT(1,10) = (BE_CELL*180.0)/PI
      RESULT(1,11) = (GA_CELL*180.0)/PI
      IF(IPRROW.GE.20) THEN
        CH4=CR_SPGR(1:4)
        RESULT(1,12)=R4
        CH4=CR_SPGR(5:8)
        RESULT(1,13)=R4
        CH4=CR_SPGR(9:11)//' '
        RESULT(1,14)=R4
        RESULT(1,15)=NHATOM
        RESULT(1,16)=NCHAIN
        RESULT(1,17)=NCS
        RESULT(1,18)=ICP_IGIVEN
        RESULT(1,19)=NRES_TOT
        RESULT(1,20)=BAVER
      ENDIF
      WRITE(LINE,'('' Cell: '',3F9.2,3F7.2)') 
     *  RESULT(1,6),RESULT(1,7),RESULT(1,8),RESULT(1,9)
     * ,RESULT(1,10),RESULT(1,11) 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Space group : '',A)') CR_SPGR 
      CALL MSGDOC(MDOC,LINE)
      IF(CR_RESL_PDB(1:1).NE.'.') THEN
        IF(CR_RESL_PDB(21:24).EQ.'ANGS') THEN
          READ(CR_RESL_PDB(13:19),'(F7.2)') RESULT(1,4)
          WRITE(LINE,'('' Resolution: '',A7)') CR_RESL_PDB(13:19) 
        ELSE
          READ(CR_RESL_PDB(13:16),'(F4.2)') RESULT(1,4)
          WRITE(LINE,'('' Resolution: '',A4)') CR_RESL_PDB(13:16) 
        ENDIF
        CALL MSGDOC(MDOC,LINE)
      ELSE
        RESULT(1,4)=0.0
      ENDIF
      IF(CR_RFAC_PDB(1:1).NE.'.') THEN
        READ(CR_RFAC_PDB(30:34),'(F4.2)') RESULT(1,5)
        WRITE(LINE,'('' R_factor  : '',A4)') CR_RFAC_PDB(30:34) 
        CALL MSGDOC(MDOC,LINE)
      ELSE
        RESULT(1,5)=0.0
      ENDIF
      WRITE(LINE,500) NA,NAHOH
  500 FORMAT(' Number of atoms:',I6,' ( ',I6,' water molecules)')
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,520) NCHAIN
  520 FORMAT(' Number of chains:',I6)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,521) NRES_TOT
  521 FORMAT(' Number of residues:',I6)
      CALL MSGDOC(MDOC,LINE)
      IF(NHATOM.GT.0) THEN
        WRITE(LINE,510) NHATOM
  510   FORMAT(' Number of H-atoms:',I6)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(NCS.GT.0) THEN
        WRITE(LINE,530) NCS
  530   FORMAT(' Number of NCS-operators:',I6)
        CALL MSGDOC(MDOC,LINE)

        IF(ICP_IGIVEN.EQ.0) THEN
          CALL MSGDOC(MDOC,
     * '   use NCS-operators for to restore asymm. part of unit cell')
        ELSE
          CALL MSGDOC(MDOC,
     * '   file contents asymm. part of unit cell')
          CALL MSGDOC(MDOC,
     * '   NC-symmetry only for information')
        ENDIF

      ENDIF
      IF(NA.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: Number of atoms = 0')
        IERR=1
      ENDIF

      STR_DATE =CR_DATE_PDB
      STR_TITLE=CR_TITLE(9:80)

      IF(CR_INFO_FLAG.EQ.'N') THEN

        IF(CR_NDB_NAME(1:1).NE.'?'.AND.CR_NDB_NAME(1:1).NE.'.') THEN
          CALL LENSTR_BL(CR_NDB_NAME,LEN)
          IF(LEN.GT.40) LEN=40
          IF(LEN.GT.0) THEN
            STR_TITLE=CR_NDB_NAME(1:40)
            WRITE(LINE,'('' NDB_name: '',A)') CR_NDB_NAME(1:LEN) 
            CALL MSGDOC(MDOC,LINE)
          ELSE
            STR_TITLE='.'
          ENDIF
        ENDIF

        IF(CR_NDB_TITLE(1:1).NE.'?'.AND.CR_NDB_TITLE(1:1).NE.'.')THEN
          CALL LENSTR_BL(CR_NDB_TITLE,LEN)
          IF(LEN.GT.76) LEN=76
          L=LEN
          IF(L.GT.0) THEN
            L=(L/4)*4+4
            IF(L.GT.76) L=76
            IF(L.GT.LEN) THEN
              DO I=LEN+1,L
                CR_NDB_TITLE(I:I)=' '
              ENDDO           
            ENDIF
            ILEN=L/4
            DO I=1,20
              CH4='    '
              RESULT(4,I)=R4
            ENDDO
            DO I=1,ILEN
              IS=(I-1)*4+1
              IF=IS+4
              CH4=CR_NDB_TITLE(IS:IF)
              RESULT(4,I)=R4
            ENDDO
   
            CALL MSGDOC(MDOC,' NDB_title: ')
            WRITE(LINE,'(A)') CR_NDB_TITLE(1:LEN)
            CALL MSGDOC(MDOC,LINE)

          ENDIF
        ENDIF
 
      ENDIF

      CH4(1:1) = CR_INFO_FLAG
      CH4(2:4) = '   '
      RESULT(4,20)=R4
      WRITE(LINE,'('' info_code: '',A)') CR_INFO_FLAG
      CALL MSGDOC(MDOC,LINE)

C -----------------------------
C
C      RESULT(2,1)  - NDB_code(8)
C      RESULT(2,2)  - 
C      RESULT(2,3)  - CR_DATE_NDB(10)
C      RESULT(2,4)  - 
C      RESULT(2,5)  - 
C      RESULT(2,6)  - CR_RES_MIN
C      RESULT(2,7)  - CR_RES_MAX   
C      RESULT(2,8)  - CR_SIGMA_I
C      RESULT(2,9)  - CR_SIGMA_F
C      RESULT(2,10) - CR_TEMPER
C      RESULT(2,11) - CR_WAVEL
C      RESULT(2,12) - CR_RFAC_ALL
C      RESULT(2,13) - CR_RFAC_OBS 
C      RESULT(2,17) - 
C      RESULT(2,18) - 
C      RESULT(2,19) -
C
C      RESULT(3,1) - CR_PROGRAM
C      RESULT(3,2) 
C      RESULT(3,3)
C      RESULT(3,4)  
C      RESULT(3,5) - CR_RES_RMIN
C      RESULT(3,6) - CR_RES_RMAX
C      RESULT(3,7) - CR_RFAC_CUT
C      RESULT(3,8) - CR_RFREE_ALL  
C      RESULT(3,9) - CR_RFREE_OBS
C      RESULT(3,10)- CR_RFREE_CUT
C
C
C      RESULT(4,1-19)= NDB_TITLE(1:19)
C
C      RESULT(4,20) = info_flag 'N' - NDB, 'C' - BLANC , 'P' -PDB
C
C -----------------------------
      CH4=CR_CD_NDB(1:4)
      RESULT(2,1)=R4
      CH4=CR_CD_NDB(5:8)
      RESULT(2,2)=R4
C -------------------------------
      IF(CR_DATE_NDB(1:1).NE.'?'.AND.CR_DATE_NDB(1:1).NE.'.') THEN
        CH4=CR_DATE_NDB(1:4)
        RESULT(2,3)=R4
        CH4=CR_DATE_NDB(5:8)
        RESULT(2,4)=R4
        CH4(1:2)=CR_DATE_NDB(9:10)
        CH4(3:4)='  '
        RESULT(2,5)=R4
        WRITE(LINE,'('' Date_NDB: '',A)') CR_DATE_NDB 
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_RES_MIN.GT.0.0.OR.CR_RES_MAX.GT.0.0) THEN
        RESULT(2,6) = CR_RES_MIN
        RESULT(2,7) = CR_RES_MAX   
        WRITE(LINE,'('' Resolution of data: '',2F8.3)') 
     *   CR_RES_MIN,CR_RES_MAX
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_SIGMA_I.GT.0.0) THEN
        RESULT(2,8) = CR_SIGMA_I
        WRITE(LINE,'('' Sigma cut_off (I): '',F8.3)') 
     *  CR_SIGMA_I
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_SIGMA_F.GT.0.0) THEN
        RESULT(2,9) = CR_SIGMA_F
        WRITE(LINE,'('' Sigma cut_off (F): '',F8.3)') 
     *  CR_SIGMA_F
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_TEMPER.GT.0.0) THEN
        RESULT(2,10) = CR_TEMPER
        WRITE(LINE,'('' Temperature: '',F8.3)') 
     *  CR_TEMPER
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_WAVEL.GT.0.0) THEN
        RESULT(2,11) = CR_WAVEL
        WRITE(LINE,'('' Radiation wavelength: '',F8.3)') 
     *  CR_WAVEL
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_RFAC_ALL.GT.0.0) THEN
        RESULT(2,12) = CR_RFAC_ALL
        WRITE(LINE,'('' R-factor_all: '',F8.3)') 
     *  CR_RFAC_ALL
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_RFAC_OBS.GT.0.0) THEN
        RESULT(2,13) = CR_RFAC_OBS
        WRITE(LINE,'('' R-factor_obs: '',F8.3)') 
     *  CR_RFAC_OBS
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C ----------------------
C      RESULT(3,1) - CR_PROGRAM
C      RESULT(3,2) 
C      RESULT(3,3)
C      RESULT(3,4)  
C      RESULT(3,5) - CR_RES_RMIN
C      RESULT(3,6) - CR_RES_RMAX
C      RESULT(3,7) - CR_RFAC_CUT
C      RESULT(3,8) - CR_RFREE_ALL  
C      RESULT(3,9) - CR_RFREE_OBS
C      RESULT(3,10)- CR_RFREE_CUT
C      RESULT(3,11) = CR_SIGMAR_I
C      RESULT(3,12) = CR_SIGMAR_F
C
      IF(CR_PROGRAM(1:1).NE.'?'.AND.CR_PROGRAM(1:1).NE.'.') THEN
        CALL LENSTR_BL(CR_PROGRAM,LEN)
        IF(LEN.GT.16) LEN=16
        IF(LEN.LE. 0) THEN
          CR_PROGRAM(1:1)='?'
          LEN=1
        ENDIF
        IF(LEN.LT.16) THEN
          DO I=LEN+1,16
            CR_PROGRAM(I:I)=' '
          ENDDO
        ENDIF
        CH4=CR_PROGRAM(1:4)
        RESULT(3,1)=R4
        CH4=CR_PROGRAM(5:8)
        RESULT(3,2)=R4
        CH4=CR_PROGRAM(9:12)
        RESULT(3,3)=R4
        CH4=CR_PROGRAM(13:16)
        RESULT(3,4)=R4
        WRITE(LINE,'('' Refinement program : '',A)')CR_PROGRAM(1:LEN) 
        CALL MSGDOC(MDOC,LINE)
      ELSE
        CH4='?   '
        RESULT(3,1)=R4
      ENDIF
      IF(CR_RES_RMIN.GT.0.0.OR.CR_RES_RMAX.GT.0.0) THEN
        RESULT(3,5) = CR_RES_RMIN
        RESULT(3,6) = CR_RES_RMAX   
        WRITE(LINE,'('' Resolution for refinement: '',2F8.3)') 
     *   CR_RES_RMIN,CR_RES_RMAX
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(CR_RFAC_CUT.GT.0.0) THEN
        RESULT(3,7) = CR_RFAC_CUT
        WRITE(LINE,'('' R-factor_cut: '',F8.3)') 
     *  CR_RFAC_CUT
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(CR_RFREE_ALL.GT.0.0) THEN
        RESULT(3,8) = CR_RFREE_ALL
        WRITE(LINE,'('' Rfree_all: '',F8.3)') 
     *  CR_RFREE_ALL
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(CR_RFREE_OBS.GT.0.0) THEN
        RESULT(3,9) = CR_RFREE_OBS
        WRITE(LINE,'('' Rfree_obs: '',F8.3)') 
     *  CR_RFREE_OBS
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(CR_RFREE_CUT.GT.0.0) THEN
        RESULT(3,10) = CR_RFREE_CUT
        WRITE(LINE,'('' Rfree_cut: '',F8.3)') 
     *  CR_RFREE_CUT
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_SIGMAR_I.GT.0.0) THEN
        RESULT(3,11) = CR_SIGMAR_I
        WRITE(LINE,'('' Sigma cut_off(I) for refinement: '',F8.3)') 
     *  CR_SIGMAR_I
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_SIGMAR_F.GT.0.0) THEN
        RESULT(3,12) = CR_SIGMAR_F
        WRITE(LINE,'('' Sigma cut_off (F) for refinement: '',F8.3)') 
     *  CR_SIGMAR_F
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      RESULT(3,14)=CR_NREF_REP
C -----------------------------
      RETURN
      END

C ******
      SUBROUTINE ORCRD_NDB(MDOC,IN,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P- ORCRD - OPEN OF FILE-CRD FOR READ
C
C
      INTEGER   IN,MDOC,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
C ----------
      CHARACTER EXT*3,PATH*1,LINE*80,NAME*256
C -------------------------------------------------------------
      IERR=0
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        LINE = NAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.cif') THEN
          NAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      EXT='cif'
      PATH=' '
      CALL OPENFR(IN,MDOC,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('INPUT FILE-COORDS /CRD/:',A)
      CALL MSGDOC(MDOC,LINE)
      CALL RD_TTL_CRD_NDB(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.EQ.2) GO TO 9200
      IF(IERR.EQ.3) GO TO 9000
      IF(IERR.GT.0) THEN
        IERR=4
        CLOSE(IN)
      ENDIF
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERR: READ OF FILE /...CRD/')
      CLOSE(IN)
      IERR=3
      RETURN
9200  CONTINUE
      CALL MSGERR(MDOC,' ERR: END OF FILE /..CRD/')
      IERR=2
      RETURN
      END

C ******
      SUBROUTINE OPEN_NDB(MDOC,IN,FNAME,IERR)
C
C -P- ORCRD - OPEN OF FILE-CRD FOR READ
C
C
      INTEGER   IN,MDOC,IERR
      CHARACTER FNAME*(*)
C ******
C ----------
      CHARACTER EXT*3,PATH*1,LINE*80,NAME*256
C -------------------------------------------------------------
      IERR=0
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        LINE = NAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.cif') THEN
          NAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      EXT='cif'
      PATH=' '
      CALL OPENFR(IN,MDOC,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('INPUT FILE-COORDS /CRD/:',A)
      CALL MSGDOC(MDOC,LINE)
      RETURN
      END

C ******
      SUBROUTINE RD_TTL_CRD_NDB(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
C
C -P- RD_TTL_CRD - reads title of file to common/CRDINF/
C ----------------------------------------------------------------------------
C ---
      INTEGER   NSYM,MDOC,IN,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ---
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 60 )
      COMMON /COMCIF_CRD_C/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON/COM_NDB_CIF/ IEND_CIF      
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRDFRM/ NCRD_CSF,CSF_NE,CSF_RAD
     *               ,CSF_A1,CSF_B1,CSF_A2,CSF_B2
     *               ,CSF_A3,CSF_B3,CSF_A4,CSF_B4
     *               ,CSF_C,CSF_FI,CSF_FII,CSF_ATOM
      CHARACTER       CSF_ATOM(IPRAT_SF)*4
      REAL            CSF_A1(IPRAT_SF),CSF_B1(IPRAT_SF)
      REAL            CSF_A2(IPRAT_SF),CSF_B2(IPRAT_SF)
      REAL            CSF_A3(IPRAT_SF),CSF_B3(IPRAT_SF)
      REAL            CSF_A4(IPRAT_SF),CSF_B4(IPRAT_SF)
      REAL            CSF_C (IPRAT_SF),CSF_RAD(IPRAT_SF)
      REAL            CSF_FI(IPRAT_SF),CSF_FII(IPRAT_SF)
      REAL            CSF_NE(IPRAT_SF)
C ---------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB/   CR_TEMPER   ,CR_WAVEL
     *                 ,CR_RES_MIN  ,CR_RES_MAX 
     *                 ,CR_RFAC_ALL ,CR_RFAC_OBS
     *                 ,CR_SIGMA_I  ,CR_SIGMA_F 
     *                 ,CR_CD_NDB   ,CR_CD_CSD
     *                 ,CR_DATE_NDB ,CR_DATE_CREAT
     *                 ,CR_PROGRAM  ,CR_METHOD
      REAL  CR_TEMPER
      REAL  CR_WAVEL
      REAL  CR_RES_MIN
      REAL  CR_RES_MAX 
      REAL  CR_RFAC_ALL
      REAL  CR_RFAC_OBS
      REAL  CR_SIGMA_I
      REAL  CR_SIGMA_F 
      CHARACTER CR_CD_NDB    *8
      CHARACTER CR_CD_CSD    *8
      CHARACTER CR_DATE_NDB  *10
      CHARACTER CR_DATE_CREAT*20
      CHARACTER CR_PROGRAM   *40
      CHARACTER CR_METHOD    *40
C -----------------------------------------------
C   CR_TEMPER        CR_WAVEL
C   CR_RES_MIN       CR_RES_MAX 
C   CR_RFAC_ALL      CR_RFAC_OBS CR_RMERG_IOBS
C   CR_SIGMA_I       CR_SIGMA_F 
C   CR_CD_NDB        CR_CD_CSD
C   CR_DATE_NDB      CR_DATE_CREAT
C   CR_PROGRAM       CR_METHOD
C ----------------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB_2/   CR_RFAC_CUT  ,CR_NMODEL   ,CR_RMERG_ALL
     *                   ,CR_RES_RMIN  ,CR_RES_RMAX ,CR_RMERG_OBS
     *                   ,CR_SIGMAR_I,CR_SIGMAR_F 
     *                   ,CR_RMERG_IOBS
     *                   ,CR_RFREE_ALL ,CR_RFREE_OBS,CR_RFREE_CUT
     *                   ,CR_DPI,CR_ERR_CRD_MIN     ,CR_ERR_CRD_MAX
     *                   ,CR_NDB_TITLE ,CR_NDB_NAME 
     *                   ,CR_INFO_FLAG
      REAL  CR_DPI
      REAL  CR_ERR_CRD_MIN
      REAL  CR_ERR_CRD_MAX
      REAL  CR_RMEGR_ALL
      REAL  CR_RMERG_OBS,CR_RMERG_IOBS
      REAL  CR_RES_RMIN
      REAL  CR_RES_RMAX 
      REAL  CR_SIGMAR_I
      REAL  CR_SIGMAR_F 
      REAL  CR_RFAC_CUT
      REAL  CR_RFREE_OBS
      REAL  CR_RFREE_ALL
      REAL  CR_RFREE_CAT
      INTEGER CR_NMODEL
      CHARACTER CR_NDB_TITLE *80
      CHARACTER CR_NDB_NAME  *80
      CHARACTER CR_INFO_FLAG *1
C ------------------------------------------
      COMMON /CRDPDB_3/ CR_NREF_REP
      INTEGER CR_NREF_REP
C -----------------
C    CR_RFAC_CUT  
C    CR_NMODEL
C    CR_RMEGR_ALL
C    CR_RMERG_OBS
C    CR_RES_RMIN  
C    CR_RES_RMAX 
C    CR_RFREE_ALL 
C    CR_RFREE_OBS
C    CR_RFREE_CUT
C    CR_DPI
C    CR_ERR_CRD_MIN
C    CR_ERR_CRD_MAX
C    CR_NDB_TITLE 
C    CR_NDB_NAME
C    CR_INFO_FLAG
C ----------------------------------------------------------------
C ---
C  CR_MODEL_PDB -
C  CR_CD_PDB    -  PDB code /_database_2.code_PDB/
C  CR_CD_NDB    -  NDB code /_database_2.code_NDB/
C  CR_CD_CSD    -  NDB code /_database_2.code_CSD/
C  CR_NAME_PDB  -  PDB name /_struct_keywords.text/  (PROTEIN,DNA,RNA,...)
C  CR_DATE_PDB  -  PDB creating date /_database_PDB_rev.data_original /
C  CR_DATE_NDB  -  NDB creating date 
C  CR_DATE_CREAT-  file creation date /_audit.creation_date /
C  CR_TITLE     -  title /_struct.title '5"-D(*CP*GP*CP*G)-3",SPERMIN' /
C  CR_RESL_PDB  -  resolution from PDB_remark
C  CR_RFAC_PDB  -  R-factor   from PDB_remark
C  CR_PROGRAM   -  refinement program name / _computing.structure_refinement / 
C  CR_METHOD    -   /_expt.method 'X_RAY DIFFRACTION'/ 
C  CR_TEMPER    -   /_diffrn.ambient_temp 293 /
C  CR_WAVEL     -   /_diffrn_radiation.wavelength  1.5418 /
C  CR_RES_MIN   -   /_refine.ls_d_res_low  /
C  CR_RES_MAX   -   /_refine.ls_d_res_high /
C  CR_RFAC_ALL  -   /_refine.ls_R_factor_all/
C  CR_RFAC_OBS  -  t.e. with cutoff /_refine.ls_R_factor_obs/
C  CR_SIGMA_I   -   / ? _reflns.observed_criterion  '>2sigma(I)' /
C  CR_SIGMA_F   -
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -
C  CR_NCS       -
C  CR_ISYMOP    -
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compound
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C -------------------------------------------------
      COMMON/COM_STOR_NDB/ FLAG_SC_NDB
      CHARACTER            FLAG_SC_NDB*1
C --------------------------------------------------------------
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C ---
      REAL        AM(3,3)
      CHARACTER   FL(6)*40
      REAL        FN(40)
C ----
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CH2*2
      REAL      RLATT(6),AMR(3,3),TR(3)
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAME*20,DATE*9,SPGR*24

      CHARACTER SGNAME*24

      CHARACTER TITLE*80,TIME*20,NAME_NDB*8,TEMPER*5,WAVE*5
      CHARACTER LINE*80,CH10*10
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
C -------------------------------------------------------------------
      DO I=1,80
        CR_TITLE(I:I)        = ' '
        TITLE(I:I)           = ' '
        CR_NDB_TITLE (I:I)   = ' '
        CR_NDB_NAME  (I:I)   = ' '
      ENDDO
      DO I=1,40
        CR_NAME_PDB(I:I) = ' '
        CR_RESL_PDB(I:I) = ' '
        CR_RFAC_PDB(I:I) = ' '
      ENDDO
      NCRD_CSF=0
      CR_CELL(1)=1.0
      CR_CELL(2)=1.0
      CR_CELL(3)=1.0
      CR_CELL(4)=PI/2.0
      CR_CELL(5)=PI/2.0
      CR_CELL(6)=PI/2.0
      CR_SCALE(1,1)=1.0
      CR_SCALE(1,2)=0.0
      CR_SCALE(1,3)=0.0
      CR_SCALE(2,1)=0.0
      CR_SCALE(2,2)=1.0
      CR_SCALE(2,3)=0.0
      CR_SCALE(3,1)=0.0
      CR_SCALE(3,2)=0.0
      CR_SCALE(3,3)=1.0
      CR_U(1)      =0.0
      CR_U(2)      =0.0
      CR_U(3)      =0.0
      CR_FLAG_HA='N'
      CR_CF1 = 0.0
      CR_CF2 = 0.0
      CR_TOV = 0.0
      CR_ORT_TO_FRAC(1,1)=1.0
      CR_ORT_TO_FRAC(1,2)=0.0
      CR_ORT_TO_FRAC(1,3)=0.0
      CR_ORT_TO_FRAC(2,1)=0.0
      CR_ORT_TO_FRAC(2,2)=1.0
      CR_ORT_TO_FRAC(2,3)=0.0
      CR_ORT_TO_FRAC(3,1)=0.0
      CR_ORT_TO_FRAC(3,2)=0.0
      CR_ORT_TO_FRAC(3,3)=1.0
      CR_FRAC_TO_ORT(1,1)=1.0
      CR_FRAC_TO_ORT(1,2)=0.0
      CR_FRAC_TO_ORT(1,3)=0.0
      CR_FRAC_TO_ORT(2,1)=0.0
      CR_FRAC_TO_ORT(2,2)=1.0
      CR_FRAC_TO_ORT(2,3)=0.0
      CR_FRAC_TO_ORT(3,1)=0.0
      CR_FRAC_TO_ORT(3,2)=0.0
      CR_FRAC_TO_ORT(3,3)=1.0
      CR_NAME_PDB(1:13) = 'XXXXXXXX    ?'
      CR_DATE_PDB   = 'XX-XXX-XX'
      CR_CD_PDB     = 'XXXX'
      CR_TITLE(1:9)   = '?   ?   ?'
      CR_TITLE(69:78) = '?    ?    '
      CR_RFAC_PDB = '.'
      CR_RESL_PDB = '.'
      CR_TIME     = '.'
      CR_FLAG_HA  = 'N'
      CR_FLAG_USER= 'N'
      CR_MODEL    = 0
      CR_NSPGR    = 1
      CR_SETT     = 1
      CR_SPGR     = 'P 1        '
      CR_PDB_REC  ='.'
      CR_NSYM     = 1
      CR_NCS      = 0
      CR_SYMOP    = 'X,Y,Z'
      CR_IATOM    =0
      CR_IRES     =0
      CR_IATOLD   =0
      CR_IGROUP   =0
      CR_MULT_FLAG  =0
      CR_MULT_FACTOR=1
      CR_RTYPE    = '.'
      CR_ATYPE    = '.'
      CR_TERM     = '.'
      CR_RNAME    = '.'
      CR_ANAME    = '.'
      CR_ALT      = '.'
      CR_CORR     = '.'
      CR_CHAIN    = '. '
      CR_GROUP    = '.   '
      CR_BTYPE    = 'I'
      CR_FSC      = '.'
      CR_FSA      = '.'
      NAME_NDB    = 'XXXX    '
      TITLE(1:1)  = '?'
      TEMPER      = '?    '
      WAVE        = '?    '
      NAME(1:1)   = '?'
C --------------------
C -----------------------------------------------
C ----- PDB --------------------
      CR_TEMPER     = 0.0
      CR_WAVEL      = 0.0
      CR_RES_MIN    = 0.0
      CR_RES_MAX    = 0.0
      CR_RFAC_ALL   = 0.0
      CR_RFAC_OBS   = 0.0
      CR_SIGMA_I    = 0.0
      CR_SIGMA_F    = 0.0
      CR_CD_NDB     = '?'
      CR_CD_CSD     = '?'
      CR_DATE_NDB   = '?'
      CR_DATE_CREAT = '?'
      CR_PROGRAM    = '?'
      CR_METHOD     = '?'
C -----------------------------------------------
C ----- PDB 2 --------------------
      CR_RFAC_CUT     = 0.0
      CR_NMODEL       = 0
      CR_RMEGR_ALL    = 0.0
      CR_RMERG_OBS    = 0.0
      CR_RMERG_IOBS   = 0.0
      CR_RES_RMIN     = 0.0
      CR_RES_RMAX     = 0.0
      CR_SIGMAR_I     = 0.0
      CR_SIGMAR_F     = 0.0
      CR_RFREE_ALL    = 0.0
      CR_RFREE_OBS    = 0.0
      CR_RFREE_CUT    = 0.0
      CR_DPI          = 0.0
      CR_ERR_CRD_MIN  = 0.0
      CR_ERR_CRD_MAX  = 0.0
      CR_NDB_TITLE    = '?'
      CR_NDB_NAME     = '?                           '
      CR_INFO_FLAG    = '?'
C------------------------------------------
      CR_NREF_REP     = 0
C------------------------------------------
      FLAG_SC_NDB='N'

      CR_INFO_FLAG    = 'C'

C ------------------------------------------
      INCS=0
      CALL SET_NCS(MDOC,NCMAX,INCS,AMR,TR,IERR)
      IF(IERR.NE.0) RETURN
      IGRP=0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGRP,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
C --
      ISOP =  0
      IEND_CIF = -1
C -------
  300 CONTINUE   
      CALL GETCIF_C(IN,MDOC,IERR,IEND_CIF)
      IF(IERR.NE.0) THEN
        IERR=3
        RETURN
      ENDIF
      IF(IEND_CIF.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        GO TO 300
      ELSE IF(IEND_CIF.NE.0) THEN
        IERR=2
        RETURN
      ENDIF

      IF(N_CIF.LE.0) GO TO 300

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF((ITEM(1:18).EQ.'_database_PDB_code').OR.
     *     (ITEM(1:18).EQ.'_database_PDB.code').OR.
     *     (ITEM(1:18).EQ.'_database.code_PDB').OR.
     *     (ITEM(1:20).EQ.'_database_2.code_PDB').OR.
     *     (ITEM(1:9) .EQ.'_entry.id')) THEN
C               Data items in the DATABASE_2 category record details about the
C               database identifiers of the data block.
C
C               These data items are assigned by database managers and should
C               only appear in a data block if they originate from that source.
C
C               The somewhat clunky name of this category (DATABASE_2) is a
C               consequence of the name DATABASE having been already used in
C               the CIF core, but used in a manner different than the usage
C               in mmCIF. Since CIF data names, once adopted, cannot be
C               changed, a new category was created.
Csave__database_2.database_id
C    _item_description.description
C;              An abbreviation that identifies the database.
C;
C                                  NDB
C;                                 Nucleic Acid Database
C;
C                                  NBS
C;                                 NBS (NIST) Crystal Data Database
C                                  (lattice parameters)
C;
C                                  PDB
C;                                 Protein Data Bank

          CR_CD_PDB = '    '
          IF(LEND.GT.4) LEND=4
          CR_CD_PDB = DATA(1:LEND)
          IF(LEND.LT.4) THEN
            DO II=LEND+1,4
              CR_CD_PDB(II:II)=' '
            ENDDO
          ENDIF


        ELSE IF((ITEM(1:20).EQ.'_database_2.code_NDB').OR.
     *          (ITEM(1:18).EQ.'_database.code_NDB')) THEN         
          NAME_NDB = '?'
          IF(LEND.GT.8) LEND=8
          NAME_NDB = DATA(1:LEND)
          IF(LEND.LT.8) THEN
            DO II=LEND+1,8
              NAME_NDB(II:II)=' '
            ENDDO
          ENDIF
          CR_CD_NDB       = NAME_NDB
          CR_INFO_FLAG    = 'N'

        ELSE IF((ITEM(1:18).EQ.'_database_PDB_name').OR.
     *          (ITEM(1:21).EQ.'_struct_keywords.text').OR.
     *    (ITEM(1:16).EQ.'_struct.keywords'.AND.LENI.EQ.16)) THEN
          CR_NAME_PDB = ' '
          IF(LEND.GT.20) LEND=20
          NAME = DATA(1:LEND)
          IF(LEND.LT.20) THEN
            DO II=LEND+1,20
              NAME(II:II)=' '
            ENDDO
          ENDIF
          CR_NDB_NAME=NAME

        ELSE IF((ITEM(1:18).EQ.'_database_PDB_date').OR.
     *          (ITEM(1:18).EQ.'_database_PDB.date').OR.
     *          (ITEM(1:20).EQ.'_audit.creation_date')) THEN         
          CR_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR_DATE_PDB)         
          ELSE
            CR_DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:31).EQ.'_database_PDB_rev.date_original').OR.        
     *    (ITEM(1:31).EQ.'_database_NDB_rev.date_original')) THEN         
          CR_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR_DATE_PDB)         
          ELSE
            CR_DATE_PDB = CH10(1:9)
          ENDIF

          IF(CR_INFO_FLAG.EQ.'N') THEN
            CR_DATE_NDB=CH10
          ENDIF

        ELSE IF((ITEM(1:13).EQ.'_struct_title').OR.
     *          (ITEM(1:13).EQ.'_struct.title')) THEN     
          IF(LEND.GT.60) LEND=60
          TITLE = DATA(1:LEND)
          IF(LEND.LT.60) THEN
            DO II=LEND+1,60
              TITLE(II:II)=' '
            ENDDO
          ENDIF
c          IF(CR_INFO_FLAG.EQ.'N') THEN
            CR_NDB_TITLE=DATA(1:LEND)
c          ENDIF
        ELSE IF(ITEM(1:19).EQ.'_file_creation_date') THEN
          IF(LEND.GT.20) LEND=20
          CR_TIME = DATA(1:LEND)
        ELSE IF((ITEM(1:19).EQ.'_database_PDB_model').OR.
     *          (ITEM(1:19).EQ.'_database_PDB.model')) THEN
          CR_MODEL = IDATA
        ELSE IF((ITEM(1:31).EQ.'_database_PDB_remark_resolution').OR.
     *          (ITEM(1:31).EQ.'_database_PDB.remark_resolution')) 
     *       THEN
          IF(LEND.GT.40) LEND=40
          CR_RESL_PDB = DATA(1:LEND)              
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR_RESL_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:29).EQ.'_database_PDB_remark_R_factor').OR.
     *          (ITEM(1:29).EQ.'_database_PDB.remark_R_factor')) THEN
          IF(LEND.GT.40) LEND=40
          CR_RFAC_PDB = DATA(1:LEND)
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR_RFAC_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:20).EQ.'_diffrn.ambient_temp') THEN
Csave__diffrn.ambient_temp
C    _item_description.description
C;              The mean temperature in kelvins at which the intensities were
C               measured.
C;
          IF(LEND.GT.5) LEND=5
          TEMPER = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              TEMPER(II:II)=' '
            ENDDO
          ENDIF
          CR_TEMPER=FDATA
        ELSE IF((ITEM(1:28).EQ.'_diffrn_radiation.wavelength'.AND.
     *           LENI.EQ.28).OR.
     *      (ITEM(1:32).EQ.'_diffrn_radiation_wavelength.wav'))THEN 
C
C    _diffrn_radiation_wavelength.wavelength            1.54
C
          IF(LEND.GT.5) LEND=5
          WAVE = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              WAVE(II:II)=' '
            ENDDO
          ENDIF
          CR_WAVEL=FDATA
        ELSE IF(ITEM(1:20).EQ.'_refine.ls_d_res_low') THEN

          IF(CR_RES_RMIN.LE.0.0) CR_RES_RMIN     = FDATA

        ELSE IF(ITEM(1:21).EQ.'_refine.ls_d_res_high') THEN

          IF(CR_RES_RMAX.LE.0.0) CR_RES_RMAX     = FDATA

        ELSE IF(ITEM(1:25).EQ.'_reflns.d_resolution_high') THEN
C         save__reflns.d_resolution_high
C;              The highest resolution for the interplanar spacings in
C               the reflection data. This is the smallest d value.

          IF(CR_RES_MAX.LE.0.0) CR_RES_MAX    = FDATA

        ELSE IF(ITEM(1:24).EQ.'_reflns.d_resolution_low') THEN
C         save__reflns.d_resolution_low
C;        The lowest resolution for the interplanar spacings in the
C         reflection data. This is the largest d value.

          IF(CR_RES_MIN.LE.0.0) CR_RES_MIN    = FDATA

        ELSE IF(ITEM(1:23).EQ.'_refine.ls_R_factor_all') THEN
C         save__refine.ls_R_factor_all
C         Residual factor R for all reflections that satisfy the resolution
C         limits established by _refine.ls_d_res_high and _refine.ls_d_res_low

          IF(DATA(1:1).NE.'?'.AND.DATA(1:1).NE.'.') THEN
            IF(CR_RFAC_ALL.LE.0.0) CR_RFAC_ALL     = FDATA
          ENDIF

        ELSE IF(ITEM(1:23).EQ.'_refine.ls_R_factor_obs') THEN
C         save__refine.ls_R_factor_obs
C;        Residual factor R for reflections that satify the resolution
C         limits established by _refine.ls_d_res_high and 
C         _refine.ls_d_res_low and the observation limit established by
C         _reflns.observed_criterion.

          IF(DATA(1:1).NE.'?'.AND.DATA(1:1).NE.'.') THEN
            IF(CR_RFAC_OBS.LE.0.0) CR_RFAC_OBS     = FDATA
            IF(CR_RFAC_CUT.LE.0.0) CR_RFAC_CUT     = FDATA
          ENDIF

        ELSE IF(ITEM(1:26).EQ.'_refine.ls_R_factor_R_free') THEN
C         save__refine.ls_R_factor_R_free
C;        Residual factor R for reflections that satisfy the resolution
C         limits established by _refine.ls_d_res_high and
C         _refine.ls_d_res_low and the observation limit established by
C         _reflns.observed_criterion, and that were used as the test
C         (i.e., excluded from refinement) reflections when refinement
C         included calculation of a "free" R-factor. Details of how
C         reflections were assigned to the working and test sets are
C         given in _reflns.R_free_details.

          IF(DATA(1:1).NE.'?'.AND.DATA(1:1).NE.'.') THEN
            IF(CR_RFREE_CUT.LE.0.0) CR_RFREE_CUT     = FDATA
          ENDIF         
        ELSE IF(ITEM(1:34).EQ.'_reflns.observed_criterion_sigma_F')
     *  THEN
C         save__reflns.observed_criterion_sigma_F
C;        The criterion used to classify a reflection as 'observed',
C         expressed as a multiple of the value of sigma(F).

          IF(DATA(1:1).NE.'?'.AND.DATA(1:1).NE.'.') THEN
            IF(CR_SIGMA_F.LE.0.0) CR_SIGMA_F    = FDATA
          ENDIF
         
        ELSE IF(ITEM(1:22).EQ.'_refine.ndb_ls_sigma_F') THEN

          IF(DATA(1:1).NE.'?'.AND.DATA(1:1).NE.'.') THEN
            IF(CR_SIGMAR_F.LE.0.0) CR_SIGMAR_F    = FDATA
          ENDIF

        ELSE IF(ITEM(1:34).EQ.'_reflns.observed_criterion_sigma_I')
     *  THEN
C         save__reflns.observed_criterion_sigma_I
C;        The criterion used to classify a reflection as 'observed',
C         expressed as a multiple of the value of sigma(I).  

          IF(DATA(1:1).NE.'?'.AND.DATA(1:1).NE.'.') THEN
            IF(CR_SIGMA_I.LE.0.0) CR_SIGMA_I    = FDATA
          ENDIF

        ELSE IF(ITEM(1:22).EQ.'_refine.ndb_ls_sigma_I') THEN

          IF(DATA(1:1).NE.'?'.AND.DATA(1:1).NE.'.') THEN
            IF(CR_SIGMAR_I.LE.0.0) CR_SIGMAR_I    = FDATA
          ENDIF

        ELSE IF(ITEM(1:20).EQ.'_reflns.Rmerge_F_all') THEN
C         save__reflns.Rmerge_F_all
C;        Residual factor Rmerge for all reflections that satify the
C         resolution limits established by _reflns.d_resolution_high 
C         and _reflns.d_resolution_low.

          IF(CR_RMERG_ALL.LE.0.0) CR_RMERG_ALL    = FDATA

        ELSE IF(ITEM(1:20).EQ.'_reflns.Rmerge_F_obs') THEN
C         save__reflns.Rmerge_F_obs
C;        Residual factor Rmerge for reflections that satify the
C         resolution limits established by _reflns.d_resolution_high
C         and _reflns.d_resolution_low and the observation limit
C         established by _reflns.observed_criterion.

          IF(CR_RMERG_OBS.LE.0.0) CR_RMERG_OBS    = FDATA

        ELSE IF(ITEM(1:20).EQ.'_reflns.Rmerge_I_obs') THEN
C         save__reflns.Rmerge_F_obs
C;        Residual factor Rmerge for reflections that satify the
C         resolution limits established by _reflns.d_resolution_high
C         and _reflns.d_resolution_low and the observation limit
C         established by _reflns.observed_criterion.

          IF(CR_RMERG_IOBS.LE.0.0) CR_RMERG_IOBS    = FDATA

        ELSE IF(ITEM(1:28).EQ.'_refine.ls_number_reflns_all') THEN
c         The number of reflections that satisfy the resolution limits
c         established by _refine.ls_d_res_high and _refine.ls_d_res_low.

          IF(CR_NREF_REP.LE.0) CR_NREF_REP = IDATA 

        ELSE IF(ITEM(1:28).EQ.'_refine.ls_number_reflns_obs') THEN
c         The number of reflections that satisfy the resolution limits
c         established by _refine.ls_d_res_high and _refine.ls_d_res_low
c         and the observation limit established by
c         _reflns.observed_criterion.

          IF(CR_NREF_REP.LE.0) CR_NREF_REP = IDATA 

        ELSE IF(ITEM(1:31).EQ.'_refine.ls_number_reflns_R_work') THEN
c         The number of reflections that satisfy the resolution limits
c         established by _refine.ls_d_res_high and _refine.ls_d_res_low
c         and the observation limit established by
c         _reflns.observed_criterion, and that were used as the working
c         (i.e., included in refinement) reflections when refinement
c         included calculation of a "free" R-factor. Details of how
c         reflections were assigned to the working and test sets are
c         given in _reflns.R_free_details.

          CR_NREF_REP = IDATA 

        ELSE IF(ITEM(1:31).EQ.'_computing.structure_refinement') THEN

          CR_PROGRAM = DATA(1:LEND)

        ELSE IF((ITEM(1:12) .EQ.'_cell_length').OR.         
     *          (ITEM(1:12) .EQ.'_cell_angle_').OR.         
     *          (ITEM(1:12) .EQ.'_cell.length').OR.         
     *          (ITEM(1:12) .EQ.'_cell.angle_')) THEN         
          IF(ITEM(7:14).EQ.'length_a'.AND.LENI.EQ.14) THEN
            CR_CELL(1) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_b'.AND.LENI.EQ.14) THEN
            CR_CELL(2) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_c'.AND.LENI.EQ.14) THEN
            CR_CELL(3) = FDATA
          ELSE IF(ITEM(7:17).EQ.'angle_alpha'.AND.LENI.EQ.17) THEN
            CR_CELL(4) = FDATA
            CR_CELL(4) = CR_CELL(4)*PI180
          ELSE IF(ITEM(7:16).EQ.'angle_beta'.AND.LENI.EQ.16) THEN
            CR_CELL(5) = FDATA
            CR_CELL(5) = CR_CELL(5)*PI180
          ELSE IF(ITEM(7:17).EQ.'angle_gamma'.AND.LENI.EQ.17) THEN
            CR_CELL(6) = FDATA
            CR_CELL(6) = CR_CELL(6)*PI180
          ENDIF
        ELSE IF(ITEM(1:9).EQ.'_symmetry') THEN
          IF(ITEM(11:30).EQ.'space_group_name_H-M') THEN
            IF(LEND.GT.11) LEND=11
            CR_SPGR = DATA(1:LEND)
            IF(LEND.LT.11) THEN
              DO II=LEND+1,11
                CR_SPGR(II:II)=' '
              ENDDO
            ENDIF
          ENDIF
        ELSE IF((ITEM(1:11).EQ.'_atom_type_').OR.
     *          (ITEM(1:11).EQ.'_atom_type.')) THEN
          IF(NCRD_CSF.GE.IPRAT_SF) THEN
            GO TO 410
          ENDIF
          IF(I.EQ.1) THEN
            CSF_RAD (NCRD_CSF+1)=0.0
            CSF_NE  (NCRD_CSF+1)=0.0
            CSF_ATOM(NCRD_CSF+1)='.   '
          ENDIF
          IF(ITEM(12:17).EQ.'symbol') THEN
            CSF_ATOM(NCRD_CSF+1) = DATA(1:4)
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a1') THEN
            CSF_A1(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a2') THEN
            CSF_A2(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a3') THEN
            CSF_A3(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a4') THEN
            CSF_A4(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b1') THEN
            CSF_B1(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b2') THEN
            CSF_B2(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b3') THEN
            CSF_B3(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:29).EQ.'scat_Cromer_Mann_c') THEN
            CSF_C(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_real') THEN
            CSF_FI(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_imag') THEN
            CSF_FII(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:17).EQ.'radius') THEN
            CSF_RAD(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:16).EQ.'nelec') THEN
            CSF_NE(NCRD_CSF+1)  =FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            NCRD_CSF   = NCRD_CSF + 1
          ENDIF


C_atom_sites.frac_transf_matrix[1][1]   0.040667  
C_atom_sites.frac_transf_matrix[1][2]   0.000000  
C_atom_sites.frac_transf_matrix[1][3]   0.000000  
C_atom_sites.frac_transf_matrix[2][1]   0.000000  
C_atom_sites.frac_transf_matrix[2][2]   0.024728  
C_atom_sites.frac_transf_matrix[2][3]   0.000000  
C_atom_sites.frac_transf_matrix[3][1]   0.000000  
C_atom_sites.frac_transf_matrix[3][2]   0.000000  
C_atom_sites.frac_transf_matrix[3][3]   0.015207  
C_atom_sites.frac_transf_vector[1]   0.00000  
C_atom_sites.frac_transf_vector[2]   0.00000  
C_atom_sites.frac_transf_vector[3]   0.00000  

        ELSE IF(ITEM(1:24).EQ.'_atom_sites.frac_transf_') THEN

          IF(DATA(1:1).NE.'?') THEN
            FLAG_SC_NDB='Y'
            IF(ITEM(25:36).EQ.'matrix[1][1]') THEN
              CR_SCALE(1,1)=FDATA
            ELSE IF(ITEM(25:36).EQ.'matrix[1][2]') THEN
              CR_SCALE(2,1)=FDATA
            ELSE IF(ITEM(25:36).EQ.'matrix[1][3]') THEN
              CR_SCALE(3,1)=FDATA
            ELSE IF(ITEM(25:33).EQ.'vector[1]') THEN
              CR_U(1)      =FDATA  
            ELSE IF(ITEM(25:36).EQ.'matrix[2][1]') THEN
              CR_SCALE(1,2)=FDATA
            ELSE IF(ITEM(25:36).EQ.'matrix[2][2]') THEN
              CR_SCALE(2,2)=FDATA
            ELSE IF(ITEM(25:36).EQ.'matrix[2][3]') THEN
              CR_SCALE(3,2)=FDATA
            ELSE IF(ITEM(25:33).EQ.'vector[2]') THEN
              CR_U(2)      =FDATA  
            ELSE IF(ITEM(25:36).EQ.'matrix[3][1]') THEN
              CR_SCALE(1,3)=FDATA
            ELSE IF(ITEM(25:36).EQ.'matrix[3][2]') THEN
              CR_SCALE(2,3)=FDATA
            ELSE IF(ITEM(25:36).EQ.'matrix[3][3]') THEN
              CR_SCALE(3,3)=FDATA
            ELSE IF(ITEM(25:33).EQ.'vector[3]') THEN
              CR_U(3)      =FDATA  
            ENDIF
          ENDIF

        ELSE IF((ITEM(1:11).EQ.'_atom_site_').OR.
     *          (ITEM(1:11).EQ.'_atom_site.')) THEN
          GO TO 400
        ENDIF
 410    CONTINUE
      ENDDO
      GO TO 300
 400  CONTINUE


      CALL LENSTR_BL(CR_SPGR,LENS)
      IF(LENS.LT.1.OR.LENS.GT.24) THEN
        CALL MSGERR(MDOC
     *   ,' WARNING: wrong space group name in CIFile.')
        CALL MSGERR(MDOC
     *    ,'          default space group "P 1"')
        CR_SPGR='P 1'
        LENS=3 
      ENDIF

      NOSPGR = 0
      ISETT  = 0
      NSYM   = 0

              IF(CR_SPGR.EQ.'P2' .OR.CR_SPGR.EQ.'P 2' .OR.
     *           CR_SPGR.EQ.'P21'.OR.CR_SPGR.EQ.'P 21'.OR.
     *           CR_SPGR.EQ.'B2' .OR.CR_SPGR.EQ.'B 2' .OR.
     *           CR_SPGR.EQ.'C2' .OR.CR_SPGR.EQ.'C 2'     ) THEN
                T  = PI/2.0
c                ISETT = 2
                IF(ABS(CR_CELL(6)-T).GT.0.0001.AND.
     *             ABS(CR_CELL(5)-T).LE.0.0001     ) ISETT = 1
                IF(CR_SPGR.EQ.'P2'.OR.CR_SPGR.EQ.'P 2') THEN
                  IF(ISETT.EQ.1) THEN
                    CR_SPGR = 'P 1 1 2'
                  ELSE
                    CR_SPGR = 'P 1 2 1'
                  ENDIF
                ELSE IF(CR_SPGR.EQ.'P21'.OR.CR_SPGR.EQ.'P 21') THEN
                  IF(ISETT.EQ.1) THEN
                    CR_SPGR = 'P 1 1 21'
                  ELSE
                    CR_SPGR = 'P 1 21 1'
                  ENDIF
                ELSE IF(CR_SPGR.EQ.'B2'.OR.CR_SPGR.EQ.'B 2'.OR.
     *              CR_SPGR.EQ.'C2'.OR.CR_SPGR.EQ.'C 2'    ) THEN
                  IF(ISETT.EQ.1) THEN
                    CR_SPGR = 'B 1 1 2'
                  ELSE
                    CR_SPGR = 'C 1 2 1'
                  ENDIF
                ENDIF
              ENDIF

      CALL LENSTR_BL(CR_SPGR,LENS)
      SGNAME = CR_SPGR(1:LENS)
      IF(SGNAME(1:1).EQ.'H') SGNAME(1:1)='R'
      IF((LENS.GE.3.AND.SGNAME(1:3).EQ.'R 3').OR.
     *   (LENS.GE.2.AND.SGNAME(1:2).EQ.'R3')) THEN
        T= (PI*2.0)/3.0
        IF(ABS(CR_CELL(6)-T).LE.0.0001) THEN
          ISETT=2
          SGNAME(1:1)='H'
        ELSE
          ISETT=1
        ENDIF
      ENDIF

      CALL GET_SYMM(MDOC,NOSPGR,ISETT,SGNAME,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.NE.0) RETURN

      CR_NSPGR = NOSPGR
      CR_SETT  = ISETT
      CR_NSYM  = NSYM
      CR_SPGR  = SGNAME

      IF(NAME_NDB(1:1).NE.'?'.AND.NAME_NDB(1:4).NE.'XXXX') THEN
        CR_NAME_PDB(5:12)=NAME_NDB
      ELSE
        CR_NAME_PDB(5:12)=CR_CD_PDB//'    '
      ENDIF
      CR_NAME_PDB(1:4)   = CR_CD_PDB
      CR_NAME_PDB(13:32) = NAME(1:20)

      CR_TITLE(9:68) = TITLE
      CR_TITLE(69:73)= WAVE
      CR_TITLE(74:78)= TEMPER

      RETURN
      END

C ******
      SUBROUTINE RDCRD_NDB(MDOC,IN,MODE,IEND,IERR)
C
C -P- RDCRD - reads coordinates to common/CRDATM/
C
      INTEGER IN,MDOC,IERR,IEND,MODE
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 60 )
      COMMON /COMCIF_CRD_C/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ------------------------------------------------------------
C ---
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of chain started from 1.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
      COMMON/COM_STOR_NDB/ FLAG_SC_NDB
      CHARACTER            FLAG_SC_NDB*1
C --------------------------------------------------------------
      COMMON/COM_NDB_CIF/ IEND_CIF      
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C --
      REAL Y(3)
      CHARACTER LINE*80,BFLAG*1,MULT*2,ASYMB*4
C      CHARACTER CODE*4,ALT*2,CH2*2
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.EQ.-1) THEN
        REWIND IN
        IEND_CIF = -1
        CR_IATOM=0
        IEND=0
      ENDIF


  300 CONTINUE   
      CALL GETCIF_C(IN,MDOC,IERR,IEND_CIF)
      IF(IERR.NE.0) THEN
        GO TO 1200
      ENDIF

      IF(IEND_CIF.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        LINE=DT_CIF (NWORDSMAX)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#'.OR.LINE(1:1).EQ.'C'.OR.
     *     LINE(1:1).EQ.'d'.OR.LINE(1:1).EQ.'c'.OR.
     *     LINE(1:1).EQ.'_') THEN
          MODE=1
          IF(LEN.LE.0) THEN
            LEN=1
            LINE(1:1)='#'
          ENDIF
          CR_LINE=LINE(1:LEN)
          GO TO 500
        ENDIF
        GO TO 300 
      ELSE IF(IEND_CIF.NE.0) THEN
        GO TO 1300
      ENDIF

      IF(N_CIF.LE.0) GO TO 300

      IF((ITM_CIF(1)(1:11).NE.'_atom_site_').AND.
     *   (ITM_CIF(1)(1:11).NE.'_atom_site.'))  GO TO 300

      CR_ANAME = '    '
      CR_ASYMB = '    '
      CR_RNAME = '   '
      CR_CORR  = '.'
      IFLAG    = 0 

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF(ITEM(1:10).EQ.'_atom_site') THEN

        IF((ITEM(12:22).EQ.'atom_number').OR.
     *     (ITEM(12:13).EQ.'id')) THEN

          CR_IATOLD=IDATA

        ELSE IF(ITEM(12:24).EQ.'label_atom_id') THEN

          CR_ANAME(1:LEND)=DATA(1:LEND)
          IFLAG=1    

        ELSE IF(ITEM(12:22).EQ.'type_symbol') THEN
C               This data item is a pointer to _atom_type.symbol in the
C               ATOM_TYPE category.

          CR_ASYMB(1:LEND) = DATA(1:LEND)

        ELSE IF((ITEM(12:20).EQ.'atom_type').OR.
     *          (ITEM(12:20).EQ.'calc_flag')) THEN
C              A standard code to signal if the site data have been determined
C               from the intensities or calculated from the geometry of
C               surrounding sites, or have been assigned dummy coordinates. The
C               abbreviation 'c' may be used in place of 'calc'.
C    _item_enumeration.detail      d
C                                 'determined from experimental measurements'
C                                  calc
C                                 'calculated from molecular geometry'
C                                  c
C                                 'abbreviation for "calc"'
C                                  dum
C                                 'dummy site with meaningless coordinates'

          IF(DATA(1:1).EQ.'?') DATA(1:1)='.'
          CR_ATYPE=DATA(1:1)

        ELSE IF(ITEM(12:23).EQ.'label_alt_id') THEN
C               A component of the macromolecular identifier for this atom site.
C               For further details, see the definition of the ATOM_SITE_ALT
C               category.
C
C               This data item is a pointer to _atom_sites_alt.id in the
C               ATOM_SITES_ALT category.

          IF(DATA(1:1).EQ.'?') DATA(1:1)='.'
          CR_ALT=DATA(1:1)

        ELSE IF((ITEM(12:24).EQ.'label_corr_id').OR.
     *          (ITEM(12:22).EQ.'footnote_id')) THEN
C;              The value of _atom_site.footnote_id must match an id
C               specified by _atom_sites_footnote.id in the
C               ATOM_SITES_FOOTNOTE list.

          IF(DATA(1:1).EQ.'?') DATA(1:1)='.'
          CR_CORR=DATA(1:1)
          CR_CORR='.'

        ELSE IF((ITEM(12:23).EQ.'label_res_id').OR.
     *          (ITEM(12:24).EQ.'label_comp_id')) THEN
C              A component of the macromolecular identifier for this atom site.
C
C              This data item is a pointer to _chem_comp.id in the CHEM_COMP
C              category.

          CR_RNAME(1:LEND)=DATA(1:LEND)

        ELSE IF((ITEM(12:23).EQ.'label_seq_id').OR.
     *          (ITEM(12:28).EQ.'ndb_label_seq_num')) THEN
C              This data item is a pointer to _entity_poly_seq.num in the 
C               ENTITY_POLY_SEQ category.

          IF(DATA(1:1).NE.'?') CR_IRES=IDATA

        ELSE IF((ITEM(12:26).EQ.'label_entity_id').OR.
     *          (ITEM(12:24).EQ.'label_asym_id')) THEN
C
C             This data item is a pointer to _entity.id in the ENTITY category.
C
C              A component of the macromolecular identifier for this atom site.
C              For further details, see the definition of the STRUCT_ASYM
C              category.
C
C              This data item is a pointer to _struct_asym.id in the
C              STRUCT_ASYM category.

          IF(DATA(1:1).NE.'?') THEN
            CR_CHAIN='  '
            L=LEND
            IF(L.GT.2) L=2           
            CR_CHAIN(1:L)=DATA(1:L)
          ENDIF

        ELSE IF(ITEM(13:18).EQ.'artn_x'.AND.LENI.EQ.18) THEN
          CR_XYZ(1)=FDATA
          CR_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_y'.AND.LENI.EQ.18) THEN
          CR_XYZ(2)=FDATA
          CR_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_z'.AND.LENI.EQ.18) THEN
          CR_XYZ(3)=FDATA
          CR_PDB_REC(1:1)='C'

        ELSE IF(ITEM(12:18).EQ.'fract_x'.AND.LENI.EQ.18) THEN
          CR_XYZ(1)=FDATA
          CR_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_y'.AND.LENI.EQ.18) THEN
          CR_XYZ(2)=FDATA
          CR_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_z'.AND.LENI.EQ.18) THEN
          CR_XYZ(3)=FDATA
          CR_PDB_REC(1:1)='F'

        ELSE IF(ITEM(12:20).EQ.'occupancy'.AND.LENI.EQ.20) THEN
          CR_OCC=FDATA
        ELSE IF((ITEM(12:25).EQ.'B_iso_or_equiv'.AND.LENI.EQ.25).OR.
     *          (ITEM(12:25).EQ.'B_isi_or_equiv')) THEN
          CR_BISO=FDATA
        ELSE IF(ITEM(12:32).EQ.'thermal_displace_type') THEN
          CR_BTYPE=DATA(1:1)
        ELSE IF(ITEM(12:32).EQ.'symmetry_multiplicity') THEN
C              The multiplicity of a site due to the space-group symmetry as is
C              given in International Tables for Crystallography, Vol. A (1987).
C
C    _item_range.maximum           
C    _item_range.minimum           192   192
C                                  192     1
C                                    1     1
          IF(DATA(1:1).EQ.'.') THEN
            CR_MULT_FACTOR=1
          ELSE
            CR_MULT_FACTOR=IDATA
          ENDIF

c        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][1]') THEN
C               Isotropic temperature factor parameter, or equivalent isotropic
C               temperature factor, B~equiv~, calculated from anisotropic
C               temperature factor parameters.
C
C               B~equiv~ = (1/3) sum~i~[sum~j~(B~ij~ A~i~ A~j~ a*~i~ a*~j~)] 
C
C               A     = the real space cell lengths
C               a*    = the reciprocal space cell lengths
C               B~ij~ = 8 pi^2^ U~ij~
C
C               Ref: Fischer, R. X. & Tillmanns, E. (1988). Acta Cryst. C44,
C                    775-776.
C
C               The IUCr Commission on Nomenclature recommends against the use
C               of B for reporting atomic displacement parameters. U, being
C               directly proportional to B, is preferred.
C              The [1][1] element of the standard anisotropic atomic
C               displacement matrix U, which appears in the structure factor
C               term:
C
C               T = exp{-2 pi^2^ sum~i~[sum~j~(U~ij~ h~i~ h~j~ a*~i~ a*~j~)]}
C              _item_units.code              angstroms_squared
C
C               T = exp{-1/4 sum~i~[sum~j~(B~ij~ h~i~ h~j~ a*~i~ a*~j~)]}
C              _item_units.code              8pi2_angstroms_squared
C
C               h  = the Miller indices
C               a* = the reciprocal space cell lengths
C
c          CR_FLAG_USER='A'
c          CR_ANIS(1)=FDATA
c        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][2]') THEN
c          CR_FLAG_USER='A'
c          CR_ANIS(2)=FDATA
c        ELSE IF(ITEM(12:24).EQ.'aniso_U[3][3]') THEN
c          CR_FLAG_USER='A'
c          CR_ANIS(3)=FDATA
c        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][2]') THEN
c          CR_FLAG_USER='A'
c          CR_ANIS(4)=FDATA
c        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][3]') THEN
c          CR_FLAG_USER='A'
c          CR_ANIS(5)=FDATA
c        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][3]') THEN
c          CR_FLAG_USER='A'
c          CR_ANIS(6)=FDATA

        ENDIF

        ENDIF

      ENDDO

      IF(IFLAG.EQ.0) GO TO 300

      MODE     = 0
      CR_IATOM = CR_IATOM+1
      BFLAG    = '.'
      IF(CR_BTYPE.EQ.'A') BFLAG='A'
      IF(CR_MULT_FACTOR.GT.1) THEN
        WRITE(MULT,'(I2)') CR_MULT_FACTOR
      ELSE
        MULT='. '
      ENDIF
      ASYMB      = CR_ASYMB
      ASYMB(3:4) = '  '          
      WRITE(LINE,100)
     *    CR_IATOLD,CR_ANAME,ASYMB,CR_ATYPE
     *   ,CR_ALT,CR_CORR
     *   ,CR_RNAME,CR_IRES,CR_IGROUP
     *   ,CR_XYZ(1),CR_XYZ(2),CR_XYZ(3)
     *   ,CR_OCC,CR_BISO,BFLAG,MULT

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I2,1X,F8.3,1X,F8.3,1X,F8.3,1X,F6.2,1X,F6.2
     *    ,1X,A1,1X,A2)
      CR_LINE=LINE


      IF(FLAG_SC_NDB.EQ.'Y') THEN

        CALL MVMULT(CR_SCALE,CR_XYZ,Y)
        Y(1)=Y(1)+CR_U(1)
        Y(2)=Y(2)+CR_U(2)
        Y(3)=Y(3)+CR_U(3)
        CALL MVMULT(CR_FRAC_TO_ORT,Y,CR_XYZ)

      ENDIF

 500  CONTINUE
      CALL MSGDOC(MDOC,LINE)
C ---
      RETURN
1200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.CRD/')
      CLOSE(IN)
      IERR=1
      RETURN
1300  CONTINUE 
      CLOSE(IN)
      IEND=1
      RETURN
      END

      SUBROUTINE CORR_NAME_NDB(ANAME,RNAME,ASYMB,CTYPE)
C ----------------------------------------------
      PARAMETER (N_NAME = 95)
      CHARACTER ANAME*4,RNAME*3,ASYMB*4,CTYPE*4
C -----------------------------------------------
      CHARACTER TYPE*1,CH1*1,CH2*2,CH4*4,CH3*3
      CHARACTER NAME(N_NAME)*2
      CHARACTER ACODE3(32)*3
      INTEGER   NCODE_RES
      CHARACTER BCODE3(12)*3
      INTEGER   NCODE_BAS
C ----
      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
     *          'HG','AL','GD','NA','CD','NI','SR','IN','HO','YB',
     *          'TE','LI','RB','BA','CS','SM','TL','PT','BE','SE',
     *          'MO','SI','I ','NE','AR','SC','TI','CR','GA','GE',
     *          'AS','KR','HE','ZR','NB','TC','RU','RH','PD','AG',
     *          'SN','SB','XE','LA','HF','TA','RE','OS','IR','AU',
     *          'BI','PO','AT','RN','FR','RA','AC','CE','PR','ND',
     *          'PM','EU','TB','DY','ER','TM','LU','TH','PA','NP',
     *          'PU','AM','CM','BK','CF','ES','FM','MD','NO','LR',
     *          'K ','V ','Y ','U ','W '                          /
C 
C ---
      DATA      NCODE_RES/32/
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','ASX','GLX','ACD','PCA' 
     *           ,'HYP','INI','FOR','IVA','DFO','NME','ACD','PCA'/
C ---
      DATA      NCODE_BAS/12/
      DATA BCODE3/'A  ','C  ','G  ','T  ','U  ','PSU','1MG','YG ' 
     *           ,'+A ','+C ','+G ','+T '/
C ---------------------------------------------
C --------------------
      IF(RNAME(1:1).EQ.' ') THEN
        RNAME=RNAME(2:3)//' '
        IF(RNAME(1:1).EQ.' ') RNAME=RNAME(2:3)//' '
      ENDIF
      IF(RNAME.EQ.'WAT') RNAME='HOH'
      IF(RNAME.EQ.'DOD') RNAME='HOH'
      IF(RNAME.EQ.'CYT') RNAME='C'
      IF(RNAME.EQ.'ADE') RNAME='A'
      IF(RNAME.EQ.'THY') RNAME='T'
      IF(RNAME.EQ.'GUA') RNAME='G'
      IF(RNAME.EQ.'URI') RNAME='U'
      IF(RNAME.EQ.'DC')  RNAME='C'
      IF(RNAME.EQ.'DA')  RNAME='A'
      IF(RNAME.EQ.'DT')  RNAME='T'
      IF(RNAME.EQ.'DG')  RNAME='G'

      IF(RNAME(1:1).EQ.'''') RNAME(1:1)='*'
      IF(RNAME(2:2).EQ.'''') RNAME(2:2)='*'
      IF(RNAME(3:3).EQ.'''') RNAME(3:3)='*'
      IPROT=0
      DO  I=1,NCODE_RES
        IF(ACODE3(I).EQ.RNAME) THEN
          IPROT=1
          GO TO 200
        ENDIF
      ENDDO
      IDNA=0
      DO  I=1,NCODE_BAS
        IF(BCODE3(I).EQ.RNAME) THEN
          IDNA=1
          GO TO 200
        ENDIF
      ENDDO
 200  CONTINUE
C -----------------------------------
      IF(ANAME(1:1).NE.' ') THEN

        CH1 = ANAME(1:1)
        CALL CHKSMB(CH1,TYPE)

        IF(TYPE.EQ.'D') THEN

          CALL LENSTR_BL(ANAME,LN)
          IF(LN.LE.1) THEN
            LN         = 2
            ANAME(2:2) = 'H'
          ENDIF
          ASYMB     = ANAME(2:2)//'   '
          CH4       = '    '
          CH4(1:LN) = ANAME(2:LN)//CH1
          ANAME     = CH4
C         CTYPE='H   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '

        ELSE IF(ANAME(4:4).EQ.' ') THEN

          CH2 = ANAME(1:2)
          IF(IPROT.EQ.0) THEN
            DO  I=1,N_NAME
              IF(NAME(I).EQ.CH2) THEN
                ASYMB = ANAME(1:2)//'  '
                CTYPE = '$   '
                GO TO 100
              ENDIF
            ENDDO
          ENDIF
          ASYMB = ANAME(1:1)//'   '
          CTYPE = 'C   '
          IF(ASYMB(1:1).EQ.'H') CTYPE = 'H   '
  100     CONTINUE

        ELSE
          ASYMB = ANAME(2:2)//'   '
          IF(RNAME.EQ.'IUM') THEN
            CTYPE = '$   '
            ASYMB = ANAME(1:2)//'  '
          ELSE
            CTYPE = 'C   '
            ASYMB = ANAME(2:2)//'   '
            IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
          ENDIF
        ENDIF  
      ELSE
        IF(RNAME.EQ.'IUM') THEN
          CTYPE = '$   '
          ASYMB = ANAME(2:3)//'  '
          CH1   = ANAME(3:3)
          CALL CHKSMB(CH1,TYPE)
          IF(CH1.EQ.'+'.OR.CH1.EQ.'-'.OR.TYPE.EQ.'D') ASYMB(2:2) = ' '
        ELSE
          ASYMB = ANAME(2:2)//'   '
          IF(ASYMB(1:1).EQ.'M') ASYMB='C   '
          IF(ASYMB(1:1).EQ.'C'.OR.ASYMB(1:1).EQ.'N'.OR.
     *       ASYMB(1:1).EQ.'O'.OR.ASYMB(1:1).EQ.'B'.OR.
     *       ASYMB(1:1).EQ.'F'                         ) THEN
            CTYPE = 'C   '
          ELSE
            CTYPE = '$   '
          ENDIF
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
        ENDIF
      ENDIF
      
      IF(ANAME(1:1).EQ.' ') THEN
        ANAME=ANAME(2:4)//' '
      ENDIF
      IF(ANAME(2:2).EQ.' ') THEN
        ANAME(2:4)=ANAME(3:4)//' '
        IF(ANAME(2:2).EQ.' ') ANAME(2:4)=ANAME(3:4)//' '
      ENDIF
      IF(ANAME(1:1).EQ.'''') ANAME(1:1)='*'
      IF(ANAME(2:2).EQ.'''') ANAME(2:2)='*'
      IF(ANAME(3:3).EQ.'''') ANAME(3:3)='*'
      IF(ANAME(4:4).EQ.'''') ANAME(4:4)='*'

      IF(ANAME.EQ.'H0  ') THEN
        ANAME    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ASYMB.EQ.'D  ') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH11') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH12') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HT1 ') THEN
        ANAME    = 'H1  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT2 ') THEN
        ANAME    = 'H2  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT3 ') THEN
        ANAME    = 'H3  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF

      IF(RNAME.EQ.'HOH') THEN
        IF(ASYMB(1:1).EQ.'O') THEN
          ANAME = 'O   '
          ASYMB = 'O   '
          CTYPE = 'C   '
        ELSE IF(ASYMB(1:1).EQ.'H'.OR.ASYMB(1:1).EQ.'D') THEN
          ASYMB = 'H   '
          CTYPE = 'H   '
        ELSE IF(ASYMB(1:1).EQ.'W') THEN
          ANAME = 'O   '
          ASYMB = 'O   '
          CTYPE = 'C   '
        ENDIF
      ENDIF
C ---  special cases ---
      IF(RNAME.EQ.'IUM'.AND.CTYPE.EQ.'$   ') THEN
        RNAME = ANAME(1:2)
      ENDIF

      RETURN
      END

C -I-
      SUBROUTINE READPDB_C(MDOC,FILE,ISYM,IPRSYM
     *  ,STR_TITLE,STR_DATE,RESULT,IPRROW,IPRMAX,PDB,FILE_O
     *  ,N_SPGR,N_SETT,CELL_I,IERR)
C --------------------------------------------------------------
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE*(*),FILE_O*(*),PDB*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,IPRMAX)
      REAL      CELL_I(6)
C ----------------------
      CHARACTER   EXT*80,PATH*1,LINE*80
      CHARACTER   STR_TITLE*40,STR_DATE*9
C ---
      REAL      R4
      INTEGER*4 IEND
      CHARACTER REC*6,CH7*7,NCSF*1,GID*4,NAME*256,CH16*16
      CHARACTER MODE*4,CH1*1,CHAR1*1,CH2*2,CH4*4
      EQUIVALENCE (R4,CH4)
C -----------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      COMMON/COM_PDB_B/ NBAV,BAVER,NO_SPGR,CELL
      REAL              CELL(6)
C ---------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB/   CR_TEMPER   ,CR_WAVEL
     *                 ,CR_RES_MIN  ,CR_RES_MAX 
     *                 ,CR_RFAC_ALL ,CR_RFAC_OBS
     *                 ,CR_SIGMA_I  ,CR_SIGMA_F 
     *                 ,CR_CD_NDB   ,CR_CD_CSD
     *                 ,CR_DATE_NDB ,CR_DATE_CREAT
     *                 ,CR_PROGRAM  ,CR_METHOD
      REAL  CR_TEMPER
      REAL  CR_WAVEL
      REAL  CR_RES_MIN
      REAL  CR_RES_MAX 
      REAL  CR_RFAC_ALL
      REAL  CR_RFAC_OBS
      REAL  CR_SIGMA_I
      REAL  CR_SIGMA_F 
      CHARACTER CR_CD_NDB    *8
      CHARACTER CR_CD_CSD    *8
      CHARACTER CR_DATE_NDB  *10
      CHARACTER CR_DATE_CREAT*20
      CHARACTER CR_PROGRAM   *40
      CHARACTER CR_METHOD    *40
C -----------------------------------------------
C   CR_TEMPER        CR_WAVEL
C   CR_RES_MIN       CR_RES_MAX 
C   CR_RFAC_ALL      CR_RFAC_OBS
C   CR_SIGMA_I       CR_SIGMA_F 
C   CR_CD_NDB        CR_CD_CSD
C   CR_DATE_NDB      CR_DATE_CREAT
C   CR_PROGRAM       CR_METHOD
C ----------------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB_2/   CR_RFAC_CUT  ,CR_NMODEL   ,CR_RMEGR_ALL
     *                   ,CR_RES_RMIN  ,CR_RES_RMAX ,CR_RMEGR_OBS
     *                   ,CR_SIGMAR_I,CR_SIGMAR_F 
     *                   ,CR_RMERG_IOBS
     *                   ,CR_RFREE_ALL ,CR_RFREE_OBS,CR_RFREE_CUT
     *                   ,CR_DPI,CR_ERR_CRD_MIN     ,CR_ERR_CRD_MAX
     *                   ,CR_NDB_TITLE ,CR_NDB_NAME 
     *                   ,CR_INFO_FLAG
      REAL  CR_DPI
      REAL  CR_ERR_CRD_MIN
      REAL  CR_ERR_CRD_MAX
      REAL  CR_RMEGR_ALL
      REAL  CR_RMERG_OBS,CR_RMERG_IOBS
      REAL  CR_RES_RMIN
      REAL  CR_RES_RMAX 
      REAL  CR_SIGMAR_I
      REAL  CR_SIGMAR_F 
      REAL  CR_RFAC_CUT
      REAL  CR_RFREE_OBS
      REAL  CR_RFREE_ALL
      REAL  CR_RFREE_CAT
      INTEGER CR_NMODEL
      CHARACTER CR_NDB_TITLE  *80
      CHARACTER CR_NDB_NAME  *80
      CHARACTER CR_INFO_FLAG *1
C ------------------------------------------
      COMMON /CRDPDB_3/ CR_NREF_REP
      INTEGER CR_NREF_REP
C -----------------
C    CR_RFAC_CUT  
C    CR_NMODEL
C    CR_RMEGR_ALL
C    CR_RMERG_OBS
C    CR_RMERG_IOBS
C    CR_RES_RMIN  
C    CR_RES_RMAX 
C    CR_RFREE_ALL 
C    CR_FREE_OBS
C    CR_FREE_CUT
C    CR_DPI
C    CR_ERR_CRD_MIN
C    CR_ERR_CRD_MAX
C    CR_NDB_TITLE 
C    CR_NDB_NAME
C    CR_INFO_FLAG
C ----------------------------------------------------------------
      IERR=0
      M=99
      MD=-ABS(MDOC)-1
      CALL LENSTR_BL(FILE,LEN)
      IF(LEN.LT.1.OR.FILE(1:1).EQ.','.OR.FILE(1:1).EQ.' ') THEN
        CALL MSGERR(MD,' ERR: WRONG NAME OF INPUT_FILE')
        IERR=1
        RETURN
      ENDIF
c      LN=LEN
c      DO I=LEN,1,-1
c        IF(FILE(I:I).EQ.','.OR.FILE(I:I).EQ.' ') THEN
c          LN=LN-1
c        ENDIF
c      ENDDO
c      NAME=FILE(1:LN)
c      FILE = NAME
c      LEN  = LN
      CALL CORR_NAME_ALL(FILE)
      CALL LENSTR_BL(FILE,LEN)
C --
      EXT = ' '
      LN  = 0
      DO I=LEN,1,-1
        IF(FILE(I:I).EQ.'.') GO TO 300
        LN = LN+1
      ENDDO
      LN = 0
 300  CONTINUE
      IF(LN.GT.0) THEN
        L1   = LEN-LN+1
        L2   = LEN-LN-1
        EXT  = FILE(L1:LEN)
        NAME = FILE(1:L2)
        FILE = NAME
      ENDIF
      IOUT= 11
      CALL LENSTR_BL(FILE_O,LEN)
      IF(LEN.LT.1.OR.FILE_O(1:1).EQ.','.OR.FILE_O(1:1).EQ.' ') THEN
        IOUT=0
      ENDIF
C --------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      IN  = 10
      PATH=' '
C --------
      CP_PASS=0
      NCS=0
      CALL SET_NCS(MDOC,NCMAX,NCS,CP_NSCALE,CP_NV,IERR)
      IF(IERR.NE.0) RETURN
      IGR  =0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
      NCHAIN  =0
      CP_NAN  =0
      CR_NREF_REP=0
      NO_SPGR=N_SPGR
      CELL(1)=CELL_I(1)
      CELL(2)=CELL_I(2)
      CELL(3)=CELL_I(3)
      CELL(4)=CELL_I(4)
      CELL(5)=CELL_I(5)
      CELL(6)=CELL_I(6)
C --------------------------------------------------------------
 400  CONTINUE
      CP_PASS=CP_PASS+1

C      EXT ='pdb'
      CALL OPENFR(IN,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT_FILE')
        RETURN
      ENDIF
C ---
C -------------------
      IFIRST=0
      IERR=0
      JERR=0
      KERR=0
      REC='START '
      IR       =0
      CH7='???????'
      CP_PNUM_OLD='???????'
      CH1='N'
      CH2='??'
      NA  =0
      NBAV=0
      BAVER=0.0
      NRES_TOT=0
      NHATOM=0
      NAHOH=0
      FLAG_CR='N'
      FLAG_SC='N'
      FLAG_MT='N'
      CP_BTYPE='I'
C -------------------
  100 CONTINUE
      CALL GETREC_C(MDOC,IN,REC,IERR,IEND)
      IF(IERR.NE.0) GO TO 600

      IF(IEND.NE.0) GO TO 200

      IF(REC.EQ.'ATOM  ') THEN
        IF(CP_PNUM.NE.CH7) THEN
          IF(CP_PNUM(1:2).NE.CH2) THEN
C v--- 11.01.97
c ---            READ(CP_PNUM(3:6),'(I4)') IR
c ---            IR=IR-1
C ^--- 11.01.97
            IF(CP_ICH.LT.NMAX) CP_ICH=CP_ICH+1
            CH2=CP_PNUM(1:2)
C --
            IF(CP_PASS.EQ.1) THEN
              IF(NCHAIN.LE.NMAX) THEN
                NCHAIN=NCHAIN+1
                IGR   =NCHAIN
                ICH   =IGR
                IGOLD =IGR
                ICHOLD=IGR
                INC=0
                MLT=0
                IATM=0
                NCSF='Y'
                GID='    '
                GID(1:2)=CH2
                CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
                IF(IERR.NE.0) GO TO 600
              ENDIF
            ENDIF
C --
          ENDIF
C v--- 11.01.97
C---          IR =IR+1
          READ(CP_PNUM(3:6),'(I4)') IR
C ^--- 11.01.97
          NRES_TOT = NRES_TOT+1
        ENDIF
        CP_IRES  = IR
        NA       = NA+1

        CALL CP_CRD_C(MDOC,IOUT,IFIRST,FILE_O,NAHOH,NHATOM,NA
     *  ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 600

        CH7=CP_PNUM
        CP_PNUM_OLD=CP_PNUM
      ENDIF
      KERR=JERR
      GO TO 100
C --------------------
  200 CONTINUE
      CLOSE(IN)
      IEND=1
      IMODE=0     
      IF(CP_PASS.EQ.2.AND.IOUT.GT.0) THEN
        CALL WRCRD(M,IOUT,IMODE,IEND,IERR)
      ENDIF
C ---
      IF(CP_PASS.EQ.1) THEN
        NCS=0
        CALL GET_NCS(MDOC,NCMAX,NCS,CP_NSCALE,CP_NV,IERR)
        IF(IERR.NE.0) GO TO 600
        IGR=0
        CALL GET_ASYMM(MDOC,NMAX,NGRT,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 600
        IF(NCS.GT.0.AND.CP_IGIVEN.EQ.0) THEN
          JGR=NGRT
          DO I=1,NGRT
            IGR=I
            CALL GET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) GO TO 600
            DO J=1,NCS
              INC=J
              NCSF='N'               
              JGR   =JGR+1
              ICHOLD=ICH
              IGOLD =JGR
              CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,JGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) GO TO 600
            ENDDO
          ENDDO
        ENDIF
      ENDIF
C ----
      IF(CP_PASS.EQ.1) GO TO 400
c      IF(IOUT.GT.0) THEN
c        END FILE IOUT
c        CLOSE(IOUT) 
c      ENDIF
C --------------------------------------------------------
      IF(NBAV.GT.0) BAVER=BAVER/NBAV

      CR_INFO_FLAG='P'
      WRITE(LINE,'('' PDB_code : '',A4)') CP_CODE
      CALL MSGDOC(MDOC,LINE)

      IF(CP_NDBCODE(1:1).NE.'?') CR_CD_NDB = CP_NDBCODE
         
      IF((CR_INFO_FLAG.EQ.'N').OR.(CR_CD_NDB(1:1).NE.'?')) THEN
        WRITE(LINE,'('' NDB_code : '',A)') CR_CD_NDB
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      CH4=CP_CODE
      RESULT(1,1)=R4

      CH4=CR_CD_NDB(1:4)
      RESULT(2,1)=R4
      CH4=CR_CD_NDB(5:8)
      RESULT(2,2)=R4

      RESULT(1,2)=NA
      RESULT(1,3)=NAHOH
      RESULT(1,6)=CP_CELL(1)
      RESULT(1,7)=CP_CELL(2)
      RESULT(1,8)=CP_CELL(3)
      CP_CELL(4)=(CP_CELL(4)*180.0)/PI
      CP_CELL(5)=(CP_CELL(5)*180.0)/PI
      CP_CELL(6)=(CP_CELL(6)*180.0)/PI
      RESULT(1,9)  =CP_CELL(4)
      RESULT(1,10) =CP_CELL(5)
      RESULT(1,11) =CP_CELL(6)
      IF(IPRROW.GE.20) THEN
        CH4=CP_SPGR(1:4)
        RESULT(1,12)=R4
        CH4=CP_SPGR(5:8)
        RESULT(1,13)=R4
        CH4=CP_SPGR(9:11)//' '
        RESULT(1,14)=R4
        RESULT(1,15)=NHATOM
        RESULT(1,16)=NCHAIN
        RESULT(1,17)=NCS
        RESULT(1,18)=CP_IGIVEN
        RESULT(1,19)=NRES_TOT
        RESULT(1,20)=BAVER
      ENDIF
      WRITE(LINE,'('' Cell: '',3F9.2,3F7.2)') 
     *  RESULT(1,6),RESULT(1,7),RESULT(1,8),RESULT(1,9)
     * ,RESULT(1,10),RESULT(1,11) 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Space group : '',A)') CP_SPGR 
      CALL MSGDOC(MDOC,LINE)
      IF(CP_RESL(1:1).NE.'.') THEN
        IF(CP_RESL(21:24).EQ.'ANGS') THEN
          CH16=CP_RESL(13:19)
          CALL WTODIG_PDB(CH16,F,I)
          RESULT(1,4)=F
          WRITE(LINE,'('' Resolution: '',A7)') CP_RESL(13:19) 
        ELSE
          CH16=CP_RESL(13:16)
          CALL WTODIG_PDB(CH16,F,I)
          RESULT(1,4)=F
          WRITE(LINE,'('' Resolution: '',A4)') CP_RESL(13:16) 
        ENDIF
        CALL MSGDOC(MDOC,LINE)
      ELSE
        RESULT(1,4)=0.0
      ENDIF
      IF(CP_RFAC(1:1).NE.'.') THEN
        CH16=CP_RFAC(30:34)
        CALL WTODIG_PDB(CH16,F,I)
        RESULT(1,5)=F
        WRITE(LINE,'('' R_factor  : '',A4)') CP_RFAC(30:35) 
        CALL MSGDOC(MDOC,LINE)
      ELSE
        RESULT(1,5)=0.0
      ENDIF

      WRITE(LINE,500) NA,NAHOH
  500 FORMAT(' Number of atoms:',I6,' ( ',I6,' water molecules)')
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,520) NCHAIN
  520 FORMAT(' Number of chains:',I6)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,521) NRES_TOT
  521 FORMAT(' Number of residues:',I6)
      CALL MSGDOC(MDOC,LINE)
      IF(NHATOM.GT.0) THEN
        WRITE(LINE,510) NHATOM
  510   FORMAT(' Number of H-atoms:',I6)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(NCS.GT.0) THEN
        WRITE(LINE,530) NCS
  530   FORMAT(' Number of NCS-operators:',I6)
        CALL MSGDOC(MDOC,LINE)
        IF(CP_IGIVEN.EQ.0) THEN
          CALL MSGDOC(MDOC,
     * '   use NCS-operators for to restore asymm. part of unit cell')
        ELSE
          CALL MSGDOC(MDOC,
     * '   PDB_file contents asymm. part of unit cell')
          CALL MSGDOC(MDOC,
     * '   NC-symmetry only for information')
        ENDIF
      ENDIF
      IF(NA.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: Number of atoms = 0')
        IERR=1
      ENDIF
      STR_DATE =CP_DATE
      STR_TITLE=CP_TITLE
      FILE=NAME




      CH4(1:1) = CR_INFO_FLAG
      CH4(2:4) = '   '
      RESULT(4,20)=R4
      WRITE(LINE,'('' info_code: '',A)') CR_INFO_FLAG
      CALL MSGDOC(MDOC,LINE)


        CR_NDB_TITLE=STR_TITLE
        CALL LENSTR_BL(CR_NDB_TITLE,LEN)
        IF(LEN.GT.76) LEN=76
        L=LEN
        IF(L.GT.0) THEN
          L=(L/4)*4+4
          IF(L.GT.76) L=76
          IF(L.GT.LEN) THEN
            DO I=LEN+1,L
              CR_NDB_TITLE(I:I)=' '
            ENDDO           
          ENDIF
          ILEN=L/4
          DO I=1,20
            CH4='    '
            RESULT(4,I)=R4
          ENDDO
          DO I=1,ILEN
            IS=(I-1)*4+1
            IF=IS+4
            CH4=CR_NDB_TITLE(IS:IF)
            RESULT(4,I)=R4
          ENDDO
        ENDIF

        CR_DATE_NDB=STR_DATE
        IF(CR_DATE_NDB(1:1).NE.'?'.AND.CR_DATE_NDB(1:1).NE.'.') THEN
          CH4=CR_DATE_NDB(1:4)
          RESULT(2,3)=R4
          CH4=CR_DATE_NDB(5:8)
          RESULT(2,4)=R4
          CH4(1:1)=CR_DATE_NDB(9:9)
          CH4(2:4)='   '
          RESULT(2,5)=R4
        ENDIF




C -----------------------------
C
C      RESULT(2,1)  - NDB_code(8)
C      RESULT(2,2)  - 
C      RESULT(2,3)  - CR_DATE_NDB(9)
C      RESULT(2,4)  - 
C      RESULT(2,5)  - 
C      RESULT(2,6)  - CR_RES_MIN
C      RESULT(2,7)  - CR_RES_MAX   
C      RESULT(2,8)  - CR_SIGMA_I
C      RESULT(2,9)  - CR_SIGMA_F
C      RESULT(2,10) - CR_TEMPER
C      RESULT(2,11) - CR_WAVEL
C      RESULT(2,12) - CR_RFAC_ALL
C      RESULT(2,13) - CR_RFAC_OBS 
C      RESULT(2,17) - 
C      RESULT(2,18) - 
C      RESULT(2,19) -
C
C      RESULT(3,1) - CR_PROGRAM
C      RESULT(3,2) 
C      RESULT(3,3)
C      RESULT(3,4)  
C      RESULT(3,5) - CR_RES_RMIN
C      RESULT(3,6) - CR_RES_RMAX
C      RESULT(3,7) - CR_RFAC_CUT
C      RESULT(3,8) - CR_RFREE_ALL  
C      RESULT(3,9) - CR_RFREE_OBS
C      RESULT(3,10)- CR_RFREE_CUT
C
C
C      RESULT(4,1-19)= NDB_TITLE(1:19)
C
C      RESULT(4,20) = info_flag 'N' - NDB, 'C' - BLANC , 'P' -PDB
C
C -----------------------------
C -------------------------------

      IF(CR_RES_MIN.GT.0.0.OR.CR_RES_MAX.GT.0.0) THEN
        RESULT(2,6) = CR_RES_MIN
        RESULT(2,7) = CR_RES_MAX   
        WRITE(LINE,'('' Resolution of data: '',2F8.3)') 
     *   CR_RES_MIN,CR_RES_MAX
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_SIGMA_I.GT.0.0) THEN
        RESULT(2,8) = CR_SIGMA_I
        WRITE(LINE,'('' Sigma cut_off (I): '',F8.3)') 
     *  CR_SIGMA_I
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_SIGMA_F.GT.0.0) THEN
        RESULT(2,9) = CR_SIGMA_F
        WRITE(LINE,'('' Sigma cut_off (F): '',F8.3)') 
     *  CR_SIGMA_F
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_TEMPER.GT.0.0) THEN
        RESULT(2,10) = CR_TEMPER
        WRITE(LINE,'('' Temperature: '',F8.3)') 
     *  CR_TEMPER
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_WAVEL.GT.0.0) THEN
        RESULT(2,11) = CR_WAVEL
        WRITE(LINE,'('' Radiation wavelength: '',F8.3)') 
     *  CR_WAVEL
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_RFAC_ALL.GT.0.0) THEN
        RESULT(2,12) = CR_RFAC_ALL
        WRITE(LINE,'('' R-factor_all: '',F8.3)') 
     *  CR_RFAC_ALL
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_RFAC_OBS.GT.0.0) THEN
        RESULT(2,13) = CR_RFAC_OBS
        WRITE(LINE,'('' R-factor_obs: '',F8.3)') 
     *  CR_RFAC_OBS
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C ----------------------
C      RESULT(3,1) - CR_PROGRAM
C      RESULT(3,2) 
C      RESULT(3,3)
C      RESULT(3,4)  
C      RESULT(3,5) - CR_RES_RMIN
C      RESULT(3,6) - CR_RES_RMAX
C      RESULT(3,7) - CR_RFAC_CUT
C      RESULT(3,8) - CR_RFREE_ALL  
C      RESULT(3,9) - CR_RFREE_OBS
C      RESULT(3,10)- CR_RFREE_CUT
C      RESULT(3,11)- CR_SIGMAR_I
C      RESULT(3,12)- CR_SIGMAR_F
C      RESULT(3,14)- CR_NREF_REP
C
      IF(CR_PROGRAM(1:1).NE.'?'.AND.CR_PROGRAM(1:1).NE.'.') THEN
        CALL LENSTR_BL(CR_PROGRAM,LEN)
        IF(LEN.GT.16) LEN=16
        IF(LEN.LE. 0) THEN
          CR_PROGRAM(1:1)='?'
          LEN=1
        ENDIF
        IF(LEN.LT.16) THEN
          DO I=LEN+1,16
            CR_PROGRAM(I:I)=' '
          ENDDO
        ENDIF
        CH4=CR_PROGRAM(1:4)
        RESULT(3,1)=R4
        CH4=CR_PROGRAM(5:8)
        RESULT(3,2)=R4
        CH4=CR_PROGRAM(9:12)
        RESULT(3,3)=R4
        CH4=CR_PROGRAM(13:16)
        RESULT(3,4)=R4
        WRITE(LINE,'('' Refinement program : '',A)')CR_PROGRAM(1:LEN) 
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(CR_RES_RMIN.GT.0.0.OR.CR_RES_RMAX.GT.0.0) THEN
        RESULT(3,5) = CR_RES_RMIN
        RESULT(3,6) = CR_RES_RMAX   
        WRITE(LINE,'('' Resolution for refinement: '',2F8.3)') 
     *   CR_RES_RMIN,CR_RES_RMAX
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(CR_RFAC_CUT.GT.0.0) THEN
        RESULT(3,7) = CR_RFAC_CUT
        WRITE(LINE,'('' R-factor_cut: '',F8.3)') 
     *  CR_RFAC_CUT
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(CR_RFREE_ALL.GT.0.0) THEN
        RESULT(3,8) = CR_RFREE_ALL
        WRITE(LINE,'('' Rfree_all: '',F8.3)') 
     *  CR_RFREE_ALL
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(CR_RFREE_OBS.GT.0.0) THEN
        RESULT(3,9) = CR_RFREE_OBS
        WRITE(LINE,'('' Rfree_obs: '',F8.3)') 
     *  CR_RFREE_OBS
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(CR_RFREE_CUT.GT.0.0) THEN
        RESULT(3,10) = CR_RFREE_CUT
        WRITE(LINE,'('' Rfree_cut: '',F8.3)') 
     *  CR_RFREE_CUT
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_SIGMAR_I.GT.0.0) THEN
        RESULT(3,11) = CR_SIGMAR_I
        WRITE(LINE,'('' Sigma cut_off(I) for refinement: '',F8.3)') 
     *  CR_SIGMAR_I
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_SIGMAR_F.GT.0.0) THEN
        RESULT(3,12) = CR_SIGMAR_F
        WRITE(LINE,'('' Sigma cut_off (F) for refinement: '',F8.3)') 
     *  CR_SIGMAR_F
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(CR_NREF_REP.GT.0) THEN
        RESULT(3,14) = CR_NREF_REP
        WRITE(LINE,'('' No. of Reflections: '',I8)') 
     *  CR_NREF_REP
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C -----------------------------

      RETURN
C --------------------
  600 CONTINUE
      IERR=1
      CLOSE(IN)
      IF(CP_PASS.EQ.2.AND.IOUT.GT.0) THEN
        END FILE IOUT
        CLOSE(IOUT) 
      ENDIF
      RETURN
      END

      SUBROUTINE GETREC_C(MDOC,IN,REC,IERR,IEND)
C -----------------------------------------------
      INTEGER*4 MDOC,IERR,IEND
      CHARACTER REC*6
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      COMMON/STTCREC/ ICEND,JEND,ICH0,STR
      INTEGER*4 ICEND,JEND,ICH0
      CHARACTER STR*80
C ---
      REAL      PI,CELL(6)
      INTEGER*4 M,IN
      CHARACTER LINE*80
C ----
      INCLUDE 'sfch_comt.fh'
C -----------------------------------
      IERR=0
      IEND=0
      IF(REC.EQ.'START ') THEN
C ---
        PI=4.0*ATAN(1.0)
        IF(CP_PASS.EQ.1) THEN
          CP_CELL(1)=1.0
          CP_CELL(2)=1.0
          CP_CELL(3)=1.0
          CP_CELL(4)=PI/2.0
          CP_CELL(5)=PI/2.0
          CP_CELL(6)=PI/2.0
          CP_SPGR   =' '
        ENDIF
        CP_IA       =0
        CP_IRES     =0
        CP_ICH      =0
        ICEND       =0
        ICH0        =-1
        ICOMPND     =0
        CP_OXT      ='N'
        CP_MODEL    =0
        CP_NAME='----'
        CP_DATE='XX-XXX-XX'
        CP_CODE='XXXX'
        CP_NDBCODE='?XXXXXXX'
        CP_TITLE='---'
        CP_RESL ='.'
        CP_RFAC ='.'
        IF(CP_PASS.EQ.1) THEN
          CP_NCS  = 0
          CP_IGIVEN=1
        ENDIF
        CALL GETLINE(IN,MDOC,STR,IERR,JEND)
        ICEND=JEND
        IF(IERR.NE.0.OR.JEND.NE.0) THEN
          IEND=JEND
          RETURN
        ENDIF
        REC         = ' '
        
      ENDIF
C -----
  100 CONTINUE
      LINE=STR   
      IEND=ICEND
      IF(IEND.NE.0) THEN
        RETURN
      ENDIF
      CALL GETLINE(IN,MDOC,STR,IERR,JEND)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF
      ICEND=JEND
      IF(JEND.NE.0) STR=' '

C     All the TITLE records are read (current record is not a TITLE record)
      IF (TITLE_FLAG.AND..NOT.TITLE_DONE.AND.TITLE_REC.AND.
     +     (LINE(1:5).NE.'TITLE')) TITLE_DONE = .TRUE.
C     All the COMPND records are read (current record is not a COMPND record)
      IF (TITLE_FLAG.AND..NOT.TITLE_DONE.AND..NOT.TITLE_REC.AND.
     +     (LINE(1:6).NE.'COMPND')) TITLE_DONE = .TRUE.
         

      IF(LINE(1:6).EQ.'HEADER') THEN
        CALL RDHEAD_C(LINE)
        GO TO 100        
      ELSE IF(LINE(1:6).EQ.'COMPND') THEN
        ICOMPND = ICOMPND + 1
C     This is possibly the first TITLE record
        IF (.NOT.TITLE_FLAG) THEN
C          Yes, it is
           NLTITLE = 0
           TITLE_FLAG = .TRUE.
           TITLE_DONE = .FALSE.
           TITLE_REC = .FALSE.
        ENDIF
c        IF(ICOMPND.EQ.1) CALL RDCOMPND_C(LINE)
        CALL RDCOMPND_C(MODC,LINE)
        GO TO 100
      ELSE IF(LINE(1:5).EQ.'TITLE') THEN
        ICOMPND = ICOMPND + 1
C     This is possibly the first TITLE record
        IF (.NOT.TITLE_FLAG) THEN
C          Yes, it is
           NLTITLE = 0
           TITLE_FLAG = .TRUE.
           TITLE_DONE = .FALSE.
           TITLE_REC = .TRUE.
        ENDIF
        CALL RDTITLE_PDB_C(MDOC,LINE)
        GO TO 100
      ELSE IF(LINE(1:5).EQ.'DBREF') THEN
        CALL RDDBREF_C(LINE)
        GO TO 100
      ELSE IF(LINE(1:4).EQ.'CRYS') THEN
        CALL RDCRYST1_C(LINE)
        FLAG_CR='Y'
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'MODEL ') THEN
        CALL RDMODEL_C(LINE,MODEL)
        IF(MODEL.GT.1) ICEND=1
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'HET   ') THEN
        CALL RDHET_C(LINE)
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'FORMUL') THEN
        CALL RDFORMUL_C(LINE)
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'REMARK') THEN
        CALL RDREMARK_C(LINE)
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'SCALE1'.OR.
     *        LINE(1:6).EQ.'SCALE2'.OR.
     *        LINE(1:6).EQ.'SCALE3') THEN
        CALL RDSCALE_C(LINE)
        FLAG_SC='Y'
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'MTRIX1'.OR.
     *        LINE(1:6).EQ.'MTRIX2'.OR.
     *        LINE(1:6).EQ.'MTRIX3') THEN
        CALL RDMTRIX_C(MDOC,LINE,IERR)
        IF(IERR.NE.0) RETURN
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'TER   ') THEN
        REC='TER   '
      ELSE IF(LINE(1:6).EQ.'CONECT') THEN
        CALL RDCONECT_C(MDOC,LINE,IERR)
        REC='CONECT'
      ELSE IF(LINE(1:6).EQ.'SSBOND') THEN
        CALL RDSSBOND_C(MDOC,LINE,IERR)
        REC='USER_L'
      ELSE IF((LINE(1:6).EQ.'ATOM  ').OR. 
     *        (LINE(1:6).EQ.'HETATM')) THEN
        CALL RDATOM_C(MDOC,LINE,REC,ICH0)
        REC='ATOM  '
        IF((STR(1:6).EQ.'SIGATM').OR.          
     *     (STR(1:6).EQ.'ANISOU').OR.          
     *     (STR(1:6).EQ.'USER_G').OR.          
     *     (STR(1:6).EQ.'SIGUIJ')) GO TO 100
      ELSE IF(LINE(1:6).EQ.'ANISOU') THEN
        CALL RDANISO_C(LINE)
        IF((STR(1:6).EQ.'SIGATM').OR.          
     *     (STR(1:6).EQ.'USER_G').OR.          
     *     (STR(1:6).EQ.'SIGUIJ')) GO TO 100
        REC='ATOM  '
      ELSE IF(LINE(1:6).EQ.'SIGATM') THEN
        CALL RDSIGAT_C(LINE)
        IF((STR(1:6).EQ.'ANISOU').OR.          
     *     (STR(1:6).EQ.'USER_G').OR.          
     *     (STR(1:6).EQ.'SIGUIJ')) GO TO 100
        REC='ATOM  '
      ELSE IF(LINE(1:6).EQ.'SIGUIJ') THEN
        CALL RDSIGUIJ_C(LINE)
        IF((STR(1:6).EQ.'SIGATM').OR.          
     *     (STR(1:6).EQ.'USER_G').OR.          
     *     (STR(1:6).EQ.'ANISOU')) GO TO 100          
        REC='ATOM  '
      ELSE
        GO TO 100
      ENDIF
      RETURN
C -----------------------------------
      END    

      SUBROUTINE RDATOM_C(MDOC,LINE,REC,ICH0)
C -------------------------------------------------------
C     RDATOM - reads record ATOM/HETATOM from PDB_file.
C 
C -------------------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8,ACODE*4
      CHARACTER TYPE1*1,TYPE2*1
C --------------------------------------------------------------
      CHARACTER LINE*(*),REC*(*)
      INTEGER*4 ICH0
C -----------------------------------
      INTEGER*4 IA
      CHARACTER PNUM*7
      CHARACTER FRMT*80,ANAME*4,RNAME*3,ASYMB*4,CTYPE*4
      DATA FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/
c     DATA FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2)'/
C ------------------------------------
      ASYMB='    '
      READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,ACODE
      CALL LENSTR_BL(LINE,LEN_INPUT)

      IF(RNAME.EQ.'   ') THEN
        CALL MSGERR(MDOC,
     * ' WARNING: residue name is empty, default is "HOH"')
        RNAME='HOH'
      ENDIF

      CP_IA=IA
      IF(CP_CORR.EQ.' ') CP_CORR='.'
      IF(CP_ALT .EQ.' ') CP_ALT ='.'

      IF(CP_OCC.GT.1.0) THEN
        IF(FLAG_MT.EQ.'N') THEN
          IF(CP_PASS.EQ.1) THEN
            CALL MSGERR(MDOC,' WARNING: occupancy > 1.0')
          ENDIF
          FLAG_MT='Y'
        ENDIF 
        CP_OCC=1.0
      ENDIF



      CALL CORR_NAME_C(ANAME,RNAME,ASYMB,CTYPE)
      CP_ANAME=ANAME
      CP_ASYMB=ASYMB
      CP_ATYPE=CTYPE

      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)
      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN_INPUT.GE.77) THEN
        IF(LEN_INPUT.GE.80) THEN
          CALL CHKSMB(ACODE(3:3),TYPE1)
          CALL CHKSMB(ACODE(4:4),TYPE2)
          IF(TYPE2.EQ.'S'.AND.TYPE1.EQ.'D') THEN         
            TYPE1      = ACODE(3:3)
            ACODE(3:3) = ACODE(4:4)
            ACODE(4:4) = TYPE1 
          ENDIF 
          CALL CHKSMB(ACODE(3:3),TYPE1)
          CALL CHKSMB(ACODE(4:4),TYPE2)
          IF(TYPE1.EQ.'S'.AND.TYPE2.EQ.'D') THEN         
            IF(ACODE(4:4).EQ.'0') THEN
              ACODE(3:3) = ' '
              ACODE(4:4) = ' ' 
            ENDIF
          ENDIF 
        ENDIF
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        CALL CHKSMB(ACODE(1:1),TYPE1)
        IF(TYPE1.EQ.'D'.OR.TYPE1.EQ.'B') ACODE = ' '
C       ASYMB = ACODE
        IT = 1
C
C       IT = 1  convert symbols to upper case.
C                   
        CALL CHECK_LINE(IT,ACODE)
         
      ELSE
        ACODE = ' '
      ENDIF

      IF(ACODE.NE.' ') THEN
        CALL CHKSMB(CP_ASYMB(2:2),TYPE1)
        IF(TYPE1.EQ.'D'.OR.TYPE1.EQ.'S') CP_ASYMB(2:2) = ' '
        CP_ASYMB(3:3) = ' '
        CP_ASYMB(4:4) = ' '
        CALL CHKSMB(ACODE(2:2),TYPE1) 
        IF(TYPE1.EQ.'D'.OR.TYPE1.EQ.'S') ACODE(2:2) = ' '
        ACODE(3:3) = ' '
        ACODE(4:4) = ' '
        IF(ACODE.NE.CP_ASYMB) CP_ASYMB = ACODE
      ENDIF

      CP_BTYPE='I'
      PNUM(1:1)=PNUM(2:2)
      PNUM(2:2)= ' '

      IF(REC(1:6).NE.LINE(1:6).AND.REC(1:6).NE.'ATOM  ') THEN

        ICH0=ICH0+1
        IF(ICH0.GT.9) ICH0=0
        CP_OXT='N'

      ELSE IF(LINE(1:6).EQ.'HETATM'.AND.
     *     CP_PNUM(3:7).NE.PNUM(3:7))THEN
  
        IF(RNAME.NE.'HOH'.OR.CP_RNAME.NE.RNAME) THEN
          ICH0=ICH0+1
          IF(ICH0.GT.9) ICH0=0
        ENDIF
        CP_OXT='N'

      ELSE IF(LINE(1:6).EQ.'ATOM  '.AND.REC(1:6).EQ.'ATOM  '.AND.
     *     CP_PNUM(3:7).NE.PNUM(3:7).AND.CP_OXT.EQ.'Y')THEN
        ICH0=ICH0+1
        IF(ICH0.GT.9) ICH0=0
        CP_OXT='N'
      ELSE

        IF(RNAME.EQ.'HOH'.AND.CP_RNAME.NE.RNAME) THEN
          ICH0=ICH0+1
          IF(ICH0.GT.9) ICH0=0
          CP_OXT='N'
        ENDIF

      ENDIF

      CP_RNAME=RNAME
      
      WRITE(PNUM(2:2),'(I1)') ICH0
      IF(PNUM(2:2).EQ.'0'.AND.PNUM(1:1).NE.' ') PNUM(2:2)=' '
      CP_PNUM=PNUM

      IF(ANAME.EQ.'OXT ') CP_OXT='Y'
      RETURN
      END

      SUBROUTINE CORR_NAME_C(ANAME,RNAME,ASYMB,CTYPE)
C ----------------------------------------------
      PARAMETER (N_NAME = 95)
      CHARACTER ANAME*4,RNAME*3,ASYMB*4,CTYPE*4
C -----------------------------------------------
      CHARACTER TYPE*1,CH1*1,CH2*2,CH4*4
      CHARACTER NAME(N_NAME)*2
      CHARACTER ACODE3(32)*3
      INTEGER   NCODE_RES
      CHARACTER BCODE3(12)*3
      INTEGER   NCODE_BAS
C ----
      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
     *          'HG','AL','GD','NA','CD','NI','SR','IN','HO','YB',
     *          'TE','LI','RB','BA','CS','SM','TL','PT','BE','SE',
     *          'MO','SI','I ','NE','AR','SC','TI','CR','GA','GE',
     *          'AS','KR','HE','ZR','NB','TC','RU','RH','PD','AG',
     *          'SN','SB','XE','LA','HF','TA','RE','OS','IR','AU',
     *          'BI','PO','AT','RN','FR','RA','AC','CE','PR','ND',
     *          'PM','EU','TB','DY','ER','TM','LU','TH','PA','NP',
     *          'PU','AM','CM','BK','CF','ES','FM','MD','NO','LR',
     *          'K ','V ','Y ','U ','W '                          /
C ----
      DATA      NCODE_RES/32/
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','ASX','GLX','ACD','PCA' 
     *           ,'HYP','INI','FOR','IVA','DFO','NME','ACD','PCA'/
C ----
      DATA      NCODE_BAS/12/
      DATA BCODE3/'A  ','C  ','G  ','T  ','U  ','PSU','1MG','YG ' 
     *           ,'+A ','+C ','+G ','+T '/
C ---------------------------------------------
C ---------------------------------------------
C ---
      IF(RNAME(1:1).EQ.' ') THEN
        RNAME=RNAME(2:3)//' '
        IF(RNAME(1:1).EQ.' ') RNAME=RNAME(2:3)//' '
      ENDIF
      IF(RNAME.EQ.'WAT') RNAME='HOH'
      IF(RNAME.EQ.'DOD') RNAME='HOH'
      IF(RNAME.EQ.'CYT') RNAME='C'
      IF(RNAME.EQ.'ADE') RNAME='A'
      IF(RNAME.EQ.'THY') RNAME='T'
      IF(RNAME.EQ.'GUA') RNAME='G'
      IF(RNAME.EQ.'URI') RNAME='U'
      IF(RNAME.EQ.'DC')  RNAME='C'
      IF(RNAME.EQ.'DA')  RNAME='A'
      IF(RNAME.EQ.'DT')  RNAME='T'
      IF(RNAME.EQ.'DG')  RNAME='G'

      IF(RNAME(1:1).EQ.'''') RNAME(1:1)='*'
      IF(RNAME(2:2).EQ.'''') RNAME(2:2)='*'
      IF(RNAME(3:3).EQ.'''') RNAME(3:3)='*'

      IPROT=0
      DO  I=1,NCODE_RES
        IF(ACODE3(I).EQ.RNAME) THEN
          IPROT=1
          GO TO 200
        ENDIF
      ENDDO
      IDNA=0
      DO  I=1,NCODE_BAS
        IF(BCODE3(I).EQ.RNAME) THEN
          IDNA=1
          GO TO 200
        ENDIF
      ENDDO
 200  CONTINUE
C -----------------------------------
      IF(ANAME(1:1).NE.' ') THEN
        CH1=ANAME(1:1)
        CALL CHKSMB(CH1,TYPE)
        IF(TYPE.EQ.'D') THEN
          CALL LENSTR_BL(ANAME,LN)
          IF(LN.LE.1) THEN
            LN=2
            ANAME(2:2)='H'
          ENDIF
          ASYMB = ANAME(2:2)//'   '
          CH4='    '
          CH4(1:LN)=ANAME(2:LN)//CH1
          ANAME=CH4
C         CTYPE='H   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
        ELSE IF(ANAME(4:4).EQ.' ') THEN
          CH2=ANAME(1:2)
          DO  I=1,N_NAME
            IF(NAME(I).EQ.CH2) THEN
              ASYMB=ANAME(1:2)//'  '
              CTYPE='$   '
              GO TO 100
            ENDIF
          ENDDO
          ASYMB=ANAME(2:2)//'   '
          CTYPE='C   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
  100     CONTINUE
        ELSE
          IF(RNAME.EQ.'IUM') THEN
            CTYPE = '$   '
            ASYMB = ANAME(1:2)//'  '
          ELSE IF(ANAME(3:3).EQ.'-'.OR.ANAME(3:3).EQ.'+'.OR.
     *            ANAME(4:4).EQ.'-'.OR.ANAME(4:4).EQ.'+') THEN
            CTYPE = '$   '
            ASYMB = ANAME(1:2)//'  '
          ELSE
            CTYPE = 'C   '
            ASYMB = ANAME(2:2)//'   '
            IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
          ENDIF
        ENDIF  
      ELSE
        IF(RNAME.EQ.'IUM') THEN
          CTYPE = '$   '
          ASYMB = ANAME(2:3)//'  '
          CH1   = ANAME(3:3)
          CALL CHKSMB(CH1,TYPE)
          IF(CH1.EQ.'+'.OR.CH1.EQ.'-'.OR.TYPE.EQ.'D') ASYMB(2:2) = ' '
        ELSE
          ASYMB = ANAME(2:2)//'   '
          IF(ASYMB(1:1).EQ.'M') ASYMB='C   '
          IF(ASYMB(1:1).EQ.'C'.OR.ASYMB(1:1).EQ.'N'.OR.
     *       ASYMB(1:1).EQ.'O'.OR.ASYMB(1:1).EQ.'B'.OR.
     *       ASYMB(1:1).EQ.'F'                         ) THEN
            CTYPE = 'C   '
          ELSE
            CTYPE = '$   '
          ENDIF
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
        ENDIF
      ENDIF
      
      IF(ANAME(1:1).EQ.' ') THEN
        ANAME=ANAME(2:4)//' '
      ENDIF
      IF(ANAME(2:2).EQ.' ') THEN
        ANAME(2:4)=ANAME(3:4)//' '
        IF(ANAME(2:2).EQ.' ') ANAME(2:4)=ANAME(3:4)//' '
      ENDIF
      IF(ANAME(1:1).EQ.'''') ANAME(1:1)='*'
      IF(ANAME(2:2).EQ.'''') ANAME(2:2)='*'
      IF(ANAME(3:3).EQ.'''') ANAME(3:3)='*'
      IF(ANAME(4:4).EQ.'''') ANAME(4:4)='*'

      IF(ANAME.EQ.'H0  ') THEN
        ANAME    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ASYMB.EQ.'D  ') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH11') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH12') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HT1 ') THEN
        ANAME    = 'H1  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT2 ') THEN
        ANAME    = 'H2  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT3 ') THEN
        ANAME    = 'H3  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF

      IF(RNAME.EQ.'HOH') THEN
        IF(ASYMB(1:1).EQ.'O') THEN
          ANAME = 'O   '
          ASYMB = 'O   '
          CTYPE = 'C   '
        ELSE IF(ASYMB(1:1).EQ.'H'.OR.ASYMB(1:1).EQ.'D') THEN
          ASYMB = 'H   '
          CTYPE = 'H   '
        ELSE IF(ASYMB(1:1).EQ.'W') THEN
          ANAME = 'O   '
          ASYMB = 'O   '
          CTYPE = 'C   '
        ENDIF
      ENDIF
C ---  special cases ---
      IF(RNAME.EQ.'IUM'.AND.CTYPE.EQ.'$   ') THEN
        RNAME = ANAME(1:2)
      ENDIF

      RETURN
      END


      SUBROUTINE RDHEAD_C(LINE)
C -------------------------------------------------------
C     RDHEAD - reads record HEADER from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      CHARACTER FRMT*80,NAME_PDB*40,DATE_PDB*9,CD_PDB*4
      DATA FRMT/'(10X,A40,A9,3X,A4)'/
C ------------------------------------
      READ(LINE,FRMT) NAME_PDB,DATE_PDB,CD_PDB

      CALL LENSTR_BL(NAME_PDB,LEN)
      IF(LEN.LE.0) NAME_PDB='----'
      CALL LENSTR_BL(DATE_PDB,LEN)
      IF(LEN.LE.0) DATE_PDB='XX-XXX-XX'
      CALL LENSTR_BL(CD_PDB,LEN)
      IF(LEN.LE.0) CD_PDB='XXXX'

      CP_DATE = DATE_PDB
      CP_NAME = NAME_PDB
      CP_CODE = CD_PDB

      RETURN
      END

      SUBROUTINE RDCOMPND_C(MDOC,LINE)
C -------------------------------------------------------
C     RDCOMPND - reads record COMPND from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      CHARACTER FRMT*80,TITLE*68
C ------------------------------------
      INCLUDE 'sfch_comt.fh'
C ----
c      DATA FRMT/'(10X,A68)'/
      DATA FRMT/'(10X,A60)'/
C ------------------------------------
      READ(LINE,FRMT) TITLE

      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.LE.0) TITLE='---'

C      CP_TITLE = TITLE(1:40)
      IF (CP_TITLE(1:3) .EQ. '---') CP_TITLE = TITLE(1:40)

      IF (.NOT.TITLE_DONE.AND.TITLE_FLAG) THEN
         IF (LEN.GT.0) THEN
            NLTITLE = NLTITLE + 1
            IF (NLTITLE.GT.MAXNLTIT) THEN
               NLTITLE = MAXNLTIT
               TITLE_DONE = .TRUE.
               CALL MSGERR(MDOC,
     *         ' WARNING: not all the COMPND records kept')
            ELSE
               TITLINE(NLTITLE) = TITLE(1:LEN)
            ENDIF
         ENDIF
      ENDIF
         
      RETURN
      END

      SUBROUTINE RDTITLE_PDB_C(MDOC,LINE)
C -------------------------------------------------------
C     RDTITLE_PDB - reads record TITLE from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      CHARACTER FRMT*80,TITLE*68
C ------------------------------------
      INCLUDE 'sfch_comt.fh'
C ------------------------------------
c      DATA FRMT/'(10X,A68)'/
      DATA FRMT/'(10X,A60)'/
C ------------------------------------
C ----
      READ(LINE,FRMT) TITLE

      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.LE.0) TITLE='---'

C     CP_TITLE = TITLE(1:40)
      IF (CP_TITLE(1:3) .EQ. '---') CP_TITLE = TITLE(1:40)

      IF (.NOT.TITLE_DONE.AND.TITLE_FLAG) THEN
         IF (LEN.GT.0) THEN
            NLTITLE = NLTITLE + 1
            IF (NLTITLE.GT.MAXNLTIT) THEN
               NLTITLE = MAXNLTIT
               TITLE_DONE = .TRUE.
               CALL MSGERR(MDOC,
     *         ' WARNING: not all the TITLE records kept')
            ELSE
               TITLINE(NLTITLE) = TITLE(1:LEN)
            ENDIF
         ENDIF
      ENDIF
         
      RETURN
      END

      SUBROUTINE RDMODEL_C(LINE,MODEL)
C -------------------------------------------------------
C     RDMODEL - reads record MODEL from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ------------------------------------------------------
      CHARACTER FRMT*80
      DATA FRMT/'(10X,I4)'/
C ------------------------------------
      READ(LINE,FRMT) MODEL

      RETURN
      END

      SUBROUTINE RDREMARK_C(LINE)
C -------------------------------------------------------
C     RDREMARK - reads record REMARK from PDB_file.
C   
C -------------------------------------------------------
      CHARACTER LINE*(*)
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB/   CR_TEMPER   ,CR_WAVEL
     *                 ,CR_RES_MIN  ,CR_RES_MAX 
     *                 ,CR_RFAC_ALL ,CR_RFAC_OBS
     *                 ,CR_SIGMA_I  ,CR_SIGMA_F 
     *                 ,CR_CD_NDB   ,CR_CD_CSD
     *                 ,CR_DATE_NDB ,CR_DATE_CREAT
     *                 ,CR_PROGRAM  ,CR_METHOD
      REAL  CR_TEMPER
      REAL  CR_WAVEL   
      REAL  CR_RES_MIN
      REAL  CR_RES_MAX 
      REAL  CR_RFAC_ALL
      REAL  CR_RFAC_OBS
      REAL  CR_SIGMA_I
      REAL  CR_SIGMA_F 
      CHARACTER CR_CD_NDB    *8
      CHARACTER CR_CD_CSD    *8
      CHARACTER CR_DATE_NDB  *10
      CHARACTER CR_DATE_CREAT*20
      CHARACTER CR_PROGRAM   *40
      CHARACTER CR_METHOD    *40
C -----------------------------------------------
C   CR_TEMPER        CR_WAVEL
C   CR_RES_MIN       CR_RES_MAX 
C   CR_RFAC_ALL      CR_RFAC_OBS
C   CR_SIGMA_I       CR_SIGMA_F 
C   CR_CD_NDB        CR_CD_CSD
C   CR_DATE_NDB      CR_DATE_CREAT
C   CR_PROGRAM       CR_METHOD
C ----------------------------------------------------------------
C ---------------------------------------------------------
      COMMON /CRDPDB_2/   CR_RFAC_CUT  ,CR_NMODEL   ,CR_RMEGR_ALL
     *                   ,CR_RES_RMIN  ,CR_RES_RMAX ,CR_RMEGR_OBS
     *                   ,CR_SIGMAR_I,CR_SIGMAR_F 
     *                   ,CR_RMERG_IOBS
     *                   ,CR_RFREE_ALL ,CR_RFREE_OBS,CR_RFREE_CUT
     *                   ,CR_DPI,CR_ERR_CRD_MIN     ,CR_ERR_CRD_MAX
     *                   ,CR_NDB_TITLE ,CR_NDB_NAME 
     *                   ,CR_INFO_FLAG
      REAL  CR_DPI
      REAL  CR_ERR_CRD_MIN
      REAL  CR_ERR_CRD_MAX
      REAL  CR_RMEGR_ALL
      REAL  CR_RMERG_OBS,CR_RMERG_IOBS
      REAL  CR_RES_RMIN
      REAL  CR_RES_RMAX 
      REAL  CR_SIGMAR_I
      REAL  CR_SIGMAR_F 
      REAL  CR_RFAC_CUT
      REAL  CR_RFREE_OBS
      REAL  CR_RFREE_ALL
      REAL  CR_RFREE_CAT
      INTEGER CR_NMODEL
      CHARACTER CR_NDB_TITLE  *80
      CHARACTER CR_NDB_NAME  *80
      CHARACTER CR_INFO_FLAG *1
C ------------------------------------------
      COMMON /CRDPDB_3/ CR_NREF_REP
      INTEGER CR_NREF_REP
C -----------------------------------
      CHARACTER FRMT*80,CH36*36,CHAR*1,TYPE*1,CH16*16
      DATA FRMT/'(7X,I3,1X,A36)'/
C ------------------------------------
      CHAR=LINE(8:8)
      CALL CHKSMB(CHAR,TYPE)
      IF(TYPE.NE.'B'.AND.TYPE.NE.'D') GO TO 100
      CHAR=LINE(9:9)
      CALL CHKSMB(CHAR,TYPE)
      IF(TYPE.NE.'B'.AND.TYPE.NE.'D') GO TO 100
      CHAR=LINE(10:10)
      CALL CHKSMB(CHAR,TYPE)
      IF(TYPE.NE.'B'.AND.TYPE.NE.'D') GO TO 100

      IF(LINE(47:47).EQ.':'.OR.LINE(48:48).EQ.':'.OR.
     *   LINE(55:55).EQ.':'.OR.
     *   LINE(44:44).EQ.':'.OR.LINE(56:56).EQ.':'.OR.
     *   LINE(26:26).EQ.':'.OR.LINE(45:45).EQ.':') GO TO 200

      READ(LINE,FRMT,ERR=100) I,CH36

C123456789 123456789 123456789 123456789 123456789 123456789 1
C1234567123 123456789 123456789 123456789 123456 
CREMARK   2 RESOLUTION. 3    ANGSTROMS.
cREMARK   2 RESOLUTION. 2.50 ANGSTROMS.                                          
cREMARK   2 RESOLUTION.    1.93 ANGSTROMS. <--  NEW
CREMARK   3   R VALUE                    0.203 
CREMARK   3   FREE R VALUE               0.31
CREMARK   3   PROGRAM                    X-PLOR 

CREMARK   3   RESOLUTION RANGE        7. - 3.0  ANGSTROMS
CREMARK   3   DATA CUTOFF                3.0    SIGMA(F)
CREMARK   3   REJECTION CRITERIA                1.     SIGMA(I

      IF(I.EQ.2     .AND.CH36(1:10).EQ.'RESOLUTION') THEN
        CP_RESL    = CH36
      ELSE IF(I.EQ.3.AND.CH36(1:10).EQ.'  R VALUE ') THEN
        CP_RFAC    = CH36
        CH16=CH36(29:34)
        CALL WTODIG_PDB(CH16,F,I) 
        CR_RFAC_ALL=F
      ELSE IF(I.EQ.3.AND.CH36(1:10).EQ.'  FREE R V') THEN
        CH16=CH36(29:34)
        CALL WTODIG_PDB(CH16,F,I) 
        CR_RFREE_CUT=F
      ELSE IF(I.EQ.3.AND.CH36(1:10).EQ.'  PROGRAM ') THEN
        CR_PROGRAM   = LINE(41:61)
      ELSE IF(I.EQ.3.AND.CH36(1:23).EQ.'  NUMBER OF REFLECTIONS') THEN
         CH16  = CH36(29:34)
         CALL WTODIG_PDB(CH16,F,I)
         CR_NREF_REP=I
      ELSE IF(I.EQ.3.AND.CH36(1:10).EQ.'  DATA CUT') THEN
        CH16   = CH36(29:32)
        CALL WTODIG_PDB(CH16,F,I)
        IF(LINE(61:61).EQ.'I') THEN
          CR_SIGMAR_I=F
        ELSE
          CR_SIGMAR_F=F
        ENDIF
c      ELSE IF(I.EQ.3.AND.CH36(1:18).EQ.'  RESOLUTION RANGE') THEN
      ELSE IF(I.EQ.3.AND.CH36(1:18).EQ.'  RESOLUTION RANGE'
     *       .AND.CH36(30:30).EQ.'-') THEN
        CH16=CH36(25:29)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RES_RMIN=F
        CH16=CH36(31:35)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RES_RMAX=F
      ENDIF
   
      RETURN

 200  CONTINUE

C123456789 123456789 123456789 123456789 123456789 123456789
C1234567123 123456789 123456789 12345678
c
cREMARK 2 states the highest resolution, in Angstroms, that was used in building
cthe model. As with all the remarks, the first REMARK 2 record is empty and is
cused as a spacer.
C
CREMARK   2 RESOLUTION. 1.74 ANGSTROMS.
C
C Refinement using X-PLOR
C
cREMARK   3   PROGRAM     : X-PLOR X.X
cREMARK   3   RESOLUTION RANGE HIGH (ANGSTROMS) :
cREMARK   3   RESOLUTION RANGE LOW  (ANGSTROMS) :
cREMARK   3   DATA CUTOFF            (SIGMA(F)) :
cREMARK   3   NUMBER OF REFLECTIONS             :
cREMARK   3   R VALUE            (WORKING SET) :
cREMARK   3   FREE R VALUE                     :
c
c Refinement using NUCLSQ
c
cREMARK   3   PROGRAM     : NUCLSQ
cREMARK   3   RESOLUTION RANGE HIGH (ANGSTROMS) :
cREMARK   3   RESOLUTION RANGE LOW  (ANGSTROMS) :
cREMARK   3   DATA CUTOFF            (SIGMA(F)) :
cREMARK   3   NUMBER OF REFLECTIONS             :
cREMARK   3   R VALUE     (WORKING + TEST SET) :
cREMARK   3   R VALUE            (WORKING SET) :
cREMARK   3   R VALUE   (WORKING + TEST SET, NO CUTOFF) :
cREMARK   3   R VALUE          (WORKING SET, NO CUTOFF) :
cREMARK   3   FREE R VALUE                  (NO CUTOFF) :
cREMARK   3   FREE R VALUE TEST SET SIZE (%, NO CUTOFF) :
cREMARK   3   FREE R VALUE TEST SET COUNT   (NO CUTOFF) :
cREMARK   3   TOTAL NUMBER OF REFLECTIONS   (NO CUTOFF) :
C
C Refinement using PROLSQ
C
CREMARK   3   PROGRAM     : PROLSQ
CREMARK   3   RESOLUTION RANGE HIGH (ANGSTROMS) :
CREMARK   3   RESOLUTION RANGE LOW  (ANGSTROMS) :
CREMARK   3   DATA CUTOFF            (SIGMA(F)) :
CREMARK   3   NUMBER OF REFLECTIONS             :
CREMARK   3   R VALUE     (WORKING + TEST SET) :
CREMARK   3   R VALUE            (WORKING SET) :
CREMARK   3   FREE R VALUE                     :
CREMARK   3   R VALUE   (WORKING + TEST SET, NO CUTOFF) :
CREMARK   3   R VALUE          (WORKING SET, NO CUTOFF) :
CREMARK   3   FREE R VALUE                  (NO CUTOFF) :
CREMARK   3   TOTAL NUMBER OF REFLECTIONS   (NO CUTOFF) :
C
C Refinement using SHELXL-96
C
CREMARK   3  PROGRAM     : SHELXL-XX
CREMARK   3  RESOLUTION RANGE HIGH (ANGSTROMS) :
CREMARK   3  RESOLUTION RANGE LOW  (ANGSTROMS) :
CREMARK   3  DATA CUTOFF            (SIGMA(F)) :
CREMARK   3  R VALUE   (WORKING + TEST SET, NO CUTOFF) :
CREMARK   3  R VALUE          (WORKING SET, NO CUTOFF) :
CREMARK   3  FREE R VALUE                  (NO CUTOFF) :
CREMARK   3  TOTAL NUMBER OF REFLECTIONS   (NO CUTOFF) :
C
C Refinement using TNT
C
CREMARK   3   PROGRAM     : TNT XXX
CREMARK   3   RESOLUTION RANGE HIGH (ANGSTROMS) :
CREMARK   3   RESOLUTION RANGE LOW  (ANGSTROMS) :
CREMARK   3   DATA CUTOFF            (SIGMA(F)) :
CREMARK   3   NUMBER OF REFLECTIONS             :
CREMARK   3  USING DATA ABOVE SIGMA CUTOFF.
CREMARK   3   R VALUE     (WORKING + TEST SET) :
CREMARK   3   R VALUE            (WORKING SET) :
CREMARK   3   FREE R VALUE                     :
CREMARK   3  USING ALL DATA, NO SIGMA CUTOFF.
CREMARK   3   R VALUE   (WORKING + TEST SET, NO CUTOFF) :
CREMARK   3   R VALUE          (WORKING SET, NO CUTOFF) :
CREMARK   3   FREE R VALUE                  (NO CUTOFF) :
CREMARK   3   FREE R VALUE TEST SET SIZE (%, NO CUTOFF) :
CREMARK   3   FREE R VALUE TEST SET COUNT   (NO CUTOFF) :
CREMARK   3   TOTAL NUMBER OF REFLECTIONS   (NO CUTOFF) :
C
C ------
CREMARK   3   R VALUE                          : 0.203 
C
CREMARK  18  MERGING R-FACTOR (INTENSITY)   : 0.088
CREMARK  18  WAVELENGTH OR RANGE (A)        : 0.9
CREMARK   4   WAVELENGTH OR WAVELENGTH RANGE : 1.54 A   
C
C ------
CREMARK 200  WAVELENGTH OR RANGE        (A) : 0.890     
C
      IF(LINE(14:47).EQ.
     *'R VALUE                          :') THEN

        CH16=LINE(48:63)
        CALL WTODIG_PDB(CH16,F,I) 
        CR_RFAC_ALL=F

      ELSE IF(LINE(14:47).EQ.
     *'R VALUE            (WORKING SET) :') THEN

        CH16=LINE(48:63)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RFAC_CUT=F

      ELSE IF(LINE(14:47).EQ.
     *'FREE R VALUE                     :') THEN

        CH16=LINE(48:63)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RFREE_CUT=F

      ELSE IF(LINE(14:56).EQ.
     *'R VALUE          (WORKING SET, NO CUTOFF) :') THEN

        CH16=LINE(57:69)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RFAC_OBS=F

      ELSE IF(LINE(13:55).EQ.
     *'R VALUE          (WORKING SET, NO CUTOFF) :') THEN

        CH16=LINE(56:71)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RFAC_OBS=F

      ELSE IF(LINE(13:55).EQ.
     *'FREE R VALUE                  (NO CUTOFF) :') THEN

        CH16=LINE(56:71)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RFREE_OBS=F

      ELSE IF(LINE(14:56).EQ.
     *'FREE R VALUE                  (NO CUTOFF) :') THEN

        CH16=LINE(57:72)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RFREE_OBS=F

      ELSE IF(LINE(14:26).EQ.
     *'PROGRAM     :') THEN

        CR_PROGRAM   = LINE(28:48)

      ELSE IF(LINE(14:48).EQ.
     *'RESOLUTION RANGE HIGH (ANGSTROMS) :') THEN

        CH16=LINE(49:64)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RES_RMAX=F

      ELSE IF(LINE(14:48).EQ.
     *'RESOLUTION RANGE LOW  (ANGSTROMS) :') THEN

        CH16=LINE(49:64)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RES_RMIN=F

      ELSE IF(LINE(14:48).EQ.
     *'DATA CUTOFF            (SIGMA(F)) :') THEN

        CH16=LINE(49:64)
        CALL WTODIG_PDB(CH16,F,I)
        CR_SIGMAR_F=F

      ELSE IF(LINE(14:48).EQ.
     *'DATA CUTOFF            (SIGMA(I)) :') THEN

        CH16=LINE(49:64)
        CALL WTODIG_PDB(CH16,F,I)
        CR_SIGMAR_I=F

      ELSE IF(LINE(13:44).EQ.
     *'MERGING R-FACTOR (INTENSITY)   :') THEN

        CH16=LINE(49:64)
        CALL WTODIG_PDB(CH16,F,I)
        CR_RMERG_IOBS=F

      ELSE IF((LINE(13:44).EQ.
     *'WAVELENGTH OR RANGE (A)        :').OR.(LINE(13:44).EQ.
     *'WAVELENGTH OR RANGE        (A) :')) THEN

        CH16=LINE(45:60)
        CALL WTODIG_PDB(CH16,F,I)
        CR_WAVEL=F

      ELSE IF(LINE(14:48).EQ.
     *'NUMBER OF REFLECTIONS             :') THEN

        CH16=LINE(49:64)
        CALL WTODIG_PDB(CH16,F,I)
        CR_NREF_REP=I

      ELSE IF(LINE(14:56).EQ.
     *'TOTAL NUMBER OF REFLECTIONS   (NO CUTOFF) :') THEN

        IF(CR_NREF_REP.LE.0) THEN
          CH16=LINE(57:72)
          CALL WTODIG_PDB(CH16,F,I)
          CR_NREF_REP=I
        ENDIF

      ELSE IF(LINE(13:55).EQ.
     *'TOTAL NUMBER OF REFLECTIONS   (NO CUTOFF) :') THEN

        IF(CR_NREF_REP.LE.0) THEN
          CH16=LINE(56:71)
          CALL WTODIG_PDB(CH16,F,I)
          CR_NREF_REP=I
        ENDIF

      ENDIF

  100 CONTINUE


      RETURN
      END



C ******
      SUBROUTINE WTODIG_PDB(LINE,F,I)
C -------------------------------------------------------
C -P- WTODIG - convert string to integer and real.
C              
C              STR  - input string of characters (without blancs).
C              I    - output integer value of string.
C              F    - output real value of string.
C      Subroutine returns I=0 and F=0.0 if it can't convert the string 
C      to the digits.
C      Examples right strings: "+23", "324", "-123", "-1.0", "0.23",
C                              "+2.00", "-1.2E-2", "0.3e+2", "-3E4".
C -------------------------------------------------------
      REAL F
      INTEGER*4 I,IW
      CHARACTER LINE*(*),STR*80
C ******
C ---
      REAL A,SIGN
      INTEGER*4 IA,INTGR,IPOINT,NP,K,J
      CHARACTER CH*1,NUM(10)*1
      DATA NUM /'0','1','2','3','4','5','6','7','8','9'/
C ---------------------------------
      INTGR = 0
      SIGN  = 1.0
      IPOINT= 0
      NP    = 0
      F     = 0.0
      I     = 0
      A     = 0.0
      IA    = 0
      IE    = 0
C --------------------------------
      IFIRST=0
      CALL LENSTR_BL(LINE,IW)
      IF(IW.LE.0) RETURN
      IF(LINE(2:5).EQ.'NULL') RETURN
C ---
      II=0
      DO   J=1,IW
        CH=LINE(J:J)

        IF(CH.EQ.' '.AND.IFIRST.EQ.0) THEN

        ELSE
          II=II+1
          STR(II:II)=CH
          IFIRST=1
        ENDIF

      ENDDO
      IW=II
      IF(IW.LE.0) RETURN

      DO   J=1,IW
        CH=STR(J:J)
        DO    K=1,10
          IF(CH.EQ.NUM(K)) GO TO 100
        ENDDO  
        IF((CH.EQ.'-'.OR.CH.EQ.'+').AND.J.EQ.1) THEN
          IF(CH.EQ.'-') SIGN=-1.0
          GO TO 200
        ENDIF
        IF(CH.EQ.'.'.AND.IPOINT.EQ.0) THEN
          IPOINT=1
          GO TO 200
        ENDIF
        IF(CH.EQ.'e'.OR.CH.EQ.'E') THEN
          IF(A.EQ.0.0) RETURN
          IE=1
          GO TO 300
        ENDIF
        RETURN
  100   CONTINUE
        K=K-1
        IF(IPOINT.EQ.1) NP=NP+1
        A=A*10.0+K
        IF(IPOINT.EQ.0) IA=IA*10+K
 200    CONTINUE
      ENDDO
 300  F=SIGN*A/10.0**NP
      I=IA
      IF(SIGN.LT.0.0) I=-I
C --- 
      J=J+1
      IF(IE.EQ.0.OR.J.GT.IW) RETURN
      I=0
      IA=0
      A=F
      F=0.0
      ISIGN=1
C --------------------------------
      JJ=J
      DO   J=JJ,IW
        CH=STR(J:J)
        DO    K=1,10
          IF(CH.EQ.NUM(K)) GO TO 400
        ENDDO  
        IF((CH.EQ.'-'.OR.CH.EQ.'+').AND.J.EQ.JJ) THEN
          IF(CH.EQ.'-') ISIGN=-1
          GO TO 500
        ENDIF
        RETURN
  400   CONTINUE
        K=K-1
        IA=IA*10+K
  500   CONTINUE
      ENDDO
      IF(ISIGN.LT.0) IA=-IA
      F= A * 10.0**IA
C ---------------------------------
      RETURN
      END


      SUBROUTINE RDDBREF_C(LINE)
C -------------------------------------------------------
C     RDDBREF - reads record DBREF from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      CHARACTER FRMT*80,NAME_DB*3,CD_NDB*8,CH8*8
      DATA FRMT/'(26X,A3,4X,A8,1X,A8)'/
C ------------------------------------
      READ(LINE,FRMT) NAME_DB,CD_NDB,CH8

      CALL LENSTR_BL(NAME_DB,LEN)
      IF(LEN.LE.0) NAME_DB='---'
      CALL LENSTR_BL(CD_NDB,LEN)
      IF(LEN.LE.0) THEN
        CALL LENSTR_BL(CH8,LEN)
        IF(LEN.LE.0) THEN
          CD_NDB='?'
        ELSE
          CD_NDB=CH8
        ENDIF
      ENDIF
      IF(NAME_DB(1:3).EQ.'NDB') CP_NDBCODE = CD_NDB
      RETURN
      END

      SUBROUTINE RDHET_C(LINE)
C -------------------------------------------------------
C     RDHET - reads record HET from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
      CHARACTER FRMT*80,MON*3,NAME*40
      DATA FRMT/'(7X,A3,10X,I5,5X,A40)'/
C ------------------------------------
      READ(LINE,FRMT) MON,NA,NAME

      IF(MON(1:1).EQ.' ') THEN
        MON=MON(2:3)//' '
        IF(MON(1:1).EQ.' ') MON=MON(2:3)//' '
      ENDIF

      CALL LENSTR_BL(NAME,LEN)
     
      IF(LEN.GT.0) THEN
        DO I=1,LEN
          IF(NAME(I:I).EQ.' ')  NAME(I:I)='_'
          IF(NAME(I:I).EQ.'''') NAME(I:I)='*'
        ENDDO 
      ELSE
        NAME='.'
      ENDIF

      RETURN
      END

      SUBROUTINE RDFORMUL_C(LINE)
C -------------------------------------------------------
C     RDFORMUL - reads record FORMUL from PDB_file.
C  
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
      CHARACTER FRMT*80,MON*3,FORMUL*40
      DATA FRMT/'(12X,A3,4X,A40)'/
C ------------------------------------
      READ(LINE,FRMT) MON,FORMUL

      IF(MON(1:1).EQ.' ') THEN
        MON=MON(2:3)//' '
        IF(MON(1:1).EQ.' ') MON=MON(2:3)//' '
      ENDIF

      RETURN
      END

      SUBROUTINE RDCRYST1_C(LINE)
C -------------------------------------------------------
C     RDCRYST1 - reads record CRYST1 from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      REAL CELL(6)
      CHARACTER FRMT*80
      CHARACTER SPGR*11
      DATA FRMT/'(6X,3F9.3,3F7.2,1X,A11)'/
C ------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      PI180=PI/180.0
C
      READ(LINE,FRMT) CELL(1),CELL(2),CELL(3)
     *               ,CELL(4),CELL(5),CELL(6)
     *               ,SPGR
C ---
      CP_CELL(1) =CELL(1)
      CP_CELL(2) =CELL(2)
      CP_CELL(3) =CELL(3)
      CP_CELL(4) =CELL(4)*PI180
      CP_CELL(5) =CELL(5)*PI180
      CP_CELL(6) =CELL(6)*PI180
C ---
      CALL LENSTR_BL(SPGR,LENS)
      IF(LENS.LE.0) THEN
        SPGR=' '
        LENS=1
      ELSE
        J=0
        NB=-11
        DO I=1,LENS
          IF(SPGR(I:I).EQ.' ') THEN
            NB=NB+1
            IF(NB.EQ.1) THEN
              J=J+1
              SPGR(J:J)=SPGR(I:I)
            ENDIF
          ELSE
            NB=0
            J=J+1
            SPGR(J:J)=SPGR(I:I)
          ENDIF
        ENDDO
        LENS=J
      ENDIF

      CP_SPGR = SPGR(1:LENS)

      RETURN
      END

      SUBROUTINE RDSCALE_C(LINE)
C -------------------------------------------------------
C     RDSCALE - reads record SCALE1 from PDB_file.
C
C -------------------------------------------------------
      CHARACTER LINE*(*)
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      CHARACTER FRMT*80,CH1*1
      DATA FRMT/'(5X,A1,4X,3F10.6,5X,F10.5)'/
C ------------------------------------
      READ(LINE,FRMT) CH1,S1,S2,S3,U

      I=1
      IF(CH1.EQ.'2') I=2
      IF(CH1.EQ.'3') I=3
      IF(I.EQ.1) THEN
        CP_SCALE(1,1)=S1
        CP_SCALE(2,1)=S2
        CP_SCALE(3,1)=S3
        CP_U(1)      =U  
      ELSE IF(I.EQ.2) THEN
        CP_SCALE(1,2)=S1
        CP_SCALE(2,2)=S2
        CP_SCALE(3,2)=S3
        CP_U(2)      =U  
      ELSE IF(I.EQ.3) THEN
        CP_SCALE(1,3)=S1
        CP_SCALE(2,3)=S2
        CP_SCALE(3,3)=S3
        CP_U(3)      =U  
      ENDIF
      RETURN
      END

      SUBROUTINE RDMTRIX_C(MDOC,LINE,IERR)
C -------------------------------------------------------
C     RDMTRIX - reads record MTRIX1 from PDB_file.
C   
C -------------------------------------------------------
      CHARACTER LINE*(*)
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      REAL FRTOCR(3,3),CRTOFR(3,3),V1(3),U(3),V2(3)
      REAL AM(3,3),BM(3,3),SI(3,3),S(3,3)
      CHARACTER FRMT*80,CH1*1,STR*80
      DATA FRMT/'(5X,A1,1X,I3,3F10.6,5X,F10.5,4X,I1)'/
C ------------------------------------
      PI=4.0*ATAN(1.0)
      READ(LINE,FRMT) CH1,ICS,S1,S2,S3,V,IGIVEN

      IF(CP_PASS.EQ.1) THEN
        I=1
        IF(CH1.EQ.'2') I=2
        IF(CH1.EQ.'3') I=3
        IF(I.EQ.1) THEN
          CP_NSCALE(1,1)=S1
          CP_NSCALE(2,1)=S2
          CP_NSCALE(3,1)=S3
          CP_NV(1)      =V  
        ELSE IF(I.EQ.2) THEN
          CP_NSCALE(1,2)=S1
          CP_NSCALE(2,2)=S2
          CP_NSCALE(3,2)=S3
          CP_NV(2)      =V  
        ELSE IF(I.EQ.3) THEN
          CP_NSCALE(1,3)=S1
          CP_NSCALE(2,3)=S2
          CP_NSCALE(3,3)=S3
          CP_NV(3)      =V  
          CP_NCS=CP_NCS+1                     
          CP_IGIVEN=IGIVEN


          CALL INVERT(CP_SCALE,SI,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' WARNING: problem with SCALE matrix')             
            IERR=0
            GO TO 200
          ENDIF

c          WRITE(STR,'('' MATRIX : '',3F12.4)') (CP_NSCALE(L,1),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (CP_NSCALE(L,2),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (CP_NSCALE(L,3),L=1,3)
c          CALL MSGDOC(MD,STR)
c
c          CALL MTOANG(CP_NSCALE,ALPHA,BETA,GAMMA)
c          WRITE(STR,100) ALPHA,BETA,GAMMA
c  100     FORMAT('EILER ANGLES : ALPHA BETA GAMMA :',3F10.4)
c          CALL MSGDOC(MD,STR)
c
c          ALPHA=ALPHA*PI/180.
c          BETA =BETA *PI/180.
c          GAMMA=GAMMA*PI/180.c
c
c          CALL EULERM(ALPHA,BETA,GAMMA,AM)
c
c          WRITE(STR,'('' MATRIX : '',3F12.4)') (AM(L,1),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (AM(L,2),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (AM(L,3),L=1,3)
c          CALL MSGDOC(MD,STR)


          CALL FRORTH(CP_CELL(1),CP_CELL(2),CP_CELL(3)
     *           ,CP_CELL(4),CP_CELL(5),CP_CELL(6)
     *                         ,FRTOCR,CRTOFR,IERR)
          CALL  MATMLT(SI,CRTOFR,AM)
          CALL  MATMLT(FRTOCR,CP_SCALE,BM)
          CALL  MATMLT(CP_NSCALE,AM,S)
          CALL  MATMLT(BM,S,CP_NSCALE)

          CALL  MVMULT(FRTOCR,CP_U,U)
          CALL  MVMULT(CP_NSCALE,U,V1)
          CALL  VADD(U,V1,V2)
          CALL  MVMULT(BM,CP_NV,V1)
          CALL  VADD(V1,V2,CP_NV)


c          WRITE(STR,'('' MATRIX : '',3F12.4)') (CP_NSCALE(L,1),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (CP_NSCALE(L,2),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (CP_NSCALE(L,3),L=1,3)
c          CALL MSGDOC(MD,STR)
c
c          CALL MTOANG(CP_NSCALE,ALPHA,BETA,GAMMA)
c          WRITE(STR,100) ALPHA,BETA,GAMMA
c          CALL MSGDOC(MD,STR)
c
c          ALPHA=ALPHA*PI/180.
c          BETA =BETA *PI/180.
c          GAMMA=GAMMA*PI/180.
c
c          CALL EULERM(ALPHA,BETA,GAMMA,AM)
c
c          WRITE(STR,'('' MATRIX : '',3F12.4)') (AM(L,1),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (AM(L,2),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (AM(L,3),L=1,3)
c          CALL MSGDOC(MD,STR)

          CALL SET_NCS(MDOC,NMAX,CP_NCS,CP_NSCALE,CP_NV,IERR)
 200      CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE RDSSBOND_C(MDOC,LINE,IERR)
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*(*)
C ----------------------------------
      CHARACTER STR*80,CH1*1,CH2*1,CR1*5,CR2*5
      CHARACTER FRMT*80
      DATA FRMT/'(15X,A1,1X,A5,7X,A1,1X,A5)'/
C ------------------------------------
      READ(LINE,FRMT) CH1,CR1,CH2,CR2
C
      RETURN
      END

      SUBROUTINE RDCONECT_C(MDOC,LINE,IERR)
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*(*)
      RETURN
      END


      SUBROUTINE RDANISO_C(LINE)
      CHARACTER LINE*(*)
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
C ******
C ------------------------------------------------------
      INTEGER*4 IANISO(6)
      CHARACTER FRMT*80
      DATA FRMT/'(28X,6I7)'/
C ------------------------------------

      READ(LINE,FRMT) (IANISO(I),I=1,6)

      DO I=1,6
        CP_ANIS(I) = IANISO(I)/10000.0
      ENDDO 

      CP_NAN    = 1
      CP_BTYPE  = 'A'

      RETURN
      END

      SUBROUTINE RDSIGAT_C(LINE)
      CHARACTER LINE*(*)
      RETURN
      END

      SUBROUTINE RDSIGUIJ_C(LINE)
      CHARACTER LINE*(*)
      RETURN
      END

      SUBROUTINE CP_CRD_C(MDOC,IOUT,IFIRST,FNAME,NAHOH,NHATOM,NA
     * ,ISYM,IPRSYM,IERR)
C -------------------------------------------------------
      INTEGER MDOC,IOUT,IERR,IFIRST
      CHARACTER FNAME*(*)
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C -------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD,CP_NDBCODE
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CP_NDBCODE*8
C --------------------------------------------------------------
      COMMON/COM_PDB_B/ NBAV,BAVER,NO_SPGR,CELL
      REAL              CELL(6)
C ---------------------------------------------------------
      COMMON /CRDPDB/   CR_TEMPER   ,CR_WAVEL
     *                 ,CR_RES_MIN  ,CR_RES_MAX 
     *                 ,CR_RFAC_ALL ,CR_RFAC_OBS
     *                 ,CR_SIGMA_I  ,CR_SIGMA_F 
     *                 ,CR_CD_NDB   ,CR_CD_CSD
     *                 ,CR_DATE_NDB ,CR_DATE_CREAT
     *                 ,CR_PROGRAM  ,CR_METHOD
      REAL  CR_TEMPER
      REAL  CR_WAVEL
      REAL  CR_RES_MIN
      REAL  CR_RES_MAX 
      REAL  CR_RFAC_ALL
      REAL  CR_RFAC_OBS
      REAL  CR_SIGMA_I
      REAL  CR_SIGMA_F 
      CHARACTER CR_CD_NDB    *8
      CHARACTER CR_CD_CSD    *8
      CHARACTER CR_DATE_NDB  *10
      CHARACTER CR_DATE_CREAT*20
      CHARACTER CR_PROGRAM   *40
      CHARACTER CR_METHOD    *40
C -----------------------------------------------
C   CR_TEMPER        CR_WAVEL
C   CR_RES_MIN       CR_RES_MAX 
C   CR_RFAC_ALL      CR_RFAC_OBS
C   CR_SIGMA_I       CR_SIGMA_F 
C   CR_CD_NDB        CR_CD_CSD
C   CR_DATE_NDB      CR_DATE_CREAT
C   CR_PROGRAM       CR_METHOD
C ----------------------------------------------------------------
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of atom from the file.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
      REAL      FRTOCR(3,3),CRTOFR(3,3),Y(3)
      CHARACTER CH4*4
      INTEGER   NOSPGR,ISETT,NSYM,NS
      CHARACTER SGNAME*24,SYMOP*26,LINE*80
      CHARACTER CHAR*1,TYPE*1,FNAME_OUT*256
C -------------------------
      PI   =4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
      M    = 99
      IENDW=0
      IF(IFIRST.EQ.0) THEN
        IF(FLAG_CR.NE.'Y') THEN
          IF(CELL(1).GT.0.0) THEN 
            CP_CELL(1)=CELL(1)
            CP_CELL(2)=CELL(2)
            CP_CELL(3)=CELL(3)
            CP_CELL(4)=(CELL(4)*PI)/180.0
            CP_CELL(5)=(CELL(5)*PI)/180.0
            CP_CELL(6)=(CELL(6)*PI)/180.0              
          ELSE
            CALL MSGERR(MDOC
     *      ,' ERROR: card "CRYST1" is missing in PDB_file')
            IERR=1
            RETURN
          ENDIF
        ENDIF

        IF(CP_CELL(1).LE.0.5.OR.CP_CELL(2).LE.0.5.OR.
     *     CP_CELL(3).LE.0.5.OR.CP_CELL(4).LE.0.001.OR.
     *     CP_CELL(5).LE.0.001.OR.CP_CELL(6).LE.0.001) THEN
          CALL MSGERR(MDOC,' WARNING: wrong CELL parameters')
          CALL MSGERR(MDOC,'          Default: 100,100,100,90,90,90')
          CP_CELL(1)=100.0
          CP_CELL(2)=100.0
          CP_CELL(3)=100.0
          CP_CELL(4)=PI/2.0
          CP_CELL(5)=PI/2.0
          CP_CELL(6)=PI/2.0
        ENDIF

     

        CALL LENSTR_BL(CP_SPGR,LENS)


        IF(LENS.LT.1.OR.LENS.GT.24) THEN
          IF(NO_SPGR.LE.0.OR.NO_SPGR.GT.230) THEN 
            CALL MSGERR(MDOC
     *      ,' WARNING: wrong card "CRYST1" of PDB_file.')
            CALL MSGERR(MDOC
     *      ,'          default space group "P 1"')
            CP_SPGR='P 1'
            LENS=3 
          ELSE
            WRITE(CP_SPGR,'(I3)') NO_SPGR
            LENS=3
          ENDIF

        ENDIF

        IND=0
        DO I=1,LENS
          CHAR=CP_SPGR(I:I)
          CALL CHKSMB(CHAR,TYPE)
          IF(TYPE.NE.'B'.AND.TYPE.NE.'D') IND=1
        ENDDO

        IF(IND.EQ.0) THEN

          READ(CP_SPGR(1:LENS),*) NOSPGR


          ISETT  = 0
          IF(NOSPGR.LT.1.OR.NOSPGR.GT.230) THEN
            CALL MSGERR(MDOC
     *      ,' WARNING: wrong card "CRYST1" of PDB_file')
            CALL MSGERR(MDOC
     *      ,'          default space group: "P 1"')
            NOSPRG=1
          ENDIF
          IF(NOSPRG.EQ.146.OR.NOSPRG.EQ.155) THEN
            T= (PI*2.0)/3.0
            IF(ABS(CP_CELL(6)-T).LE.0.0001) ISETT=2
          ENDIF
          IF(NOSPGR.GE.3.AND.NOSPGR.LE.5) THEN
            IF(ISETT.EQ.2) THEN
              T = PI/2.0
              IF(ABS(CP_CELL(6)-T).GT.0.0001) ISETT=1
            ELSE IF(ISETT.EQ.1) THEN
              T = PI/2.0
              IF(ABS(CP_CELL(5)-T).GT.0.0001) ISETT=2
            ENDIF
          ENDIF
          NSYM   = 0
          SGNAME = ' '

        ELSE

          NOSPGR = 0
          ISETT  = 0
          NSYM   = 0

              IF(CP_SPGR.EQ.'P2' .OR.CP_SPGR.EQ.'P 2' .OR.
     *           CP_SPGR.EQ.'P21'.OR.CP_SPGR.EQ.'P 21'.OR.
     *           CP_SPGR.EQ.'B2' .OR.CP_SPGR.EQ.'B 2' .OR.
     *           CP_SPGR.EQ.'C2' .OR.CP_SPGR.EQ.'C 2'     ) THEN
                T  = PI/2.0
c                ISETT = 2
                IF(ABS(CP_CELL(6)-T).GT.0.0001.AND.
     *             ABS(CP_CELL(5)-T).LE.0.0001     ) ISETT = 1
                IF(CP_SPGR.EQ.'P2'.OR.CP_SPGR.EQ.'P 2') THEN
                  IF(ISETT.EQ.1) THEN
                    CP_SPGR = 'P 1 1 2'
                  ELSE
                    CP_SPGR = 'P 1 2 1'
                  ENDIF
                ELSE IF(CP_SPGR.EQ.'P21'.OR.CP_SPGR.EQ.'P 21') THEN
                  IF(ISETT.EQ.1) THEN
                    CP_SPGR = 'P 1 1 21'
                  ELSE
                    CP_SPGR = 'P 1 21 1'
                  ENDIF
                ELSE IF(CP_SPGR.EQ.'B2'.OR.CP_SPGR.EQ.'B 2'.OR.
     *              CP_SPGR.EQ.'C2'.OR.CP_SPGR.EQ.'C 2'    ) THEN
                  IF(ISETT.EQ.1) THEN
                    CP_SPGR = 'B 1 1 2'
                  ELSE
                    CP_SPGR = 'C 1 2 1'
                  ENDIF
                ENDIF
              ENDIF


          IF(CP_SPGR(1:1).EQ.'H') CP_SPGR(1:1)='R'

          CALL LENSTR_BL(CP_SPGR,LENS)
          SGNAME = CP_SPGR(1:LENS)
          IF(SGNAME(1:1).EQ.'H')  SGNAME(1:1)='R'
          IF((LENS.GE.3.AND.SGNAME(1:3).EQ.'R 3').OR.
     *       (LENS.GE.2.AND.SGNAME(1:2).EQ.'R3')) THEN
            T= (PI*2.0)/3.0
            IF(ABS(CP_CELL(6)-T).LE.0.0001) THEN
              ISETT=2
              SGNAME(1:1)='H'
            ELSE
              ISETT=1
            ENDIF
          ENDIF

        ENDIF

        CALL GET_SYMM(MDOC,NOSPGR,ISETT,SGNAME,NSYM,ISYM,IPRSYM,IERR)

        IF(IERR.GT.0) RETURN
        IF(IERR.LT.0) RETURN

        CP_SPGR=SGNAME
        DO I=1,6
          CR_CELL(I)=CP_CELL(I)
        ENDDO 


        CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *                         ,FRTOCR,CRTOFR,IERR)

        IF(FLAG_SC.EQ.'Y') THEN
          DO I=1,3
            DO J=1,3
              CR_SCALE(I,J)=CP_SCALE(I,J)
            ENDDO
            CR_U(I)=CP_U(I)
          ENDDO
        ELSE
          DO I=1,3
            DO J=1,3
              CR_SCALE(I,J)=CRTOFR(I,J)
            ENDDO
          ENDDO
        ENDIF

        DO I=1,3
          DO J=1,3
            CR_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
            CR_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          ENDDO
        ENDDO

C        CR_ORT_TO_FRAC(3,3)
C        CR_FRAC_TO_ORT(3,3)
C        CR_M_NCS(3,3)
C        CR_V_NCS(3)
C        CR_NCS

        CR_NSPGR    =NOSPGR
        CR_NSYM     =NSYM
        CR_SETT     =ISETT
        CR_MULT_FLAG=0
        CR_MODEL    =CP_MODEL
        CR_CD_PDB   =CP_CODE
        CR_CD_NDB   =CP_NDBCODE
        CR_NAME_PDB =CP_CODE//CP_CODE//'    '//CP_NAME
        CR_DATE_PDB =CP_DATE
        CR_TITLE    ='?   ?   '//CP_TITLE
        CR_RESL_PDB =CP_RESL
        CR_RFAC_PDB =CP_RFAC
        CR_SPGR     =SGNAME

        CALL C_AT_CR

        MD=-ABS(MDOC)-1

        IF(CP_PASS.EQ.2.AND.IOUT.GT.0) THEN
          CALL LENSTR_BL(FNAME,LEN)
          FNAME_OUT = FNAME
c         CALL REMOVE_PATH(FNAME_OUT)
          CALL LENSTR_BL(FNAME_OUT,LEN)
          IF(LEN.GT.0) THEN
            IF(LEN.GT.60) LEN=60
            LINE = 'Output file :'//FNAME_OUT(1:LEN)//'.crd'
            CALL MSGDOC(MDOC,LINE)
          ENDIF
          CALL OWCRD(MD,IOUT,FNAME,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: OPEN OUTPUT_FILE')
            CLOSE(IOUT) 
            RETURN
          ENDIF
          FNAME = FNAME_OUT        
        ENDIF
        IENDW=-1
        IFIRST=1
      ENDIF

      MODE = 0
      IF(CP_NAN.EQ.1) CR_FLAG_USER='A'
      CR_PNUM  = CP_PNUM
      CR_IATOM = CP_IA
      CR_IRES  = CP_IRES
      CR_IATOLD= NA
      CR_IGROUP= CP_ICH
      WRITE(CH4,'(I4)') CP_ICH
      CR_CHAIN = CP_PNUM(1:2)
      CR_GROUP = CR_CHAIN//'  '
      CR_ALT   = CP_ALT
      CR_CORR  = '.'
      CR_ATYPE = '.'

      CALL MVMULT(CR_SCALE,CP_XYZ,Y)
      Y(1)=Y(1)+CR_U(1)
      Y(2)=Y(2)+CR_U(2)
      Y(3)=Y(3)+CR_U(3)
      CALL MVMULT(CR_FRAC_TO_ORT,Y,CP_XYZ)


      CR_XYZ(1)= CP_XYZ(1)
      CR_XYZ(2)= CP_XYZ(2)
      CR_XYZ(3)= CP_XYZ(3)
      CR_OCC   = CP_OCC
      CR_BISO  = CP_BISO
      CR_ANAME = CP_ANAME
      CR_RNAME = CP_RNAME
      CR_ASYMB = CP_ASYMB
      IF(CR_OCC.GT.0.0) THEN
        BAVER=BAVER+CR_BISO
        NBAV=NBAV+1
      ENDIF
      CR_BTYPE = CP_BTYPE 
      DO IAN=1,6
        CR_ANIS(IAN) = 0.0
      ENDDO
      IF(CP_BTYPE.EQ.'A') THEN
        DO IAN=1,6
          CR_ANIS(IAN) = CP_ANIS(IAN)
        ENDDO
      ENDIF

      CR_MULT_FACTOR =  1
C     IF(CR_ANAME.EQ.'O   '.AND.CR_RNAME.EQ.'HOH') NAHOH=NAHOH+1

      IF(CP_ASYMB.EQ.'H   '.OR.CP_ASYMB.EQ.'D   ') THEN
        NHATOM=NHATOM+1
      ELSE
        IF(CR_RNAME.EQ.'HOH'.OR.CR_RNAME.EQ.'DOD') THEN
          CR_ANAME='O   '
          NAHOH=NAHOH+1
        ENDIF
      ENDIF

      IF(CP_PASS.EQ.2.AND.IOUT.GT.0) THEN
        CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: WRITE OUTPUT_FILE')
          CLOSE(IOUT) 
          RETURN
        ENDIF
      ENDIF

      RETURN
      END


C -I-
      SUBROUTINE TOBLANC(MDOC,POOL,MEMORY,NAME_IN,NAME_OUT
     * ,NAME_C,NAME_F,NAME_I,PATH_SCR,RESCRD,FORM_I,CIF,SETT
     * ,ANOM,ATOP,SD_LIM,MTZ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ---------------------------------------------------
C -P- TOBLANC : converts file of Structure Factors with PDB-format or CIFile. 
C               reads formatted file ( CIF or PDB ) which contains indices 
C               and structure factors or intensities or phases, (also simple
C               formatted file with "h,k,l,!F!"  or "h,k,l,!F!,sig(F)" and
C               without titles is acceptable) sorts, brings to asymmetric
C               unit of reciprical space, averages equivalent elements.
C               The entrance to complex BLANC.
C -S-   
C      Dialog and Batch:
C
C    FILE_IN  - name of formatted input SF_PDB_file or CIFile.
C               For PDB_file program will try to make scratch CIFile: 
C               "toblanc.cif" and to convert it to the internal BLANC format.
C    FILE_OUT - name of output file. Type name of file where you want to
C               save result of this programm.
C
C    FILE_C:  - information about CELL and SYMMetry operators will
C               be taken from this file of coordinates.
C               /without extention "crd"/
C    FILE_INF: - information about CELL and SYMMetry operators will
C               be taken from this INF_file.
C               /without extention "inf"/
C    FILE_F:  - information about CELL and SYMMetry operators will
C               be taken from this file of structure factors.
C               If FILE_C = " ",FILE_INF = " " and FILE_F = " " then the
C               information about CELL and SYMMetry operators will
C               be taken from this FILE_IN.
C
C    ANOM     - <N>,Y -  Y - if you are going to use ANOM. SCATT.
C
C    TOP      - Reflections with !I-<I>! > sd(I) * TOP will be accepted. 
C               Here <I> is average value of intensities of on equalents.
C
C    SLIM     -  <0.0> - Reflections with I > sd(I) * SLIM will be accepted. 
C
C    FORM_I   -  <F>/C/P - get: F - Fobs, C - Fcalc, P - Phase') 
C
C                                                 "toblanc.cif" only. 
C       It is possible to use the subroutine TOBLANC by program:
C
C      SUBROUTINE TOBLANC(MDOC,POOL,MEMORY,NAME_IN,NAME_OUT
C     * ,NAME_C,NAME_F,NAME_I,RESCRD,FORM_I,CIF,SETT
C     * ,ANOM,ATOP,SD_LIM,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C            Parameters of subroutine: 
C
C    MDOC     - mode of writting messages to DOC-file
C               0 - only terminal , < - 0 only file, 0 < < 99 - both
C               >= 99 - don't write  
C    POOL     - working array /real/. Dimension is equal MEMORY.
C    MEMORY   - maximal number of reflexions is MEMORY/4.           
C    NAME_IN  - name of input file.
C    NAME_OUT - name of output file.
C    NAME_C   - name of input file of coordinates. /see above/
C    NAME_F   - name of intput file of structure factors. /see above/
C    NAME_I   - name of input INF_file. /see above/
C    FORM     -  <F>/C/P /character*1/- get: F - Fobs, C - Fcalc, P - Phase' 
C    CIF      - /character*1/ dummy
C    ANOM     - <N>,Y - /character*1/, Y - if you are going to use ANOM.SCATT.
C    ATOP     - Reflections with !I-<I>! > sd(I) * ATOP will be accepted. 
C    SD_LIM   -  <0.0> reflections with I > sd(I) * SD_LIM will be accepted. 
C    RESCRD   - high resolution limit. 0 means all rflections. 
C    SETT     - now is dummy.
C    ISYM     - integer*2 array for cryst.symmetry operators 
C    IPRSYM   - dimension of integer*2 array ISYM(5,3,IPRSYM)
C               We need not to define contents of arrays ISYM.
C               Here is only reservation of memory.
C    IERR    -  output signal of error / =1 -error , =0 - OK / 
C
C    RESULT /real RESULT(IPRROW)/ - array for output information:
C
C  RESULT(1) - number of refls in output file.
C  RESULT(2) - min resolution
C  RESULT(3) - max resolution
C  RESULT(4) - R-merge
C  RESULT(5) - number of refls after symm. average.
C  RESULT(6) - number of refls befor symm. average.
C  RESULT(7) - N_gt_3sig
C  
C  RESULT(8)
C  RESULT(9)   space group / 12 characters/
C  RESULT(10)
C
C  RESULT(11) - R-mult
C  RESULT(12) - number of refls after average.
C  RESULT(13) - number of refls before average.
C  RESULT(14) - R-st(I)
C  RESULT(15) - number of refls with I > sig.
C  RESULT(16) - number of refls in input file.
C  RESULT(17) - NBAD_SD
C  RESULT(18) - NSYM
C  RESULT(19) - NBAD_ABS
C               NBAD = NBAD_SD + NBAD_ABS + ( F < 0.0 ; H=K=L=0 ; H,K,L > LIM )
C  RESULT(20) = SD_LIM
C  RESULT(21) = NOUT OUT FROM RESOLUTION
C
C  RESULT(I,2) - R-merge
C  RESULT(I,3) - number of symm. refls
C -I-
C ------------------------------
      REAL      POOL(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,3)
      REAL      RLATT(6)
      CHARACTER LINE*80
      REAL      ATOP,SD_LIM,RESCRD
      INTEGER*4 MDOC,IERR,NUMBT
      CHARACTER NAME_IN*(*),NAME_OUT*(*),NAME_I*(*),PATH_SCR*(*)
      CHARACTER NAME_C*(*),NAME_F*(*),FORM_I*1,CIF*1,SETT*1,MTZ*1
      CHARACTER ANOM*1
C -----------------------------------------------------
      CHARACTER FILE_CIF*256
C -----------------------------------------------------
c     IF(CIF.EQ.'y') CIF='Y'
c     IF(CIF.NE.'Y') CIF='N'

      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_CIF = PATH_SCR(1:LEN)//'toblanc.cif'
      ELSE 
        FILE_CIF = 'toblanc.cif'
      ENDIF

      CALL PRESFPDB(MDOC,NAME_IN,FILE_CIF,IERR)
      IF(IERR.GT.0)  RETURN
c     IF(CIF.EQ.'Y') RETURN

      CALL TO_BLANC(MDOC,POOL,MEMORY,FILE_CIF,NAME_OUT
     * ,NAME_C,NAME_F,NAME_I,RESCRD,FORM_I,SETT
     * ,ANOM,ATOP,SD_LIM,MTZ,ISYM,IPRSYM,RESULT,IPRROW,IERR)

C       MT=10
C       FILE_CIF='toblanc.cif'
C       OPEN(UNIT=MT,FILE=FILE_CIF,ACCESS='SEQUENTIAL',ERR=16)
C       CLOSE(MT,STATUS='DELETE',ERR=16)
C 16    CONTINUE


      RETURN
      END

      SUBROUTINE TO_BLANC(MDOC,POOL,MEMORY,NAME_IN,NAME_OUT
     * ,NAME_C,NAME_F,NAME_I,RESCRD,FORM_I,SETT
     * ,ANOM,ATOP,SD_LIM,MTZ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ---------------------------------------------------
C ------------------------------
      REAL      POOL(*)

      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,3)
      REAL      RLATT(6)
      CHARACTER LINE*80
      REAL      ATOP,SD_LIM,RESCRD
      INTEGER*4 MDOC,IERR,NUMBT
      CHARACTER NAME_IN*(*),NAME_OUT*(*),NAME_I*(*)
      CHARACTER NAME_C*(*),NAME_F*(*),FORM_I*1,SETT*1
C -----------------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      CHARACTER ANOM*1,FLAG_C*1,FLAG_S*1,TYPE*4,TITLE*80,FORM*1,MTZ*1
      CHARACTER TITLEL*160
      REAL      R4    
      CHARACTER CH4*4
      EQUIVALENCE (R4,CH4)
C ------------------------------------------------------------
      IERR=0
      MAXREF=MEMORY/4
      IANOM=0
      IF(ANOM.EQ.'y') ANOM='Y'
      IF(ANOM.EQ.'Y') IANOM=1
      TITLEL=' '

      NSP_GROUP=0
      SP_GROUP=' '
 
      NUMBT= 0
      RESMIN=0.0
      RESMAX=1.0E30

      IF(FORM_I.EQ.'f') FORM_I='F'
      IF(FORM_I.EQ.'c') FORM_I='C'
      IF(FORM_I.EQ.'p') FORM_I='P'
      IF(FORM_I.NE.'C'.AND.FORM_I.NE.'P') FORM_I='F'

      CALL LENSTR_BL(NAME_C,LEN)
      IF(LEN.LE.0.OR.NAME_C(1:1).EQ.' '.OR.
     *               NAME_C(1:1).EQ.',') THEN
        CALL LENSTR_BL(NAME_I,LEN)
        IF(LEN.LE.0.OR.NAME_I(1:1).EQ.' '.OR.
     *                  NAME_I(1:1).EQ.',') THEN
          FLAG_C='N'
        ELSE
          FLAG_C='I'
        ENDIF
      ELSE
        FLAG_C='Y'
      ENDIF
      IF(FLAG_C.EQ.'Y') THEN
        MT  =10
        M   =99
        CALL ORCRD(M,MT,NAME_C,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN COORD_FILE')
          RETURN
        ENDIF
        DO I=1,6
          RLATT(I) = CR_CELL(I)
        ENDDO
        CLOSE(MT)
        CALL C_AT_CR
        LINE = USER_TITLE
        TITLEL=USER_TITLE(1:80)//PDB_NAME(1:40)
      ELSE IF(FLAG_C.EQ.'I') THEN

        CALL RD_INF(M,NAME_I,RLATT,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE_INF')
          RETURN
        ENDIF
        LINE = USER_TITLE
        TITLEL=USER_TITLE(1:80)//PDB_NAME(1:40)

      ELSE

        CALL LENSTR_BL(NAME_F,LEN)
        IF(LEN.LE.0.OR.NAME_F(1:1).EQ.' '.OR.
     *                 NAME_F(1:1).EQ.',') THEN
          FLAG_C='N'
        ELSE
          FLAG_C='Y'
          MT  =10
          M   =99
          TYPE='    '
          CALL ORFILE(M,MT,NAME_F,TYPE,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.GT.0) THEN
            CALL MSGERR(MDOC,' ERR: OPEN FILE_F')
            RETURN
          ENDIF
          CALL GET_TITLE(M,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     *    ,RLATT(6),DM,DM,DRN,DRX,IDM,IDM,IDM,IDM,IDM,TITLEL,IERR)
          CLOSE(MT)
          CALL C_RD_CR
          LINE = USER_TITLE
          TITLEL=USER_TITLE(1:80)//PDB_NAME(1:40)

        ENDIF
      ENDIF
C ---
      CALL RDSORT(MDOC,NUMBT,RLATT,LINE,TITLEL,NAME_IN,FORM_I,MAXREF
     * ,POOL(1),POOL(MAXREF+1),POOL(MAXREF*2+1),POOL(MAXREF*3+1)
     * ,RFAC_ST,N_GT_SIG,N_GT_3SIG
     * ,N_INPUT,SD_LIM,NBAD_SD,NBAD_ABS
     * ,RESMIN,RESMAX,NSYM,ISYM,IPRSYM,FLAG_C,FLAG_S,NBAD,MTZ,IERR)
      IF(IERR.NE.0) RETURN      
      NBAD_SD=NBAD_SD+NBAD
      RESULT(2,1)=RESMIN
      RESULT(3,1)=RESMAX
      RESULT(7,1)=N_GT_3SIG
C ---
      FORM='B'
      IF(FORM_I.NE.'C'.AND.FORM_I.NE.'F') FORM='H'
      IERR=0
      CALL JOINWR(MDOC,NUMBT
     *   ,POOL(1),POOL(MAXREF+1),POOL(MAXREF*2+1),POOL(MAXREF*3+1)
     *   ,MAXREF,RLATT,RESMIN,RESMAX,RESCRD,ISYM,NSYM
     *   ,NAME_OUT,IANOM,ATOP
     *   ,IPRSYM,FORM,TITLEL,FLAG_S
     *   ,RESULT,IPRROW,IERR)

C     *   ,DELRFR,NRFR,NRFRT
C     *   ,NREF,DELF,NSMT,NSMTT,IERR)

      CH4=CR_SPGR(1:4)
      RESULT(8,1)=R4
      CH4=CR_SPGR(5:8)
      RESULT(9,1)=R4
      CH4=CR_SPGR(9:11)//' '
      RESULT(10,1)=R4

C      RESULT(1,1)=NREF
C      RESULT(4,1)=DELF
C      RESULT(5,1)=NSMT
C      RESULT(6,1)=NSMTT
C      RESULT(11,1)=DELRFR
C        RESULT(12,1)=NRFR
C        RESULT(13,1)=NRFRT

      IF(RFAC_ST.LT.0.0015) RFAC_ST=0.0
      IF(IPRROW.GE.20 ) THEN
C        --- R-st(I)---
        RESULT(14,1)=RFAC_ST
        RESULT(15,1)=N_GT_SIG
        RESULT(16,1)=N_INPUT
        RESULT(17,1)=NBAD_SD
        RESULT(18,1)=NSYM
        RESULT(19,1)=NBAD_ABS
        RESULT(20,1)=SD_LIM
      ENDIF
      RETURN
      END

      SUBROUTINE RDSORT(MDOC,NUMBT,RLATT,LINE,TITLEL,NAME,FORM_I,MAXREF
     *   ,IARRH,IARRS,ARRF,ARRS,SUMSDT,ISUM1,ISUM3
     *   ,N_INPUT,SD_LIM,NBSD,NBABS
     *   ,RESMIN,RESMAX,NSYM,ISYM,IPRSYM,FLAG_C,FLAG_S,NBAD,MTZ,IERR)
        
C -----------------------------------------
CMS      : IARRH,IARRS,ARRF,ARRS
      REAL RESMIN,RESMAX
C      INTEGER*4 MT
      INTEGER*4 IERR
      INTEGER*4 NUMBT,MAXREF,IARRH(*),IARRS(*)
      REAL      ARRF(*),ARRS(*)
      INTEGER*4 NSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL RLATT(6)
      CHARACTER FORM_I*1,NAME*(*),LINE*(*),TITLEL*(*),MTZ*1
      INTEGER*4 IPRSYM
      CHARACTER FLAG_C*1,FLAG_S*1,FLAG_PDB*1
      EXTERNAL  PACK
C -------------------------------------
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
C ---
      CHARACTER   TITLE*80,STR*256
      CHARACTER   PATH*1,EXT*1,SGNAME*24
      CHARACTER   CODE_PDB*4,DATE_PDB*9,NAME_PDB*40,CODE_NDB*8
C ---
      REAL      FDATA
      INTEGER*4 IDATA
      CHARACTER DATA*80,ITEM*80,FLAG_FOM*1,WAVE*5,TEMPER*5,CH10*10
      CHARACTER FORM_F*1,FORM_P*1,FORM_FC*1,FORM_F2*1,FORM*1,STATUS*1
      CHARACTER FLAG_99*1
      CHARACTER CRYST*80
      CHARACTER FLAG_SA*1,FLAG_SI*1,FLAG_SIA*1,FLAG_S2*1,FLAG_S2A*1
      CHARACTER FORM_FA*1,FORM_F2A*1,FORM_FI*1,FORM_FIA*1
      CHARACTER BLOCK*80
C------------------------------------------------
      IERR  = 0
C     MT    = MDOC
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      PI180 = PI/180.0
C------------------------------
      FLAG_S = 'N'
      FLAG_PDB = 'N'
      LINE   = ' '
      TEMPER = '?    '
      WAVE   = '?    '
      BLOCK ='?    ' 
C ------------------
      IHMIN =-511
      IHMAX = 511
      IKMIN =-511
      IKMAX = 511
      ILMIN =-511
      ILMAX = 511
C -----------------
      N_INPUT = 0
      NUMB    = 0
      ICNT    = 0
      NBL     = 0
      RHMIN   = 1.E 30
      RHMAX   = 0.0
      NBAD    = 0
      NBSD    = 0
      NBABS   = 0
      SUMSDT  = 0.0
      SUMINT  = 0.0
      ISUM1   = 0
      ISUM3   = 0
      ISUM10  = 0
      IPRNT   = 5000
      N99     = 0
      NRECS   = 1

C      JRECS  =  200
C      LRECIN = 1600

      SGNAME   = ' '
      NSG      = 0
      NSETT    = 0
      ACELL    = 0.0
      BCELL    = 0.0
      CCELL    = 0.0
      ALCELL   = 0.0
      BECELL   = 0.0
      GACELL   = 0.0
      CODE_PDB = 'XXXX'
      CODE_NDB = 'XXXX    '
      DATE_PDB = 'XX-XXX-XX'
      NAME_PDB = '?'

      TITLE    = '?   ?   ?'
      IFIRST   = 0
      CRYST    = ' '            

      CALL LENSTR_BL(TITLEL,LEN)

      IF(LEN.GT.0) THEN
        TITLE    = TITLEL(1:80)        
      ENDIF

      IF(LEN.GT.80) THEN
        CODE_PDB = TITLEL(81:84)
        CODE_NDB = TITLEL(85:92)
        NAME_PDB = TITLEL(85:124)
      ENDIF
C-------------------------------------
      IERR = 0
      MTIN = 10
      M    = 99
      PATH = ' '
      EXT  = ' '
      CALL OPENFR(MTIN,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: can''t open input_CIFile')
        RETURN
      ENDIF
      MD =-ABS(MDOC)-1

      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(STR,'('' INPUT-FILE:'',A)') NAME(1:LEN)
      CALL MSGDOC(MD,STR)
C -----
      DO I=1,2000
C#CRYST1   36.520   36.520  139.120  90.00  90.00  90.00 P 43 21 2     8
        READ(MTIN,'(A)',END=110) STR
        IF(STR(1:7).EQ.'#CRYST1') THEN
          CALL LENSTR_BL(STR,LEN)
          CRYST = STR(1:LEN)             
          FLAG_PDB = 'Y'
          GO TO 110
        ENDIF 
      ENDDO
 110  CONTINUE
      CLOSE(MTIN)    
C -----
      CALL OPENFR(MTIN,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: can''t open input_CIFile')
        RETURN
      ENDIF
C -----
  100 CONTINUE
      IEND =-1
C --------------------------------------------------------
  200 CONTINUE   

      CALL GETCIF(MTIN,MDOC,IERR,IEND)
      IF(IERR.NE.0) THEN
        CLOSE(MTIN)
        RETURN
      ENDIF
      IF(IEND.NE.0) THEN
        GO TO 210
      ENDIF
      LH       = 0
      LK       = 0
      LL       = 0

      FA       = 0.0
      SA       = 0.0
      FA1      = 0.0
      SA1      = 0.0
      FA2      = 0.0
      SA2      = 0.0

      F2A       = 0.0
      S2A       = 0.0
      F2A1      = 0.0
      S2A1      = 0.0
      F2A2      = 0.0
      S2A2      = 0.0

      FIA       = 0.0
      SIA       = 0.0
      FIA1      = 0.0
      SIA1      = 0.0
      FIA2      = 0.0
      SIA2      = 0.0

      PHI      = 0.0
      FOM      = 0.0
      FORM     = ' '

      FLAG_S   = 'N'
      FLAG_SA  = 'N'
      FLAG_SI  = 'N'
      FLAG_SIA = 'N'
      FLAG_S2  = 'N'
      FLAG_S2A = 'N'

      FORM_F   = ' '
      FORM_FA  = ' '
      FORM_F2  = ' '
      FORM_F2A = ' '
      FORM_FI  = ' '
      FORM_FIA = ' '

      FORM_P   = ' '
      FORM_FC  = ' '
      FLAG_FOM = ' '
      FLAG_99  = ' '
      NPASS    = 1
      I_PASS   = 0
      STATUS   = 'o'

      IF(BLOCK(1:1).NE.'?') THEN
        IF(BLOCK.NE.BLK_CIF) GO TO 210
      ENDIF
      BLOCK = BLK_CIF
      IF(N_CIF.LE.0) GO TO 200

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM  = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA  = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA = IDT_CIF(I)
        FDATA = FDT_CIF(I)
        IF((ITEM(1:18).EQ.'_database_PDB_code').OR.         
     *     (ITEM(1:18).EQ.'_database_PDB.code').OR.
     *     (ITEM(1:20).EQ.'_database_2.code_PDB').OR.
     *     (ITEM(1:9) .EQ.'_entry.id')) THEN         
          LN = LEND
          IF(LN.GT.4) LN=4
          CODE_PDB=DATA(1:LN)
          IF(LN.LT.4) THEN
            DO II=LN+1,4
              CODE_PDB(II:II) = ' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_name').OR.
     *          (ITEM(1:21).EQ.'_struct_keywords.text').OR.
     *          (ITEM(1:16).EQ.'_struct.keywords')) THEN
          LN = LEND
          IF(LN.GT.40) LN=40
          NAME_PDB=DATA(1:LN)
          IF(LN.LT.40) THEN
            DO II=LN+1,40
              NAME_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:20).EQ.'_database_2.code_NDB') THEN
          LN=LEND
          IF(LN.GT.8) LN=8
          CODE_NDB=DATA(1:LN)
          IF(LN.LT.8) THEN
            DO II=LN+1,8
              CODE_NDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:27).EQ.'_diffrn.ambient_temperature')) THEN
          IF(LEND.GT.5) LEND=5
          TEMPER = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              TEMPER(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:28).EQ.'_diffrn_radiation.wavelength')) THEN
          IF(LEND.GT.5) LEND=5
          WAVE = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              WAVE(II:II)=' '
            ENDDO
          ENDIF
       ELSE IF((ITEM(1:31).EQ.'_database_PDB_rev.date_original').OR.        
     *   (ITEM(1:31).EQ.'_database_NDB_rev.date_original')) THEN         
          DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,DATE_PDB)         
          ELSE
            DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_date').OR.
     *          (ITEM(1:20).EQ.'_audit.creation_date')) THEN         
          DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,DATE_PDB)         
          ELSE
            DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:13).EQ.'_struct_title').OR.
     *          (ITEM(1:13).EQ.'_struct.title')) THEN     
          TITLE=DATA(1:LEND)

        ELSE IF((ITEM(1:12) .EQ.'_cell_length').OR.         
     *          (ITEM(1:12) .EQ.'_cell_angle_').OR.         
     *          (ITEM(1:12) .EQ.'_cell.length').OR.         
     *          (ITEM(1:12) .EQ.'_cell.angle_')) THEN         
          IF(IFIRST.EQ.0) THEN     
          IF(ITEM(7:14).EQ.'length_a'.AND.LENI.EQ.14) THEN         
            ACELL=FDATA
          ELSE IF(ITEM(7:14).EQ.'length_b'.AND.LENI.EQ.14) THEN         
            BCELL=FDATA
          ELSE IF(ITEM(7:14).EQ.'length_c'.AND.LENI.EQ.14) THEN         
            CCELL=FDATA
          ELSE IF(ITEM(7:17).EQ.'angle_alpha'.AND.LENI.EQ.17) THEN     
            ALCELL=FDATA
            ALCELL=ALCELL*PI180
          ELSE IF(ITEM(7:16).EQ.'angle_beta'.AND.LENI.EQ.16) THEN         
            BECELL=FDATA
            BECELL=BECELL*PI180
          ELSE IF(ITEM(7:17).EQ.'angle_gamma'.AND.LENI.EQ.17) THEN
            GACELL=FDATA
            GACELL=GACELL*PI180
          ENDIF
          ENDIF
        ELSE IF(ITEM(1:9).EQ.'_symmetry') THEN
          IF(IFIRST.EQ.0) THEN

          IF     (ITEM(11:30).EQ.'space_group_name_H-M') THEN         
            SGNAME=DATA
          ELSE IF(ITEM(11:21).EQ.'Int_Tables_') THEN         
            NSG=IDATA
          ELSE IF(ITEM(11:21).EQ.'cell_settin') THEN         
            NSETT=IDATA
          ELSE IF(ITEM(11:21).EQ.'equiv_pos_a') THEN     

          ENDIF

          ENDIF

        ELSE IF((ITEM(1:7) .EQ.'_refln_').OR.
     *          (ITEM(1:23) .EQ.'_cell_measurement_refln').OR.
     *          (ITEM(1:7) .EQ.'_refln.')) THEN
          CALL LENSTR_BL(ITEM,LEN)
          IF((ITEM(8:14) .EQ.'index_h').OR.
     *       (ITEM(25:31).EQ.'index_h')) THEN
            LH=IDATA
          ELSE IF((ITEM(8:14) .EQ.'index_k').OR.
     *       (ITEM(25:31) .EQ.'index_k')) THEN
            LK=IDATA
          ELSE IF((ITEM(8:14) .EQ.'index_l').OR.
     *       (ITEM(25:31) .EQ.'index_l')) THEN
            LL=IDATA
          ELSE IF((ITEM(8:22) .EQ.'figure_of_merit').OR.
     *            (ITEM(8:10) .EQ.'fom')) THEN
            FOM=FDATA  
            IF(FORM_I.EQ.'P') FLAG_FOM='Y'
          ELSE IF((ITEM(8:13) .EQ.'status').OR.
     *       (ITEM(25:30) .EQ.'status')) THEN
            STATUS=DATA(1:1)
            IF(STATUS.EQ.'0') STATUS='o'
            IF(STATUS.EQ.'1') STATUS='f'
          ELSE IF(ITEM(8:17) .EQ.'phase_calc') THEN
            PHI=FDATA
            IF(FORM_I.EQ.'P') FORM='H'
          ELSE IF(ITEM(8:17) .EQ.'coef_H_L_a') THEN

          ELSE IF(ITEM(8:17) .EQ.'coef_H_L_b') THEN

          ELSE IF(ITEM(8:17) .EQ.'coef_H_L_c') THEN

          ELSE IF(ITEM(8:17) .EQ.'coef_H_L_d') THEN

          ELSE IF(ITEM(8:13) .EQ.'F_meas') THEN
            CALL LENSTR_BL(ITEM,LEN)
            IF((LEN.EQ.16.AND.ITEM(8:16).EQ.'F_meas_au').OR. 
     *         (LEN.EQ.13.AND.ITEM(8:13).EQ.'F_meas'   )    ) THEN
C             _refln.F_meas
C             _refln.F_meas_sigma
C             _refln.F_meas_au
C             _refln.F_meas_sigma_au
              FA     = FDATA
              FORM_F = 'Y'
            ELSE IF(LEN.EQ.26.AND.ITEM(8:22).EQ.'F_meas_au_(+)_s') THEN
              SA1    = FDATA
              FLAG_SA = 'Y'
              NPASS  = 2
            ELSE IF(LEN.EQ.26.AND.ITEM(8:22).EQ.'F_meas_au_(-)_s') THEN
              SA2    = FDATA
              FLAG_SA = 'Y'
              NPASS  = 2
            ELSE IF(LEN.EQ.20.AND.ITEM(8:20).EQ.'F_meas_au_(+)') THEN
              FA1    = FDATA
              FORM_FA = 'Y'
              NPASS  = 2
            ELSE IF(LEN.EQ.20.AND.ITEM(8:20).EQ.'F_meas_au_(-)') THEN
              FA2    = FDATA
              FORM_FA = 'Y'
              NPASS  = 2
            ELSE IF((LEN.EQ.22.AND.ITEM(8:22).EQ.'F_meas_sigma_au').OR.
     *              (LEN.EQ.22.AND.ITEM(8:22).EQ.'F_meas_au_sigma').OR.
     *              (LEN.EQ.19.AND.ITEM(8:19).EQ.'F_meas_sigma') ) THEN
              SA     = FDATA
              FLAG_S = 'Y'
              IF(DATA(1:5).EQ.'99.99'.AND.MTZ.EQ.'N') FLAG_99='Y'
            ELSE
              FA     = FDATA
              FORM_F = 'Y'
            ENDIF
c_refln.pdbx_F_plus 
c_refln.pdbx_F_plus_sigma 
c_refln.F_plus 
c_refln.F_plus_sigma 
          ELSE IF((LEN.EQ.18.AND.ITEM(8:18).EQ.'pdbx_F_plus').OR.
     *            (LEN.EQ.13.AND.ITEM(8:13).EQ.'F_plus')) THEN
            FA1    = FDATA
            FORM_FA = 'Y'
            NPASS  = 2
          ELSE IF((LEN.EQ.18.AND.ITEM(8:19).EQ.'pdbx_F_minus').OR.
     *            (LEN.EQ.14.AND.ITEM(8:14).EQ.'F_minus')) THEN
            FA2    = FDATA
            FORM_FA = 'Y'
            NPASS  = 2
          ELSE IF((LEN.EQ.24.AND.ITEM(8:24).EQ.'pdbx_F_plus_sigma').OR.
     *            (LEN.EQ.19.AND.ITEM(8:19).EQ.'F_plus_sigma')) THEN
            SA1    = FDATA
            FLAG_SA = 'Y'
            NPASS  = 2
          ELSE IF((LEN.EQ.24.AND.ITEM(8:25).EQ.'pdbx_F_minus_sigma').OR.
     *            (LEN.EQ.20.AND.ITEM(8:20).EQ.'F_minus_sigma')) THEN
            SA2    = FDATA
            FLAG_SA = 'Y'
            NPASS  = 2
          ELSE IF(ITEM(8:13) .EQ.'F_calc') THEN
            FCALC=FDATA
            FORM_FC='Y'
          ELSE IF(ITEM(8:17) .EQ.'phase_calc') THEN
            PHI=FDATA
            IF(FORM_I.EQ.'P') FORM_P='Y'
          ELSE IF(ITEM(8:14) .EQ.'F_sigma') THEN
            SA_CALC=FDATA
            FLAG_S='Y'
          ELSE IF(ITEM(8:21) .EQ.'intensity_meas') THEN
            FIA=FDATA
            FORM_FI='Y'
          ELSE IF(LEN.EQ.16.AND.ITEM(8:16) .EQ.'intensity') THEN
            FIA=FDATA
            FORM_FI='Y'
          ELSE IF((ITEM(8:25) .EQ.'intensity_(+)_meas').OR.
     *            (LEN.EQ.18.AND.ITEM(8:18).EQ.'pdbx_I_plus').OR.
     *            (LEN.EQ.13.AND.ITEM(8:13).EQ.'I_plus')) THEN
            FIA1=FDATA
            FORM_FIA='Y'
            NPASS=2
          ELSE IF((ITEM(8:25) .EQ.'intensity_(-)_meas').OR.
     *            (LEN.EQ.19.AND.ITEM(8:19).EQ.'pdbx_I_minus').OR.
     *            (LEN.EQ.14.AND.ITEM(8:14).EQ.'I_minus')) THEN
            FIA2=FDATA
            FORM_FIA='Y'
            NPASS=2
          ELSE IF(ITEM(8:22) .EQ.'intensity_sigma') THEN
            SIA=FDATA
            FLAG_SI='Y'
          ELSE IF((ITEM(8:26) .EQ.'intensity_(+)_sigma').OR.
     *      (LEN.EQ.24.AND.ITEM(8:24).EQ.'pdbx_I_plus_sigma').OR.
     *      (LEN.EQ.19.AND.ITEM(8:19).EQ.'I_plus_sigma')) THEN
            SIA1=FDATA
            FLAG_SIA='Y'
            NPASS=2
          ELSE IF((ITEM(8:26) .EQ.'intensity_(-)_sigma').OR.
     *      (LEN.EQ.25.AND.ITEM(8:25).EQ.'pdbx_I_minus_sigma').OR.
     *      (LEN.EQ.20.AND.ITEM(8:20).EQ.'I_minus_sigma')) THEN
            SIA2=FDATA
            FLAG_SIA='Y'
            NPASS=2
          ELSE IF(ITEM(8:21) .EQ.'F_squared_meas') THEN
            FORM_F2='Y'
            F2A=FDATA
            FORM='S'
          ELSE IF(ITEM(8:22) .EQ.'F_squared_sigma') THEN
            S2A=FDATA
            FLAG_S2='Y'
          ELSE IF(ITEM(8:25) .EQ.'F_squared_(+)_meas') THEN
            FORM_F2A='Y'
            F2A1=FDATA
            FORM='S'
            NPASS=2
          ELSE IF(ITEM(8:26) .EQ.'F_squared_(+)_sigma') THEN
            S2A1=FDATA
            FLAG_S2A='Y'
            NPASS=2
          ELSE IF(ITEM(8:25) .EQ.'F_squared_(-)_meas') THEN
            FORM_F2A='Y'
            F2A2=FDATA
            FORM='S'
            NPASS=2
          ELSE IF(ITEM(8:26) .EQ.'F_squared_(-)_sigma') THEN
            S2A2=FDATA
            FLAG_S2A='Y'
            NPASS=2
          ENDIF

        ENDIF
      ENDDO

C       _refln.F_meas_au_(+)
C       _refln.F_meas_au_(+)_sigma
C       _refln.F_meas_au_(-)
C       _refln.F_meas_au_(-)_sigma
C       _refln.intensity_(+)_meas
C       _refln.intensity_(+)_meas_sigma
C       _refln.intensity_(-)_meas
C       _refln.intensity_(-)_meas_sigma
C       _refln.F_squared_(+)_meas
C       _refln.F_squared_(+)_sigma
C       _refln.F_squared_(-)_meas
C       _refln.F_squared_(-)_sigma
C       _refln.pdbx_I_plus
C       _refln.pdbx_I_plus_sigma
C       _refln.pdbx_I_minus
C       _refln.pdbx_I_minus_sigma

      IF(FLAG_99.EQ.'Y') THEN
            IF(N99.LT.10) THEN
            CALL MSGERR(MDOC
     *      ,' WARNING: reflection with SIGMA=99.99 is not accepted')
            ELSE IF(N99.EQ.10) THEN
            CALL MSGERR(MDOC
     *      ,' WARNING: ... more ... reflections with SIGMA=99.99')
            ENDIF
            N99=N99+1
        GO TO 200
      ENDIF

      IF(FORM_I.EQ.'F') THEN
        IF(FORM_F.EQ.'Y') THEN
C         FA SA
          FORM_F2 = 'N'
          NPASS = 1
          FORM_FC='N'
        ELSE IF(FORM_FA.EQ.'Y') THEN
C         FA1 FA2 SA1 SA2
          FLAG_S = FLAG_SA
          FORM_F = 'Y'
          FORM_F2='N'
          FORM_FC='N'
        ELSE IF(FORM_F2.EQ.'Y') THEN
          FORM_F = 'Y'
          FLAG_S = FLAG_S2
          FA = F2A
          SA = S2A
          NPASS = 1
          FORM_FC='N'
        ELSE IF(FORM_F2A.EQ.'Y') THEN
          FORM_F = 'Y'
          FLAG_S = FLAG_S2A
          FA1 = F2A1
          SA1 = S2A1
          FA2 = F2A2
          SA2 = S2A2
          FORM_F2 = 'Y'
          FORM_FC='N'
        ELSE IF(FORM_FI.EQ.'Y') THEN
          FORM_F = 'Y'
          FLAG_S = FLAG_SI
          FA = FIA
          SA = SIA
          FORM_F2 = 'Y'
          NPASS = 1
          FORM_FC='N'
        ELSE IF(FORM_FIA.EQ.'Y') THEN
          FORM_F = 'Y'
          FLAG_S = FLAG_SIA
          FA1 = FIA1
          SA1 = SIA1
          FA2 = FIA2
          SA2 = SIA2
          FORM_F2 = 'Y'
          FORM_FC='N'
        ENDIF
      ENDIF


      IF(FORM_I.EQ.'F'.AND.(FORM_F.EQ.'Y'.OR.FORM_F2.EQ.'Y')) THEN
        FORM='B'
        IF(FORM_F2.EQ.'Y') FORM='S'
      ELSE IF(FORM_I.EQ.'P'.AND.FORM_P.EQ.'Y') THEN
        FORM='H'
        IF(FLAG_FOM.NE.'Y') FOM=1.0
      ELSE IF(FORM_I.EQ.'C'.AND.FORM_FC.EQ.'Y') THEN
        FORM='B'
        FA=FCALC
        SA=SA_CALC
      ENDIF
      IF(FORM.EQ.' ') GO TO 200

 222  CONTINUE

      I_PASS=I_PASS+1
      IF(NPASS.EQ.2) THEN

        IF(I_PASS.EQ.1) THEN
          LHO=LH          
          LKO=LK          
          LLO=LL          
          FA=FA1
          SA=SA1
        ELSE
          LH=-LHO          
          LK=-LKO          
          LL=-LLO          
          FA=FA2
          SA=SA2
        ENDIF   
 
      ENDIF   

      IF(IFIRST.EQ.0) THEN
 
        IF(FLAG_C.EQ.'N'.OR.FLAG_PDB.EQ.'Y') THEN

c          IF(SGNAME(1:1).EQ.' '.AND.NSG.LE.0) THEN

            CALL LENSTR_BL(CRYST,LEN)
            IF(LEN.GT.7) THEN
              READ(CRYST,'(7X,3F9.3,3F7.2,1X,A11)') 
     *               ACELL,BCELL,CCELL,ALCELL,BECELL,GACELL
     *               ,SGNAME
              ALCELL = ALCELL*PI180
              BECELL = BECELL*PI180
              GACELL = GACELL*PI180
              NSG = 0
             
            ENDIF

c          ENDIF

          RLATT(1)=ACELL
          RLATT(2)=BCELL
          RLATT(3)=CCELL
          RLATT(4)=ALCELL
          RLATT(5)=BECELL
          RLATT(6)=GACELL
C         IF(NSG.LT.1.OR.NSG.GT.230) NSG=1
C         IF(NSETT.LT.1.OR.NSETT.GT.2) NSETT=1
          IF(ACELL.LE.0.5.OR.BCELL.LE.0.5.OR.CCELL.LE.0.5.OR.
     *       ALCELL.LE.0.001.OR.BECELL.LE.0.001.OR.GACELL.LE.0.001) 
     *    THEN
            CALL MSGERR(MDOC,' WARNING: there is not CELL parameters')
            CLOSE(MTIN)
            IERR = 31
            RETURN
C
C          CALL MSGERR(MDOC,'          Defaut: 100,100,100,90,90,90')
C          ACELL=100.0
C          BCELL=100.0
C          CCELL=100.0
C          ALCELL=PI/2.0
C          BECELL=PI/2.0
C          GACELL=PI/2.0
CC          IERR=3
CC          CLOSE(MTIN)
CC          GO TO 240
C          RLATT(1)=ACELL
C          RLATT(2)=BCELL
C          RLATT(3)=CCELL
C          RLATT(4)=ALCELL
C          RLATT(5)=BECELL
          RLATT(6)=GACELL
        ENDIF
        IF(SGNAME(1:1).EQ.' '.AND.NSG.LE.0) THEN
          CALL MSGERR(MDOC,
     *    ' WARNING: there is not a symmetry information')
          CLOSE(MTIN)
          IERR = 32
          RETURN
C
C          CALL MSGERR(MDOC,
C     *    '          Default space group : P1')
C          SGNAME(1:3)='P 1' 
C          NSG=1
C          NSETT=1
C          IERR=3
C          CLOSE(MTIN)
C          GO TO 240
        ENDIF
C ----
C        IF(SGNAME(1:3).EQ.'R 3'.OR.SGNAME(1:2).EQ.'R3') THEN
C          T= (PI*2.0)/3.0
C          IF(ABS(GACELL-T).LE.0.0001) NSETT=2
C        ENDIF
C ----

        IF(SGNAME(1:1).EQ.' ') THEN
c       IF(NSG.GT.0) THEN

          NSETT = 0
          NOSPGR = NSG
          IF(NOSPGR.GT.1000) THEN

            ISETT  = NOSPGR/1000
            NOSPGR = NOSPGR - ISETT*1000
            ISETT  = ISETT + 1
            NOSG   = NOSPGR

            IF(NOSG.EQ.3.OR.NOSG.EQ.4.OR.NOSG.EQ.146.OR.
     *         NOSG.EQ.155) THEN
              IF(ISETT.EQ.1) THEN
                ISETT = 2
              ELSE IF(ISETT.EQ.2) THEN  
                ISETT = 1
C              ELSE IF(ISTT.EQ.4) THEN  
C                ISTT = 3
              ENDIF
            ELSE IF(NOSG.EQ.  5) THEN
              IF(ISETT.EQ.1) THEN
                ISETT = 2
              ELSE IF(ISETT.EQ.2) THEN  
                ISETT = 1
C              ELSE IF(ISETT.EQ.3) THEN  
C                ISETT = 4
C              ELSE IF(ISETT.EQ.4) THEN  
C                ISETT = 3
              ENDIF
            ENDIF
            NSETT = ISETT
          ENDIF
          IF(NOSPGR.LT.1.OR.NOSPGR.GT.230) THEN
            CALL MSGERR(MDOC
     *      ,' WARNING: wrong space group of input_file.')
            CLOSE(MTIN)
            IERR = 32
            RETURN
C
C            CALL MSGERR(MDOC
C     *      ,'          default space group: "P 1"')
C            NOSPGR = 1
          ENDIF

          IF(NOSPGR.EQ.146.OR.NOSPGR.EQ.155) THEN
            T= (PI*2.0)/3.0
            IF(ABS(RLATT(6)-T).LE.0.0001) NSETT=2
          ENDIF
          IF(NOSPGR.GE.3.AND.NOSPGR.LE.5) THEN
            IF(NSETT.LE.0) NSETT  = 2
            IF(NSETT.EQ.2) THEN
              T = PI/2.0
              IF(ABS(RLATT(6)-T).GT.0.0001) NSETT=1
            ELSE IF(NSETT.EQ.1) THEN
              T = PI/2.0
              IF(ABS(RLATT(5)-T).GT.0.0001) NSETT=2
            ENDIF
          ENDIF
          IF(NSETT.LE.0) NSETT = 1
          NSYM   = 0
          NSG    = NOSPGR
          SGNAME = ' '

        ELSE
     
          CALL LENSTR_BL(SGNAME,LENS)
          IF((LENS.GE.3.AND.SGNAME(1:3).EQ.'R 3').OR.
     *       (LENS.GE.2.AND.SGNAME(1:2).EQ.'R3')) THEN
            T = (PI*2.0)/3.0
            IF(ABS(RLATT(6)-T).LE.0.0001) THEN
              NSETT       = 2
              SGNAME(1:1) = 'H'
            ENDIF
          ENDIF
        ENDIF

        CALL GET_SYMM(MDOC,NSG,NSETT,SGNAME,NSYM,ISYM
     *                                            ,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(MTIN)
          IERR = 32
          RETURN
        ENDIF

        IF(CODE_NDB(1:4).EQ.'XXXX'.OR.CODE_NDB(1:1).EQ.'?'.OR.
     *     CODE_NDB(1:1).EQ.' '.OR.CODE_NDB(1:1).EQ.'.') 
     *     CODE_NDB(1:4)=CODE_PDB

        CALL LENSTR_BL(TITLE,LEN)
        IF(LEN.LE.0) THEN
          LINE=CODE_PDB//'    '
          LEN=9
        ELSE
          IF(LEN.GT.60) LEN=60
          L=8+LEN
          LINE(9:L)=TITLE(1:LEN)             
        ENDIF

        LINE(69:73)=WAVE
        LINE(74:78)=TEMPER
        TITLEL=LINE(1:80)//CODE_PDB//CODE_NDB//NAME_PDB(1:20)
            

        CALL SET_CELL(RLATT,CODE_PDB,NAME_PDB,DATE_PDB,LINE,NSG
     *        ,NSETT,SGNAME,IERR)

        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: WRONG TITLE')
          CLOSE(MTIN)
          IERR = 35
          RETURN
        ENDIF

       ELSE

       ENDIF        


        MMDOC=99
        CALL ANOMF(MMDOC,NSYM,ISYM)
        IFIRST=1
c        GO TO 100
      ENDIF
      IF(FORM.EQ.'B') THEN
        IF(FA.GE.0.00000001) THEN
          IF(SA.LE.0.00000001) THEN
            FSQL=FA*FA
            SDL =0.001*FSQL
          ELSE
            SDL=2.0*FA*SA
            FSQL=FA*FA
          ENDIF
        ELSE
          FSQL=0.0
          SDL=0.0
        ENDIF
        ICNT=ICNT+1
        IHR=LH
        IKR=LK
        ILR=LL
        FRD=FSQL
        SDEV=SDL
      ELSE IF(FORM.EQ.'S') THEN
        IF(FA.GE.0.00000001) THEN
          IF(SA.LE.0.00000001) THEN
            FSQL=FA
            SDL=0.001*FSQL
          ELSE
            SDL =SA
            FSQL=FA
          ENDIF
        ELSE
          FSQL=0.0
          SDL=0.0
        ENDIF
        ICNT=ICNT+1
        IHR=LH
        IKR=LK
        ILR=LL
        FRD=FSQL
        SDEV=SDL
        FORM='B'
      ELSE IF(FORM.EQ.'H') THEN
        IF(PHI.LT.0.0) THEN
          PHI=PHI+360.
        ENDIF
        IF(PHI.GT.360.0) THEN
          PHI=PHI-360.
        ENDIF
        FSQL=PHI+1.0
        FOM=1.0
        SDL =FOM+1.0
        ICNT=ICNT+1
        IHR=LH
        IKR=LK
        ILR=LL
        FRD=FSQL
        SDEV=SDL
      ENDIF
      IF(FRD.LE.0.0)                   GO TO 230
      IF(IHR.LT.IHMIN.OR.IHR.GT.IHMAX) GO TO 230
      IF(IKR.LT.IKMIN.OR.IKR.GT.IKMAX) GO TO 230
      IF(ILR.LT.ILMIN.OR.ILR.GT.ILMAX) GO TO 230
      IF(ILR.EQ.0.AND.IKR.EQ.0.AND.IHR.EQ.0) GO TO 230

C      IF(FLAG_S.EQ.'Y') THEN
C        IF (NBSD.LE.100.AND.SDEV.LE.0.0.AND.FORM.EQ.'B') THEN
C          WRITE(STR,'(''SD?:H,K,L,I,SD:'',6X,3I4,F14.2,F10.2    )')
C     .                     IHR,IKR,ILR,FRD,SDEV
C          CALL MSGERR(MDOC,STR)
CCCCC          NBSD=NBSD+1
C        ENDIF
C      ENDIF
      IF(NUMBT+1.GT.MAXREF) THEN
        WRITE(STR,7000) MAXREF
        CALL MSGERR(MDOC,STR)
 7000   FORMAT(' ERR: NUMBER OF INPUT REFLECTIONS > ',I7)
        GO TO 7001
      ENDIF
      IF(FORM.NE.'H') THEN
        TEST=FRD/SDEV
        IF(TEST.LT.SD_LIM.OR.SDEV.LE.0.0) THEN 
          NBSD=NBSD+1
          NBAD=NBAD+1
          IF (NBAD.LT.20) THEN
          WRITE(STR,'('' -->SD_LIM:H,K,L,I,SD:'',6X,3I4,F14.2,F10.2)')
     .                     IHR,IKR,ILR,FRD,SDEV
            CALL MSGERR(MDOC,STR)
          ELSE IF (NBAD.EQ.20) THEN
            CALL MSGERR(MDOC,' ... more ...')
          ENDIF
          GO TO 220 
        ENDIF

        CALL SYSABS_BL(IHR,IKR,ILR,NSYM,ISYM,ICND)
        IF(ICND.NE.0) THEN
          NBABS=NBABS+1
          NBAD=NBAD+1
          IF (NBAD.LT.20) THEN
          WRITE(STR,'('' -->SYSABS:H,K,L,I,SD:'',6X,3I4,F14.2,F10.2)')
     .                     IHR,IKR,ILR,FRD,SDEV
            CALL MSGERR(MDOC,STR)
          ELSE IF (NBAD.EQ.20) THEN
            CALL MSGERR(MDOC,' ... more ...')
          ENDIF
          GO TO 220
        ENDIF


        NUMB =NUMB +1
        SUMSDT=SUMSDT+SDEV
        SUMINT=SUMINT+FRD
        IF(TEST.GT. 1.) ISUM1 =ISUM1 +1
        IF(TEST.GT. 3.) ISUM3 =ISUM3 +1
        IF(TEST.GT.10.) ISUM10=ISUM10+1
      ELSE


        CALL SYSABS_BL(IHR,IKR,ILR,NSYM,ISYM,ICND)
        IF(ICND.NE.0) THEN
          NBABS=NBABS+1
          NBAD=NBAD+1
          IF (NBAD.LT.20) THEN
          WRITE(STR,'('' -->SYSABS:H,K,L,I,SD:'',6X,3I4,F14.2,F10.2)')
     .                     IHR,IKR,ILR,FRD,SDEV
            CALL MSGERR(MDOC,STR)
          ELSE IF (NBAD.EQ.20) THEN
            CALL MSGERR(MDOC,' ... more ...')
          ENDIF
          GO TO 220
        ENDIF



        TEST=(SDEV-1.0)*10.0
        IF(TEST.GT. 1.) ISUM1 =ISUM1 +1
        IF(TEST.GT. 3.) ISUM3 =ISUM3 +1
        IF(TEST.GT. 9.) ISUM10=ISUM10+1
        NUMB =NUMB +1
        SUMSDT=SUMSDT+SDEV
        SUMINT=SUMINT+FRD
      ENDIF
      NH=IHR
      NK=IKR
      NL=ILR
      CALL ANOMSC(NH,NK,NL,KANOM,JJSYM,NSYM,ISYM)
      IF(KANOM.NE.1) JJSYM=-JJSYM
      CALL PACK(INDEX,NH,NK,NL)
C  ----- IARRH(NUMBT)=((NL+000128)*000256+NK+000128)*000256+NH+000128
      NFL=1
      NUMBT =NUMBT +1
      IARRH(NUMBT)=INDEX

      ISTAT=0
      IF(STATUS.EQ.'f') ISTAT=1
      IF(STATUS.EQ.'r') ISTAT=2

      IARRS(NUMBT)= (ISTAT*256+(JJSYM+128))*256+NFL
      ARRF(NUMBT) =FRD
      ARRS(NUMBT) =SDEV
      IF(IPRNT.GT.0) THEN
        IF(MOD(NUMBT,IPRNT).EQ.0) THEN
          IF(FORM.NE.'H') THEN
            WRITE(STR,
     *'(''   N,H,K,L,I,SD,ISYM:'',I6,3I4,F14.2,F14.2,I4)')
     *       NUMBT,IHR,IKR,ILR,FRD,SDEV,JJSYM
            CALL MSGDOC(MDOC,STR)
          ELSE
            FOM=SDEV-1.0
            PHI=FRD-1.0
            WRITE(STR,
     *'(''   N,H,K,L,m,PH,ISYM:'',I6,3I4,F14.2,F14.2,I4)')
     *       NUMBT,IHR,IKR,ILR,FOM,PHI,JJSYM
            CALL MSGDOC(MDOC,STR)
          ENDIF
       ENDIF
      ENDIF
      CALL DSTAR_BL(NH,NK,NL,RS)
      RH=SQRT(RS)
      IF(RH.LT.RHMIN) RHMIN=RH
      IF(RH.GT.RHMAX) RHMAX=RH

 220  CONTINUE
      IF(I_PASS.LT.NPASS) GO TO 222

      GO TO 200
230   NBAD=NBAD+1
      IF (NBAD.LT.20) THEN
        WRITE(STR,'('' --> BAD  :H,K,L,I,SD:'',6X,3I4,F14.2,F10.2)')
     .                     IHR,IKR,ILR,FRD,SDEV
        CALL MSGERR(MDOC,STR)
      ELSE IF (NBAD.EQ.20) THEN
        CALL MSGERR(MDOC,' ... more ...')
      ENDIF

      IF(I_PASS.LT.NPASS) GO TO 222

      GO TO 200
C-----------------------------------------------
  210 CONTINUE
7001  CONTINUE
C     WRITE( *,'('' N-REFLS: READ='',I6,'' PASS='',I6)') ICNT,NUMBT
      IF(RHMAX.GT.0.000001) THEN
        RHMAX=1./RHMAX
      ELSE
        RHMAX=88888.88
      ENDIF
      IF(RHMIN.GT.0.000001) THEN
        RHMIN=1./RHMIN
      ELSE
        RHMIN=88888.88
      ENDIF
      IF(RESMIN.LT.RHMIN) RESMIN=RHMIN
      IF(RESMAX.GT.RHMAX) RESMAX=RHMAX
c --
      IT = RESMIN*1000.0 
      IT = IT + 1
      RESMIN = FLOAT(IT)/1000.0
      IT = RESMAX*1000.0 
      IT = IT - 1
      RESMAX = FLOAT(IT)/1000.0
c --
C      WRITE(*,403) RHMIN,RHMAX
  403 FORMAT(1X,'RESOLUTION OF DATA :',F8.2,' - ',F8.2,' ANGSTR')
      IF(FORM.NE.'H') THEN
        IF(SUMINT.NE.0.0) SUMSDT=SUMSDT/SUMINT
      ENDIF
      IF(NUMB.GT.0) THEN
        TEMP1=FLOAT(ISUM1 )/NUMB
        TEMP2=FLOAT(ISUM3 )/NUMB
        TEMP3=FLOAT(ISUM10)/NUMB
      ELSE
        TEMP1=0.0
        TEMP2=0.0
        TEMP3=0.0
      ENDIF

      CALL MSGDOC(MDOC,' -----------------------------')
      WRITE(STR,'('' N-REFLS: READ='',I6,'' PASS='',I6)') ICNT,NUMBT
      CALL MSGDOC(MDOC,STR)
      N_INPUT=ICNT
      WRITE(STR,403) RHMIN,RHMAX
      CALL MSGDOC(MDOC,STR)
      IF(FORM.NE.'H') THEN
        IF(FLAG_S.EQ.'Y') THEN

          WRITE(STR,'('' R-STAND-OLD :'',F8.4)') SUMSDT
          CALL MSGDOC(MDOC,STR)

C          SUMSDT,ISUM1

      WRITE(STR,'('' I >SIG,>3SIG,>10SIG:'',3I8)')ISUM1,ISUM3,ISUM10
          CALL MSGDOC(MDOC,STR)
      WRITE(STR,'(''                     '',3F8.3)') TEMP1,TEMP2,TEMP3
          CALL MSGDOC(MDOC,STR)
        ENDIF
      ELSE
        WRITE(STR,'('' m >0.1,>0.3 ,>0.9  :'',3I8)')ISUM1,ISUM3,ISUM10
        CALL MSGDOC(MDOC,STR)
      WRITE(STR,'(''                     '',3F8.3)') TEMP1,TEMP2,TEMP3
        CALL MSGDOC(MDOC,STR)
      ENDIF
      CALL MSGDOC(MDOC,' -----------------------------')

      IF(N99.GT.0) THEN
      CALL MSGDOC(MDOC,STR)
      WRITE(STR,'(''WARNING: Number of refls with sigma=99.99 :'',I8)') 
     * N99
      CALL MSGERR(MDOC,STR)
      ENDIF



      CLOSE(MTIN)
      RETURN

240   WRITE(STR,'('' TOTAL NUMBER OF REFLS :'',I8)') NUMBT
      CALL MSGDOC(MDOC,STR)

      IF(NUMBT.LE.1) THEN
        CALL MSGERR(MDOC,' ERR: NUMBER OF REFLS < 2')
        IERR=34
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE JOINWR(MT,NUMBT,IARRH,IARRS,ARRF,ARRS
     *   ,MAXREF,RLATT,RESMIN,RESMAX,RESCRD,ISYM,NSYM
     *   ,NAME_OUT,IANOM,ATOP
     *   ,IPRSYM,FORM,STR,FLAG_S
     *   ,RESULT,IPRROW,IERR)
C     *   ,DELRFR,NRFR,NRFRT
C     *   ,NREF,DELF,NSMT,NSMTT,IERR)

C --
CMS      : IARRH,IARRS,ARRF,ARRS
      REAL RESMIN,RESMAX
      INTEGER*4 MT,IERR
      INTEGER*4 NUMBT,MAXREF,IARRH(*),IARRS(*)
      REAL      ARRF(*),ARRS(*),RESULT(IPRROW,3)
      INTEGER*4 NSYM
      INTEGER*4 IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL RLATT(6)
      CHARACTER FORM*1,NAME_OUT*(*),STR*(*),FLAG_S*1
C -----------------------------------------
      PARAMETER ( NEQ=200 )
      REAL       FSQ(NEQ),SD(NEQ)
      INTEGER    MRKR(NEQ)
      INTEGER*4  ITYP,IANOM
      REAL       ATOP
      CHARACTER  NAME*256
C      CHARACTER  LINE*80
C ---------------------------------------------------
      IERR=0
      IF(NUMBT.LE.0) THEN
        CALL MSGERR(MT,' ERR: NUMBER OF REFLS < 1')
        IERR=1
        RETURN
      ENDIF
C      CALL MSGDOC(MT,' --- SORT ----')
      CALL ISORT3(IARRH,NUMBT,IARRS,ARRF,ARRS)
C      CALL MSGDOC(MT,' --- SORT  FINISHED ---')
C-------
C      CALL MSGDOC(MT,' -----------------------------')
C ----------------------------------------------------
      NAME=NAME_OUT
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.LE.0.OR.NAME(1:1).EQ.' '.OR.NAME(1:1).EQ.',') THEN
        CALL MSGERR(MT,' ERR: WRONG FILE-NAME')
        IERR=1
        RETURN
      ENDIF

      IF(FORM.NE.'H') THEN
        ITYP=0
        CALL SORTRF(MT,NAME,IANOM,IARRH,IARRS,ARRF,ARRS,MAXREF
     *    ,NUMBT,ATOP,ITYP,NSYM,ISYM,IPRSYM,FSQ,SD,MRKR,NEQ
     *    ,RLATT,FORM,STR,RESMIN,RESMAX,RESCRD,FLAG_S
     *    ,RESULT,IPRROW,IERR)
C     *    ,DELRFR,NRFR,NRFRT
C     *    ,NREF,DELF,NSMT,NSMTT,IERR)
      ELSE
        CALL SORTPH(MT,NAME,STR,IARRH,IARRS,ARRF,ARRS,MAXREF,NUMBT
     *            ,NEQ,RLATT,NSYM,ISYM,IPRSYM,RESMIN,RESMAX,IERR)
      ENDIF
      RETURN
      END

      SUBROUTINE SORTRF(MT,NAME,IANOM,IARRH,IARRS,ARRF,ARRS,MAXREF
     * ,NUMBT,ATOP,ITYP,NSYM,ISYM,IPRSYM,FSQ,SD,MRKR,NEQ
     * ,RLATT,FORM,LINE,RESMIN,RESMAX,RESCRD,FLAG_S
     * ,RESULT,IPRROW,IERR)
C     * ,DELRFR,NRFR,NRFRT
C     * ,NREF,DELF,NSMT,NSMTT,IERR)
C ------------------------------------------------------------------
CMS      : IARRH,IARRS,ARRF,ARRS
      INTEGER   IARRH(MAXREF),IARRS(MAXREF)
      REAL      ARRF (MAXREF),ARRS (MAXREF)
      REAL      FSQ(NEQ),SD(NEQ)
      INTEGER   MRKR(NEQ)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6),RESULT(IPRROW,3),RESLT1(22),RESLT2(22)
      REAL      RESLT3(22)
      CHARACTER FORM*1,LINE*(*),NAME*(*),FLAG_S*1
      INTEGER   IFL(200)
C CMS  NMGRPR,NMGRSM,NMGRSA,NMGR,NMGRRP,RFAC11,RFAC12,RFAC21,RFAC22
C CMS  RFAC31,RFAC32,RFAC41,RFAC42,RFAC51,RFAC52,RFAC61,RFAC62
      INTEGER   NMGRPR(22),NMGRSM(22),NMGRSA(22),NMGR(22),NMGRRP(22)
      REAL      RFAC11(22),RFAC12(22),RFAC21(22),RFAC22(22)
      REAL      RFAC31(22),RFAC32(22),RFAC41(22),RFAC42(22)
      REAL      RFAC51(22),RFAC52(22),RFAC61(22),RFAC62(22)
      CHARACTER   ITPF*4,STR*80
      CHARACTER   MSG*1,MSG1*1,MSG2*1,MSG5*1
      EXTERNAL  UNPACK
C==================================================================
      MM  =-ABS(MT)-1
      IPRROW22 = 22
      DO     I=1,22
        NMGR  (I)=0
        NMGRPR(I)=0
        NMGRSM(I)=0
        NMGRSA(I)=0
        NMGRRP(I)=0
        RFAC11(I)=0.
        RFAC21(I)=0.
        RFAC31(I)=0.
        RFAC41(I)=0.
        RFAC12(I)=0.
        RFAC22(I)=0.
        RFAC32(I)=0.
        RFAC42(I)=0.
        RFAC51(I)=0.
        RFAC52(I)=0.
        RFAC61(I)=0.
        RFAC62(I)=0.
        RESLT1(I)=0.
        RESLT2(I)=0.
        RESLT3(I)=0.
      ENDDO
C ---------------------------------------------------
100   CONTINUE
C      CALL DISPL_BL('RESMIN,RESMAX           :')
C      READ(*,*)   RESMIN,RESMAX
      IF(RESMAX.GT.RESMIN) THEN
        STOR=RESMIN
        RESMIN=RESMAX
        RESMAX=STOR
      ENDIF
C      RESMIN=RESMIN+0.001
C      RESMAX=RESMAX-0.001

      RESMX=RESMAX

      IF(RESCRD.GT.0.AND.RESCRD.GT.RESMAX) RESMX=RESCRD

      IF((RESMIN.EQ.RESMX).OR.
     *   (RESMIN.LE.0.0).OR.(RESMX.LE.0.0)) THEN
        IERR=1
        RETURN
      ENDIF 
      IF((RESMIN.EQ.RESMAX).OR.
     *   (RESMIN.LE.0.0).OR.(RESMAX.LE.0.0)) THEN
        IERR=1
        RETURN
      ENDIF 
      RHMIN =1./RESMIN
      RHMAX =1./RESMAX
      RHCMAX=1./RESMX
C -------------
      MSG2='N'
      IF(IANOM.EQ.1) MSG2='Y'
C --------------
      MSG='N'
      IF(ATOP.GT.0.0) MSG='Y'
      ICOUNT=0
      IPRNT=0
      SUMRFR=0.0
      DELRFR=0.0
      NRFR  =0
      NRFRT =0
      SUMFA =0.0
      DELFA =0.0
      NSMTTA=0
      NSMTA =0
      DELF  =0.0
      NPR   =0
      DSYM  =0.0
      SUMSYM=0.0
      SUMF  =0.0
      NSMTT =0
      NSMT  =0
      NREF  =0
      M     =0
      NBL   =0
      IEND  =-1
      RFAC  =0.0
      FAVER =0
C -------------------------------
      IF(FLAG_S.EQ.'Y') THEN
        ITPF='FS  '
        MSG1='Y'
      ELSE
        ITPF='F   '
        MSG1='N'
      ENDIF
      CALL WRITET(MT,MTOUT,NAME,LINE,ITPF,RLATT,RESMIN,RESMAX
     *   ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN

C------------------------------------------------------
C      MTOUT=11
      NNNREF=0
      ISUM1 =0.
      ISUM3 =0.
      ISUM10=0.
      SUMST =0.
      SUMIT =0.
      SUMSAT=0.
      SUMIAT=0.
      NBAD  =0
      SUMNCN=0.
      SUMCN =0.
      DELNCN=0.
      DELCN =0.
      NNCN  =0
      NCN   =0
      I     =0
      IN    =0
      IHOLD =-512
      IKOLD =-512
      ILOLD =-512
      KEND  =0
      N     =-1
      NOUT  = 0
      ISTTS1=0
      ISTTS =0
      ISTTS1=0
      ISTTS =0
C==========================================================================
      DO     IJKLM=1,NUMBT+1
        I=I+1
        IF(I.LE.NUMBT) THEN
          IDBL =IARRH(I)
          CALL UNPACK(IDBL,NH,NK,NL)
          CALL DSTAR_BL(NH,NK,NL,RS)
          RH=SQRT(RS)
c          IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) THEN
c             NOUT=NOUT+1
c             GO TO 430
c          ENDIF
          IF(RH.LT.RHMIN.OR.RH.GT.RHCMAX) THEN
             NOUT=NOUT+1
          ENDIF
          IF(RH.GT.1.E-8) THEN
            IRGR=1.0/(RH*0.5)
            IRGR=IRGR+1
            IF(IRGR.GT.22) IRGR=22
          ELSE
            IRGR=22
          ENDIF

          ISTATUS=IARRS(I)/(256*256)
          ITEMP  =IARRS(I)-ISTATUS*(256*256)
          JJSYM  =ITEMP/256
          NFL    =ITEMP-JJSYM*256
          JJSYM  =JJSYM-128
          FFF    =ARRF(I)
          SSS    =ARRS(I)

        ELSE
          NH = -513
          NK = -513
          NL = -513
          KEND=1
        ENDIF
        IF(IHOLD.EQ.NH.AND.IKOLD.EQ.NK.AND.ILOLD.EQ.NL) THEN
          N=N+1
          IF(N.GT.NEQ) THEN
            WRITE(STR,'('' !! NUMB EQUIV OR REPET-REFLS GT:'',I5)')NEQ
            CALL MSGERR(MT,STR)
            IERR=1
            RETURN
          ENDIF
          FSQ (N) =FFF
          IFL (N) =NFL
          SD  (N) =SSS
          MRKR(N) =JJSYM
          ISTTS1  = ISTATUS
          IF(IANOM.NE.1) MRKR(N)=IABS(MRKR(N))
C          IF(I.GE.NUMBT) GO TO 500
          GO TO 430
        ENDIF
C        IF(I.LT.NUMBT) GO TO 510
C -------------------------------------------------------------
C500     KEND=1
510     IF(IHOLD.NE.NH.OR.IKOLD.NE.NK.OR.ILOLD.NE.NL
     .                                    .OR.KEND.EQ.1) THEN
          IF(N.EQ.-1) GO TO 520
          IF(N.EQ. 0) GO TO 560
          IF(N.GT. 1) THEN
            CALL ISORT3(MRKR,N,IFL,FSQ,SD)
2032        CONTINUE
            DO     J=1,N
              NN=0
              IF(J.EQ.N) GO TO 2010
              IF(MRKR(J).EQ.0) GO TO 2010
              MMM=MRKR(J)
              I1=J+1
              NN=1
              IF(SD(J).LE.0.0000001) SD(J)=1.0
              WT=1./(SD(J)*SD(J))
              SM=FSQ(J)*WT
              SMW=WT
              DO     L=I1,N
                IF(MRKR(L).NE.MMM) GO TO 2011
                IF(SD(L).LE.0.0000001) SD(L)=1.0
                WT=1./(SD(L)*SD(L))
                SM=SM  +FSQ(L)*WT
                SMW=SMW+WT
                NN=NN+1
 2011           CONTINUE
              ENDDO
 2010         IF(MRKR(J).EQ.0) GO TO 2030
              IF(NN.LE.1) GO TO 2030
C------ANALISYS REPET-REFLS-----
              SSSSM=SM/SMW
              SSSSMW=1./SQRT(SMW)
              I1=J+1
              IBAD=0
              DO     L=J,N
                IF(MRKR(L).NE.MMM) GO TO 2031
                DEL   =ABS(SSSSM-FSQ(L))
                TTTT=DEL
                ATOPP=ATOP*SD(L)
                IF(MSG.EQ.'Y'.AND.TTTT.GT.ATOPP) THEN
C                 IF(IBAD.GE.NN-1) GO TO 2031
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,
     *              '('' IFL,<I>,SD:'',I5,2E12.4,A4)')
     *              IFL(L),SSSSM,SSSSMW,' BAD'
                    CALL MSGDOC(MT,STR)
                  ENDIF
                  IH=IHOLD
                  IK=IKOLD
                  IL=ILOLD
                  IF(MSG.EQ.'Y') THEN
                    NBAD=NBAD+1
                    IF(NBAD.LE.500) THEN
                      WRITE(STR,
     *                '('' RPT-H,K,L,I,SD:'',3I5,2E12.4)')
     *                IH,IK,IL,FSQ(L),SD(L)
                      CALL MSGDOC(MT,STR)
                      WRITE(STR,'('' --------'')')
                      CALL MSGDOC(MT,STR)
                      ICOUNT=ICOUNT+3
C                      IF(ICOUNT.GE.18.AND.MT.GE.0.AND.MT.LT.99) THEN
C                        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
C                        READ(*,'(A)') MSG5
C                        ICOUNT=0
C                      ENDIF
                    ENDIF
                  ENDIF
                  MRKR(L)=0
                  IBAD=IBAD+1
                ENDIF
 2031           CONTINUE
              ENDDO
              IF(IBAD.NE.0) GO TO 2032
C----------------------------------
              SM=SM/SMW
              SMW=1./SQRT(SMW)
              NRFR=NRFR+1
              NRFRT=NRFRT+1
              SUMRFR=SUMRFR+FSQ(J)
              DEL   =ABS(SM-FSQ(J))
              DELRFR=DELRFR+DEL
              NMGRRP(IRGR)=NMGRRP(IRGR)+1
              RFAC61(IRGR)=RFAC61(IRGR)+DEL
              RFAC62(IRGR)=RFAC62(IRGR)+FSQ(J)
              FSQ(J)=SM
              SD(J)=SMW
              I1=J+1
              DO     L=I1,N
                IF(MRKR(L).NE.MMM) GO TO 2033
                SUMRFR=SUMRFR+FSQ(L)
                DEL   =ABS(SM-FSQ(L))
                DELRFR=DELRFR+DEL
                NMGRRP(IRGR)=NMGRRP(IRGR)+1
                RFAC61(IRGR)=RFAC61(IRGR)+DEL
                RFAC62(IRGR)=RFAC62(IRGR)+FSQ(L)
                NRFRT=NRFRT+1
                MRKR(L)=0
 2033           CONTINUE
              ENDDO
 2030         CONTINUE
            ENDDO
          ENDIF
C
C --- CALC <F>-SYMM <FANOM>-SYM ---
C
471       CONTINUE
          ISTTS=ISTTS1
          FSYM=0.
          SWT=0.
          NSM=0
          FSYMA=0.
          SWTA =0.
          NSMA=0
          TDEL=0.
          TSUM=0.
          SSUMF=0.
          SSUMFA=0.
          SDELF=0.
          SDELFA=0.
          FAVER=0.
          FAVERA=0.
          FMAX=0.
          DO     L=1,N
            IF(MRKR(L).EQ.0) GO TO 540
            TEMP =ABS(FSQ(L))
            IF(SD(L).LE.0.0000001) SD(L)=1.0
            WT   =1./(SD(L)*SD(L))
            IF(MRKR(L).LE.0) THEN
              FSYMA=FSYMA+TEMP*WT
              FAVERA=FAVERA+TEMP
              SWTA=SWTA+WT
              NSMA=NSMA+1
            ELSE
              FSYM=FSYM+TEMP*WT
              IF(TEMP.GT.FMAX) THEN
                FMAX=TEMP
                SDMAX=WT
              ENDIF
              FAVER=FAVER+TEMP
              SWT=SWT+WT
              NSM=NSM+1
            ENDIF
540         CONTINUE
          ENDDO
          IF(NSM .NE.0) THEN
            FSYM=FSYM/SWT
            FAVER=FAVER/NSM
            SWT=1./SQRT(SWT)
          ENDIF
          IF(NSMA.NE.0) THEN
            FSYMA=FSYMA/SWTA
            FAVERA=FAVERA/NSMA
            SWTA=1./SQRT(SWTA)
          ENDIF
C ---
          IBAD=0
          IBADA=0
          ITOT=0
          ITOTA=0
          ATMIN=-1.E30
          ATMINA=-1.E30
          IF(N.LE.1) GO TO 490
C ---     ANALISYS !F-<F>!/<F>
          DO     L=1,N
            IF(MRKR(L).EQ.0) GO TO 470
            STOR=ABS(FSQ(L))
            SDTOR=ABS(SD(L))
            IF(MRKR(L).LE.0) THEN
              IF(NSMA.LE.1) GO TO 470
              ITOTA=ITOTA+1
              SSUMFA=SSUMFA+STOR
              DELTA= ABS(FSYMA-STOR)
              DDELTA= ABS(FAVERA-STOR)
              SDELFA=SDELFA+DELTA
              IF(MSG.EQ.'Y') THEN
                TATOP=DDELTA
                ATOPP=ATOP*SDTOR
                IF(ATMINA.LT.TATOP) ATMINA=TATOP
                IF(TATOP.GT.ATOPP) THEN
                  IBADA=IBADA+1
                ENDIF
              ENDIF
            ELSE
              IF(NSM.LE.1) GO TO 470
              ITOT=ITOT+1
              SSUMF=SSUMF+STOR
              TSUM=TSUM+STOR
              DELTA=ABS(FSYM-STOR)
              DDELT= ABS(FAVER-STOR)
              TDEL=TDEL+DELTA
              SDELF=SDELF+DELTA
              IF(MSG.EQ.'Y') THEN
                TATOP=DDELT
                ATOPP=ATOP*SDTOR
                IF(ATMIN.LT.TATOP) ATMIN=TATOP
                IF(TATOP.GT.ATOPP) THEN
                  IBAD=IBAD+1
                ENDIF
              ENDIF
            ENDIF
  470       CONTINUE
          ENDDO
C ------ PRINT OF BAD REFLEXION -----

          IF(IBAD.NE.0.OR.IBADA.NE.0) THEN

C          IBADD=0
C          IBADDA=0
          DO     L=1,N
            IF(MRKR(L).EQ.0) GO TO 472
            STOR=ABS(FSQ(L))
            SDTOR=ABS(SD(L))
            IF(MRKR(L).LE.0) THEN
              IF(NSMA.LE.1) GO TO 472
              DELTA= ABS(FSYMA-STOR)
              DDELTA=ABS(FAVERA-STOR)
              IF(MSG.EQ.'Y') THEN
C                IF(IBADDA.GE.NSMA-1) GO TO 472
                TATOP=DDELTA
                ATOPP=ATOP*SDTOR
                ATOPP=ATMINA
                IF(IBADA.NE.0.AND.ITOTA.EQ.2) ATOPP=0.
                IF(TATOP.GE.ATOPP) THEN
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,'('' ISYM,I,SD:'',I5,2E12.4,A4)')
     *                       MRKR(L),STOR,SD(L),' BAD'
                    CALL MSGDOC(MT,STR)
                    ICOUNT=ICOUNT+1
C                    IF(ICOUNT.GE.20.AND.MT.GE.0.AND.MT.LT.99) THEN
C                      CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
C                      READ(*,'(A)') MSG5
C                      ICOUNT=0
C                    ENDIF
                  ENDIF
C                  IBADDA=IBADDA+1
                  NBAD=NBAD+1
                  MRKR(L)=0
                ELSE
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,'('' ISYM,I,SD:'',I5,2E12.4)')
     *                           MRKR(L),STOR,SD(L)
                    CALL MSGDOC(MT,STR)
                    ICOUNT=ICOUNT+1
C                    IF(ICOUNT.GE.20.AND.MT.GE.0.AND.MT.LT.99) THEN
C                      CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
C                      READ(*,'(A)') MSG5
C                      ICOUNT=0
C                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
            ELSE
              IF(NSM.LE.1) GO TO 472
              IF(MSG.EQ.'Y') THEN
C                IF(IBADD.GE.NSM-1) GO TO 472
                DELTA=ABS(FSYM-STOR)
                DDELT=ABS(FAVER-STOR)
                TATOP=DDELT
                ATOPP=ATOP*SDTOR
                ATOPP=ATMIN
                IF(TATOP.GE.ATOPP) THEN
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,'('' ISYM,I,SD:'',I5,2E12.4,A4)')
     *                    MRKR(L),STOR,SD(L),' BAD'
                    CALL MSGDOC(MT,STR)
                    ICOUNT=ICOUNT+1
                    IF(ICOUNT.GE.20.AND.MT.GE.0.AND.MT.LT.99) THEN
                      CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
                      READ(*,'(A)') MSG5
                      ICOUNT=0
                    ENDIF
                  ENDIF
C                  IBADD=IBADD+1
                  NBAD=NBAD+1
                  MRKR(L)=0
                ELSE
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,'('' ISYM,I,SD:'',I5,2E12.4)')
     *                     MRKR(L),STOR,SD(L)
                    CALL MSGDOC(MT,STR)
                    ICOUNT=ICOUNT+1
C                    IF(ICOUNT.GE.20.AND.MT.GE.0.AND.MT.LT.99) THEN
C                      CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
C                      READ(*,'(A)') MSG5
C                      ICOUNT=0
C                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
  472       CONTINUE
          ENDDO
          IH=IHOLD
          IK=IKOLD
          IL=ILOLD
          IF(MSG.EQ.'Y') THEN
            IF(NBAD.LE.500) THEN
              IF(NSM.NE.0) THEN
                WRITE(STR,'(''  H, K, L,I,SD:'',3I5,2E12.4)')
     *                 IH,IK,IL,FAVER,SWT
                CALL MSGDOC(MT,STR)
                ICOUNT=ICOUNT+1
              ENDIF
              IF(NSMA.NE.0) THEN
                WRITE(STR,'('' -H,-K,-L,I,SD:'',3I5,2E12.4)')
     *               IH,IK,IL,FAVERA,SWTA
                CALL MSGDOC(MT,STR)
                ICOUNT=ICOUNT+1
              ENDIF
              WRITE(STR,'('' --------'')')
              CALL MSGDOC(MT,STR)
              ICOUNT=ICOUNT+1
C              IF(ICOUNT.GE.18.AND.MT.GE.0.AND.MT.LT.99) THEN
C                CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
C                READ(*,'(A)') MSG5
C                ICOUNT=0
C              ENDIF
            ENDIF
          ENDIF
          GO TO 471

          ENDIF

C ----------------------------------------------------------------
          IF(NSM.EQ.0.AND.NSMA.EQ.0) GO TO 521
          JPR=0
          IF(NSM.NE.0.AND.NSMA.NE.0) THEN
            SUMSYM=SUMSYM+FSYM+FSYMA
            SUMSMT=       FSYM+FSYMA
            DSYM=DSYM+ABS(FSYM-FSYMA)
            DSYMT=    ABS(FSYM-FSYMA)
            NPR=NPR+1
            JPR=1
          ENDIF
          DELF=DELF+SDELF
          DELFA=DELFA+SDELFA
          SUMF=SUMF+SSUMF
          SUMFA=SUMFA+SSUMFA
  490     CONTINUE
c          IF(NSMA.GT.0) THEN
          IF(NSMA.GT.1) THEN
            NSMTA=NSMTA+1
            NSMTTA=NSMTTA+NSMA
          ENDIF
c          IF(NSM .GT.0) THEN
          IF(NSM .GT.1) THEN
            NSMT =NSMT +1
            NSMTT=NSMTT+NSM
          ENDIF
          SUMST=SUMST+SWT
          SUMIT=SUMIT+FSYM
          FMOD=SQRT(FSYM)
          SSWT=SWT
          IF(FMOD.NE.0.) THEN
            SWT =(.5*SWT)/FMOD
            TEST=FMOD/SWT
            IF(TEST.GT. 1.) ISUM1=ISUM1  +1
            IF(TEST.GT. 3.) ISUM3=ISUM3  +1
            IF(TEST.GT.10.) ISUM10=ISUM10+1
            NNNREF=NNNREF+1
          ENDIF
          SUMSAT=SUMSAT+SWTA
          SUMIAT=SUMIAT+FSYMA
          FMODA=SQRT(FSYMA)
          SSWTA=SWTA
          IF(FMODA.NE.0.) THEN
            SWTA =(.5*SWTA)/FMODA
            TEST=FMODA/SWTA
            IF(TEST.GT. 1.) ISUM1= ISUM1 +1
            IF(TEST.GT. 3.) ISUM3= ISUM3 +1
            IF(TEST.GT.10.) ISUM10=ISUM10+1
            NNNREF=NNNREF+1
          ENDIF
          IH=IHOLD
          IK=IKOLD
          IL=ILOLD
          NREF=NREF+1
          IF(ITYP.NE.0.AND.NSM.GT.1) THEN
            ICENT=0
            IF((ITYP.EQ.1.OR.ITYP.EQ.5).AND.IH.EQ.0) ICENT=1
            IF((ITYP.EQ.2.OR.ITYP.EQ.5).AND.IK.EQ.0) ICENT=1
            IF((ITYP.EQ.3.OR.ITYP.EQ.5).AND.IL.EQ.0) ICENT=1
            IF(ITYP.EQ.4.AND.IH.EQ.IK) ICENT=1
            IF(ICENT.EQ.0) THEN
              SUMNCN=SUMNCN+TSUM
              DELNCN=DELNCN+TDEL
              NNCN=NNCN+1
            ELSE
              SUMCN=SUMCN+TSUM
              DELCN=DELCN+TDEL
              NCN=NCN+1
            ENDIF
          ENDIF

          NMGR(IRGR)=NMGR(IRGR)+1
          IF(JPR .EQ.1) NMGRPR(IRGR)=NMGRPR(IRGR)+1

c          IF(NSM .GT.0) THEN
          IF(NSM .GT.1) THEN
            NMGRSM(IRGR)=NMGRSM(IRGR)+1
          ENDIF
          RFAC11(IRGR)=RFAC11(IRGR)+SDELF
          RFAC12(IRGR)=RFAC12(IRGR)+SSUMF

          IF(NSM .GT.1) THEN
             NKR=IPRROW22-1
             DRK=(RHCMAX-RHMIN)/NKR
             KR=(RH-RHMIN)/DRK+1.
             IF(KR.GT.NKR) KR=NKR
             IF(KR.LT.1) KR=1
             RESLT1(KR)=RESLT1(KR)+SDELF
             RESLT1(IPRROW22)=RESLT1(IPRROW22)+SDELF
             RESLT2(KR)=RESLT2(KR)+SSUMF
             RESLT2(IPRROW22)=RESLT2(IPRROW22)+SSUMF
             RESLT3(KR)=RESLT3(KR)+NSM
             RESLT3(IPRROW22)=RESLT3(IPRROW22)+NSM
          ENDIF
         


c          IF(NSMA.GT.0) THEN
          IF(NSMA.GT.1) THEN
            NMGRSA(IRGR)=NMGRSA(IRGR)+1
          ENDIF

          RFAC21(IRGR)=RFAC21(IRGR)+SDELFA
          RFAC22(IRGR)=RFAC22(IRGR)+SSUMFA
          RFAC31(IRGR)=RFAC31(IRGR)+SSWT
          RFAC32(IRGR)=RFAC32(IRGR)+FSYM
          RFAC41(IRGR)=RFAC41(IRGR)+SSWTA
          RFAC42(IRGR)=RFAC42(IRGR)+FSYMA
          IF(JPR.EQ.1) THEN
            RFAC51(IRGR)=RFAC51(IRGR)+DSYMT
            RFAC52(IRGR)=RFAC52(IRGR)+SUMSMT
          ENDIF
          IF(IPRNT.GT.0) THEN
          IF(MOD(NREF,IPRNT).EQ.0) THEN
            IF(NSM.NE.0) THEN
              WRITE(STR,'(''  N,H,K,L,F,SD:'',I6,2X,3I5,2E12.4)')
     .             NREF,IH,IK,IL,FMOD ,SWT
              CALL MSGDOC(MT,STR)
            ENDIF
            IF(NSMA.NE.0) THEN
              IHM=-IH
              IKM=-IK
              ILM=-IL
              WRITE(STR,'(''  N,H,K,L,F,SD:'',I6,2X,3I5,2E12.4)')
     .             NREF,IHM,IKM,ILM,FMODA,SWTA
              CALL MSGDOC(MT,STR)
            ENDIF
          ENDIF
          ENDIF
          IF(MTOUT.GT.0) THEN
            KEY=ISTTS
            NBL=NBL+1
            IF(MSG1.NE.'N') THEN
              CALL WWRT(MTOUT,IH,IK,IL,FMOD,FMODA,SWT,SWTA,KEY,IEND)
            ELSE
              CALL WRT(MTOUT,IH,IK,IL,FMOD ,FMODA,KEY,IEND)
            ENDIF
            IF(MTOUT.LE.0) THEN
              IERR=1
              RETURN
            ENDIF
          ENDIF
521       CONTINUE
          IF(KEND.EQ.1) GO TO 560
520       N=1
          FSQ (N)=FFF
          SD  (N)=SSS
          IFL (N)=NFL
          MRKR(N)=JJSYM
          ISTTS1 =ISTATUS
          IF(IANOM.NE.1) MRKR(N)=IABS(MRKR(N))
          IHOLD=NH
          IKOLD=NK
          ILOLD=NL
        ENDIF
  430   CONTINUE
      ENDDO
C--------------------------------------------
560   IEND=2
      IF(MTOUT.GT.0) THEN
        CALL WRT(MTOUT,IH,IK,IL,FMOD,FMODA,NBL,IEND)
      ENDIF

c      IF(NRFR.GT.0.AND.SUMRFR.GT.0.0) THEN
c        DELRFR=DELRFR/SUMRFR
c      ENDIF
c      IF(NSMT.GT.0.AND.SUMF.GT.0.0) THEN
c        DELF=DELF/SUMF
c      ENDIF
c      IF(NSMT.GT.0.AND.SUMIT.GT.0.0) THEN
c        SUMST=SUMST/SUMIT
c      ENDIF
c      IF(NSMTA.GT.0.AND.SUMFA.GT.0.0) THEN
c        DELFA=DELFA/SUMFA
c      ENDIF
c      IF(NSMTA.GT.0.AND.SUMIAT.GT.0.0) THEN
c        SUMSAT=SUMSAT/SUMIAT
c      ENDIF
      IF(SUMRFR.GT.0.0) THEN
        DELRFR=DELRFR/SUMRFR
      ENDIF
      IF(SUMF.GT.0.0) THEN
        DELF=DELF/SUMF
      ENDIF
      IF(SUMIT.GT.0.0) THEN
        SUMST=SUMST/SUMIT
      ENDIF
      IF(SUMFA.GT.0.0) THEN
        DELFA=DELFA/SUMFA
      ENDIF
      IF(SUMIAT.GT.0.0) THEN
        SUMSAT=SUMSAT/SUMIAT
      ENDIF

      WRITE(STR,400) NREF
      CALL MSGDOC(MT,STR)
      IF(MSG.EQ.'Y') THEN
        WRITE(STR,'('' N-BAD-REFLS                :'',I6)') NBAD
        CALL MSGDOC(MT,STR)
      ENDIF
      IF(ITPF.EQ.'FS  ') THEN
      WRITE(STR,'('' F >SIG,>3SIG,>10SIG:'',3I8)') ISUM1,ISUM3,ISUM10
        CALL MSGDOC(MT,STR)
        IF(NNNREF.GT.0) THEN
          TEMP1=FLOAT(ISUM1 )/NNNREF
          TEMP2=FLOAT(ISUM3 )/NNNREF
          TEMP3=FLOAT(ISUM10)/NNNREF
        ELSE
          TEMP1=0.0
          TEMP2=0.0
          TEMP3=0.0
        ENDIF
      WRITE(STR,'(''                     '',3F8.3)') TEMP1,TEMP2,TEMP3
        CALL MSGDOC(MT,STR)
      ENDIF
      IF(NRFR.GT.0) THEN
        WRITE(STR,409) NRFR,NRFRT
        CALL MSGDOC(MT,STR)
        WRITE(STR,1409) DELRFR
        CALL MSGDOC(MT,STR)
      ENDIF
      IF(NSMT.LT.NSMTT) THEN
        WRITE(STR,406)  NSMT,NSMTT
        CALL MSGDOC(MT,STR)
        WRITE(STR,1406) DELF
        CALL MSGDOC(MT,STR)
      ELSE
        DELF=0.0
      ENDIF
      IF(ITPF.EQ.'FS  ') THEN
        WRITE(STR,416) SUMST
        CALL MSGDOC(MT,STR)
      ELSE
        SUMST=0.0
      ENDIF
      IF(ITYP.NE.0) THEN
        IF(NNCN.GT.0) DELNCN=DELNCN/SUMNCN
        IF(NCN .GT.0) DELCN =DELCN/SUMCN
        WRITE(STR,411) NCN
        CALL MSGDOC(MT,STR)
        WRITE(STR,1411) DELCN
        CALL MSGDOC(MT,STR)
        WRITE(STR,410) NNCN
        CALL MSGDOC(MT,STR)
        WRITE(STR,410) DELNCN
        CALL MSGDOC(MT,STR)
      ENDIF
      IF(IANOM.NE.0) THEN
        RFAC=0.
        IF(NSMTA.LT.NSMTTA) THEN
          WRITE(STR,407) NSMTA,NSMTTA
          CALL MSGDOC(MT,STR)
          WRITE(STR,1407) DELFA
          CALL MSGDOC(MT,STR)
          WRITE(STR,417) SUMSAT
          CALL MSGDOC(MT,STR)
        ENDIF
        IF(NPR.NE.0)THEN
          RFAC=2.0*DSYM/SUMSYM
          WRITE(STR,408) NPR
          CALL MSGDOC(MT,STR)
          WRITE(STR,1408) RFAC
          CALL MSGDOC(MT,STR)
        ENDIF
      ENDIF

C      MM=MT           
C      IF(MT.GE.0.AND.MT.LT.99) MM=0

      CALL MSGDOC(MM,' ')
      WRITE(STR,730)
  730 FORMAT(' ANGSTR:2.5   3.0   3.5   4.',
     *   '0   4.5   5.0   5.5   6.0   6.5   7.0   7.5   8.0')
      CALL MSGDOC(MM,STR)
      WRITE(STR,740) (NMGR(K),K=6,16)
  740 FORMAT(' N      ',11I6)
      CALL MSGDOC(MM,STR)
      DO     I=1,22
        IF(RFAC12(I).NE.0.) RFAC11(I)=RFAC11(I)/RFAC12(I)
        IF(RFAC22(I).NE.0.) RFAC21(I)=RFAC21(I)/RFAC22(I)
        IF(RFAC32(I).NE.0.) RFAC31(I)=RFAC31(I)/RFAC32(I)
        IF(RFAC42(I).NE.0.) RFAC41(I)=RFAC41(I)/RFAC42(I)
        IF(RFAC52(I).NE.0.) RFAC51(I)=RFAC51(I)/RFAC52(I)
        IF(RFAC62(I).NE.0.) RFAC61(I)=RFAC61(I)/RFAC62(I)
        IF(RESLT2(I).NE.0.) RESLT1(I)=RESLT1(I)/RESLT2(I)
      ENDDO
      IF(NSMT .GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,741) (RFAC11(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,743) (RFAC31(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRSM(K),K=6,16)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NSMTA.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,742) (RFAC21(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,744) (RFAC41(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRSA(K),K=6,16)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NPR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,747) (RFAC51(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRPR(K),K=6,16)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NRFR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,748) (RFAC61(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRRP(K),K=6,16)
        CALL MSGDOC(MM,STR)
      ENDIF
  741 FORMAT(' R-SYM  ',11F6.3)
  742 FORMAT(' R-SYM A',11F6.3)
  743 FORMAT(' R-STAN ',11F6.3)
  744 FORMAT(' R-STANA',11F6.3)
  747 FORMAT(' R-PAIRS',11F6.3)
  748 FORMAT(' R-REPET',11F6.3)
C ------------

C      MM=99
C      IF(MT.NE.0.AND.MT.LT.99) MM=-1

      WRITE(STR,745)
  745 FORMAT(' ANGSTR:0.0   0.5   1.0   1.',
     *   '5   2.0   2.5   3.0   3.5   4.0   4.5   5.0   5.5')
      CALL MSGDOC(MM,STR)
      WRITE(STR,740) (NMGR(K),K=1,11)
      CALL MSGDOC(MM,STR)
      IF(NSMT.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,741) (RFAC11(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,743) (RFAC31(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRSM(K),K=1,11)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NSMTA.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,742) (RFAC21(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,744) (RFAC41(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRSA(K),K=1,11)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NPR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,747)  (RFAC51(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRPR(K),K=1,11)
        CALL MSGDOC(MM,STR)
        CALL MSGDOC(MM,' ')
      ENDIF
      IF(NRFR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,748) (RFAC61(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRRP(K),K=1,11)
        CALL MSGDOC(MM,STR)
      ENDIF
      CALL MSGDOC(MM,' ')
      WRITE(STR,746)
  746 FORMAT(' ANGSTR:5.5   6.0   6.5   7.',
     *   '0   7.5   8.0   8.5   9.0   9.5  10.0  10.5  11.0')
      CALL MSGDOC(MM,STR)
      WRITE(STR,740) (NMGR(K),K=12,22)
      CALL MSGDOC(MM,STR)
      IF(NSMT .GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,741) (RFAC11(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,743) (RFAC31(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRSM(K),K=12,22)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NSMTA.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,742) (RFAC21(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,744) (RFAC41(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRSA(K),K=12,22)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NPR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,747)  (RFAC51(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRPR(K),K=12,22)
        CALL MSGDOC(MM,STR)
        CALL MSGDOC(MM,' ')
      ENDIF
      IF(NRFR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,748) (RFAC61(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRRP(K),K=12,22)
        CALL MSGDOC(MM,STR)
      ENDIF

C ------------------
      RESULT(1,1)=NREF
      RESULT(4,1)=DELF
      RESULT(5,1)=NSMT
      RESULT(6,1)=NSMTT
      RESULT(11,1)=DELRFR
      IF(IPRROW.GE.21) THEN
        RESULT(12,1)=NRFR
        RESULT(13,1)=NRFRT
        RESULT(21,1)=NOUT
      ENDIF
      N = IPRROW22
      IF(IPRROW.LT.N) N = IPRROW
      DO I=1,N
        RESULT(I,2)=RESLT1(I)
        RESULT(I,3)=RESLT3(I)
      ENDDO
      RETURN
C--------
  400 FORMAT(1X,'NUMB REFLS                   =',I6)
  406 FORMAT(1X,'NUMB SYMM REFLS(HKL)         =',I6,
     * '(before average',I6,')')
 1406 FORMAT(1X,'Rmerge INT(HKL)-SYMM         =',E12.4,
     .          ' S(!I-IAVER!)/S(I)')
  416 FORMAT(1X,'R-FAC-STAND S(SD)/S(I)       =',E12.4)
  417 FORMAT(1X,'R-FAC-STAND S(SD)/S(I)       =',E12.4)
  407 FORMAT(1X,'NUMB SYMM-ANOM-REFLS(-H-K-L) =',I6,
     *'(before average',I6,')')          
 1407 FORMAT(1X,'Rmerge INT(-H-K-L)-SYMM-ANOM =',E12.4)
  409 FORMAT(1X,'NUMB OF REPEATING REFLS      =',I6,
     * '(before average',I6,')')
 1409 FORMAT(1X,'Rmerge INT-multiple          =',E12.4,
     .       ' S(!I-IAVER!)/S(I)')
  408 FORMAT(1X,'NUMB PAIRS (I(HKL),I(-H-K-L))=',I6)
 1408 FORMAT(1X,'R-FAC                         =',E12.4,
     .      ' 2*S(!I1-I2!)/S(I1+I2)')
  410 FORMAT(1X,'NUMB OF NON-CENTR REFLS      =',I6)
 1410 FORMAT(1X,'R-FAC INT-NON-CENTRS.        =',E12.4,
     .       ' S(!I-IAVER!)/S(I)')
  411 FORMAT(1X,'NUMB OF CENTRSYM. REFLS      =',I6)
 1411 FORMAT(1X,'R-FAC INT-CENTRSYM.          =',E12.4,
     .       ' S(!I-IAVER!)/S(I)')
C ----------------------------------------------
      END

      SUBROUTINE SORTPH(MT,NAME,LINE,IARRH,IARRS,ARRF,ARRS
     * ,MAXREF,NUMBT,NEQ,RLATT,NSYM,ISYM,IPRSYM,RESMIN,RESMAX,IERR)
C ------------------------------------------------------------------
CMS      : IARRH,IARRS,ARRF,ARRS
      INTEGER    IARRH(MAXREF),IARRS(MAXREF)
      REAL       ARRF (MAXREF),ARRS (MAXREF)
      REAL       RLATT(6)
      CHARACTER  LINE*(*),NAME*(*)
      INTEGER*2  ISYM(5,3,IPRSYM)
      INTEGER    NMGR(22)
      CHARACTER  ITPF*4,STR*80
      EXTERNAL   UNPACK
C==================================================================
      PI=3.1415926
      DO     I=1,22
        NMGR(I)=0
      ENDDO
      IPRNT=0
C ---------------------------------------------------
100   CONTINUE
      IF(RESMAX.GT.RESMIN) THEN
        STOR=RESMIN
        RESMIN=RESMAX
        RESMAX=STOR
      ENDIF
      IF(RESMIN.EQ.RESMAX) GO TO 100
      IF(RESMIN.LE.0.0) GO TO 100
      IF(RESMAX.LE.0.0) GO TO 100
      RHMIN=1./RESMIN
      RHMAX=1./RESMAX
C ------------------------------------------------------------
      NREF  =0
      NBL   =0
      IEND  =-1
C -------------------------------
      ITPF='PH  '
      CALL WRITET(MT,MTOUT,NAME,LINE,ITPF,RLATT,RESMIN,RESMAX
     *    ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
C------------------------------------------------------
C      MTOUT=11
      IHOLD =-512
      IKOLD =-512
      ILOLD =-512
      I     =0
      NOUT=0
C==========================================================================
      DO     IJKLM=1,NUMBT
        I=I+1
        IDBL =IARRH(I)
        CALL UNPACK(IDBL,NH,NK,NL)
        CALL DSTAR_BL(NH,NK,NL,RS)
        RH=SQRT(RS)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) THEN
          NOUT=NOUT+1
          GO TO 430
        ENDIF
        IF(RH.GT.1.E-8) THEN
          IRGR=1.0/(RH*0.5)
          IRGR=IRGR+1
          IF(IRGR.GT.22) IRGR=22
        ELSE
          IRGR=22
        ENDIF
        ISTATUS=IARRS(I)/(256*256)
        ITEMP  =IARRS(I)-ISTATUS*(256*256)
        JJSYM  =ITEMP/256
        NFL    =ITEMP-JJSYM*256
        JJSYM  =JJSYM-128
        JSYM =IABS(JJSYM)
        FFF  =ARRF(I)
        SSS  =ARRS(I)
        IF(IHOLD.EQ.NH.AND.IKOLD.EQ.NK.AND.ILOLD.EQ.NL) GO TO 430
C ------------------
        IH=NH
        IK=NK
        IL=NL
        PHI=FFF-1.0
        FOM =SSS-1.0
        NREF=NREF+1
        NMGR(IRGR)=NMGR(IRGR)+1
        IF(IPRNT.GT.0) THEN
          IF(MOD(NREF,IPRNT).EQ.0) THEN
            WRITE(STR,'(''  N,H,K,L,PH,m:'',I6,2X,3I5,2E12.4)')
     .             NREF,IH,IK,IL,PHI,FOM
            CALL MSGDOC(M,STR)
          ENDIF
        ENDIF
        ANG=(PHI*3.1415926)/180.0
        COSPH=COS(ANG)*FOM
        SINPH=SIN(ANG)*FOM
        IF(JJSYM.LT.0) SINPH=-SINPH
        IF(JSYM.NE.1) THEN
          TEMP= IH*(REAL(ISYM(4,1,JSYM))/REAL(ISYM(5,1,JSYM)))
     *         +IK*(REAL(ISYM(4,2,JSYM))/REAL(ISYM(5,2,JSYM)))
     *         +IL*(REAL(ISYM(4,3,JSYM))/REAL(ISYM(5,3,JSYM)))
          ANG=2.0*PI*TEMP
          COST=COS(ANG)
          SINT=SIN(ANG)
          TEMP =COSPH*COST-SINPH*SINT
          SINPH=COSPH*SINT+SINPH*COST
          COSTH=TEMP
        ENDIF
        IF(MTOUT.GT.0) THEN
          NBL=NBL+1
          KEY=0
          CALL WRT(MTOUT,IH,IK,IL,COSPH,SINPH,KEY,IEND)
          IF(MTOUT.LE.0) THEN
            IERR=1
            RETURN
          ENDIF
        ENDIF
        IHOLD=NH
        IKOLD=NK
        ILOLD=NL
  430   CONTINUE
      ENDDO
C--------------------------------------------
560   IEND=2
      IF(MTOUT.GT.0) THEN
        CALL WRT(MTOUT,IH,IK,IL,FMOD,FMODA,NBL,IEND)
      ENDIF
C -------------
      M=MT
      IF(MT.GE.0.AND.MT.LT.99) M=0
      WRITE(LINE,400) NREF
      CALL MSGDOC(M,LINE)
  400 FORMAT(1X,'NUMB REFLS                   =',I6)
      CALL MSGDOC(M,' ')
      WRITE(LINE,730)
  730 FORMAT(' ANGSTR:2.5   3.0   3.5   4.',
     *   '0   4.5   5.0   5.5   6.0   6.5   7.0   7.5   8.0')
      CALL MSGDOC(M,LINE)
      WRITE(LINE,740) (NMGR(K),K=6,16)
  740 FORMAT(' N      ',11I6)
      CALL MSGDOC(M,LINE)
C--------
      M=99
      IF(MT.NE.0.AND.MT.LT.99) M=-1      
      WRITE(STR,400) NREF
      CALL MSGDOC(M,STR)
      WRITE(STR,745)
  745 FORMAT(' ANGSTR:0.0   0.5   1.0   1.',
     *   '5   2.0   2.5   3.0   3.5   4.0   4.5   5.0   5.5')
      CALL MSGDOC(M,STR)
      WRITE(STR,740) (NMGR(K),K=1,11)
      CALL MSGDOC(M,STR)
      CALL MSGDOC(M,' ')
      WRITE(STR,746)
  746 FORMAT(' ANGSTR:5.5   6.0   6.5   7.',
     *   '0   7.5   8.0   8.5   9.0   9.5  10.0  10.5  11.0')
      CALL MSGDOC(M,STR)
      WRITE(STR,740) (NMGR(K),K=12,22)
      CALL MSGDOC(M,STR)
C ------------------
      RETURN
      END

      SUBROUTINE WRITET(MT,MTOUT,NAME,LINE,ITPF,RLATT,RESMIN,RESMAX
     *    ,NSYM,ISYM,IPRSYM,IERR)
      REAL      RLATT(6),RESMIN,RESMAX
      INTEGER*4 IERR,MT
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER ITPF*4
      CHARACTER NAME*(*),LINE*(*)
C -----------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---------------------------------------------
c      RESMIN=RESMIN+0.001
c      RESMAX=RESMAX-0.001
      COEF  =1.0
      B     =0.0
      MTOUT =11
      M=-ABS(MT)-1
      CALL C_CR_WR
      CALL SET_TITLE(M,RLATT(1),RLATT(2),
     *  RLATT(3),RLATT(4),RLATT(5),RLATT(6),COEF,B,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,LINE,IERR)
      CALL OWFILE(M,MTOUT,NAME,ITPF,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE PRESFPDB(MDOC,FILE_PDB,FILE_CIF,IERR)
C ------------------------------------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER FILE_PDB*(*),FILE_CIF*(*)
C -----------------------------------------------------------
C    presfPDB - convert file of Structure Factors with PDB-format to CIFile.
C   
C
C  Dialog and Batch: 
C
C    FILE_SF_PDB  - input formatted PDB file of struture factors.
C                   (also simple formatted file with "h,k,l,!F!,sig(F)" 
C                    or "h,k,l,!F!,sig(F)" and without titles is acceptable)
C    FILE_SF_CIF  - output CIFile.
C
C  Parameters of subroutine PRESFPDB: 
C
C      SUBROUTINE PRESFPDB(MDOC,FILE_PDB,FILE_CIF,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    FILE_SF_PDB  - input formatted PDB file of struture factors.
C    FILE_SF_CIF  - output CIFile.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C 
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COM3FREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ----
      CHARACTER LINE*256,STR*256,PATH*1,EXT*3,CODE*4
      CHARACTER CONTENT*256,FORM*80,CH1*1,LINE1*256
C==================================================================
      IERR=0
      NREFLS=0
      N99=0
      MD=-ABS(MDOC)-1
      M=99
      MT=10
      PATH=' '
      EXT =' '
      LENC=0
      LENF=0
      CALL OPENFR(MT,M,PATH,FILE_PDB,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: CAN NOT OPEN INPUT_SF_FILE')
        CLOSE(MT)
        RETURN
      ENDIF
      CODE=FILE_PDB(1:4)
C ---------------------------
      IFORM=0
      IFIRST=0
 800  CONTINUE
      READ(MT,'(A)',END=100,ERR=200) STR
      CALL LENSTR_BL(STR,LEN)
      IF(IFIRST.EQ.0) THEN
        LINE1=STR
        IF(LEN.LE.0) GO TO 800
        IF(LEN.GT.0) THEN
          NB=0
          DO I=1,LEN
            IF(STR(I:I).EQ.' ') THEN
              NB=NB+1 
            ELSE
              GO TO 801
            ENDIF
          ENDDO
 801      CONTINUE
          IF(NB.GT.0) THEN
            DO I=1,LEN-NB
              LINE1(I:I)=STR(NB+I:NB+I)
            ENDDO
          ENDIF
        ENDIF
        IF(LINE1(1:1).EQ.'#') GO TO 800
      ENDIF
      IF(IFIRST.EQ.0.AND.LINE1(1:5).EQ.'data_') THEN
        CALL MSGDOC(MDOC,' ---  This is CIFile ---')
        FILE_CIF=FILE_PDB
        CLOSE(MT)
        RETURN
      ELSE
        IFIRST=1
        CALL MSGDOC(MDOC
     *  ,' ---  This is PDB_file of structure factors ---')
        CALL MSGDOC(MDOC
     *  ,'      Program will try to make scratch CIFile: "toblanc.cif"')
        CALL MSGDOC(MDOC
     *  ,'      and to convert it to the internal BLANC format.')
      ENDIF
      IF(STR(1:8).EQ.'*HEADER ') THEN

        CALL LENSTR_BL(STR,LEN)
        IF(LEN.GT.0) THEN
          CALL MSGDOC(MDOC,STR(1:LEN))
        ENDIF

 300    CONTINUE 
        READ(MT,'(A)',END=100,ERR=200) STR
        CALL LENSTR_BL(STR,LEN)
C        IF(LEN.GT.0) THEN
C          CALL MSGDOC(MDOC,STR(1:LEN))
C        ENDIF
        IF(STR(1:8).EQ.'*CONTNT ') THEN
          IF(LENC.GT.0) THEN
            CONTENT=CONTENT(1:LENC)//' '//STR(11:LEN) 
          ELSE
            CONTENT=' '//STR(11:LEN) 
          ENDIF              
          LENC=LENC+LEN+1
        ELSE IF(STR(1:8).EQ.'*FORMAT ') THEN
          IF(STR(LEN:LEN).NE.')') THEN
            STR(LEN+1:LEN+1)=STR(LEN+1:LEN+1)//')'
            LEN=LEN+1 
          ENDIF 
          FORM=STR(11:LEN)
          IF(STR(11:11).NE.'(') FORM='('//STR(11:LEN) 
          CALL LENSTR_BL(FORM,LENF)
        ELSE IF(STR(1:1).NE.'*') THEN
          GO TO 400
        ENDIF
        GO TO 300
      ELSE IF(STR(1:1).EQ.'*'.OR.STR(1:1).EQ.'#') THEN
        GO TO 800
      ELSE
        CALL MSGERR(MDOC,' ERR: unknown format of SF_PDB_file')
        CALL MSGERR(MDOC,'      Program will try to make CIFile')
        IFORM=-1
      ENDIF       
C ---------------------------
 400  CONTINUE  
C      IF(LENF.LE.0) THEN        
C        CALL MSGERR(MDOC,
C     *  ' ERR: can not find "FORMAT" card in SF_PDB_file')
C        IERR=1
C        CLOSE(MT)
C        RETURN
C      ENDIF
      IF(IFORM.GE.0) THEN
        IF(LENC.LE.0) THEN
          CALL MSGERR(MDOC,
     *    ' ERR: can not find "CONTNT" card in SF_PDB_file')
          IERR=1
          CLOSE(MT)
          RETURN
        ENDIF
        CALL CHECK_CNTNT(CONTENT,IPH,IPK,IPL,IFOBS,IFSIG
     *   ,IPHASE,IFCALC,IFORM)
        IF(IFORM.EQ.0) THEN
          CALL MSGERR(MDOC,
     *    ' ERR: can not read "CONTNT" card in SF_PDB_file')
          IERR=1
          CLOSE(MT)
          RETURN
        ENDIF
      ENDIF
C ---------------------------------------------------
      REWIND MT
      JERR=0
      MTOUT=11
      PATH=' '
      EXT =' '
      CALL OPENFW(MTOUT,M,PATH,FILE_CIF,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: CAN NOT OPEN SF_CIF_FILE')
        CLOSE(MT)
        CLOSE(MTOUT)
        RETURN
      ENDIF
      LINE='data_structure_'//CODE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
      LINE='_entry.id '//CODE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
      LINE='loop_'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
      IF(IFORM.GT.0) THEN
        DO I=1,IFORM
          IF(IPH.EQ.I) THEN
            LINE='_refln.index_h'
            CALL LENSTR_BL(LINE,LEN)
            WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
          ELSE IF(IPK.EQ.I) THEN
            LINE='_refln.index_k'
            CALL LENSTR_BL(LINE,LEN)
            WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
          ELSE IF(IPL.EQ.I) THEN
            LINE='_refln.index_l'
            CALL LENSTR_BL(LINE,LEN)
            WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
          ELSE IF(IFOBS.EQ.I) THEN
            LINE='_refln.F_meas_au'
            CALL LENSTR_BL(LINE,LEN)
            WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
          ELSE IF(IFSIG.EQ.I) THEN
c            LINE='_refln.F_meas_au_sigma'
            LINE='_refln.F_meas_sigma_au'
            CALL LENSTR_BL(LINE,LEN)
            WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
          ELSE IF(IPHASE.EQ.I) THEN
            LINE='_refln.phase_calc'
            CALL LENSTR_BL(LINE,LEN)
            WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
          ELSE IF(IFCALC.EQ.I) THEN
            LINE='_refln.F_calc'
            CALL LENSTR_BL(LINE,LEN)
            WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
          ELSE 
            WRITE(CH1,'(I1)') I-1
            LINE='_refln.dm'//CH1
            CALL LENSTR_BL(LINE,LEN)
            WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
          ENDIF
        ENDDO
      ELSE
        LINE='_refln.index_h'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
        LINE='_refln.index_k'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
        LINE='_refln.index_l'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
        LINE='_refln.F_meas_au'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(MTOUT,'(A)',ERR=700) LINE(1:LEN)
      ENDIF
C ---------------------------
      IFORM2=IFORM*2
      IFORM3=IFORM*3
      IFORM4=IFORM*4
      IFIRST=0
      ICOUNT=0
 500  CONTINUE
      LINE=' '
      READ(MT,'(A)',END=600,ERR=200) STR
      CALL LENSTR_BL(STR,LEN)
      IF(LEN.GT.0) THEN

        IF(LEN.GT.256.AND.IFIRST.EQ.0) THEN
          JERR=1
          IFIRST=1
          WRITE(LINE,'('' ERR: Length of records > 256'')') 
          CALL MSGERR(MDOC,LINE)
        ENDIF
         
        IF(STR(1:1).EQ.'*') THEN
          STR(1:1)='#'
          IF(NREFLS.EQ.0) THEN
            CALL MSGDOC(MDOC,STR(1:LEN))
          ENDIF
        ELSE
          IF(NREFLS.EQ.0) THEN
            IF(ICOUNT.LT.3) THEN
              CALL MSGDOC(MDOC,STR(1:LEN))
            ENDIF
            ICOUNT=ICOUNT+1
          ENDIF
          DO J=1,LEN
            CALL CHKSMB(STR(J:J),CH1)
            IF(CH1.NE.'D'.AND.CH1.NE.'S'.AND.
     *        STR(J:J).NE.'.') THEN
              STR(J:J)=' '
            ENDIF
          ENDDO
          IN_STRING=STR(1:LEN)
          CALL FRD_4PARM
          IF(NREFLS.EQ.0) THEN
            IF(NWORDS.LE.0) GO TO 500
            IF(IFORM.GT.0) THEN
              IF(NWORDS.NE.IFORM .AND.NWORDS.NE.IFORM2.AND.
     *           NWORDS.NE.IFORM3.AND.NWORDS.NE.IFORM4) THEN
c                JERR=1
                IF(ICOUNT.LT.3) THEN
                  CALL MSGERR(MDOC
     *            ,' ERR: wrong number of items in SF_PDB_FILE')
                  CALL MSGERR(MDOC
     *            ,'      check SF_CIFile and maybe run again')
                ENDIF
                ICOUNT=ICOUNT+1
              ENDIF
            ELSE IF(IFORM.LT.0) THEN
              IF(NWORDS.LT.4) THEN
c                JERR=1
                IF(ICOUNT.LT.3) THEN
                  CALL MSGERR(MDOC
     *            ,' ERR: wrong number of items in SF_PDB_FILE')
                  CALL MSGERR(MDOC
     *            ,'      check SF_CIFile and maybe run again')
                ENDIF
                ICOUNT=ICOUNT+1
                IFORM=4
              ELSE IF(NWORDS.EQ.5) THEN
                LINE='_refln.F_dm'
                CALL LENSTR_BL(LINE,LN)
                WRITE(MTOUT,'(A)',ERR=700) LINE(1:LN)
                IFORM=5
              ELSE IF(NWORDS.GT.5) THEN
                LINE='_refln.dm'
                CALL LENSTR_BL(LINE,LN)
                WRITE(MTOUT,'(A)',ERR=700) LINE(1:LN)
                DO J=1,NWORDS-5
                  WRITE(CH1,'(I1)') J-1
                  LINE='_refln.dm'//CH1
                  CALL LENSTR_BL(LINE,LN)
                  WRITE(MTOUT,'(A)',ERR=700) LINE(1:LN)
                ENDDO
                IFORM=NWORDS
              ELSE
                IFORM=4
              ENDIF
              IFORM2=IFORM*2
              IFORM3=IFORM*3
              IFORM4=IFORM*4
            ENDIF
          ENDIF
          IF(NWORDS.LE.0) GO TO 500
          IF(IFORM.LE.0)  GO TO 500
          IF(NWORDS.NE.IFORM .AND.NWORDS.NE.IFORM2.AND.
     *    NWORDS.NE.IFORM3.AND.NWORDS.NE.IFORM4) THEN
            L=LEN_WORDS(1)
            STR=WORDS(1)(1:L)
            LS=L
            NF=IFORM
C           IF(NWORDS.GT.IFORM2) NF=IFORM2
C           IF(NWORDS.GT.IFORM3) NF=IFORM3
C           IF(NWORDS.GT.IFORM4) NF=IFORM4
            DO I=2,NF
              L=LEN_WORDS(I)
              STR=STR(1:LS)//' '//WORDS(I)(1:L)
              LS=LS+L+1
            ENDDO
            LEN=LS
          ENDIF
C123456789 123456789 123456789 123456789 123456789 
C0       1        0        0    0.000   99.990    1.000
          
          IF(STR(40:45).EQ.'99.990') THEN
            IF(N99.LT.10) THEN
            CALL MSGERR(MDOC
     *      ,' WARNING: reflection with SIGMA=99.99 is not accepted')
            ELSE IF(N99.EQ.10) THEN
            CALL MSGERR(MDOC
     *      ,' WARNING: ... more ... reflections with SIGMA=99.99')
            ENDIF
            N99=N99+1
            GO TO 500
          ENDIF
          NREFLS=NREFLS+1
        ENDIF
        WRITE(MTOUT,'(A)',ERR=700) STR(1:LEN)
      ENDIF
      GO TO 500
 600  CONTINUE
      IERR=JERR
      END FILE MTOUT
      CLOSE(MT)
      CLOSE(MTOUT)
      WRITE(LINE,'('' Number of records :'',I8)') NREFLS
      IF(N99.GT.0) THEN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''WARNING: Number of refls with sigma=99.99 :'',I8)') 
     * N99
      CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NREFLS.LE.1) THEN
        IERR=1
        WRITE(LINE,'('' ERR: Number of records :'',I8)') NREFLS
        CALL MSGERR(MDOC,LINE)
      ENDIF
      RETURN
C ---------------------------
 100  CALL MSGERR(MDOC,' ERR: END OF SF_PDB_FILE')
      CLOSE(MT)
      IERR=1
      RETURN
C ---------------------------
 200  CALL MSGERR(MDOC,' ERR: READ SF_PDB_FILE')
      CLOSE(MT)
      IERR=1
      RETURN
C ---------------------------
 700  CALL MSGERR(MDOC,' ERR: WRITE SF_CIF_FILE')
      CLOSE(MT)
      IERR=1
      RETURN
C ---------------------------
      END

      SUBROUTINE CHECK_CNTNT(STR,IPH,IPK,IPL,IFOBS,IFSIG
     *   ,IPHASE,IFCALC,IFORM)
      CHARACTER STR*(*)
      INTEGER   IPH,IPK,IPL,IFOBS,IFSIG,IFORM,IPHASE
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COM3FREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C -------------------------------------------------------
      IPH=0
      IPK=0
      IPL=0
      IFOBS=0
      IFSIG=0
      IFORM=0
      IFMEAN=0
      IPHASE=0
      IFCALC=0
      IN_STRING=STR
      CALL FRD_3PARM

      IF(NWORDS.LT.4) RETURN

      DO I=1,NWORDS
        IF(LEN_WORDS(I).EQ.1.AND.WORDS(I)(1:1).EQ.'H') IPH=I
        IF(LEN_WORDS(I).EQ.1.AND.WORDS(I)(1:1).EQ.'K') IPK=I
        IF(LEN_WORDS(I).EQ.1.AND.WORDS(I)(1:1).EQ.'L') IPL=I
        IF(LEN_WORDS(I).EQ.4.AND.WORDS(I)(1:2).EQ.'FP') IFOBS=I
        IF(LEN_WORDS(I).EQ.4.AND.WORDS(I)(1:4).EQ.'FOBS') IFOBS=I
        IF(LEN_WORDS(I).EQ.5.AND.WORDS(I)(1:5).EQ.'FMEAN')IFMEAN=I
        IF(LEN_WORDS(I).GE.5.AND.WORDS(I)(1:5).EQ.'SIGMA') IFSIG=I
        IF(LEN_WORDS(I).GE.9.AND.WORDS(I)(1:9).EQ.'ABS(FOBS)')IFOBS=I
        IF(LEN_WORDS(I).GE.5.AND.WORDS(I)(1:5).EQ.'PHASE')IPHASE=I
        IF(LEN_WORDS(I).GE.5.AND.WORDS(I)(1:5).EQ.'FCALC')IFCALC=I
      ENDDO        
      IF(IFOBS.EQ.0) IFOBS=IFMEAN
      IF(IPH.EQ.0.OR.IPK.EQ.0.OR.IPL.EQ.0.OR.IFOBS.EQ.0) THEN
        IFORM=0
      ELSE
        IFORM=NWORDS
      ENDIF

      RETURN
      END

      SUBROUTINE FRD_3PARM
C -------------------------------------------------------
C     FRD_3PARM - free format reading of the string of characters.
C                See common /COM3FREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'" or ",".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C 
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COM3FREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*80
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      LN=0
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.NE.' ') THEN
          LN=LN+1
          IN_STRING(LN:LN)=CH
        ENDIF
      ENDDO
      LEN=LN
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.EQ.',') CH=' '
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

      SUBROUTINE FRD_4PARM
C -------------------------------------------------------
C    FRD_4PARM - free format reading of the string of characters.
C                See common /COM3FREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'" or "," or " ".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C 
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COM3FREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*80
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.EQ.',') CH=' '
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      


C -I-
      SUBROUTINE FLSTAT(MDOC,MODE,POOL,MEMORY,NAME1,NAME2,BOFF
     *  ,RESMIN,RESMAX,ATOP
     *  ,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
C ---------------------------------------------------
C 
C -P- FLSTAT : gives statistics about files F or PH or DENS.
C
C          FLSTAT calculates and writes to DOC_file some statistic 
C          such as distrubition of density or of structure factors, R-factors 
C          between two files, difference between two structure factors, 
C          difference between two phase angles, anomaloues characteristics of
C          structure factors, on resolutions and on absolute values of these
C          informations. Program may print these values in resiprocal space
C          for each l-planes. Results depend on how many files will be 
C          reading. And much more...
C -S-   
C      Dialog:
C
C    MODE     -  function : FMOD / PHAS / PLAN / ANGL / ANOM / DENS / END /
C               You may choose function which you want to operate: 
C          FMOD if you want calculate distrubition of structure factors on 
C               the resolutions and on the modules of structure factors,
C               R-factor between two files of structure factors or standart
C               R-factors (R=SUM(SIGMA)/SUM(F) and their distrubitions, 
C               completenees;
C          PHAS if you want to calculate distrubition of figure of
C               merit, difference between two figure of merits on the 
C               resolution  and on the value of figure of merit; 
C          PLAN you want to look through these files in reciprocal space 
C               for each l-planes;
C          ANGL if you want to calculate distrubition of values of 
C               angles, difference between angles;
C          ANOM you want look to characteristics of anomalues defferences.
C          DENS if you want to calculate distrubition of values of 
C               density, difference between two files of density,density
C               histogram; distribution along some line.
C          END  exit of program.
C
C    FILE_1   -  name of input_file_1.
C    FILE_2   -  name of input_file_2, if you want it, if not tape CR.
C    RESOL    -  MIN,MAX - resolution. Default values will be taken from files.
C
C    SCALE    -  for MODE='PLAN' means:
C                        SCALING : F-new = F * TOP 
C                                  F-new values > 10 will show as "*"
C                                  Others - " ","1","2",...,"9".
C    ATOP     -  for MODE = 'FMOD', 'PHAS', 'ANGL', 'ANOM':
C                maximal value of F or ANGLE or FOM which will be
C                accepted, t.e from 0 to ATOP.
C                       Default value is:    
C                          for PHAS :  FOM  - MAX = <  1.0>
C                          for F    : ! F ! - MAX = <100.0>
C                          for ANGL : ANGLE - MAX = <180.0>
C
C     BOFF:   <0> , 240 corresponds to RESmin=10 /aprox./
C                      / F-new = Fold*(1-exp(-Boff*s**2))/
C
C    for MODE='DENS'
C
C       ATOP: <1>  , Dmax_new =  Dmax*ATOP /for density histogram/
C       LINE: IX,IY,IZ - density distribution along:
C                         X - if IX=-1 for line (IY,IZ),    
C                         Y - if IY=-1 for line (IX,IZ),    
C                         Z - if IZ=-1 for line (IX,IY),    
C
C      It possible to use subroutine FLSTAT by program:
C
C      SUBROUTINE FLSTAT(MDOC,MODE,POOL,MEMORY,NAME1,NAME2,BOFF
C     *  ,RESMIN,RESMAX,ATOP
C     *  ,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
C
C
C    STOP_T   - Y/<N>  Y - make stop of writing to terminal for reading.
C
C  Parameters: 
C
C    MDOC  - mode of writting messages to DOC-file
C            0 - only terminal , < - 0 only file, 0 < < 99 - both
C            >= 99 - don't write  
C    MODE    - function: FMOD or PHAS or PLAN or ANGL or ANOM or DENS.
C              see above.
C    POOL    - working array / real /. Dimension is equal MEMORY.
C    MEMORY  - dimension or array POOL, for sections of density
C                                             NX*NY =< MEMORY           
C    NAME1   - name of input_file_1.
C    NAME2   - name of input_file_2, if you want it, else NAME2=' '.
C    RESMIN  - resolution. Default values will be taken from files.
C    RESMAX
C    ATOP    - see above.
C    BOFF   <0> , 240 corresponds to RESmin=10 /aprox./
C                For suppressing low resolutin reflections, kind of 
C                modeling desordered solvent: Fnew=(1-exp(-Boff*s**2))*Fold    
C    IX,IY,IZ - density distribution along:
C                   X - if IX=-1 for line (IY,IZ),    
C                   Y - if IY=-1 for line (IX,IZ),    
C                   Z - if IZ=-1 for line (IX,IY),    
C    STOP_T  - /character*1/ see above.
C    ISYM    - integer*2 array for cryst.symmetry operators.
C    IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM),
C              number of cryst. symm. operators.
C    IERR    - output signal of error / =1 -error , =0 - OK / 
C
C    RESULT /real RESULT(IPRROW,11)/ - array for output information:
C    IPRROW may be = 11 or 21.
C
C  MODE = "FMOD" and two input files.
C
C  RESULT(I,1)-resolution (A),from resmin=RESULT(1,1) to resmax=RESULT(IPRROW,1)
C  RESULT(I,2) - number of the pairs of structure factors 
C  RESULT(I,3) - R-factors , RESULT(IPRROW,3) - total R-factors
C  RESULT(I,4) - corr.
C  RESULT(I,5) - R-factors for Luzzati plot with RMS_L.
C  RESULT(*,5) = RMS_L - upper estimate error in coords by Luzzati plot.
C  RESULT(I,6) - number of structure factors F(h,k,l)
C
C  MODE = "FMOD" and one input file.
C
C  RESULT(I,1)-resolution (A),from resmin=RESULT(1,1) to resmax=RESULT(IPRROW,1)
C  RESULT(I,7) - <F(h,k,l)>
C  RESULT(I,8) - completeness
C  RESULT(I,9) - <sigma(F(h,k,l))>/<F(h,k,l)>
C  RESULT(I,11) -  <F>*EXP(-Bover*S**2) 
C                      RESULT(IPRROW,11)= Boverall/estimated by Wilson plot/
C  RESULT(I,12) - number of structure factors F(h,k,l)
C
C  RESULT(1,10) = No of the structure factors for this limits of resolution
C  RESULT(2,10) = Actual No of the structure factors
C  RESULT(3,10) = No of F(-h,-k,-l)
C  RESULT(4,10) = Fmin
C  RESULT(5,10) = Fmax
C  RESULT(6,10) = Nabs
C  RESULT(7,10) = Nadd
C  RESULT(8,10) = <F(h,k,l)>
C  RESULT(9,10) = <F> = sqrt (<I>) /estimated by Wilson plot/
C  RESULT(10,10)=  B_overall
C  RESULT(11,10)= <F(-h,-k,-l)>
C  RESULT(12,10)= F(h,k,l)min
C  RESULT(13,10)= F(h,k,l)max
C  RESULT(14,10)= F(-h,-k,-l)min
C  RESULT(15,10)= F(-h,-k,-l)max
C  RESULT(16,10)= <F(h,k,l)**2>
C  RESULT(17,10) = No of F(-h,-k,-l)
c  RESULT(19,10)= RFAC_S
C  RESULT(18,10)= RESLIM 
c  RESULT(20,10)= RCORR_S
C  RESULT(21,10)= RFREE
C
c  RESULT(I,21) = RFREEK(I)
C
C
C  MODE = "ANGL" 
C
C  RESULT(I,1)-resolution (A),from resmin=RESULT(1,1) to resmax=RESULT(IPRROW,1)
C  RESULT(I,2) - number of the pairs of structure factors 
C  RESULT(I,3) - <DELTA>  in grad. , RESULT(IPRROW,3) - total <delata>
C
C  MODE = "DENS" 
C
C      RESULT(1,1) = AVER1
C      RESULT(2,1) = DMAX1T
C      RESULT(3,1) = DMIN1T
C      RESULT(4,1) = RMS1
C      RESULT(5,1) = AVER2
C      RESULT(6,1) = DMAX2T
C      RESULT(7,1) = DMIN2T
C      RESULT(8,1) = RMS2
C      RESULT(9,1) = RCORRD
C      RESULT(10,1)= RESOL1
C      RESULT(11,1)= AMOM31
C      NKR=NK
C      IF(NKR.GT.20) NKR=20
C      RESULT(1,2)=NKR
C      RESULT(1,2)=RMIN1
C      RESULT(1,2)=RMAX1
C      RESULT(1,2)=RMIN2
C      RESULT(1,2)=RMAX2
C      IF(IPRROW.GE.21) THEN
C        RESULT(12,1)= AMOM41
C        RESULT(13,1)= RMSD
C        RESULT(14,1)= AVERD
C        RESULT(15,1)= RMSP
C        RESULT(16,1)= RMSN
C        RESULT(17,1)= RMSP2
C        RESULT(18,1)= RMSN2
C        RESULT(19,1)= RMSPD
C        RESULT(20,1)= RMSND
C        RESULT(21,1)= 0.0
C  ---    Histograms ---
C        DO I=1,NKR   
C          RESULT(I,3)=NPOINT(I)    
C          RESULT(I,4)=NPOINT2(I)
C        ENDDO
C      ENDIF
C -I-
C ------------------------------
CMS      : POOL
      REAL      POOL(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,21)
      REAL      ATOP,RESMIN,RESMAX
      INTEGER*4 NCREST,MDOC,IERR
      CHARACTER NAME1*(*),NAME2*(*),MODE*4,STOP_T*1
C ------------------
      INTEGER*4 NCRES
C====================================================================
      IF(STOP_T.EQ.'y') STOP_T='Y'
      IF(STOP_T.NE.'Y') STOP_T='N'
      CALL CHECK_BATCH(IBAT)
      IF(IBAT.NE.0) STOP_T='N'
C ------------------------------------------
      NCREST=MEMORY/2
      NCRES =MEMORY
      IF(MODE.EQ.'PLAN') THEN
        CALL PLAN(MDOC,NAME1,NAME2,RESMIN,RESMAX,ATOP
     *            ,STOP_T,ISYM,IPRSYM,IERR)
      ELSE IF(MODE.EQ.'DENS') THEN
        CALL STDENS(MDOC,POOL,POOL(NCREST+1),NCRES,NAME1,NAME2
     *   ,IXL,IYL,IZL,ATOP,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)
      ELSE IF(MODE.EQ.'PHAS'.OR.MODE.EQ.'ANGL') THEN
        CALL STATP(MODE,MDOC,NAME1,NAME2,RESMIN,RESMAX,ATOP
     *            ,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)
      ELSE IF(MODE.EQ.'ANOM') THEN
        CALL STATA(MODE,MDOC,NAME1,NAME2,RESMIN,RESMAX,ATOP
     *            ,STOP_T,ISYM,IPRSYM,IERR)
      ELSE
        CALL STATF(MODE,MDOC,NAME1,NAME2,BOFF,RESMIN,RESMAX,ATOP
     *            ,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)
      ENDIF
      RETURN
      END

      SUBROUTINE STATF(ITPR,MDOC,NAME1,NAME2,BOFF,R1,R2,ATOP
     * ,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C -----------------------------------------------
      REAL      R1,R2,ATOP
      REAL      RESULT(IPRROW,21)
      INTEGER   MDOC,IPRSYM,IERR
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAME1*(*),NAME2*(*),ITPR*4
C ----------------------------------------------
      INTEGER   NUMB1,ISTOR
      INTEGER   NF(11,21),NFA(11,21),ICOMPL(21)
      REAL      RHR(21),FM(21),FMA(21),ATR(11)
      REAL      ANF(11,21),ANFA(11,21),RLATT(6)
      REAL      RNF(21),RNFA(21),RHRB(21)
      REAL      SUM11(11,21),SUM12(11,21)
      REAL      SUM21(11,21),SUM22(11,21)
      REAL      SUM31(11,21),SUM32(11,21)
      REAL      SUM33(11,21),SUM34(11,21)
      REAL      SUM35(11,21),SUMF2(21),SUMF1(21),SUMF3(21),SUMF4(21)
      REAL      SUMF5(21),SUMF6(21)
      REAL      RFREEK(21),DLFREEK(21)
      CHARACTER STOP_T*1
      CHARACTER ITP1*4,ITP2*4,ITF1*4,ITF2*4
      CHARACTER TTT*80,LINE*80
      CHARACTER MSG*1,MSG1*1
C================================================================
      PI=4.0*ATAN(1.0)
      IF(STOP_T.EQ.'N') THEN
        MD=-ABS(MDOC)-1
      ELSE
        MD=MDOC
      ENDIF
      MDD=-ABS(MDOC)-1
C ------------------------------------------------------
      IF(IERR.NE.0) THEN
        RESNL = RESULT(1,1)
        RESXL = RESULT(2,1)
        SIGL  = RESULT(3,1)
        LIM_FLAG = RESULT(4,1)
        RESULT(1,1) = 0.0
        RESULT(2,1) = 0.0
        RESULT(3,1) = 0.0
        RESULT(4,1) = 0.0
      ELSE
        RESNL    = 6.0
        RESXL    = 0.0
        SIGL     = 1.5
        LIM_FLAG = 0
      ENDIF
      IERR=0
      IF(SIGL.LE.0.0) SIGL=1.0
C -----------------------------------------------------
C     CALL MSGDOC(MDOC,'INPUT FILE-1')
      MT1 =11
      ITP1='    '
c      MD=-1
      CALL ORFILE(MDD,MT1,NAME1,ITP1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-1')
        RETURN
      ENDIF
      CALL GET_TITLE(MDD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,NX,NY,NZ,IZN,IZM,TTT,IERR)
      CALL C_RD_CR
      RN=RESMIN
      RX=RESMAX
      IF(ITP1.NE.'F   '.AND.ITP1.NE.'FS  ') THEN
        CALL MSGERR(MDOC,' ERR: WRONG TYPE OF FILE')
        CLOSE(MT1)
        IERR=1
        RETURN
      ENDIF
      ITF1=ITP1
      IF(ITP1.EQ.'FS  ') ITP1='F   '
C ---------------------------------------------------
      MT2 =0
      MSG='N'
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',') THEN
        MSG='Y'
        MT2 =12
        ITP2='    '
c        MD=-1
        CALL ORFILE(MDD,MT2,NAME2,ITP2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MDD,A,B,C,AL,BE,GA
     *    ,F1,F2,RESMIN,RESMAX,NX,NY,NZ,IZN,IZM,TTT,IERR)
        IF(ITP2.NE.'F   '.AND.ITP2.NE.'FS  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE OF FILE')
          IERR=1
          CLOSE(MT1)
          CLOSE(MT2)
          RETURN
        ENDIF
        ITF2=ITP2
        IF(ITP2.EQ.'FS  ') ITP2='F   '
        IF(RN.LT.RESMIN)   RESMIN=RN
        IF(RX.GT.RESMAX)   RESMAX=RX
        IF(ITP1.NE.ITP2) THEN
          CALL MSGERR(MDOC,' ERR: TYPE OF FILE-1 # TYPE OF FILE-2')
          IERR=1
          CLOSE(MT1)
          CLOSE(MT2)
          RETURN
        ENDIF
      ENDIF
C ---------------------------------------------------
      IF(ATOP.LE.1.E-6) THEN
        ATOP=100.
      ENDIF
      WRITE(LINE,'('' ATOP:'',F10.3)') ATOP
      CALL MSGDOC(MD,LINE)
C ---------------------------------------------------
      IF(R1.LT.R2) THEN
        T=R1
        R1=R2
        R2=T
      ENDIF
      IF(R1.GT.1.E-5.AND.R2.GT.1.E-5) THEN
        RESMIN=R1
        RESMAX=R2
      ENDIF
      WRITE(LINE,'('' RESMIN,RESMAX :'',2F10.3)') RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      RHMIN=1./RESMIN
      RHMAX=1./RESMAX
      IF(RESNL.GT.RESMIN) RESNL=RESMIN
      IF(RESXL.LT.RESMAX) RESXL=RESMAX
      RHMINL=1./RESNL
      RHMAXL=1./RESXL
C ---------------------------------------------------------
      NRFL_D=0
      DO    I=1,IPRROW
        ICOMPL(I) = 0
        RNF (I)   = 0.0
        RNFA(I)   = 0.0
        FM  (I)   = 0.0
        FMA (I)   = 0.0
        SUMF1(I)  = 0.0
        SUMF2(I)  = 0.0
        SUMF3(I)  = 0.0
        SUMF4(I)  = 0.0
        SUMF5(I)  = 0.0
        SUMF6(I)  = 0.0
        RFREEK(I) = 0.0
        DLFREEK(I)= 0.0
        DO    J=1,11
          ANF  (J,I) = 0.0
          ANFA (J,I) = 0.0
          NF   (J,I) = 0
          NFA  (J,I) = 0
          SUM11(J,I) = 0.0
          SUM21(J,I) = 0.0
          SUM12(J,I) = 0.0
          SUM22(J,I) = 0.0
          SUM31(J,I) = 0.0
          SUM32(J,I) = 0.0
          SUM33(J,I) = 0.0
          SUM34(J,I) = 0.0
          SUM35(J,I) = 0.0
        ENDDO
      ENDDO
      NUMB1   = 0
      NUMB2   = 0
      IEND1   =-1
      IEND2   =-1
      DLFREE  = 0.0
      DLREST  = 0.0
      FSFREE  = 0.0
      FSREST  = 0.0
      DDEL    = 0.0
      DDEL2   = 0.0
      FSUM    = 0.0
      DDEL_S  = 0.0
      FSUM_S  = 0.0
      FSUM1   = 0.0
      FSM21   = 0.0
      FSM22   = 0.0
      FSM12   = 0.0
      NO_C    = 0
      NO_USED = 0
      FSM12_C = 0.0
      FSM22_C = 0.0
      FSM21_C = 0.0
      FSUM_C  = 0.0
      FSUM1_C = 0.0
      NO      = 0
      NOFREE  = 0
      NOREST  = 0
      ATR(1)  = 0.0
      JH      = 0
      JK      = 0
      JL      = 0
      FFA     = 0.0
      FFB     = 0.0
C     NK < IPRROW , NDF < 11
      NK     = IPRROW-1
      DR     = (RHMAX-RHMIN)/NK
      RHR(1) = RHMIN
      DO    I=2,IPRROW
        RHR(I) = RHR(I-1)+DR
      ENDDO
      NDF = 8
      DF  = ATOP/NDF
      DO    I=2,11
        ATR(I) = ATR(I-1)+DF
      ENDDO
C     CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      IF(MT2.LE.0) GO TO 2040
C ---------------------------------------------------
      DO I=1,6
        DO J=1,IPRROW
          RESULT(J,I)=0.0
        ENDDO
      ENDDO

C ---------------------------------------------------
   40 CONTINUE
C      IF(IEND1.EQ.1.AND.IEND2.EQ.1)        GO TO 50
C      IF(IEND1.EQ.1) GO TO 663
      IF(IEND1.EQ.1) GO TO 50
      IF(ITF1.EQ.'FS  ') THEN
        CALL RRD1(MT1,IH,IK,IL,FA,FB,SA,SB,KEY1,IEND1)
      ELSE
        CALL RD1(MT1,IH,IK,IL,FA,FB,KEY1,IEND1)
        SA=.04*FA
        SB=.04*FB
      ENDIF
      IF(MT1.LE.0) THEN
        IF(MT2.GT.0) CLOSE(MT2)
        IERR=1
        RETURN
      ENDIF
C     IF(IEND1.EQ.1)        GO TO 663
      IF(IEND1.EQ.1)        GO TO 50
      NUMB1=NUMB1+1
      IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 40
      IF(FA.GT.1.E-5.OR.FB.GT.1.E-5) THEN
        IF(FA.GT.1.E-5.AND.FB.GT.1.E-5) THEN
          IF(SA.LE.0.0000001) SA=1.0
          IF(SB.LE.0.0000001) SB=1.0
          WT1=1./(SA*SA)
          WT2=1./(SB*SB)
          WT =WT1+WT2
          FA =FA*WT1+FB*WT2
          FA =FA/WT
          SA =1./SQRT(WT)
        ELSE IF(FB.GT.1.E-5) THEN
          FA =FB
          SA =SB
        ENDIF
      ENDIF
      CALL DSTAR_BL(IH,IK,IL,RSQ)
      RH=SQRT(RSQ)
      CBOFF=1.0
      IF(BOFF.GT.0.0) THEN
        BT=BOFF/4.0
        CBOFF=1.0-EXP(-BT*RSQ)
      ENDIF
      FAFREE=FA
      FA=FA*CBOFF
      SA=SA*CBOFF
      FB=FB*CBOFF
      SB=SB*CBOFF
      IF(RH.GE.RHMIN.AND.RH.LE.RHMAX) THEN
        K=(RH-RHMIN)/DR+1.
        IF(K.GT.NK) K=NK
        SUMF6(K)=SUMF6(K)+FA*FA
        SUMF6(IPRROW)=SUMF6(IPRROW)+FA*FA
      ENDIF
C ----------------------------------------------
C  663 IF(IEND1.EQ.1.AND.IEND2.EQ.1)        GO TO 50
  663 IF(IEND1.EQ.1.OR.IEND2.EQ.1)        GO TO 50
C      IF(IEND2.EQ.1) GO TO 40
      IF(MT2.EQ.0) GO TO 650

C      IF(JL-IL) GO TO 660,661,40
C  661 IF(JK-IK) GO TO 660,662,40
C  662 IF(JH-IH) GO TO 660,650,40

      IF(JL.LT.IL) GO TO 660
      IF(JL.GT.IL) GO TO 40
      IF(JK.LT.IK) GO TO 660
      IF(JK.GT.IK) GO TO 40
      IF(JH.LT.IH) GO TO 660
      IF(JH.GT.IH) GO TO 40
      GO TO 650

  660 CONTINUE
      IF(ITF2.EQ.'FS  ') THEN
        CALL RRD2(MT2,JH,JK,JL,FFA,FFB,SSA,SSB,KEY2,IEND2)
      ELSE
        CALL RD2(MT2,JH,JK,JL,FFA,FFB,KEY2,IEND2)
        SSA=.04*FFA
        SSB=.04*FFB
      ENDIF
      IF(MT2.LE.0) THEN
        CLOSE(MT1)
        IERR=1
        RETURN
      ENDIF
C      IF(IEND2.EQ.1) GO TO 40
      IF(IEND2.EQ.1) GO TO 50
      NUMB2=NUMB2+1
      IF(JH.EQ.0.AND.JK.EQ.0.AND.JL.EQ.0) GO TO 663
      IF(FFA.GT.1.E-5.OR.FFB.GT.1.E-5) THEN
        IF(FFA.GT.1.E-5.AND.FFB.GT.1.E-5) THEN
          IF(SSA.LE.0.0000001) SSA=1.0
          IF(SSB.LE.0.0000001) SSB=1.0
          WT1=1./(SSA*SSA)
          WT2=1./(SSB*SSB)
          WT =WT1+WT2
          FFA =FFA*WT1+FFB*WT2
          FFA =FFA/WT
          SSA =1./SQRT(WT)
        ELSE IF(FFB.GT.1.E-5) THEN
          FFA =FFB
          SSA =SSB
        ENDIF
      ENDIF
      CALL DSTAR_BL(JH,JK,JL,RSQ)
      RH=SQRT(RSQ)
      CBOFF=1.0
      IF(BOFF.GT.0.0) THEN
        BT=BOFF/4.0
        CBOFF=1.0-EXP(-BT*RSQ)
      ENDIF
      FFAFREE=FFA
      FFA=FFA*CBOFF
      SSA=SSA*CBOFF
      FFB=FFB*CBOFF
      SSB=SSB*CBOFF
      IF(RH.GE.RHMIN.AND.RH.LE.RHMAX) THEN
        K=(RH-RHMIN)/DR+1.
        IF(K.GT.NK) K=NK
        RESULT(K,6)=RESULT(K,6)+FFA*FFA
        RESULT(IPRROW,6)=RESULT(IPRROW,6)+FFA*FFA
        NRFL_D=NRFL_D+1
      ENDIF
      GO TO 663

  650 CONTINUE


      FB=FFA
      FBFREE=FFAFREE
      DEL=ABS(FA-FFA)
      DELFREE=ABS(FAFREE-FFAFREE)
      GA=FA
      GAFREE=FAFREE

      SIGA=SA
      SIGB=SSA

      CALL DSTAR_BL(IH,IK,IL,RSQ)
      RH=SQRT(RSQ)
      IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 40
      K=(RH-RHMIN)/DR+1.
      IF(K.GT.NK) K=NK

      CALL CALC_EPS(NEPS,IH,IK,IL,NSYM,ISYM)

      IF(GA.LT.1.E-5.OR.FB.LT.1.E-5) GO TO 40

C     IF(GA.LT.1.E-5) GO TO 30
      L1=GA/DF+1.
      IF(L1.GT.NDF) L1=0

      FM(K)        =FM(K)        +GA
      FM(IPRROW)   =FM(IPRROW)   +GA
      NF(11,K)     =NF(11,K)     +1
      NF(11,IPRROW)=NF(11,IPRROW)+1

      SUM11(11,K)     =SUM11(11,K)      +SIGA
      SUM12(11,K)     =SUM12(11,K)      +GA
      SUM11(11,IPRROW)=SUM11(11,IPRROW) +SIGA
      SUM12(11,IPRROW)=SUM12(11,IPRROW) +GA

      SUM21(11,K)     =SUM21(11,K)      +SIGB
      SUM22(11,K)     =SUM22(11,K)      +DEL
      SUM21(11,IPRROW)=SUM21(11,IPRROW) +SIGB
      SUM22(11,IPRROW)=SUM22(11,IPRROW) +DEL

      SUM31(11,K)     =SUM31(11,K)      +GA
      SUM32(11,K)     =SUM32(11,K)      +FB
      SUM33(11,K)     =SUM33(11,K)      +GA*GA
      SUM34(11,K)     =SUM34(11,K)      +FB*FB
      SUM35(11,K)     =SUM35(11,K)      +GA*FB
      SUM31(11,IPRROW)=SUM31(11,IPRROW) +GA
      SUM32(11,IPRROW)=SUM32(11,IPRROW) +FB
      SUM33(11,IPRROW)=SUM33(11,IPRROW) +GA*GA
      SUM34(11,IPRROW)=SUM34(11,IPRROW) +FB*FB
      SUM35(11,IPRROW)=SUM35(11,IPRROW) +GA*FB

      IF(L1.GT.0) THEN
        NF(L1,K)        =NF(L1,K)        +1
        NF(L1,IPRROW)   =NF(L1,IPRROW)   +1
        ANF  (L1,K)     =ANF  (L1,K)     +GA
        ANF  (L1,IPRROW)=ANF  (L1,IPRROW)+GA

        SUM11(L1,K)     =SUM11(L1,K)     +SIGA
        SUM12(L1,K)     =SUM12(L1,K)     +GA
        SUM11(L1,IPRROW)=SUM11(L1,11)    +SIGA
        SUM12(L1,IPRROW)=SUM12(L1,11)    +GA
        SUM21(L1,K)     =SUM21(L1,K)     +SIGB
        SUM22(L1,K)     =SUM22(L1,K)     +DEL
        SUM21(L1,IPRROW)=SUM21(L1,IPRROW)+SIGB
        SUM22(L1,IPRROW)=SUM22(L1,IPRROW)+DEL

        SUM31(L1,K)     =SUM31(L1,K)      +GA
        SUM32(L1,K)     =SUM32(L1,K)      +FB
        SUM33(L1,K)     =SUM33(L1,K)      +GA*GA
        SUM34(L1,K)     =SUM34(L1,K)      +FB*FB
        SUM35(L1,K)     =SUM35(L1,K)      +GA*FB
        SUM31(L1,IPRROW)=SUM31(L1,IPRROW) +GA
        SUM32(L1,IPRROW)=SUM32(L1,IPRROW) +FB
        SUM33(L1,IPRROW)=SUM33(L1,IPRROW) +GA*GA
        SUM34(L1,IPRROW)=SUM34(L1,IPRROW) +FB*FB
        SUM35(L1,IPRROW)=SUM35(L1,IPRROW) +GA*FB
      ENDIF

      NO   =NO   +1
      DDEL        =DDEL        +DEL
      DDEL2       =DDEL2       +DEL*DEL



C --- reported resolution and sigma --------------

      SG=SIGA/GA
      SLIM=1.0/SIGL
C     RHMINL=1./RESNL
C     RHMAXL=1./RESXL

      IF(LIM_FLAG.GT.0) THEN
        IF(RH.GE.RHMINL.AND.RH.LE.RHMAXL) THEN
          IF(LIM_FLAG.GT.1) THEN
            IF(SG.LE.SLIM) NO_USED=NO_USED+1
          ELSE
            NO_USED=NO_USED+1
          ENDIF
        ENDIF
      ENDIF

      IF(RH.GE.RHMINL.AND.RH.LE.RHMAXL.AND.SG.LE.SLIM) THEN

        DDEL_S=DDEL_S+DELFREE
        FSUM_S=FSUM_S+GAFREE

        NO_C   =NO_C+1
        FSM12_C=FSM12_C+GAFREE*FBFREE
        FSM22_C=FSM22_C+FBFREE*FBFREE
        FSM21_C=FSM21_C+GAFREE*GAFREE
        FSUM_C =FSUM_C +GAFREE
        FSUM1_C=FSUM1_C+FBFREE
C ---
      ENDIF

      FSUM =FSUM +GA
      FSUM1=FSUM1+FB
      FSM21=FSM21+GA*GA
      FSM22=FSM22+FB*FB
      FSM12=FSM12+GA*FB

      IF(RH.GE.RHMINL.AND.RH.LE.RHMAXL.AND.SG.LE.SLIM) THEN
C --- Rfree ----
      IT1=KEY1/2
      IT1=KEY1-IT1*2
      IF(IT1.EQ.0) THEN
        NOREST=NOREST+1
        FSREST=FSREST+FAFREE
        DLREST=DLREST+DELFREE
      ELSE
        NOFREE=NOFREE+1
        FSFREE=FSFREE+FAFREE
        DLFREE=DLFREE+DELFREE
        RFREEK(K)=RFREEK(K)+FAFREE
        DLFREEK(K)=DLFREEK(K)+DELFREE
      ENDIF
      ENDIF
C ---------------

C   30 IF(FB.LT.1.E-5) GO TO 40
      L2=FB/DF+1.
      IF(L2.GT.NDF) L2=0
      NFA  (11,K)     =NFA  (11,K)     +1
      NFA  (11,IPRROW)=NFA  (11,IPRROW)+1
      FMA  (K)        =FMA  (K)        +FB
      FMA  (IPRROW)   =FMA  (IPRROW)   +FB
      IF(L2.GT.0) THEN
        NFA  (L2,K)     =NFA  (L2,K)     +1
        NFA  (L2,IPRROW)=NFA  (L2,IPRROW)+1
        ANFA (L2,IPRROW)=ANFA (L2,IPRROW)+FB
        ANFA (L2,K)     =ANFA (L2,K)     +FB
      ENDIF
      GO TO 40
C ----------------------------------------------------
   50 CONTINUE
      DO    I=1,NK+1
        RHR(I)=1./RHR(I)
      ENDDO
      DO    J=1,IPRROW
        DO    I=1,J
          RNF (J)=RNF (J)+SUM22(11,I)
          RNFA(J)=RNFA(J)+SUM12(11,I)
        ENDDO
      ENDDO
      DO    I=1,IPRROW
        IF(RNFA(I).NE.0.0) RNF(I)=RNF(I)/RNFA(I)
      ENDDO
      DO    I=1,11
      DO    J=1,IPRROW
        ISTOR=NF(I,J)
        IF(ISTOR.NE.0) THEN
          SUM12(I,J)=SUM22(I,J)/SUM12(I,J)
        ENDIF
      ENDDO
      ENDDO
  700 CONTINUE
      DO    I=1,IPRROW
        IF(NF (11,I).NE.0) FM (I)=FM (I)/NF (11,I)
        IF(NFA(11,I).NE.0) FMA(I)=FMA(I)/NFA(11,I)
      ENDDO
C --------------------------------------------------------------
      CALL MSGDOC(MD,' ')
      CALL MSGDOC(MD,'     STATISTICS FOR : ')
      CALL MSGDOC(MD,' ')
      WRITE(LINE,60) NF(11,IPRROW)
   60 FORMAT(5X,'FILE-1 & -2 : NUMBER OF PAIRS=',I8)
      CALL MSGDOC(MD,LINE)
      CALL MSGDOC(MD,' ')
      CALL MSGDOC(MD,'                         F-1(H,K,L)')
      CALL MSGDOC(MD,' ')
      CALL MSGDOC(MD,'             VALUE OF STR. FACTOR ')
      WRITE(LINE,100) (ATR(I),I=2,NDF+1)
  100 FORMAT('RANGE (A) ','0.0',8F6.2,1X,'TOTAL',2X,'AVER')
      CALL MSGDOC(MD,LINE)
C------------------------------------
  130 FORMAT(F5.1,'-',F4.1,8('!',I5),'I',I6,E12.4)
  140 FORMAT('  TOTAL',3X,8(1X,I5),1X,I6,E12.4)

C-------------------------------
      WRITE(LINE,110)
  110 FORMAT(1X,76('-'))
      CALL MSGDOC(MD,LINE)
      DO    I=1,NK
        WRITE(LINE,130) RHR(I),RHR(I+1),(NF(J,I),J=1,8),NF(11,I),FM(I)
        CALL MSGDOC(MD,LINE)
      ENDDO
      WRITE(LINE,110)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,140) (NF(J,IPRROW),J=1,8),NF(11,IPRROW),FM(IPRROW)
      CALL MSGDOC(MD,LINE)
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      CALL MSGDOC(MD,' ')
      CALL MSGDOC(MD,'                         F-2(H,K,L)')
      CALL MSGDOC(MD,' ')
      CALL MSGDOC(MD,'             VALUE OF STR. FACTOR ')
      WRITE(LINE,100) (ATR(I),I=2,NDF+1)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,110)
      CALL MSGDOC(MD,LINE)
      DO    I=1,NK
        WRITE(LINE,130) 
     *  RHR(I),RHR(I+1),(NFA(J,I),J=1,8),NFA(11,I),FMA(I)
        CALL MSGDOC(MD,LINE)
      ENDDO
      WRITE(LINE,110)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,140) (NFA(J,IPRROW),J=1,8),NFA(11,IPRROW),FMA(IPRROW)
      CALL MSGDOC(MD,LINE)
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
C       CALL MSGDOC(MD,' ')
        CALL MSGDOC(MD,'       CRYST. R-FACTOR   <!F1-F2!>/<!F1!>')
        CALL MSGDOC(MD,' ')
        WRITE(LINE,100) (ATR(I),I=2,9)
        CALL MSGDOC(MD,LINE)

      WRITE(LINE,110)
      CALL MSGDOC(MD,LINE)
      DO    I=1,NK
        WRITE(LINE,760) RHR(I),RHR(I+1),(SUM12(J,I),J=1,8),SUM12(11,I)
  760   FORMAT(F5.1,'-',F4.1,8('!',F5.3),'I',6X,'I',4X,F7.3)
        CALL MSGDOC(MD,LINE)
      ENDDO
      WRITE(LINE,110)
      CALL MSGDOC(MD,LINE)

      SUMD21=RESULT(IPRROW,6)
      DO    J=1,IPRROW

        T1= SUM35(11,J)
        T2= SUMF6(J)
        T3= RESULT(J,6)
        T2=T2*T3
        IF(T2.LT.1.E-7) THEN
          T3=0.0
        ELSE
          T2=SQRT(T2)
          T3=T1/T2
        ENDIF
        RESULT(J,6)=T3

        DO    I=1,11
          T1=NF(I,J)*SUM35(I,J)-SUM31(I,J)*SUM32(I,J)
          T2=NF(I,J)*SUM33(I,J)-SUM31(I,J)*SUM31(I,J)
          T3=NF(I,J)*SUM34(I,J)-SUM32(I,J)*SUM32(I,J)
          T2=T2*T3
          IF(T2.LT.1.E-7) THEN
            T3=0.0
          ELSE
            T2=SQRT(T2)
            T3=T1/T2
          ENDIF
          SUM35(I,J)=T3
        ENDDO
      ENDDO


        T1=NO*FSM12-FSUM*FSUM1
        T2=NO*FSM21-FSUM*FSUM
        T3=NO*FSM22-FSUM1*FSUM1
        T2=T2*T3
        IF(T2.LT.1.E-7) THEN
          RCORR=10000000.
        ELSE
          T2=SQRT(T2)
          RCORR=T1/T2
        ENDIF

        IF(NO_C.GT.0) THEN
          T1=NO_C*FSM12_C-FSUM_C*FSUM1_C
          T2=NO_C*FSM21_C-FSUM_C*FSUM_C
          T3=NO_C*FSM22_C-FSUM1_C*FSUM1_C
          T2=T2*T3
          IF(T2.LT.1.E-7) THEN
            RCORR_S=10000000.
          ELSE
            T2=SQRT(T2)
            RCORR_S=T1/T2
          ENDIF
        ELSE
          RCORR_S=0.0
        ENDIF
 
        RFAC=DDEL/FSUM
        IF(FSUM_S.GT.0.0) THEN
          RFAC_S=DDEL_S/FSUM_S
        ELSE
          RFAC_S=0.0
        ENDIF

        IF(IPRROW.GE.20) THEN
          RESULT(19,10)=RFAC_S
          RESULT(20,10)=RCORR_S
        ENDIF
        R2=DDEL/(FSUM+FSUM1)
        IF(NO.GE.2) THEN
          RMS=SQRT(DDEL2/NO)
        ELSE
          RMS=0.0
        ENDIF
C ---RFREE ---
        RFREE=-1.0
        IF(NOFREE.GT.0.AND.FSFREE.GT.0.0) THEN
          RFREE=DLFREE/FSFREE
        ENDIF
        DO I=1,IPRROW-1
          IF(NOFREE.GT.0.AND.RFREEK(I).GT.0.0) THEN
            RFREEK(I)    = DLFREEK(I)/RFREEK(I)
            RESULT(I,21) = RFREEK(I)
          ELSE
            RESULT(I,21) = 0.0
          ENDIF
        ENDDO
        RREST=-1.0
        IF(NOREST.GT.0.AND.FSREST.GT.0.0) THEN
          RFREST=DLREST/FSREST
        ENDIF
C --------
C ----------------------------
C  RESULT(I,1)-resolution (A),from resmin=RESULT(1,1) to resmax=RESULT(IPRROW,1)
C  RESULT(I,2) - number of the pairs of structure factors 
C  RESULT(I,3) - R-factors , RESULT(IPRROW,3) - total R-factors
C  RESULT(I,4) - corr.
C  RESULT(I,5) - R-factors for Luzzati plot with RMS_L.
C  RESULT(*,5) = RMS_L - upper estimate error in coords by Luzzati plot.
C
      DO I=1,NK
        RESULT(I,1)=RHR  (I)
        RESULT(I,2)=NF   (11,I)
        RESULT(I,3)=SUM12(11,I)
        RESULT(I,4)=SUM35(11,I)
        RESULT(I,5)=0.0
      ENDDO
      RESULT(IPRROW,1)=RHR  (IPRROW)
      RESULT(IPRROW,2)=NF   (11,IPRROW)
      RESULT(IPRROW,3)=SUM12(11,IPRROW)
      RESULT(IPRROW,4)=RCORR
      SUM=0.0
      WT =0.0
      RESLIM=RHR(1)
      IF(RHR(IPRROW).LE.3.0.AND.RHR(1).GE.5.0) THEN
        RESLIM=5.0
      ENDIF 
      IF(RHR(IPRROW).LE.2.0.AND.RHR(1).GE.4.0) THEN
        RESLIM=4.0
      ENDIF 
      IF(RHR(IPRROW).GT.3.0.AND.RHR(IPRROW).LT.5.0.AND.RHR(1).GE.10.0) 
     *THEN
        RESLIM=10.0
      ENDIF

c     IF(RESLIM.GT.10.0) RESLIM=10.0 

      DO I=1,NK
        RRES=(RESULT(I,1)+RESULT(I+1,1))/2.0
        IF(RRES.LE.RESLIM) THEN
          RRFAC=RESULT(I,3)
          CALL RMS_LUZZ(RRES,RRFAC,RRMS)
C         RESULT(I,6)=RRMS
          SUM=SUM+RRMS*RESULT(I,2)
          WT =WT +RESULT(I,2)
        ELSE
c         RESULT(I,6)=0.0
        ENDIF
      ENDDO
      RESULT(IPRROW,5)=SUM/WT
      RMS_L=RESULT(IPRROW,5)
      DO I=1,NK
        RRES=(RESULT(I,1)+RESULT(I+1,1))/2.0
        IF(RRES.LE.10.0) THEN
          CALL RF_LUZZ(RRES,RMS_L,RRFAC)
          RESULT(I,5)=RRFAC
        ELSE
          RESULT(I,5)= 0.0
        ENDIF
      ENDDO
C ----------------------------
C     CALL MSGDOC(MD,' ')
      WRITE(LINE,'(1X,''Boff   ='',F8.2)')BOFF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(1X,''R-FAC=<!F1-F2!>/<!F1!>     ='',F8.4)')RFAC
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,8000)
     *  SIGL,RESNL,RESXL,RFAC_S
 8000 FORMAT(1X,'R-factor(for s/F >=',F4.1,' and resol.',F5.1
     * ,' - ',F5.2,'  A)=',F8.4)
      CALL MSGDOC(MDOC,LINE)

C     WRITE(*,'(1X,''R-FAC=<!F1-F2!>/<!F1!+!F2!>='',F8.4)') R2
C     CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(1X,''R-CORR                     ='',F8.4)') RCORR
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,8010)
     *  SIGL,RESNL,RESXL,RCORR_S
 8010 FORMAT(1X,'R-corr (for s/F >=',F4.1,' and resol.',F5.1
     * ,' - ',F5.2,'  A)=',F8.4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'('' <F1*F2>-<F1><F2>/SQRT(<F1^2>-<F1>^2)(<F2^2>-<F2>^2)'')') 
      CALL MSGDOC(MDOC,LINE)


      IF(NRFL_D.GT.0) SUMD21=SQRT(SUMD21/NRFL_D)
      WRITE(LINE,'(1X,'' Corr_Density: '',F6.3,G14.4,1X,I5)') 
     * RESULT(IPRROW,6),SUMD21,NRFL_D
       CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,
     *'('' Upper estimate error in coords by Luzzati plot/='',F8.4)'
     *)  RESULT(IPRROW,5)
      CALL MSGDOC(MDOC,LINE)
C     WRITE(LINE,'(  1X,''RMS=SQRT( < (F1-F2)**2 > ) ='',F8.4)') RMS
C       CALL MSGDOC(MDOC,LINE)

C --- Rfree ----
      IF(NOFREE.GT.0) THEN
        WRITE(LINE,
     *  '('' Rfree,Nfree                   ='',F8.4,I8)') RFREE,NOFREE
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     *  '('' Rrest,Nrest                   ='',F8.4,I8)')RFREST,NOREST
        CALL MSGDOC(MDOC,LINE)
        RESULT(15,10) = RFREST
        IF(IPRROW.GE.21) THEN
          RESULT(21,10) = RFREE
C -->           RESULT(I,21) = RFREEK(I)
          RESULT(21,21) = NOFREE
        ENDIF
      ENDIF
      RESULT(16,10) = NOREST
      RESULT(17,10) = NO_C
      RESULT(14,10) = NO_USED
C --------------
      NNK = NK
      IF(IPRROW.GT.11) NNK = 10
      CALL MSGDOC(MD,' ')
      CALL MSGDOC(MD,'Rfac from  till ... ')
      WRITE(LINE,920)  RHR(1),(RHR(I+1),I=1,NNK)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,921) (RNF(I),I=1,NNK)
      CALL MSGDOC(MD,LINE)
      IF(IPRROW.GT.11) THEN
        NNK=NK-10+1
        CALL MSGDOC(MD,' ')
        WRITE(LINE,920)  RHR(NNK),(RHR(I+1),I=NNK,NK)
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,921) (RNF(I),I=NNK,NK)
        CALL MSGDOC(MD,LINE)
      ENDIF
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      NNK=NK
      IF(IPRROW.GT.11) NNK=10
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,920)  RHR(1),(RHR(I+1),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,921) (RESULT(I,3),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,924) (RESULT(I,4),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,925) (RESULT(I,6),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,922) (RESULT(I,5),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,923) (NF(11,I),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
  920 FORMAT('Rs',F5.1,10(2X,F5.1))
  921 FORMAT('Rfc',1X,10(F7.3))
  922 FORMAT('Luz',1X,10(F7.3))
  923 FORMAT('N  ',1X,10(I7))
  924 FORMAT('Cor',1X,10(F7.3))
  925 FORMAT('C_D',1X,10(F7.3))

      IF(IPRROW.GT.11) THEN
        NNK=NK-10+1
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,920)  RHR(NNK),(RHR(I+1),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,921) (RESULT(I,3),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,924) (RESULT(I,4),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,925) (RESULT(I,6),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,922) (RESULT(I,5),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,923) (NF(11,I),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      NFUN=2
      FMIN=0.0
      FMAX=.60
      CALL GRAPH_RF(MDOC,NK,NFUN,RESULT(1,2),RHR
     * ,RESULT(1,3),RESULT(1,5),FMIN,FMAX)
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      NFUN=2
      FMIN=0.0
      FMAX=0.0
      DO I=1,NK
        IF(FM(I) .GT.FMAX)   FMAX=FM(I)
        IF(FMA(I).GT.FMAX)  FMAX=FMA(I)
      ENDDO
      IF(FMAX.LE.0.0) FMAX=1.0
      CALL GRAPH_F(MD,NK,NFUN,RESULT(1,2),RHR
     * ,FM,FMA,FMIN,FMAX)
  500 CLOSE(MT1)
      IF(MT2.GT.0) CLOSE(MT2)
      RETURN
C ----------------------------------------------------------
C ----------------------------------------------------------
C     MT2=0
 2040 CONTINUE

      DO I=7,11
        DO J=1,IPRROW
          IF(I.NE.10) RESULT(J,I)=0.0
        ENDDO
      ENDDO
C ----------
      RESLIM=1./RHR(1)
      BRMAX =1./RHR(IPRROW)
      NKB=IPRROW-1
      IF(BRMAX.LE.3.0.AND.RESLIM.GE.6.0) THEN
        RESLIM=6.0
      ENDIF 
      IF(BRMAX.LE.2.0.AND.RESLIM.GE.5.0) THEN
        RESLIM=5.0
      ENDIF 
      IF(BRMAX.GT.3.0.AND.BRMAX.LT.6.0.AND.RESLIM.GE.20.0) 
     *THEN
        RESLIM=20.0
      ENDIF

c      IF(BRMAX.LT.15.0.AND.RESLIM.GT.30.0) RESLIM=30.0 
c      RSXLIM=BRMAX

      BRMIN=1./RESLIM
      BRMAX=1./BRMAX
      BDR=(BRMAX-BRMIN)/NKB
      RHRB(1)= BRMIN
      DO    I=2,NKB+1
        RHRB(I)=RHRB(I-1)+BDR
      ENDDO
      DO    I=1,NKB+1
        RHRB(I)=1.0/RHRB(I)
      ENDDO
C ---------
      FAV   =0.0
      F2AVER=0.0
      FMIN = 1.0E30
      FMAX =-1.0E30
      FAMIN= 1.0E30
      FAMAX=-1.0E30
      FBMIN= 1.0E30
      FBMAX=-1.0E30
      NO    = 0
      NOA   = 0
      NOB   = 0
      NTOT  = 0
      NABS  = 0
      NADD  = 0
      NUMB1 = 0
      IEND1 =-1
      M=99
      CALL ANOMF(M,NSYM,ISYM)
C     CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
      IH     = 0
      IK     = 0
      IL     =-1
      IFIRST = 0

      DO     ILP=0,ILMAX
      DO     IKP=-IKMAX,IKMAX
      DO     IHP=-IHMAX,IHMAX
        IF(IHP.EQ.0.AND.IKP.EQ.0.AND.ILP.EQ.0) GO TO 4300
        IIHP=IHP
        IIKP=IKP
        IILP=ILP
        CALL ANOMSC(IIHP,IIKP,IILP,IANOM,JJSYM,NSYM,ISYM)
        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 4300
        IF(NSYM.GT.1) THEN
          CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        ELSE
          ICND=0
        ENDIF
C        CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        IF(ICND.NE.0) GO TO 4300
        CALL DSTAR_BL(IHP,IKP,ILP,RSQ)
        RH=SQRT(RSQ)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 4300
        NTOT=NTOT+1
        K=(RH-RHMIN)/DR+1.
        IF(K.GT.NK) K=NK
C ---
 4060   IF(MT1.LE.0)  THEN
          IERR=1
          RETURN
        ENDIF
C        write(*,*) ih,ik,il,ihp,ikp,ilp
        IF(IEND1.GT.0) GO TO 4040

C        IF(IL-ILP) 4050,4010,4040
C 4010   IF(IK-IKP) 4050,4020,4040
C 4020   IF(IH-IHP) 4050,4030,4040

        IF(IL.LT.ILP) GO TO 4050
        IF(IL.GT.ILP) GO TO 4040
        IF(IK.LT.IKP) GO TO 4050
        IF(IK.GT.IKP) GO TO 4040
        IF(IH.LT.IHP) GO TO 4050
        IF(IH.GT.IHP) GO TO 4040
        GO TO 4030

 4040   CONTINUE
C       MISS REFL IHP,IKP,ILP   
        IF(NSYM.GT.1) THEN
          CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        ELSE
          ICND=0
        ENDIF
        IF(ICND.NE.0) GO TO 4300
C       MISS IHP,IKP,ILP   
        GO TO 5000

 4050   CONTINUE
        IF(IFIRST.EQ.1) THEN
C         ADDITIONAL IL,IK,IL,REFLS
          IF(NSYM.GT.1) THEN
            CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
          ELSE
            ICND=0
          ENDIF
C          CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
          IF(ICND.NE.0) GO TO 7000
          GO TO 6000
        ENDIF
        IFIRST=1
        IF(ITF1.EQ.'FS  ') THEN
          CALL RRD1(MT1,IH,IK,IL,FA,FB,SA,SB,KEY1,IEND1)
        ELSE
          CALL RD1(MT1,IH,IK,IL,FA,FB,KEY1,IEND1)
C          write(*,*) ' ---', ih,ik,il,fa,fb,numb1,iend1
          SA=.04*FA
          SB=.04*FB
        ENDIF
        IF(IEND1.GT.0) GO TO 4040
        NUMB1=NUMB1+1
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) THEN
          IFIRST=0
          GO TO 4060
        ENDIF
        GO TO 4060
C ---
 4030   IFIRST=0
        IF(NSYM.GT.1) THEN
          CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        ELSE
          ICND=0
        ENDIF
C        CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        IF(ICND.NE.0) GO TO 7000

        SIGA=0.
        SIGB=0.
        IF(FA.GT.1.E-5.OR.FB.GT.1.E-5) THEN
          IF(FA.GT.1.E-5.AND.FB.GT.1.E-5) THEN
            IF(SA.LE.0.0000001) SA=1.0
            IF(SB.LE.0.0000001) SB=1.0
            WT1=1./(SA*SA)
            WT2=1./(SB*SB)
            WT =WT1+WT2
            FAVER =FA*WT1+FB*WT2
            FAVER =FAVER/WT
            SAVER =1./SQRT(WT)
          ELSE IF(FB.GT.1.E-5) THEN
            FAVER =FB
            SAVER =SB
          ELSE
            FAVER =FA
            SAVER =SA
          ENDIF
        ENDIF
C -----------------------------
C       
        GA=FA
        SIGA=SA
        SIGB=SB

        IF(GA.LT.1.E-5.AND.FB.LT.1.E-5) GO TO 5000
C total number
        NO=NO+1
        
        IF(GA.LT.1.E-5) GO TO 2030
C number F(h,k,l)
        NOA=NOA+1
        FAV   =FAV   +GA
        F2AVER=F2AVER+GA*GA



        IF(RH.LT.BRMAX.AND.RH.GT.BRMIN) THEN
          KB=(RH-BRMIN)/BDR+1.
          IF(KB.GT.NKB) KB=NKB
          SUMF1(KB)      =SUMF1(KB)       +GA*GA
          SUMF4(KB)      =SUMF4(KB)       +GA
          SUMF2(KB)      =SUMF2(KB)       +1.0
        ENDIF

        IF(GA.LT.FAMIN) FAMIN=GA
        IF(GA.GT.FAMAX) FAMAX=GA
        IF(GA.LT.FMIN ) FMIN =GA
        IF(GA.GT.FMAX ) FMAX =GA

        L1=GA/DF+1.
        IF(L1.GT.8) L1=0
        SUMF5(K)        =SUMF5(K)         +GA*GA
        FM(K)           =FM(K)+GA
        NF(11,K)        =NF(11,K)         +1
        NF(11,IPRROW)   =NF(11,IPRROW)    +1
        SUM11(11,K)     =SUM11(11,K)      +SIGA
        SUM12(11,K)     =SUM12(11,K)      +GA
        SUM11(11,IPRROW)=SUM11(11,IPRROW) +SIGA
        SUM12(11,IPRROW)=SUM12(11,IPRROW) +GA
        FM(IPRROW)      =FM(IPRROW)       +GA

        IF(L1.LE.0) GO TO 2030
        NF(L1,K)    =NF(L1,K) +1
        NF(L1,IPRROW)   =NF(L1,IPRROW)   +1
        SUM11(L1,K)     =SUM11(L1,K)     +SIGA
        SUM12(L1,K)     =SUM12(L1,K)     +GA
        SUM11(L1,IPRROW)=SUM11(L1,IPRROW)+SIGA
        SUM12(L1,IPRROW)=SUM12(L1,IPRROW)+GA

 2030   IF(FB.LT.1.E-5) GO TO 5000
C number F(-h,-k,-l)
        NOB=NOB+1

        IF(FB.LT.FBMIN) FBMIN=FB
        IF(FB.GT.FBMAX) FBMAX=FB
        IF(FB.LT.FMIN ) FMIN =FB
        IF(FB.GT.FMAX ) FMAX =FB

        L2=FB/DF+1.
        IF(L2.GT.8) L2=0
        NFA  (11,K)     =NFA  (11,K) +1
        NFA  (11,IPRROW)=NFA  (11,IPRROW)+1
        SUM21(11,K)     =SUM21(11,K)     +SIGB
        SUM22(11,K)     =SUM22(11,K)     +FB
        SUM21(11,IPRROW)=SUM21(11,IPRROW)+SIGB
        SUM22(11,IPRROW)=SUM22(11,IPRROW)+FB
        FMA  (K)        =FMA  (K)        +FB
        FMA  (IPRROW)   =FMA  (IPRROW)   +FB
        IF(L2.LE.0) GO TO 5000
        NFA  (L2,K)     =NFA  (L2,K)     +1
        NFA  (L2,IPRROW)=NFA  (L2,IPRROW)+1
        SUM21(L2,K)     =SUM21(L2,K)     +SIGB
        SUM22(L2,K)     =SUM22(L2,K)     +FB
        SUM21(L2,IPRROW)=SUM21(L2,IPRROW)+SIGB
        SUM22(L2,IPRROW)=SUM22(L2,IPRROW)+FB
C -----------------------------
C missing
 5000   CONTINUE

        ANFA(11,IPRROW) = ANFA(11,IPRROW) + 1.0 
        ANFA(11,K)  = ANFA(11,K)  + 1.0
        NOTOT  = NOTOT   +1
        GO TO 4300
C -------------------------------------
C additional
 6000   CONTINUE
        ANF(2,IPRROW)  = ANF(2,IPRROW) + 1.0 
        ANF(2,K)       = ANF(2,K)  + 1.0
        NADD = NADD + 1
        IFIRST=0
        GO TO 4050 
C -----------------
C  absent
 7000   CONTINUE
        ANF(1,IPRROW)  = ANF(1,IPRROW) + 1.0
        ANF(1,K)   = ANF(1,K)  + 1.0
        NABS = NABS + 1
        IF(IFIRST.EQ.0) GO TO 4300
        IFIRST=0
        GO TO 4050 
C -------------------------------------------------------------
4300    CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ----------------------
C
C        IF(RH.LT.BRMAX.AND.RH.GT.BRMIN) THEN
C          KB=(RH-RESLIM)/BDR+1.
C          IF(KB.GT.NKB) KB=NKB
C          SUMF1(KB)      =SUMF1(KB)       +GA*GA
C          SUMF2(KB)      =SUMF2(KB)       +1.0
C        ENDIF
c        IF(RH.LT.BRMAX.AND.RH.GT.BRMIN) THEN
c          KB=(RH-BRMIN)/BDR+1.
c          IF(KB.GT.NKB) KB=NKB
c          SUMF1(KB)      =SUMF1(KB)       +GA*GA
c          SUMF4(KB)      =SUMF4(KB)       +GA
c          SUMF2(KB)      =SUMF2(KB)       +1.0
c        ENDIF

      CALL TEMP_FL(SUMF1,SUMF2,NKB,BRMIN,BDR,FSCALE,BTEMP)

      BI   =BTEMP*2.0
      FSCLI=FSCALE
      BTEMP=BTEMP
      FSCALE=SQRT(FSCALE)


c      NFUN=2
c      FBMIN=0.0
c      FBMAX=0.0
c      DO I=1,NKB
c        IF(SUMF2(I).GT.0) THEN
c          SUMF1(I)=SUMF1(I)/SUMF2(I)
c        ENDIF
c        T=SUMF1(I)
c        FJ=FLOAT(I)
c        RSQ=((FJ-0.5)*BDR+BRMIN)**2
C       BT=BTEMP/4.0
C       FSC=FSCALE
c        FSC=FSCLI
c        BT=BI/4.0
c        X=FSC*EXP(-BT*RSQ)
c        IF(T.GT.FBMAX)  FBMAX=T
c        IF(T.GT.FBMAX)  FBMAX=T
c        IF(X.GT.FBMAX)  FBMAX=X
c        IF(X.GT.FBMAX)  FBMAX=X
c        SUMF3(I)=X
c      ENDDO
c      IF(FBMAX.LE.0.0) FBMAX=1.0
c      MMDOC=0
c      CALL GRAPH_FB(MMDOC,NKB,NFUN,SUMF2,RHRB
c     * ,SUMF1,SUMF3,FBMIN,FBMAX)



      DO    I=1,IPRROW
        IF(NF (11,I).NE.0) SUMF5(I)=SUMF5(I)/NF (11,I)
        SUMF5(I)=SQRT(SUMF5(I))

      ENDDO

C ?????
c      DO I=1,NK
c        FJ=FLOAT(I)
c        RSQ=((FJ-0.5)*DR+RHMIN)**2
c        BT =BTEMP/4.0
c        FSC=FSCALE
cC        FSC=FSCLI
C        BT=BI/4.0
c        X=FSC*EXP(-BT*RSQ)
c        RESULT(I,11)= X
c      ENDDO
c
c      NFUN=2
c      FGMIN=0.0
c      FGMAX=0.0
c      DO I=1,NK
c        IF(SUMF5(I)    .GT.FGMAX)  FGMAX=SUMF5(I)
c        IF(RESULT(I,11).GT.FGMAX)  FGMAX=RESULT(I,11)
c      ENDDO
c
c      RESULT(NK+1,1)=1.0/RHR  (NK+1)
c      DO I=1,NK
c        RESULT(I,1)=1.0/RHR  (I)
c        RESULT(I,12)=NF   (11,I)
c      ENDDO
c
c      IF(FGMAX.LE.0.0) FGMAX=1.0
c      CALL GRAPH_FB(MMDOC,NK,NFUN,RESULT(1,12),RESULT(1,1)
c     * ,SUMF5,RESULT(1,11),FGMIN,FGMAX)
C ?????

C ----------------------
      DO    I=1,NK+1
        RHR(I)=1./RHR(I)
      ENDDO

      DO    I=1,11
      DO    J=1,IPRROW
        ISTOR=NF(I,J)
        IF(ISTOR.NE.0) SUM11(I,J)=SUM11(I,J)/SUM12(I,J)
        ISTOR=NFA(I,J)
        IF(ISTOR.NE.0) SUM21(I,J)=SUM21(I,J)/SUM22(I,J)
      ENDDO
      ENDDO
C ------------------
      IF(NOA.GT.0) THEN
        FAV   =FAV   /NOA
        F2AVER=F2AVER/NOA
      ENDIF
      DO    I=1,IPRROW
        IF(NF (11,I).NE.0) FM (I)=FM (I)/NF (11,I)
        IF(NFA(11,I).NE.0) FMA(I)=FMA(I)/NFA(11,I)
        N=ANFA(11,I)+0.001
        IF(N.GT.0) THEN
          NN=NF(11,I)+NFA(11,I)
          IF(N.EQ.NN) THEN
            ANFA(11,I)=100.0
          ELSE
            ANFA(11,I)=(FLOAT(NN)*100.0)/FLOAT(N)
          ENDIF
        ENDIF
      ENDDO
C ------------------
C -----------------
      CALL MSGDOC(MD,'        STATISTICS FOR FILE-1 :')
      WRITE(LINE,2060) NO,FMIN,FMAX
 2060 FORMAT(  ' N-REFLS   =',I8,' FMIN=',G12.4,' FMAX=',G12.4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,2069) NTOT
 2069 FORMAT(' No refls (max possible) :',I8)
      CALL MSGDOC(MDOC,LINE)
      IF(NOA.GT.0) THEN
        WRITE(LINE,2067) FAV,F2AVER
 2067   FORMAT(' <F>=',G12.4,' <F**2>=',G12.4)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(NOB.GT.0) THEN
        WRITE(LINE,2061) NOA,FAMIN,FAMAX
 2061   FORMAT(' N-(hkl)   =',I8,' FMIN=',G12.4,' FMAX=',G12.4)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,2062) NOB,FBMIN,FBMAX
 2062   FORMAT(' N-(-h-k-l)=',I8,' FMIN=',G12.4,' FMAX=',G12.4)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      WRITE(LINE,2063) ANFA(11,IPRROW)
 2063 FORMAT(  ' Completeness =',F8.2,' %')
      CALL MSGDOC(MDOC,LINE)
      IF(ITF1.EQ.'FS  ') THEN
        WRITE(LINE,2066) SUM11(11,IPRROW)
 2066   FORMAT(' R_stand(F) = <sig(F)>/<F> =',F8.3)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      WRITE(LINE, 
     *'( '' Boverall/estimated by Wilson plot/     ='',F8.3)') 
     * BTEMP
      CALL MSGDOC(MDOC,LINE)
      DISP=BTEMP/(8.0*PI*PI)
      IF(DISP.LT.0.0) DISP=0.0
      DISP=SQRT(DISP)
      WRITE(LINE,2068) DISP
 2068 FORMAT(  ' <u> = sqrt(Bov/8pi**2)                  :',F8.2)
      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE, 
     * '('' <F>=sqrt(<I>)/estimated by Wilson plot/='',F8.3)') 
     * FSCALE
      CALL MSGDOC(MDOC,LINE)
      IF(NABS.GT.0) THEN
        WRITE(LINE,2064) NABS
 2064   FORMAT(' Systematic absent refls  =',I8)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(NADD.GT.0) THEN
        WRITE(LINE,2065) NADD
 2065   FORMAT(' Additional (? ,probably out of resolution) refls  ='
     *  ,I8)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C ---------------------------------
C  RESULT(I,1)-resolution (A),from resmin=RESULT(1,1) to resmax=RESULT(IPRROW,1)
C  RESULT(I,12) - number of structure factors F(h,k,l)
C  RESULT(I,7) - <F(h,k,l)>
C  RESULT(I,8) - completeness
C  RESULT(I,9) - <sigma(F(h,k,l))>/<F(h,k,l)>
C  RESULT(I,11) -  <F>*EXP(-Bover*S**2) 
C                      RESULT(IPRROW,11)= Boverall/estimated by Wilson plot/
      DO I=1,NK
        RESULT(I,1)=RHR  (I)
        RESULT(I,12)=NF   (11,I)
C       RESULT(I,7)=FM   (I)
        RESULT(I,7)=SUMF5  (I)
        RESULT(I,8)=ANFA (11,I)
        IF(ITF1.EQ.'FS  ') THEN
          RESULT(I,9)=SUM11(11,I)
        ELSE
          RESULT(I,9)=0.0
        ENDIF
      ENDDO
      RESULT(IPRROW,1)=RHR  (IPRROW)
      RESULT(IPRROW,12)=NF   (11,IPRROW)
      RESULT(IPRROW,7)=FM   (IPRROW)
      RESULT(IPRROW,8)=ANFA (11,IPRROW)
      IF(ITF1.EQ.'FS  ') THEN
        RESULT(IPRROW,9)=SUM11(11,IPRROW)
      ELSE
        RESULT(IPRROW,9)=0.0
      ENDIF
C ----------------------------------

C  RESULT(1,10) = No 
C  RESULT(2,10) = No of the structure factors for this limits of resolution
C  RESULT(3,10) = No of F(-h,-k,-l)
C  RESULT(4,10) = Fmin
C  RESULT(5,10) = Fmax
C  RESULT(6,10) = Nabs
C  RESULT(7,10) = Nadd
C  RESULT(8,10) = <F(h,k,l)>
C  RESULT(9,10) = <F> = sqrt (<I>) /estimated by Wilson plot/
C  RESULT(10,10)=  B_overall
C  RESULT(11,10)= <F(-h,-k,-l)>
C  RESULT(12,10)= F(h,k,l)min
C  RESULT(13,10)= F(h,k,l)max
C  RESULT(14,10)= F(-h,-k,-l)min
C  RESULT(15,10)= F(-h,-k,-l)max
C  RESULT(16,10)= <F(h,k,l)**2>
C  RESULT(17,10) = No of F(-h,-k,-l)
C  RESULT(18,10)= NSYM
CCC  RESULT(19,10)= RESMIN for scaling 
CCC  RESULT(20,10)= RESMAX

      RESULT(1 ,10)= NTOT
      RESULT(2 ,10)= NO
      RESULT(3 ,10)= NOB
      RESULT(4 ,10)= FMIN
      RESULT(5 ,10)= FMAX
      RESULT(6 ,10)= NABS
      RESULT(7 ,10)= NADD
      RESULT(8 ,10)= FAVER
      RESULT(9 ,10)= FSCALE
      RESULT(10,10)= BTEMP
      RESULT(11,10)= FMA(IPRROW)
      IF(IPRROW.GE.20) THEN
        RESULT(12,10)= FAMIN
        RESULT(13,10)= FAMAX
        RESULT(14,10)= FBMIN
        RESULT(15,10)= FBMAX
        RESULT(16,10)= F2AVER
        RESULT(17,10)= NOA
C        RESULT(18,10)= NSYM
        RESULT(18,10)= RESLIM 
C        RESULT(20,10)= BRMAX
      ENDIF

      NNK=NK
      IF(IPRROW.GT.11) NNK=10

      WRITE(LINE,2920)  RHR(1),(RHR(I+1),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,2921) (RESULT(I,7),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
      IF(ITF1.EQ.'FS  ') THEN
        WRITE(LINE,2924) (RESULT(I,9),I=1,NNK)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      WRITE(LINE,2922) (RESULT(I,8),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,2923) (NF(11,I),I=1,NNK)
      CALL MSGDOC(MDOC,LINE)
 2920 FORMAT('Rs',F5.1,10(2X,F5.1))
 2921 FORMAT('<F> ',1X,10(F7.1))
 2922 FORMAT('Comp',1X,10(F7.1))
 2923 FORMAT('N   ',1X,10(I7))
 2924 FORMAT('sd/F',1X,10(F7.3))

      IF(IPRROW.GT.11) THEN
        CALL MSGDOC(MDOC,' ')
        NNK=NK-10+1
        WRITE(LINE,2920)  RHR(NNK),(RHR(I+1),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,2921) (RESULT(I,7),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
        IF(ITF1.EQ.'FS  ') THEN
          WRITE(LINE,2924) (RESULT(I,9),I=NNK,NK)
          CALL MSGDOC(MDOC,LINE)
        ENDIF
        WRITE(LINE,2922) (RESULT(I,8),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,2923) (NF(11,I),I=NNK,NK)
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      DO I=1,NK
        FJ=FLOAT(I)
        RSQ=((FJ-0.5)*DR+RHMIN)**2
        BT =BTEMP/4.0
        FSC=FSCALE
        X=FSC*EXP(-BT*RSQ)
        RESULT(I,11)= X
      ENDDO
      RESULT(IPRROW,11)=BTEMP
      NFUN=2
      FGMIN=0.0
      FGMAX=0.0
      DO I=1,NK
        IF(RESULT(I,7) .GT.FGMAX)  FGMAX=RESULT(I,7)
        IF(RESULT(I,11).GT.FGMAX)  FGMAX=RESULT(I,11)
      ENDDO

      IF(FGMAX.LE.0.0) FGMAX=1.0
      CALL GRAPH_FB(MDOC,NK,NFUN,RESULT(1,12),RHR
     * ,RESULT(1,7),RESULT(1,11),FGMIN,FGMAX)
C -------------------------------------------------------------
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      CALL MSGDOC(MD,' ')
      CALL MSGDOC(MD,'                           F(H,K,L)')
      CALL MSGDOC(MD,' ')

      CALL MSGDOC(MD,'             VALUE OF STR. FACTOR ')
      WRITE(LINE,2100) (ATR(I),I=2,9)
 2100 FORMAT('RANGE (A) ','0.0',8F6.2,1X,'TOTAL',2X,'AVER')
      CALL MSGDOC(MD,LINE)

C------------------------------------
 2130 FORMAT(F5.1,'-',F4.1,8('!',I5),'I',I6,E12.4)
 2140 FORMAT('  TOTAL',3X,8(1X,I5),1X,I6,E12.4)

C-------------------------------
      WRITE(LINE,2110)
 2110 FORMAT(1X,76('-'))
      CALL MSGDOC(MD,LINE)
      DO    I=1,NK
        WRITE(LINE,2130)RHR(I),RHR(I+1),(NF(J,I),J=1,8),NF(11,I),FM(I)
        CALL MSGDOC(MD,LINE)
      ENDDO
      WRITE(LINE,2110)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,2140) (NF(J,IPRROW),J=1,8),NF(11,IPRROW),FM(IPRROW)
      CALL MSGDOC(MD,LINE)
      IF(ITF1.EQ.'FS  ') THEN
C ::::::::::::::::
        IF(STOP_T.EQ.'Y') THEN
          CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
          READ(*,'(A)') MSG1
        ENDIF
C ::::::::::::::::
        CALL MSGDOC(MD,' ')
        CALL MSGDOC(MD,'                 SUM(SIGMA)/SUM(F(H,K,L))')
        CALL MSGDOC(MD,' ')
        CALL MSGDOC(MD,'                  VALUE OF STR. FACTOR')
        WRITE(LINE,2101) (ATR(I),I=2,9)
        CALL MSGDOC(MD,LINE)
C------------------------------------
 2101   FORMAT('RANGE (A) ','0.0',8F6.2,2X,'TOTAL')
 2111   FORMAT(72('-'))

 2131   FORMAT(F5.1,'-',F4.1,8('!',F5.3),'I',1X,F5.3,'I')
 2141   FORMAT('  TOTAL',3X,8(1X,F5.3),2X,F5.3)
C-------------------------------
        WRITE(LINE,2111)
        CALL MSGDOC(MD,LINE)
        DO    I=1,NK
        WRITE(LINE,2131)RHR(I),RHR(I+1),(SUM11(J,I),J=1,8),SUM11(11,I)
        CALL MSGDOC(MD,LINE)
        ENDDO
        WRITE(LINE,2111)
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,2141) (SUM11(J,IPRROW),J=1,8),SUM11(11,IPRROW)
        CALL MSGDOC(MD,LINE)
      ENDIF
      IF(NFA(11,IPRROW).EQ.0) GO TO 2500
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      CALL MSGDOC(MD,' ')
      CALL MSGDOC(MD,'                         F(-H,-K,-L)')
      CALL MSGDOC(MD,' ')
      WRITE(LINE,2100) (ATR(I),I=2,9)
      CALL MSGDOC(MD,LINE)
      CALL MSGDOC(MD,' ')
      WRITE(LINE,2110)
      CALL MSGDOC(MD,LINE)
      DO    I=1,NK
        WRITE(LINE,2130) 
     *  RHR(I),RHR(I+1),(NFA(J,I),J=1,8),NFA(11,I),FMA(I)
        CALL MSGDOC(MD,LINE)
      ENDDO
      WRITE(LINE,2110)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,2140) (NFA(J,IPRROW),J=1,8),NFA(11,IPRROW)
     *,FMA(IPRROW)
      CALL MSGDOC(MD,LINE)
      IF(ITF1.EQ.'FS  ') THEN
C ::::::::::::::::
        IF(STOP_T.EQ.'Y') THEN
          CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
          READ(*,'(A)') MSG1
        ENDIF
C ::::::::::::::::
        CALL MSGDOC(MD,' ')
        CALL MSGDOC(MD,'         SUM(SIGMA)/SUM(F(-H,-K,-L)) ')
        CALL MSGDOC(MD,' ')
        WRITE(LINE,2101) (ATR(I),I=2,9)
        CALL MSGDOC(MD,LINE)
C-------------------------------
        WRITE(LINE,2111)
        CALL MSGDOC(MD,LINE)
        DO    I=1,NK
        WRITE(LINE,2131)RHR(I),RHR(I+1),(SUM21(J,I),J=1,8),SUM21(11,I)
        CALL MSGDOC(MD,LINE)
        ENDDO
        WRITE(LINE,2111)
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,2141) (SUM21(J,IPRROW),J=1,8),SUM21(11,IPRROW)
        CALL MSGDOC(MD,LINE)
      ENDIF
 2500 CLOSE(MT1)
      RETURN
C---------------------------------------------------------
      END

      SUBROUTINE STATP(ITPR,MDOC,NAME1,NAME2,R1,R2,ATOP
     * ,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C -----------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NUMB1,ISTOR
      INTEGER   NF(11,11),NFA(11,11)
      REAL      RHR(11),FM(11),FMA(11),ATR(11)
      REAL      ANF(11,11),ANFA(11,11),RLATT(6)
      REAL      RNF(11),RNFA(11)
      REAL      SUM11(11,11),SUM12(11,11)
      REAL      SUM21(11,11),SUM22(11,11)
      REAL      RESULT(IPRROW,12)
      CHARACTER ITPR*4,STOP_T*1
      CHARACTER ITP1*4,ITP2*4,ITF1*4,ITF2*4
      CHARACTER NAME1*(*),NAME2*(*),TTT*80,LINE*80
      CHARACTER MSG*1,MSG1*1
C================================================================
      IF(STOP_T.EQ.'N') THEN
        MD=-ABS(MDOC)-1
      ELSE
        MD=MDOC
      ENDIF
      MDD=-ABS(MDOC)-1
      DO I=1,10
        DO J=1,11
          RESULT(J,I)=0.0
        ENDDO
      ENDDO
      IERR=0
C     CALL MSGDOC(MDOC,'INPUT FILE-1')
      MT1 =11
      ITP1='    '
c      MD=0
      CALL ORFILE(MDD,MT1,NAME1,ITP1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-1')
        RETURN
      ENDIF
      CALL GET_TITLE(MDD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,NX,NY,NZ,IZN,IZM,TTT,IERR)
      CALL C_RD_CR
      RN=RESMIN
      RX=RESMAX
      IF(ITP1.NE.'F   '.AND.ITP1.NE.'PH  '.AND.ITP1.NE.'FS  ') THEN
        CALL MSGERR(MDOC,' ERR: WRONG TYPE OF FILE')
        CLOSE(MT1)
        IERR=1
        RETURN
      ENDIF
      ITF1=ITP1
      IF(ITP1.EQ.'FS  ') ITP1='F   '
C ---------------------------------------------------
      MT2 =0
      MSG='N'
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',') THEN
        MSG='Y'
        MT2 =12
        ITP2='    '
C        CALL MSGDOC(MDOC,'INPUT FILE-2')
c        MD=-1
        CALL ORFILE(MDD,MT2,NAME2,ITP2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MDD,A,B,C,AL,BE,GA
     *    ,F1,F2,RESMIN,RESMAX,NX,NY,NZ,IZN,IZM,TTT,IERR)
        IF(ITP2.NE.'F   '.AND.ITP2.NE.'PH  '.AND.ITP2.NE.'FS  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE OF FILE')
          IERR=1
          CLOSE(MT1)
          CLOSE(MT2)
          RETURN
        ENDIF
        ITF2=ITP2
        IF(ITP2.EQ.'FS  ') ITP2='F   '
        IF(RN.LT.RESMIN)   RESMIN=RN
        IF(RX.GT.RESMAX)   RESMAX=RX
        IF(ITP1.NE.ITP2) THEN
          CALL MSGERR(MDOC,' ERR: TYPE OF FILE-1 # TYPE OF FILE-2')
          IERR=1
          CLOSE(MT1)
          CLOSE(MT2)
          RETURN
        ENDIF
      ENDIF
C ---------------------------------------------------
      IF(ATOP.LE.1.E-6) THEN
        ATOP=100.
        IF(ITPR.EQ.'ANGL') ATOP=180.
        IF(ITPR.EQ.'PHAS') ATOP=1.
      ENDIF
c      MD=-1
      WRITE(LINE,'('' ATOP:'',F10.3)') ATOP
      CALL MSGDOC(MD,LINE)
C ---------------------------------------------------
      IF(R1.LT.R2) THEN
        T=R1
        R1=R2
        R2=T
      ENDIF
      IF(R1.GT.1.E-5.AND.R2.GT.1.E-5) THEN
        RESMIN=R1
        RESMAX=R2
      ENDIF
c      MD=-1
      WRITE(LINE,'('' RESMIN,RESMAX :'',2F10.3)') RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      RHMIN=1./RESMIN
      RHMAX=1./RESMAX
C ---------------------------------------------------------
      NK=10
      DR=(RHMAX-RHMIN)/NK
      DF=ATOP/8.
      COSFM  =0.0
      FMDELTA=0.0
      DO    I=1,11
        RNF (I)=0.
        RNFA(I)=0.
        FM  (I)=0.
        FMA (I)=0.
        DO    J=1,11
          ANF  (I,J)=0.
          ANFA (I,J)=0.
          NF   (I,J)=0
          NFA  (I,J)=0
          SUM11(I,J)=0.
          SUM21(I,J)=0.
          SUM12(I,J)=0.
          SUM22(I,J)=0.
        ENDDO
      ENDDO
      NUMB1=0
      NUMB2=0
      IEND1=-1
      IEND2=-1
      DLFREE=0.0
      DLREST=0.0
      FSFREE=0.0
      FSREST=0.0
      DDEL =0.
      DDEL2=0.
      FSUM =0.
      FSUM1=0.
      FSM21=0.
      FSM22=0.
      FSM12=0.
      NO   =0
      NOFREE=0
      NOREST=0
      ATR(1)=0.
      RHR(1)=RHMIN
      JH=0
      JK=0
      JL=0
      FFA=0.
      FFB=0.
      DO    I=2,11
        ATR(I)=ATR(I-1)+DF
        RHR(I)=RHR(I-1)+DR
      ENDDO
C     CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C---------------------------------------------------------
   40 CONTINUE
      IF(IEND1.EQ.1) GO TO 50
      IF(ITF1.EQ.'FS  ') THEN
        CALL RRD1(MT1,IH,IK,IL,FA,FB,SA,SB,KEY1,IEND1)
      ELSE
        CALL RD1(MT1,IH,IK,IL,FA,FB,KEY1,IEND1)
        SA=.04*FA
        SB=.04*FB
      ENDIF
      IF(MT1.LE.0) THEN
        IF(MT2.GT.0) CLOSE(MT2)
        IERR=1
        RETURN
      ENDIF
      IF(IEND1.EQ.0) NUMB1=NUMB1+1
      IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 40
  663 IF(IEND1.EQ.1.OR.IEND2.EQ.1)        GO TO 50
      IF(MT2.EQ.0) GO TO 650

C        IF(JL-IL) 660,661,40
C  661   IF(JK-IK) 660,662,40
C  662   IF(JH-IH) 660,650,40

        IF(JL.LT.IL) GO TO 660
        IF(JL.GT.IL) GO TO 40
        IF(JK.LT.IK) GO TO 660
        IF(JK.GT.IK) GO TO 40
        IF(JH.LT.IH) GO TO 660
        IF(JH.GT.IH) GO TO 40
        GO TO 650

  660   CONTINUE
        IF(ITF2.EQ.'FS  ') THEN
          CALL RRD2(MT2,JH,JK,JL,FFA,FFB,SSA,SSB,KEY2,IEND2)
        ELSE
          CALL RD2(MT2,JH,JK,JL,FFA,FFB,KEY2,IEND2)
          SSA=.04*FFA
          SSB=.04*FFB
        ENDIF
        IF(MT2.LE.0) THEN
          CLOSE(MT1)
          IERR=1
          RETURN
        ENDIF
        IF(IEND2.EQ.1) GO TO 50
        IF(IEND2.EQ.0) NUMB2=NUMB2+1
        GO TO 663
  650 CONTINUE
      SIGA=0.
      SIGB=0.
      IF(ITPR.EQ.'ANOM') THEN
        GA=0.
        FFA=FB
        FB=0.
        IF(FA.LT.1.E-5.OR.FFA.LT.1.E-5) GO TO 40
        DEL=ABS(FA-FFA)
        IF(FA.LT.FFA) THEN
          FB=DEL
        ELSE
          GA=DEL
        ENDIF
      ELSE IF(ITPR.EQ.'FMOD') THEN
        IF(MT2.NE.0) THEN
          IF(FB.LT.1.E-5) FB=FA
          IF(FA.LT.1.E-5) FA=FB
          FA=(FA+FB)*.5
          IF(FFB.LT.1.E-5) FFB=FFA
          IF(FFA.LT.1.E-5) FFA=FFB
          FFA=(FFA+FFB)*.5
        ENDIF
        DEL=ABS(FA-FFA)
        GA=FA
        SIGA=SA
        SIGB=SB
      ELSE IF(ITPR.EQ.'PHAS') THEN
        DEL=ABS(FA-FFA)
        GA=FA
        DEL=ABS(SQRT((FA-FFA)**2+(FB-FFB)**2))
        SCL=(FA*FFA+FB*FFB)
        FA=SQRT(FA*FA+FB*FB)
        FFA=SQRT(FFA*FFA+FFB*FFB)
        GA=FA
      ELSE
        IF(MT2.EQ.0) FFA=1.0
        DEL=ABS(SQRT((FA-FFA)**2+(FB-FFB)**2))
        SCL=(FA*FFA+FB*FFB)
        FA=SQRT(FA*FA+FB*FB)
        FFA=SQRT(FFA*FFA+FFB*FFB)
        GA=0.
        CS=FA*FFA
        IF(CS.GT.1.E-5) THEN
          FM12DELTA=CS
          GA=SCL/CS
          CS=ABS(SQRT(ABS(1.-GA*GA)))
          IF(ABS(GA).GT.1.E-5) THEN
            GA=ATAN(CS/GA)*57.29578
            IF(GA.LT.0) THEN
              IF(GA.GT.-1.E-5) GA=0.
              IF(GA.LT.0) GA=180.+GA
            ENDIF
          ELSE
            GA=90.
          ENDIF
          FM12DELTA=FM12DELTA*GA
        ENDIF
      ENDIF
      CALL DSTAR_BL(IH,IK,IL,RSQ)
      RH=SQRT(RSQ)
      IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 40
      K=(RH-RHMIN)/DR+1.
      IF(K.GT.NK) K=NK
      IF(GA.LT.1.E-5.AND.ITP1.NE.'PH  '.AND.ITPR.NE.'ANOM') GO TO 30
      L1=GA/DF+1.
      IF(L1.GT.8) L1=0
      IF(GA.LT.1.E-5.AND.ITPR.EQ.'ANOM') GO TO 1000
      FM(K)       =FM(K)+GA
      NF(11,K)    =NF(11,K) +1
      NF(11,11)   =NF(11,11)+1
      SUM11(11,K) =SUM11(11,K)  +SIGA
      SUM12(11,K) =SUM12(11,K)  +GA
      SUM11(11,11)=SUM11(11,11) +SIGA
      SUM12(11,11)=SUM12(11,11) +GA
 1000 ANF (11,11) =ANF (11,11) +DEL
      DDEL        =DDEL        +DEL
      DDEL2       =DDEL2       +DEL*DEL
      ANFA(11,11) =ANFA(11,11) +FA
      ANF (11,K)  =ANF (11,K)  +DEL
      ANFA(11,K)  =ANFA(11,K)  +FA
      NO   =NO   +1
      FSUM =FSUM +FA
      FSUM1=FSUM1+FFA
      FSM21=FSM21+FA*FA
      FSM22=FSM22+FFA*FFA
      FSM12=FSM12+FA*FFA
C      CALL HSRD(RAND)
C      RAND1=RAND+0.5
C      IF(RAND1.GT.0.1) THEN
C        NOREST=NOREST+1
C        FSREST=FSREST+FA
C        DLREST=DLREST+DEL
C      ELSE
C        NOFREE=NOFREE+1
C        FSFREE=FSFREE+FA
C        DLFREE=DLFREE+DEL
C      ENDIF
      IF(GA.LT.1.E-5.AND.ITPR.EQ.'ANOM') GO TO 1010
      FM(11)      =FM(11)   +GA

      FMDELTA=FMDELTA       + FM12DELTA

      IF(L1.LE.0) GO TO 30
      NF(L1,K)    =NF(L1,K) +1
      NF(L1,11)   =NF(L1,11)+1
      SUM11(L1,K) =SUM11(L1,K) +SIGA
      SUM12(L1,K) =SUM12(L1,K) +GA
      SUM11(L1,11)=SUM11(L1,11)+SIGA
      SUM12(L1,11)=SUM12(L1,11)+GA
 1010 IF(L1.LE.0) GO TO 30
      ANF (L1,11)=ANF (L1,11)+DEL
      ANFA(L1,11)=ANFA(L1,11)+FA
      ANF (L1,K) =ANF (L1,K) +DEL
      ANFA(L1,K) =ANFA(L1,K) +FA
   30 IF(FB.LT.1.E-5) GO TO 40
      L2=FB/DF+1.
      IF(L2.GT.8) L2=0
      NFA  (11,K) =NFA  (11,K) +1
      NFA  (11,11)=NFA  (11,11)+1
      SUM21(11,K) =SUM21(11,K) +SIGB
      SUM22(11,K) =SUM22(11,K) +FB
      SUM21(11,11)=SUM21(11,11)+SIGB
      SUM22(11,11)=SUM22(11,11)+FB
      FMA  (K)    =FMA  (K)    +FB
      FMA  (11)   =FMA  (11)   +FB
      IF(L2.LE.0) GO TO 40
      NFA  (L2,K) =NFA  (L2,K) +1
      NFA  (L2,11)=NFA  (L2,11)+1
      SUM21(L2,K) =SUM21(L2,K) +SIGB
      SUM22(L2,K) =SUM22(L2,K) +FB
      SUM21(L2,11)=SUM21(L2,11)+SIGB
      SUM22(L2,11)=SUM22(L2,11)+FB
      GO TO 40
C ----------------------------------------------------
   50 CONTINUE
      DO    I=1,NK+1
        RHR(I)=1./RHR(I)
      ENDDO
      IF(MT2.EQ.0.AND.ITPR.NE.'ANOM') GO TO 700
      DO    J=1,11
        DO    I=1,J
          RNF (J)=RNF (J)+ANF (11,I)
          RNFA(J)=RNFA(J)+ANFA(11,I)
        ENDDO
      ENDDO
      DO    I=1,11
        IF(RNFA(I).NE.0.0) RNF(I)=RNF(I)/RNFA(I)
      ENDDO
      DO    I=1,11
      DO    J=1,11
        ISTOR=NF(I,J)
        IF(ITPR.EQ.'ANOM') ISTOR=ISTOR+NFA(I,J)
        IF(ISTOR.NE.0) ANF(I,J)=ANF(I,J)/ANFA(I,J)
      ENDDO
      ENDDO
  700 CONTINUE
      IF(MT2.EQ.0.AND.ITPR.EQ.'FMOD') THEN
        DO    I=1,11
        DO    J=1,11
          ISTOR=NF(I,J)
          IF(ISTOR.NE.0) SUM11(I,J)=SUM11(I,J)/SUM12(I,J)
          ISTOR=NFA(I,J)
          IF(ISTOR.NE.0) SUM21(I,J)=SUM21(I,J)/SUM22(I,J)
        ENDDO
        ENDDO
      ENDIF
      DO    I=1,11
        IF(NF (11,I).NE.0) FM (I)=FM (I)/NF (11,I)
        IF(NFA(11,I).NE.0) FMA(I)=FMA(I)/NFA(11,I)
      ENDDO

      IF(NF(11,11).NE.0) THEN
        FMDELTA=FMDELTA/NF(11,11)
      ENDIF

      CALL MSGDOC(MD,' ')
      CALL MSGDOC(MD,'     STATISTICS FOR : ')
      CALL MSGDOC(MD,' ')
      WRITE(LINE,60) NUMB1
   60 FORMAT(5X,'FILE-1 : NUMBER OF REFLS=',I8)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MD,' ')
C ------------------------------------------------
      IF(ITPR.EQ.'ANGL') THEN
        CALL MSGDOC(MD,' ')
        CALL MSGDOC(MDOC,'                      !ANGLE 1 - ANGLE 2!')
        CALL MSGDOC(MD,' ')
        IF(MT2.EQ.0) THEN
          CALL MSGDOC(MDOC,'                         ANGLE 2 = 0')
          CALL MSGDOC(MD,' ')
        ENDIF
        CALL MSGDOC(MD,'                 VALUE DELTA(ANGLE) GRAD')
        WRITE(LINE,820) (ATR(I),I=2,9)
  820   FORMAT('RANGE (A) ','0.00',8(F5.1,1X),2X,'TOTAL',2X,'AVER')
        CALL MSGDOC(MD,LINE)
      ELSE IF(ITP1.EQ.'PH  ') THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'                          FIG. OF MER.')
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'                      VALUE FIG OF MER ')
        WRITE(LINE,640) (ATR(I),I=2,9)
  640   FORMAT('RANGE (A) ','0.00',8F6.2,3X,'TOTAL',2X,'AVER')
        CALL MSGDOC(MDOC,LINE)
      ELSE
        IF(ITPR.NE.'ANOM') THEN
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,'                           F(H,K,L)')
          CALL MSGDOC(MDOC,' ')
        ELSE IF(ITPR.EQ.'ANOM') THEN
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,'      +DEL( F(H,K,L)-F(-H,-K,-L) )')
          CALL MSGDOC(MDOC,' ')
        ENDIF
        CALL MSGDOC(MDOC,'             VALUE OF STR. FACTOR ')
        WRITE(LINE,100) (ATR(I),I=2,9)
  100   FORMAT('RANGE (A) ','0.00',8F6.2,3X,'TOTAL',2X,'AVER')
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C------------------------------------
  130 FORMAT(F5.1,'-',F5.1,8('!',I5),'I',I6,'I',E12.4)
  140 FORMAT('   TOTAL',3X,8(1X,I5),1X,I6,1X,E12.4)

C-------------------------------
      WRITE(LINE,110)
  110 FORMAT(1X,78('-'))
      CALL MSGDOC(MD,LINE)
      DO    I=1,NK
        WRITE(LINE,130) RHR(I),RHR(I+1),(NF(J,I),J=1,8),NF(11,I),FM(I)
        CALL MSGDOC(MD,LINE)
      ENDDO
      WRITE(LINE,110)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,140) (NF(J,11),J=1,8),NF(11,11),FM(11)
      CALL MSGDOC(MD,LINE)
      IF(ITPR.EQ.'ANGL') THEN
        IF(MT2.GT.0) THEN
          CALL MSGDOC(MDOC,' ')
          WRITE(LINE,'(''<DELTA> ='',F7.2)') FM(11)
          CALL MSGDOC(MDOC,LINE)
          COSDELTA=COS(FM(11)/57.29578)
          WRITE(LINE,'(''COS(<DELTA>),<m1m2DELTA> ='',F6.3,F10.3)') 
     *    COSDELTA,FMDELTA
          CALL MSGDOC(MDOC,LINE)
        ELSE
          CALL MSGDOC(MDOC,' ')
          WRITE(LINE,'(''   <ANGLE> ='',F7.2)') FM(11)
          CALL MSGDOC(MDOC,LINE)
        ENDIF
        DO I=1,NK
C  I  1 - RESOL  2 NUMB  3 - <DELTA> 
C 11     TOT_RES    N        < > -TOT   
          RESULT(I,1)=RHR(I)
          RESULT(I,2)=NF(11,I)
          RESULT(I,3)=FM(I)
        ENDDO
        RESULT(11,1)=RHR(11)
        RESULT(11,2)=NF (11,11)
        RESULT(11,3)=FM(11)
        RESULT(11,4)=FM(11)
      ENDIF
      NFUN=1
      FMIN=0.0
      FMAX=0.0
      DO I=1,NK
        IF(FM(I).GT.FMAX)  FMAX=FM(I)
      ENDDO
      IF(FMAX.LE.0.0) FMAX=1.0
      CALL GRAPH_A(MDOC,NK,NFUN,RESULT(1,2),RHR
     * ,RESULT(1,3),RESULT(1,3),FMIN,FMAX)
      IF(ITPR.EQ.'FMOD'.AND.ITF1.EQ.'FS  '.AND.MT2.EQ.0) THEN
C ::::::::::::::::
        IF(STOP_T.EQ.'Y') THEN
          CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
          READ(*,'(A)') MSG1
        ENDIF
C ::::::::::::::::
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'                 SUM(SIGMA)/SUM(F(H,K,L))')
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'                  VALUE OF STR. FACTOR')
        WRITE(LINE,101) (ATR(I),I=2,9)
        CALL MSGDOC(MDOC,LINE)
C------------------------------------
  101   FORMAT('RANGE (A) ','0.00',8F6.2,3X,'TOTAL')
  111   FORMAT(72('-'))

  131   FORMAT(F5.1,'-',F5.1,8('!',F5.3),'I',1X,F5.3,'I')
  141   FORMAT('   TOTAL',3X,8(1X,F5.3),2X,F5.3)
C-------------------------------
        WRITE(LINE,111)
        CALL MSGDOC(MDOC,LINE)
        DO    I=1,8
         WRITE(LINE,131) RHR(I),RHR(I+1),(SUM11(J,I),J=1,8),SUM11(11,I)
         CALL MSGDOC(MDOC,LINE)
        ENDDO
        WRITE(LINE,111)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,141) (SUM11(J,11),J=1,8),SUM11(11,11)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(MT2 .GT.0)       GO TO 720
      IF(ITP1.EQ.'PH  ')  GO TO 500
      IF(NFA(11,11).EQ.0) GO TO 500
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      CALL MSGDOC(MDOC,' ')
      IF(ITPR.NE.'ANOM') THEN
        CALL MSGDOC(MDOC,'                         F(-H,-K,-L)')
      ENDIF
      IF(ITPR.EQ.'ANOM') THEN
        CALL MSGDOC(MDOC,'           -DEL( F(H,K,L)-F(-H,-K,-L) )')
      ENDIF
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,100) (ATR(I),I=2,9)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,110)
      CALL MSGDOC(MDOC,LINE)
      DO    I=1,8
        WRITE(LINE,130) 
     *  RHR(I),RHR(I+1),(NFA(J,I),J=1,8),NFA(11,I),FMA(I)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      WRITE(LINE,110)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,140) (NFA(J,11),J=1,8),NFA(11,11),FMA(11)
      CALL MSGDOC(MDOC,LINE)
      IF(ITPR.EQ.'FMOD'.AND.ITF1.EQ.'FS  '.AND.MT2.EQ.0) THEN
C ::::::::::::::::
        IF(STOP_T.EQ.'Y') THEN
   
          CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
          READ(*,'(A)') MSG1
        ENDIF
C ::::::::::::::::
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'         SUM(SIGMA)/SUM(F(-H,-K,-L)) ')
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,101) (ATR(I),I=2,9)
        CALL MSGDOC(MDOC,LINE)
C-------------------------------
        WRITE(LINE,111)
        CALL MSGDOC(MDOC,LINE)
        DO    I=1,8
         WRITE(LINE,131) RHR(I),RHR(I+1),(SUM21(J,I),J=1,8),SUM21(11,I)
         CALL MSGDOC(MDOC,LINE)
        ENDDO
        WRITE(LINE,111)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,141) (SUM21(J,11),J=1,8),SUM21(11,11)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(ITPR.NE.'ANOM') GO TO 500
  720   CONTINUE
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      IF(ITP1.EQ.'PH  ') THEN
        CALL MSGDOC(MD,' ')
        CALL MSGDOC(MD
     *  ,'       R-FAC=SUM(!FOM1-FOM2!)/SUM(!FOM1!+!FOM2!)')
        CALL MSGDOC(MD,' ')
        IF(ITPR.EQ.'ANGL') THEN
          WRITE(LINE,820) (ATR(I),I=2,9)
          CALL MSGDOC(MD,LINE)
        ELSE
          WRITE(LINE,640) (ATR(I),I=2,9)
          CALL MSGDOC(MD,LINE)
        ENDIF
      ELSE
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'       CRYST. R-FACTOR   <!F1-F2!>/<!F1!>')
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,100) (ATR(I),I=2,9)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      WRITE(LINE,110)
      CALL MSGDOC(MD,LINE)
      DO    I=1,8
        WRITE(LINE,760) RHR(I),RHR(I+1),(ANF(J,I),J=1,8),ANF(11,I)
  760   FORMAT(F5.1,'-',F5.1,8('!',F5.3),'I',6X,'I',4X,F7.3)
        CALL MSGDOC(MD,LINE)
      ENDDO
      WRITE(LINE,110)
      CALL MSGDOC(MD,LINE)
      IF(ITP1.EQ.'F   ') THEN
        T1=NO*FSM12-FSUM*FSUM1
        T2=NO*FSM21-FSUM*FSUM
        T3=NO*FSM22-FSUM1*FSUM1
        T2=T2*T3
        IF(T2.LT.1.E-7) THEN
          RCORR=10000000.
        ELSE
          T2=SQRT(T2)
          RCORR=T1/T2
        ENDIF
        RFAC=DDEL/FSUM
        R2=DDEL/(FSUM+FSUM1)
        IF(NO.GE.2) THEN
          RMS=SQRT(DDEL2/NO)
        ELSE
          RMS=0.0
        ENDIF
C        RFREE=-1.0
C        IF(NOFREE.GT.0.AND.FSFREE.GT.0.0) THEN
C          RFREE=DLFREE/FSFREE
C        ENDIF
C        RREST=-1.0
C        IF(NOREST.GT.0.AND.FSREST.GT.0.0) THEN
C          RFREST=DLREST/FSREST
C        ENDIF
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,'(5X,''R-FAC=<!F1-F2!>/<!F1!>     ='',F8.4)')RFAC
        CALL MSGDOC(MDOC,LINE)
C       WRITE(*,'(5X,''R-FAC=<!F1-F2!>/<!F1!+!F2!>='',F8.4)') R2
        WRITE(LINE,'(5X,''R-CORR                     ='',F8.4)') RCORR
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     *  '(''  <F1*F2>-<F1><F2>/SQRT(<F1^2>-<F1>^2)(<F2^2>-<F2>^2)'')') 
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(  5X,''RMS=SQRT( < (F1-F2)**2 > ) ='',F8.4)') RMS
        CALL MSGDOC(MDOC,LINE)
C        WRITE(*,'(  5X
C     *  ,''R-FREE,N     /10%/         ='',F8.4,I8)') RFREE,NOFREE
C        WRITE(*,'(  5X
C     *  ,''R-REST,N     /90%/         ='',F8.4,I8)') RFREST,NOREST
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,920)  RHR(1),(RHR(I+1),I=1,8)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,921) (RNF(I),I=1,8)
        CALL MSGDOC(MDOC,LINE)
  920   FORMAT(' A :',F5.1,8(3X,F5.1))
  921   FORMAT(' R :',5X,8(F8.4))
      ENDIF
  500 CLOSE(MT1)
      IF(MT2.GT.0) CLOSE(MT2)
      RETURN
      END

      SUBROUTINE STATA(ITPR,MDOC,NAME1,NAME2,R1,R2,ATOP
     * ,STOP_T,ISYM,IPRSYM,IERR)
C -----------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NUMB1,ISTOR
      INTEGER   NF(11,11),NFA(11,11)
      REAL      RHR(11),FM(11),FMA(11),ATR(11)
      REAL      ANF(11,11),ANFA(11,11),RLATT(6)
      REAL      RNF(11),RNFA(11)
      REAL      SUM11(11,11),SUM12(11,11)
      REAL      SUM21(11,11),SUM22(11,11)
      CHARACTER ITPR*4,STOP_T
      CHARACTER ITP1*4,ITP2*4,ITF1*4,ITF2*4
      CHARACTER NAME1*(*),NAME2*(*),TTT*80,LINE*80
      CHARACTER MSG*1,MSG1*1
C================================================================
      IERR=0
C      CALL CHECK_BATCH(IBAT)
C      STOP_T='N'
C      IF(IBAT.EQ.0) STOP_T='Y'
C     CALL MSGDOC(MDOC,'INPUT FILE-1')
      MT1 =11
      ITP1='    '
      MDD=-ABS(MDOC)-1
      MD=0
      CALL ORFILE(MDD,MT1,NAME1,ITP1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-1')
        RETURN
      ENDIF
      CALL GET_TITLE(MDD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,NX,NY,NZ,IZN,IZM,TTT,IERR)
      CALL C_RD_CR
      RN=RESMIN
      RX=RESMAX
      IF(ITP1.NE.'F   '.AND.ITP1.NE.'PH  '.AND.ITP1.NE.'FS  ') THEN
        CALL MSGERR(MDOC,' ERR: WRONG TYPE OF FILE')
        CLOSE(MT1)
        IERR=1
        RETURN
      ENDIF
      ITF1=ITP1
      IF(ITP1.EQ.'FS  ') ITP1='F   '
C ---------------------------------------------------
      MT2 =0
      MSG='N'
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',') THEN
        MSG='Y'
        MT2 =12
        ITP2='    '
C        CALL MSGDOC(MDOC,'INPUT FILE-2')
        MD=-1
        CALL ORFILE(MDD,MT2,NAME2,ITP2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MDD,A,B,C,AL,BE,GA
     *    ,F1,F2,RESMIN,RESMAX,NX,NY,NZ,IZN,IZM,TTT,IERR)
        IF(ITP2.NE.'F   '.AND.ITP2.NE.'PH  '.AND.ITP2.NE.'FS  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE OF FILE')
          IERR=1
          CLOSE(MT1)
          CLOSE(MT2)
          RETURN
        ENDIF
        ITF2=ITP2
        IF(ITP2.EQ.'FS  ') ITP2='F   '
        IF(RN.LT.RESMIN)   RESMIN=RN
        IF(RX.GT.RESMAX)   RESMAX=RX
        IF(ITP1.NE.ITP2) THEN
          CALL MSGERR(MDOC,' ERR: TYPE OF FILE-1 # TYPE OF FILE-2')
          IERR=1
          CLOSE(MT1)
          CLOSE(MT2)
          RETURN
        ENDIF
      ENDIF
C ---------------------------------------------------
      IF(ATOP.LE.1.E-6) THEN
        ATOP=100.
        IF(ITPR.EQ.'ANGL') ATOP=180.
        IF(ITPR.EQ.'PHAS') ATOP=1.
      ENDIF
      MD=-1
      WRITE(LINE,'('' ATOP:'',F10.3)') ATOP
      CALL MSGDOC(MD,LINE)
C ---------------------------------------------------
      IF(R1.LT.R2) THEN
        T=R1
        R1=R2
        R2=T
      ENDIF
      IF(R1.GT.1.E-5.AND.R2.GT.1.E-5) THEN
        RESMIN=R1
        RESMAX=R2
      ENDIF
      MD=-1
      WRITE(LINE,'('' RESMIN,RESMAX :'',2F10.3)') RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      RHMIN=1./RESMIN
      RHMAX=1./RESMAX
C ---------------------------------------------------------
      DR=(RHMAX-RHMIN)/8.
      DF=ATOP/8.
      DO    I=1,11
        RNF (I)=0.
        RNFA(I)=0.
        FM  (I)=0.
        FMA (I)=0.
        DO    J=1,11
          ANF  (I,J)=0.
          ANFA (I,J)=0.
          NF   (I,J)=0
          NFA  (I,J)=0
          SUM11(I,J)=0.
          SUM21(I,J)=0.
          SUM12(I,J)=0.
          SUM22(I,J)=0.
        ENDDO
      ENDDO
      NUMB1=0
      NUMB2=0
      IEND1=-1
      IEND2=-1
      DLFREE=0.0
      DLREST=0.0
      FSFREE=0.0
      FSREST=0.0
      DDEL =0.
      DDEL2=0.
      FSUM =0.
      FSUM1=0.
      FSM21=0.
      FSM22=0.
      FSM12=0.
      NO   =0
      NOFREE=0
      NOREST=0
      ATR(1)=0.
      RHR(1)=RHMIN
      JH=0
      JK=0
      JL=0
      FFA=0.
      FFB=0.
      DO    I=2,11
        ATR(I)=ATR(I-1)+DF
        RHR(I)=RHR(I-1)+DR
      ENDDO
c      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C---------------------------------------------------------
   40 CONTINUE
      IF(IEND1.EQ.1) GO TO 50
      IF(ITF1.EQ.'FS  ') THEN
        CALL RRD1(MT1,IH,IK,IL,FA,FB,SA,SB,KEY1,IEND1)
      ELSE
        CALL RD1(MT1,IH,IK,IL,FA,FB,KEY1,IEND1)
        SA=.04*FA
        SB=.04*FB
      ENDIF
      IF(MT1.LE.0) THEN
        IF(MT2.GT.0) CLOSE(MT2)
        IERR=1
        RETURN
      ENDIF
      IF(IEND1.EQ.0) NUMB1=NUMB1+1
      IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 40
  663 IF(IEND1.EQ.1.OR.IEND2.EQ.1)        GO TO 50
      IF(MT2.EQ.0) GO TO 650

C        IF(JL-IL) 660,661,40
C  661   IF(JK-IK) 660,662,40
C  662   IF(JH-IH) 660,650,40

        IF(JL.LT.IL) GO TO 660
        IF(JL.GT.IL) GO TO 40
        IF(JK.LT.IK) GO TO 660
        IF(JK.GT.IK) GO TO 40
        IF(JH.LT.IH) GO TO 660
        IF(JH.GT.IH) GO TO 40
        GO TO 650

  660   CONTINUE
        IF(ITF2.EQ.'FS  ') THEN
          CALL RRD2(MT2,JH,JK,JL,FFA,FFB,SSA,SSB,KEY2,IEND2)
        ELSE
          CALL RD2(MT2,JH,JK,JL,FFA,FFB,KEY2,IEND2)
          SSA=.04*FFA
          SSB=.04*FFB
        ENDIF
        IF(MT2.LE.0) THEN
          CLOSE(MT1)
          IERR=1
          RETURN
        ENDIF
        IF(IEND2.EQ.1) GO TO 50
        IF(IEND2.EQ.0) NUMB2=NUMB2+1
        GO TO 663
  650 CONTINUE
      SIGA=0.
      SIGB=0.
      IF(ITPR.EQ.'ANOM') THEN
        GA=0.
        FFA=FB
        FB=0.
        IF(FA.LT.1.E-5.OR.FFA.LT.1.E-5) GO TO 40
        DEL=ABS(FA-FFA)
        IF(FA.LT.FFA) THEN
          FB=DEL
        ELSE
          GA=DEL
        ENDIF
      ELSE IF(ITPR.EQ.'FMOD') THEN
        IF(MT2.NE.0) THEN
          IF(FB.LT.1.E-5) FB=FA
          IF(FA.LT.1.E-5) FA=FB
          FA=(FA+FB)*.5
          IF(FFB.LT.1.E-5) FFB=FFA
          IF(FFA.LT.1.E-5) FFA=FFB
          FFA=(FFA+FFB)*.5
        ENDIF
        DEL=ABS(FA-FFA)
        GA=FA
        SIGA=SA
        SIGB=SB
      ELSE IF(ITPR.EQ.'PHAS') THEN
        DEL=ABS(FA-FFA)
        GA=FA
        DEL=ABS(SQRT((FA-FFA)**2+(FB-FFB)**2))
        SCL=(FA*FFA+FB*FFB)
        FA=SQRT(FA*FA+FB*FB)
        FFA=SQRT(FFA*FFA+FFB*FFB)
        GA=FA
      ELSE
        IF(MT2.EQ.0) FFA=1.0
        DEL=ABS(SQRT((FA-FFA)**2+(FB-FFB)**2))
        SCL=(FA*FFA+FB*FFB)
        FA=SQRT(FA*FA+FB*FB)
        FFA=SQRT(FFA*FFA+FFB*FFB)
        GA=0.
        CS=FA*FFA
        IF(CS.GT.1.E-5) THEN
          GA=SCL/CS
          CS=ABS(SQRT(ABS(1.-GA*GA)))
          IF(ABS(GA).GT.1.E-5) THEN
            GA=ATAN(CS/GA)*57.29578
            IF(GA.LT.0) THEN
              IF(GA.GT.-1.E-5) GA=0.
              IF(GA.LT.0) GA=180.+GA
            ENDIF
          ELSE
            GA=90.
          ENDIF
        ENDIF
      ENDIF
      CALL DSTAR_BL(IH,IK,IL,RSQ)
      RH=SQRT(RSQ)
      IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 40
      K=(RH-RHMIN)/DR+1.
      IF(K.GT.8) K=8
      IF(GA.LT.1.E-5.AND.ITP1.NE.'PH  '.AND.ITPR.NE.'ANOM') GO TO 30
      L1=GA/DF+1.
      IF(L1.GT.8) L1=0
      IF(GA.LT.1.E-5.AND.ITPR.EQ.'ANOM') GO TO 1000
      FM(K)       =FM(K)+GA
      NF(11,K)    =NF(11,K) +1
      NF(11,11)   =NF(11,11)+1
      SUM11(11,K) =SUM11(11,K)  +SIGA
      SUM12(11,K) =SUM12(11,K)  +GA
      SUM11(11,11)=SUM11(11,11) +SIGA
      SUM12(11,11)=SUM12(11,11) +GA
 1000 ANF (11,11) =ANF (11,11) +DEL
      DDEL        =DDEL        +DEL
      DDEL2       =DDEL2       +DEL*DEL
      ANFA(11,11) =ANFA(11,11) +FA
      ANF (11,K)  =ANF (11,K)  +DEL
      ANFA(11,K)  =ANFA(11,K)  +FA
      NO   =NO   +1
      FSUM =FSUM +FA
      FSUM1=FSUM1+FFA
      FSM21=FSM21+FA*FA
      FSM22=FSM22+FFA*FFA
      FSM12=FSM12+FA*FFA
C      CALL HSRD(RAND)
C      RAND1=RAND+0.5
C      IF(RAND1.GT.0.1) THEN
C        NOREST=NOREST+1
C        FSREST=FSREST+FA
C        DLREST=DLREST+DEL
C      ELSE
C        NOFREE=NOFREE+1
C        FSFREE=FSFREE+FA
C        DLFREE=DLFREE+DEL
C      ENDIF
      IF(GA.LT.1.E-5.AND.ITPR.EQ.'ANOM') GO TO 1010
      FM(11)      =FM(11)   +GA
      IF(L1.LE.0) GO TO 30
      NF(L1,K)    =NF(L1,K) +1
      NF(L1,11)   =NF(L1,11)+1
      SUM11(L1,K) =SUM11(L1,K) +SIGA
      SUM12(L1,K) =SUM12(L1,K) +GA
      SUM11(L1,11)=SUM11(L1,11)+SIGA
      SUM12(L1,11)=SUM12(L1,11)+GA
 1010 IF(L1.LE.0) GO TO 30
      ANF (L1,11)=ANF (L1,11)+DEL
      ANFA(L1,11)=ANFA(L1,11)+FA
      ANF (L1,K) =ANF (L1,K) +DEL
      ANFA(L1,K) =ANFA(L1,K) +FA
   30 IF(FB.LT.1.E-5) GO TO 40
      L2=FB/DF+1.
      IF(L2.GT.8) L2=0
      NFA  (11,K) =NFA  (11,K) +1
      NFA  (11,11)=NFA  (11,11)+1
      SUM21(11,K) =SUM21(11,K) +SIGB
      SUM22(11,K) =SUM22(11,K) +FB
      SUM21(11,11)=SUM21(11,11)+SIGB
      SUM22(11,11)=SUM22(11,11)+FB
      FMA  (K)    =FMA  (K)    +FB
      FMA  (11)   =FMA  (11)   +FB
      IF(L2.LE.0) GO TO 40
      NFA  (L2,K) =NFA  (L2,K) +1
      NFA  (L2,11)=NFA  (L2,11)+1
      SUM21(L2,K) =SUM21(L2,K) +SIGB
      SUM22(L2,K) =SUM22(L2,K) +FB
      SUM21(L2,11)=SUM21(L2,11)+SIGB
      SUM22(L2,11)=SUM22(L2,11)+FB
      GO TO 40
C ----------------------------------------------------
   50 CONTINUE
      DO    I=1,9
        RHR(I)=1./RHR(I)
      ENDDO
      IF(MT2.EQ.0.AND.ITPR.NE.'ANOM') GO TO 700
      DO    J=1,11
        DO    I=1,J
          RNF (J)=RNF (J)+ANF (11,I)
          RNFA(J)=RNFA(J)+ANFA(11,I)
        ENDDO
      ENDDO
      DO    I=1,11
        IF(RNFA(I).NE.0.0) RNF(I)=RNF(I)/RNFA(I)
      ENDDO
      DO    I=1,11
      DO    J=1,11
        ISTOR=NF(I,J)
        IF(ITPR.EQ.'ANOM') ISTOR=ISTOR+NFA(I,J)
        IF(ISTOR.NE.0) ANF(I,J)=ANF(I,J)/ANFA(I,J)
      ENDDO
      ENDDO
  700 CONTINUE
      IF(MT2.EQ.0.AND.ITPR.EQ.'FMOD') THEN
        DO    I=1,11
        DO    J=1,11
          ISTOR=NF(I,J)
          IF(ISTOR.NE.0) SUM11(I,J)=SUM11(I,J)/SUM12(I,J)
          ISTOR=NFA(I,J)
          IF(ISTOR.NE.0) SUM21(I,J)=SUM21(I,J)/SUM22(I,J)
        ENDDO
        ENDDO
      ENDIF
      DO    I=1,11
        IF(NF (11,I).NE.0) FM (I)=FM (I)/NF (11,I)
        IF(NFA(11,I).NE.0) FMA(I)=FMA(I)/NFA(11,I)
      ENDDO
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,'     STATISTICS FOR : ')
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,60) NUMB1
   60 FORMAT(5X,'FILE-1 : NUMBER OF REFLS=',I8)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
C ------------------------------------------------
      IF(ITPR.EQ.'ANGL') THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'                      !ANGLE 1 - ANGLE 2!')
        CALL MSGDOC(MDOC,' ')
        IF(MT2.EQ.0) THEN
          CALL MSGDOC(MDOC,'                         ANGLE 2 = 0')
          CALL MSGDOC(MDOC,' ')
        ENDIF
        CALL MSGDOC(MDOC,'                 VALUE DELTA(ANGLE) GRAD')
        WRITE(LINE,820) (ATR(I),I=2,9)
  820   FORMAT('RANGE (A) ','0.00',8(F5.1,1X),2X,'TOTAL',2X,'AVER')
        CALL MSGDOC(MDOC,LINE)
      ELSE IF(ITP1.EQ.'PH  ') THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'                          FIG. OF MER.')
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'                      VALUE FIG OF MER ')
        WRITE(LINE,640) (ATR(I),I=2,9)
  640   FORMAT('RANGE (A) ','0.00',8F6.2,3X,'TOTAL',2X,'AVER')
        CALL MSGDOC(MDOC,LINE)
      ELSE
        IF(ITPR.NE.'ANOM') THEN
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,'                           F(H,K,L)')
          CALL MSGDOC(MDOC,' ')
        ELSE IF(ITPR.EQ.'ANOM') THEN
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,'      +DEL( F(H,K,L)-F(-H,-K,-L) )')
          CALL MSGDOC(MDOC,' ')
        ENDIF
        CALL MSGDOC(MDOC,'             VALUE OF STR. FACTOR ')
        WRITE(LINE,100) (ATR(I),I=2,9)
  100   FORMAT('RANGE (A) ','0.00',8F6.2,3X,'TOTAL',2X,'AVER')
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C------------------------------------
  130 FORMAT(F5.1,'-',F5.1,8('!',I5),'I',I6,'I',E12.4)
  140 FORMAT('   TOTAL',3X,8(1X,I5),1X,I6,1X,E12.4)

C-------------------------------
      WRITE(LINE,110)
  110 FORMAT(1X,78('-'))
      CALL MSGDOC(MDOC,LINE)
      DO    I=1,8
        WRITE(LINE,130) RHR(I),RHR(I+1),(NF(J,I),J=1,8),NF(11,I),FM(I)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      WRITE(LINE,110)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,140) (NF(J,11),J=1,8),NF(11,11),FM(11)
      CALL MSGDOC(MDOC,LINE)
      IF(ITPR.EQ.'FMOD'.AND.ITF1.EQ.'FS  '.AND.MT2.EQ.0) THEN
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'                 SUM(SIGMA)/SUM(F(H,K,L))')
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'                  VALUE OF STR. FACTOR')
        WRITE(LINE,101) (ATR(I),I=2,9)
        CALL MSGDOC(MDOC,LINE)
C------------------------------------
  101   FORMAT('RANGE (A) ','0.00',8F6.2,3X,'TOTAL')
  111   FORMAT(72('-'))

  131   FORMAT(F5.1,'-',F5.1,8('!',F5.3),'I',1X,F5.3,'I')
  141   FORMAT('   TOTAL',3X,8(1X,F5.3),2X,F5.3)
C-------------------------------
        WRITE(LINE,111)
        CALL MSGDOC(MDOC,LINE)
        DO    I=1,8
         WRITE(LINE,131) RHR(I),RHR(I+1),(SUM11(J,I),J=1,8),SUM11(11,I)
         CALL MSGDOC(MDOC,LINE)
        ENDDO
        WRITE(LINE,111)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,141) (SUM11(J,11),J=1,8),SUM11(11,11)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(MT2 .GT.0)       GO TO 720
      IF(ITP1.EQ.'PH  ')  GO TO 500
      IF(NFA(11,11).EQ.0) GO TO 500
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      CALL MSGDOC(MDOC,' ')
      IF(ITPR.NE.'ANOM') THEN
        CALL MSGDOC(MDOC,'                         F(-H,-K,-L)')
      ENDIF
      IF(ITPR.EQ.'ANOM') THEN
        CALL MSGDOC(MDOC,'           -DEL( F(H,K,L)-F(-H,-K,-L) )')
      ENDIF
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,100) (ATR(I),I=2,9)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,110)
      CALL MSGDOC(MDOC,LINE)
      DO    I=1,8
        WRITE(LINE,130) 
     *  RHR(I),RHR(I+1),(NFA(J,I),J=1,8),NFA(11,I),FMA(I)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      WRITE(LINE,110)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,140) (NFA(J,11),J=1,8),NFA(11,11),FMA(11)
      CALL MSGDOC(MDOC,LINE)
      IF(ITPR.EQ.'FMOD'.AND.ITF1.EQ.'FS  '.AND.MT2.EQ.0) THEN
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
   
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'         SUM(SIGMA)/SUM(F(-H,-K,-L)) ')
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,101) (ATR(I),I=2,9)
        CALL MSGDOC(MDOC,LINE)
C-------------------------------
        WRITE(LINE,111)
        CALL MSGDOC(MDOC,LINE)
        DO    I=1,8
         WRITE(LINE,131) RHR(I),RHR(I+1),(SUM21(J,I),J=1,8),SUM21(11,I)
         CALL MSGDOC(MDOC,LINE)
        ENDDO
        WRITE(LINE,111)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,141) (SUM21(J,11),J=1,8),SUM21(11,11)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(ITPR.NE.'ANOM') GO TO 500
  720 CONTINUE
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      IF(ITP1.EQ.'PH  ') THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC
     *  ,'       R-FAC=SUM(!FOM1-FOM2!)/SUM(!FOM1!+!FOM2!)')
        CALL MSGDOC(MDOC,' ')
        IF(ITPR.EQ.'ANGL') THEN
          WRITE(LINE,820) (ATR(I),I=2,9)
          CALL MSGDOC(MDOC,LINE)
        ELSE
          WRITE(LINE,640) (ATR(I),I=2,9)
          CALL MSGDOC(MDOC,LINE)
        ENDIF
      ELSE
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'       CRYST. R-FACTOR   <!F1-F2!>/<!F1!>')
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,100) (ATR(I),I=2,9)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      WRITE(LINE,110)
      CALL MSGDOC(MDOC,LINE)
      DO    I=1,8
        WRITE(LINE,760) RHR(I),RHR(I+1),(ANF(J,I),J=1,8),ANF(11,I)
  760   FORMAT(F5.1,'-',F5.1,8('!',F5.3),'I',6X,'I',4X,F7.3)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      WRITE(LINE,110)
      CALL MSGDOC(MDOC,LINE)
      IF(ITP1.EQ.'F   ') THEN
        T1=NO*FSM12-FSUM*FSUM1
        T2=NO*FSM21-FSUM*FSUM
        T3=NO*FSM22-FSUM1*FSUM1
        T2=T2*T3
        IF(T2.LT.1.E-7) THEN
          RCORR=10000000.
        ELSE
          T2=SQRT(T2)
          RCORR=T1/T2
        ENDIF
        RFAC=DDEL/FSUM
        R2=DDEL/(FSUM+FSUM1)
        IF(NO.GE.2) THEN
          RMS=SQRT(DDEL2/NO)
        ELSE
          RMS=0.0
        ENDIF
C        RFREE=-1.0
C        IF(NOFREE.GT.0.AND.FSFREE.GT.0.0) THEN
C          RFREE=DLFREE/FSFREE
C        ENDIF
C        RREST=-1.0
C        IF(NOREST.GT.0.AND.FSREST.GT.0.0) THEN
C          RFREST=DLREST/FSREST
C        ENDIF
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,'(5X,''R-FAC=<!F1-F2!>/<!F1!>     ='',F8.4)')RFAC
        CALL MSGDOC(MDOC,LINE)
C       WRITE(*,'(5X,''R-FAC=<!F1-F2!>/<!F1!+!F2!>='',F8.4)') R2
        WRITE(LINE,'(5X,''R-CORR                     ='',F8.4)') RCORR
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     *  '(''<F1*F2>-<F1><F2>/SQRT(<F1^2>-<F1>^2)(<F2^2>-<F2>^2)'')') 
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(  5X,''RMS=SQRT( < (F1-F2)**2 > ) ='',F8.4)') RMS
        CALL MSGDOC(MDOC,LINE)
C        WRITE(*,'(  5X
C     *  ,''R-FREE,N     /10%/         ='',F8.4,I8)') RFREE,NOFREE
C        WRITE(*,'(  5X
C     *  ,''R-REST,N     /90%/         ='',F8.4,I8)') RFREST,NOREST
      ENDIF
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,920)  RHR(1),(RHR(I+1),I=1,8)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,921) (RNF(I),I=1,8)
      CALL MSGDOC(MDOC,LINE)
  920 FORMAT(' A :',F5.1,8(3X,F5.1))
  921 FORMAT(' R :',5X,8(F8.4))
  500 CLOSE(MT1)
      IF(MT2.GT.0) CLOSE(MT2)
      RETURN
      END

      SUBROUTINE PLAN(MDOC,NAME1,NAME2,R1,R2,ATOP
     *   ,STOP_T,ISYM,IPRSYM,IERR)
C-----------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NUMBN,NREFLS
      REAL      RLATT(6)
      CHARACTER NAME1*(*),NAME2*(*),ITP1*4,ITF1*4,TTT*80
      CHARACTER ITP2*4,ITF2*4,STOP_T*1
      CHARACTER MSG*1,MSG1*1,LINE*80
      CHARACTER IDIG(18)*1,ILINE(101)*1,IST*1
      CHARACTER IDIGN(11)*1,CHAR1*1
      DATA IDIG /'0','1','2','3','4','5','6','7','8','9',
     *           '*',' ','.','I','=','-','+','0'/
      DATA IDIGN/'Z','A','B','C','D','E','F','G','H','J','K'/
C================================================================
C      CALL CHECK_BATCH(IBAT)
C      STOP_T='N'
C      IF(IBAT.EQ.0) STOP_T='Y'
      IPRINT=0
      MT1 =11
      ITP1='    '
      MD=-ABS(MDOC)-1
      CALL ORFILE(MD,MT1,NAME1,ITP1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-1')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,NX,NY,NZ,IZN,IZM,TTT,IERR)
      CALL C_RD_CR
      RN=RESMIN
      RX=RESMAX
      IF(ITP1.NE.'F   '.AND.ITP1.NE.'PH  '.AND.ITP1.NE.'FS  ') THEN
        CALL MSGERR(MDOC,' ERR: WRONG TYPE OF FILE-1')
        CLOSE(MT1)
        IERR=1
        RETURN
      ENDIF
      ITF1=ITP1
      IF(ITP1.EQ.'FS  ') ITP1='F   '
C -------------------------------------------------------
      MT2=0
      MSG='N'
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',') THEN
        MSG='Y'
        MT2 =12
        ITP2='    '
        MD=-1
        CALL ORFILE(MD,MT2,NAME2,ITP2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,NX,NY,NZ,IZN,IZM,TTT,IERR)
        IF(RN.LT.RESMIN) RESMIN=RN
        IF(RX.GT.RESMAX)  RESMAX=RX
        ITF2=ITP2
        IF(ITP2.EQ.'FS  ') ITP2='F   '
        IF(ITP2.NE.ITP1) THEN
          CALL MSGERR(MDOC,' ERR: TYPE OF FILE-1 # TYPE OF FILE-2')
          CLOSE(MT1)
          CLOSE(MT2)
          IERR=1
          RETURN
        ENDIF
      ENDIF
  670 CONTINUE
      IF(ABS(ATOP).LT.1.0E-7) ATOP=1.0
      IF(R1.LT.R2) THEN
        T=R1
        R1=R2
        R2=T
      ENDIF
      IF(R1.GT.1.E-5.AND.R2.GT.1.E-5) THEN
        RESMIN=R1
        RESMAX=R2
      ENDIF
      RHMIN=1./RESMIN
      RHMAX=1./RESMAX
C -------------------------------------------------
      ICOUNT=0
      IFL1  =0
C     IF(ITP1.EQ.'F   '.AND.MT2.NE.0) IFL1=1
      IF(MT2.NE.0) IFL1=1
      WRITE(LINE,50) ATOP
   50 FORMAT(' PLAN L   SCALE=',E12.4,5X,'(F(PRINT)=F*SCALE)')
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,' POSITIV VALUES : 0,1,2,3,4,5,6,7,8,9,*')
      CALL MSGDOC(MDOC,' NEGATIV VALUES : Z,A,B,C,D,E,F,G,H,J,K')
      CALL MSGDOC(MDOC,' ')
C --------------------------------------------------
      IF(ITP1.EQ.'PH  ') THEN
        IF(MT2.EQ.0) THEN
          CALL MSGDOC(MDOC,' ')
          WRITE(LINE,570)
          CALL MSGDOC(MDOC,LINE)
          CALL MSGDOC(MDOC,' ')
        ELSE
          CALL MSGDOC(MDOC,' ')
          WRITE(LINE,560)
          CALL MSGDOC(MDOC,LINE)
          CALL MSGDOC(MDOC,' ')
        ENDIF
      ELSE
        IF(MT2.EQ.0) THEN
          CALL MSGDOC(MDOC,' ')
          WRITE(LINE,540)
          CALL MSGDOC(MDOC,LINE)
          CALL MSGDOC(MDOC,' ')
        ELSE
          CALL MSGDOC(MDOC,' ')
          WRITE(LINE,520)
          CALL MSGDOC(MDOC,LINE)
          CALL MSGDOC(MDOC,' ')
        ENDIF
      ENDIF
  520 FORMAT(20X,' F1-F2 ')
  540 FORMAT(20X,'F(H,K,L)')
  560 FORMAT(20X,'ANGLE1 - ANGLE2')
  570 FORMAT(20X,'FIG. OF MER.')
      GA=0.0
      GB=0.0
      MH    =-100
      MK    =-100
      ML    =-100
      ILL   =-101
      IKK   =-101
      NUMB1 =0
      NUMB2 =0
      NUMBN =0
      NREFLS=0
      IEND1 =-1
      IEND2 =-1
      IN    =0
C ---------------------------------------------------------
  150 IF(IEND1.EQ.1)     GO TO 120
      IF(ITF1.EQ.'FS  ') THEN
        CALL RRD1(MT1,IH,IK,IL,FA,FB,SA,SB,KEY1,IEND1)
      ELSE
        CALL RD1(MT1,IH,IK,IL,FA,FB,KEY1,IEND1)
        SA=FA*.04
        SB=FB*.04
      ENDIF
      IF(IEND1.EQ.0) NUMB1=NUMB1+1
      IF(IEND1.EQ.1.OR.IEND2.EQ.1)     GO TO 120
      IF(MT2.EQ.0)       GO TO 425

C  421 IF(ML-IL) 424,422,150
C  422 IF(MK-IK) 424,423,150
C  423 IF(MH-IH) 424,425,150

  421 CONTINUE
      IF(ML.LT.IL) GO TO 424
      IF(ML.GT.IL) GO TO 150
      IF(MK.LT.IK) GO TO 424
      IF(MK.GT.IK) GO TO 150
      IF(MH.LT.IH) GO TO 424
      IF(MH.GT.IH) GO TO 150
      GO TO 425

  424 IF(ITF2.EQ.'FS  ') THEN
        CALL RRD2(MT2,MH,MK,ML,GA,GB,SSA,SSB,KEY2,IEND2)
      ELSE
        CALL RD2(MT2,MH,MK,ML,GA,GB,KEY2,IEND2)
        SSA=GA*.04
        SSB=GB*.04
      ENDIF
      IF(IEND2.EQ.1) GO TO 120
      IF(IEND2.EQ.0) NUMB2=NUMB2+1
      GO TO 421
  425 CONTINUE
      IF(ITP1.EQ.'PH  ') THEN
        FFA=SQRT(FA*FA+FB*FB)
      ELSE
        IF(FA.LT.1.E-8) FA=FB
        IF(FB.LT.1.E-8) FB=FA
        FFA=(FA+FB)/2.
      ENDIF
      IF(MT2.GT.0) THEN
        IF(ITP1.EQ.'PH  ') THEN
C          FFA=SQRT(FA*FA+FB*FB)
C          FFA=FFA-SQRT(GA*GA+GB*GB)
           FFA=1.0
           DEL=ABS(SQRT((FA-GA)**2+(FB-GB)**2))
           SCL=(FA*GA+FB*GB)
           FA=SQRT(FA*FA+FB*FB)
           FFA=SQRT(GA*GA+GB*GB)

           GA=0.
           CS=FA*FFA
           IF(CS.GT.1.E-5) THEN
             GA=SCL/CS
             CS=ABS(SQRT(ABS(1.-GA*GA)))
             IF(ABS(GA).GT.1.E-5) THEN
               GA=ATAN(CS/GA)*57.29578
               IF(GA.LT.0) THEN
                 IF(GA.GT.-1.E-5) GA=0.
                 IF(GA.LT.0) GA=180.+GA
               ENDIF
             ELSE
               GA=90.
             ENDIF
           ENDIF
           FFA=GA
        ELSE
          IF(GA.LT.1.E-8) GA=GB
          IF(GB.LT.1.E-8) GB=GA
          GFA=(GA+GB)/2.
          FFA=FFA-GFA
        ENDIF
      ENDIF

C      IF(FFA) 600,610,620

      IF(FFA.LT.0.0) GO TO 600
      IF(FFA.GT.0.0) GO TO 620
      GO TO 610

  600 IFL2=16
      GO TO 630
  610 IFL2=18
      GO TO 630
  620 IFL2=17
  630 FFA=ABS(FFA)
 4410 CONTINUE
      NREFLS=NREFLS+1
      IF(ILL.EQ.IL) IN=1
      IF(ILL.LT.IL.OR.IKK.LT.IK) GO TO 120
  310 IF(IL.EQ.ILL) GO TO 200
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
      IF(ILL.GT.-101.AND.ICOUNT.GE.15) THEN
        CALL DISPL_BL('CONTINUE /<Y>,S- FOR STOP/ ? :')
        READ(*,'(A)') MSG1
        IF(MSG1.EQ.'s') MSG1='S'
        IF(MSG1.EQ.'S') GO TO 160
        ICOUNT=0
      ENDIF
      ENDIF
C ::::::::::::::::
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,'(''           PLAN  L='',I5)') IL           
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,'           H < 0                     H > 0')
      CALL MSGDOC(MDOC,' ')
      ICOUNT=ICOUNT+3
      ILL=IL
      IKK=IK
  200 JH=IH+51
      IF(JH.LT.0.OR.JH.GT.101) GO TO 150
      ID=FFA*ATOP+1.0001
      IF(ID.GT.11) ID=11
      ILINE(JH)=IDIG(ID)
      IF(IFL2.EQ.16) ILINE(JH)=IDIGN(ID)
      IN=1
      GO TO 150
  120 IF(IN.EQ.0) GO TO 140
  170 CONTINUE
      CHAR1=' '
      WRITE(LINE,1100) CHAR1,IKK,(ILINE(JJ),JJ=31,101)
 1100 FORMAT(A1,'K',I3,'!',71A1)
C     IF(ICOUNT.EQ.0) CHAR1='+'
C ::::
      IF(STOP_T.EQ.'Y') THEN
        IF(ICOUNT.GE.20) THEN
          CALL DISPL_BL(LINE)
          READ(*,'(A)') MSG1
          IF(MSG1.EQ.'s') MSG1='S'
          IF(MSG1.EQ.'S') GO TO 160
          ICOUNT=0
        ELSE
          CALL MSGDOC(MDOC,LINE)
        ENDIF
        ICOUNT=ICOUNT+1
      ENDIF
C :::::
C      IF(ICOUNT.GE.21) THEN
C CN      WRITE(*,'(''$CONT ?:'')')
C CVX     WRITE(*,'(''$CONT ?:'')')
C CDP     WRITE(*,'('' CONT ?:''\)')
C CMS     WRITE(*,'(''+CONT ?:''\)')
C        READ(*,'(A)') MSG1
C        IF(MSG1.EQ.'s') MSG1='S'
C        IF(MSG1.EQ.'S') GO TO 160
C        ICOUNT=0
C      ENDIF
  140 IF(IEND1.EQ.1.OR.IEND2.EQ.1) GO TO 160
      DO    I=1,101
        IST=IDIG(13)
        IF((IKK+1).EQ.0) IST=IDIG(15)
        ILINE(I)=IST
      ENDDO
      ILINE(51)=IDIG(14)
C      11:*   12:  13:.  14:I  15:=  16:- 17:+ 18:0
      IN=0
      IKK=IKK+1
      IF(IL .GT.ILL) GO TO 310
      IF(IKK.LT.IK) GO TO 170
      GO TO 310
  160 CLOSE(MT1)
      IF(MT2.NE.0) CLOSE(MT2)
      WRITE(LINE,'('' NUMBER OF REFLS='',I6)') NREFLS
      CALL MSGDOC(MDOC,LINE)
      RETURN
      END

      SUBROUTINE STDENS(MDOC,POOL1,POOL2,NCRES,NAME1,NAME2
     *  ,IXL,IYL,IZL,ATOP,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C --------------------------------------------------------------------
CMS      : POOL1,POOL2
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*2 POOL1(NCRES),POOL2(NCRES)
      CHARACTER NAME1*(*),NAME2*(*)
      CHARACTER STOP_T*1
      REAL      RESULT(IPRROW,12)
C --------------------------------------------------------------
      PARAMETER ( IPRNRG =20 )
      INTEGER*4 NPOINT(IPRNRG)
      INTEGER*4 NPOINT2(IPRNRG)
      REAL      PERSNT(IPRNRG),DDENS(IPRNRG+1)
      REAL      PERSNT2(IPRNRG)
      CHARACTER MSGF*1,MSG1*1
      CHARACTER TITLE*80,LINE*80,PATT*1,STR*80
C ----------------------------------------------------------------------
 200  CONTINUE
C--------------------------------------
      IF(STOP_T.EQ.'N') THEN
        MD=-ABS(MDOC)-1
      ELSE
        MD=MDOC
      ENDIF
      MDD=-ABS(MDOC)-1
C      DO I=1,12
        DO J=1,IPRROW
          RESULT(J,1)=0.0
        ENDDO
C      ENDDO
      ITYPE1  =0
      MTIN1  =10
      MDC=-ABS(MDOC)-1
      CALL IRDENS(MTIN1,NAME1,MDC,ITYPE1,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     * IZMIN1,RMAX1,RMIN1,POOL1,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS1,
     * RAVER1,RESOL1,IX01,IY01,IZ01,ITR1,TITLE
     *   ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE-DENS')
        CLOSE(MTIN1)
        IERR=1
        RETURN
      ENDIF
      NXY1=NX1*NY1
      IF(NXY1.GT.NCRES) THEN
        CALL MSGERR(MDOC,' ERR: NOT MEMORY ')
        CLOSE(MTIN1)
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,'('' Resolution :'',F8.3)') RESOL1
      CALL MSGDOC(MDOC,LINE)
      PATT='N'
      IF(TITLE(1:4).EQ.'PATT') PATT='Y'

      MTIN2=0
      MSGF='N'
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.' ') THEN
        MSGF='Y'
 300    MTIN2  =20
        ITYPE2 =0
        CALL IRDNS2(MTIN2,NAME2,MDC,ITYPE2,ICNTZ2,NX2,NY2,NZ2,IZMAX2,
     *  IZMIN2,RMAX2,RMIN2,POOL2,SCALE2,A2,B2,C2,AL2,BE2,GA2,DRMS2,
     *  RAVER2,RESOL2,IX02,IY02,IZ02,ITR2,TITLE
     *   ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-DENS')
          CLOSE(MTIN2)
          CLOSE(MTIN2)
          IERR=1
          RETURN
        ENDIF
        IF(NX1.NE.NX2.OR.NY1.NE.NY2.OR.NZ1.NE.NZ2.OR.
     *     IZMAX2.NE.IZMAX1.OR.IZMIN1.NE.IZMIN2.OR.
     *     A1.NE.A2.OR.B1.NE.B2.OR.C1.NE.C2) THEN
          CALL MSGERR(MDOC,' ERR : CELL-1 # CELL-2')
          CLOSE(MTIN1)
          CLOSE(MTIN2)
          IERR=1
          RETURN
        ENDIF
      ENDIF
C ----------------------
      ICNTZ1=-999
      ICNTZ2=-999
      ITYPE1=-1
      ITYPE2=-1
      WRITE(LINE,61)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,60)
 60   FORMAT(3X,'X',3X,'Y',3X,'Z',6X,'R-MAX',7X,'X',3X,'Y',
     *         3X,'Z',6X,'R-MIN')
 61   FORMAT(' ')
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,61)
      CALL MSGDOC(MDOC,LINE)
      DMAX1T=-1.E30
      DMIN1T= 1.E30
      DMAX2T=-1.E30
      DMIN2T= 1.E30
      SUM1=0.0
      SUM2=0.0
      SUM21=0.0
      SUM22=0.0
      SUM31=0.0
      SUM32=0.0
      SUM41=0.0
      SUM42=0.0
      SUM12=0.0
      NUMB1=0
      NUMB2=0
      NPOS =0
      NPOS2=0
      NK=IPRNRG
      DKMIN=RMIN1
      DKMAX=RMAX1
      DRMS=DRMS1
    
C      IF(ATOP.LE.0.0) ATOP=1.0

      IF(MTIN2.GT.0) THEN
        IF(DKMIN.GT.RMIN2) DKMIN=RMIN2
        IF(DKMAX.LT.RMAX2) DKMAX=RMAX2
        IF(DRMS  .LT.DRMS2) DRMS=DRMS2
      ENDIF
      IF(ATOP.GT.0) THEN
        DKMAX=DRMS*ATOP
        IF(ABS(DKMIN).GT.DKMAX) THEN
          DKMIN=-DKMAX
        ENDIF
      ENDIF
C      DKMAX=DKMAX*ATOP
      DK=(DKMAX-DKMIN)/NK
      IF(DKMIN.LT.0) THEN
        AN0=(-DKMIN)/DK
        N0 =AN0+0.5
        DKMIN=-(DK*N0)
      ENDIF
      DDENS(1)= DKMIN
      DO  I=1,NK
        NPOINT(I) = 0
        PERSNT(I) = 0.0
        NPOINT2(I) = 0
        PERSNT2(I) = 0.0
        DDENS(I+1)= DDENS(I)+ DK
      ENDDO
      NNEG=0
      NZER=0

      SUMP=0.0
      SUMN=0.0
      SUMP2=0.0
      SUMN2=0.0


      SUM2P2=0.0
      SUMP22=0.0
      SUM2N2 =0.0
      SUMN22=0.0

      SUMD  = 0.0
      SUMD2 = 0.0

      SUMPD = 0.0
      SUMP2D= 0.0
      SUMND = 0.0
      SUMN2D= 0.0

      DIFMAX=-1.E30
      DIFMIN= 1.E30

      NP2=0
      NN2=0
      N02=0
      NPD=0
      NND=0
      N0D=0

      NL10S=0
      NL2S =0
      NL1S =0
      NGE0 =0
      NG1S =0
      NG2S =0
      NG10S=0

      IF(TITLE(1:4).EQ.'RF: ') THEN
        COEF=1.0
      ELSE
        S=(AL1+BE1+GA1)*0.5
        VOL=2.0*A1*B1*C1*
     *    SQRT(SIN(S)*SIN(S-AL1)*SIN(S-BE1)*SIN(S-GA1))
        COEF=(VOL)/(NX1*NY1*NZ1)
      ENDIF
C ---
      DO     IZ=IZMIN1,IZMAX1
        Z=IZ/FLOAT(NZ1)
C -----------------------
        CALL IRDENS(MTIN1,NAME1,MDOC,ITYPE1,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     *  IZMIN1,RMAX1,RMIN1,POOL1,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS1,
     *  RAVER1,RESOL1,IX01,IY01,IZ01,ITR1,TITLE
     *   ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-DENS-1')
          IERR=1
          CLOSE(MTIN1)
          IF(MTIN2.GT.0) CLOSE(MTIN2)
          RETURN
        ENDIF
        IF(MTIN2.GT.0) THEN
        CALL IRDNS2(MTIN2,NAME2,MDOC,ITYPE2,ICNTZ2,NX2,NY2,NZ2,IZMAX2,
     *    IZMIN2,RMAX2,RMIN2,POOL2,SCALE2,A2,B2,C2,AL2,BE2,GA2,DRMS2,
     *    RAVER2,RESOL2,IX02,IY02,IZ02,ITR2,TITLE
     *   ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: FILE-DENS-2')
            CLOSE(MTIN1)
            CLOSE(MTIN2)
            IERR=1
            RETURN
          ENDIF
        ENDIF
C-----------------------
        DMAX1=-1.E30
        DMIN1= 1.E30
        DMAX2=-1.E30
        DMIN2= 1.E30
        DO     IY=1,NY1
          Y=(IY-1)/FLOAT(NY1)
          IND0 =(IY-1)*NX1
          DO     IX=1,NX1
            X=(IX-1)/FLOAT(NX1)
            IND =IND0+IX
            D1=POOL1(IND)/SCALE1
            IF(DMAX1.LE.D1) THEN
              DMAX1=D1
              IXM=IX-1
              IYM=IY-1
            ENDIF
            IF(DMIN1.GE.D1) THEN
              DMIN1=D1
              IXN=IX-1
              IYN=IY-1
            ENDIF
            IF(DMAX1T.LE.D1) DMAX1T=D1
            IF(DMIN1T.GE.D1) DMIN1T=D1
            NUMB1=NUMB1 +1
            SUM1 =SUM1  +D1
            SUM21=SUM21 +D1*D1
            SUM31=SUM31 +D1*D1*D1
            SUM41=SUM41 +D1*D1*D1*D1
c            IF(RMAX1.GT.0.0.AND.D1.GT.0.0) THEN
            K=(D1-DKMIN)/DK+1.
            IF(K.GT.NK) K=NK
            IF(K.LT.1) K=1
            NPOINT(K)=NPOINT(K)+1
c            ENDIF
            IF(MTIN2.GT.0) THEN
              D2=POOL2(IND)/SCALE2
              IF(DMAX2.LE.D2) THEN
                DMAX2=D2
                IXM2=IX-1
                IYM2=IY-1
              ENDIF
              IF(DMIN2.GE.D2) THEN
                DMIN2=D2
                IXN2=IX-1
                IYN2=IY-1
              ENDIF
              IF(DMAX2T.LE.D2) DMAX2T=D2
              IF(DMIN2T.GE.D2) DMIN2T=D2

              NUMB2=NUMB2+1
              SUM2 =SUM2 +D2
              SUM22=SUM22+D2*D2
              SUM32=SUM32+D2*D2*D2
              SUM42=SUM42+D2*D2*D2*D2
              SUM12=SUM12+D1*D2

              IF(D2.GT.0.0) THEN
                SUM2P2=SUM2P2+D2
                SUMP22=SUMP22+D2*D2
                NP2=NP2+1
              ELSE IF(D2.LT.0.0) THEN
                SUM2N2=SUM2N2+D2
                SUMN22=SUMN22+D2*D2
                NN2=NN2+1
              ELSE
                N02=N02+1
              ENDIF

              DIFF  = (D1-D2)
              SUMD  = SUMD +DIFF
              SUMD2 = SUMD2+DIFF*DIFF
              NUMB12=NUMB12+1
              IF(DIFF.GT.DIFMAX) DIFMAX=DIFF  
              IF(DIFF.LT.DIFMIN) DIFMIN=DIFF  
              IF(DIFF.GT.0.0) THEN
                SUMPD=SUMPD+DIFF
                SUMP2D=SUMP2D+DIFF*DIFF
                NPD=NPD+1
              ELSE IF(DIFF.LT.0.0) THEN
                SUMND=SUMND  +DIFF
                SUMN2D=SUMN2D+DIFF*DIFF
                NND=NND+1
              ELSE
                N0D=N0D+1
              ENDIF

              K2=(D2-DKMIN)/DK+1.
              IF(K2.GT.NK) K2=NK
              IF(K2.LT.1) K2=1
              NPOINT2(K2)=NPOINT2(K2)+1
              IF(D2.GT.0.0) NPOS2=NPOS2+1
            ENDIF

            IF(D1.GT.0.0) THEN
              NPOS=NPOS+1
              SUMP=SUMP+D1
              SUMP2=SUMP2+D1*D1
            ELSE IF(D1.LT.0.0) THEN
              NNEG=NNEG+1
              SUMN=SUMN+D1
              SUMN2=SUMN2+D1*D1
            ELSE
              NZER=NZER+1
            ENDIF
             
            IF(D1.LT.(-DRMS1*10.0)) THEN
              NL10S=NL10S+1
            ENDIF
            IF(D1.LT.(-DRMS1*2.0)) THEN
              NL2S=NL2S+1
            ENDIF
            IF(D1.LT.(-DRMS1*1.0)) THEN
              NL1S=NL1S+1
            ENDIF
            IF(D1.GE.( DRMS1*10.0)) THEN
              NG10S=NG10S+1
            ENDIF
            IF(D1.GE.( DRMS1*2.0)) THEN
              NG2S=NG2S+1
            ENDIF
            IF(D1.GE.( DRMS1*1.0)) THEN
              NG1S=NG1S+1
            ENDIF
            IF(D1.GE.(0.0)) THEN
              NGE0=NGE0+1
            ENDIF

          ENDDO
        ENDDO
        WRITE(LINE,10) IXM,IYM,IZ,DMAX1,IXN,IYN,IZ,DMIN1
        CALL MSGDOC(MDOC,LINE)
   10   FORMAT(1X,3I4,1X,G12.4,' , ',3I4,1X,G12.4)
        IF(MTIN2.GT.0) THEN
          WRITE(LINE,11) IXM2,IYM2,DMAX2,IXN2,IYN2,DMIN2
   11     FORMAT(1X,2I4,5X,G12.4,' , ',2I4,5X,G12.4)
          CALL MSGDOC(MDOC,LINE)
        ENDIF
      ENDDO
C ----------------------
      DO I=1,NK
        IF(NPOS.GT.0) THEN
          PERSNT(I)=(FLOAT(NPOINT(I))/NPOS)*100.0
        ELSE
          PERSNT(I)=0.0
        ENDIF
        IF(NPOS2.GT.0) THEN
          PERSNT2(I)=(FLOAT(NPOINT2(I))/NPOS2)*100.0
        ELSE
          PERSNT2(I)=0.0
        ENDIF
      ENDDO
C ---
C ---
      SUMP =SUMP *COEF
      SUMN =SUMN *COEF
      SUMP2=SUMP2*COEF
      SUMN2=SUMN2*COEF
      SUM1 =SUM1 *COEF
      SUM2 =SUM2 *COEF
      SUM21=SUM21*COEF
      SUM22=SUM22*COEF
      SUM31=SUM31*COEF
      SUM32=SUM32*COEF
      SUM41=SUM41*COEF
      SUM42=SUM42*COEF
      SUM12=SUM12*COEF

      SUM2P2 = SUM2P2*COEF
      SUMP22 = SUMP22*COEF
      SUM2N2 = SUM2N2*COEF
      SUMN22 = SUMN22*COEF
      SUMD   = SUMD  *COEF
      SUMD2  = SUMD2 *COEF
      SUMPD  = SUMPD *COEF
      SUMP2D = SUMP2D*COEF
      SUMND  = SUMND *COEF
      SUMN2D = SUMN2D*COEF

      IF(TITLE(1:4).EQ.'RF: ') THEN
        CFVOL=1.0
      ELSE
        CFVOL=(VOL*NUMB1)/(NX1*NY1*NZ1)
      ENDIF

      AVER1 =SUM1 /CFVOL
      AVER21=SUM21/CFVOL
      RMS1  =SQRT((AVER21-AVER1*AVER1))
      AMOM31=SUM31/(CFVOL*RMS1*RMS1*RMS1)
      AMOM41=SUM41/(CFVOL*RMS1*RMS1*RMS1*RMS1)

      WRITE(LINE,20)
   20 FORMAT(' ---------------------')
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,30) AVER1,DMAX1T,DMIN1T
   30 FORMAT(' <R>,RMAX,RMIN:',3G18.5)
      CALL MSGDOC(MDOC,LINE)
C      CSUM1=COEF*SUM1
      WRITE(LINE,40) SUM1,SUM21
   40 FORMAT(' SUM-R, SUM-R**2 :',2G18.5)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,50) NUMB1,RMS1
      CALL MSGDOC(MDOC,LINE)
   50 FORMAT(' NUMB, RMS:',I10,G18.5)
      WRITE(LINE,55) AMOM31,AMOM41
 55   FORMAT(' Mom3, Mom4:',2G18.5)
      CALL MSGDOC(MDOC,LINE)
C      IF(MTIN2.LE.0) THEN
         WRITE(LINE,80) NPOS,SUMP
   80    FORMAT(' NUMB D>0 , SUM:',I10,G18.5)
         CALL MSGDOC(MDOC,LINE)
         WRITE(LINE,82) NNEG,SUMN
   82    FORMAT(' NUMB D<0 , SUM:',I10,G18.5)
         CALL MSGDOC(MDOC,LINE)
         WRITE(LINE,84) NZER
   84    FORMAT(' NUMB D=0 :',I10)
         CALL MSGDOC(MDOC,LINE)
         NUMB1P=NPOS+NZER
         RMSP =0.0
         IF(NUMB1P.GT.0) THEN
           AVERP =SUMP /NUMB1P
           AVERP2=SUMP2/NUMB1P
           RMSP =
     *     SQRT(AVERP2-AVERP*AVERP)
         ENDIF
         NUMB1N=NNEG+NZER
         RMSN =0.0
         IF(NUMB1N.GT.0) THEN
           AVERN =SUMN /NUMB1N
           AVERN2=SUMN2/NUMB1N
           RMSN =
     *     SQRT(AVERN2-AVERN*AVERN)
         ENDIF
         WRITE(LINE,
     *'('' RMS (for D>=0) ='',G16.3,'' RMS (for D=<0) ='',G16.3)'
     *) RMSP,RMSN
        CALL MSGDOC(MDOC,LINE)
C      ELSE
       IF(MTIN2.GT.0) THEN

        CALL MSGDOC(MDOC,' --- Second file ---')

        AVER2 =SUM2 /CFVOL
        AVER22=SUM22/CFVOL
        RMS2  =SQRT((AVER22-AVER2*AVER2))
        AMOM32=SUM32/(CFVOL*RMS2*RMS2*RMS2)
        AMOM42=SUM42/(CFVOL*RMS2*RMS2*RMS2*RMS2)
        WRITE(LINE,20)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,30) AVER2,DMAX2T,DMIN2T
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,40) SUM2,SUM22
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,50) NUMB2,RMS2
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,55) AMOM32,AMOM42
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,20)
        CALL MSGDOC(MDOC,LINE)
        DMOD1  =SQRT(SUM21)
        DMOD2  =SQRT(SUM22)
        RCORRD=     (SUM12)
        TEMP=DMOD1*DMOD2
        IF(TEMP.GT.0.0) THEN
          RCORRD=RCORRD/TEMP
        ELSE
          RCORRD=0.0
        ENDIF
        WRITE(LINE,90) RCORRD
   90   FORMAT(' R-corr:',G18.5)
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,
     * '<R1*R2>/SQRT(<R1**2>*<R2**2>)')
        WRITE(LINE,20)
        CALL MSGDOC(MDOC,LINE)
        AVER21=SUM21/CFVOL
        AVER22=SUM22/CFVOL
        AVER12=SUM12/CFVOL
        DMOD1  =SQRT(AVER21-AVER1*AVER1)
        DMOD2  =SQRT(AVER22-AVER2*AVER2)
        RCORRD=     (AVER12-AVER1*AVER2)
        TEMP=DMOD1*DMOD2
        IF(TEMP.GT.0.0) THEN
          RCORRD=RCORRD/TEMP
        ELSE
          RCORRD=0.0
        ENDIF
        WRITE(LINE,90) RCORRD
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,
     * '(<R1*R2>-<R1><R2>)/SQRT((<R1**2>-<R1>**2)*(<R2**2>-<R2>**2))')
        WRITE(LINE,20)
        CALL MSGDOC(MDOC,LINE)
        NUMB2P=NP2+N02
        RMSP2=0.0
        IF(NUMB2P.GT.0) THEN
          AVER2P2 =SUM2P2/NUMB2P
          AVERP22 =SUMP22/NUMB2P
          RMSP2 =
     *    SQRT(AVERP22-AVER2P2*AVER2P2)
        ENDIF
        NUMB2N=NN2+N02
        RMSN2=0.0
        IF(NUMB2N.GT.0) THEN
          AVER2N2 =SUM2N2/NUMB2N
          AVERN22 =SUMN22/NUMB2N
          RMSN2 =
     *    SQRT(AVERN22-AVER2N2*AVER2N2)
        ENDIF
        WRITE(LINE,
     *'('' RMS (for DEL>=0) ='',G16.3,'' RMS (for DEL=<0) ='',G16.3)'
     *) RMSP2,RMSN2
        CALL MSGDOC(MDOC,LINE)

        CALL MSGDOC(MDOC,' --- Difference ---')


        AVERD =SUMD /CFVOL
        AVERD2=SUMD2/CFVOL
        RMSD  =SQRT((AVERD2-AVERD*AVERD))
        WRITE(LINE,'(''DEL_max,DEL_min:'',2G18.5)') DIFMAX,DIFMIN
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''DEL_rms,DEL_aver:'',2G18.5)') RMSD,AVERD

        NUMBDP=NPD+N0D
        RMSPD=0.0
        IF(NUMBDP.GT.0) THEN
          AVERPD =SUMPD /NUMBDP
          AVERP2D=SUMP2D/NUMBDP
          RMSPD =
     *    SQRT(AVERP2D-AVERPD*AVERPD)
        ENDIF
        NUMBDN=NND+N0D
        RMSND=0.0
        IF(NUMBDN.GT.0) THEN
          AVERND =SUMND /NUMBDN
          AVERN2D=SUMN2D/NUMBDN
          RMSND =
     *    SQRT(AVERN2D-AVERND*AVERND)
        ENDIF
        WRITE(LINE,
     *'('' RMS (for DEL>=0) ='',G16.3,'' RMS (for DEL=<0) ='',G16.3)'
     *) RMSPD,RMSND
        CALL MSGDOC(MDOC,LINE)

      ENDIF
      RESULT(1,1) = AVER1
      RESULT(2,1) = DMAX1T
      RESULT(3,1) = DMIN1T
      RESULT(4,1) = RMS1
      RESULT(5,1) = AVER2
      RESULT(6,1) = DMAX2T
      RESULT(7,1) = DMIN2T
      RESULT(8,1) = RMS2
      RESULT(9,1) = RCORRD
      RESULT(10,1)= RESOL1
      RESULT(11,1)= AMOM31

      RESULT(1,5) =NX1
      RESULT(2,5) =NY1
      RESULT(3,5) =NZ1
      RESULT(4,5) =IZMIN1
      RESULT(5,5) =IZMAX1
      RESULT(6,5) =RMAX1
      RESULT(7,5) =RMIN1
      RESULT(8,5) =DRMS1
      RESULT(9,5) =NG10S
      RESULT(10,5)=NG2S
      RESULT(11,5)=NG1S
      IF(IPRROW.GE.15) THEN
        RESULT(12,5)=NGE0
        RESULT(13,5)=NL1S
        RESULT(14,5)=NL2S
        RESULT(15,5)=NL10S
        RESULT(16,5)=RAVER1
        RESULT(17,5)=RESOL1
        RESULT(18,5)=IX01
        RESULT(19,5)=IY01
        RESULT(20,5)=IZ01
        RESULT(21,5)=ITR1
      ENDIF

      NKR=NK
      IF(NKR.GT.20) NKR=20
      RESULT(1,2)=NKR
      RESULT(2,2)=DKMIN
      RESULT(3,2)=DKMAX
      RESULT(4,2)=RMIN2
      RESULT(5,2)=RMAX2
      IF(IPRROW.GE.21) THEN
        RESULT(12,1)= AMOM41
        RESULT(13,1)= RMSD
        RESULT(14,1)= AVERD
        RESULT(15,1)= RMSP
        RESULT(16,1)= RMSN
        RESULT(17,1)= RMSP2
        RESULT(18,1)= RMSN2
        RESULT(19,1)= RMSPD
        RESULT(20,1)= RMSND
        RESULT(21,1)= NUMB1
        DO I=1,NKR
          RESULT(I,3)=NPOINT(I)
          RESULT(I,4)=NPOINT2(I)
        ENDDO
      ENDIF
C ::::::::::::::::
      IF(STOP_T.EQ.'Y') THEN
        CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG1
      ENDIF
C ::::::::::::::::
      NFUN=1
      IF(MTIN2.GT.0) NFUN=2
      FMIN=0.0
      FMAX=100.0
      IF(PATT.EQ.'Y') FMAX=0.25
      CALL GRAPH_D(MDOC,NK,NFUN,NPOINT,NPOINT2,DDENS
     * ,PERSNT,PERSNT2,FMIN,FMAX)
      IF(IXL.EQ.-1.OR.IYL.EQ.-1.OR.IZL.EQ.-1) THEN
C ::::::::::::::::
        IF(STOP_T.EQ.'Y') THEN
          CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
          READ(*,'(A)') MSG1
        ENDIF
C ::::::::::::::::
        CLOSE(MTIN1)
        ITYPE1  =0
        MTIN1  =10
        M=99
        CALL IRDENS(MTIN1,NAME1,M,ITYPE1,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     *  IZMIN1,RMAX1,RMIN1,POOL1,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS1,
     *  RAVER1,RESOL1,IX01,IY01,IZ01,ITR1,TITLE
     *   ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-DENS')
          CLOSE(MTIN1)
          IERR=1
          RETURN
        ENDIF
        NXY1=NX1*NY1
        IF(NXY1.GT.NCRES) THEN
          CALL MSGERR(MDOC,' ERR: NOT MEMORY ')
          CLOSE(MTIN1)
          IERR=1
          RETURN
        ENDIF
        TEMP=RMAX1-RMIN1
        IF(TEMP.LT.1.E-5) TEMP=1.0
        NCOL=50
        COEF=NCOL/TEMP
        IFN0=(-RMIN1)*COEF+1
        IF(IFN0.GT.NCOL+1) IFN0=NCOL+1
        IF(IFN0.LT.1) IFN0=1
        CALL MSGDOC(MDOC,' --------------------------------')
        IF(IXL.EQ.-1) THEN
          WRITE(LINE,'(''  Line : IY='',I5,'' IZ='',I5)') IYL,IZL
          CALL MSGDOC(MDOC,LINE)
        ELSE IF(IYL.EQ.-1) THEN
          WRITE(LINE,'(''  Line : IX='',I5,'' IZ='',I5)') IXL,IZL
          CALL MSGDOC(MDOC,LINE)
        ELSE IF(IZL.EQ.-1) THEN
          WRITE(LINE,'(''  Line : IX='',I5,'' IY='',I5)') IXL,IYL
          CALL MSGDOC(MDOC,LINE)
        ENDIF
        CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
        ICNTZ1=-999
        ITYPE1=-1
        DO     IZ=IZMIN1,IZMAX1
          Z=IZ/FLOAT(NZ1)
C -----------------------
          CALL IRDENS(MTIN1,NAME1,M,ITYPE1,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     *    IZMIN1,RMAX1,RMIN1,POOL1,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS1,
     *    RAVER1,RESOL1,IX01,IY01,IZ01,ITR1,TITLE
     *    ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: FILE-DENS-1')
            IERR=1
            CLOSE(MTIN1)
            IF(MTIN2.GT.0) CLOSE(MTIN2)
            RETURN
          ENDIF
          DO     IY=0,NY1-1
            Y=(IY)/FLOAT(NY1)
            IND0 =(IY)*NX1
            DO     IX=0,NX1-1
              X=(IX)/FLOAT(NX1)
              IND =IND0+IX+1
              D1=POOL1(IND)/SCALE1
              IFN=(D1-RMIN1)*COEF+1
              IF(IFN.GT.NCOL+1) IFN=NCOL+1
              IF(IFN.LT.1) IFN=1
              STR=' '
              STR( 1: 1)  ='.'
              STR(11:11)  ='.'
              STR(21:21)  ='.'
              STR(31:31)  ='.'
              STR(41:41)  ='.'
              STR(51:51)  ='.'
              STR(61:61)  ='.'
              STR(IFN0:IFN0)='o'
              STR(IFN:IFN)='*'
              IF(IXL.EQ.-1) THEN
                IF(IYL.EQ.IY.AND.IZL.EQ.IZ) THEN
                  DENS=D1
                  WRITE(LINE,'(''IX,X,D:'',I3,F7.2,G12.4,A51)') 
     *            IX,X,DENS,STR(1:51)
                  CALL MSGDOC(MDOC,LINE)
                ENDIF
              ELSE IF(IYL.EQ.-1) THEN
                IF(IXL.EQ.IX.AND.IZL.EQ.IZ) THEN
                  DENS=D1
                  WRITE(LINE,'(''IY,Y,D:'',I3,F7.2,G12.4,A51)') 
     *            IY,Y,DENS,STR(1:51)
                  CALL MSGDOC(MDOC,LINE)
                ENDIF
              ELSE IF(IZL.EQ.-1) THEN
                IF(IXL.EQ.IX.AND.IYL.EQ.IY) THEN
                  DENS=D1
                  WRITE(LINE,'(''IZ,Z,D:'',I3,F7.2,G12.4,A51)') 
     *            IZ,Z,DENS,STR(1:51)
                  CALL MSGDOC(MDOC,LINE)
                ENDIF
              ENDIF
            ENDDO
          ENDDO
        ENDDO
        CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      

      ENDIF
C ----------------------
      CLOSE(MTIN1)
      IF(MTIN2.GT.0) CLOSE(MTIN2)
      RETURN
      END

      SUBROUTINE RMS_LUZZ(RRES,RRFAC,RMS)
C
C      THE UPPER ESTIMATE IN THE ERROR IN ATOMIC POSITIONS
C
C       input:  RES ( in angstrom), from 0.05 to 10.0
C               RFAC (for example 0.20), from 0.01 to .60
C       output: RMS (in angstrom)
C
       REAL RM(2),RF(2)
C ----------------------------------
       RMS  = 0.0
       RFAC = RRFAC
       RES  = RRES
       IF(RFAC.LT.0.01)   RFAC = 0.01
       IF(RFAC.GT.0.60)   RFAC = 0.60
       IF(RES.GT.10.0)    RES = 10.0
       IF(RES.LT.0.05)    RES = 0.05
       RM(2) = 2.0
       RM(1) = 0.01
       CALL RF_LUZZ(RES,RM(1),RF(1))
c       write(*,*) ' --1- rms,rfc,res:',RM(1),RF(1),RES
       CALL RF_LUZZ(RES,RM(2),RF(2))
c       write(*,*) ' --2- rms,rfc,res:',RM(2),RF(2),RES

       DO   I=1,1000      
         D=RF(2)-RF(1)
         IF(D.LT.0.001) GO TO 100           
         RMS=((RFAC-RF(1))*(RM(2)-RM(1)))/D+RM(1)
C         write(*,*) ' i,res,rms:',I,RES,RMS
         CALL RF_LUZZ(RES,RMS,RFC)
C         write(*,*) ' r-fac:',RFC
         IF(RFC.GT.RFAC) THEN
           RF(2) =RFC
           RM(2) =RMS
         ELSE
           RF(1) =RFC
           RM(1) =RMS
         ENDIF
       ENDDO
100    CONTINUE
      RETURN
      END

      SUBROUTINE RF_LUZZ(RRESOL,RRMS,RFAC)
      REAL*8 SUM,RM
C -----------------------
      PI    = 4.0*ATAN(1.0)
      RMS   = RRMS
      RESOL = RRESOL
      IF(RMS.LT.0.01)   RMS = 0.01
      IF(RMS.GT.2.0)    RMS = 2.0
      IF(RESOL.GT.10.0) RESOL = 10.0
      IF(RESOL.LT.0.05) RESOL = 0.05
      S    = 1.0/RESOL
      TEMP = -PI*PI*PI*S*S*RMS*RMS*0.25
      D    = EXP(TEMP)
      IF(D.LE.0.OR.D.GT.1) THEN
        RFAC = 0.0
        RETURN
      ENDIF
      SUM   = 0.0
      DELTA = PI/1000.0
      N     = 1000
      DO    I=1,N
        GAM = COS(I*DELTA)
        RM  = (2+(12*D*GAM-4)/(2-2*D*GAM)**1.5)/(1+D*GAM)**2
        SUM = SUM+DELTA*RM
      ENDDO
      SUMM = SUM
      RFAC = (1-D*D)**1.5*SUMM/PI
      RETURN
      END

      SUBROUTINE GRAPH_RF(MDOC,NG,NF,ANGP,R,X,Y,FMIN,FMAX)
      REAL ANGP(NG),X(NG),Y(NG),R(NG)
      CHARACTER STR*61,MSG*1,LINE*80
C----------------------------------------------------------------
      NNG=NG
      IF(NNG.GT.20) NNG=20
      TEMP=FMAX-FMIN
      IF(TEMP.LT.1.E-5) TEMP=1.0
      COEF=60.0/TEMP
      N=0

      CALL MSGDOC(MDOC,' --------------------------------')
      IF(NF.GT.1) THEN
        CALL MSGDOC(MDOC,
     *  '   N  Resolution    (*) R-factor   (+) Luzzati plot')
      ELSE
        CALL MSGDOC(MDOC,
     *  '   N  Resolution    (*) R-factor')
      ENDIF
      STR=' '
      STR( 1: 1)  ='0'
      STR(10:11)  ='10'
      STR(20:21)  ='20'
      STR(30:31)  ='30'
      STR(40:41)  ='40'
      STR(50:51)  ='50'
      STR(60:61)  ='60'
      WRITE(LINE,'(16X,A61)') STR
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
     
      DO     I=1,NNG
C        IF(ANGP(I).GT.0.001) THEN
          N=N+1
          RES=(R(I)+R(I+1))/2.0
          IFN=(X(N)-FMIN)*COEF+1
          IF(IFN.GT.61) IFN=61
          STR=' '
          STR( 1: 1)  ='.'
          STR(11:11)  ='.'
          STR(21:21)  ='.'
          STR(31:31)  ='.'
          STR(41:41)  ='.'
          STR(51:51)  ='.'
          STR(61:61)='.'
          STR(IFN:IFN)='*'
          IF(NF.GT.1) THEN
            IFD=(Y(N)-FMIN)*COEF+1
            IF(IFD.GT.61) IFD=61
            STR(IFD:IFD)='+'
            IF(IFN.EQ.IFD) STR(IFN:IFN)='#'
          ENDIF
          NP=ANGP(I)+0.001
          WRITE(LINE,'(I6,F8.2,2X,A61)') NP,RES,STR
          CALL MSGDOC(MDOC,LINE)
C        ENDIF
      ENDDO
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
      RETURN
      END

      SUBROUTINE GRAPH_F(MDOC,NG,NF,ANGP,R,X,Y,FMIN,FMAX)
      REAL ANGP(NG),X(NG),Y(NG),R(NG)
      CHARACTER STR*61,MSG*1,LINE*80
C----------------------------------------------------------------
      NNG=NG
      IF(NNG.GT.20) NNG=20
      TEMP=FMAX-FMIN
      IF(TEMP.LT.1.E-5) TEMP=1.0
      COEF=60.0/TEMP
      N=0

      CALL MSGDOC(MDOC,' --------------------------------')
      IF(NF.GT.1) THEN
        CALL MSGDOC(MDOC,
     *  '   N   Resolution     (*) <F-1>       (+) <F-2>')
      ELSE
        CALL MSGDOC(MDOC,
     *  '   N   Resolution     (*) <F>')
      ENDIF
      STR=' '
      STR( 1: 1)  ='0'
      WRITE(STR(46:61),'(''max='',F12.2)') FMAX
      WRITE(LINE,'(16X,A61)') STR
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
     
      DO     I=1,NNG
C        IF(ANGP(I).GT.0.001) THEN
          N=N+1
          RES=(R(I)+R(I+1))/2.0
          IFN=(X(N)-FMIN)*COEF+1
          IF(IFN.GT.61) IFN=61
          STR=' '
          STR( 1: 1)  ='.'
          STR(11:11)  ='.'
          STR(21:21)  ='.'
          STR(31:31)  ='.'
          STR(41:41)  ='.'
          STR(51:51)  ='.'
          STR(61:61)='.'
          STR(IFN:IFN)='*'
          IF(NF.GT.1) THEN
            IFD=(Y(N)-FMIN)*COEF+1
            IF(IFD.GT.61) IFD=61
            STR(IFD:IFD)='+'
            IF(IFN.EQ.IFD) STR(IFN:IFN)='#'
          ENDIF
          NP=ANGP(I)+0.001
          WRITE(LINE,'(I6,F8.2,2X,A61)') NP,RES,STR
          CALL MSGDOC(MDOC,LINE)
C        ENDIF
      ENDDO
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
      RETURN
      END

      SUBROUTINE GRAPH_FB(MDOC,NG,NF,ANGP,R,X,Y,FMIN,FMAX)
      REAL ANGP(NG),X(NG),Y(NG),R(NG)
      CHARACTER STR*61,MSG*1,LINE*80
C----------------------------------------------------------------
      NNG=NG
      IF(NNG.GT.20) NNG=20
      TEMP=FMAX-FMIN
      IF(TEMP.LT.1.E-5) TEMP=1.0
      COEF=60.0/TEMP
      N=0

      CALL MSGDOC(MDOC,' --------------------------------')
      IF(NF.GT.1) THEN
        CALL MSGDOC(MDOC,
     *'   N   Resolution     (*) <F>     (+) <F>*EXP(-Bover*S**2)')
      ELSE
        CALL MSGDOC(MDOC,
     *  '   N   Resolution     (*) <F>')
      ENDIF
      STR=' '
      STR( 1: 1)  ='0'
      WRITE(STR(46:61),'(''max='',F12.2)') FMAX
      WRITE(LINE,'(16X,A61)') STR
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
     
      DO     I=1,NNG
C        IF(ANGP(I).GT.0.001) THEN
          N=N+1
          RES=(R(I)+R(I+1))/2.0
          IFN=(X(N)-FMIN)*COEF+1
          IF(IFN.GT.61) IFN=61
          STR=' '
          STR( 1: 1)  ='.'
          STR(11:11)  ='.'
          STR(21:21)  ='.'
          STR(31:31)  ='.'
          STR(41:41)  ='.'
          STR(51:51)  ='.'
          STR(61:61)='.'
          STR(IFN:IFN)='*'
          IF(NF.GT.1) THEN
            IFD=(Y(N)-FMIN)*COEF+1
            IF(IFD.GT.61) IFD=61
            STR(IFD:IFD)='+'
            IF(IFN.EQ.IFD) STR(IFN:IFN)='#'
          ENDIF
          NP=ANGP(I)+0.001
          WRITE(LINE,'(I6,F8.2,2X,A61)') NP,RES,STR
          CALL MSGDOC(MDOC,LINE)
C        ENDIF
      ENDDO
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
      RETURN
      END

      SUBROUTINE GRAPH_A(MDOC,NG,NF,ANGP,R,X,Y,FMIN,FMAX)
      REAL ANGP(NG),X(NG),Y(NG),R(NG)
      CHARACTER STR*61,MSG*1,LINE*80
C----------------------------------------------------------------
      NNG=NG
      IF(NNG.GT.20) NNG=20
      TEMP=FMAX-FMIN
      IF(TEMP.LT.1.E-5) TEMP=1.0
      COEF=60.0/TEMP
      N=0

      CALL MSGDOC(MDOC,' --------------------------------')
      IF(NF.GT.1) THEN
        CALL MSGDOC(MDOC,
     *  '   N   Resolution     (*) <F-1>       (+) <F-2>')
      ELSE
        CALL MSGDOC(MDOC,
     *  '   N   Resolution     (*) <DELTA>')
      ENDIF
      STR=' '
      STR( 1: 1)  ='0'
      WRITE(STR(46:61),'(''max='',F12.2)') FMAX
      WRITE(LINE,'(16X,A61)') STR
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
     
      DO     I=1,NNG
C        IF(ANGP(I).GT.0.001) THEN
          N=N+1
          RES=(R(I)+R(I+1))/2.0
          IFN=(X(N)-FMIN)*COEF+1
          IF(IFN.GT.61) IFN=61
          STR=' '
          STR( 1: 1)  ='.'
          STR(11:11)  ='.'
          STR(21:21)  ='.'
          STR(31:31)  ='.'
          STR(41:41)  ='.'
          STR(51:51)  ='.'
          STR(61:61)='.'
          STR(IFN:IFN)='*'
          IF(NF.GT.1) THEN
            IFD=(Y(N)-FMIN)*COEF+1
            IF(IFD.GT.61) IFD=61
            STR(IFD:IFD)='+'
            IF(IFN.EQ.IFD) STR(IFN:IFN)='#'
          ENDIF
          NP=ANGP(I)+0.001
          WRITE(LINE,'(I6,F8.2,2X,A61)') NP,RES,STR
          CALL MSGDOC(MDOC,LINE)
C        ENDIF
      ENDDO
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
      RETURN
      END

      SUBROUTINE GRAPH_D(MDOC,NROW,NF,NGP,NGP2,R,X,Y,FMIN,FMAX)
      REAL    X(NROW),Y(NROW),R(NROW)
      INTEGER NGP(NROW),NGP2(NROW)
      CHARACTER STR*61,MSG*1,LINE*80
C----------------------------------------------------------------
      NNG=NROW
      IF(NNG.GT.20) NNG=20
      TEMP=FMAX-FMIN
      IF(TEMP.LT.1.E-5) TEMP=1.0
      NCOL=50
      IF(NF.EQ.2) NCOL=50
      COEF=NCOL/TEMP
      N=0

      CALL MSGDOC(MDOC,' --------------------------------')
      IF(NF.GT.1) THEN
        CALL MSGDOC(MDOC,
     *  ' N-D1   N-D2          Dens      (*)  %-D1       (+)  %-D2')
      ELSE
        CALL MSGDOC(MDOC,
     *  '  N                      Dens     (*)    %')
      ENDIF
      STR=' '
      STR( 1: 1)  ='0'
      STR(39:41)  ='100'
      WRITE(LINE,'(26X,A41)') STR
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
     
      DO     I=1,NNG
          N=N+1
          RES=R(I)
          IFN=(X(N)-FMIN)*COEF+1
          IF(IFN.GT.NCOL+1) IFN=NCOL+1
          STR=' '
          STR( 1: 1)  ='.'
          STR(11:11)  ='.'
          STR(21:21)  ='.'
          STR(31:31)  ='.'
          STR(41:41)  ='.'
          STR(51:51)  ='.'
          STR(61:61)  ='.'
          STR(IFN:IFN)='*'
          IF(NF.GT.1) THEN
            IFD=(Y(N)-FMIN)*COEF+1
            IF(IFD.GT.NCOL+1) IFD=NCOL+1
            STR(IFD:IFD)='+'
            IF(IFN.EQ.IFD) STR(IFN:IFN)='#'
          ENDIF
          NP =NGP(I)
          NP2=NGP2(I)
          IF(NF.EQ.1) THEN
            WRITE(LINE,'(I6,1X,6X,3X,F8.2,2X,A51)') NP,RES,STR(1:51)
            CALL MSGDOC(MDOC,LINE)
          ELSE
            WRITE(LINE,'(I6,1X,I6,3X,F8.2,2X,A51)')NP,NP2,RES,STR(1:51)
            CALL MSGDOC(MDOC,LINE)
          ENDIF
      ENDDO
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
      RETURN
      END


      SUBROUTINE TEMP_FL(SUMMET,SUMAZ,NGP,RHMIN,THINT,SCALE,BTEMP)
      REAL    SUMMET(40),SUMAZ(40),X(40),Y(40)
C --------------------------------------------------------------------
      SUMXY = 0.0
      SUMXX = 0.0
      SUMX  = 0.0
      SUMY  = 0.0
      COUNT = 0.0
      DO     J=1,NGP
        GP = SUMAZ(J)
        NP = GP+0.001
        IF(NP.GT.0) THEN
          FJ    = J
          X(J)  = (((FJ-0.5)*THINT+RHMIN)**2)/4.0
          Y(J)  = ALOG(SUMAZ(J)/SUMMET(J))
          SUMXY = SUMXY + X(J)*Y(J)*GP
          SUMXX = SUMXX + X(J)*X(J)*GP
          SUMX  = SUMX  + X(J)*GP
          SUMY  = SUMY  + Y(J)*GP
          COUNT = COUNT + GP

        ENDIF
      ENDDO  

      T1 = (COUNT*SUMXX)-(SUMX*SUMX)
      IF(COUNT.LT.0.001.OR.ABS(T1).LT.0.00001) THEN
        BTEMP = 0.0
        SCALE = 1.0
        RETURN
      ENDIF

      SLOPE = ((COUNT*SUMXY)-(SUMX*SUMY))/((COUNT*SUMXX)-(SUMX*SUMX))
      CEPT  = (1.0/COUNT)*(SUMY-(SLOPE*SUMX))

      BTEMP = 0.5*SLOPE
      SCALE = EXP(-CEPT)
      RETURN
      END


C -I-
      SUBROUTINE PSCALE(MDOC,F_NAME,F2_NAME,FO_NAME
     * ,BOFFR,BADDR,MODE,RESTR,RFACD
     * ,RESMNIR,RESMXIR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C 
C -P- PSCALE - scaling by origine peak of Patterson.
C              Program calculates Boverall factor by Patterson or
C              by Wilson plot, calculates parameters of scaling
C              Scale & Thermal factor for file_1, restores missing
C              reflections in file_1 (to use reflections from file_2),
C              defines effective resolution, writes scaled !F! of file_1
C              to output file. Without file_2 program just restore missing
C              reflections by Faver, B_overal defined by Patterson.
C              Can scale two files with different unit cell.
C -S-
C      Dialog and Batch:
C
C     FILE_F: - input file of the modules of structure factors for scaling.
C     FILE_2: - input second file / test file/
C               without this file program will only restore missing
C               reflections by Faver, B_overal defined by Patterson.
C     FILE_O: - output file / scaled file / 
C     RESOL: MIN,MAX  - resolution /default from input file/
C     MODE: <P>/W  scaling: "W" by Wilson plot, "P" by Patterson
C     REST: <N>/Y/O , Y - restore missing refls to get its from file_2
C                     O - restore by Faver, B_overal defined by Patterson
C                         Resolution for restoration: 1)input or 2)from file-2
C                         without file-2: REST: <N>,O , resolution 1) input
C                         or 2) from file-1.       
C     BOFF:    <0> , 256 corresponds to RESmin=8 
C     BADD:    <0> , BOFF and BADD mean :
C            !F!new = !F!input *EXP(-BADD*RSQ)*(1-EXP(-BOFF*RSQ)
C
C       It is possible to use the subroutine PSCALE by program:
C
C      SUBROUTINE PSCALE(MDOC,F_NAME,F2_NAME,FO_NAME
C     * ,BOFF,BADD,MODE,REST,RFACD
C     * ,RESMNI,RESMXI,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C  Parameters of subroutine: 
C
C    MDOC  - mode of writting messages to DOC-file
C            0 - only terminal , < - 0 only file, 0 < < 99 - both
C            >= 99 - don't write  
C    F_NAME  - input file of the modules of structure factors.
C    F2_NAME - second input file.
C    FO_NAME - output file.
C    RESMNI  - resolution MIN  
C    RESMXI               MAX
C    MODE    <P>/W  scaling: "W" by Wilson plot, "P" by Patterson
C    REST    <N>/Y/O , Y - restore missing refls to get its from file_2
C                      O - restore by Faver, B_overal defined by Patterson
C    RFACD    /character*1/ dummy
C    BOFF    <0>     - 256 corresponds to RESmin=8 
C    BADD    <0>     - BOFF and BADD mean :
C                       !F!new = !F!input *EXP(-BADD*RSQ)*(1-EXP(-BOFF*RSQ)
C    ISYM    - integer*2 array for cryst.symmetry operators.
C    IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM),
C              number of cryst. symm. operators.
C    IERR    - output signal of error / =1 -error , =o - OK / 
C
C    RESULT /real RESULT(IPRROW,21) / - array for output information:
C
C     i = 1 - information about !F! of file_1
C     i = 2 - information about !F! of file_2
C     
C
C      RESULT(1,i)  =NREF    N_refls
C      RESULT(2,i)  =RESMNI  min resolution
C      RESULT(3,i)  =RESMXI  max resolution
C      RESULT(4,i)  =LAP     sqrt(<s^2*F>)*4*pi^2/VOL for complete data set
C      RESULT(5,i)  =DT      <u>_patt 
C      RESULT(6,i)  =BSUM    B_patt  = 8pi^2*<u>_patt^2
C      RESULT(7,i)  =DTR     <u>_res = Resmax/3
C      RESULT(8,i)  =BRES    Bres    = 4*<u>_res^2
C      RESULT(9,i)  =DTFOUR  <u>_four= <u>_patt/sqrt(2)
C      RESULT(10,i) =BEFF    Beff    = 4*RESeff^2
C      RESULT(11,i) =RESEFF  RESeff  = <u>_four*2*sqrt(2)
C      RESULT(12,i) =SF2     sqrt(<F^2>)/VOL
C      RESULT(13,i) =SF4     sqrt(<F^4>)/VOL
C      RESULT(14,i) =SH2F    sqrt(<s^2*F>)*2*pi^2/(VOL*A^2) curvature(x)
C      RESULT(15,i) =COMPL   completeness
C      RESULT(16,i) =RESEFF_COMP  RESeff for complete data set
C      RESULT(17,i) =LAP     sqrt(<s^2*F>)*4*pi^2/VOL
C      RESULT(18,i) =FSCALE  Scale    for !F! by Wilson plot
C      RESULT(19,i) =BTEMP   Boverall for !F! by Wilson plot
C      RESULT(20,i) =RESN    Resmin for scaling by Wilson Plot
C      RESULT(21,i) =SCALE   P(000) /Patterson/
C      
C      RESULT(1,3)  =scale1P
C      RESULT(2,3)  =btemp1P
C      RESULT(3,3)  =scale2P
C      RESULT(4,3)  =btemp2P
C
C
C      RESULT(10,3) =ERR_MIN    
C      RESULT(11,3) =RFAC_FREE
C      RESULT(12,3) =DPI_VAL     
C      RESULT(13,3) =ERR_MAX     
C      RESULT(14.3) =NUMGP    
C      RESULT(15,3) =BOFF     
C      RESULT(16,3) =BADD     
C      RESULT(17,3) =RCORR  - correlation factor   
C      RESULT(18,3) =CSCALE - Scaling F_out = F_2*cscale*exp(-bscale*S^2/4)
C      RESULT(19,3) =BSCALE
C      RESULT(20,3) =R-FAC  - R-factor
C
C      RESULTA(I,4)= RHRP(I)
C      RESULTA(I,5)= RES_EFF(I)
C      RESULTA(I,6)= RES_EFF_B0(I)
C      RESULTA(I,7)= ERR_MIN(I)
C
C      RESULTA(I,8)=RHRP(I)
C      RESULTA(I,9)=ERR_MAX(I)
C -----------------------
C ---   expected minimal coordinate error     ----
C
C
C       sig(Ah) =[ 2pi* sqrt( sum ( h^2 * sig(Fobs)^2 )) ]/ (V* Acell) 
C
C       Ahh     =[ 2pi^2 * sum(h^2* Fobs )]/ (V *Acell^2) 
C
C       sig_min(r)  = (sig(Ah)/Ahh) * sqrt(3)
C
C     V - volume of cell, A - cell parameter, summation over all reflections.
c
C    ---  expected maximal coordinate error --------
c
c         del       = Fobs-Fcalc
c
C         sigma(Ah) = [2pi*sqrt(sum(h^2*del^2))]/(V*Acell)
C         Ahh       = [2pi^2*sum(h^2*Fobs)]/(V*Acell^2)
C         sig_max(r)= sqrt(3)*(sigma(Ah)/ Ahh)
C
C         sig_max(r) = 4pi*sqrt(3*sum(h^2*(Fobs-F2)^2*A))/VOL')
C
C --------------------------------------
C 
C Width_of_origin_peak_patt                D     
c Corresponding Thermal factor:            B_patt    = 8p^2*D^2
C
c Expected <width> of atomic peaks         <u>_four  = D/sqr(2)
c Corresponding B_overall                  B_overall = 8pi^2*<u>_four^2  
C
c <width> of atomic peaks for              <u>_resol = RESmax/3                
c resolution only                          B_resol   = 4*RESmax^2
C
c Resolution_effective                     Res_eff   = <u>_four*2.0*sqrt(2)
c Corresponding thermal factor             R_res_eff = 4Res_eff^2
c
C
C------------------------------------
C -I-
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,21)
      REAL      RESMNI,RESMXI
      INTEGER*4 MDOC,NUMGP,IERR
      CHARACTER F_NAME*(*),F2_NAME*(*),FO_NAME*(*),MODE*1,TITLE1*80
      CHARACTER REST*1,RESTR*1,MISS*1,NAME*256,RFACD*1,RFAC*1,ITYP*4
      CHARACTER NAME_SCL*256
C ==============================
      CHARACTER LINE*80,TITLE*80
C -----------------------------------------------------------
      NATOM = IERR
      IERR  = 0
      MD    =-ABS(MDOC)-1
      M     = 99
C -------------------------------------------------------------
      DO I=1,IPRROW
      DO J=1,9
        RESULT(I,J) = 0.0
      ENDDO
      ENDDO
C ---
      REST = RESTR
      BADD = BADDR
      BOFF = BOFFR
      IF(BOFF.LT.0.000001) BOFF = 256
      RESMNI = RESMNIR
      RESMXI = RESMXIR
      RFAC   = 'Y'
      IF(REST.EQ.'y') REST = 'Y'
      IF(REST.EQ.'o') REST = 'O'
      IF(REST.NE.'Y'.AND.REST.NE.'O') REST = 'N'
      MISS = 'N'
      IF(MODE.EQ.'w') MODE = 'W'
      IF(MODE.NE.'W') MODE = 'P'
      COEF  = 0.0
      NUMGP = 20
C -----------------------------------------------------------
      ITYP  = 'FF  '
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        IERR = 1
        RETURN
      ELSE
        MTIN=10
        CALL ORFILE(MD,MTIN,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: OPEN FILE-F /for scaling/')
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
        CLOSE(MTIN)
      ENDIF
      IF(RESMNI.LT.1.E-5 ) RESMNI = RESMIN
      IF(RESMXI.LT.1.E-5 ) RESMXI = RESMAX
      IF(RESMXI.GT.RESMAX) RESMXI = RESMAX
      IF(RESMNI.LT.RESMIN) RESMNI = RESMIN
C ---------
      ITYP  = 'FF  '
      CALL LENSTR_BL(F2_NAME,LEN)
      IF(LEN.LE.0.OR.F2_NAME(1:1).EQ.' '.OR.F2_NAME(1:1).EQ.',') THEN

      ELSE
        MTIN = 10
        CALL ORFILE(MD,MTIN,F2_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: OPEN FILE-F /test-file/')
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A2,B2,C2,AL2,BE2,GA2
     *  ,COEF2,BET2,RESMIN2,RESMAX2,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
        CLOSE(MTIN)
        IF(RESMNI.GT.RESMIN2) RESMNI = RESMIN2
        IF(RESMNI.LT.RESMAX2) RESMXI = RESMAX2
      ENDIF

      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,' --------  checking file_1 --------')
      CALL MSGDOC(MDOC,' ')
      CALL CHECK_PATT(MDOC,F_NAME
     *  ,NUMGP,COEF,BOFF,BADD,MISS,RESULT_S,RESULT_B
     *  ,PADD,DFOURX,BOVERX
     *  ,RESMNI,RESMXI,ISYM,IPRSYM,RESULT(1,1),RESULT,IPRROW,IERR)
      IF(IERR.NE.0) RETURN

      FSCALE      = RESULT(18,1) 
      BTEMP       = RESULT(19,1)
      RESULT(1,3) = RESULT_S
      RESULT(2,3) = RESULT_B 
      RESULT(5,3) = PADD
      RESULT(6,3) = DFOURX 
      RESULT(7,3) = BOVERX 
      SCALEP      = SQRT(RESULT(1,3)) 
      PBTEMP      = RESULT( 2,3)/2.0 
      NAME        = ' '
      NAME_SCL    = F_NAME
C -------------------------------------------------------------
      IFILE2 = 0
      ITYP   = 'FF  '
      CALL LENSTR_BL(F2_NAME,LEN)
      IF(LEN.LE.0.OR.F2_NAME(1:1).EQ.' '.OR.F2_NAME(1:1).EQ.',') THEN
        IF(REST.EQ.'Y') REST='O'
        NAME=' '
        IF(MODE.EQ.'W') THEN
          CSCALE = 1.0
          BSCALE = 0.0
          BOVER  = BTEMP
          FAVER  = FSCALE
        ELSE
          BSCALE = 0.0
          CSCALE = 1.0
          BOVER  = PBTEMP
          FAVER  = SCALEP
        ENDIF
        GO TO 100
      ENDIF
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,' --------  checking file_2 --------')
      CALL MSGDOC(MDOC,' ')
      MTIN  = 10
      ITYP  = 'FF  '
      CALL ORFILE(MD,MTIN,F2_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN FILE-F-2 /test-file/')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,A2,B2,C2,AL2,BE2,GA2
     *,COEF2,BET2,RESMIN2,RESMAX2,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      CLOSE(MTIN)
      DA  = ABS(A-A2)
      DB  = ABS(B-B2)
      DC  = ABS(C-C2)
      DAL = ABS(AL-AL2)
      DBE = ABS(BE-BE2)
      DGA = ABS(GA-GA2)
      IF(DA.GT.1.0.OR.DB.GT.1.0.OR.DC.GT.1.0.OR.DAL.GT.0.03.OR.
     *   DBE.GT.0.03.OR.DGA.GT.0.03) THEN
        CALL MSGERR(MD,' WARNING: different unit cell parameters')
        RFAC = 'N'
        IF(REST.EQ.'Y') REST = 'O'
      ELSE
        RFAC = 'Y'
      ENDIF
      CALL CHECK_PATT(MDOC,F2_NAME
     * ,NUMGP,COEF,BOFF,BADD,MISS,RESULT_S,RESULT_B
     * ,PADD,DFOURX,BOVERX
     * ,RESMNI,RESMXI,ISYM,IPRSYM,RESULT(1,2),RESULT,IPRROW,IERR)
      IF(IERR.NE.0) RETURN

      FSCALE2     = RESULT(18,2) 
      BTEMP2      = RESULT(19,2) 
      RESULT(3,3) = RESULT_S
      RESULT(4,3) = RESULT_B 
      RESULT(5,3) = PADD
      RESULT(6,3) = DFOURX 
      RESULT(7,3) = BOVERX 
      PSCALE2     = SQRT(RESULT(3,3)) 
      PBTEMP2     = RESULT( 4,3)/2.0 

      IF(MODE.EQ.'W') THEN
        BSCALE = BTEMP2-BTEMP
        CSCALE = (FSCALE2/FSCALE)
        BOVER  = BTEMP2
        FAVER  = FSCALE2
      ELSE
        BSCALE = PBTEMP2-PBTEMP
        CSCALE = (PSCALE2/SCALEP)
        BOVER  = PBTEMP2
        FAVER  = PSCALE2
      ENDIF

      NAME     = F2_NAME
      NAME_SCL = F_NAME
      IF(RFAC.EQ.'N') THEN
        NAME   = ' '
      ENDIF
      IFILE2 = 1
C ---
  100 CONTINUE
      IF(IFILE2.GT.0) THEN
        IF(MODE.EQ.'W') THEN
          TITLE1 = 'by Wilson plot'
        ELSE
          TITLE1 = 'by Patterson'
        ENDIF
        CALL LENSTR_BL(TITLE1,LEN)
        CALL MSGDOC(MDOC,' ')
        LINE=' ----  scaling '//TITLE1(1:LEN)//'  ----'
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,
     *'('' Scaling of file_1: SCALE,BTEMP:'',2G12.4)') CSCALE,BSCALE
        CALL MSGDOC(MDOC,LINE)
      ELSE
         IF(REST.EQ.'N') RETURN 
      ENDIF
C ---
      CALL LENSTR_BL(FO_NAME,LEN)
      IF(LEN.GT.0.AND.FO_NAME(1:1).NE.' '.AND.FO_NAME(1:1).NE.',')
     *THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC
     *   ,' ----   writing to output file   ----')
        CALL MSGDOC(MDOC,' ')
      ENDIF
      IF(RESMNIR.GT.1.E-5)  RESMNI=RESMNIR
      IF(RESMXIR.GT.1.E-5)  RESMXI=RESMXIR
      CALL WRT_PSCLF(MDOC,NAME,NAME_SCL,FO_NAME,FAVER,BOVER
     * ,REST,BOFF,BADD,CSCALE,BSCALE,NUMGP,RESULT(1,3),RESULT
     * ,IPRROW,RESMNI,RESMXI,ISYM,IPRSYM,NATOM,IERR)
      RETURN
      END

      SUBROUTINE CHECK_PATT(MDOC,F_NAME
     * ,NUMGPR,COEFR,BOFFR,BADDR,MISSR,RESULT_S,RESULT_B
     * ,PADD,RESEFFX,BOVERX
     * ,RESMNIR,RESMXIR,ISYM,IPRSYM,RESULT,RESULTA,IPRROW,IERR)
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
      REAL      RESULTA(IPRROW,21)
      REAL      RESMNI,RESMXI
      INTEGER*4 MDOC,NUMGP,IERR
      CHARACTER F_NAME*(*),MISS*1,MISSR*1
C ==============================
      INTEGER*4 MTIN
      REAL      RLATT(6),DISTR(41),AVERF(40),SUMF20(40),RHRP2(40)
      REAL      AVERF2(40),SUMN(40),SUMFNT(40),SUMH2F(40)
      REAL      SUMA(40),SUMB(40),SUMC(40),SUMD(40),SUME(40)
      REAL      SUMH2F2T(40),AVERF2T(40),SUMAT(40),AVERFT(40)
      REAL      AVERF2T0(40),SUMSIG2(40),SUMSIG0(40),SUMH2F2(40)
      REAL      RHR(41),SUMF2(40),SUMFN(40),SUMF(40),RHRP(41)
      REAL      SUMR(40),SUMX(40),SUMI20(40),SUMI0(40),SUMIN(40)
      CHARACTER ITYP*4
      CHARACTER LINE*80,TITLE*80,TITLE1*80
C -----------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      IERR  = 0
      MD    =-ABS(MDOC)-1
      M     = 99
C -----------------------------------------------------------
      NUMGP  = NUMGPR
      COEF   = COEFR
      BOFF   = BOFFR
      BADD   = BADDR
      RESMNI = RESMNIR
      RESMXI = RESMXIR
      MTIN   = 20
      ITYP   = 'FF  '
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong name of FILE-F')
        IERR=1
        RETURN
      ENDIF
      CALL ORFILE(M,MTIN,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open FILE-F')
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
C -------------------------------------------------------------
      IF(RESMNI.LT.1.E-5)  RESMNI = RESMIN
      IF(RESMXI.LT.1.E-5)  RESMXI = RESMAX
      IF(RESMXI.LT.RESMAX) RESMXI = RESMAX
      IF(RESMNI.GT.RESMIN) RESMNI = RESMIN
      WRITE(LINE,
     *'(''Resolution       :'',2F10.2)') RESMNI,RESMXI
      CALL MSGDOC(MDOC,LINE)
C ---
      CALL C_RD_CR
      RLATT(1) = A
      RLATT(2) = B
      RLATT(3) = C
      RLATT(4) = AL
      RLATT(5) = BE
      RLATT(6) = GA
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C ---
      IF(COEF.LE.0.0) COEF=1.5
      WRITE(LINE,
     *'(''coef        :'',F10.3)') COEF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Boff,Badd        :'',2F10.2)') BOFF,BADD
      CALL MSGDOC(MDOC,LINE)
C ---
      IF(NUMGP.LE. 0) NUMGP = 20
      IF(NUMGP.GT.20) NUMGP = 20
      WRITE(LINE,
     *'(''Number of shells :'',I7)') NUMGP
      CALL MSGDOC(MDOC,LINE)
C ---
      CALL ANOMF(M,NSYM,ISYM)
C
C     initialization for CENTR_BL
C
      CALL INIT_CENTR(NSYM,ISYM)
      CALL LIMHKL(RESMXI,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----------------------------------------------------------------
C     ----   Scaling by Wilson plot ------------------
      RESN = RESMNI
      RESX = RESMXI
      IF(RESX.LE.3.0.AND.RESN.GE.6.0) THEN
        RESN = 6.0
      ENDIF 
      IF(RESX.LE.2.0.AND.RESN.GE.5.0) THEN
        RESN = 5.0
      ENDIF 
      IF(RESX.GT.3.0.AND.RESX.LT.6.0.AND.RESN.GE.20.0) THEN
        RESN = 20.0
      ENDIF 
      RHMIN = 1.0/RESN
      RHMAX = 1.0/RESX
      DO    K=1,NUMGP
        SUMF2  (K) =0.
        SUMFN  (K) =0.
        SUMFNT (K) =0.
      ENDDO
      DELTRH = (RHMAX-RHMIN)/NUMGP
      IH     = 0
      IK     = 0
      IL     =-1
      IFIRST = 0
      IEND   =-1
      NUMB   = 0
      NREF   = 0
      NTOT   = 0
      KEY    = 0
      MISS   = 'N'
      IHMAX1 = IHMAX+1
      IKMAX1 = IKMAX+1
      ILMAX1 = ILMAX+1
C --------------------------------------
      DO     ILP=0,ILMAX1
      DO     IKP=-IKMAX1,IKMAX1
      DO     IHP=-IHMAX1,IHMAX1
        IF(IHP.EQ.0.AND.IKP.EQ.0.AND.ILP.EQ.0) GO TO 300
        IIHP=IHP
        IIKP=IKP
        IILP=ILP
        CALL ANOMSC(IIHP,IIKP,IILP,IANOM,JJSYM,NSYM,ISYM)
        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 300
        CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        IF(ICND.NE.0) GO TO 300
        CALL DSTAR_BL(IHP,IKP,ILP,RSQ)
        RH=SQRT(RSQ)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 300
        K=(RH-RHMIN)/DELTRH+1.0
        IF(K.GT.NUMGP) K=NUMGP
        IF(K.LT.1) K=1     

 5060   IF(MTIN.LE.0)  THEN
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0) GO TO 5040

C        IF(IL-ILP) 5050,5010,5040
C 5010   IF(IK-IKP) 5050,5020,5040
C 5020   IF(IH-IHP) 5050,5030,5040

        IF(IL.LT.ILP) GO TO 5050
        IF(IL.GT.ILP) GO TO 5040
        IF(IK.LT.IKP) GO TO 5050
        IF(IK.GT.IKP) GO TO 5040
        IF(IH.LT.IHP) GO TO 5050
        IF(IH.GT.IHP) GO TO 5040
        GO TO 5030

 5040   CONTINUE
C       MISS REFL IHP,IKP,ILP   
        CALL DSTAR_BL(IH,IK,IL,RSQI)
        RHI=SQRT(RSQI)
        IF(RHI.LT.RHMIN.OR.RHI.GT.RHMAX) GO TO 300
        CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        IF(ICND.NE.0) GO TO 300

        SUMFNT(K)=SUMFNT(K)+1
        NTOT=NTOT+1

        GO TO 300

 5050   CONTINUE
        IF(ITYP.EQ.'FS  ') THEN
          CALL RRD1(MTIN,IH,IK,IL,FN,FNA,SN,SNA,KEY,IEND)
        ELSE
          CALL RD1(MTIN,IH,IK,IL,FN,FNA,KEY,IEND)
C         SIG-DUMMY
          SN =0.04*FN
          SNA=0.04*FNA
        ENDIF
        IF(MTIN.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_F')
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0)      GO TO 5060
        IF(FN.LE.1.E-6.AND.FNA.LE.1.E-6) GO TO 5060
        IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
          IF(SN.LE.0.0000001) SN=1.0
          IF(SNA.LE.0.0000001) SNA=1.0
          WT1=1./(SN*SN)
          WT2=1./(SNA*SNA)
          WT =WT1+WT2
          FN =FN*WT1+FNA*WT2
          FN =FN/WT
          SN =1./SQRT(WT)
        ELSE IF(FNA.GT.1.E-6) THEN
          FN =FNA
          SN =SNA
        ENDIF
        GO TO 5060

 5030   CONTINUE
        NREF=NREF+1
        NTOT=NTOT+1
        IF(BOFF.GT.0.0) THEN
          BT=BOFF/4.0
          CBOFF=1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF=1.0
        ENDIF
        IF(BADD.GT.0.0) THEN
          BT=BADD/4.0
          CBADD=EXP(-BT*RSQ)
        ELSE
          CBADD=1.0
        ENDIF
C        FN2       =FN*FN*CBOFF*CBOFF*CBADD*CBADD
        FN2       =FN*FN
        SUMF2 (K) =SUMF2(K)  +FN2
        SUMFN (K) =SUMFN(K) + 1
        SUMFNT(K) =SUMFNT(K)+ 1
  300   CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ---
      IF(NREF.LE.0) THEN
        CALL MSGERR(MDOC
     *  ,' ERROR : number of reflections / for scaling / = 0')
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
      DO I=1,NUMGP
        IF(SUMFN(I).LE.0.0) SUMFNT(I)=0.0
      ENDDO
C -----------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *' ----     Scaling by Wilson plot        ----')
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,200) RESN,RESX
 200  FORMAT(
     * 'Resolution /for scaling by Wilson plot/       :',2F7.2)
      CALL MSGDOC(MDOC,LINE)
      CALL TEMP_FLLL(SUMF2,SUMFN,NUMGP,RHMIN,DELTRH,FSCALE,BTEMP)
      BI     = BTEMP*2.0
      FSCLI  = FSCALE
      FSCALE = SQRT(FSCALE)
      WRITE(LINE,
     *'(''Scale,Boverall /for F by Wilson plot/         :'',2G12.4)' 
     * ) FSCALE,BTEMP
      CALL MSGDOC(MDOC,LINE)
      IF(BTEMP.LT.0.0) BTEMP=0.0
      UFOUR=SQRT(BTEMP/(8.0*PI*PI))
      UPATT=UFOUR*SQRT(2.0)
      CALL MSGDOC(MDOC,
     * 'corresponding displacement:')
      WRITE(LINE,
     *'(''<u>_four,<u>_patt                             :'',2G12.4)'
     *) UFOUR,UPATT 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Number of refls/for scaling/                  :'',I8)')NREF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Number of refls/total for scaling resolution /:'',I8)')NTOT
      CALL MSGDOC(MDOC,LINE)
      COMPL=0.0
      IF(NTOT.GT.0) COMPL=FLOAT(NREF)/FLOAT(NTOT)
      WRITE(LINE,
     *'(''Completeness/for scaling/                     :'',F9.3)')
     * COMPL
      CALL MSGDOC(MDOC,LINE)
C --------------------------------------
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,
     *'('' ---- Scaling by Patterson with Boff ='',F9.0,'' ----'')')
     * BOFF
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
      ITYP  ='    '
      CALL OPFILE(M,MTIN,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open FILE-F')
        RETURN
      ENDIF
C ---
      RHMIN=1.0/RESMNI
      RHMAX=1.0/RESMXI
      DMAX =(RESMXI/3.0)*2.0*COEF
      B=BTEMP
      IF(B.LT.0.0) B=0.0

      DMAX1=SQRT(B/(8.0*PI*PI))*2.0*COEF
      IF(DMAX1.GT.DMAX) DMAX=DMAX1
      WRITE(LINE,1001) DMAX,VOL,DVOL
 1001 FORMAT('D-max, VOL , 4/3*PI*Rmax^3:'
     *  ,F7.2,1X,2G14.4)
      CALL MSGDOC(MDOC,LINE)
C ---
      DELT =DMAX/NUMGP
      DO    K=1,NUMGP
        SUMA    (K) =0.
        SUMB    (K) =0.
        SUMF2   (K) =0.
        SUMF20  (K) =0.
        SUMI20  (K) =0.
        SUMI0   (K) =0.
        SUMIN   (K) =0.
        SUMFN   (K) =0.
        SUMFNT  (K) =0.
        SUMF    (K) =0.
        SUMSIG2 (K) =0.
        SUMSIG0 (K) =0.
        AVERF   (K) =0.
        AVERF2  (K) =0.
        AVERF2T0(K) =0.
        SUMH2F  (K) =0.
        SUMH2F2 (K) =0.
        SUMH2F2T(K) =0.
      ENDDO
      D=0
      DO    K=1,NUMGP+1
        DISTR(K)=D
        D=D+DELT
      ENDDO
      DELTRH=(RHMAX-RHMIN)/NUMGP
      RHR(1) =RHMIN
      RHRP(1)=1./RHMIN
      DO    I=2,NUMGP+1
        RHR(I)=RHR(I-1)+DELTRH
        RHRP(I)=1.0/RHR(I)
      ENDDO
      IH    = 0
      IK    = 0
      IL    =-1
      IFIRST= 0
      IEND  =-1
C
      NREF  = 0
      NTOT  = 0
      NREFA = 0
      NTOTA = 0
      NREAD = 0
      NREF0 = 0
      NSIG0 = 0
      NREF_ABS = 0
      NREF_OUT = 0
      NREF_MISS= 0
      NADD     = 0
      NF000    = 0
      NCENT    = 0
      NABS     = 0
C
      F000  =0.0
      SSIG  =0.0
      SF    =0.0
      SF2   =0.0
      SF20  =0.0
      SF4   =0.0
      SH2F  =0.0
      SH2S2 =0.0
      SH2   =0.0
      MISS  ='Y'
c ------------------------
      DO     ILP=0,ILMAX
      DO     IKP=-IKMAX,IKMAX
      DO     IHP=-IHMAX,IHMAX
        IF(IHP.EQ.0.AND.IKP.EQ.0.AND.ILP.EQ.0) GO TO 100
        IIHP=IHP
        IIKP=IKP
        IILP=ILP
        CALL ANOMSC(IIHP,IIKP,IILP,IANOM,JJSYM,NSYM,ISYM)
        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 100

        CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        IF(NSYM.GT.1) THEN
          CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        ELSE
          ICND=0
        ENDIF
        IF(ICND.NE.0) THEN
           GO TO 100
        ENDIF

        CALL DSTAR_BL(IHP,IKP,ILP,RSQ)
        RH=SQRT(RSQ)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) THEN
          GO TO 100
        ENDIF

        IHT=IHP
        IKT=0
        ILT=0
        CALL DSTAR_BL(IHT,IKT,ILT,RSQT)
        RHT=SQRT(RSQT)

        K=(RH-RHMIN)/DELTRH+1.0
        IF(K.GT.NUMGP) K=NUMGP
        IF(K.LT.1) K=1     

        CALL INDMLTT(IHP,IKP,ILP,NGEN,NSYM,ISYM)

 4060   IF(MTIN.LE.0)  THEN
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0) GO TO 4040

C        IF(IL-ILP) 4050,4010,4040
C 4010   IF(IK-IKP) 4050,4020,4040
C 4020   IF(IH-IHP) 4050,4030,4040

        IF(IL.LT.ILP) GO TO 4050
        IF(IL.GT.ILP) GO TO 4040
        IF(IK.LT.IKP) GO TO 4050
        IF(IK.GT.IKP) GO TO 4040
        IF(IH.LT.IHP) GO TO 4050
        IF(IH.GT.IHP) GO TO 4040
        GO TO 4030
 
 4040   CONTINUE

        CALL DSTAR_BL(IH,IK,IL,RSQI)
        RHI=SQRT(RSQI)
        IF(RHI.LT.RHMIN.OR.RHI.GT.RHMAX) THEN
          NREF_OUT = NREF_OUT + 1
          GO TO 100
        ENDIF
        IF(NSYM.GT.1) THEN
          CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        ELSE
          ICND=0
        ENDIF
        IF(ICND.NE.0) THEN
          NREF_ABS = NREF_ABS + 1
          GO TO 100
        ENDIF
        IF(MISS.EQ.'Y') THEN
          SUMFNT(K)=SUMFNT(K)+NGEN
          NTOT=NTOT+NGEN
        ENDIF
        NTOTA=NTOTA+1
        NREF_MISS = NREF_MISS + 1
        GO TO 100

 4050   CONTINUE
        IF(IFIRST.EQ.1) THEN
C         ADDITIONAL IL,IK,IL,REFLS
          IF(NSYM.GT.1) THEN
            CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
          ELSE
            ICND=0
          ENDIF
          IF(ICND.NE.0) THEN 
            NABS = NABS + 1
            IFIRST=0
            GO TO 4050 
          ENDIF
          NADD = NADD + 1
          IFIRST=0
          CALL DSTAR_BL(IH,IK,IL,RSQI)
          RHI=SQRT(RSQI)
          IF(RHI.LT.RHMIN.OR.RHI.GT.RHMAX) THEN
            NREF_OUT = NREF_OUT + 1
c            T=1/RHI
c            WRITE(*,*) IH,IK,IL,T,FN,SN
            IFIRST=0
            GO TO 4050 
          ENDIF
          GO TO 4050
        ENDIF
        IFIRST=1
        IF(ITYP.EQ.'FS  ') THEN
          CALL RRD1(MTIN,IH,IK,IL,FN,FNA,SN,SNA,KEY,IEND)
          IDUMMY_SIG=0
        ELSE
          CALL RD1(MTIN,IH,IK,IL,FN,FNA,KEY,IEND)
C         SIG-DUMMY
          IDUMMY_SIG=1
          SN =0.05*FN
          SNA=0.05*FNA
        ENDIF
        IF(MTIN.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: read FILE_F')
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0)                    GO TO 4040
        NREAD = NREAD+1
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) THEN
          NF000=NF000+1
          F000 =FN
          IFIRST=0
          GO TO 4060
        ENDIF
        IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
          IF(SN.LE.0.0000001) SN=1.0
          IF(SNA.LE.0.0000001) SNA=1.0
          WT1=1./(SN*SN)
          WT2=1./(SNA*SNA)
          WT =WT1+WT2
          FN =FN*WT1+FNA*WT2
          FN =FN/WT
          SN =1./SQRT(WT)
        ELSE IF(FNA.GT.1.E-6) THEN
          FN =FNA
          SN =SNA
        ENDIF
        GO TO 4060

 4030   IFIRST=0
        IF(NSYM.GT.1) THEN
          CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        ELSE
          ICND=0
        ENDIF
        IF(ICND.NE.0) THEN
          NABS = NABS + 1
          IF(IFIRST.EQ.0) GO TO 100
          IFIRST=0
          GO TO 4050 
        ENDIF

        IF(FN.LE.1.E-8) THEN
          NREF0 = NREF0 + 1
          GO TO 100
        ENDIF

        IF(SN.LE.1.E-6) THEN
          NSIG0 = NSIG0 + 1 
          GO TO 100
        ENDIF

C ---
C       CENTR_BL - Determine whether a reflection (IH,IK,IL) is centric or not

        CALL CENTR_BL(IHP,IKP,ILP,JCENT)
C
C ---   JCENT = 1 centric reflection, JCENT = 0 acentric reflection

        NREF =NREF+NGEN
        NTOT =NTOT+NGEN
        NREFA=NREFA+1
        NTOTA=NTOTA+1
        IF(BOFF.GT.0.0) THEN
          BT=BOFF/4.0
          CBOFF=1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF=1.0
        ENDIF
        IF(BADD.GT.0.0) THEN
          BT=BADD/4.0
          CBADD=EXP(-BT*RSQ)
        ELSE
          CBADD=1.0
        ENDIF
        Y = CBOFF*CBADD
        FN2       =FN*FN*CBOFF*CBOFF*CBADD*CBADD
        SN2       =SN*SN*CBOFF*CBOFF*CBADD*CBADD
        SUMF2 (K) =SUMF2(K)   +FN2    *NGEN
        SUMF20(K) =SUMF20(K)  +FN*FN  *NGEN

        IF(JCENT.EQ.0) THEN
          SUMI20(K) = SUMI20(K)  +FN*FN*FN*FN*NGEN
          SUMI0 (K) = SUMI0 (K)  +FN*FN  *NGEN
          SUMIN (K) = SUMIN (K)  +        NGEN
          NCENT     = NCENT      +NGEN
        ENDIF

        SUMH2F(K) =SUMH2F(K)  +RSQT*FN*NGEN*Y
        SUMSIG2(K)=SUMSIG2(K) +RSQT*SN*SN*NGEN*Y*Y

        SUMH2F2(K)=SUMH2F2(K) +RSQ *FN*NGEN
        SUMFN (K) =SUMFN(K)   +        NGEN
        SUMFNT(K) =SUMFNT(K)  +        NGEN
        SUMSIG0(K)=SUMSIG0(K) +SN     *NGEN
        SSIG      =SSIG       +SN     *NGEN
        SF        =SF         +FN     *NGEN
        SF20      =SF20       +FN*FN  *NGEN
        SF2       =SF2        +FN2    *NGEN
        SF4       =SF4        +FN2*FN2*NGEN

        SH2F      =SH2F       +RSQT*FN*NGEN*Y
        SH2S2     =SH2S2      +RSQT*SN*SN*NGEN*Y*Y

        SH2       =SH2        +RSQT   *NGEN
  100   CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ---
      CLOSE (MTIN)
      IF(NREF.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: number of reflections = 0')
        IERR=1
        RETURN
      ENDIF

C      IF(MISS.EQ.'Y'.AND.NTOT.NE.NREF) THEN
C        CALL MSGDOC(MDOC,
C     *  ' ---  Missing reflections will be included with F=0 ---')
C      ELSE
C        NTOT=NREF
C        DO I=1,NUMGP
C          SUMFNT(I)=SUMFN(I)
C        ENDDO
C      ENDIF
      A_CELL=A
      SF2   =(SQRT(SF2*2.0)        )/VOL
      SF4   =(SQRT(SF4*2.0)        )/VOL
      SH2S2 =(SQRT(SH2S2*2.0)*TWOPI)  /(VOL*A_CELL)
      SH2   =(SQRT(SH2  *4.0)*TWOPI)  /(VOL*A_CELL)
      SH2F  =((SH2F *2.0)*TWOPI*PI)/(VOL*A_CELL*A_CELL)
      COMPL=1.0
      IF(NTOTA.GT.0) COMPL=FLOAT(NREFA)/FLOAT(NTOTA)
      RSTAND=0.0
      IF(NREF.GT.0) THEN
        SSIG=SSIG/NREF
        SF  =SF  /NREF
        SF20=SF20/NREF
        IF(SF.GT.0.0.AND.IDUMMY_SIG.LE.0) RSTAND=SSIG/SF
      ENDIF
      DO I=1,NUMGP
        AVERF2  (I)=0.0
        AVERF2T (I)=0.0
        AVERF2T0(I)=0.0
        IF(SUMFNT(I).GT.0.0) AVERF2T (I) =SUMF2 (I)/SUMFNT(I)
        IF(SUMFNT(I).GT.0.0) AVERF2T0(I) =SUMF20(I)/SUMFNT(I)
        IF(SUMFN(I) .GT.0.0) AVERF2  (I) =SUMF2 (I)/SUMFN(I)
        IF(SUMIN(I) .GT.0.000001) THEN
          SUMI20(I) = SUMI20(I)/SUMIN(I)
          SUMI0 (I) = SUMI0 (I)/SUMIN(I)
        ENDIF
        AVERF (I) =SQRT(AVERF2 (I))
        AVERFT(I) =SQRT(AVERF2T(I))
        SUMH2F2T(I)=0.0
        IF(SUMFN (I).GT.0.0) THEN
          SUMH2F2T(I)=(SUMH2F2(I)*SUMFNT(I))/SUMFN(I)
        ENDIF
      ENDDO
C -----------------------
      WRITE(LINE,
     *'(''Number of reflections / & total number/  :'',2I8)') 
     *NREFA,NTOTA
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Numbers: In file,Sys.abs,Miss,RES_out    :'',4I8)') 
     * NREAD,NREF_ABS,NREF_MISS,NREF_OUT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Numbers: With_F=<0,With_sig=<0,Nadd,NF000:'',4I8)') 
     * NREF0,NSIG0,NADD,NF000
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Resolution                               :'',2F8.3)') 
     *RESMNI,RESMXI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Completeness                             :'',F9.3)')COMPL
      CALL MSGDOC(MDOC,LINE)
      IF(NF000.GT.0) THEN
        WRITE(LINE,
     *  '(''F000                                     :'',G14.4)')
     *  F000
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      WRITE(LINE,
     *'(''<F>,<F^2>                                :'',2G14.4)')
     *SF,SF20
      CALL MSGDOC(MDOC,LINE)
      IF(IDUMMY_SIG.LE.0) THEN
        WRITE(LINE,
     *  '(''<sig(F)>,R_stand(F) (<sig(F)>/<F>)       :'',G14.4,F9.3)')
     *  SSIG,RSTAND
        CALL MSGDOC(MDOC,LINE)
      ENDIF
c      WRITE(LINE,'(
c     *''rsm(F^2),rms(F^4)                        :'',2G14.4)')
c     * SF2,SF4
c      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,
     *'(''<Curvature>_of atomic peak               :'',G14.4)') 
     *SH2F 
      CALL MSGDOC(MDOC,LINE)
      T=0.0
      IF(SH2F.GT.0.0000001) T=(SH2S2*SQRT(3.0))/SH2F 
      WRITE(LINE,
     *'(''sig(x)/expected minimal coordinate error/:'',G14.4)') T
      CALL MSGDOC(MDOC,LINE)
      ERR_MIN=T
      IF(IDUMMY_SIG.GT.0) THEN
        CALL MSGDOC(MDOC,'with assumption <sig(F)>/<F> = 0.05')
      ENDIF
      CALL MSGDOC(MDOC,
     *'sig(r) =sqrt(3)*(sig(Ah)/Ahh)  (in A)')
      CALL MSGDOC(MDOC,
     *'   sig(Ah) = (2pi*sqrt(sum(h^2*(sigF)^2)))/(VOL*A)')
      CALL MSGDOC(MDOC,
     *'   Ahh     = (2pi^2*sum(h^2*F))/(VOL*A^2)')
      CALL MSGDOC(MDOC,
     *'   VOL - volume of cell, A - cell parameter, summation over all r
     *efls.')

      WRITE(LINE,1000) VOL
 1000 FORMAT(
     * 'Volume of cell                           :',G14.4)
      CALL MSGDOC(MDOC,LINE)

      DVOL=(4.0*PI*RHMAX*RHMAX*RHMAX)/3.0
c      WRITE(LINE,1001) DVOL
c 1001 FORMAT(
c     * '4/3*PI*Rmax^3                            :',G14.4)
c      CALL MSGDOC(MDOC,LINE)


C -----------------------------------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *' ----       <F> and Wilson plot(F)      ----')
      CALL MSGDOC(MDOC,' ')
      DO I=1,NUMGP
        RH=(RHR(I+1)-RHR(I))/2.0+RHR(I)
        RSQ=RH*RH
C        RSQ=RHR(I)*RHR(I)
c for F  
        FSC=FSCALE
        BT =BTEMP/4.0
c for I     
c        FSC=FSCLI
c        BT =BI/4.0
        X=FSC*EXP(-BT*RSQ)
        SUMA(I)= X
      ENDDO
      NF=2
      FMIN = 1.E30
      FMAX =-1.E30
      FFMAX=-1.E30
      DO I=1,NUMGP
C        SUMC(I)=AVERF2T0(I)/COMPL
         SUMC(I)=SQRT(AVERF2T0(I))/SQRT(COMPL)
        IF(SUMC(I).GT.FMAX)  FMAX =SUMC(I)
        IF(SUMC(I).GT.FFMAX) FFMAX=SUMC(I)
        IF(SUMC(I).LT.FMIN)  FMIN =SUMC(I)
        IF(SUMA(I).GT.FMAX)  FMAX=SUMA(I)
      ENDDO
      WRITE(LINE,'(''  min,max:'',2G14.4)') 
     *FMIN,FFMAX
      CALL MSGDOC(MDOC,LINE)
      TITLE1='  (*) <F>     (+) SCALE_F*EXP(-Bover*S^2)'
      IMSG=0
      FMIN=0
      CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP,SUMC,SUMA,FMIN,FMAX,SUMFN
     *             ,TITLE1,IMSG)
C ------------------------------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *' ---- ln(<I>)  and ln(Sc*exp(-Bov*s^2)) ----')
      CALL MSGDOC(MDOC,' ')
      S2MAX=RHMAX*RHMAX
      S2MIN=RHMIN*RHMIN
      DL   =(S2MAX-S2MIN)/NUMGP
      DO I=1,NUMGP

        S2  = S2MIN+DL*(FLOAT(I)-0.5)
        RH  = SQRT(S2)
        RHRP2(I)=1.0/RH
        RH  = (RH - RHMIN)/DELTRH
        IRH = RH
        FRH = RH-IRH
        IRH=IRH+1
        IF(IRH.LT.1    ) IRH=1
        IF(IRH.GT.NUMGP) IRH=NUMGP
        IRH1=IRH+1
        IF(IRH1.LT.1    ) IRH1=1
        IF(IRH1.GT.NUMGP) IRH1=NUMGP
        T1=AVERF2T0(IRH )/COMPL
        T2=AVERF2T0(IRH1)/COMPL
        T=(1.0-FRH)*T1+FRH*T2 
        IF(T.GT.0.0000001) THEN
          T=LOG(T)
        ELSE
          T=0.0
        ENDIF
        SUMC(I)=T
 
        RSQ=S2
        FSC=FSCLI
        BT=BI/4.0
        X=FSC*EXP(-BT*RSQ)
        IF(X.GT.0.00001) THEN
          SUMB(I)= LOG(X)
        ELSE
          SUMB(I)= 0.0
        ENDIF

      ENDDO

      NF=2
      FMIN= 1.E30
      FMAX=-1.E30   
      DO I=1,NUMGP
C       T=AVERF2T0(I)/COMPL
        IF(SUMC(I).GT.FMAX)  FMAX=SUMC(I)
        IF(SUMB(I).GT.FMAX)  FMAX=SUMB(I)
        IF(SUMC(I).LT.FMIN)  FMIN=SUMC(I)
        IF(SUMB(I).LT.FMIN)  FMIN=SUMB(I)
      ENDDO
      WRITE(LINE,'(''  min,max:'',2G14.4)') 
     *FMIN,FMAX
      CALL MSGDOC(MDOC,LINE)
      CALL CORR_MAX(FMAX,FMAXN)
      FFMAX=FMAX
      IF(ABS(FMIN).GT.FMAX) FFMAX=ABS(FMIN)     
      DO I=1,NUMGP
        T=0.0
        IF(FFMAX.GT.0.0) T=SUMC(I)/FFMAX
        SUMR(I)=T
      ENDDO

      TITLE1='  (*) ln(<I>) (+) ln(SCALE_I*EXP(-2Bover*S^2))'
      IMSG=1
      CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP2,SUMC,SUMB,FMIN,FMAX,SUMR
     *             ,TITLE1,IMSG)
C -----------------------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *' ---- sig(r) - expected minimal coordinate error     ----')
      CALL MSGDOC(MDOC,' ')
      IF(IDUMMY_SIG.GT.0) THEN
        CALL MSGDOC(MDOC,
     *'               with assumption <sig(F)>/<F> = 0.05')
      ENDIF
      S =0.0
      ST=0.0
      FFMIN= 1.E30
      FFMAX=-1.E30   
      FMIN = 1.E30
      FMAX =-1.E30   
C
C       sig(Ah) =[ 2pi* sqrt( sum ( h^2 * sigF^2 )) ]/ (V* Acell) 
C
C       Ahh     =[ 2pi^2 * sum(h^2* F )]/ (V *Acell^2) 
C
C       sig(r)  = (sig(Ah)/Ahh) * sqrt(3)
C
      DO I=1,NUMGP
        SUMC(I)=0.0
        S =S +SUMSIG2(I)
        T =(SQRT(S*2.0)*TWOPI)/(VOL*A_CELL)
        ST=ST+SUMH2F (I)
        TT=((ST *2.0)*TWOPI*PI)/(VOL*A_CELL*A_CELL)
        IF(TT.GT.0.000000001) THEN
          SUMC(I)=(T*SQRT(3.0))/TT
          IF(SUMC(I).GT.FFMAX) FFMAX = SUMC(I)
          IF(SUMC(I).LT.FFMIN) FFMIN = SUMC(I)
          IF(I.GT.5) THEN
            IF(SUMC(I).GT.FMAX) FMAX=SUMC(I)
            SUMR(I)=0.0
          ELSE
            SUMR(I)=10000000000000.0
          ENDIF
          IF(SUMC(I).LT.FMIN) FMIN =SUMC(I)
        ELSE
          SUMR(I)=10000000000000.0
        ENDIF

C        WRITE(LINE,'(''error,curv :'',2G14.4,F8.3)') 
C     *  SUMC(I),TT,RHRP(I+1)
C        CALL MSGDOC(MDOC,LINE)

      ENDDO

      NF=1

C      FMIN= 1.E30
C      FMAX=-1.E30   
C      DO I=1,NUMGP
C        IF(I.GT.5) THEN
C          IF(SUMC(I).GT.FMAX)  FMAX=SUMC(I)
C        ENDIF
C        IF(SUMC(I).LT.FMIN)  FMIN =SUMC(I)
C      ENDDO

      DO I=1,NUMGP
        RESULTA(I,4)= RHRP(I)
        RESULTA(I,7)= SUMC(I)
      ENDDO
      RESULTA(IPRROW,4)= RHRP(NUMGP+1)
      RESULTA(IPRROW,7)= ERR_MIN
      RESULTA(10,3)    = ERR_MIN    

      TITLE1='     (*)  sig(r)'
      WRITE(LINE,'(''  min :'',G14.4)') 
     *FFMIN
      CALL MSGDOC(MDOC,LINE)

      CALL CORR_MAX(FMAX,FMAXN)

      DO I=1,NUMGP
        IF(SUMR(I).EQ.0.0) THEN
          T=0.0
          IF(FMAX.GT.0) T=SUMC(I)/FMAX
          SUMR(I)=T
        ENDIF
      ENDDO

      FMIN=0.0
      IMSG=1
      CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP,SUMC,SUMB,FMIN,FMAXN,SUMR
     *             ,TITLE1,IMSG)
      CALL MSGDOC(MDOC,' ')
C
C -----------------------------------------
      IF(NCENT.GT.0) THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,
     *       ' ---- Twinning test    <I^2>/<I>^2     ----')
        CALL MSGDOC(MDOC,' ')

        TWIN   = 0.0
        FNTWIN = 0

        DO I=1,NUMGP
          IF(SUMI0(I).GT.0.00001) THEN
            SUMI20(I) = SUMI20(I)/(SUMI0(I)*SUMI0(I))
            TWIN      = TWIN   + SUMI20(I)*SUMIN(I)
            FNTWIN    = FNTWIN + SUMIN(I)
          ENDIF
          RESULTA(I,9) = SUMI20(I)
        ENDDO
        
        IF(FNTWIN.GT.0.00001) TWIN = TWIN/FNTWIN
        RESULTA(13,3)    = TWIN    
        
        WRITE(LINE,
     *  '(''<I^2>/<I>^2                              :'',G14.4)')
     *  TWIN
        CALL MSGDOC(MDOC,LINE)
c ---//--
        NF=1
        FMIN= 1.E30
        FMAX=-1.E30   
        DO I=1,NUMGP
          SUMC(I)=SUMI20(I) 
          IF(SUMC(I).GT.FMAX)  FMAX=SUMC(I)
          IF(SUMC(I).LT.FMIN)  FMIN=SUMC(I)
        ENDDO
        TITLE1='     (*) Twinning test <I^2>/<I>^2'
        WRITE(LINE,'(''  min,max:'',2G14.4)') 
     *  FMIN,FMAX
        CALL MSGDOC(MDOC,LINE)
        CALL CORR_MAX(FMAX,FMAXN)
        DO I=1,NUMGP
          T=0.0
          IF(FMAX.GT.0.00000000001) T=SUMC(I)/FMAX
          SUMR(I)=T
        ENDDO
        FMIN=0.0
        IMSG=1
        CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP,SUMC,SUMB,FMIN,FMAXN,SUMR
     *             ,TITLE1,IMSG)
        CALL MSGDOC(MDOC,' ')

      ENDIF
C ---------------------------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *' ----     Laplacian     ----')
      CALL MSGDOC(MDOC,' ')
      S =0.0
      ST=0.0
      DO I=1,NUMGP
        RH=(RHR(I+1)-RHR(I))/2.0+RHR(I)
        RSQ=RH*RH
        S =S + SUMH2F2 (I)
        ST=ST+ SUMH2F2T(I)
        T =((S  *2.0)*TWOPI*TWOPI)/VOL
        TT=((ST *2.0)*TWOPI*TWOPI)/VOL
        SUMH2F2 (I)=T
        SUMH2F2T(I)=TT
      ENDDO
      SLAP = T

      WRITE(LINE,
     *'(''L = 4pi^2*sqrt<s^2*F>/VOL                :'',G14.4)') 
     *SLAP
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''L /for complete data set/                :'',G14.4)') 
     *TT
      CALL MSGDOC(MDOC,LINE)

      NF=1
      FMIN= 1.E30
      FMAX=-1.E30   
      DO I=1,NUMGP
        SUMC(I)= SUMH2F2(I)
        IF(SUMC(I).GT.FMAX)  FMAX=SUMC(I)
        IF(SUMC(I).LT.FMIN)  FMIN=SUMC(I)
      ENDDO
      TITLE1='     (*) Laplacian'
      WRITE(LINE,'(''  min,max:'',2G14.4)') 
     *FMIN,FMAX
      CALL MSGDOC(MDOC,LINE)
      CALL CORR_MAX(FMAX,FMAXN)
      DO I=1,NUMGP
        T=0.0
        IF(FMAX.GT.0) T=SUMC(I)/FMAX
        SUMR(I)=T
      ENDDO
      FMIN=0.0
      IMSG=1
      CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP,SUMC,SUMB,FMIN,FMAXN,SUMR
     *             ,TITLE1,IMSG)
      CALL MSGDOC(MDOC,' ')
C
C ---- PATTERSON ----------------------------------------------------
C
      CALL MSGDOC(MDOC,
     *' ----          Patterson                ----')
      CALL MSGDOC(MDOC,' ')
      NUMGPF=NUMGP

c      WRITE(*,*) ' DELTRH,COMPL:',DELTRH,COMPL

      CALL CALC_PATT(MDOC,NUMGP,NUMGPF,DELT,DELTRH,RHR,COMPL
     *     ,AVERF2,AVERF2T,SUMA,SUMC,IERR)

      ALIM=0.1
      CALL  TEMP_FLPP(SUMC,NUMGP,DISTR,SCALE,BTP,ALIM)

C --------------------------
      PADD = SCALE-SUMC(1)
      WRITE(LINE,*) ' PADD:',PADD
      CALL MSGDOC(MDOC,LINE)
      DO I=1,NUMGP
        SUMX(I)= SUMC(I)+PADD
      ENDDO
      ALIM = 0.1
      CALL  TEMP_FLPP(SUMX,NUMGP,DISTR,SCALEX,BTPX,ALIM)
      IF(BTPX.NE.0.0) THEN
        DT2X=1.0/(2.0*BTPX)
      ELSE
        DT2X=0.0
      ENDIF
      DTX     = SQRT(DT2X)
      BSUMX   = 8.0*PI*PI*DT2X
      BSUMFX  = BSUMX/2.0
      DTFOURX = SQRT(BSUMFX/(8.0*PI*PI))
      RESEFFX = DTFOURX*2.0*SQRT(2.0)
      DFOURX  = RESEFFX
      BOVERX  = BSUMFX
C ----------------------
      IF(BTP.NE.0.000001) THEN
        DT2=1.0/(2.0*BTP)
      ELSE
        DT2=0.0
      ENDIF
c     sig_patt
      DT    =SQRT(DT2)

c      DT    = DT2
c      DT2   = DT * DT

      BSUM  =8.0*PI*PI*DT2

      WIDTH_RES   = 0.715 * RESMXI
      B_RES       = 4.0*RESMXI*RESMXI

      P000        = SCALE
      WIDTH_PATT  = DT * 2.0
      T           = WIDTH_PATT 
      B_PATT      = 8.0*PI*PI*(T/2.0)*(T/2.0)

      T           = WIDTH_PATT*WIDTH_PATT + WIDTH_RES*WIDTH_RES
      WIDTH_FOUR  = SQRT(T/2.0)

      B_FOUR      = B_PATT/2.0

      RES_EFF     = WIDTH_FOUR
      B_EFF       = 8.0*PI*PI*(WIDTH_FOUR/2.0)*(WIDTH_FOUR/2.0)


      RES_EFF_T   = RES_EFF
      SLAP_COMP   = SLAP
      WIDTH_FOUR_T= WIDTH_FOUR

      P000_T      = P000
      B_PATT_T    = B_PATT
      B_FOUR_T    = B_FOUR

C      DTFOURT     = WIDTH_FOUR
C      SCALET      = P000
C      BSUMT       = B_PATT
C      BSUMFT      = B_FOUR
C ---
      IF(MISS.EQ.'Y'.AND.NTOT.NE.NREF) THEN

        CALL  TEMP_FLPP(SUMA,NUMGP,DISTR,SCALET,BTPT,ALIM)

        IF(BTPT.NE.0.0) THEN
          DT2T=1.0/(2.0*BTPT)
        ELSE
          DT2T=0.0
        ENDIF

        DTT=SQRT(DT2T)

        BSUMT=8.0*PI*PI*DT2T

        WIDTH_RES   = 0.715 * RESMXI
        B_RES       = 4.0*RESMXI*RESMXI

        P000_T        = SCALET
        WIDTH_PATT_T  = DT*2.0
        T             = WIDTH_PATT_T  
        B_PATT_T      = 8.0*PI*PI*(T/2.0)*(T/2.0)

        T            = WIDTH_PATT_T*WIDTH_PATT_T + WIDTH_RES*WIDTH_RES
        WIDTH_FOUR_T = SQRT(T/2.0)
        B_FOUR_T     = B_PATT_T/2.0


        RES_EFF_T   =  WIDTH_FOUR_T
        B_EFF_T     =  8.0*PI*PI*(WIDTH_FOUR_T/2.0)*(WIDTH_FOUR_T/2.0)

        BSUMFT     = B_FOUR_T
        DTFOURT    = WIDTH_FOUR_T
        BEFFT      = B_EFF_T

      ENDIF
C --- 
      WRITE(LINE,
     *'(''Patt_origin_peak,Width_of_peak: P000,W :'',2G14.4)') 
     * P000,WIDTH_PATT
      CALL MSGDOC(MDOC,LINE)

      SIG_PATT  = WIDTH_PATT/2.0
      SIG2_PATT = SIG_PATT*SIG_PATT
      WRITE(LINE,
     *'(''Sig,sig2,B:'',2G14.4)') 
     * SIG_PATT,SIG2_PATT
      CALL MSGDOC(MDOC,LINE)

      T=SQRT(ABS(P000))
      WRITE(LINE,
     *'(''sqrt(P000)                             :'',G14.4)') 
     * T
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Corresponding Thermal factor: B_patt= 8p^2*(W/2)^2 :'',G14.4)'
     *) B_PATT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Expected <width> of atomic peaks                :'',G14.4)') 
     * WIDTH_FOUR
      CALL MSGDOC(MDOC,LINE)

      SIG_FOUR = WIDTH_FOUR/2.0
      SIG2_FOUR = SIG_FOUR*SIG_FOUR
      WRITE(LINE,
     *'(''Sig,sig2,B:'',2G14.4)') 
     * SIG_FOUR,SIG2_FOUR
      CALL MSGDOC(MDOC,LINE)

      CALL MSGDOC(MDOC,
     *   '       / W_four= sqrt(( W_patt^2 + W_res^2)/2)/')
c      CALL MSGDOC(MDOC,
c     *   '       / W_four= W_patt/sqr(2)/')
      WRITE(LINE,
     *'(''Corresponding B_overall = 8pi^2*(W_p)^2*/8      :'',G14.4)') 
     * B_FOUR
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''W_resol = 0.715RESmax                           :'',G14.4)') 
     * WIDTH_RES
      CALL MSGDOC(MDOC,LINE)

      SIG_RES = WIDTH_RES/2.0
      SIG2_RES = SIG_RES*SIG_RES
      WRITE(LINE,
     *'(''Sig,sig2,B:'',2G14.4)') 
     * SIG_RES,SIG2_RES
      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,
     *'(''B_resol = 4*RESmax^2                            :'',G14.4)') 
     * B_RES
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Optical Resolution =  W_f                       :'',G14.4)') 
     * RES_EFF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Corresponding thermal factor/4 * Opt_Res^2/     :'',G14.4)') 
     * B_EFF
      CALL MSGDOC(MDOC,LINE)

      RESULT(1) =NREF
      RESULT(2) =RESMNI
      RESULT(3) =RESMXI
      RESULT(4) =SLAP_COMP
      RESULT(5) =WIDTH_PATT/2.0

      RESULT(6) =B_PATT

      RESULT(7) =WIDTH_RES/2.0
      RESULT(8) =B_RES
      RESULT(9) =WIDTH_FOUR/2.0
      RESULT(10)=B_EFF
      RESULT(11)=RES_EFF
      IF(IPRROW.GE.21) THEN
        RESULT(12) =SF2
        RESULT(13) =SF4
        RESULT(14) =SH2F 
        RESULT(15) =COMPL
        RESULT(16) =RES_EFF_T
        RESULT(17) =SLAP
        RESULT(18) =FSCALE
        RESULT(19) =BTEMP
        RESULT(20) =RESN

        RESULT(21) =P000

      ENDIF

C      SCALE = P000


      DO I=1,NUMGP
        D2  =DISTR(I)*DISTR(I)
        FSC =P000
        BT  =1.0/(2.0*DT2)
        X   =FSC*EXP(-BT*D2)
        SUMB(I)= X
      ENDDO

C     CALL MSGDOC(MDOC,' --- P(000) /scaling till 1/10 of P(000)/ ---')
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *' ---- <Patterson> and corresponding Gaussian ----')
      CALL MSGDOC(MDOC,' ')
      NF=2
      FMIN= 1.E30
      FMAX=-1.E30   
      FFMIN= 1.E30
      FFMAX=-1.E30   
      DO I=1,NUMGP
        IF(SUMB(I) .GT.FMAX )  FMAX =SUMB(I)
        IF(SUMC(I) .GT.FMAX )  FMAX =SUMC(I)
        IF(SUMC(I) .GT.FFMAX)  FFMAX=SUMC(I)
        IF(SUMB(I) .LT.FMIN )  FMIN =SUMB(I)
        IF(SUMC(I) .LT.FMIN )  FMIN =SUMC(I)
        IF(SUMC(I) .LT.FFMIN)  FFMIN=SUMC(I)
      ENDDO
      CALL CORR_MAX(FMAX,FMAXN)
      WRITE(LINE,'(''  min,max:'',2G14.4)') 
     *FFMIN,FFMAX
      CALL MSGDOC(MDOC,LINE)
      DO I=1,NUMGP
        T=0.0
        IF(FMAX.GT.0) T=SUMC(I)/FMAX
        SUMR(I)=T
      ENDDO
      TITLE1='   (*) Patterson     (+) Gaussian'
      IMSG=1
      IF(FMIN.GT.0.0) FMIN=0.0 
      CALL GRAPH_PATTT(MDOC,NUMGP,NF,DISTR,SUMC,SUMB,FMIN,FMAX,SUMR
     * ,TITLE1,IMSG)
C ------------------------
      IF(MISS.EQ.'Y'.AND.NTOT.NE.NREF) THEN
C  ---
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC
     *  ,' --- for complete data set ---')
        CALL MSGDOC(MDOC,' ')
C ---
        SLAP_COMP = ST
C ---

        WRITE(LINE,
     *'(''Patt_origin_peak,Width_of_peak              :'',2G14.4)') 
     *  P000_T,WIDTH_PATT_T
        CALL MSGDOC(MDOC,LINE)
        T=SQRT(ABS(P000_T))
        WRITE(LINE,
     *'(''sqrt(P000)                                  :'',G14.4)') 
     *  T
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     *'(''Corresponding Thermal factor: B_patt        :'',G14.4)') 
     *  B_PATT_T
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     *'(''Expected <width> of atomic peaks /W_four/   :'',G14.4)') 
     *  WIDTH_FOUR_T
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     *'(''Corresponding B_overall (8pi^2*(W_p)^2/8)   :'',G14.4)') 
     *  B_FOUR_T
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     *'(''Optical Resolution = W_f                    :'',G14.4)') 
     *  RES_EFF_T
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     *'(''Corresponding thermal factor/4Opt_res^2/    :'',G14.4)') 
     *  B_EFF_T
        CALL MSGDOC(MDOC,LINE)

        RESULT(4)= SLAP_COMP
        IF(IPRROW.GE.21) THEN   
          RESULT(16) =RES_EFF_T
C         RESULT(21) =SCALET
        ENDIF
      ENDIF

      RESULT_B = B_PATT_T
      RESULT_S = P000_T
C -----------------------

      BTEST = BTEMP
      BTEST = 0.0
      DO I=1,NUMGP
        RH=(RHR(I+1)-RHR(I))/2.0+RHR(I)
        RSQ=RH*RH
        IF(BOFF.GT.0.0) THEN
          BT=BOFF/4.0
          CBOFF=1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF=1.0
        ENDIF
        IF(BADD.GT.0.0) THEN
          BT=BADD/4.0
          CBADD=EXP(-BT*RSQ)
        ELSE
          CBADD=1.0
        ENDIF
        FSC    = FSCALE
        BT     = BTEST/4.0
        SUMD(I)= FSC*EXP(-BT*RSQ)*CBADD*CBOFF
        SUMB(I)= 0.0
        SUME(I)= 0.0
      ENDDO

      FMIN= 1.E30
      FMAX=-1.E30   
      DO I=1,16

        NUMGPF = NUMGP-I+1

        CALL CALC_PATT(MDOC,NUMGP,NUMGPF,DELT,DELTRH,RHR,COMPL
     *       ,SUMD,AVERF2T,SUMA,SUMC,IERR)

        ALIM=0.1
        CALL  TEMP_FLPP(SUMC,NUMGP,DISTR,SCALE,BTP,ALIM)
        IF(BTP.NE.0.0) THEN
          DT2=1.0/(2.0*BTP)
        ELSE
          DT2=0.0
        ENDIF

C        BSUM=8.0*PI*PI*DT2
C        BSUMF=BSUM/2.0
C        DTFOUR=SQRT(BSUMF/(8.0*PI*PI))
C        RESEFF=DTFOUR*2.0*SQRT(2.0)

        DT          = SQRT(ABS(DT2))

        WIDTH_RES   = 0.715 * RESMXI
        WIDTH_PATT  = DT*2.0
        T           = WIDTH_PATT*WIDTH_PATT + WIDTH_RES*WIDTH_RES
        WIDTH_FOUR  = SQRT(T/2.0)

        RES_EFF     =  WIDTH_FOUR

        SUMB (NUMGPF) = RES_EFF

        IF(RES_EFF.GT.FMAX)  FMAX=RES_EFF
        IF(RES_EFF.LT.FMIN)  FMIN=RES_EFF

        CALL  TEMP_FLPP(SUMA,NUMGP,DISTR,SCALE,BTP,ALIM)

        IF(BTP.NE.0.0) THEN
          DT2=1.0/(2.0*BTP)
        ELSE
          DT2=0.0
        ENDIF

        DT          = SQRT(ABS(DT2))
        WIDTH_RES   = 0.715 * RESMXI
        WIDTH_PATT  = DT*2.0
        T           = WIDTH_PATT*WIDTH_PATT + WIDTH_RES*WIDTH_RES
        WIDTH_FOUR  = SQRT(T/2.0)

        RES_EFF_G   =  WIDTH_FOUR


C        BSUM=8.0*PI*PI*DT2
C        BSUMF=BSUM/2.0
C        DTFOUR=SQRT(BSUMF/(8.0*PI*PI))
C        RESEFF_G=DTFOUR*2.0*SQRT(2.0)

        SUME (NUMGPF) = RES_EFF_G

C        WRITE(LINE,'(''RES_eff :'',2G14.4,F8.3)') 
C     *  RESEFF,RESEFF_G,RHRP(NUMGPF+1)
C        CALL MSGDOC(MDOC,LINE)

      ENDDO
C --
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,
     *'('' -- Res_eff and Res_eff for atom with B :'',F8.3,'' --'')'
     *) BTEST
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')

      WRITE(LINE,'(''  min,max:'',2G14.4)') 
     *FMIN,FMAX
      CALL MSGDOC(MDOC,LINE)


      DO I=1,NUMGP
        RESULTA(I,5)= SUMB(I)
        RESULTA(I,6)= SUME(I)
      ENDDO
      RESULTA(IPRROW,5)= SUMB(NUMGP)
      RESULTA(IPRROW,6)= SUME(NUMGP)

      NF=2
      FMIN= 1.E30
      FMAX=-1.E30   
      DO I=1,NUMGP
        IF(SUMB(I).GT.FMAX)  FMAX=SUMB(I)
        IF(SUME(I).GT.FMAX)  FMAX=SUME(I)
        IF(SUMB(I).LT.FMIN)  FMIN=SUMB(I)
        IF(SUME(I).LT.FMIN)  FMIN=SUME(I)
      ENDDO
      CALL CORR_MAX(FMAX,FMAXN)
      DO I=1,NUMGP
        IF(SUMB(I).GT.0.0) THEN
          T=0.0
          IF(FMAX.GT.0) T=SUMB(I)/FMAX
          SUMR(I)=T
        ELSE
          SUMR(I)=10000000000.0
        ENDIF
      ENDDO
      IMSG=1
      FMIN=0
      TITLE1='  (*) Res_eff    (+) Res_eff for SC*EXP(-Bover*S^2)'
      CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP,SUMB,SUME,FMIN,FMAXN,SUMR
     *             ,TITLE1,IMSG)
C -----------------------
      RETURN
      END


      SUBROUTINE CALC_PATT(MDOC,NUMGP,NUMGPF,DELT,DELTRH,RHR,COMPL
     *     ,AVERF2,AVERF2T,SUMA,SUMC,IERR)
      REAL      SUMA(40),SUMC(40)
      REAL      AVERF2(40),AVERF2T(40)
      REAL      RHR(41)
      CHARACTER LINE*80
C -----------------------------------------------------------
C
C     <I(s)> = AVERF2(s) , dS = DETRH
C
C     P(r) = 4pi * Int <I> * (sin(2pisr)/(2pisr)) * s^2 * ds
C
C -----------------------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      IERR=0
      MD  =-ABS(MDOC)-1
      M = 99

      DO I=1,NUMGP
        SUMA (I) = 0.0
        SUMC(I)  = 0.0
      ENDDO

      DO I=1,NUMGP
        DIST=(I-1)*DELT 
        DIST2=DIST*DIST

        DO J=1,NUMGPF
          RH=(RHR(J+1)-RHR(J))/2.0+RHR(J)
          RSQ=RH*RH
          IF(I.GT.1) THEN
            SR=(RH*DIST*TWOPI)
            SINSR=SIN(SR)

            TEMP =(AVERF2 (J)*SINSR*RSQ*DELTRH)/SR

            SUMA(I) =SUMA(I) +TEMP

            TEMP =(AVERF2T(J)*SINSR*RSQ*DELTRH)/SR

            SUMC(I) =SUMC(I) +TEMP

          ELSE

            TEMP =AVERF2(J)*RSQ*DELTRH

            SUMA(I) =SUMA(I) +TEMP

            TEMP =AVERF2T(J)*RSQ*DELTRH

            SUMC(I) =SUMC(I) +TEMP

          ENDIF
        ENDDO

        SUMA (I)= SUMA (I)*2.0 *TWOPI
        SUMC (I)= SUMC(I) *2.0 *TWOPI
      ENDDO
C  ----------------------------------------
      DO I=1,NUMGP
        SUMC(I)=SUMC(I)/SQRT(COMPL)
      ENDDO

      RETURN
      END


      SUBROUTINE WRT_PSCLF(MDOC,F_NAME,F2_NAME,FO_NAME,FAVER,BOVER
     * ,REST,BOFFR,BADDR,CSCALE,BT,NUMGRP,RESULT,RESULTA,IPRROW
     * ,RESMNI,RESMXI,ISYM,IPRSYM,NATOM,IERR)
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*4 MDOC,IERR
      CHARACTER F_NAME*(*),F2_NAME*(*),FO_NAME*(*),REST*1
      CHARACTER TITLE1*80
C ==============================
      INTEGER*4 MTIN,MTIN2,MTOUT
      REAL      RESULT(21)
      REAL      RESULTA(IPRROW,21)
      CHARACTER ITYP*4,ITYP2*4
      CHARACTER LINE*80,TITLE*80,TTT*80
      REAL      RHR(41),RHRP(41),RLATT(6),SUMSIGN(40)
      REAL      SUMF1(40),SUMF1N(40),SUMD(40),SUME(40),SUMSIG(40)
      REAL      SUMF1_FREE(40),SUMF1N_FREE(40),SUMD_FREE(40)
      REAL      DERK(40),CURK(40),SUMC(40),DLUZZ(40)
C -----------------------------------------------------------
      BOFF  = BOFFR
      BADD  = BADDR
      NUMGP = NUMGRP
      IF(NUMGP.LE. 0) NUMGP=20
      IF(NUMGP.GT.20) NUMGP=20
C ---
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      IERR  = 0
      MD    = -ABS(MDOC)-1
      M     = 99
C ----
      MTIN  = 20
      ITYP  = 'FF  '
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        MTIN=0
      ELSE
        CALL ORFILE(M,MTIN,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-F /TEST/')
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      ENDIF
C ----
      MTIN2 = 21
      ITYP2 = 'FF  '
      CALL LENSTR_BL(F2_NAME,LEN)
      IF(LEN.LE.0.OR.F2_NAME(1:1).EQ.' '.OR.F2_NAME(1:1).EQ.',') THEN
        IF(MTIN.GT.0) CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
      CALL ORFILE(M,MTIN2,F2_NAME,ITYP2,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN FILE-F_2')
        IF(MTIN.GT.0) CLOSE (MTIN)
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,COEF2,BET2,RESMIN2,RESMAX2,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
C ---
      CALL C_RD_CR
      RESMNO = RESMNI
      RESMXO = RESMXI
      WRITE(LINE,'(''Resolution         :'',2F8.2)') RESMNO,RESMXO
      CALL MSGDOC(MDOC,LINE)
C ---
      CALL ANOMF(M,NSYM,ISYM)
      CALL LIMHKL(RESMXO,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
      RLATT(1) = A
      RLATT(2) = B
      RLATT(3) = C
      RLATT(4) = AL
      RLATT(5) = BE
      RLATT(6) = GA
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C ----------------------------------------------------------------
      RHMIN  = 1.0/RESMNO
      RHMAX  = 1.0/RESMXO
      DELTRH = (RHMAX-RHMIN)/NUMGP
      RHR(1) = RHMIN
      RHRP(1)= 1./RHMIN
      DO    I=2,NUMGP+1
        RHR(I)  = RHR(I-1)+DELTRH
        RHRP(I) = 1.0/RHR(I)
      ENDDO
      DO    K=1,NUMGP
        SUMSIG (K) =0.0
        SUMSIGN(K) =0.0
      ENDDO
      IF(MTIN.GT.0) THEN
        IH     =  0
        IK     =  0
        IL     = -1
        JH     =  0
        JK     =  0
        JL     = -1
        IFIRST =  0
        IEND   = -1
        IEND2  = -1
        FSCALE =  0.04
        FN0    =  0.0
        NTOT   =  0 
        SFF12  =  0.0
        SFF22  =  0.0
        FN     =  0.0
        SN     =  0.0
        DO    K=1,NUMGP
          SUMSIG (K) =0.0
          SUMSIGN(K) =0.0
        ENDDO
C ---
        DO     ILP=0,ILMAX
        DO     IKP=-IKMAX,IKMAX
        DO     IHP=-IHMAX,IHMAX
          IF(IHP.EQ.0.AND.IKP.EQ.0.AND.ILP.EQ.0) GO TO 200
          IIHP = IHP
          IIKP = IKP
          IILP = ILP
          CALL ANOMSC(IIHP,IIKP,IILP,IANOM,JJSYM,NSYM,ISYM)
          IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 200
          CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
          IF(ICND.NE.0) GO TO 200
          CALL DSTAR_BL(IHP,IKP,ILP,RSQ)
          RH=SQRT(RSQ)
          IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 200
          K=(RH-RHMIN)/DELTRH+1.0
          IF(K.GT.NUMGP) K=NUMGP
          IF(K.LT.1) K=1     

 2060     CONTINUE 

          IF(IEND.GT.0) GO TO 2040

          IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) THEN
            FN0 = FN
            SN0 = SN
          ENDIF
          IFLAG_FN = 1

C          IF(IL-ILP) 2050,2010,2040
C 2010     IF(IK-IKP) 2050,2020,2040
C 2020     IF(IH-IHP) 2050,2030,2040

          IF(IL.LT.ILP) GO TO 2050
          IF(IL.GT.ILP) GO TO 2040
          IF(IK.LT.IKP) GO TO 2050
          IF(IK.GT.IKP) GO TO 2040
          IF(IH.LT.IHP) GO TO 2050
          IF(IH.GT.IHP) GO TO 2040
          GO TO 2030

 2040     CONTINUE
C         MISS REFL IHP,IKP,ILP   
          IFLAG_FN = -1
          GO TO 2030

 2050     CONTINUE

          IF(IEND.GT.0) GO TO 2040

          IF(ITYP.EQ.'FS  ') THEN
            CALL RRD1(MTIN,IH,IK,IL,FN,FNA,SN,SNA,NUMB,IEND)
          ELSE
            CALL RD1(MTIN,IH,IK,IL,FN,FNA,NUMB,IEND)
C           SIG-DUMMY
            SN  = 0.04*FN
            SNA = 0.04*FNA
          ENDIF
          IF(MTIN.LE.0) THEN
            CALL MSGERR(MDOC,' ERROR: READ FILE_F')
            CLOSE (MTIN2)
            IERR=1
            RETURN
          ENDIF
          IF(IEND.GT.0)      GO TO 2060
          IF(FN.LE.1.E-6.AND.FNA.LE.1.E-6) GO TO 2060
          IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
            IF(SN.LE.0.0000001) SN=1.0
            IF(SNA.LE.0.0000001) SNA=1.0
            WT1=1./(SN*SN)
            WT2=1./(SNA*SNA)
            WT =WT1+WT2
            FN =FN*WT1+FNA*WT2
            FN =FN/WT
            SN =1./SQRT(WT)
          ELSE IF(FNA.GT.1.E-6) THEN
            FN =FNA
            SN =SNA
          ENDIF
          IFLAG_FN = 1
          GO TO 2060

 2030     CONTINUE

 3060     CONTINUE

          IF(IEND2.GT.0) GO TO 3040

          IFLAG_GN = 1

C          IF(JL-ILP) 3050,3010,3040
C 3010     IF(JK-IKP) 3050,3020,3040
C 3020     IF(JH-IHP) 3050,3030,3040

          IF(JL.LT.ILP) GO TO 3050
          IF(JL.GT.ILP) GO TO 3040
          IF(JK.LT.IKP) GO TO 3050
          IF(JK.GT.IKP) GO TO 3040
          IF(JH.LT.IHP) GO TO 3050
          IF(JH.GT.IHP) GO TO 3040
          GO TO 3030

 3040     CONTINUE
C         MISS REFL IHP,IKP,ILP   
          IFLAG_GN = -1
          GO TO 3030

 3050     CONTINUE

          IF(IEND2.GT.0) GO TO 3040

          IF(ITYP2.EQ.'FS  ') THEN
            CALL RRD2(MTIN2,JH,JK,JL,GN,GNA,SGN,SGNA,NUMB2,IEND2)
          ELSE
            CALL RD2(MTIN2,JH,JK,JL,GN,GNA,NUMB2,IEND2)
C           SIG-DUMMY
            SGN  = 0.04*GN
            SGNA = 0.04*GNA
          ENDIF
          IF(MTIN2.LE.0) THEN
            CALL MSGERR(MDOC,' ERROR: READ FILE_F_2')
            IF(MTIN.GT.0) CLOSE (MTIN)
            IERR=1
            RETURN
          ENDIF
          IF(IEND2.GT.0)      GO TO 3060
          IF(IFIRST.LE.0) THEN
            FMOD = 0.0
            IF(JH.EQ.0.AND.JK.EQ.0.AND.JL.EQ.0) THEN
              FMOD= GN  *CSCALE
              SNN = SGN *CSCALE
              FAN = 0.0
              SNA = 0.0
            ELSE
              IF(FN0.GT.0.0) THEN
                FMOD = FN0  
                SNN  = SN0 
                FAN  = 0.0
                SNA  = 0.0
              ENDIF
            ENDIF

            IF(FMOD.GT.0.0) THEN
              IFIRST=1
              IF(JH.EQ.0.AND.JK.EQ.0.AND.JL.EQ.0) GO TO 3060
            ENDIF

          ENDIF


          IF(GN.LE.1.E-6.AND.GNA.LE.1.E-6) GO TO 3060
          IF(GN.GT.1.E-6.AND.GNA.GT.1.E-6) THEN
            IF(SGN.LE.0.0000001) SGN=1.0
            IF(SGNA.LE.0.0000001) SGNA=1.0
            WT1=1./(SGN*SGN)
            WT2=1./(SGNA*SGNA)
            WT =WT1+WT2
            GN =GN*WT1+GNA*WT2
            GN =GN/WT
            SGN =1./SQRT(WT)
          ELSE IF(GNA.GT.1.E-6) THEN
            GN  =GNA
            SGN =SGNA
          ENDIF
          IFLAG_GN = 1
          GO TO 3060

 3030     CONTINUE

          IF(BOFF.GT.0.0) THEN
            BTTT=BOFF/4.0
            CBOFF=1.0-EXP(-BTTT*RSQ)
          ELSE
            CBOFF=1.0
          ENDIF
          IF(BADD.GT.0.0) THEN
            BTTT=BADD/4.0
            CBADD=EXP(-BTTT*RSQ)
          ELSE
            CBADD=1.0
          ENDIF
          Y=CBADD*CBOFF

          IF(IFLAG_GN.LT.0) THEN
            IF(REST.NE.'Y'.AND.REST.NE.'O') GO TO 200
            IF(REST.EQ.'O') THEN
              BTT  =BOVER/4.0
              X    =FAVER*EXP(-BTT*RSQ)
              GGN  =X
              SGGN =X*0.04
              GGNA =0.0
              SGGNA=0.0
            ELSE
              IF(IFLAG_FN.LT.0) GO TO 200
              GGN  =FN
              SGGN =SN
              GGNA =FNA
              SGGNA=SNA
              SUMSIG(K) = SUMSIG(K) + SN
              SUMSIGN(K)= SUMSIGN(K)+ 1.0
            ENDIF
          ELSE
            GGN  = GN
            SGGN = SGN
            GGNA = GNA
            SGGNA= SGNA
            BTT  = BT/4.0
            X    = CSCALE*EXP(-BTT*RSQ)
C           IF(MTIN.LE.0) X=1.0
            GGN  = GGN   *X
            SGGN = SGGN  *X
            GGNA = GGNA  *X
            SGGNA= SGGNA *X
            IF(IFLAG_FN.GE.0) THEN
              NTOT      = NTOT+1
              SFF12     = SFF12     + FN*FN  *Y*Y
              SFF22     = SFF22     + GGN*GGN*Y*Y
              SUMSIG(K) = SUMSIG(K) + SN
              SUMSIGN(K)= SUMSIGN(K)+ 1.0
            ENDIF
          ENDIF
  200     CONTINUE
        ENDDO
        ENDDO
        ENDDO
C ---
        IF(SFF22.GT.0.0.AND.SFF12.GT.0.0) THEN
          SCALE_ADD = SQRT(SFF12/SFF22)
        ELSE
          SCALE_ADD = 1.0
        ENDIF
        CSCALE = CSCALE*SCALE_ADD

        WRITE(LINE,'('' New Scale:'',G12.4)') CSCALE
        CALL MSGDOC(MDOC,LINE)

        DO    K=1,NUMGP
         IF(SUMSIGN(K).GT.0.0) SUMSIG (K) = SUMSIG (K) / SUMSIGN(K) 
        ENDDO

        RESULT(18) = CSCALE
        RESULT(19) = BT

        CLOSE(MTIN)
        CLOSE(MTIN2)
        CALL ORFILE(M,MTIN,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: OPEN FILE-F /TEST/')
          RETURN
        ENDIF
        CALL ORFILE(M,MTIN2,F2_NAME,ITYP2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: OPEN FILE-F_2')
          IF(MTIN.GT.0) CLOSE (MTIN)
          RETURN
        ENDIF
      ENDIF
C -------------------------------------------------------------
C ----
      CALL C_CR_WR
      MTOUT=22
      CALL LENSTR_BL(FO_NAME,LEN)
      IF(LEN.LE.0.OR.FO_NAME(1:1).EQ.' '.OR.FO_NAME(1:1).EQ.',') THEN
C        IF(MTIN.GT.0) CLOSE (MTIN)
C        CLOSE (MTIN2)
C        IERR=1
C        RETURN
        MTOUT=0
      ENDIF
      COEF3 = COEF2*CSCALE
      BET3  = BET2+BT
      IF(MTOUT.GT.0) THEN
        CALL SET_TITLE(MD,A,B,C,AL,BE,GA
     *    ,COEF3,BET3,RESMNO,RESMXO,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
        CALL OWFILE(MD,MTOUT,FO_NAME,ITYP2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          IF(MTIN.GT.0) CLOSE (MTIN)
          CLOSE (MTIN2)
          CALL MSGERR(MD,' ERROR: OPEN OUTPUT_FILE')
          IERR=1
          RETURN
        ENDIF
      ENDIF
C -------------------------------------------------------------
      DO    K=1,NUMGP
        SUMD_FREE   (K) =0.0
        SUMF1_FREE  (K) =0.0
        SUMF1N_FREE (K) =0.0
        SUMD   (K) =0.0
        SUMF1  (K) =0.0
        SUMF1N (K) =0.0
        CURK   (K) =0.0
        DERK   (K) =0.0
      ENDDO
      DELTRH  = (RHMAX-RHMIN)/NUMGP
      RHR(1)  = RHMIN
      RHRP(1) = 1./RHMIN
      DO    I=2,NUMGP+1
        RHR(I)  = RHR(I-1)+DELTRH
        RHRP(I) = 1.0/RHR(I)
      ENDDO
      NTOT  = 0
      NTOTG = 0
      NREFA = 0
      NREFG = 0
      NC    = 0
      SUMDT = 0.0
      SF1   = 0.0
      SFF2  = 0.0
      SFF12 = 0.0
      SFF22 = 0.0
      SF1F2 = 0.0
      SUMDT_FREE = 0.0
      SF1_FREE   = 0.0
      NFREE = 0

      DER_TEST = 0.0
      CUR_TEST = 0.0

      CUR   = 0.0
      DER   = 0.0
      IH    = 0
      IK    = 0
      IL    =-1
      JH    = 0
      JK    = 0
      JL    =-1
      IFIRST= 0
      IEND  =-1
      IEND2 =-1
      KEY1  = 0
      KEY2  = 0
      KEY3  = 0
      NREF  = 0
      NREST = 0
      IEND1 =-1
      FSCALE= 0.04
      NMISS = 0
      FN0   = 0.0
      IF(MTIN.LE.0) IEND=1
C --------------------------------------
C ---
      DO     ILP=0,ILMAX
      DO     IKP=-IKMAX,IKMAX
      DO     IHP=-IHMAX,IHMAX
        IF(IHP.EQ.0.AND.IKP.EQ.0.AND.ILP.EQ.0) GO TO 100
        IIHP=IHP
        IIKP=IKP
        IILP=ILP
        CALL ANOMSC(IIHP,IIKP,IILP,IANOM,JJSYM,NSYM,ISYM)
        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 100
        CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        IF(ICND.NE.0) GO TO 100
        CALL DSTAR_BL(IHP,IKP,ILP,RSQ)
        RH=SQRT(RSQ)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 100

        IHT=IHP
        IKT=0
        ILT=0
        CALL DSTAR_BL(IHT,IKT,ILT,RSQT)
        RHT=SQRT(RSQT)

        CALL INDMLTT(IHP,IKP,ILP,NGEN,NSYM,ISYM)
        NTOT=NTOT  +1
        NTOTG=NTOTG+NGEN
        K=(RH-RHMIN)/DELTRH+1.0
        IF(K.GT.NUMGP) K=NUMGP
        IF(K.LT.1) K=1     

 4060   IF(IEND.GT.0) GO TO 4040

        IF(MTIN2.LE.0)  THEN
          IF(MTIN2.GT.0) CLOSE (MTIN2)
          IF(MTIN.GT.0)  CLOSE (MTIN)
          CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) THEN
          FN0=FN
          SN0=SN
        ENDIF
        IFLAG_FN = 1

C        IF(IL-ILP) 4050,4010,4040
C 4010   IF(IK-IKP) 4050,4020,4040
C 4020   IF(IH-IHP) 4050,4030,4040

        IF(IL.LT.ILP) GO TO 4050
        IF(IL.GT.ILP) GO TO 4040
        IF(IK.LT.IKP) GO TO 4050
        IF(IK.GT.IKP) GO TO 4040
        IF(IH.LT.IHP) GO TO 4050
        IF(IH.GT.IHP) GO TO 4040
        GO TO 4030

 4040   CONTINUE
C       MISS REFL IHP,IKP,ILP   
        IFLAG_FN = -1
        KEY1     =  0
        GO TO 4030

 4050   CONTINUE
        IF(IEND.GT.0) GO TO 4040
        IF(ITYP.EQ.'FS  ') THEN
          CALL RRD1(MTIN,IH,IK,IL,FN,FNA,SN,SNA,KEY1,IEND)
        ELSE
          CALL RD1(MTIN,IH,IK,IL,FN,FNA,KEY1,IEND)
C         SIG-DUMMY
          SN =0.04*FN
          SNA=0.04*FNA
        ENDIF
        IF(MTIN.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: READ FILE_F')
          CLOSE (MTIN2)
          CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0)      GO TO 4060
        IF(FN.LE.1.E-6.AND.FNA.LE.1.E-6) GO TO 4060
        IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
          IF(SN.LE.0.0000001) SN=1.0
          IF(SNA.LE.0.0000001) SNA=1.0
          WT1=1./(SN*SN)
          WT2=1./(SNA*SNA)
          WT =WT1+WT2
          FN =FN*WT1+FNA*WT2
          FN =FN/WT
          SN =1./SQRT(WT)
        ELSE IF(FNA.GT.1.E-6) THEN
          FN =FNA
          SN =SNA
        ENDIF
        IFLAG_FN = 1
        GO TO 4060

 4030   CONTINUE

 5060   IF(IEND2.GT.0) GO TO 5040
        IF(MTIN2.LE.0)  THEN
          IF(MTIN2.GT.0) CLOSE (MTIN2)
          IF(MTIN.GT.0)  CLOSE (MTIN)
          CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF

        IFLAG_GN = 1

C        IF(JL-ILP) 5050,5010,5040
C 5010   IF(JK-IKP) 5050,5020,5040
C 5020   IF(JH-IHP) 5050,5030,5040

        IF(JL.LT.ILP) GO TO 5050
        IF(JL.GT.ILP) GO TO 5040
        IF(JK.LT.IKP) GO TO 5050
        IF(JK.GT.IKP) GO TO 5040
        IF(JH.LT.IHP) GO TO 5050
        IF(JH.GT.IHP) GO TO 5040
        GO TO 5030

 5040   CONTINUE
C       MISS REFL IHP,IKP,ILP   
        IFLAG_GN = -1
        KEY2=0
        IF(IFLAG_FN.LT.0) THEN
          NMISS=NMISS+1
        ENDIF
        GO TO 5030

 5050   CONTINUE
        IF(IEND2.GT.0) GO TO 5040
        IF(ITYP2.EQ.'FS  ') THEN
          CALL RRD2(MTIN2,JH,JK,JL,GN,GNA,SGN,SGNA,KEY2,IEND2)
        ELSE
          CALL RD2(MTIN2,JH,JK,JL,GN,GNA,KEY2,IEND2)
C         SIG-DUMMY
          SGN =0.04*GN
          SGNA=0.04*GNA
        ENDIF
        IF(MTIN2.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: READ FILE_F_2')
          IF(MTIN.GT.0) CLOSE (MTIN)
          CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND2.GT.0)      GO TO 5060
        IF(IFIRST.LE.0) THEN
          FMOD=0.0
          IF(JH.EQ.0.AND.JK.EQ.0.AND.JL.EQ.0) THEN
            FMOD=GN  *CSCALE
            SNN =SGN *CSCALE
            FAN=0.0
            SNA=0.0
          ELSE
            IF(FN0.GT.0.0) THEN
              FMOD=FN0  
              SNN =SN0 
              FAN=0.0
              SNA=0.0
            ENDIF
          ENDIF
          IF(FMOD.GT.0.0) THEN
            NREF =NREF +1
            JJH=0
            JJK=0
            JJL=0
            KEY3=0
            IF(MTOUT.GT.0) THEN 
              IF(ITYP2.EQ.'F   ') THEN
                CALL WRT(MTOUT,JJH,JJK,JJL,FMOD,FAN,KEY3,IEND1)
              ELSE
            CALL WWRT(MTOUT,JJH,JJK,JJL,FMOD,FAN,SNN,SNA,KEY3,IEND1)
              ENDIF
              IF(MTOUT.LE.0) THEN
                CALL MSGERR(MDOC,' ERROR: WRITE FILE_OUT')
                IF(MTIN.GT.0) CLOSE (MTIN)
                CLOSE (MTIN2)
                IERR=1
                RETURN
              ENDIF
            ENDIF
            IFIRST=1
           IF(JH.EQ.0.AND.JK.EQ.0.AND.JL.EQ.0) GO TO 5060
          ENDIF
        ENDIF
        IF(GN.LE.1.E-6.AND.GNA.LE.1.E-6) GO TO 5060
        IF(GN.GT.1.E-6.AND.GNA.GT.1.E-6) THEN
          IF(SGN.LE.0.0000001) SGN=1.0
          IF(SGNA.LE.0.0000001) SGNA=1.0
          WT1=1./(SGN*SGN)
          WT2=1./(SGNA*SGNA)
          WT =WT1+WT2
          GN =GN*WT1+GNA*WT2
          GN =GN/WT
          SGN =1./SQRT(WT)
        ELSE IF(GNA.GT.1.E-6) THEN
          GN  =GNA
          SGN =SGNA
        ENDIF
        IFLAG_GN = 1
        GO TO 5060

 5030   CONTINUE

        IF(BOFF.GT.0.0) THEN
          BTTT=BOFF/4.0
          CBOFF=1.0-EXP(-BTTT*RSQ)
        ELSE
          CBOFF=1.0
        ENDIF
        IF(BADD.GT.0.0) THEN
          BTTT=BADD/4.0
          CBADD=EXP(-BTTT*RSQ)
        ELSE
          CBADD=1.0
        ENDIF
        Y=CBADD*CBOFF

        IF(IFLAG_GN.LT.0) THEN

            IF(IFLAG_FN.GE.0) THEN
              ACUR = FN
              IF(SUMSIG(K).GT.0.0) THEN
                DEL  = SUMSIG(K) 
              ELSE
                DEL  = FN*0.04 
              ENDIF
              ACUR=ACUR*Y
              DEL=DEL  *Y
              CUR_TEST  =CUR_TEST  + ACUR*RSQT*NGEN
              DER_TEST  =DER_TEST  + DEL*DEL*RSQT*NGEN
            ELSE
              ACUR = X
              IF(SUMSIG(K).GT.0.0) THEN
                DEL  = SUMSIG(K) 
              ELSE
                DEL  = X*0.04 
              ENDIF
              ACUR=ACUR*Y
              DEL=DEL  *Y
              CUR_TEST  =CUR_TEST  + ACUR*RSQT*NGEN
              DER_TEST  =DER_TEST  + DEL*DEL*RSQT*NGEN
            ENDIF

          IF(REST.NE.'Y'.AND.REST.NE.'O') GO TO 100

          IF(REST.EQ.'O') THEN

            BTT  =BOVER/4.0
            X    =FAVER*EXP(-BTT*RSQ)
            GGN  =X
            SGGN =X*0.04
            GGNA =0.0
            SGGNA=0.0

          ELSE

            IF(IFLAG_FN.LT.0.AND.REST.EQ.'O') THEN
              GO TO 100
            ENDIF
            GGN  =FN
            SGGN =SN
            GGNA =FNA
            SGGNA=SNA
          ENDIF

          IT1=KEY2/2 
          IT2=KEY2-IT1*2 
          IT3=IT1/2
          KEY3=IT3*4+1+IT2 

          NREST=NREST+1

        ELSE

          KEY3 =KEY2

          GGN  =GN
          SGGN =SGN
          GGNA =GNA
          SGGNA=SGNA
          BTT=BT/4.0
          X=CSCALE*EXP(-BTT*RSQ)
C         IF(MTIN.LE.0) X=1.0
          GGN  =GGN   *X
          SGGN =SGGN  *X
          GGNA =GGNA  *X
          SGGNA=SGGNA *X

          IF(IFLAG_FN.GE.0) THEN

            IT1=KEY1/2 
            IT2=KEY1-IT1*2 
            IF(IT2.GT.0) THEN

              SUMDT_FREE=SUMDT_FREE +ABS(FN-GGN)*Y
              SF1_FREE  =SF1_FREE   +FN     *Y
              NFREE=NFREE+1
              SUMF1_FREE(K)  =SUMF1_FREE(K)  +FN     *Y
              SUMF1N_FREE(K) =SUMF1N_FREE(K) +1
              SUMD_FREE(K)   =SUMD_FREE(K)   +ABS(FN-GGN)*Y

            ENDIF
            NREFA=NREFA+1
            NREFG=NREFG+NGEN
            SUMD(K)   =SUMD(K)   +ABS(FN-GGN)*Y
            SUMDT     =SUMDT     +ABS(FN-GGN)*Y
            SF1       =SF1       +FN     *Y
            SFF2      =SFF2      +GGN    *Y
            SFF12     =SFF12     +FN *FN *Y*Y
            SFF22     =SFF22     +GGN*GGN*Y*Y
            SF1F2     =SF1F2     +FN *GGN*Y*Y
            SUMF1(K)  =SUMF1(K)  +FN     *Y
            SUMF1N(K) =SUMF1N(K) +1

            DEL       = FN-GGN
            ACUR      = FN
            ACUR=ACUR*Y
            DEL=DEL  *Y

            CUR_TEST  =CUR_TEST  +ACUR*RSQT*NGEN
            CUR       =CUR       +ACUR*RSQT*NGEN
            CURK(K)   =CURK(K)   +ACUR*RSQT*NGEN

            DER_TEST  =DER_TEST  + DEL*DEL*RSQT*NGEN
            DER       =DER       + DEL*DEL*RSQT*NGEN
            DERK(K)   =DERK(K)   + DEL*DEL*RSQT*NGEN

          ELSE
 
            BTT  =BOVER/4.0
            X    =FAVER*EXP(-BTT*RSQ)
C            ACUR =  X
            ACUR = GGN 

            IF(SUMSIG(K).GT.0.0) THEN
              DEL  = SUMSIG(K) 
            ELSE
              DEL  = X*0.04 
            ENDIF
            ACUR=ACUR*Y
            DEL=DEL  *Y
            CUR_TEST  =CUR_TEST  + ACUR*RSQT*NGEN
            DER_TEST  =DER_TEST  + DEL*DEL*RSQT*NGEN
            DER       =DER       + DEL*DEL*RSQT*NGEN
            DERK(K)   =DERK(K)   + DEL*DEL*RSQT*NGEN

            IF(REST.EQ.'O'.AND.MTIN.GT.0) THEN
              NC = NC + 1
            ENDIF

          ENDIF
        ENDIF

        NREF=NREF+1
        IF(MTOUT.GT.0) THEN
          IF(ITYP2.EQ.'F   ') THEN
            CALL WRT(MTOUT,IHP,IKP,ILP,GGN,GGNA,KEY3,IEND1)
          ELSE
            CALL WWRT(MTOUT,IHP,IKP,ILP,GGN,GGNA,SGGN,SGGNA
     *      ,KEY3,IEND1)
          ENDIF
          IF(MTOUT.LE.0) THEN
            CALL MSGERR(MDOC,' ERROR: WRITE OUTPUT_FILE')
            IF(MTIN.GT.0) CLOSE(MTIN)
            CLOSE(MTIN2)
            IERR=1
            RETURN
          ENDIF
        ENDIF
  100   CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ---
      IF(MTIN.GT.0) CLOSE (MTIN)
      CLOSE (MTIN2)
      IEND1=2
      IF(MTOUT.GT.0) THEN
        CALL WRT(MTOUT,IH,IK,IL,FNN,FNA,KEY3,IEND1)
        IF(MTOUT.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: WRITE TO FILE_OUT')
          IERR=1
          RETURN
        ENDIF
        CLOSE(MTOUT)
      ENDIF
C ----------- R-FAC ------------
      A_CELL=A
      IF(MTIN.GT.0) THEN
 
      IF(NREFA.GT.0) THEN
        RFAC=SUMDT/SF1
      ELSE
        RFAC=0.0
      ENDIF      
      IF(NFREE.GT.0) THEN
        RFAC_FREE=SUMDT_FREE/SF1_FREE
      ELSE
        RFAC_FREE=0.0
      ENDIF      
      WRITE(LINE,'('' R-factor               :'',F8.4)') RFAC
      CALL MSGDOC(MDOC,LINE)
      IF(NFREE.GT.0) THEN
        WRITE(LINE,'('' Nfree, Rfree           :'',I8,F8.4)') 
     *  NFREE,RFAC_FREE
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      ERR_MAX=0.0 
      ERR_MAX_TEST=0.0 
      IF(NREFA.GT.0) THEN
        DER_TEST  =(SQRT(DER_TEST*2.0)*TWOPI)/(VOL*A_CELL)
        CUR_TEST  =(CUR_TEST*2.0*TWOPI*PI)/(VOL*A_CELL*A_CELL)

        DER  = (SQRT(DER*2.0)*TWOPI)/(VOL*A_CELL)
        CUR  = (CUR*2.0*TWOPI*PI)/(VOL*A_CELL*A_CELL)
        IF(CUR.GT.0.0000001) ERR_MAX=(DER/CUR)*SQRT(3.0)
        IF(CUR_TEST.GT.0.0000001) 
     *  ERR_MAX_TEST=(DER_TEST/CUR_TEST)*SQRT(3.0)
        SF1A   = SF1  /NREFA
        SF2A   = SFF2 /NREFA
        SF12A  = SFF12/NREFA
        SF22A  = SFF22/NREFA
        SF1F2A = SF1F2/NREFA
        T1     = (SF12A-SF1A*SF1A)
        T2     = (SF22A-SF2A*SF2A)
        T1     = T1*T2
        IF(T1.GE.0.0) THEN
          RCORR=(SF1F2A-SF1A*SF2A)/SQRT(ABS(T1))
        ELSE
          RCORR=0.0
        ENDIF
      ELSE
        RCORR=0.0
      ENDIF
      WRITE(LINE,'(''Correlation coefficient :'',F8.4)') RCORR
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,
     *'CC = <F1*F2>-<F1><F2>/SQRT((<F1^2>-<F1>^2)(<F2^2>-<F2>^2))')
      WRITE(LINE,
     *'(''sig(r)/expected maximal coordinate error/:'',G14.4)')
     * ERR_MAX

c         DEL       = FN-GGN
c         ACUR      = FN
c         DER       =DER       + DEL*DEL*RSQT*NGEN
c         CUR       =CUR       + ACUR*RSQT*NGEN
C
C         DER    =(SQRT(ABS(DER*2.0))*TWOPI)/(VOL*A_CELL)
C         CUR    =(CUR*2.0*TWOPI*PI)/(VOL*A_CELL*A_CELL)
C         ERR_MAX=(DER/CUR)*SQRT(3.0)
C
C
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,
     *'sig(r) =sqrt(3)*(sig(Ah)/Ahh)  (in A)')
      CALL MSGDOC(MDOC,
     *'   sig(Ah) = (2pi*sqrt(sum(h^2*(F1-F2)^2)))/(VOL*A)')
      CALL MSGDOC(MDOC,
     *'   Ahh     = (2pi^2*sum(h^2*F))/(VOL*A^2)')
      CALL MSGDOC(MDOC,
     *'   VOL - volume of cell, A - cell parameter, summation over all r
     *efls.')
      WRITE(LINE,
     *'(''sig(r)/for complete data set/            :'',G14.4)')
     * ERR_MAX_TEST
      CALL MSGDOC(MDOC,LINE)

      DPI_VAL = 0.0
      IF(NATOM.GT.0.AND.NTOT.GT.0) THEN
        COMPL = FLOAT(NREFA)/FLOAT(NTOT)
        P = FLOAT(NREFA)-4.0*FLOAT(NATOM)
        IF(P.GT.0.0000001.AND.COMPL.GT.0.001) THEN
          T1=SQRT(FLOAT(NATOM)/P)       
          T2=COMPL**(-0.333333)        
          DPI_VAL= 1.0  *T1*T2*RESMXO*RFAC
        ENDIF
        WRITE(LINE,'('' DPI   :'',G14.5)') DPI_VAL
        CALL MSGDOC(MDOC,LINE)
      ENDIF

c      WRITE(LINE,*) ' CUR:',CUR,CUR_TEST
c      CALL MSGDOC(MDOC,LINE)
c      WRITE(LINE,*) ' DER:',DER,DER_TEST
c      CALL MSGDOC(MDOC,LINE)
C       WRITE(LINE,'('' NT,NTG,NF,NFG,NC,NREST:'',7I8)') 
C     *NTOT,NTOTG,NREFA,NREFG,NC,NREST,NATOM
C       CALL MSGDOC(MDOC,LINE)

C --------------- R-factor ------------

      FMIN  = 1.E30
      FFMIN = 1.E30
      FMAX  =-1.E30   
      FFMAX =-1.E30   
      sd=0.0
      sc=0.0
      DO I=1,NUMGP
        IF(SUMF1N (I).GT.0.0 ) THEN
          SUME(I)=SUMD(I)/SUMF1(I)
          IF(I.GT.1) THEN
            IF(SUME(I).GT.FFMAX) FFMAX=SUME(I)
            IF(SUME(I).LT.FFMIN) FFMIN=SUME(I)
          ENDIF
        ELSE
          SUME(I)=0.0
        ENDIF
        IF(SUME(I).GT.FFMAX) FFMAX=SUME(I)

        IF(SUMF1N_FREE (I).GT.0.0 ) THEN
          SUMD_FREE(I)=SUMD_FREE(I)/SUMF1_FREE(I)
        ELSE
          SUMD_FREE(I)=0.0
        ENDIF

c        tt=0.0
c        SD  = SD + DERK(I)
c        T1  = (SQRT(SD*8.0)*TWOPI)/(VOL*A_CELL)
c        SC  = SC + CURK(I)
c        T2  = (SC*2.0*TWOPI*TWOPI)/(VOL*A_CELL*A_CELL)
c        IF(T2.GT.0.00000001) THEN 
c          TT=(T1/T2)*SQRT(3.0)
c        endif
c        WRITE(*,*) t1,t2,tt

      ENDDO


      SUM=0.0
      WT =0.0
      RESLIM=RESMNI
      IF(RESMXI.LE.3.0.AND.RESMNI.GE.5.0) THEN
        RESLIM =5.0
      ENDIF 
      IF(RESMXI.LE.2.0.AND.RESMNI.GE.4.0) THEN
        RESLIM=4.0
      ENDIF 
      IF(RESMXI.GT.3.0.AND.RESMXI.LT.5.0.AND.RESMNI.GE.10.0) 
     *THEN
        RESLIM=10.0
      ENDIF

      IF(RESLIM.GT.10.0) RESLIM=10.0 
      DO I=2,NUMGP-2
        RRES=(RHRP(I)+RHRP(I+1))/2.0
        IF(RRES.LE.RESLIM) THEN
          RRFAC=SUME(I)
          CALL RMS_LUZZ(RRES,RRFAC,RRMS)
          R1 =RHR(I)
          R2 =RHR(I+1)
          W  =R2-R1
          SUM = SUM + RRMS * SUMF1N(I)/W
          WT  = WT  +        SUMF1N(I)/W
        ENDIF
      ENDDO

      ERR_LUZZ=0.0
      IF(WT.GT.0.0) ERR_LUZZ=SUM/WT

      DO I=1,NUMGP
        RRES=(RHRP(I)+RHRP(I+1))/2.0
        IF(RRES.LE.10.0) THEN
          CALL RF_LUZZ(RRES,ERR_LUZZ,RRFAC)
          DLUZZ(I)=RRFAC
        ELSE
          DLUZZ(I)= 0.0
        ENDIF
      ENDDO

      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,
     *'(''<u>/upper estimate error in coords by Luzzati plot/='',F8.4)'
     *) ERR_LUZZ
      CALL MSGDOC(MDOC,LINE)

      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *' ----    Distribution of R-factor     ----')
      CALL MSGDOC(MDOC,' ')

      WRITE(LINE,'(''  min,max:'',2G14.4)') 
     *FFMIN,FFMAX
      CALL MSGDOC(MDOC,LINE)

      TITLE1='     (*) R-factor   (+) Luzzati plot'
      IF(FMAX.GT.0.75) FMAX=0.75
      IF(FMAX.LE.0.20) FMAX=0.20
      IF(FMAX.LE.0.30) FMAX=0.30
      IF(FMAX.LE.0.40) FMAX=0.40
      IF(FMAX.LE.0.50) FMAX=0.50
      IF(FMAX.LE.0.60) FMAX=0.60
      IF(FMAX.LE.0.75) FMAX=0.75
      NF=2
      IMSG=0
      FMIN=0
      CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP,SUME,DLUZZ,FMIN,FMAX,SUMF1N
     *              ,TITLE1,IMSG)
C ---------------------------------------
C ---------------
      FMIN  = 1.E30
      FFMIN = 1.E30
      FMAX  =-1.E30   
      FFMAX =-1.E30
      S  = 0.0
      S1 = 0.0  
      DO I=1,NUMGP
        S  = S  + SUMD(I)
        S1 = S1 + SUMF1(I)
        IF(S1.GT.0.0 ) THEN
          SUME(I) = S/S1
          IF(I.GT.1) THEN
            IF(SUME(I).GT.FFMAX) FFMAX=SUME(I)
            IF(SUME(I).LT.FFMIN) FFMIN=SUME(I)
          ENDIF
        ELSE
          SUME(I)=0.0
        ENDIF
        IF(SUME(I).GT.FFMAX) FFMAX=SUME(I)
      ENDDO


      SUM=0.0
      WT =0.0
      RESLIM=RESMNI
      IF(RESMXI.LE.3.0.AND.RESMNI.GE.5.0) THEN
        RESLIM =5.0
      ENDIF 
      IF(RESMXI.LE.2.0.AND.RESMNI.GE.4.0) THEN
        RESLIM=4.0
      ENDIF 
      IF(RESMXI.GT.3.0.AND.RESMXI.LT.5.0.AND.RESMNI.GE.10.0) 
     *THEN
        RESLIM=10.0
      ENDIF

      IF(RESLIM.GT.10.0) RESLIM=10.0 
      DO I=2,NUMGP-2
        RRES=(RHRP(I)+RHRP(I+1))/2.0
        IF(RRES.LE.RESLIM) THEN
          RRFAC=SUME(I)
          CALL RMS_LUZZ(RRES,RRFAC,RRMS)
          R1 =RHR(I)
          R2 =RHR(I+1)
          W  =R2-R1
          SUM = SUM + RRMS * SUMF1N(I)/W
          WT  = WT  +        SUMF1N(I)/W
        ENDIF
      ENDDO

      ERR_LUZZ=0.0
      IF(WT.GT.0.0) ERR_LUZZ=SUM/WT


      DO I=1,NUMGP
        RRES=(RHRP(I)+RHRP(I+1))/2.0
        IF(RRES.LE.10.0) THEN
          CALL RF_LUZZ(RRES,ERR_LUZZ,RRFAC)
          DLUZZ(I)=RRFAC
        ELSE
          DLUZZ(I)= 0.0
        ENDIF
      ENDDO

      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *' ----    Cumulative R-factor     ----')
      CALL MSGDOC(MDOC,' ')

      WRITE(LINE,'(''  min,max:'',2G14.4)') 
     *FFMIN,FFMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,  
     *'('' Luzzati plot / for <u> = '',F8.4,'' /'')') 
     *ERR_LUZZ
      CALL MSGDOC(MDOC,LINE)

      TITLE1='     (*) R-factor   (+) Luzzati plot'
      IF(FMAX.GT.0.75) FMAX=0.75
      IF(FMAX.LE.0.20) FMAX=0.20
      IF(FMAX.LE.0.30) FMAX=0.30
      IF(FMAX.LE.0.40) FMAX=0.40
      IF(FMAX.LE.0.50) FMAX=0.50
      IF(FMAX.LE.0.60) FMAX=0.60
      IF(FMAX.LE.0.75) FMAX=0.75
      NF=2
      IMSG=0
      FMIN=0
      CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP,SUME,DLUZZ,FMIN,FMAX,SUMF1N
     *              ,TITLE1,IMSG)
C ---------------------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *' ---- sig(r) - expected maximal coordinate error ----')
      CALL MSGDOC(MDOC,' ')
      NF=1
      FMIN = 1.E30
      FFMIN= 1.E30
      FMAX =-1.E30
      FFMAX=-1.E30

      SD=0.0
      SC=0.0   
      DO I=1,NUMGP
        TT  = 0.0
        SD  = SD + DERK(I)
        T1  = (SQRT(SD*2.0)*TWOPI)/(VOL*A_CELL)
        SC  = SC + CURK(I)
        T2  = (SC*2.0*TWOPI*PI)/(VOL*A_CELL*A_CELL)
        IF(T2.GT.0.00000001) THEN 
          TT=(T1/T2)*SQRT(3.0)
          IF(TT.GT.FFMAX) FFMAX = TT
          IF(TT.LT.FFMIN) FFMIN = TT
          IF(I.GT.5) THEN
            IF(TT.GT.FMAX)  FMAX =TT
            IF(TT.LT.FMIN)  FMIN =TT
            SUMF1N(I)=0.0
          ELSE
            SUMF1N(I)=10000000000000.0
          ENDIF
        ELSE
          SUMF1N(I)=10000000000000.0
        ENDIF
        SUMC(I)=TT
      ENDDO
      TITLE1='     (*) sig(r)'
      WRITE(LINE,'(''  min :'',G14.4)') 
     *FFMIN
      CALL MSGDOC(MDOC,LINE)

      DO I=1,NUMGP
        RESULTA(I,8)=RHRP(I)
        RESULTA(I,9)=SUMC(I)
      ENDDO
      RESULTA(IPRROW,8)=RHRP(NUMGP+1)
      RESULTA(IPRROW,9)=ERR_MAX

      DO I=1,NUMGP
        IF(SUMF1N(I).EQ.0.0) THEN
          IF(FMAX.GT.0.0) THEN
            T=SUMC(I)/FMAX
          ELSE
            T=0.0
          ENDIF 
          SUMF1N(I)=T
        ENDIF 
      ENDDO      
      CALL CORR_MAX(FMAX,FMAXN)
      IMSG  = 1
      FMIN  = 0
      CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP,SUMC,SUMF1,FMIN,FMAXN,SUMF1N
     *              ,TITLE1,IMSG)
C -----------------------------------
      IF(IPRROW.GE.21) THEN
        RESULT(11) =RFAC_FREE
        RESULT(12) =DPI_VAL     
        RESULT(13) =ERR_MAX     
        RESULT(14) =NUMGP    
        RESULT(15) =BOFF     
        RESULT(16) =BADD     
        RESULT(17) =RCORR
        RESULT(20) =RFAC
      ENDIF

      ELSE

      IF(IPRROW.GE.21) THEN
        RESULT(15) =BOFF     
        RESULT(16) =BADD     
        RESULT(17) =0.0
        RESULT(20) =0.0
      ENDIF

      ENDIF
C ----------------
      CALL MSGDOC(MDOC,' ')
      IF(MTOUT.GT.0) THEN
        CALL MSGDOC(MDOC,'Writing to output file')
      ELSE
        CALL MSGDOC(MDOC,'Scaled file')
      ENDIF
      WRITE(LINE,'(''Number of refls                  :'',I8)')NREF
      CALL MSGDOC(MDOC,LINE)
      IF(REST.EQ.'Y'.OR.REST.EQ.'O') THEN
        IF(NREST.GT.0) THEN
        CALL MSGDOC(MDOC,'      /including restored refls/ ')
        WRITE(LINE,'(''Number restored refls            :'',I8)')NREST
        CALL MSGDOC(MDOC,LINE)
        ENDIF
        IF(MTIN.GT.0.AND.NMISS.GT.0) THEN
        WRITE(LINE,'(''Number missed refls in both files:'',I8)')NMISS
        CALL MSGDOC(MDOC,LINE)
        ENDIF
      ENDIF
C ---
      IF(NREF.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: NUMBER OF REFLS = 0')
        IERR=1
      ENDIF
      RETURN
      END


      SUBROUTINE GRAPH_PATTT(MDOC,NG,NF,R,X,Y,FMIN,FMAX,SN
     *                      ,TITLE,IMSG)
      REAL X(NG),Y(NG),R(NG),SN(NG)
      CHARACTER STR*61,MSG*1,LINE*80,TITLE1*80,TITLE*(*),LINE1*80
C----------------------------------------------------------------
      CHARACTER FRMT1*7,FRMT2*7,FRMT3*7,FRM*7,CH6*6
      DATA FRMT1/'(F12.2)'/,FRMT2/'(F12.3)'/,FRMT3/'(F12.5)'/
C----------------------------------------------------------------
      NNG=NG
      IF(NNG.GT.20) NNG=20
      IF(NNG.LE. 0) NNG=1

      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      

      SCALE=1.0
      IF(FMAX.LT.0.00001.OR.
     *   FMAX.GE.1000000000.0) THEN
        SCALE=100.0/FMAX + 0.00000001
        WRITE(LINE,'(''Scale :'',F12.2)') 
     *  SCALE
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      FRM=FRMT1
      IF(FMAX.LT.0.1)  FRM=FRMT2
      IF(FMAX.LT.0.01) FRM=FRMT3
      LINE=
     *'                                                              
     *        '
      T=FMIN*SCALE
      WRITE(LINE( 6:17),FRM) T
       
      DEL=((FMAX-FMIN)*SCALE)/5.0
      DO I=1,4
        T =FMIN*SCALE+DEL*I
        I2=12*I+17
        I1=I2-11
        WRITE(LINE(I1:I2),FRM) T
      ENDDO
      T=FMAX*SCALE
      WRITE(LINE(66:77),FRM) T
C ----
      IF(IMSG.GT.0) THEN
        TITLE1='Ratio Distance'
      ELSE
        TITLE1='   N  Distance'
      ENDIF
      CALL LENSTR_BL(TITLE1,LEN1)
      CALL LENSTR_BL(TITLE ,LEN)
      I=80-(LEN1+LEN+2)
      IF(I.LT.0) LEN=LEN+I
      IF(LEN.LE.0) THEN
        LEN=1
      ELSE IF(LEN.GT.60) THEN
        LEN=60
      ENDIF
      I=LEN+LEN1
      LINE1=' '
      IF(I.GT.0.AND.I.LE.80)
     *LINE1=TITLE1(1:LEN1)//TITLE(1:LEN)
      CALL LENSTR_BL(LINE1,LEN)
      IF(LEN.LE.0) THEN
        LINE1=' '
        LEN=1
      ELSE IF(LEN.GT.78) THEN
        LEN=78
      ENDIF
      CALL MSGDOC(MDOC,LINE1(1:LEN))
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
      TEMP=(FMAX-FMIN)*SCALE
      IF(TEMP.LT.1.E-5) TEMP=1.0
      COEF=60.0/TEMP
      IFN0=(-FMIN*SCALE)*COEF+1
      IF(IFN0.GT.61) IFN0=61
      IF(IFN0.LE. 0) IFN0=0

      DO     I=1,NNG
          RES=R(I)
          IFN=(X(I)-FMIN)*SCALE*COEF+1
          IF(IFN.GT.61) IFN=61
          IF(IFN.LE. 0) IFN= 1
          STR=' '
          STR( 1: 1)  ='.'
          STR(13:13)  ='.'
          STR(25:25)  ='.'
          STR(37:37)  ='.'
          STR(49:49)  ='.'
          STR(61:61)  ='.'
          IF(IFN0.GT.0) STR(IFN0:IFN0)='o'
          STR(IFN:IFN)='*'
          IF(NF.GT.1) THEN
            IFD=(Y(I)-FMIN)*SCALE*COEF+1
            IF(IFD.GT.61) IFD=61
            IF(IFD.LE. 0) IFD= 1
            STR(IFD:IFD)='+'
            IF(IFN.EQ.IFD) STR(IFN:IFN)='#'
          ENDIF
          IF(IMSG.GT.0) THEN
            WRITE(CH6,'(F6.4)') SN(I)
            IF(CH6(1:1).EQ.'*') CH6='   -  ' 
            WRITE(LINE,'(A,1X,F7.2,2X,A61)') CH6,RES,STR
          ELSE
            NP=I
            WRITE(LINE,'(I6,F8.2,2X,A61)') NP,RES,STR
          ENDIF
          CALL MSGDOC(MDOC,LINE)
      ENDDO
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
      RETURN
      END

      SUBROUTINE TEMP_FLPP(SUMMET,NGP,RHR,SCALE,BTEMP,ALIM)
      REAL    SUMMET(*),X(40),Y(40),RHR(*)
C --------------------------------------------------------------------
      SUMXY =0.0
      SUMXX =0.0
      SUMX  =0.0
      SUMY  =0.0
      COUNT =0.0
      IFIRST=0
      FMAX  =0.0
      DO     J=1,NGP
        IF(SUMMET(J).GE.FMAX) FMAX=SUMMET(J)
      ENDDO  
      DEL2  = (RHR(2)-RHR(1))/2.0
      DO     J=1,NGP
        
        RAD = RHR(J) + DEL2

c        GP=1.0
        GP=1.0/J

        X(J)=(RAD**2)/4.0

        IF(SUMMET(J).LE.(FMAX*ALIM)) IFIRST=1
        IF(IFIRST.EQ.0) THEN
          Y(J) =ALOG(1.0/SUMMET(J))
          SUMXY=SUMXY + X(J)*Y(J)*GP
          SUMXX=SUMXX + X(J)*X(J)*GP
          SUMX =SUMX  + X(J)*GP
          SUMY =SUMY  + Y(J)*GP
          COUNT=COUNT + GP
        ENDIF
      ENDDO  
      SLOPE = ((COUNT*SUMXY)-(SUMX*SUMY))/((COUNT*SUMXX)-(SUMX*SUMX))
      CEPT  = (1.0/COUNT)*(SUMY-(SLOPE*SUMX))
      BTEMP = 0.5*SLOPE*0.5
      SCALE = EXP(-CEPT)
      RETURN
      END

      SUBROUTINE GRAPH_PP(MDOC,NG,NF,R,X,Y,FMIN,FMAX,SN
     *                   ,TITLE,IMSG)
      REAL X(NG),Y(NG),R(NG),SN(NG)
      CHARACTER STR*61,MSG*1,LINE*80,TITLE*(*),TITLE1*80,LINE1*80
      CHARACTER FRMT1*7,FRMT2*7,FRMT3*7,FRM*7,CH6*6
      DATA FRMT1/'(F12.2)'/,FRMT2/'(F12.3)'/,FRMT3/'(F12.5)'/
C----------------------------------------------------------------
      NNG=NG
      IF(NNG.GT.20) NNG=20
      IF(NNG.LE. 0) NNG=1

      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      

      SCALE=1.0
      IF(FMAX.LT.0.00001.OR.
     *   FMAX.GE.1000000000.0) THEN
        SCALE=100.0/FMAX + 0.00000001
        WRITE(LINE,'(''Scale :'',F12.2)') 
     *  SCALE
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      FRM=FRMT1
      IF(FMAX.LT.0.1)  FRM=FRMT2
      IF(FMAX.LT.0.01) FRM=FRMT3
      LINE=
     *'                                                              
     *        '
      T=FMIN*SCALE
      WRITE(LINE( 6:17),FRM) T
       
      DEL=((FMAX-FMIN)*SCALE)/5.0
      DO I=1,4
        T =FMIN*SCALE+DEL*I
        I2=12*I+17
        I1=I2-11
        WRITE(LINE(I1:I2),FRM) T
      ENDDO
      T=FMAX*SCALE
      WRITE(LINE(66:77),FRM) T
C ---------------

      IF(IMSG.GT.0) THEN
        TITLE1=' Ratio Resolution'
      ELSE
        TITLE1='   N   Resolution'
      ENDIF
      CALL LENSTR_BL(TITLE1,LEN1)
      CALL LENSTR_BL(TITLE ,LEN)
      I=80-(LEN1+LEN+2)
      IF(I.LT.0) LEN=LEN+I
      IF(LEN.LE.0) THEN
        LEN=1
      ELSE IF(LEN.GT.60) THEN
        LEN=60
      ENDIF
      I=LEN+LEN1
      LINE1=' '
      IF(I.GT.0.AND.I.LE.80)
     *LINE1=TITLE1(1:LEN1)//TITLE(1:LEN)
      CALL LENSTR_BL(LINE1,LEN)
      IF(LEN.LE.0) THEN
        LINE1=' '
        LEN=1
      ELSE IF(LEN.GT.78) THEN
        LEN=78
      ENDIF
      CALL MSGDOC(MDOC,LINE1(1:LEN))

      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
      TEMP=(FMAX-FMIN)*SCALE
      IF(TEMP.LT.1.E-5) TEMP=1.0
      COEF=60.0/TEMP
      IFN0=(-FMIN*SCALE)*COEF+1
      IF(IFN0.GT.61) IFN0=61
      IF(IFN0.LE. 0) IFN0=0
      DO     I=1,NNG
          RES=R(I)
          IFN=(X(I)-FMIN)*SCALE*COEF+1
          IF(IFN.GT.61) IFN=61
          IF(IFN.LE. 0) IFN= 1
          STR=' '
          STR( 1: 1)  ='.'
          STR(13:13)  ='.'
          STR(25:25)  ='.'
          STR(37:37)  ='.'
          STR(49:49)  ='.'
          STR(61:61)  ='.'
          IF(IFN0.GT.0) STR(IFN0:IFN0)='o'
          STR(IFN:IFN)='*'
          IF(NF.GT.1) THEN
            IFD=(Y(I)-FMIN)*SCALE*COEF+1
            IF(IFD.GT.61) IFD=61
            IF(IFD.LE. 0) IFD= 1
            STR(IFD:IFD)='+'
            IF(IFN.EQ.IFD) STR(IFN:IFN)='#'
          ENDIF
          IF(IMSG.GT.0) THEN
            WRITE(CH6,'(F6.4)') SN(I)
            IF(CH6(1:1).EQ.'*') CH6='   -  ' 
            WRITE(LINE,'(A,1X,F7.2,2X,A61)') CH6,RES,STR
          ELSE
            NP=SN(I)
            WRITE(CH6,'(I6)') NP
            IF(CH6(1:1).EQ.'*'.OR.NP.EQ.0) CH6='   -  ' 
            WRITE(LINE,'(A,1X,F7.2,2X,A61)') CH6,RES,STR
          ENDIF
          CALL MSGDOC(MDOC,LINE)
      ENDDO
      CALL MSGDOC(MDOC
     *,' ---------------------------------------------------------------
     *-------')      
      RETURN
      END


      SUBROUTINE TEMP_FLLL(SUMMET,SUMAZ,NGP,RHMIN,THINT,SCALE,BTEMP)
      REAL    SUMMET(*),SUMAZ(*),X(40),Y(40)
C --------------------------------------------------------------------
      SUMXY=0.0
      SUMXX=0.0
      SUMX =0.0
      SUMY =0.0
      COUNT=0.0
      DO     J=1,NGP
        GP=SUMAZ(J)
        NP=GP+0.001
        IF(NP.GT.0) THEN
          FJ   =J
          X(J) =(((FJ-0.5)*THINT+RHMIN)**2)/4.0
          Y(J) =ALOG(SUMAZ(J)/SUMMET(J))
          SUMXY=SUMXY + X(J)*Y(J)*GP
          SUMXX=SUMXX + X(J)*X(J)*GP
          SUMX =SUMX  + X(J)*GP
          SUMY =SUMY  + Y(J)*GP
          COUNT=COUNT + GP

        ENDIF
      ENDDO  
      SLOPE=((COUNT*SUMXY)-(SUMX*SUMY))/((COUNT*SUMXX)-(SUMX*SUMX))
      CEPT =(1.0/COUNT)*(SUMY-(SLOPE*SUMX))
      BTEMP=0.5*SLOPE
      SCALE=EXP(-CEPT)
      RETURN
      END

      SUBROUTINE CORR_MAX(AMAX,AMAXN)
C -------------------------------------------
      IF(AMAX.LE.0.0) THEN
        AMAXN = 0.0
        RETURN
      ENDIF
      ALG = LOG(AMAX)/LOG(10.0)
      N   = ALG
      IF(N.LE.0) N=N-1
      A1N   = FLOAT(1-N)
      COEF  = 10.0**A1N
      AMAXC = AMAX*COEF
      DEL   = AMAXC/5.0
      IDEL  = DEL
      A     = DEL-IDEL
      IF(A.GT.0.0) IDEL = IDEL+1 
      IMAX  = IDEL*5
      AMAXN = IMAX/COEF
      RETURN
      END

C -I-
      SUBROUTINE ABCDPH(MDOC,NAME1,NAME2,NAMEO,NAMEA,SCCOMB
     * ,RESMIN,RESMAX,IPRINT,STOP_T
     * ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ---------------------------------------------------------
C -P- ABCDPH - calculates phases of structure factors from Henderickson/Lattman
C	       coefficients or/and joins two files of ABCD. Shows 
C              distribution of phase probability for some reflections.
C              See also program "joinfl".
C -S-
C
C  Dialog and Batch: 
C
C  FILE_I:  input_file ABCD_coef
C  FILE_2:  input_file ABCD_coef_2 /" " means without this file/
C  FILE_O:  output_file PHASE      /" " means without output/'
C  FILE_A:  output_file ABCD (+ ABCD_2) /" " means without output/
C  RESOL:   MIN,MAX - resolution / default values from input_files /
C  PRINT:   <0>  information about each print-th reflection will be printed
C
C  Parameters of subroutine ABCDPH: 
C
C      SUBROUTINE ABCDPH(MDOC,NAME1,NAME2,NAMEO,NAMEA,SCCOMB
C     * ,RESMIN,RESMAX,IPRINT,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C    MDOC    - mode of writting messages to DOC-file
C              0 - only terminal , < - 0 only file, 0 < < 99 - both
C              >= 99 - don't write  
C    NAME1   - input_file ABCD_coef
C    NAME2   - input_file ABCD_coef_2 /" " means without this file/
C    NAMEO   - output_file PHASE      /" " means without output/'
C    NAMEA   - output_file ABCD (+ ABCD_2) /" " means without output/
C    RESMIN  -  MIN,MAX - resolution / default values from input_files /
C    RESMAX
C    IPRINT  -  <0> information about each iprint-th reflection will be printed
C    STOP_T  - must be = 'N'
C    SCCOMB  - not used.
C    ISYM    - integer*2 array for cryst.symmetry operators.
C    IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM),
C              number of cryst. symm. operators.
C    IERR    - output signal of error / = 1 -error , = 0 - OK / 
C
C        output information :
C
C     RESULT(1) - number of refls /in output file/
C     RESULT(2) - <FOM>
C
C -I-
C ---------------------------------------------------------
      CHARACTER NAME1*(*),NAMEA*(*),NAMEO*(*),STOP_T*1,NAME2*(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
C ---------------------------------------------------------
      INTEGER   NRGZ(11)
      REAL      RLATT(6)
      REAL      STL(11),RHR(11),AAMSZ(11),SUMFZ(11)
      CHARACTER TYPN*4,TYPP*4,TABC*4
      CHARACTER TTT*80,LINE*80,TITLE*80
      CHARACTER MSG*1,MSG1*1
C========================================================================
      IERR=0
      MD=-ABS(MDOC)-1

      MT1  =10
      TYPN  ='ABCD'
      CALL ORFILE(MD,MT1,NAME1,TYPN,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MDOC,'INPUT-FILE ABCD_coef_1')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RN,RX,IDM1,IDM2,IDM3,IDM4,IDM5,TITLE,IERR)
      IF(IERR.GT.0) THEN
        CLOSE(MT1)
        RETURN
      ENDIF
      RLATT(1)=A
      RLATT(2)=B
      RLATT(3)=C
      RLATT(4)=AL
      RLATT(5)=BE
      RLATT(6)=GA
      CALL C_RD_CR
C --------------------------------------------------------------------
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',') THEN 
        MABCD=11
        TABC ='ABCD'
        CALL ORFILE(MDoc,MABCD,NAME2,TABC,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGDOC(MDOC,'INPUT-FILE ABCD_coef_2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MDoc,A,B,C,AL,BE,GA
     *    ,F1,F2,RNN,RXX,IDM1,IDM2,IDM3,IDM4,IDM5,TTT,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(MABCD)
          CLOSE(MT1)
          RETURN
        ENDIF
      ELSE
        MABCD=0
      ENDIF
C--------------------------------------------------------------
      IF(RESMIN.LE.0.0) RESMIN=RN      
      IF(RESMIN.GT.RN)  RESMIN=RN      
      IF(RESMAX.LT.RX ) RESMAX=RX
      IF(MABCD.GT.0) THEN
        IF(RESMIN.GT.RNN)  RESMIN=RNN     
        IF(RESMAX.LT.RXX)  RESMAX=RXX
      ENDIF
      IF(RESMIN.LT.RESMAX) THEN
        T=RESMIN
        RESMIN=RESMAX
        RESMAX=T
      ENDIF
      IF(STOP_T.EQ.'y') STOP_T='Y'
      IF(STOP_T.NE.'Y') STOP_T='N'
C ------------------------------------------------
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      RHMIN=1./RESMIN
      RHMAX=1./RESMAX
      DRANG=(RHMAX-RHMIN)/10.
      IF(IPRINT.LE.0) IPRINT=0
      IF(SCCOMB.LE.0.0) SCCOMB=1.0
C -------------------------------------------------
      CALL LENSTR_BL(NAMEO,LEN)
      MTOUT=0
      IF(LEN.GT.0.AND.NAMEO(1:1).NE.' '.AND.NAMEO(1:1).NE.',') THEN 
        MTOUT=12
        TYPP ='PH  '
        TTT  = TITLE
        TTT(1:4)='PHAS'
        TTT(5:8)='ABCD'
        IF(MABCD.NE.0) TTT(5:8)='COMB'
        CALL C_CR_WR
        CALL SET_TITLE(MDOC,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM1,IDM2,IDM3,IDM4,IDM5,TTT,IERR)
        CALL OWFILE(MDOC,MTOUT,NAMEO,TYPP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(MT1)
          IF(MABCD.GT.0) CLOSE(MABCD)
          RETURN
        ENDIF
      ENDIF    
      CALL LENSTR_BL(NAMEA,LEN)
      MTA_OUT=0
      IF(LEN.GT.0.AND.NAMEA(1:1).NE.' '.AND.NAMEA(1:1).NE.',') THEN 
        MTA_OUT=13
        TYPP ='ABCD'
        TTT  = TITLE
        TTT(1:4)='PHAS'
        TTT(5:8)='ABCD'
        IF(MABCD.NE.0) TTT(5:8)='COMB'
        CALL C_CR_WR
        CALL SET_TITLE(MDOC,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM1,IDM2,IDM3,IDM4,IDM5,TTT,IERR)
        CALL OWFILE(MDOC,MTA_OUT,NAMEA,TYPP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(MT1)
          IF(MABCD.GT.0) CLOSE(MABCD)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          RETURN
        ENDIF
      ENDIF    
C-----------------------------------------------------------------
      CALL INIT_CENTR(NSYM,ISYM)
C ---
C:::::::::::
      KKCENT=0
      IICENT=0
C     WRITE(1,*) '$KCENT (<0>-NO,1-ONLY,2-WITHOUT,3-ALL):'
C     READ(1,*) KKCENT
C     IF(KKCENT.NE.0) THEN
C       WRITE(1,*) '$ICENT (0-ALL,1-0KL,2-H0L,3-HK0,4-HHL,5-/1+2+3/) :'
C       READ(1,*) IICENT
C     ENDIF
C:::::::::::
      IEND1=-1
      IEND2=-1
      IF(MABCD.EQ.0) IEND2=1
      IENDW=-1
      IENDA=-1
      NUMB1=0
      NUMB2=0
      NUMBW=0
      NUMBA=0
      NRG=0
      AAMS=0.
      SUMF=0.0
      DO     K=1,11
        AAMSZ(K)=0.
        SUMFZ(K)=0.
        NRGZ (K)=0
      ENDDO
      CALL RABCD(MT1 ,JH1,JK1,JL1,AA1,BB1,CC1,DD1,NUMB1,IEND1)
      IF(MABCD.GT.0) THEN
        CALL RABCD1(MABCD,JH2,JK2,JL2,AA2,BB2,CC2,DD2,NUMB2,IEND2)
      ENDIF
      ILIST=0
      NCNT=0
C=================================================================
  550 IF(IEND1.EQ.1.AND.IEND2.EQ.1) GO TO 560
      IF(IEND1.EQ.1) GO TO 380
      IF(IEND2.EQ.1) GO TO 370

C      IF(JL1-JL2) 370,340,380
C  340 IF(JK1-JK2) 370,350,380
C  350 IF(JH1-JH2) 370,360,380

      IF(JL1.LT.JL2) GO TO 370
      IF(JL1.GT.JL2) GO TO 380
      IF(JK1.LT.JK2) GO TO 370
      IF(JK1.GT.JK2) GO TO 380
      IF(JH1.LT.JH2) GO TO 370
      IF(JH1.GT.JH2) GO TO 380
      GO TO 360
C -------------------
  370 IH   =JH1
      IK   =JK1
      IL   =JL1
      A1   =AA1
      B1   =BB1
      C1   =CC1
      D1   =DD1
      IABCD1=1
      IABCD2=0
      CALL RABCD(MT1,JH1,JK1,JL1,AA1,BB1,CC1,DD1,NUMB1,IEND1)
      GO TO 400
C ----------------
  380 IH   =JH2
      IK   =JK2
      IL   =JL2
      A2   =AA2
      B2   =BB2
      C2   =CC2
      D2   =DD2
      IABCD2=1
      IABCD1=0
      CALL RABCD1(MABCD,JH2,JK2,JL2,AA2,BB2,CC2,DD2,NUMB2,IEND2)
      GO TO 400
C -------------------
  360 IH   =JH2
      IK   =JK2
      IL   =JL2
      A2   =AA2
      B2   =BB2
      C2   =CC2
      D2   =DD2
      IABCD2=1
      A1   =AA1
      B1   =BB1
      C1   =CC1
      D1   =DD1
      IABCD1=1
      CALL RABCD(MT1 ,JH1,JK1,JL1,AA1,BB1,CC1,DD1,NUMB1,IEND1)
      CALL RABCD1(MABCD,JH2,JK2,JL2,AA2,BB2,CC2,DD2,NUMB2,IEND2)
C  ------------------
 400  CONTINUE
C ------------------
      ICENT=2
      JCENT=2
      IF(KKCENT.NE.0) THEN
        IF(IICENT.EQ.0)              JCENT=1
        IF(IICENT.EQ.1.AND.IH.EQ.0)  JCENT=1
        IF(IICENT.EQ.2.AND.IK.EQ.0)  JCENT=1
        IF(IICENT.EQ.3.AND.IL.EQ.0)  JCENT=1
        IF(IICENT.EQ.4.AND.IH.EQ.IK) JCENT=1
        IF(IICENT.EQ.5.AND.(IH.EQ.0.OR.IK.EQ.0.OR.IL.EQ.0)) JCENT=1
      ENDIF
      IF(KKCENT.EQ.1.AND.JCENT.EQ.2) GO TO 550
      IF(KKCENT.EQ.2.AND.JCENT.EQ.1) GO TO 550
C --------
      CALL DSTAR_BL(IH,IK,IL,RSQ)
      RH=SQRT(RSQ)
      IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 550
      SINTHL=RH/2.
      COPH=0.
      SIPH=0.
      NRG=NRG+1
      KRANG=(RH-RHMIN)/DRANG+1.
      IF(KRANG.GT.10) KRANG=10
      IF(KRANG.LT. 1) KRANG=1

      CALL BESTP_PH(MDOC,IABCD1,A1,B1,C1,D1,IABCD2,A2,B2,C2,D2
     *  ,PHI,COPH,SIPH,IPRINT,PHIB,AAM,NRG,JCENT,STOP_T
     *  ,SCCOMB,IH,IK,IL,ILIST,AS,BS,CS,DS,NCNT,IERR)

C ------------------
      NUMBW=0
      IF(MTOUT.GT.0) THEN
        CALL WRT(MTOUT,IH,IK,IL,COPH,SIPH,NUMBW,IENDW)
      ENDIF
      IF(MTA_OUT.GT.0) THEN
        CALL WABCD(MTA_OUT,IH,IK,IL,AS,BS,CS,DS,NUMBA,IENDA)
      ENDIF
C ------------------
      AAMS =AAMS+AAM
      KRANG=(RH-RHMIN)/DRANG+1.
      IF(KRANG.GT.10) KRANG=10
      IF(KRANG.LT. 1) KRANG= 1
      NRGZ(KRANG)=NRGZ(KRANG)+1
      AAMSZ(KRANG)=AAMSZ(KRANG)+AAM
      IF(IPRINT.NE.0) THEN
        IF(MOD(NRG,IPRINT).EQ.0) THEN
         WRITE(LINE,900) IH,IK,IL,AS,BS,CS,DS
         CALL MSGDOC(MDOC,LINE)
  900    FORMAT('hkl:',3I4,'  ABCD:',4(1X,E12.4))
        ENDIF
      ENDIF
      GO TO 550
C-----------------------------------------------------------
 560  CONTINUE
      IF(MTOUT.GT.0) THEN
        IENDW=2
        CALL WRT(MTOUT,IH,IK,IL,COPH,SIPH,NUMBW,IENDW)
      ENDIF
      IF(MTA_OUT.GT.0) THEN
        IENDA=2
        CALL WABCD(MTA_OUT,IH,IK,IL,AS,BS,CS,DS,NUMBA,IENDA)
      ENDIF
      CLOSE(MT1)
      IF(MABCD.GT.0) CLOSE(MABCD)
C --------------------------------------------
      IF(NRG.GT.0) AAMS=AAMS/NRG
      RHR(1)=1./RHMIN
      STL(1)=RHMIN/2.
      DO     K=2,11
        K1=K-1
        STL(K)=STL(K-1)+DRANG/2.0
        RHR(K)=1./(STL(K)*2.)
        IF(NRGZ(K1).GT.0) THEN
          AAMSZ(K1)=AAMSZ(K1)/NRGZ(K1)
        ENDIF
      ENDDO
      CALL MSGDOC(MDOC,' ----------------------------')
      WRITE(LINE, 910) AAMS,NRG,NCNT
      CALL MSGDOC(MDOC,LINE)
c      WRITE(LINE, 930) STL
c      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE, 931) RHR
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE, 940) (AAMSZ(K),K=1,10)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE, 950) (NRGZ(K),K=1,10)
      CALL MSGDOC(MDOC,LINE)
      RESULT(1)= NRG
      RESULT(2)= AAMS
      RETURN
C ------------------------------------------------------------
  910 FORMAT('F OF M =',F8.4,' NUMB REFLS=',I6,' N_CENTR=',I6)
  930 FORMAT('SINTH/LAM   ',11F6.4)
  931 FORMAT('ANGSTR    ',11F6.2)
  940 FORMAT('FOM         ',11(2X,F4.2))
  950 FORMAT('N REFLS     ',11I6)
      END
 

      SUBROUTINE BESTP_PH(MDOC,IABCD1,A1,B1,C1,D1,IABCD2,A2,B2,C2,D2
     *  ,PHI,COPH,SIPH,IPRINT,PHIB,AAM,NRG,JCENT,STOP_T
     *  ,SCCOMB,IH,IK,IL,ILIST,AS,BS,CS,DS,NCNT,IERR)
C-------------------------------------------------------------------
C       CALCULATE THE BEST PHASES IN STEPS OF 10 DEGREES
C    WRZZ  - PROBABILITIES
C    PHIB  - BEST PHASE
C    COPH  - COSINUS OF THE BEST PHASE-ANGLE MULTIPLIED BY THE
C            FIGURE OF MERIT
C    SIPH  - SINUS
C    AAM   - FIGURE OF MERIT OF THIS REFLEXION
C----------------------------------------------------------------------
      REAL    WRZZ(73),DEGR(36),CPH(36),SPH(36),DEGRC(36)
      REAL    DEGRS(36)
      INTEGER IZZ(73)
      CHARACTER LINE*80,STOP_T*1,CENT*1
C----------------------------------------------------------------------
C---------  PHASE CALCULATION IN STEPS OF 10 DEGREES
      CALL CENTR_BL(IH,IK,IL,ICENT)
      CENT='N'
      IF(ICENT.EQ.1) THEN
        CENT='Y'
        NCNT=NCNT+1
      ENDIF
      AS=0.0
      BS=0.0
      CS=0.0
      DS=0.0
      IF(IABCD1.GT.0) THEN
        AS=AS+A1
        BS=BS+B1
        CS=CS+C1
        DS=DS+D1
      ENDIF
      IF(IABCD2.GT.0) THEN
        AS=AS+A2
        BS=BS+B2
        CS=CS+C2
        DS=DS+D2
      ENDIF

      ICOMB=0
      IF(IABCD1.GT.0.AND.IABCD2.GT.0) ICOMB=1

      COPH= COS(.1745329)
      SIPH=-SIN(.1745329)
      CO5= COPH
      SI5=-SIPH
      DMINC= 1.E30
      DMAXC=-1.E30
      DMINS= 1.E30
      DMAXS=-1.E30
      DMIN = 1.E30
      DMAX =-1.E30
      DO     I=1,36
        COPH1=COPH
        SIPH1=SIPH
        COPH=COPH1*CO5-SIPH1*SI5
        SIPH=COPH1*SI5+SIPH1*CO5
        COPH2=COPH*COPH-SIPH*SIPH
        SIPH2=2.*SIPH*COPH
        STOR=AS*COPH+BS*SIPH+CS*COPH2+DS*SIPH2
        DEGRS(I)=STOR
        IF(STOR.LT.DMINS) DMINS=STOR
        IF(STOR.GT.DMAXS) DMAXS=STOR
        CPH(I)=COPH
        SPH(I)=SIPH

        IF(ICOMB.NE.0) THEN
          STOR=A1 *COPH+B1 *SIPH+C1 *COPH2+D1 *SIPH2
          DEGR(I)=STOR
          IF(STOR.LT.DMIN) DMIN=STOR
          IF(STOR.GT.DMAX) DMAX=STOR
          STOR=A2 *COPH+B2 *SIPH+C2 *COPH2+D2 *SIPH2
          DEGRC(I)=STOR
          IF(STOR.LT.DMINC) DMINC=STOR
          IF(STOR.GT.DMAXC) DMAXC=STOR
        ENDIF

      ENDDO
      SC1=-1.E30
      SC2= 1.E30
      SC3= 0.
      SC4= 0.
      NW=0
      AMIN=-1.E30
      AMCO=0.
      AMSI=0.
      SUMPI=0.
      DO     I=1,36
        STOR=DEGRS(I)-DMAXS
        IF(STOR.LT.-1.E10) STOR=-1.E10
        DEGRS(I)=STOR
        WRZNUM=EXP(STOR)
        IF(ICOMB.NE.0) THEN
          STOR=DEGR(I)-DMAX
          IF(STOR.LT.-1.E10) STOR=-1.E10
          DEGR(I)=STOR
          STOR=DEGRC(I)-DMAXC
          IF(STOR.LT.-1.E10) STOR=-1.E10
          DEGRC(I)=STOR
        ENDIF
C ----  PROBABILITY
C I HAVE COMMENTED OUT THIS LINE. BVS 20.02.90
C       WRZNUM=EXP(STOR)
C ---
        WRZZ(I)=WRZNUM
        IF(WRZZ(I).GE.SC1) SC1=WRZZ(I)
        IF(WRZZ(I).LT.SC2) SC2=WRZZ(I)
        IZZ(I)=(I-1)*10
        AMCO=AMCO+WRZNUM*CPH(I)
        AMSI=AMSI+WRZNUM*SPH(I)
        SC3=SC3+COPH
        SC4=SC4+SIPH
        SUMPI=SUMPI+WRZNUM
        IF(WRZNUM.GT.AMIN) THEN
          AMIN=WRZNUM
          IMIN=I
        ENDIF
      ENDDO
C----------------------------------------------------
      SC=SC1-SC2
      IF(ABS(SC).LT.1.E-6) GO TO 600
C     SUMPI=(SUMPI-36.*SC2)/SC
C     AMCO=(AMCO-SC2*SC3)/SC
C     AMSI=(AMSI-SC2*SC4)/SC
      IF(ABS(AMCO).LT.1.E-6) GO TO 56
      PHIB=(ATAN (AMSI/AMCO))*57.29578

C      IF(PHIB)50,51,51

      IF(PHIB.LT.0.0) GO TO 50
      IF(PHIB.GT.0.0) GO TO 51
      GO TO 51

C   50 IF(AMSI) 55,55,52

   50 CONTINUE
      IF(AMSI.LT.0.0) GO TO 55
      IF(AMSI.GT.0.0) GO TO 52
      GO TO 55

   52   PHIB=PHIB+180.
        GOTO 53
   56   PHI=90.
        GO TO 51

C   51   IF(AMSI)54,53,53

   51 CONTINUE
      IF(AMSI.LT.0.0) GO TO 54
      IF(AMSI.GT.0.0) GO TO 53
      GO TO 53



   54   PHIB=PHIB+180.
        GOTO53

   55   PHIB=PHIB+360.
   53 CONTINUE

      IF(ABS(SUMPI).LT.1.E-6) GO TO 600
      PHI=FLOAT((IMIN-1)*10)
      COPH=AMCO/SUMPI
      SIPH=AMSI/SUMPI
      AAM=SQRT (COPH**2+SIPH**2)

C      IF(CENT.EQ.'Y') THEN
c        I1=PHIB/10.+1.5
c        IF(I1.GT.36) I1=I1-36
c        W1=WRZZ(I1)
c        I2=I1+18
c        IF(I2.GT.36) I2=I2-36
c        W2=WRZZ(I2)
c        SW=W1+W2
c        IF(ABS(SW).GT.1.E-6) THEN
c          AAM=W1/(W1+W2)
c        ELSE
c          AAM=0.0
c        ENDIF
c        COPH=AAM*COS(PHIB*3.1415926/180.)
c        SIPH=AAM*SIN(PHIB*3.1415926/180.)
c      ENDIF

      IF(IPRINT.NE.0) THEN
        IF(MOD(NRG,IPRINT).EQ.0) THEN
          CALL MSGDOC(MDOC,' -----------------------')
          WRITE(LINE,910) IH,IK,IL,PHI,PHIB,AAM,CENT
          CALL MSGDOC(MDOC,LINE)
  910     FORMAT('HKL:',3I3,
     *    ' PHMAX',F5.0,' PHBST',F5.0,' FOM',F7.4,' CENTRIC-',A1)
          SC=SUMPI
          DO     I=1,36
            IZZ(I)=(WRZZ(I)*89.0)/SC
          ENDDO
          WRITE(LINE,930) (IZZ(I),I=1,36),SC
          CALL MSGDOC(MDOC,LINE)
  930     FORMAT('P :',36I1,1X,' Pi*10/SC SC:',E12.4)
          ILIST=ILIST+3
          CALL LIST(ILIST,STOP_T)
          IF(ICOMB.NE.0) THEN
            SC1=-1.E30
            SC2= 1.E30
            SC3= 0.
            SC4= 0.
            SC = 0.
            DO     I=1,36
              STOR=DEGR(I)
              WRZNUM=EXP(STOR)
              WRZZ(I)=WRZNUM
              SC=SC+WRZNUM
              IF(WRZZ(I).GE.SC1) SC1=WRZZ(I)
              IF(WRZZ(I).LT.SC2) SC2=WRZZ(I)
            ENDDO
            DO     I=1,36
              IF(ABS(SC).GT.1.E-6) THEN
                IZZ(I)=(WRZZ(I)*89.0)/SC
              ELSE
                IZZ(I)=0
              ENDIF
            ENDDO
            WRITE(LINE,931) (IZZ(I),I=1,36),SC
            CALL MSGDOC(MDOC,LINE)
  931       FORMAT('P1:',36I1,1X,' Pi*10/SC SC:',E12.4)
            CALL LIST(ILIST,STOP_T)
            SC1=-1.E30
            SC2= 1.E30
            SC3= 0.
            SC4= 0.
            SC = 0.
            DO     I=1,36
              STOR=DEGRC(I)
              WRZNUM=EXP(STOR)
              WRZZ(I)=WRZNUM
              SC=SC+WRZNUM
              IF(WRZZ(I).GE.SC1) SC1=WRZZ(I)
              IF(WRZZ(I).LT.SC2) SC2=WRZZ(I)
            ENDDO
            DO     I=1,36
              IF(ABS(SC).GT.1.E-6) THEN
                IZZ(I)=(WRZZ(I)*89.0)/SC
              ELSE
                IZZ(I)=0
              ENDIF
            ENDDO
            WRITE(LINE,932) (IZZ(I),I=1,36),SC
            CALL MSGDOC(MDOC,LINE)
  932       FORMAT('P2:',36I1,1X,' Pi*10/SC SC:',E12.4)
            CALL LIST(ILIST,STOP_T)
          ENDIF
        ENDIF
      ENDIF
      A=AS
      B=BS
      C=CS
      D=DS
      RETURN
C============
C       IF(JCENT.EQ.1) THEN
C         COSA=(COPH*FAS+SIPH*FBS)/FS
C         IF(ABS(COSA).LT.0.999) GO TO 900
C       ENDIF
C============
C ---- TOTAL PROBABILITY ZERO
  600 PHI=0.
      PHIB=0.
      SIPH=0.
      COPH=0.
      AAM=0.
      AS=0.
      BS=0.
      CS=0.
      DS=0.
      RETURN
      END

      SUBROUTINE LIST(ILIST,STOP_T)
      CHARACTER MSG*1,STOP_T*1
C --------------------------------------
      IF(STOP_T.NE.'Y') RETURN
      ILIST=ILIST+1
      IF(ILIST.GE.20) THEN
        CALL DISPL_BL('TO CONTINUE TYPE "CR"')
        READ(*,'(A)') MSG
        ILIST=0
      ENDIF
      RETURN
      END

C -I-
      SUBROUTINE PHABCD(MDOC,NAMEN,NAMEF,NAMEPH,NAMEO,FACTOR
     * ,RESMIN,RESMAX,BOFF,BADD,CENT
     * ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ---------------------------------------------------------
C -P- PHABCD - calculates Henderickson/Lattman coefficients for Phase_calc
C              using Fobs and Fcalc.
C -S-
C              Probability of phase : 
C                P =  exp(-2*Fobs*Fcalc/E**2)  
C                 where E=rms(Fobs-Fcalc)*sqrt(2)/FACTOR, for non centric refls 
C                       E=rms(Fobs-Fcalc)/FACTOR        , for centric refls 
C                 FACTOR - takes into account incompleteness of the model.
C                          aprox. = Natom_model/Natoms_structure
C
C  Dialog and Batch: 
C
C  FILE_I:  input_file F_obs
C  FILE_F:  input_file F_calc
C  FILE_PH: input_file PH_calc
C  FILE_O:  output_file PHASE /" " means without output/'
C  RESOL:   MIN,MAX - resolution / default values from input_files /
C  BOFF:  <0> , 256 corresponds to RESmin=8A, 900 -> 15A.
C  BADD:  <0> 
C  CENT:   <A>/N/Y - use for calculation E : A - all refls, 
C                                            N - only acentric,
C                                            Y - only centric
C  FACTOR <1>   incompleteness of the model ( Natom_model/Natoms_structure )
C
C
C  Parameters of subroutine PHABCD: 
C
C      SUBROUTINE PHABCD(MDOC,NAMEN,NAMEF,NAMEPH,NAMEO,FACTOR
C     * ,RESMIN,RESMAX,BOFF,BADD,CENT,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    NAMEN  input_file F_obs
C    NAMEF  input_file F_calc
C    NAMEPH input_file PH_calc
C    NAMEO  output_file PHASE /" " means without output/'
C    RESMIN   MIN,MAX - resolution / default values from input_files /
C    RESMAX
C    BOFF   <0> , 256 corresponds to RESmin=8A, 900 -> 15A.
C    BADD   <0> 
C    CENT:   <A>/N/Y - use for calculation E : A - all refls, 
C                                              N - only acentric,
C                                             Y - only centric
C    FACTOR <1>   incompleteness of the model ( Natom_model/Natoms_structure )
C    ISYM    - integer*2 array for cryst.symmetry operators.
C    IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR    - output signal of error / = 1 -error , = 0 - OK / 
C
C        output information :
C
C -I-
C ---------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
      CHARACTER NAMEN*(*),NAMEF*(*),NAMEPH*(*),NAMEO*(*)
      INTEGER   NRGZ(11),NRMSZ(11)
      REAL      X(3),PRCP(6),RLATT(6)
      REAL      STL(11),RHR(11),AAMSZ(11),RMSZ(11),RFACZ(11),SUMFZ(11)
      CHARACTER TYPN*4,TYPP*4,TABC*4,TYPF*4,CENT*1
      CHARACTER TTT*80,LINE*80,TITLE*80
      CHARACTER MSG*1,MSG1*1
C========================================================================
      IERR  = 0
      MD    =-ABS(MDOC)-1
      M     = 99
      MT1  = 10
      TYPN  ='FF  '
      CALL ORFILE(MD,MT1,NAMEN,TYPN,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RN,RX,IDM1,IDM2,IDM3,IDM4,IDM5,TITLE,IERR)
      IF(IERR.NE.0) RETURN
      RLATT(1)=A
      RLATT(2)=B
      RLATT(3)=C
      RLATT(4)=AL
      RLATT(5)=BE
      RLATT(6)=GA
      CALL C_RD_CR
C ---------------------------------------------------------------------
      IERR  = 0
      MTF   = 11
      TYPF  ='FF  '
      CALL ORFILE(MD,MTF,NAMEF,TYPF,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RNN,RXX,IDM1,IDM2,IDM3,IDM4,IDM5,TTT,IERR)
      IF(IERR.NE.0) RETURN
C ----------------------------------------------------------------------
      MTPH  = 12
      TYPP  ='PH  '
      CALL ORFILE(MD,MTPH,NAMEPH,TYPP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RNN,RXX,IDM1,IDM2,IDM3,IDM4,IDM5,TTT,IERR)
      IF(IERR.NE.0) RETURN
C --------------------------------------------------------------------
      IF(CENT.EQ.'n') CENT='N'
      IF(CENT.EQ.'y') CENT='Y'
      IF(CENT.NE.'N'.AND.CENT.NE.'Y') CENT='A'
      IF(RESMIN.LE.0.0) RESMIN=RN      
      IF(RESMIN.GT.RN)  RESMIN=RN      
      IF(RESMAX.LT.RX ) RESMAX=RX
      IF(RESMIN.GT.RNN) RESMIN=RNN      
      IF(RESMAX.LT.RXX) RESMAX=RXX
      IF(RESMIN.LT.RESMAX) THEN
        T=RESMIN
        RESMIN=RESMAX
        RESMAX=T
      ENDIF
C ------------------------------------------------
      CALL INIT_CENTR(NSYM,ISYM)
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      RHMIN=1./RESMIN
      RHMAX=1./RESMAX
      DRANG=(RHMAX-RHMIN)/10.

      IF(FACTOR.LE.0.0) FACTOR=1.0
      PRCP(1)=AST*AST*0.25
      PRCP(2)=BST*BST*0.25
      PRCP(3)=CST*CST*0.25
      PRCP(4)=AST*BST*COGAST*0.25
      PRCP(5)=AST*CST*COBEST*0.25
      PRCP(6)=BST*CST*COALST*0.25

      IF(FACTOR.LE.0.0) FACTOR=1.0
C -------------------------------------------------
      CALL LENSTR_BL(NAMEO,LEN)
      MTOUT=0
      IF(LEN.GT.0.AND.NAMEO(1:1).NE.' '.AND.NAMEO(1:1).NE.',') THEN 
        MTOUT=13
        TABC ='ABCD'
        TITLE(1:4)='PHAS'
        TITLE(5:8)='ABCD'
        CALL C_CR_WR
        CALL SET_TITLE(MDOC,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM1,IDM2,IDM3,IDM4,IDM5,TITLE,IERR)
        CALL OWFILE(MDOC,MTOUT,NAMEO,TABC,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
      ENDIF    
C-----------------------------------------------------------------
C:::::::::::
C     WRITE(1,'(*$NSYM                                 :*)')
C     READ(1,*) NSYM

CCC      NSYM=1

C ----
      KKCENT=0
      IICENT=0
C     WRITE(1,*) '$KCENT (<0>-NO,1-ONLY,2-WITHOUT,3-ALL):'
C     READ(1,*) KKCENT
C     IF(KKCENT.NE.0) THEN
C       WRITE(1,*) '$ICENT (0-ALL,1-0KL,2-H0L,3-HK0,4-HHL,5-/1+2+3/) :'
C       READ(1,*) IICENT
C     ENDIF
C ---
C:::::::::::
      IEND1=-1
      IEND2=-1
      IEND3=-1
      IEND4=-1
      IEND =-1
      NUMB1=0
      NUMB2=0
      NUMB3=0
      NUMB4=0
      NUMBN=0
      NRG=0
      AAMS=0.
      FROQ=0.
      RMS=0.0
      NRMS=0.0
      RFAC=0.0
      SUMF=0.0
      DO     K=1,11
        AAMSZ(K)=0.
        NRMSZ(K)=0
        RFACZ(K)=0.
        RMSZ (K)=0.
        SUMFZ(K)=0.
        NRGZ (K)=0
      ENDDO
      JJH=-100
      JJK=-100
      JJL=-100
      JH1=-100
      JK1=-100
      JL1=-100
      JH2=-100
      JK2=-100
      JL2=-100
C-----------------------------------------------------------------
  23    CONTINUE
        IF(TYPN.EQ.'F   ') THEN
          CALL RD1(MT1,IH,IK,IL,FA,FB,NUMBN,IEND)
          SDA=0.04*FA
          SDB=0.04*FB
        ELSE
          CALL RRD1(MT1,IH,IK,IL,FA,FB,SDA,SDB,NUMBN,IEND)
        ENDIF
        IF(IEND.GT.0) GO TO 24
        IF(FA.GT.1.E-6.AND.FB.GT.1.E-6) THEN
          W1=1./(SDA*SDA)
          W2=1./(SDB*SDB)
          FNAT=(FA*W1+FB*W2)/(W1+W2)
          SD=1./SQRT(W1+W2)
        ELSE IF(FA.GT.1.E-6) THEN
          FNAT=FA
          SD=SDA
        ELSE IF(FB.GT.1.E-6) THEN
          FNAT=FB
          SD=SDB
        ENDIF
        CALL DSTAR_BL(IH,IK,IL,RSQ)
        RH=SQRT(RSQ)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 23
        SINTHL=RH/2.
 1750   IF(IEND3.GT.0) GO TO 24

C        IF(IL-JL1) 23,1710,1740
C 1710   IF(IK-JK1) 23,1720,1740
C 1720   IF(IH-JH1) 23,1730,1740

        IF(IL.LT.JL1) GO TO 23
        IF(IL.GT.JL1) GO TO 1740
        IF(IK.LT.JK1) GO TO 23
        IF(IK.GT.JK1) GO TO 1740
        IF(IH.LT.JH1) GO TO 23
        IF(IH.GT.JH1) GO TO 1740
        GO TO 1730
 
 1740   CONTINUE
          IF(TYPF.EQ.'F   ') THEN
            CALL RD2(MTF ,JH1,JK1,JL1,FA1,FB1,NUMB3,IEND3)
            SDA1=0.04*FA1
            SDB1=0.04*FB1
          ELSE
            CALL RRD2(MTF ,JH1,JK1,JL1,FA1,FB1,SDA1,
     .                 SDB1,NUMB3,IEND3)
          ENDIF
          IF(IEND3.GT.0) GO TO 1750
          IF(FA1.GT.1.E-6.AND.FB1.GT.1.E-6) THEN
            W1=1./(SDA1*SDA1)
            W2=1./(SDB1*SDB1)
            FCOMB=(FA1*W1+FB1*W2)/(W1+W2)
            SD1=1./SQRT(W1+W2)
          ELSE IF(FA1.GT.1.E-6) THEN
            FCOMB=FA1
            SD1  =SDA1
          ELSE IF(FB1.GT.1.E-6) THEN
            FCOMB=FB1
            SD1  =SDB1
          ENDIF
          GO TO 1750
1730    CONTINUE
        KRANG=(RH-RHMIN)/DRANG+1.
        IF(KRANG.GT.10) KRANG=10
        IF(KRANG.LT.1) KRANG=1
        NRMS=NRMS+1
        NRMSZ(KRANG)=NRMSZ(KRANG)+1
        IF(BOFF.GT.0.0) THEN
          BT=BOFF/4.0
          CBOFF=1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF=1.0
        ENDIF
        IF(BADD.GT.0.0) THEN
          BT=BADD/4.0
          CBADD=EXP(-BT*RSQ)
        ELSE
          CBADD=1.0
        ENDIF
        FC=FCOMB*CBADD*CBOFF
        FN=FNAT *CBADD*CBOFF
        DEL  = ABS(FC-FN)
        DEL2 = DEL*DEL
        SUMF = SUMF+FN
        RFAC = RFAC+DEL
        RMS  = RMS+DEL2
        RFACZ(KRANG)=RFACZ(KRANG)+DEL
        SUMFZ(KRANG)=SUMFZ(KRANG)+FNAT
        RMSZ(KRANG)=RMSZ(KRANG)+DEL2
        GO TO 23
C ----------------------------------------------
  24    CONTINUE
        RFAC=RFAC/SUMF
        RMS=SQRT(RMS/NRMS)
        RHR(1)=1./RHMIN
        STL(1)=RHMIN/2.
        DO     K=2,11
          K1=K-1
          STL(K)=STL(K-1)+DRANG/2.0
          RHR(K)=1./(STL(K)*2.)
          IF(NRMSZ(K1).GT.0) THEN
            RFACZ(K1)=RFACZ(K1)/SUMFZ(K1)
            RMSZ(K1)=SQRT(RMSZ(K1)/NRMSZ(K1))
          ELSE
            RMSZ(K1)=RMS
          ENDIF
        ENDDO
        WRITE(LINE,'('' R-FAC='',F10.5,'' RMS='',F10.5,'' N='',I8)')
     *      RFAC,RMS,NRMS
        CALL MSGDOC(MDOC,LINE)
C        WRITE(LINE,9150)  STL   
C        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,9151)  RHR
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,9154) (RFACZ(K),K=1,10)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,9153) (RMSZ(K),K=1,10)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,9152) (NRMSZ(K),K=1,10)
        CALL MSGDOC(MDOC,LINE)
C 9150   FORMAT('SINTH/LAM ',11(F5.3,1X))
 9151   FORMAT('ANGSTR    ',11F6.2)
 9152   FORMAT('N REFLS      ',11I6)
 9153   FORMAT('RMS           ',11(F5.1,1X))
 9154   FORMAT('R-FAC         ',11(F5.3,1X))
C ----------------------------------------------------------------
      CLOSE(MT1)
      CLOSE(MTF)
      CALL ORFILE(M,MT1,NAMEN,TYPN,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      CALL ORFILE(M,MTF,NAMEF,TYPF,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      IEND =-1
      IEND3=-1
      JK1=-100
      JL1=-100
      JH2=-100
      JK2=-100
      JL2=-100
C -----------------------------------
  200 CONTINUE
      IF(TYPN.EQ.'F   ') THEN
        CALL RD1(MT1,IH,IK,IL,FA,FB,NUMBN,IEND)
        SDA=0.04*FA
        SDB=0.04*FB
      ELSE
        CALL RRD1(MT1,IH,IK,IL,FA,FB,SDA,SDB,NUMBN,IEND)
      ENDIF
      IF(IEND.GT.0) GO TO 230
      IF(FA.GT.1.E-6.AND.FB.GT.1.E-6) THEN
        W1=1./(SDA*SDA)
        W2=1./(SDB*SDB)
        FNAT=(FA*W1+FB*W2)/(W1+W2)
        SD=1./SQRT(W1+W2)
      ELSE IF(FA.GT.1.E-6) THEN
        FNAT=FA
        SD=SDA
      ELSE IF(FB.GT.1.E-6) THEN
        FNAT=FB
        SD=SDB
      ENDIF
C ---
C      ICENT=2
C      JCENT=2
C      IF(KKCENT.NE.0) THEN
C        IF(IICENT.EQ.0)              JCENT=1
C        IF(IICENT.EQ.1.AND.IH.EQ.0)  JCENT=1
C        IF(IICENT.EQ.2.AND.IK.EQ.0)  JCENT=1
C        IF(IICENT.EQ.3.AND.IL.EQ.0)  JCENT=1
C        IF(IICENT.EQ.4.AND.IH.EQ.IK) JCENT=1
C        IF(IICENT.EQ.5.AND.(IH.EQ.0.OR.IK.EQ.0.OR.IL.EQ.0)) JCENT=1
C      ENDIF
C      IF(KKCENT.EQ.1.AND.JCENT.EQ.2) GO TO 200
C      IF(KKCENT.EQ.2.AND.JCENT.EQ.1) GO TO 200
      CALL CENTR_BL(IH,IK,IL,JCENT)
      KKCENT=0
      IF(CENT.EQ.'N') KKCENT=2
      IF(CENT.EQ.'Y') KKCENT=1
      IF(KKCENT.EQ.1.AND.JCENT.NE.1) GO TO 200
      IF(KKCENT.EQ.2.AND.JCENT.EQ.1) GO TO 200
      ICENT=JCENT
C ---
      CALL DSTAR_BL(IH,IK,IL,RSQ)
      RH=SQRT(RSQ)
      IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 200

      X(1)=IH
      X(2)=IK
      X(3)=IL
C --
  750 IF(IEND3.GT.0) GO TO 230

C      IF(IL-JL1) 200,710,740
C  710 IF(IK-JK1) 200,720,740
C  720 IF(IH-JH1) 200,730,740

      IF(IL.LT.JL1) GO TO 200
      IF(IL.GT.JL1) GO TO 740
      IF(IK.LT.JK1) GO TO 200
      IF(IK.GT.JK1) GO TO 740
      IF(IH.LT.JH1) GO TO 200
      IF(IH.GT.JH1) GO TO 740
      GO TO 730
 
  740 CONTINUE
      IF(TYPF.EQ.'F   ') THEN
        CALL RD2(MTF ,JH1,JK1,JL1,FA1,FB1,NUMB3,IEND3)
        SDA1=0.04*FA1
        SDB1=0.04*FB1
      ELSE
        CALL RRD2(MTF ,JH1,JK1,JL1,FA1,FB1,SDA1,
     .               SDB1,NUMB3,IEND3)
      ENDIF
      IF(IEND3.GT.0) GO TO 230
      IF(FA1.GT.1.E-6.AND.FB1.GT.1.E-6) THEN
        W1=1./(SDA1*SDA1)
        W2=1./(SDB1*SDB1)
        FCOMB=(FA1*W1+FB1*W2)/(W1+W2)
        SD1=1./SQRT(W1+W2)
      ELSE IF(FA1.GT.1.E-6) THEN
        FCOMB=FA1
        SD1  =SDA1
      ELSE IF(FB1.GT.1.E-6) THEN
        FCOMB=FB1
        SD1  =SDB1
      ENDIF
      GO TO 750

730   CONTINUE
      IF(IEND4.GT.0) GO TO 230

C      IF(IL-JL2) 200,770,790
C770   IF(IK-JK2) 200,780,790
C780   IF(IH-JH2) 200,795,790

      IF(IL.LT.JL2) GO TO 200
      IF(IL.GT.JL2) GO TO 790
      IF(IK.LT.JK2) GO TO 200
      IF(IK.GT.JK2) GO TO 790
      IF(IH.LT.JH2) GO TO 200
      IF(IH.GT.JH2) GO TO 790
      GO TO 795

790   CONTINUE
      CALL RD3(MTPH,JH2,JK2,JL2,ACOMB,BCOMB,NUMB4,IEND4)
      GO TO 730

795   CONTINUE
C ------------------
      NRG=NRG+1
      KRANG=(RH-RHMIN)/DRANG+1.
      IF(KRANG.GT.10) KRANG=10
      IF(KRANG.LT. 1) KRANG=1
C
C   I''VE INTRODUCED NEW "ERROR" FACTOR HERE BVS 20.02.90
C   WHICH TAKES INTO ACCOUNT INCOMPLETNESS OF THE MODEL
C      FACTOR = 0.3
C      ECOMB=SCCOMB * RMSZ(KRANG) / FACTOR
C
      ECOMB= RMSZ(KRANG)/FACTOR
      CALL CENTR_BL(IH,IK,IL,ICENT)
      IF(ICENT.EQ.1) THEN

      ELSE
        ECOMB=ECOMB*SQRT(2.0)
      ENDIF
      IF(BOFF.GT.0.0) THEN
        BT=BOFF/4.0
        CBOFF=1.0-EXP(-BT*RSQ)
      ELSE
        CBOFF=1.0
      ENDIF
      IF(BADD.GT.0.0) THEN
        BT=BADD/4.0
        CBADD=EXP(-BT*RSQ)
      ELSE
        CBADD=1.0
      ENDIF
      FC=FCOMB*CBADD*CBOFF
      FN=FNAT *CBADD*CBOFF
      CALL CALC_ABCD(MDOC,A,B,C,D,FC,ACOMB,BCOMB,ECOMB,FN)
C ------------------
      IF(MTOUT.GT.0) THEN
        NUMB2=0
        CALL WABCD(MTOUT,IH,IK,IL,A,B,C,D,NUMB2,IEND2)
      ENDIF
C ------------------
      GO TO 200
C-----------------------------------------------------------
  230 CONTINUE
      CLOSE(MT1)
      CLOSE(MTF)
      CLOSE(MTPH)
      IF(MTOUT.GT.0) THEN
        IEND2=2
        CALL WABCD(MTOUT,IH,IK,IL,A,B,C,D,NUMB2,IEND2)
        
      ENDIF
C --------------------------------------------
      CALL MSGDOC(MDOC,' ----------------------------')
      WRITE(LINE, 910) NRG
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ------------------------------------------------------------
  910 FORMAT(' WRITE NUMBER REFLS=',I6)
      END
 
      SUBROUTINE CALC_ABCD(MDOC,A,B,C,D
     * ,FCOMB,ACOMB,BCOMB,ECOMB,FNAT)
C-------------------------------------------------------------------
      X=(2.*FNAT*FCOMB)/(ECOMB*ECOMB)
      STR=SQRT(ACOMB*ACOMB+BCOMB*BCOMB)
      IF(STR.NE.0.0) THEN
        A=(X*ACOMB)/STR
        B=(X*BCOMB)/STR
        C=0.0
        D=0.0
      ELSE
        A=0.
        B=0.
        C=0.
        D=0.
      ENDIF
      RETURN
      END


      SUBROUTINE OMIT(MDOC,NAMEC,NAMEL,NAMEPT,NAMEPH,PATH_SCR
     * ,RESN,RESX,BOFF,BADD
     * ,NOMIT,NDX,NDY,NDZ,IDX,IDY,IDZ,COMB
     * ,POOL,MEMORY,ISYM,IPRSYM,RESULTD,RESULT,IPRROW,NCRDMAX,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      POOL(MEMORY)
C ----
      REAL      RESULT (IPRROW,IPRROW)
      REAL      RESULTD(IPRROW,IPRROW)
C ---
CMS      : POOL
      CHARACTER NAMEC*(*),NAMEL*(*),NAMEPT*(*),PATH_SCR*(*)
      CHARACTER NAMED*256,NAMEF*256,NAMEPH*(*),NAMEPHM*256
      CHARACTER NAMED2*256,NAME*256,NAMET*256,NAMEFM*256,NAMES*256

      CHARACTER P1*1,COMB*1,NAME_ABC_M*256,NAME_ABC*256,NAME_TTT*256
 
      CHARACTER LINE*80,TTT*80,ITYPE*4,LAP*1,MODE*1,ASYM*1,MSGF*1
      CHARACTER REST*1,RFAC_FLAG*1,MODE_F*4,STOP_T*1,CENT*1

C -------------------------------------------------------------
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        NAMEF     = PATH_SCR(1:LEN)// 'omit_f'
C        NAMEPH    = PATH_SCR(1:LEN)// 'omit_ph'
        NAMED     = PATH_SCR(1:LEN)// 'omit_dns'
        NAMED2    = PATH_SCR(1:LEN)// 'omit_scr'
        NAMEPHM   = PATH_SCR(1:LEN)// 'omit_ph_mod'
        NAMEFM    = PATH_SCR(1:LEN)// 'omit_f_scr'
        NAMES     = PATH_SCR(1:LEN)// 'omit_fscl'
        NAME_ABC_M= PATH_SCR(1:LEN)// 'omit_abc_m'
        NAME_ABC  = PATH_SCR(1:LEN)// 'omit_abc'
        NAME_TTT  = PATH_SCR(1:LEN)// 'omit_temp_ph'
      ELSE
        NAMEF     = 'omit_f'
C        NAMEPH    = 'omit_ph'
        NAMED     = 'omit_dns'
        NAMED2    = 'omit_scr'
        NAMEPHM   = 'omit_ph_mod'
        NAMEFM    = 'omit_f_scr'
        NAMES     = 'omit_fscl'
        NAME_ABC_M= 'omit_abc_m'
        NAME_ABC  = 'omit_abc'
        NAME_TTT  = 'omit_temp_ph'
      ENDIF
      NAMET     = ' '
C -------------------------------------------------------------
      IERR = 0
      MD   = -ABS(MDOC)-1
      M    = 99
C ------------------------------------------------------------
      IF(NOMIT.LT.0) RETURN
      MTN   = 14
      ITYPE = 'FF  '
      CALL ORFILE(MD,MTN,NAMEL,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
      CALL C_RD_CR
C ----
      IF(COMB .EQ.'y') COMB='Y'
      IF(COMB .NE.'Y') COMB='N'
      IF(NOMIT.EQ. 0 ) NOMIT=2
      IF(RESN .GT.0.0) RESMIN=RESN
      IF(RESX .GT.0.0) RESMAX=RESX
      R1 = RESMIN
      R2 = RESMAX
      DO I=1,IPRROW
      DO J=1,IPRROW
        RESULTD(I,J) = 0.0    
      ENDDO
      ENDDO
      IF(BOFF.LE.0.0) BOFF = 256.0
      IFIRST = 0
C -----------------------------------------------------------
      IERR =  0
      MT   = 10
      CALL ORCRD(M,MT,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN COORD_FILE')
        RETURN
      ENDIF
      CLOSE(MT)
C ------------------------------------------------
      CALL MSGDOC(MDOC,'--- genden ---')
      RAD   = 0.0
      H2OBG = 0.0
      BADDD = 0.0
      P1    = 'N' 
      NX    = 0
      NY    = 0
      NZ    = 0
      IZMAX = -1
      IZMIN = 0
      MODE  = ' '
      TTT   = ' '
      R2    = RESMAX
      CALL GENDEN(M,NAMEC,NAMED2,TTT
     * ,R2,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1
     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ----------------------------------------
      CALL MSGDOC(MDOC,'--- real fft ---')
      R2 = RESMAX
      CALL RFFT(M,POOL,MEMORY,R2
     * ,NAMED2,NAMEFM,NAMEPHM,PATH_SCR,ISYM,IPRSYM,RESULT
     * ,IERR)
      IF(IERR.NE.0) GO TO 900
C---------------------------------------
      MODE      = 'P'
      BADDD     = 0.0
      REST      = 'N'
      RFAC_FLAG = 'Y'
      CALL PSCALE(M,NAMEFM,NAMEL,NAMES
     * ,BOFF,BADDD,MODE,REST,RFAC_FLAG
     * ,R1,R2,ISYM,IPRSYM,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) GO TO 900
C      CORR_          =RESULT(17,3) 
C      RFAC_PATT      =RESULT(20,3)
C ---
      MODE_F = 'FMOD'
      STOP_T = 'N'
      R1     = RESMIN
      R2     = RESMAX
      ATOP   = 0.0
      IXL    = 0
      IYL    = 0
      IZL    = 0
      CALL FLSTAT(M,MODE_F,POOL,MEMORY,NAMEL,NAMES,BOFF,R1,R2
     * ,ATOP,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
      IF(IERR.NE.0) GO TO 900
      RFAC = RESULT(IPRROW,3)
      WRITE(LINE,'('' initial R-factor    : '',F6.4)')  RFAC
      CALL MSGDOC(MDOC,LINE)
      RESULTD(1,1) = NOMIT
      RESULTD(2,1) = RFAC
C ---------------------------------------
      IF(COMB.EQ.'Y') THEN
        CALL MSGDOC(MDOC,'--- phabcd /model/ ---')
        FACTOR = 1.0
        CENT   = 'A'
        R1     = RESMIN
        R2     = RESMAX
        CALL PHABCD(M,NAMEL,NAMES,NAMEPHM,NAME_ABC_M,FACTOR
     *   ,R1,R2,BOFF,BADD,CENT
     *   ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900
      ENDIF
C ---------------------------------------
      CALL LENSTR_BL(NAMEPT,LEN)
      IF(LEN.GT.0.AND.NAMEPT(1:1).NE.','.AND.NAMEPT(1:1).NE.' ') THEN
        MODE_F = 'ANGL'
        STOP_T = 'N'
        R1     = RESMIN
        R2     = RESMAX
        ATOP   = 0.0
        IXL    = 0
        IYL    = 0
        IZL    = 0
        CALL FLSTAT(M,MODE_F,POOL,MEMORY,NAMEPT,NAMEPHM,BOFF,R1,R2
     *  ,ATOP,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
        IF(IERR.NE.0) GO TO 900
        DELTA = RESULT(11,3)
        WRITE(LINE,'('' Delta_PH /with test/             : '',F7.2)')
     *  DELTA
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C ---------------------------------------
      NAMET=NAMEPHM

      DO ICYCLE=1,NOMIT

      WRITE(LINE,'(''--- Total omit map : cycle '',I2,'' ---'')')
     * ICYCLE
      CALL MSGDOC(MDOC,LINE)

      CALL MSGDOC(MDOC,'--- fft ---')
      NX     = 0
      NY     = 0
      NZ     = 0
      IZMIN  = 0
      IZMAX  = -1
      F000   = 0.0
      LAP    = 'N'
      ASYM   = 'N'
      SCALEC = 0.0
      NAME   = ' '
      R1     = RESMIN
      R2     = RESMAX
      CALL CFFT(M,LAP,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEL
     *  ,NAMED,NAMET,NAME,R1,R2,BADD,BOFF
     *  ,ASYM,SCALEC,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) GO TO 900
C ---
      MODE_F='DENS'
      STOP_T='N'
      R1=RESMIN
      R2=RESMAX
      ATOP=0.0 
      NAME =' '
      IXL=0
      IYL=0
      IZL=0
      NAME =' '
      CALL FLSTAT(M,MODE_F,POOL,MEMORY,NAMED,NAME,BOFF,R1,R2
     *  ,ATOP,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
      IF(IERR.NE.0) GO TO 900
      DRMS1 =RESULT(8,5) 
C ----------------------------
      CALL MSGDOC(MDOC,'--- modden ---')
C     MSGF   = 'C'
      MSGF   = 'U'
C     CONST1 = 0.0
      CONST1 = -DRMS1
      CONST2 = 0.0 
      NAME   = ' '
      CALL MODDEN(M,NAMED,NAME,NAMED2
     *    ,POOL,MEMORY,CONST1,CONST2,MSGF,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---------------------------
      IF(IFIRST.EQ.0) THEN
        R2 = RESMAX
        CALL RFFT(M,POOL,MEMORY,R2
     *  ,NAMED2,NAMEF,NAMEPH,PATH_SCR,ISYM,IPRSYM,RESULT,IERR)
        IF(IERR.GT.0) GO TO 900
C ----
        MODE      = 'P'
        BADDD     = 0.0
        REST      = 'N'
        RFAC_FLAG = 'Y'
        R1        = RESMIN
        R2        = RESMAX
        CALL PSCALE(M,NAMEF,NAMEL,NAMES
     *   ,BOFF,BADDD,MODE,REST,RFAC_FLAG
     *   ,R1,R2,ISYM,IPRSYM,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900
C       CORR_       = RESULT(17,3) 
C       RFAC_PATT   = RESULT(20,3)
C ---
        MODE_F = 'FMOD'
        STOP_T = 'N'
        R1     = RESMIN
        R2     = RESMAX
        ATOP   = 0.0
        IXL    = 0
        IYL    = 0
        IZL    = 0
        CALL FLSTAT(M,MODE_F,POOL,MEMORY,NAMEL,NAMES,BOFF,R1,R2
     *  ,ATOP,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
        IF(IERR.NE.0) GO TO 900
        RFAC=RESULT(IPRROW,3)
        WRITE(LINE,'('' R-factor(map without neg.values) : '',F6.4)') 
     *  RFAC
        CALL MSGDOC(MDOC,LINE)
C ---
        MODE_F = 'ANGL'
        STOP_T = 'N'
        R1     = RESMIN
        R2     = RESMAX
        ATOP   = 0.0
        IXL    = 0
        IYL    = 0
        IZL    = 0
        CALL FLSTAT(M,MODE_F,POOL,MEMORY,NAMEPH,NAMEPHM,BOFF,R1,R2
     *  ,ATOP,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
        IF(IERR.NE.0) GO TO 900
        DELTA = RESULT(11,3)
        WRITE(LINE,'('' Delta_PH                         : '',F7.2)')
     *  DELTA
        CALL MSGDOC(MDOC,LINE)
C ----
        RESULTD(3,1) = RFAC
        RESULTD(1,2) = DELTA
C ----
        IFIRST = 1
      ENDIF
C ----------------------------
      CALL MSGDOC(MDOC,'--- omit-map ---')
      IX =0
      IY =0
      IZ =0
      NDX=0
      NDY=0
      NDZ=0
      IDX=0
      IDY=0
      IDZ=0
      R1 =RESMIN
      R2 =RESMAX

      CALL OMIT_MAP(MDOC,NAMED2,NAMEL,NAMEPH,R1,R2,BOFF,BADD
     * ,NDX,NDY,NDZ,IDX,IDY,IDZ,NAMED,PATH_SCR
     * ,POOL,MEMORY,ISYM,IPRSYM,RESULT,IPRROW,IX,IY,IZ,IERR)
      IF(IERR.NE.0) GO TO 900
C ------------------------------------
      CALL MSGDOC(MDOC,'--- rft --- ')
      R2=RESMAX
      CALL RFFT(M,POOL,MEMORY,R2
     *  ,NAMED,NAMEF,NAMEPH,PATH_SCR,ISYM,IPRSYM,RESULT,IERR)
      IF(IERR.GT.0) GO TO 900
C ----
      MODE='P'
      BADDD=0.0
      REST='N'
      RFAC_FLAG='Y'
      R1=RESMIN
      R2=RESMAX
      CALL PSCALE(M,NAMEF,NAMEL,NAMES
     * ,BOFF,BADDD,MODE,REST,RFAC_FLAG
     * ,R1,R2,ISYM,IPRSYM,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) GO TO 900
C      CORR_          =RESULT(17,3) 
C      RFAC_PATT      =RESULT(20,3)
C ---
      MODE_F='FMOD'
      STOP_T='N'
      R1=RESMIN
      R2=RESMAX
      ATOP=0.0
      IXL=0
      IYL=0
      IZL=0
      CALL FLSTAT(M,MODE_F,POOL,MEMORY,NAMEL,NAMES,BOFF,R1,R2
     * ,ATOP,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
      IF(IERR.NE.0) GO TO 900
      RFAC=RESULT(IPRROW,3)
      WRITE(LINE,'('' R-factor            : '',F6.4)')  RFAC
      CALL MSGDOC(MDOC,LINE)
C ---------------------------------------
      IF(COMB.EQ.'Y') THEN
        MODE_F='ANGL'
        STOP_T='N'
        R1=RESMIN
        R2=RESMAX
        ATOP=0.0
        IXL=0
        IYL=0
        IZL=0
        CALL FLSTAT(M,MODE_F,POOL,MEMORY,NAMEPH,NAMEPHM,BOFF,R1,R2
     *  ,ATOP,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
        IF(IERR.NE.0) GO TO 900
        DELTA=RESULT(11,3)
        WRITE(LINE,'('' Delta_PH /omit/     : '',F7.2)') DELTA
        CALL MSGDOC(MDOC,LINE)
C ---
        CALL MSGDOC(MDOC,'--- phabcd  ---')
        FACTOR=1.0
        CENT='A'
        R1=RESMIN
        R2=RESMAX
        CALL PHABCD(M,NAMEL,NAMES,NAMEPH,NAME_ABC,FACTOR
     *  ,R1,R2,BOFF,BADD,CENT
     *  ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900
C ---
        CALL MSGDOC(MDOC,'--- abcdph /comb / ---')

        IPRINT =0
        STOP_T ='N'
        NAME   =' '
        SCCOMB =0.0
        R1=RESMIN
        R2=RESMAX
        CALL ABCDPH(M,NAME_ABC,NAME_ABC_M,NAME_TTT,NAME,SCCOMB
     *   ,R1,R2,IPRINT,STOP_T
     *   ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C       RESULT(1) - number of refls /in output file/
C       RESULT(2) - <FOM>
        IF(IERR.NE.0) GO TO 900
        WRITE(LINE,'(''figure-of-merit      :'',F10.3)')
     *               RESULT(2,1)
        CALL MSGDOC(MDOC,LINE)

        NAMET=NAME_TTT
      ELSE
        NAMET=NAMEPH
      ENDIF
C ---------------------------------------
      MODE_F='ANGL'
      STOP_T='N'
      R1=RESMIN
      R2=RESMAX
      ATOP=0.0
      IXL=0
      IYL=0
      IZL=0
      CALL FLSTAT(M,MODE_F,POOL,MEMORY,NAMET,NAMEPHM,BOFF,R1,R2
     * ,ATOP,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
      IF(IERR.NE.0) GO TO 900
      DELTA=RESULT(11,3)
      WRITE(LINE,'('' Delta_PH            : '',F7.2)') DELTA
      CALL MSGDOC(MDOC,LINE)
C ----
        IND=(ICYCLE*3)
        IF(IND.GT.18) IND=18
        RESULTD(IND+1,1)=RFAC
        RESULTD(IND+2,1)=DELTA
        RESULTD(IND+3,1)=0.0
C ---------------------------------------
      CALL LENSTR_BL(NAMEPT,LEN)
      IF(LEN.GT.0.AND.NAMEPT(1:1).NE.','.AND.NAMEPT(1:1).NE.' ') THEN
        MODE_F='ANGL'
        STOP_T='N'
        R1=RESMIN
        R2=RESMAX
        ATOP=0.0
        IXL=0
        IYL=0
        IZL=0
        CALL FLSTAT(M,MODE_F,POOL,MEMORY,NAMEPT,NAMET,BOFF,R1,R2
     *  ,ATOP,IXL,IYL,IZL,STOP_T,ISYM,IPRSYM,RESULT,IPRROW,IERR)  
        IF(IERR.NE.0) GO TO 900
        DELTA=RESULT(11,3)
        WRITE(LINE,'('' Delta_PH /with test/             : '',F7.2)')
     *  DELTA
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C ---------------------------------------
C ----
      ENDDO

  900 RETURN
      END

      SUBROUTINE OMIT_MAP(MDOC,NAMED,NAMEL,NAMEPH,RESN,RESX,BOFF,BADD
     * ,NDX,NDY,NDZ,IDX,IDY,IDZ,NAMEO,PATH_SCR
     * ,POOL,MEMORY,ISYM,IPRSYM,RESULT,IPRROW,IX,IY,IZ,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      POOL(MEMORY)
C ----
      REAL      RESULT(IPRROW,IPRROW)
C ---
CMS      : POOL
      CHARACTER NAMED*(*),NAMEO*(*),NAMEL*(*),PATH_SCR*(*)
      CHARACTER NAMEF*256,NAMEPH*(*),NAMET*256,NAMEC*256
      CHARACTER NAME1*256,NAME2*256,NAME3*256
      CHARACTER NAMES1*256,NAMES2*256,NAME*256
      CHARACTER MSGA*1

      CHARACTER LINE*80,TTT*80,ITYPE*4,LAP*1,ASYM*1
C -------------------------------------------------------------
      NCREST=MEMORY 
      NCRES=MEMORY/2
      NCRS2=NCRES/2 
      IERR=0
      MD = -ABS(MDOC)-1
      M  = 99
      ITYPED =0
      MTIN1  =10
      CALL IRDENS(MTIN1,NAMED,M,ITYPED,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     * IZMIN1,RMAX1,RMIN1,POOL,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS
     * ,RAVER,RESOL,IX01,IY01,IZ01,ITR1,TTT,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-DENS')
        RETURN
      ENDIF
      CLOSE(MTIN1)
      NXY1=NX1*NY1
      IF(NXY1.GT.NCRES) THEN
        WRITE(LINE,'('' ERR: not memory '',I4,'' x'',I4,'' >'',I8)')
     *             NX1,NY1,NCRES
        CALL MSGERR(MDOC,LINE)
        RETURN
      ENDIF
C--------------------------------------
      IERR=0
      MTN  =14
      MD=-ABS(MDOC)-1
      ITYPE='FF  '
      CALL ORFILE(M,MTN,NAMEL,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS')
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
C ----
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        NAME3 = PATH_SCR(1:LEN)//'omit_cl_scr'
        NAMET = PATH_SCR(1:LEN)//'omit_d1_scr'
        NAMEF = PATH_SCR(1:LEN)//'omit_fm_scr'
C        NAMEPH= PATH_SCR(1:LEN)//'omit_ph_scr'
        NAMEC = PATH_SCR(1:LEN)//'omit_cf_scr'
        NAME2 = PATH_SCR(1:LEN)//'omit_d2_scr'
        NAME1 = PATH_SCR(1:LEN)//'omit_map_dns'
      ELSE
        NAME3 ='omit_cl_scr'
        NAMET ='omit_d1_scr'
        NAMEF ='omit_fm_scr'
C        NAMEPH='omit_ph_scr'
        NAMEC ='omit_cf_scr'
        NAME2 ='omit_d2_scr'
        NAME1 ='omit_map_dns'
      ENDIF
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0.OR.NAMEO(1:1).EQ.','.OR.NAMEO(1:1).EQ.',') THEN
C        NAME1 ='omit_map_dns'
      ELSE
        NAME1=NAMEO
      ENDIF
C ----
C      WRITE(LINE,'(''RESOLUTIOM MIN,MAX <'',2F7.2,''> :'')') 
C     *  RESMIN,RESMAX
C ------------------------------------------------
      IF(RESN.GT.0.0) RESMIN=RESN
      IF(RESX.GT.0.0) RESMAX=RESX
      IF(RESMIN.LT.RESMAX) THEN
        T=RESMIN
        RESMIN=RESMAX
        RESMAX=T
      ENDIF
C ---
      NAMES1=NAME1
      NAMES2=NAME2
      IFLS=1
C ---
      IF(NDX.LE.0) NDX=4
      IF(NDY.LE.0) NDY=4
      IF(NDZ.LE.0) NDZ=4
      IF(IDX.LE.0) IDX=2
      IF(IDY.LE.0) IDY=2
      IF(IDZ.LE.0) IDZ=2
C ---
      IF(IX.GT.0.AND.IY.GT.0.AND.IZ.GT.0) THEN
        IXS=IX-1
        IXF=IX-1
        IYS=IY-1
        IYF=IY-1
        IZS=IZ-1
        IZF=IZ-1
      ELSE
        IXS=0
        IXF=NDX-1
        IYS=0
        IYF=NDY-1
        IZS=0
        IZF=NDZ-1
      ENDIF
      DO    IX=IXS,IXF
      DO    IY=IYS,IYF
      DO    IZ=IZS,IZF
        IZMINS=(NZ1/NDZ)*IZ
        IZMAXS=(NZ1/NDZ)*(IZ+1)
        IF(IZMINS.LT.IZMAX1.AND.IZMAXS.GT.IZMIN1) THEN
          WRITE(LINE,'(A,3I5)') ' -- STEP ---> ',IX,IY,IZ
          CALL MSGDOC(MDOC,LINE)
C ----
          CALL MSGDOC(M,'     --- CLEAN --- ')
          CALL CLEAN(M,NAMED,NAME3,NDX,NDY,NDZ
     *    ,IX,IY,IZ,IDX,IDY,IDZ,POOL(1),POOL(NCRES+1),NCRES
     *          ,ISYM,IPRSYM,IERR)
          IF(IERR.GT.0) GO TO 900
C ----
          CALL MSGDOC(M, '     --- RFT    --- ')
          CALL RFFT(M,POOL,MEMORY,RESMAX
     *    ,NAME3,NAMEF,NAMEPH,PATH_SCR,ISYM,IPRSYM,RESULT,IERR)
          IF(IERR.GT.0) GO TO 900
C ---------
          CALL MSGDOC(M,'     --- FFT    --- ')
          NX=0
          NY=0
          NZ=0
          IZMIN=0
          IZMAX=-1
          F000=0.0
          LAP ='N'
          ASYM='N'
          SCALEC=0.0
          RESMIN=0.0
          RESMAX=0.0
          BBOFF=0.0
          BBADD=0.0
          NAME=' '
          CALL CFFT(M,LAP,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEL
     *    ,NAMET,NAMEPH,NAME,RESMIN,RESMAX,BBADD,BBOFF
     *    ,ASYM,SCALEC,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
          IF(IERR.GT.0) GO TO 900
C -----------
          CALL MSGDOC(M,'     --- DNSUM   --- ')
          CALL DNSUM(M,NAMET,NAMES1,NAMES2,NDX,NDY,NDZ,IFLS
     *    ,IX,IY,IZ,POOL(1),POOL(NCRS2+1),POOL(NCRES+1),NCRES
     *          ,ISYM,IPRSYM,IERR)
          IF(IERR.GT.0) GO TO 900
          IFLS=2
          NAME  =NAMES1
          NAMES1=NAMES2
          NAMES2=NAME
        ENDIF
C ----
      ENDDO
      ENDDO
      ENDDO
C ----
  900 RETURN
      END

      SUBROUTINE CLEAN(MDOC,NAMED,NAMEO,NDX,NDY,NDZ
     *          ,IXD,IYD,IZD,IDX,IDY,IDZ,IPOOLA,POOLC,NCRES
     *          ,ISYM,IPRSYM,IERR)
C--------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
CMS      : IPOOLA,POOLC
      INTEGER*2 IPOOLA(NCRES)
      REAL      POOLC(NCRES)
      CHARACTER NAMED*(*),NAMEO*(*)
      CHARACTER TTT1*80
      CHARACTER TTTW*80,TYPE*4
C ----------------------------------------------------------------------
      IERR=0
C--------------------------------------
C     READ OF TITLE OF FILE-1
C
      ITYPE  = 0
      MTIN1  =10
      MD=-ABS(MDOC)-1
      CALL IRDENS(MTIN1,NAMED,MD,ITYPE,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     * IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,
     * DRMS,RAVER,RESOL,IX01,IY01,IZ01,ITR1,TTT1
     * ,NSYM,ISYM,IPRSYM,IERR)
      NXY1=NX1*NY1
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: INPUT-FILE-DENS')
        IERR=1
        RETURN
      ENDIF
      IF(NXY1.GE.NCRES) THEN
        CALL MSGERR(MMDOC,' ERR: NOT MEMORY')
        IERR=1
        CLOSE(MTIN1)
        RETURN
      ENDIF
      CALL C_RD_CR
      IXMIN1=0
      IXMAX1=NX1-1
      IYMIN1=0
      IYMAX1=NY1-1
      IX0W=IX01
      IY0W=IY01
      IZ0W=IZ01
      TTTW=TTT1
C --------------------------------------
      IXMINS=(NX1/NDX)*IXD
      IXMAXS=(NX1/NDX)*(IXD+1)
      IYMINS=(NY1/NDY)*IYD
      IYMAXS=(NY1/NDY)*(IYD+1)
      IZMINS=(NZ1/NDZ)*IZD
      IZMAXS=(NZ1/NDZ)*(IZD+1)
      IZMN=IZMINS-IDZ
      IZMX=IZMAXS+IDZ
      IXMN=IXMINS-IDX
      IXMX=IXMAXS+IDX
      IYMN=IYMINS-IDY
      IYMX=IYMAXS+IDY
C ---------------------
      ALW=AL1
      BEW=BE1
      GAW=GA1
      AW =A1
      BW =B1
      CW =C1
      NXW=NX1
      NYW=NY1
      NZW=NZ1
      IXMINW=0
      IXMAXW=NXW-1
      IYMINW=0
      IYMAXW=NYW-1
      IZMINW=IZMIN1
      IZMAXW=IZMAX1
      IXMINS=IXMINS-IDX
      IXMAXS=IXMAXS+IDX
      IYMINS=IYMINS-IDY
      IYMAXS=IYMAXS+IDY
C--------------------------------------------------------
      MTS      =12
      TTTW(1:4)='CLEA'
      TTTW(5:8)='N   '
      TYPE     ='RI  '
      MD=-ABS(MDOC)-1      
      CALL C_CR_WR

      CALL SET_TITLE(MD,AW,BW,CW,ALW,BEW,GAW
     *  ,DDM,DDM,DDM,DDM,NXW,NYW,NZW,IZMINW,IZMAXW,TTTW,IERR)

C      CALL WTITLE(MTS,NAMEO,MMDOC,TYPE,IPRINT,AW,BW,CW,ALW,BEW,GAW
C     *  ,DDM,DDM,DDM,DDM,NXW,NYW,NZW,IZMINW,IZMAXW,TTTW)

      CALL OWFILE(MD,MTS,NAMEO,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN OUTPUT-FILE-DENS')
        CLOSE(MTIN1)
        RETURN
      ENDIF
C---------------------------------------------------------------
      ICNTZ3=-999
      ITYPE=1
      MD=-ABS(MDOC)-1
C---------------------------------------------------------------
      DO     IZ=IZMIN1,IZMAX1
        Z=IZ/FLOAT(NZ1)
C-----------------------
        CALL IRDENS(MTIN1,NAMED,MD,ITYPE,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     *  IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,
     *  DRMS,RAVER,RESOL,IX01,IY01,IZ01,ITR1,TTT1
     *  ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ INPUT-FILE-DENS')
          CLOSE(MTS)
          RETURN
        ENDIF
C-----------------------
        DO     IY=IYMINW,IYMAXW
          Y=IY/FLOAT(NY1)
          IND0 =IY*NX1
          INDD0=IND0
          DO     IX=IXMINW,IXMAXW
            X=IX/FLOAT(NX1)
            IND =IND0+IX+1
            INDD=IND
            D1=IPOOLA(IND)/SCALE1
            DOUT=D1
            CALL CHECKD(IX,IY,IZ,NX1,NY1,NZ1,IXMN,IXMX,IYMN,IYMX,
     *                  IZMN,IZMX,NSYM,ISYM,IPRSYM,ID)
            IF(ID.LE.0) DOUT=0.0
            POOLC(INDD)=DOUT
          ENDDO
        ENDDO
C---------------------
        CALL WDENS(MTS,MD,ICNTZ3,NXW,NYW,NZW,IZMINW,IZMAXW,
     *             RMAXD,RMIND,POOLC,RESOL,IX01,IY01,IZ01,ITR1)
        IF(MTS.LE.0) THEN
          CALL MSGERR(MD,' ERR: OUTPUT-FILE-DENS')
          IERR=1
          CLOSE(MTIN1)
          RETURN
        ENDIF
C---ZZZZZZZZZ----------
      ENDDO
C---------------------
      CLOSE(MTIN1)
      CLOSE(MTS)
      RETURN
      END

      SUBROUTINE CHECKD(IX,IY,IZ,NX1,NY1,NZ1,IXMN,IXMX,IYMN,IYMX,
     *                  IZMN,IZMX,NSYM,ISYM,IPRSYM,ID)
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---------------------------------------------------------------
      ID=1
      IXMN1=IXMN-NX1
      IXMN2=IXMN+NX1
      IYMN1=IYMN-NY1
      IYMN2=IYMN+NY1
      IZMN1=IZMN-NZ1
      IZMN2=IZMN+NZ1
      IXMX1=IXMX-NX1
      IXMX2=IXMX+NX1
      IYMX1=IYMX-NY1
      IYMX2=IYMX+NY1
      IZMX1=IZMX-NZ1
      IZMX2=IZMX+NZ1
      DO     I=1,NSYM
        IXS=ISYM(1,1,I)*IX+ISYM(2,1,I)*IY+ISYM(3,1,I)*IZ+
     *      (ISYM(4,1,I)*NX1)/ISYM(5,1,I)
        IYS=ISYM(1,2,I)*IX+ISYM(2,2,I)*IY+ISYM(3,2,I)*IZ+
     *      (ISYM(4,2,I)*NY1)/ISYM(5,2,I)
        IZS=ISYM(1,3,I)*IX+ISYM(2,3,I)*IY+ISYM(3,3,I)*IZ+
     *      (ISYM(4,3,I)*NZ1)/ISYM(5,3,I)
        IF((IZS.GE.IZMN .AND.IZS.LE.IZMX ).OR.
     *     (IZS.GE.IZMN1.AND.IZS.LE.IZMX1).OR.
     *     (IZS.GE.IZMN2.AND.IZS.LE.IZMX2)    ) THEN
          IF((IYS.GE.IYMN .AND.IYS.LE.IYMX ).OR.
     *       (IYS.GE.IYMN1.AND.IYS.LE.IYMX1).OR.
     *       (IYS.GE.IYMN2.AND.IYS.LE.IYMX2)    ) THEN
            IF((IXS.GE.IXMN .AND.IXS.LE.IXMX ).OR.
     *         (IXS.GE.IXMN1.AND.IXS.LE.IXMX1).OR.
     *         (IXS.GE.IXMN2.AND.IXS.LE.IXMX2)    ) THEN
              ID=0
              RETURN
            ENDIF
          ENDIF
        ENDIF
      ENDDO
      RETURN
      END

      SUBROUTINE DNSUM(MDOC,NAMEI,NAMED,NAMEO,NDX,NDY,NDZ
     *          ,IFLS,IXD,IYD,IZD,IPOOLA,IPOOLB,POOLC,NCRES
     *          ,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM) 
CMS      : IPOOLA,POOLC,IPOOLB
      INTEGER*2 IPOOLA(NCRES),IPOOLB(NCRES)
      REAL      POOLC(NCRES)
      CHARACTER TTT1*80,TTT2*80
      CHARACTER TTTW*80,TYPE*4
      CHARACTER NAMEI*(*),NAMED*(*),NAMEO*(*)
C ----------------------------------------------------------------------
      IERR=0
C--------------------------------------
C     NSYM=1
C--------------------------------------
C     READ OF TITLE OF FILE-1
C
      ITYPE  = 0
      MTIN1  =10
      MD=-ABS(MDOC)-1
C     '      INPUT FILE /DENS/ '
      CALL IRDENS(MTIN1,NAMEI,MD,ITYPE,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     * IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,
     * DRMS,RAVER,RESOL,IX01,IY01,IZ01,ITR1,TTT1
     * ,NSYM,ISYM,IPRSYM,IERR)
      NXY1=NX1*NY1
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: INPUT-FILE-DENS')
        IERR=1
        RETURN
      ENDIF
      CALL C_RD_CR
      IXMIN1=0
      IXMAX1=NX1-1
      IYMIN1=0
      IYMAX1=NY1-1
      IX0W=IX01
      IY0W=IY01
      IZ0W=IZ01
      TTTW=TTT1
C --------------------------------------
      MTIN2=0
      IF(IFLS.EQ.2) THEN
        ITYPE = 0
        MTIN2 =20
        MD=-ABS(MDOC)-1
C       '      INPUT FILE /DENS/ - SUM'
        CALL IRDNS2(MTIN2,NAMED,MD,ITYPE,ICNTZ2,NX2,NY2,NZ2,IZMAX2,
     *  IZMIN2,RMAX2,RMIN2,IPOOLB,SCALE2,A2,B2,C2,AL2,BE2,GA2,
     *  DRMS,RAVER,RESOL,IX02,IY02,IZ02,ITR2,TTT2
     *  ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: INPUT-FILE-DENS-SUM')
          CLOSE(MTIN1)
          IERR=1
          RETURN
        ENDIF
        NXY2=NX2*NY2
      ENDIF
C  -----------------
      ALW=AL1
      BEW=BE1
      GAW=GA1
      AW =A1
      BW =B1
      CW =C1
      NXW=NX1
      NYW=NY1
      NZW=NZ1
      IXMINW=0
      IXMAXW=NXW-1
      IYMINW=0
      IYMAXW=NYW-1
      IZMINW=IZMIN1
      IZMAXW=IZMAX1
C ---
      IXMINS=(NX1/NDX)*IXD
      IXMAXS=(NX1/NDX)*(IXD+1)
      IYMINS=(NY1/NDY)*IYD
      IYMAXS=(NY1/NDY)*(IYD+1)
      IZMINS=(NZ1/NDZ)*IZD
      IZMAXS=(NZ1/NDZ)*(IZD+1)
C--------------------------------------------------------
      TTTW=TTT1
      MTS      =12
      TTTW(1:4)='SUM '
      TTTW(5:8)='    '
      TYPE     ='RI  '
C    '      OUTPUT-FILE'
      CALL C_CR_WR

      CALL SET_TITLE(MD,AW,BW,CW,ALW,BEW,GAW
     *  ,DDM,DDM,DDM,DDM,NXW,NYW,NZW,IZMINW,IZMAXW,TTTW,IERR)

      CALL OWFILE(MD,MTS,NAMEO,TYPE,NSYM,ISYM,IPRSYM,IERR)

C      CALL WTITLE(MTS,NAMEO,MMDOC,TYPE,IPRINT,AW,BW,CW,ALW,BEW,GAW,DDM,
C     * DDM,DDM,DDM,NXW,NYW,NZW,IZMINW,IZMAXW,TTTW)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OUTPUT-FILE-DENS')
        IERR=1
        CLOSE(MTIN1)
        CLOSE(MTIN2)
        RETURN
      ENDIF
C---------------------------------------------------------------
      ICNTZ3=-999
      ITYPE=1
      MD=-ABS(MDOC)-1
C---------------------------------------------------------------
      DO     IZ=IZMIN1,IZMAX1
        Z=IZ/FLOAT(NZ1)
C-----------------------
      CALL IRDENS(MTIN1,NAMEI,MD,ITYPE,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     *  IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,
     *  DRMS,RAVER,RESOL,IX01,IY01,IZ01,ITR1,TTT1
     *  ,NSYM,ISYM,IPRSYM,IERR)

        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: INPUT-FILE-DENS')
          IF(MTIN2.GT.0) CLOSE(MTIN2)
          IERR=1
          RETURN
        ENDIF
        IF(MTIN2.GT.0) THEN
          CALL IRDNS2(MTIN2,NAMED,MD,ITYPE,ICNTZ2,NX2,NY2,NZ2,IZMAX2,
     *    IZMIN2,RMAX2,RMIN2,IPOOLB,SCALE2,A2,B2,C2,AL2,BE2,GA2,
     *    DRMS,RAVER,RESOL,IX02,IY02,IZ02,ITR2,TTT2
     *    ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: INPUT-FILE-DENS-SUM')
            CLOSE(MTIN1)
            IERR=1
            RETURN
          ENDIF
        ENDIF
C-----------------------
        DO     IY=IYMINW,IYMAXW
          IYY=IY
          Y=IY/FLOAT(NY1)
          IND0 =IY*NX1
          INDD0=IND0
          DO     IX=IXMINW,IXMAXW
            X=IX/FLOAT(NX1)
            IXX=IX
            IND =IND0+IX+1
            INDD=IND
            D1=IPOOLA(IND)/SCALE1
            IF(MTIN2.GT.0) THEN
              D2=IPOOLB(IND)/SCALE2
            ELSE
              D2=0.0
            ENDIF
            IF((IX.GE.IXMINS.AND.IX.LE.IXMAXS).AND.
     *         (IY.GE.IYMINS.AND.IY.LE.IYMAXS).AND.
     *         (IZ.GE.IZMINS.AND.IZ.LE.IZMAXS)     ) THEN
              DOUT=D1
            ELSE
              DOUT=D2
            ENDIF
            POOLC(INDD)=DOUT
C----XXXX---YYYY-------
  500       CONTINUE
          ENDDO
  400     CONTINUE
        ENDDO
C---------------------
      CALL WDENS(MTS,MD,ICNTZ3,NXW,NYW,NZW,IZMINW,IZMAXW,
     *             RMAXD,RMIND,POOLC,RESOL,IX01,IY01,IZ01,ITR1)
        IF(MTS.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: OUTPUT-FILE-DENS')
          IERR=1
          CLOSE(MTIN1)
          IF(MTIN2.GT.0) CLOSE(MTIN2)
          RETURN
        ENDIF
  300 CONTINUE
C---ZZZZZZZZZ----------
      ENDDO
C----------------------
  100 CONTINUE
C----------------------
      IF(MTIN1.GT.0) CLOSE(MTIN1)
      IF(MTIN2.GT.0) CLOSE(MTIN2)
      IF(MTS.GT.0) CLOSE(MTS)
      RETURN
      END

C -I-
      SUBROUTINE GRAD_X(MDOC,NAMEC,NAMED,NAMEM,NAMEO,NAMEE
     * ,BADD,SCALEF,BADDF,DISPFR,GRAD
     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C -P- GRAD_X:  calculates the gradients for atomic model from diff. map.
C -S-
C
C  Dialog and Batch: 
C
C    FILE_C -  input file of coordinates.
C    FILE_D -  input file of observed density
C    FILE_M -  input file of density of model
C    FILE_O -  output file of gradients.
C    FILE_E -  output file of some indicators.
C    BADD:  -  <0.0> additional B-factor /default are for SF calculation/
C
C  Parameters of subroutine GRAD_X: 
C
C      SUBROUTINE GRAD_X(MDOC,NAMEC,NAMED,NAMEM,NAMEO,NAMEE
C     * ,BADD,SCALEF,BADDF,DISPFR
C     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    MODE   - see above. / character*1 /
C    NAMEC  - name of input file without extention "crd".
C    NAMED  - name of input file of density.
C    NAMEM  -
C    NAMEO  -
C    NAMEE  -
C    BADD  -  <0.0> additional B-factor /default are for SF calculation/
C    NCRDMAX - maximal number of atoms.
C    POOL    - real array POOL(MEMORY)
C    MEMORY  - dimension array POOL. 
C              MEMORY = MAPMAX + (NCRDMAX/2)*5 , were MAPMAX - maximal
C                                                size of XY-section ( NX*NY)
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C
C        output information 
C
C
C      RESULT(1)  =CFVOL
C      RESULT(2)  =COEF
C      RESULT(3)  =SIGMA
C      RESULT(4)  =SIGMAD  
C      RESULT(5)  =SCALEF
C      RESULT(6)  =BADD
C      RESULT(7)  =SHESSX
C      RESULT(8)  =SHESSD
C      RESULT(9)  =DRV_RMS
C      RESULT(10) =SHFT_RMS
C      RESULT(11) =DISPFR
C -I-
C ----------------------------------------------------------
CMS      : POOL
      REAL             POOL(MEMORY)
      INTEGER*2        ISYM(5,3,IPRSYM)
C---------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),NAMEM*(*),NAMEO*(*),P1*1,POSITIV*1
      CHARACTER MODE*1,GRAD*1,PRINT*1,NAMEE*(*)
C==================================================================
      REAL RESULT(IPRROW)
C ----------------------------------------
C --- integer*2 version
C --- NCRDMAX =< 32767
C     IF(NCRDMAX.GT.32767) THEN 
C       CALL MSGERR(MDOC
C    *  ,' ERR: for integer*2 version max number of atoms =< 32767 ')
C       IERR=1
C       RETURN
C     ENDIF     
C     IPRCRD  = (NCRDMAX/2)*28 
C --- integer*4 version
      IPRCRD  = (NCRDMAX)*18 
C ---
      IPRMAP = ((MEMORY-IPRCRD)/4)*4
      IF(IPRMAP.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: NOT MEMORY FOR DENSITY')
        IERR=1
        RETURN
      ENDIF
C ---
      CALL SGENGRD(MDOC,NAMEC,NAMED,NAMEM,NAMEO,NAMEE
     * ,PRINT,POSITIV,MODE,GRAD,BADD,SCALEF,BADDF,DISPFR
     * ,RESULT,IPRROW,ISYM,IPRSYM,POOL(IPRMAP+1),NCRDMAX
     * ,POOL(1),IPRMAP,IERR)
C ---
      RETURN
      END

      SUBROUTINE SGENGRD(MDOC,NAMEC,NAMED,NAMEM,NAMEO,NAMEE
     * ,PRINTR,POSIT,MODE,GRAD,BADDD,SCALEF,BADDF,DISPFR
     * ,RESULT,IPRROW,ISYM,IPRSYM,ICOORD,NCOORM,X,IPRMAP,IERR)
C ----------------------------------------------------------
      REAL RESULT(IPRROW)
C ----------------------------------------------------------

      COMMON/CELL/ A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,HH2OBG,ICELL
     *             ,VOLUME,SSCALEF,GMODE,DMODE,POSITIV,PRINT
      CHARACTER GMODE*1,DMODE*1,POSITIV*1,PRINT*1
C ---
      COMMON/DIM/  DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
C ---------------------------------------
C --- integer*2 version
C     INTEGER*2  ICOORD(1)
C --- integer*4 version
      INTEGER   ICOORD(*)
C ---
CMS      : X,Y,ICOORD
C     REAL             X(IPRMAP)
c     INTEGER*2        X(IPRMAP)
      INTEGER*2        X(*)
C --
      INTEGER*2        ISYM(5,3,IPRSYM)
C --------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),NAMEO*(*),TITLE*80,P1*1,POSIT*1
      CHARACTER NAMEM*(*),LINE*80,STR*80,PATH*1,EXT*3,MODE*1,GRAD*1
      CHARACTER PRINTR*1,NAMEE*(*)
C==================================================================
      IERR = 0
      MT   = 10
      MD   =-ABS(MDOC)-1
      CALL ORCRD(MD,MT,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN COORD_FILE')
        GO TO 500
      ENDIF
      CALL C_AT_CR
      CLOSE(MT)
C -------------------------------------------
      MT     = 11
      ITYPE  = 0
      CALL IRDENS(MT,NAMED,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,X,RSCALE1,A,B,C,ALPHA,BETA,GAMMA,DRMS,
     * RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE
     *   ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
        CLOSE(MT)
        IERR=1
        RETURN
      ENDIF
      NXY = NX*NY
      IF(NXY.GT.IPRMAP) THEN
        CALL MSGERR(MDOC,' ERR: NOT MEMORY FOR DENSITY')
        CLOSE(MT)
        IERR=1
        RETURN
      ENDIF
      CLOSE(MT)
C -------------------------------------------
      MT     = 12
      ITYPE  = 0
      CALL IRDNS2(MT,NAMEM,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     *   IZMIN,RMAX,RMIN,X,RSCALE2,A,B,C,AL,BE,GA,DRMS,
     *   RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE
     *     ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN MODEL_FILE-DENS')
        CLOSE(MT)
        IERR=1
        RETURN
      ENDIF
      CLOSE(MT) 
C -------------------------------------------
      P1    = 'N'
      H2OBG = 0.0
      IF(SCALEF.LE.0.0) SCALEF = 1.0
      SSCALEF = SCALEF
      BADD    = BADDD
      BADD    = BADD+BADDF
      IF(BADD.LT.0.0) BADD = 0.0
C -------------------------------------------

      PRINTR='N'
      MODE  ='D'
C     GRAD  ='G'
      POSIT ='N'

      IF(PRINTR.EQ.'y') PRINTR='Y'
      IF(PRINTR.NE.'Y') PRINTR='N'
      IF(MODE.EQ.'o') MODE='O'
      IF(MODE.NE.'O') MODE='D'
      IF(GRAD.EQ.'e') GRAD='E'
      IF(GRAD.EQ.'d') GRAD='D'
      IF(GRAD.EQ.'o') GRAD='O'
      IF(GRAD.NE.'E'.AND.GRAD.NE.'D'.AND.GRAD.NE.'O') GRAD='G'
      IF(POSIT.EQ.'y') POSIT='Y'
      IF(POSIT.NE.'Y') POSIT='N'
      GMODE  = GRAD
      DMODE  = MODE
      POSITIV= POSIT
      PRINT  = PRINTR
C ---------------------------------------------
      DMAX = RESOL
      IF(DISPFR.LE.0.0) DISPFR=RESOL/3.0
C ------------------------------------------------
      ISPHR  = 0
      ICELL  = 0
      DLIM   = 2.8
      HH2OBG = H2OBG
      MD     =-ABS(MDOC)-1
      WRITE(LINE,*) ' DENSITY OF SOLVENT :',HH2OBG
      CALL MSGDOC(MD,LINE)
C --------------------------------------
C --- integer*2 version
C      CALL ATSORTG(MDOC,NAMEC,BAVER,BMAX,BMIN,BAVERW,BAVERF,BADD
C     *  ,NEL,SUMFI2
C     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
C     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
C     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
C     *  ,ICOORD(8*NCOORM+1),ICOORD(10*NCOORM+1)
C     *  ,ICOORD(12*NCOORM+1),ICOORD(14*NCOORM+1)
C     *  ,ICOORD(16*NCOORM+1),ICOORD(18*NCOORM+1)
C     *  ,ICOORD(24*NCOORM+1),ICOORD(26*NCOORM+1)
C     *  ,NSYM,ISYM,IPRSYM,IERR)
C --- integer*4 version
      CALL ATSORTG(MDOC,NAMEC,BAVER,BMAX,BMIN,BAVERW,BAVERF,BADD
     *  ,NEL,SUMFI2
     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
     *  ,ICOORD(8*NCOORM+1),ICOORD(9*NCOORM+1)
     *  ,ICOORD(10*NCOORM+1),ICOORD(11*NCOORM+1)
     *  ,ICOORD(12*NCOORM+1),ICOORD(13*NCOORM+1)
     *  ,ICOORD(16*NCOORM+1),ICOORD(17*NCOORM+1)
     *  ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) GO TO 500
      WRITE(LINE,*) 'ADDITIONAL B-FACTOR :',BADD
      CALL MSGDOC(MDOC,LINE)
C ---------------------------------------
      NXY=NX*NY
C --- integer*2 version
C      CALL ATMDENG(MDOC,NAMED,NAMEM,BADD,X,X(IPRMAP+1),NXY,IPRMAP
C     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
C     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
C     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
C     *  ,ICOORD(8*NCOORM+1),ICOORD(10*NCOORM+1)
C     *  ,ICOORD(12*NCOORM+1),ICOORD(14*NCOORM+1)
C     *  ,ICOORD(16*NCOORM+1),ICOORD(18*NCOORM+1)
C     *  ,ICOORD(24*NCOORM+1),ICOORD(26*NCOORM+1)
C     *  ,SUMDEN,NEL,NSYM,ISYM,IPRSYM,IERR)
C --- integer*4 version

      CALL ATMDENG(MDOC,NAMED,NAMEM,BADD,X,X(IPRMAP+1),NXY,IPRMAP
     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
     *  ,ICOORD(8*NCOORM+1),ICOORD(9*NCOORM+1)
     *  ,ICOORD(10*NCOORM+1),ICOORD(11*NCOORM+1)
     *  ,ICOORD(12*NCOORM+1),ICOORD(13*NCOORM+1)
     *  ,ICOORD(16*NCOORM+1),ICOORD(17*NCOORM+1)
     *  ,SUMDEN,NEL,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 500
C ---------------------------------------
C --- integer*2 version
C      CALL HESS_X(MDOC,BADD
C     *  ,NCOORD,NCOORM
C     *  ,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
C     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
C     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
C     *  ,ICOORD(8*NCOORM+1),ICOORD(10*NCOORM+1)
C     *  ,ICOORD(12*NCOORM+1),ICOORD(14*NCOORM+1)
C     *  ,ICOORD(16*NCOORM+1),ICOORD(18*NCOORM+1)
C     *  ,ICOORD(20*NCOORM+1),ICOORD(22*NCOORM+1)
C     *  ,NSYM,ISYM,IPRSYM,IERR)
C --- integer*4 version
      CALL HESS_X(MDOC,BADD
     *  ,NCOORD,NCOORM
     *  ,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
     *  ,ICOORD(8*NCOORM+1),ICOORD(9*NCOORM+1)
     *  ,ICOORD(10*NCOORM+1),ICOORD(11*NCOORM+1)
     *  ,ICOORD(12*NCOORM+1),ICOORD(13*NCOORM+1)
     *  ,ICOORD(14*NCOORM+1),ICOORD(15*NCOORM+1)
     *  ,NSYM,ISYM,IPRSYM,IERR)

      IF(IERR.GT.0) THEN
        GO TO 500
      ENDIF
C ---------------------------------------
C --- integer*2 version
C      CALL HESS_B(MDOC,BADD
C     *  ,NCOORD,NCOORM
C     *  ,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
C     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
C     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
C     *  ,ICOORD(8*NCOORM+1),ICOORD(10*NCOORM+1)
C     *  ,ICOORD(12*NCOORM+1),ICOORD(14*NCOORM+1)
C     *  ,ICOORD(16*NCOORM+1),ICOORD(18*NCOORM+1)
C     *  ,ICOORD(20*NCOORM+1),ICOORD(22*NCOORM+1)
C     *  ,NSYM,ISYM,IPRSYM,IERR)
C --- integer*4 version
C      CALL HESS_B(MDOC,BADD
C     *  ,NCOORD,NCOORM
C     *  ,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
C     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
C     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
C     *  ,ICOORD(8*NCOORM+1),ICOORD(9*NCOORM+1)
C     *  ,ICOORD(10*NCOORM+1),ICOORD(11*NCOORM+1)
C     *  ,ICOORD(12*NCOORM+1),ICOORD(13*NCOORM+1)
C     *  ,ICOORD(14*NCOORM+1),ICOORD(15*NCOORM+1)
C     *  ,NSYM,ISYM,IPRSYM,IERR)
C
C      IF(IERR.GT.0) THEN
C        GO TO 500
C      ENDIF
C ---------------------------------------
C --- integer*2 version
C      CALL  SORT_BACKG(MDOC,NAMEC,NAMEO
C     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
C     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
C     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
C     *  ,ICOORD(8*NCOORM+1),ICOORD(10*NCOORM+1)
C     *  ,ICOORD(12*NCOORM+1),ICOORD(14*NCOORM+1)
C     *  ,ICOORD(16*NCOORM+1),ICOORD(18*NCOORM+1)
C     *  ,ICOORD(20*NCOORM+1),ICOORD(22*NCOORM+1)
C     *  ,ICOORD(24*NCOORM+1),ICOORD(26*NCOORM+1)
C     *  ,NX,NY,NZ,NSYM,ISYM,IPRSYM,PRINT,IERR)
C --- integer*4 version

      CALL  SORT_BACKG(MDOC,NAMEC,NAMEO,NAMEE
     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
     *  ,ICOORD(8*NCOORM+1),ICOORD(9*NCOORM+1)
     *  ,ICOORD(10*NCOORM+1),ICOORD(11*NCOORM+1)
     *  ,ICOORD(12*NCOORM+1),ICOORD(13*NCOORM+1)
     *  ,ICOORD(14*NCOORM+1),ICOORD(15*NCOORM+1)
     *  ,ICOORD(16*NCOORM+1),ICOORD(17*NCOORM+1)
     *  ,NX,NY,NZ,NSYM,ISYM,DISPFR,RESULT,IERR)
      IF(IERR.NE.0) GO TO 500
C ---------------------------------------

      H2OBG     = HH2OBG
      RAD       = DLIM
      RESULT(6) = BADD


      RETURN
 500  CONTINUE
      IERR=1
      RETURN
      END

      SUBROUTINE ATMDENG(MDOC,NAMED,NAMEM,BADD,DEN1,DEN2,NXY,ISIZE
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC,ISCODE,IANUMB
     *  ,IRECRD,GRADX,GRADY,GRADZ,GRADB,GRADQ,GRADW
     *  ,SDENS1,SDENS2
     *  ,SUMD,NEL,NSYM,ISYM,IPRSYM,IERR)
C -----------------------------------------------------
CMS      : X
CMS      : IBFACT,IZMOCC,IXC,IYC,IZC
      INTEGER*2        DEN1(NXY,*),DEN2(NXY,*)
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C    *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C --- integer*4 version
      INTEGER         IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C ---
      REAL             GRADX(NCOORM),GRADY(NCOORM),GRADZ(NCOORM)
     *                ,GRADB(NCOORM),GRADQ(NCOORM),GRADW(NCOORM)
     *                ,SDENS1(NCOORM),SDENS2(NCOORM)
      INTEGER          NCOORD,NCOORM
      CHARACTER        NAMED*(*),NAMEM*(*)
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C --------------------------------------
      COMMON/COMINF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM,SD1T,SD2T,CFVOL
     *               ,DOBS_AV,DMOD_AV,SCALED,SIGMA,SIGMAD
      COMMON/CELL/   A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
     *             ,VOLUME,SCALEF,GMODE,DMODE,POSITIV,PRINT
      CHARACTER     GMODE*1,DMODE*1,POSITIV*1,PRINT*1
      COMMON/DIM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
      PARAMETER ( MAXSCALE  = 1000)
      COMMON/COM_RSCL/ RSCALE1(MAXSCALE),RSCALE2(MAXSCALE)
C --------------------------------------
      CHARACTER LINE*80,TITLE*80,TITLEM*80
      CHARACTER TYPE*4
      REAL      XS(3),XT(3),AX(3)
      EQUIVALENCE (X,XS(1)),(Y,XS(2)),(Z,XS(3))
C-----------------------------------------------
      MD=-ABS(MDOC)-1
      IERR=0
      MT=11
      M =99
      ITYPE  =0
      CALL IRDENS(MT,NAMED,MD,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,DEN1,RSCALE1(1),A,B,C,AL,BE,GA,DRMS,
     * RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE
     *   ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN DENS-FILE')
        CLOSE(MT)
        IERR=1
        RETURN
      ENDIF
C ---
      MTM=12
      M =99
      ITYPEM  =0
      CALL IRDNS2(MTM,NAMEM,MD,ITYPEM,ICNTZM,NXM,NYM,NZM,IZMAXM,
     *   IZMINM,RMAXM,RMINM,DEN2,RSCALE2(1),A,B,C,AL,BE,GA,DRMSM,
     *   RAVERM,RESOLM,IX0,IY0,IZ0,ITR,TITLEM
     *     ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN MODEL-DENS-FILE')
        CLOSE(MTM)
        IERR=1
        RETURN
      ENDIF
C ----------------------------------------------
      ICNTZ  =-999
      ICNTZM =-999
C ----
      SD1T  =0.0
      SD2T  =0.0
      SD1T2 =0.0
      SD2T2 =0.0
      SD12T =0.0
      SDIF2T=0.0
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
      COEF=(VOL)/(FLOAT(NX)*FLOAT(NY)*FLOAT(NZ))
      VOLUME=VOL
C ---------------------------------------------------
      NUMB  =0
      SUMRP =0.
      SUMRM =0.
      NDENSP=0
      NDENSM=0
      NZERO =0
      IZ000 =0

      DOBS_AV=RAVER
      DMOD_AV=RAVERM
C -----------------------------------------------------
      IP1  =ISIZE/NXY
      IR   =IZMIN
      IREND=IZMAX
C -----------------------------------------------------
C     RESOL=DMAX
      N1=NX
      N2=NY
      ITYPE =-1
      ITYPEM=-1
      NXY=NX*NY

100   CONTINUE
      IF(IR+IP1.GT.IREND) IP1 =IREND-IR+1
      N3=IP1

      DO     K=1,N3

        CALL IRDENS(MT,NAMED,MD,ITYPE,ICNTZ,NX,NY,NZ,IZMX
     *  ,IZMN,RMAX,RMIN,DEN1(1,K),RSCALE1(K),A,B,C,AL,BE,GA,DRMS
     *  ,RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE
     *   ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
          IERR=1
          CLOSE(MT)
          CLOSE(MTM)
          RETURN
        ENDIF

        IF(MTM.GT.0) THEN
          CALL IRDNS2(MTM,NAMEM,MD,ITYPEM,ICNTZM,NXM,NYM,NZM,IZMAXM,
     *    IZMINM,RMAXM,RMINM,DEN2(1,K),RSCALE2(K),A,B,C,AL,BE,GA,
     *    DRMSM,RAVERM,RESOLM,IX0,IY0,IZ0,ITR,TITLEM
     *    ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: READ FILE-MODEL-DENS')
            CLOSE(MTM)
            CLOSE(MT)
            IERR=1
            RETURN
          ENDIF
        ENDIF



      ENDDO
C ---
      DO     IZR=1,N3
        IZ=IR+IZR-1
        Z=IZ/FLOAT(NZ)
        DO     IY=1,NY
          Y=(IY-1)/FLOAT(NY)
          IND0 =(IY-1)*NX
          DO     IX=1,NX
            X=(IX-1)/FLOAT(NX)
            IND =IND0+IX
            D1=DEN1(IND,IZR)/RSCALE1(IZR)
            D2=DEN2(IND,IZR)/RSCALE2(IZR)
            IF(POSITIV.EQ.'Y') THEN
              IF(D1.LT.0.0) D1=0.0
              IF(D2.LT.0.0) D2=0.0
            ENDIF
            IT=1
            NN=1
            DO     I=2,NSYM
              DO     J=1,3
                IF(ISYM(5,J,I).EQ. 0) ISYM(5,J,I)=1
                XT(J)=ISYM(4,J,I)/REAL(ISYM(5,J,I))
                DO     K=1,3
                  XT(J)=XT(J)+ISYM(K,J,I)*XS(K)
                ENDDO
              ENDDO
              DO     J=1,3
                T=ABS(XT(J))
                IAX=T
                AX(J)=T-IAX
                IF(XT(J).LT.0) AX(J)=1.-AX(J)
                IF(AX(J).GE.1.0) AX(J)=0.
                AX(J)=XS(J)-AX(J)
                IF(ABS(AX(J)).LT.1.E-5) AX(J)=0.
              ENDDO

C              IF(AX(3)) 160,150,140
C 150          IF(AX(2)) 160,151,140
C 151          IF(AX(1)) 160,152,140

              IF(AX(3).LT.0.0) GO TO 160
              IF(AX(3).GT.0.0) GO TO 140
              IF(AX(2).LT.0.0) GO TO 160
              IF(AX(2).GT.0.0) GO TO 140
              IF(AX(1).LT.0.0) GO TO 160
              IF(AX(1).GT.0.0) GO TO 140

 152          CONTINUE
              NN=NN+1
              GO TO 160
 140          CONTINUE
              IT=0
              GO TO 170
 160          CONTINUE
            ENDDO
 170        CONTINUE
            IF(IT.GE.1) THEN
              NUMB=NUMB+1
              D1=D1/FLOAT(NN)
              D2=D2/FLOAT(NN)

              SD1T =SD1T +D1
              SD2T =SD2T +D2
              SD1T2=SD1T2+D1*D1
              SD2T2=SD2T2+D2*D2
              SD12T=SD12T+D1*D2
              SDIF2T=SDIF2T+(D1-D2)*(D1-D2)

              IDNS1=D1*RSCALE1(IZR)
              IF(IDNS1.LE.-32766) THEN
                IDNS1=-32765
              ENDIF
              DEN1(IND,IZR)=IDNS1
              DEN2(IND,IZR)=D2*RSCALE2(IZR)
            ELSE
              DEN1(IND,IZR)=-32766
              DEN2(IND,IZR)= 0
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C ---
      CALL GETDENG(MDOC,DEN1,DEN2,N1,N2,N3,IR,IZ000,BADD
     *   ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC,ISCODE,IANUMB
     *   ,IRECRD,GRADX,GRADY,GRADZ,GRADB,GRADQ,GRADW
     *   ,SDENS1,SDENS2
     *   ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        CLOSE(MT)
        CLOSE(MTM)
        RETURN
      ENDIF

      IR=IR+IP1
      IF(IR.LE.IREND) GO TO 100
C-----------------------------------------------------
      SCALED=0.0
      CFVOL=(VOL*NUMB)/(NX*NY*NZ)
      RCORR=0.0
      CALL MSGDOC(MDOC,' D_corr / for density map / = ')
      CALL MSGDOC(MDOC,
     * '(<R1*R2>-<R1><R2>)/SQRT((<R1**2>-<R1>**2)*(<R2**2>-<R2>**2))')
C        WRITE(*,*) SD12T,SD1T2,SD2T2,SD1T,SD2T,coef,cfvol

      IF(NUMB.GT.0) THEN

        SD1T =SD1T   *COEF
        SD2T =SD2T   *COEF
        SD12T=SD12T  *COEF

        SD1T =SD1T   /CFVOL
        SD2T =SD2T   /CFVOL
        SD12T=SD12T  /CFVOL

        SDIF2T=SDIF2T *COEF
        SD1T2 =SD1T2  *COEF
        SD2T2 =SD2T2  *COEF

        SDIF2T=SDIF2T /CFVOL
        SD1T2 =SD1T2  /CFVOL
        SD2T2 =SD2T2  /CFVOL

        IF(SDIF2T.GT.0.0) THEN
          SIG_DIF=SQRT(SDIF2T)
        ELSE
          SIG_DIF=0.0
        ENDIF

        SIGMAD=SIG_DIF
        SIGMA=0.0
        IF(SD2T2.GT.0.0) THEN
          SCALED=SQRT(SD1T2/SD2T2)
          SC1=SQRT(SD1T2)
          SC2=SQRT(SD2T2)
          SIGMA=SC1
        ELSE
          SCALED=0.0
        ENDIF

        DMOD1=SQRT(SD1T2-SD1T*SD1T)
        DMOD2=SQRT(SD2T2-SD2T*SD2T)
        TEMP1=(SD12T-SD1T*SD2T)
        TEMP=DMOD1*DMOD2
        IF(TEMP.GT.0.0) THEN
          RCORR=TEMP1/TEMP
        ELSE
          RCORR=0.0
        ENDIF
      ENDIF

      WRITE(LINE,'('' D_corr:'',F8.3)') RCORR
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' <Dobs>,<Dmod>,scale:'',3F8.3)') SD1T,SD2T,SCALED
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' SIG_1,2,DIF:'',3F8.3)') SC1,SC2,SIG_DIF
      CALL MSGDOC(MDOC,LINE)

      CLOSE(MT)
      CLOSE(MTM)

      RETURN
      END

      SUBROUTINE ATSORTG(MDOC,NAME,BAVER,BPEAK,BMIN,BAVERW,BAVERF
     *  ,BADD,NEL,SUMFI2
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC,ISCODE,IANUMB
     *  ,IRECRD,GRADX,GRADY,GRADZ,GRADB,GRADQ,GRADW,SDENS1,SDENS2
     *  ,NSYM,ISYM,IPRSYM,IERR)
C -------------------------
CMS      : IBFACT,IZMOCC,IXC,IYC,IZC
      INTEGER   MDOC,IERR
      CHARACTER NAME*(*),NCS_FLAG*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C    *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)        
C --- integer*4 version
      INTEGER         IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)        
C ---
      REAL             GRADX(NCOORM),GRADY(NCOORM),GRADZ(NCOORM)
     *                ,GRADB(NCOORM),GRADQ(NCOORM),GRADW(NCOORM)
     *                ,SDENS1(NCOORM),SDENS2(NCOORM)
      INTEGER          NCOORD,NCOORM
C ---
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of atom in the file.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMS/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),HESS_A(15),CATOM
      CHARACTER       CATOM(15)*2
C ---
      COMMON/DIM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
      COMMON/CELL/   A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
     *             ,VOLUME,SCALEF,GMODE,DMODE,POSITIV,PRINT
      CHARACTER     GMODE*1,DMODE*1,POSITIV*1,PRINT*1
C -----------------------------------------------------------------
      INTEGER     NCSOP
      REAL        AMNCS(3,3),TRNCS(3)
C------------------------------------------------------------------
      REAL        XA(3),YA(3),XSU(3),XFU(3)
      REAL        TRNS(3,2),XS(3),XF(3),Y(3)
      INTEGER     IPOINT(3)
C----------------------------------------------------------------
      INTEGER     MODE
      REAL        FRTOCR(3,3),CRTOFR(3,3)
      REAL        ROT(9),TR(3)
      CHARACTER   ATOM*4,CHAR4*4,CHAR2*2,RES3*3
      CHARACTER   STR*80,NCSF*1,GID*4,P1*1
C==================================================================
      ICOUNT= 0
      NONH  = 0
      NEL   = 0
      SUMFI2= 0
      NFMFC = 0
      P1='N'
C --- integer*2 version
C     IPACK =10000
C --- integer*4 version
      IPACK =100000
C ---
      IERR  = 0
      NIN   = 10
      M     = 99
      MD    = -ABS(MDOC)-1
C --------
      CALL ORCRD(MD,NIN,NAME,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      A     = CR_CELL(1)
      B     = CR_CELL(2)
      C     = CR_CELL(3)
      ALPHA = CR_CELL(4)
      BETA  = CR_CELL(5)
      GAMMA = CR_CELL(6)
      CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *                            ,FRTOCR,CRTOFR,IERR)
C -----------------------------------------
      NCRSYM=0
      NCS_FLAG='N'
      NCSOP=0
      CALL GET_NCS(MDOC,NCMAX,NCSOP,AMNCS,TRNCS,IERR)
      IF(IERR.NE.0) RETURN      
      IF(NCSOP.GT.0) THEN
        IGR=0
        CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                 ,IGOLD,NCSF,GID,IERR)
        IF(IERR.NE.0) THEN
          WRITE(STR,
     *    '('' ERR: wrong NCS description'')') 
          CALL MSGERR(MDOC,STR)
          RETURN
        ENDIF
        IF(NGR.GT.0) THEN
          DO IGR=1,NGR
            CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            IF(NCSF.EQ.'N'.OR.NCSF.EQ.'n') THEN
              NCS_FLAG='Y'
              GO TO 520
            ENDIF
          ENDDO
        ENDIF
      ENDIF
 520  CONTINUE
      IF(NCS_FLAG.EQ.'Y') THEN
        WRITE(STR,
     *  '(''NUMBER OPERATORS OF NON-CRYST.SYMMETRY:'',I5)') NCSOP
        CALL MSGDOC(MDOC,STR)
        IF(NCSOP.GT.0) THEN
          CALL MSGDOC(MD,' ')
          CALL MSGDOC(MD,'  X-NEW           X-0      TX')
          CALL MSGDOC(MD,'  Y-NEW  = [M] *  Y-0  +   TY')
          CALL MSGDOC(MD,'  Z-NEW           Z-0      TZ')
          CALL MSGDOC(MD,' ')
          CALL MSGDOC(MD,' ORTOGONAL COORDINATE SYSTEM')
          CALL MSGDOC(MD,'  COORDINATES IN ANGSTROMS')
          CALL MSGDOC(MD,' ')
          DO     I=1,NCSOP
            CALL GET_NCS(MD,NCMAX,I,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            WRITE(STR,500) I
            CALL MSGDOC(MD,STR)
  500       FORMAT('  OPERATORS OF NON-CRYST.SYMMETRY :',I5)
            CALL ANGFIX(MD,AMNCS,ALPH,BET,GAMM)
            WRITE(STR,510) (TRNCS(L),L=1,3)
            CALL MSGDOC(MD,STR)
  510       FORMAT(' TRANSLATION VECTOR :',3F10.5,' /ANGSTROM/')
          ENDDO
        ELSE
          WRITE(STR,
     *    '('' ERR: NUMBER OF NCS-OPERATORS:'',I5)') NCSOP
          CALL MSGERR(MDOC,STR)
          IERR=1
          RETURN
        ENDIF
      ENDIF
C--------------------------------------------------
      DLM=DLIM+0.5
      XS(1) =0.
      XS(2) =0.
      XS(3) =0.
      XF(1) =1.
      XF(2) =1.
      XF(3) =1.

      ZFFS  =FLOAT(IZMIN)/FLOAT(NZ)-DLM/C
      ZFFF  =FLOAT(IZMAX)/FLOAT(NZ)+DLM/C

      XSU(1)=DLM/A
      XSU(2)=DLM/B
      XSU(3)=DLM/C
      XFU(1)=1.-DLM/A
      XFU(2)=1.-DLM/B
      XFU(3)=1.-DLM/C
C
      BAVER  = 0.0
      BMIN   = 1.E30
      BPEAK  =-1.E30
      BAVERW = 0.0 
      BAVERF = 0.0
      MATOMW =0
      NINALL =0
      IATT   =0
      IAT_IN =0
      I      =0
      NSUME  =0.
      NCRSYM =0
      SCHRG=0.0
      CHRGP=0.0
      CHRGM=0.0
      D1=0.0
      D2=0.0
      D3=0.25/(DMAX*DMAX)
C ===========================================
      IEND=-1
1100  CONTINUE

        IF(NCS_FLAG.EQ.'Y'.AND.NCRSYM.GT.NCSOP) NCRSYM=0

        IF(NCRSYM.NE.0) THEN


        ELSE

          MODE = 0
          CALL RDCRD(M,NIN,MODE,IEND,IERR)
          IF(IERR.EQ.1) RETURN
          IF(IEND.NE.0) GO TO 2000
          IF(MODE.GT.0) GO TO 1000    

          IF(CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *       CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *       CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R')
     *    GO TO 1000
          IAT_IN=IAT_IN+1
        ENDIF
C--------------------------------------------------------

        ATOM=CR_ANAME
        IRES=CR_IRES
        RES3=CR_RNAME
        OCC =CR_OCC
        BT  =CR_BISO

        ISERIAL=CR_IATOM

        IF(CR_MULT_FACTOR.GT.1) THEN
          OCC = OCC / FLOAT(CR_MULT_FACTOR)
        ENDIF
        RVDW = 1.5
C--------------------------------------------------------
        XA(1)=CR_XYZ(1)
        XA(2)=CR_XYZ(2)
        XA(3)=CR_XYZ(3)
        INC=0
        IF(NCS_FLAG.EQ.'Y') THEN

          IF(NCRSYM.EQ.0) THEN
            IGR_OLD=CR_IGROUP
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description'')') 
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
              IF(IGOLD.EQ.IGR_OLD.AND.INC.EQ.0) GO TO 410
            ENDDO
            WRITE(STR,
     *      '('' ERR: wrong NCS description'')') 
            CALL MSGERR(MDOC,STR)
            IERR=1
            RETURN

 410        CONTINUE
            ICHAIN=ICHOLD
            NCRSYM=1
          ELSE
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description'')') 
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
              IF((NCSF.EQ.'N'.OR.NCSF.EQ.'n').AND.
     *           INC.EQ.NCRSYM.AND.ICHOLD.EQ.ICHAIN) GO TO 530
            ENDDO
            NCRSYM=NCRSYM+1
            GO TO 1000  

 530        CONTINUE
            CALL GET_NCS(MDOC,NCMAX,INC,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF      
            CALL MVMULT(AMNCS,CR_XYZ,XA)
            XA(1)=XA(1)+TRNCS(1)
            XA(2)=XA(2)+TRNCS(2)
            XA(3)=XA(3)+TRNCS(3)
            NCRSYM=NCRSYM+1
          ENDIF
        ENDIF

        CALL MVMULT(CRTOFR,XA,YA)

        XA(1)=YA(1)
        XA(2)=YA(2)
        XA(3)=YA(3)

C --------------------------------------------------------
        IZZ=1
        CHAR2=CR_ASYMB(1:2)
        CHAR4=CR_ASYMB
 610    CONTINUE
        IF(NFMFC.GT.0) THEN
          DO IM=1,NFMFC
            IF(CHAR2.EQ.CATOM(IM)) THEN
              IZZ=IM
              IZE=IZFMFC(IZZ)
              GO TO 600
            ENDIF
          ENDDO
        ENDIF
        CALL GET_SFA(CHAR4
     *      ,N,NELC,A1,A2,A3,A4,B1,B2,B3,B4,CC,FI,FII,RAD,IERR)
        IF(IERR.NE.0.OR.NFMFC.GE.NFMMAX) THEN
          IF(IERR.NE.0) THEN
            IF(ICOUNT.LT.4) THEN
              WRITE(STR,*) ' ERR: atom"s type "',CHAR4,'" not found'
              CALL MSGERR(MDOC,STR)
              WRITE(STR,
     *        '('' ERR: for atom '',I6,'' name:'',A4,I5,'' '',A3)')
     *        I+1,ATOM,IRES,RES3
              CALL MSGERR(MDOC,STR)
              ICOUNT=ICOUNT+1
            ELSE IF(ICOUNT.EQ.4) THEN
              CALL MSGERR(MDOC,'   ... more ...')
              ICOUNT=ICOUNT+1
            ENDIF
            IERR=0
          ELSE IF(NFMFC.GE.NFMMAX) THEN
            IF(ICOUNT.LT.4) THEN
              WRITE(STR,*) ' ERR: too many atom"s type > ',NFMMAX
              CALL MSGERR(MDOC,STR)
              ICOUNT=ICOUNT+1
            ELSE IF(ICOUNT.EQ.4) THEN
              CALL MSGERR(MDOC,'   ... more ...')
              ICOUNT=ICOUNT+1
            ENDIF
          ENDIF
          IF(ICOUNT.LE.4) THEN
            WRITE(STR,*) ' ERR: default type  is "N   "'
            CALL MSGERR(MDOC,STR)
          ENDIF
          CHAR2='N '
          CHAR4='N   '
          GO TO 610
        ENDIF
        NFMFC=NFMFC+1
        IZFMFC(NFMFC)=NELC
        FMFCA(1,NFMFC)=A1
        FMFCB(1,NFMFC)=B1
        FMFCA(2,NFMFC)=A2
        FMFCB(2,NFMFC)=B2
        FMFCA(3,NFMFC)=A3
        FMFCB(3,NFMFC)=B3
        FMFCA(4,NFMFC)=A4
        FMFCB(4,NFMFC)=B4
        FMFCA(5,NFMFC)=CC
        FMFCB(5,NFMFC)=0.0
        CATOM(NFMFC)=CHAR2
        IZZ=NFMFC
        IZE=NELC
        RVDW=RAD
 600    CONTINUE
C ----------------------------------------
        I=I+1
        IF(CR_ASYMB(1:2).NE.'H '.AND.CR_ASYMB(1:2).NE.'D ') THEN
          NONH  = NONH +1
        ENDIF
        NEL=NEL+IZE*OCC
        SUMFI2 = SUMFI2+IZE*IZE*OCC*OCC
        IF(BT.LT.2.0)  BT = 2.0
        IF(BT.GT.99.0) BT =99.0
        IZR=BT*10.0
        IF(CR_ASYMB(1:2).NE.'H '.AND.CR_ASYMB(1:2).NE.'D ') THEN
          D2=D2+IZE*IZE*OCC*OCC
          D4=0.0
          DO IGS=1,5
            D4= D4+FMFCA(IGS,IZZ)*EXP(-(BT+FMFCB(IGS,IZZ))*D3)
          ENDDO
          D4= OCC * D4
          D1=D1+D4*D4
        ENDIF
        IF(OCC.GT.99.9) OCC=99.9
        IOCC        =OCC*10.0
        INEOCC=IZZ*1000+IOCC

        IF(ABS(INEOCC).GT.32766.0) 
     *  INEOCC=(ABS(INEOCC)/INEOCC)*32766.0
        IF(ABS(IZR).GT.32600.0) IZR=(ABS(IZR)/IZR)*32600.0
C -----
        BAVER   = BAVER+BT
        IF(CR_RNAME.NE.'HOH'.AND.CR_RNAME.NE.'DOD') THEN
          BAVERW = BAVERW +BT 
          MATOMW = MATOMW +1
        ENDIF
        IF(BMIN .GT.BT ) BMIN =BT
        IF(BPEAK.LT.BT ) BPEAK=BT
C ------------------------------
        JJNS=0
        N_SYM=NSYM
        IF(P1.EQ.'Y') N_SYM=1
        DO     ISM=1,N_SYM
          ROT(1) = ISYM(1,1,ISM)
          ROT(2) = ISYM(2,1,ISM)
          ROT(3) = ISYM(3,1,ISM)
          ROT(4) = ISYM(1,2,ISM)
          ROT(5) = ISYM(2,2,ISM)
          ROT(6) = ISYM(3,2,ISM)
          ROT(7) = ISYM(1,3,ISM)
          ROT(8) = ISYM(2,3,ISM)
          ROT(9) = ISYM(3,3,ISM)
          TR(1)  = ISYM(4,1,ISM)/REAL(ISYM(5,1,ISM))
          TR(2)  = ISYM(4,2,ISM)/REAL(ISYM(5,2,ISM))
          TR(3)  = ISYM(4,3,ISM)/REAL(ISYM(5,3,ISM))

          X =ROT(1)*XA(1 ) +ROT(2)*XA(2) +ROT(3)*XA(3)
     .       + TR(1)
          YY=ROT(4)*XA(1 ) +ROT(5)*XA(2) +ROT(6)*XA(3)
     .       + TR(2)
          Z =ROT(7)*XA(1 ) +ROT(8)*XA(2) +ROT(9)*XA(3)
     .       + TR(3)

          Y(1)=X
          Y(2)=YY
          Y(3)=Z

          DO     J=1,3
21          IF(Y(J).LT.XS(J)) THEN
              Y(J)=Y(J)+1.
              GO TO 21
            ENDIF
22          IF(Y(J).GE.XF(J)) THEN
              Y(J)=Y(J)-1.
              GO TO 22
            ENDIF
            IPOINT(J)=1
            TRNS(J,1)=0.
            IF(Y(J).LE.XSU(J)) THEN
              IPOINT(J)=IPOINT(J)+1
              TRNS(J,2)=1.
            ELSE IF(Y(J).GE.XFU(J)) THEN
              IPOINT(J)=IPOINT(J)+1
              TRNS(J,2)=-1.
            ENDIF
          ENDDO

          INALL=0

          DO     IX=1,IPOINT(1)
            DO     IY=1,IPOINT(2)
              DO     IZ=1,IPOINT(3)
C                DO     JZ=1,3
                  JZ=2
                  ZZZ =Y(3)+TRNS(3,IZ)+FLOAT(JZ-2)

                  IF(ZZZ.GE.ZFFS.AND.ZZZ.LE.ZFFF) THEN

                    IXXX=(Y(1)+TRNS(1,IX))*FLOAT(IPACK)
                    IYYY=(Y(2)+TRNS(2,IY))*FLOAT(IPACK)
                    IZZZ= ZZZ             *FLOAT(IPACK)
                    IATT=IATT+1
                    IF(IX.EQ.1.AND.IY.EQ.1.AND.IZ.EQ.1) INALL=1
                    IF(IATT.GT.NCOORM ) THEN
                      WRITE(STR,*) ' ERR: too many atoms > ',NCOORM
                      CALL MSGERR(MDOC,STR)
                      IERR=1
                      RETURN
                    ENDIF
                    NSUME       = NSUME+IZE
                    IBFACT(IATT)  =IZR
                    IZMOCC(IATT)  =INEOCC
C --- integer*2 version
c                    IF(IXXX.LT.-32766.OR.IXXX.GT.32766.OR.
c     *                 IYYY.LT.-32766.OR.IYYY.GT.32766.OR.
c     *                 IZZZ.LT.-32766.OR.IZZZ.GT.32766) THEN
c                      CALL MSGERR(MDOC,' ERR: !X,Y,Z!(u.c.) > 3.2766')
c                      IERR=1
c                      RETURN
c                    ENDIF
C -----------------------
                    IXC(IATT)   =IXXX
                    IYC(IATT)   =IYYY
                    IZC(IATT)   =IZZZ
                    GRADX(IATT) =0.0
                    GRADY(IATT) =0.0
                    GRADZ(IATT) =0.0
                    GRADB(IATT) =0.0
                    GRADQ(IATT) =0.0
                    GRADW(IATT) =0.0
                    SDENS1(IATT)=0.0
                    SDENS2(IATT)=0.0
                    ITRX=TRNS(1,IX)+1.001
                    ITRY=TRNS(2,IY)+1.001
                    ITRX=TRNS(3,IZ)+1.001

                    ISCODE(IATT)=ISM*100+INC

                    IANUMB(IATT)=ISERIAL
                    IRECRD(IATT)=IATT        
          
                  ENDIF
               
C                ENDDO
              ENDDO
            ENDDO
          ENDDO
        ENDDO
C ------------------------
        NINALL=NINALL+INALL
1000    CONTINUE
      GO TO 1100
C==================================================
 2000 MATOMS =I
      NATOMS =IATT
      IF(MATOMS.GT.0) THEN
        BAVER=BAVER/MATOMS
      ENDIF
      IF(MATOMW.GT.0) THEN
        BAVERW=BAVERW/MATOMW
      ENDIF
C ------------------------------------------------------
      M=99
      IF(IATT.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS = 0')
        IERR=1
        CLOSE(NIN)
        RETURN
      ENDIF
      CALL MSGDOC(M,' --- START SORT ---')
C --- integer*2 version
C     CALL I2SORT1(IZC,IATT,IRECRD)
C --- integer*4 version
      CALL ISORT1(IZC,IATT,IRECRD)
C ---
      CALL MSGDOC(M,' --- END   SORT ---')
C ------------------------------------------------------
      D1=SQRT(D1)
      D2=SQRT(D2)
      BAVE=ALOG(D2/D1)/D3
      BAVERF = BAVE
      CALL SETBADD(DMAX,BAVE,NX,NY,NZ,BCALC)

      IF(BADD.LE.0.000001) BADD=BCALC        

c      BADD=BADD+BCALC        

      WRITE(STR,'('' BADD_CALC:'',F10.3)') BCALC
      CALL MSGDOC(MDOC,STR)

      WRITE(STR,430) IAT_IN
      CALL MSGDOC(MDOC,STR)
      IF(NCS_FLAG.EQ.'Y') THEN
        WRITE(STR,434) MATOMS
        CALL MSGDOC(MDOC,STR)
      ENDIF
      IF(MATOMS.NE.NONH) THEN
        WRITE(STR,433) NONH
        CALL MSGDOC(MDOC,STR)
      ENDIF
      WRITE(STR,431) NATOMS
      CALL MSGDOC(MDOC,STR)
      WRITE(STR,432) NINALL
      CALL MSGDOC(MDOC,STR)
 430  FORMAT('ATOMS INPUT                       :',I6)
 433  FORMAT('ATOMS INPUT/non H /               :',I6)
 431  FORMAT('ATOMS INCLUDED IN SORT            :',I6)
 432  FORMAT('ATOMS IN ONCE ONLY                :',I6)
 434  FORMAT('ATOMS INPUT/including NCS-atoms / :',I6)

      WRITE(STR,440) BMIN,BPEAK,BAVE
      CALL MSGDOC(MDOC,STR)
 440  FORMAT('MINIMUM B - MAXIMUM B - AVERAGE B:',3F10.4)
c     WRITE(STR,442) NSUME
c 442 FORMAT('SUM-ELECTRONS :',I10)
c     CALL MSGDOC(MDOC,STR)
      FAVER=SQRT(SUMFI2*NSYM)
      WRITE(STR,441) NEL,FAVER
 441  FORMAT('SUM-ELECTRONS /IN MODEL/ :',I10,' <!F!> :',F12.0)
      CALL MSGDOC(MDOC,STR)
      AVERI=SUMFI2*NSYM
      WRITE(STR,443) AVERI
 443  FORMAT('                                  <I> :',F12.0)
      CALL MSGDOC(MDOC,STR)

      NCOORD=IATT
      IF(NCOORD.EQ.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS =0')
        IERR=1
      ENDIF
      CLOSE(NIN)
      RETURN
      END


      SUBROUTINE GETDENG(MDOC,DOBS,DEN,N1,N2,N3,R,IATRC1,BADD
     * ,NCOORD,NCOORM,IBFACT,IZMOCC,IXCC,IYCC,IZCC,ISCODE,IANUMB
     * ,IRECRD,GRADX,GRADY,GRADZ,GRADB,GRADQ,GRADW
     * ,SDENS1,SDENS2
     * ,NSYM,ISYM,IPRSYM,IERR)
C------------------------------------------------------
CMS      : DEN
CMS      : IBFACT,IZMOCC,IXCC,IYCC,IZCC
      INTEGER*2 DEN(N1,N2,N3),DOBS(N1,N2,N3)
      INTEGER   R,IATRC1
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
C    *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C --- integer*4 version
      INTEGER         IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C ---
      REAL             GRADX(NCOORM),GRADY(NCOORM),GRADZ(NCOORM)
     *                ,GRADB(NCOORM),GRADQ(NCOORM),GRADW(NCOORM)
     *                ,SDENS1(NCOORM),SDENS2(NCOORM)
      INTEGER          NCOORD,NCOORM
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C------------------------------------------------------
      COMMON/COMINF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM,SD1T,SD2T,CFVOL
     *               ,DOBS_AV,DMOD_AV,SCALED,SIGMA,SIGMAD
C------------------------------------------------------
      COMMON/CELL/   A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
     *             ,VOLUME,SCALEF,GMODE,DMODE,POSITIV,PRINT
      CHARACTER     GMODE*1,DMODE*1,POSITIV*1,PRINT*1
      COMMON/DIM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
      PARAMETER ( MAXSCALE  = 1000)
      COMMON/COM_RSCL/ RSCALE1(MAXSCALE),RSCALE2(MAXSCALE)
C --------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMS/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),HESS_A(15),CATOM
      CHARACTER       CATOM(15)*2
C-------------------------------------------------------------
      REAL            BLL(5),CLL(5),BLLL(5),BBL(5)
C------------------------------------------------------------------
      IERR=0
C --- integer*2 version
C     IPACK=10000
C --- integer*4 version
      IPACK=100000
C ---
      NATREC=NCOORD
      COEF=(FLOAT(NX)*FLOAT(NY)*FLOAT(NZ))

C      IF(R.EQ.IZMIN) IATRC1=0

C
      DLIMIT=DLIM*DLIM

      SX=A/NX
      SY=B/NY
      SZ=C/NZ
C
      PI   =4.0*ATAN(1.0)
      PISQ4=4.0*PI*PI
      COSA =COS(ALPHA)
      SINA =SIN(ALPHA)
      COSG =COS(GAMMA)
      SING =SIN(GAMMA)
      COSB =COS(BETA)
      SINB =SIN(BETA)
      CSA2 =COSA*2.
      CSB2 =COSB*2.
      CSG2 =COSG*2
      SYCOSG=SY*COSG
      SXSING=SX*SING
      SYSING=SY*SING
      SZCOSB=SZ*COSB
      SZCOSA=SZ*COSA
C      COSZ  DEFINES THE ANGLE BETWEEN C AND CSTAR
      COSZ=SQRT(1.-COSA**2-COSB**2-COSG**2+2.*COSA*COSB*COSG)/SING

      DV=8.0*SX*SY*SZ*COSZ*SING*PI**1.5
C
C  CELL VOLUME
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
      COEF=COEF/VOL
      VOLUME=VOL
      ITETR=0
      ANGSUM=ABS(ALPHA+BETA+GAMMA-(3.0*PI)/2.)
      IF(ANGSUM.GT.0.01) ITETR=1
      IMON=0
      ANGSUM=ABS(BETA+ALPHA-PI/2.)
      IF(ANGSUM.GT.0.01) IMON=1

      DLM= SQRT(DLIMIT)

      IF(IMON.EQ.1) DLM=DLM+0.5

      ZSFG  =FLOAT(R)/NZ     -DLM/C
      ZFFG  =FLOAT(R+N3-1)/NZ+DLM/C
      ZSFNXT=ZFFG-2.*DLM/C
C
      IATREC=IATRC1
C==========================================
1     IATREC=IATREC+1
      IF(IATREC.GT.NATREC) GO TO 400
      
      IATM_P=IRECRD(IATREC)

      if(iatm_p.gt.NCOORM) then
        write(*,*) '>>>>',iatm_p.gt.NCOORM
      endif



      IAN   =IANUMB(IATM_P)

      IBOCC =IZMOCC(IATM_P)
      IXIN  =IXCC  (IATM_P)
      IYIN  =IYCC  (IATM_P)
      IZIN  =IZCC  (IATREC)
      Z     =IZIN/FLOAT(IPACK)
      ISCD  =ISCODE(IATM_P)
      BAT   =IBFACT(IATM_P)/10.0
C
      IF(Z.LT.ZSFNXT) IATRC1=IATREC
      IF(Z.LT.ZSFG)   GO TO 1
      IF(Z.GT.ZFFG)   GO TO 400
C
      SCALE=1.0
      BT=BAT+BADD
      IF(BT.GT.99.0) BT=99.0
      IZZ=IBOCC/1000
      IT =IBOCC-IZZ*1000
      OCC=IT/10.

      IF(OCC.LT.0.0001) GO TO 1
      X  =IXIN/FLOAT(IPACK)
      Y  =IYIN/FLOAT(IPACK)
      X1=X *A
      Y1=Y *B
      Z1=Z *C
      IF(BT.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: B-FACTOR < 0.0 ')
        IERR=1
        RETURN
      ENDIF
      IF(IZZ.LE.0.OR.IZZ.GT.NFMFC) THEN 
        CALL MSGERR(MDOC,' ERR: IDENTIFY FORMFACTORS = ?')
        IERR=1
        RETURN
      ENDIF
      DVOCC=OCC*DV*SCALE
      IM=IZZ
     
      NEL=IZFMFC(IM)
      DDLIM=DLM
CCCC      IF(NEL.EQ.1) DDLIM=3.5
      DMAXSQ=DDLIM*DDLIM

C      B11=BAT
C      IF(NEL.GT.16) B11=AMAX1(BT,20.0)
C      IF(NEL.LT.16) B11=AMIN1(BT,15.0)
C      IF(NEL.EQ. 1) B11=AMAX1(BT, 5.0)
C      B11=B11+BADD
C      RADSQ=DDLIM*(B11+25.0)/PISQ4
C      RAD  =SQRT(RADSQ)
C      DMAXSQ=RADSQ

      RRADZ=SQRT(DMAXSQ)/(SZ*COSZ)

      GQSK=0.0
      DO     J=1,5
        GQSK = GQSK + FMFCA(J,IM)
      ENDDO
      DO     J=1,5
        BLL(J) =PISQ4 /(FMFCB(J,IM)+BT )
        BLLL(J)=BLL(J)/(FMFCB(J,IM)+BT )
        BBL(J) =1.5   /(FMFCB(J,IM)+BT )
        CLL(J)=DVOCC*FMFCA(J,IM)*(FMFCB(J,IM)+BT )**(-1.5)
      ENDDO
C
      XC=X1/SX
      IXC=NINT(XC)
      YC=Y1/SY
      IYC=NINT(YC)
      ZC=Z1/SZ
      IZC=NINT(ZC)
C

      SZL=ZC-RRADZ
      SZU=ZC+RRADZ
      ISZL=INT(SZL+501.)
      ISZU=INT(SZU+500.)
C
C     CALCULATE THE DENSITY AT ALL POINTS TO WHICH ATOM CONTRIBUTES
C     (IE IN SPHERE OF RADIUS RRADZ)
C
      DO     IZ1=ISZL,ISZU
        IZ=IZ1-500
C
C     TEST WHETHER THIS ATOM LIES IN REQUIRED BLOCK OF FOURIER SECTIONS
C
        IZ2=IZ+1-R
        IF(IZ2.GT.N3 .OR. IZ2.LE.0)       GO TO 301
        DDZ=1.0-ABS(ZC-IZ)
        IF(DDZ.LE.0.0) DDZ=0.0
        DZ=IZ*SZ-Z1
        D2=DZ*DZ
        IF(D2.GT.DMAXSQ .AND. ITETR.EQ.1) GO TO 301
 
        D3=DMAXSQ-DZ*DZ*SINA*SINA

        IF(D3.LE.0.)                      GO TO 301
        RRADY=SQRT(D3)/SYSING

        ZCOSA=DZ*COSA/SY
        SYL=YC-RRADY-ZCOSA
        SYU=YC+RRADY-ZCOSA
        ISYL=INT(SYL+501.)
        ISYU=INT(SYU+500.)
        DELZ1=2.*DZ
        DZCSA2=DZ*CSA2
        DZCOSB=DZ*COSB
        DO     IY1=ISYL,ISYU
          IY=IY1 - 500
          IY2=IY+1
          IF(IY2.LE.N2.AND.IY2.GE.1) THEN
            DDY=1.0-ABS(YC-IY)
            IF(DDY.LE.0.0) DDY=0.0
            DY=IY*SY-Y1
            DYZ=D2+DY*(DZCSA2+DY)
            IF(DYZ.LE.DMAXSQ.OR.IMON.EQ.0) THEN
C
C             FOR GIVEN X AND Y  THE MINIMUM DSQ IS GIVEN
C             FOR DX=-DY*COSG-DZCOSB
C
              DXMIN=-DY*COSG-DZCOSB
              DSQMIN=DYZ-DXMIN**2
              IF(DSQMIN.LT.DMAXSQ) THEN
                DFACT2=-2.*DXMIN
                D4=DMAXSQ-DSQMIN
                DELZ2=DELZ1+DY*CSA2
                DELY1=2.*DY+DZCSA2
                DELY=2.*DY
                RRADX=SQRT(D4)/SXSING
                XDELTA=DXMIN/SX
                SXL=XC-RRADX + XDELTA
                SXU=XC+RRADX + XDELTA
                ISXL=INT(SXL+501.)
                ISXU=INT(SXU+500.)
                DO     IX1=ISXL,ISXU
                  IX=IX1-500
                  IX2=IX+1

                  IF(IX2.LE.N1.AND.IX2.GE.1) THEN

C                   DNS1=DOBS(IX2,IY2,IZ2)
C                   DNS2=DEN (IX2,IY2,IZ2)

                    IDNS1=DOBS(IX2,IY2,IZ2)
                    IDNS2=DEN (IX2,IY2,IZ2)

                    IF(IDNS1.GT.-32766 ) THEN

                      DNS1=IDNS1/RSCALE1(IZ2)
                      DNS2=IDNS2/RSCALE2(IZ2)

                      D2OM=2.0*DNS1-DNS2
                                 
                      IF(GMODE.EQ.'O') D2OM=DNS1
                      IF(DMODE.EQ.'D') DNS1=DNS1-DNS2
                    
                      DDX=1.- ABS(XC-IX)
                      IF(DDX.LE.0.0) DDX=0.0
                      DX=IX*SX-X1
                      DSQ=DX*(DX+DFACT2) + DYZ

                      IF(DSQ.LE.DMAXSQ) THEN

                        DROM =0.0
                        ROM  =0.0
                        DBM  =0.0
                        D2ROM=0.0
                        DO     J=1,5

C       ROm(R-Rm)=SUM(ROmj)=SUM(V/N*OCC*(Aj*(4*pi/Bj)^3/2*EXP(-4*pi^2/Bj)
C                                Bj=(Bj+Bm)
C       DROM=SUM(DROMJ): dROm/drm=SUM((dROm/drm)j)=SUM(2*(4pi^2/Bj)*ROmj)
C       D2ROM=SUM(D2ROMJ): d2ROm/drm2=SUM(DROMJ*(2*(r-rm)^2*(4pi^2/Bj)-3))

                          DSQ1  =-DSQ*BLL(J)
                          ROMJ  =CLL(J)*EXP(DSQ1)
                          DROMJ =2.0*ROMJ*BLL(J)
                          D2ROMJ=DROMJ*(2.0*BLL(J)*DSQ-3.0)
C                          D2ROMJ=DROMJ*(2.0*BLL(J)*DSQ-1.0)

                          DBMJ=ROMJ*(BLLL(J)*DSQ-BBL(J))
                          DBM =DBM+DBMJ
                          
                          ROM=ROM    +ROMJ
                          DROM=DROM  +DROMJ
                          D2ROM=D2ROM+D2ROMJ
                        ENDDO

                        DBDN  =DNS1*DBM

                        DRDN  =DNS1*DROM
                        DNSWT2=DNS2*D2ROM

                        SDEN1  =D2OM*ROM
                        SDEN2  =DNS2*ROM


                        DXP=DX+DY*COSG+DZ*COSB
                        DYP=DY+DX*COSG+DZ*COSA
                        DZP=DZ+DX*COSB+DY*COSA
                        ISM=ISCD/100

                        DXAU=ISYM(1,1,ISM)*DXP+
     *                       ISYM(1,2,ISM)*DYP*A/B+
     *                       ISYM(1,3,ISM)*DZP*A/C
                        DYAU=ISYM(2,1,ISM)*DXP*B/A+
     *                       ISYM(2,2,ISM)*DYP+
     *                       ISYM(2,3,ISM)*DZP*B/C
                        DZAU=ISYM(3,1,ISM)*DXP*C/A+
     *                       ISYM(3,2,ISM)*DYP*C/B+
     *                       ISYM(3,3,ISM)*DZP


C            WRITE(*,*) ISM,iscd,DXAU,DYAU,DZAU 


                        GRADX(IATM_P)=GRADX(IATM_P)+DXAU*DRDN
                        GRADY(IATM_P)=GRADY(IATM_P)+DYAU*DRDN
                        GRADZ(IATM_P)=GRADZ(IATM_P)+DZAU*DRDN
                        GRADB(IATM_P)=GRADB(IATM_P)+DBDN
                        GRADQ(IATM_P)=GRADQ(IATM_P)+ROM
                        GRADW(IATM_P)=GRADW(IATM_P)+DNSWT2

                        SDENS1(IATM_P)=SDENS1(IATM_P)+SDEN1
                        SDENS2(IATM_P)=SDENS2(IATM_P)+SDEN2
                        
                      ENDIF
                    ENDIF
                  ENDIF

                ENDDO

              ENDIF
            ENDIF
          ENDIF
        ENDDO
301     CONTINUE
300     CONTINUE
      ENDDO
      GO TO 1

C -----------------------------------------------
400   CONTINUE
      RETURN
      END

      SUBROUTINE SORT_BACKG(MDOC,NAMEC,NAMEO,NAMEE
     * ,NCOORD,NCOORM,IBFACT,IZMOCC,IXCC,IYCC,IZCC,ISCODE,IANUMB
     * ,IRECRD,GRADX,GRADY,GRADZ,GRADB,GRADQ,GRADW,GHESSX,GHESSB
     * ,SDENS1,SDENS2,NX,NY,NZ,NSYM,ISYM,DISPFR,RESULT,IERR)
C------------------------------------------------------
CMS      : IBFACT,IZMOCC,IXCC,IYCC,IZCC
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
C    *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C --- integer*4 version
      INTEGER          IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C ---
      REAL             GRADX(NCOORM),GRADY(NCOORM),GRADZ(NCOORM)
     *                ,GRADB(NCOORM),GRADQ(NCOORM),GRADW(NCOORM)
     *                ,GHESSX(NCOORM),GHESSB(NCOORM)
     *                ,SDENS1(NCOORM),SDENS2(NCOORM)
      INTEGER          NCOORD,NCOORM
      REAL             RESULT(*)
      INTEGER*2        ISYM(5,3,*)
      INTEGER*4        NSYM
      CHARACTER NAMEC*(*),NAMEO*(*),NAMEE*(*)
C --------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMS/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),HESS_A(15),CATOM
      CHARACTER       CATOM(15)*2
C -------------------------------------------------
C-------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_ICHAIN  - serial number of chain started from 1.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
C------------------------------------------------------
      COMMON/COMINF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM,SD1T,SD2T,CFVOL
     *               ,DOBS_AV,DMOD_AV,SCALED,SIGMA,SIGMAD
C------------------------------------------------------
      COMMON/CELL/  A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
     *             ,VOLUME,SCALEF,GMODE,DMODE,POSITIV,PRINT
      CHARACTER     GMODE*1,DMODE*1,POSITIV*1,PRINT*1
C ---
      REAL        FRTOCR(3,3),CRTOFR(3,3)
      REAL X(3),Y(3),TR(3),AM(3,3),BM(3,3)
      CHARACTER LINE*80
C------------------------------------------------------------------
      IERR=0
C --- integer*2 version
C     IPACK=10000
C --- integer*4 version
      IPACK=100000
C ---
      PI    = 4.0*ATAN(1.0)
      NIN   = 10
      M     = 99
      MD    =-ABS(MDOC)-1
C ---------------------------------------
C
C  CELL VOLUME
C
      SX   = A/NX
      SY   = B/NY
      SZ   = C/NZ
      COSA = COS(ALPHA)
      SINA = SIN(ALPHA)
      COSG = COS(GAMMA)
      SING = SIN(GAMMA)
      COSB = COS(BETA)
      SINB = SIN(BETA)
C     COSZ  DEFINES THE ANGLE BETWEEN C AND CSTAR
      COSZ = SQRT(ABS(1.-COSA**2-COSB**2-COSG**2+2.*COSA*COSB*COSG))
     *            /SING
      DV   = 8.0*SX*SY*SZ*COSZ*SING*PI**1.5
      S    = (ALPHA+BETA+GAMMA)*0.5
      VOL  = 2.0*A*B*C*
     *       SQRT(ABS(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA)))
      COEF = VOL/(FLOAT(NX)*FLOAT(NY)*FLOAT(NZ))

C --------------------------------------
      VOLUME = VOL

C      IF(PRINT.EQ.'Y') THEN
C        WRITE(LINE,*) ' coef,dv:',coef,dv 
C        CALL MSGDOC(MDOC,LINE)    
C      ENDIF
C -------------------
      CALL FRORTH(A,B,C
     *           ,ALPHA,BETA,GAMMA
     *                            ,FRTOCR,CRTOFR,IERR)
C -------------------
      IF(NCOORD.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS = 0')
        IERR=1
        RETURN
      ENDIF
      CALL MSGDOC(M,' --- START SORT ---')
C --- integer*2 version
C     CALL I2SORT1(IRECRD,NCOORD,IZCC)
C --- integer*4 version
      CALL ISORT1(IRECRD,NCOORD,IZCC)
C ---
      CALL MSGDOC(M,' --- END   SORT ---')
C ------------------------------------------------------
      SGX       = 0.0
      SGY       = 0.0
      SGZ       = 0.0
      SGB       = 0.0
      SWT       = 0.0
      SD2       = 0.0
      SHX       = 0.0
      SHB       = 0.0
      SDN1      = 0.0
      SDN2      = 0.0
      NA        = 0
      IOLD      =-1
      IBOCC_OLD = 0
      INC_OLD   =-1

      DO I=1,NCOORD

        IATM =IANUMB(I)
        IREC =IRECRD(I)
        IBOCC=IZMOCC(IREC)
        IXIN =IXCC  (IREC)
        IYIN =IYCC  (IREC)
        IZIN =IZCC  (IREC)
        ISCD =ISCODE(IREC)

        ISM  =ISCD/100
        INC  =ISCD-ISM*100

        GX   =GRADX (IREC)
        GY   =GRADY (IREC)
        GZ   =GRADZ (IREC)
        GB   =GRADB (IREC)
        WT   =GRADQ (IREC)
        D2   =GRADW (IREC)
        HX   =GHESSX(IREC)
        HB   =GHESSB(IREC)
        DN1  =SDENS1(IREC)
        DN2  =SDENS2(IREC)
      
        IF((IATM.NE.IOLD.OR.INC_OLD.NE.INC).AND.I.NE.1) THEN
          NA=NA+1

          IANUMB(NA)=IOLD

          GRADX (NA)=SGX
          GRADY (NA)=SGY
          GRADZ (NA)=SGZ
          GRADB (NA)=SGB
          GRADQ (NA)=SWT
          GRADW (NA)=SD2
          GHESSX(NA)=SHX
          GHESSB(NA)=SHB
          SDENS1(NA)=SDN1
          SDENS2(NA)=SDN2
          ISCODE(NA)=INC_OLD

          SGX       = 0.0
          SGY       = 0.0
          SGZ       = 0.0
          SGB       = 0.0
          SWT       = 0.0
          SD2       = 0.0
          SHX       = 0.0
          SHB       = 0.0
          SDN1      = 0.0
          SDN2      = 0.0
          IOLD      = IATM
          INC_OLD   = INC
          IBOCC_OLD = IBOCC

        ENDIF

        IF(I.EQ.1) THEN
          IOLD      = IATM
          INC_OLD   = INC
          IBOCC_OLD = IBOCC
        ENDIF        

        SGX  = SGX+GX
        SGY  = SGY+GY
        SGZ  = SGZ+GZ
        SGB  = SGB+GB
        SWT  = SWT+WT
        SD2  = SD2+D2
        SDN1 = SDN1+DN1
        SDN2 = SDN2+DN2
        SHX  = HX
        SHB  = HB
        IF(I.EQ.NCOORD) THEN
          NA = NA+1

          IANUMB(NA)=IOLD

          GRADX (NA)=SGX
          GRADY (NA)=SGY
          GRADZ (NA)=SGZ
          GRADB (NA)=SGB
          GRADQ (NA)=SWT
          GRADW (NA)=SD2
          GHESSX(NA)=SHX
          GHESSB(NA)=SHB
          SDENS1(NA)=SDN1
          SDENS2(NA)=SDN2
          ISCODE(NA)=INC_OLD

          IZMOCC(NA)=IBOCC

        ENDIF
      ENDDO
C -----------------------------------------------
      SGX  = 0.0
      SGY  = 0.0
      SGZ  = 0.0
      SGB  = 0.0
      SWT  = 0.0
      SD2  = 0.0
      SHX  = 0.0
      SHB  = 0.0
      SDN1 = 0.0
      SDN2 = 0.0

      IBOCC_OLD = 0
      SHESSX    = 0.0
      SHESSB    = 0.0
      SHESSD    = 0.0
      RATIO     = 0.0
      DENS_AVER = 0.0
      SHFT_AVER = 0.0
      SHFT_MAX  = 0.0
      SHFT_RMS  = 0.0
      DRV_RMS   = 0.0
      DRV_AVER  = 0.0
      HESS_RMS  = 0.0
      HESS_AVER = 0.0     
      N_SHFT    = 0
      IOLD      =-1

      DO IA=1,NA

        IATM  = IANUMB (IA)
        INC   = ISCODE (IA)
        IBOCC =IZMOCC(IA)
        IZZ = IBOCC/1000
        IT  = IBOCC-IZZ*1000
        OCC = IT/10.
        GX  = GRADX  (IA)
        GY  = GRADY  (IA)
        GZ  = GRADZ  (IA)
        GB  = GRADB  (IA)
        WT  = GRADQ  (IA)
        D2  = GRADW  (IA)
        HX  = GHESSX (IA)
        HB  = GHESSB (IA)
        DN1 = SDENS1 (IA)
        DN2 = SDENS2 (IA)

        IF(INC.GT.0) THEN
          CALL GET_NCS(MDOC,NCMAX,INC,AM,TR,IERR)
          IF(IERR.NE.0) THEN
            WRITE(LINE,
     *      '('' ERR: wrong NCS description'')') 
            CALL MSGERR(MDOC,LINE)
            RETURN
          ENDIF      
          CALL INVERT(AM,BM,IERR)
          X(1)=GX/A
          X(2)=GY/B
          X(3)=GZ/C
          CALL MVMULT(FRTOCR,X,Y)
C          X(1)=Y(1)-TR(1)
C          X(2)=Y(2)-TR(2)
C          X(3)=Y(3)-TR(3)
          CALL MVMULT(BM,Y,X)
C         CALL MVMULT(CRTOFR,Y,X)
          GX=X(1)
          GY=X(2)
          GZ=X(3)
        ELSE
          X(1)=GX/A
          X(2)=GY/B
          X(3)=GZ/C
          CALL MVMULT(FRTOCR,X,Y)
          GX=Y(1)
          GY=Y(2)
          GZ=Y(3)
        ENDIF
   
        IF(IATM.NE.IOLD.AND.IA.NE.1) THEN

          N_SHFT=N_SHFT+1    

          IZZ  = IBOCC_OLD/1000
          IT   = IBOCC_OLD-IZZ*1000
          OCC  = IT/10.
          NELC = IZFMFC(IZZ)

          IF(SWT.GT.0.0) THEN
C           SD2 =-SD2/SWT
            SD2 =-(SD2)/3.0
          ENDIF

C
C         SHB & SHX * OCC
C
C         SHB= SHB*SCALEF*SCALEF*OCC*OCC*VOL

          SHX  = SHX*SCALEF*SCALEF
          SGX  = SGX*SCALEF
          SGY  = SGY*SCALEF
          SGZ  = SGZ*SCALEF
          SGB  = SGB*SCALEF
          SD2  = SD2*SCALEF
          SDN1 = SDN1*SCALEF
          SDN2 = SDN2*SCALEF
          SWT  = SWT *SCALEF

          DIAG = SHX

          IF(DIAG.GT.0.000001) THEN
            SHFTX = SGX/DIAG
            SHFTY = SGY/DIAG
            SHFTZ = SGZ/DIAG
            DS2   = SHFTX*SHFTX+SHFTY*SHFTY+SHFTZ*SHFTZ
            DS    = SQRT(DS2)
            DSS2  = SGX*SGX+SGY*SGY+SGZ*SGZ
            DSS   = SQRT(DSS2)
          ELSE
            IF(SD2.LT.-0.0000001.AND.SHX.GT.0.0) THEN 
              SD2= -1.0
            ELSE
              SD2= 0.0
            ENDIF
            SHFTX = 0.0
            SHFTX = 0.0
            SHFTX = 0.0
            DSS2  = 0.0
            DSS   = 0.0
            DS2   = 0.0
            DS    = 0.0
          ENDIF
          IF(SWT.GT.0.0) THEN
            DENS_AVER=DENS_AVER+SDN1/SWT
          ENDIF

          SHESSX = SHESSX+SHX
          SHESSB = SHESSB+SHB

          IF(SD2.GT.0.0) SHESSD=SHESSD+SD2
          SHFT_RMS  = SHFT_RMS  + DS2
          SHFT_AVER = SHFT_AVER + DS
          DRV_RMS   = DRV_RMS   + DSS2
          DRV_AVER  = DRV_AVER  + DSS
          HESS_RMS  = HESS_RMS  + DIAG*DIAG
          HESS_AVER = HESS_AVER + DIAG
          IF(DS.GT.SHFT_MAX) SHFT_MAX=DS
           
          IF(SHX.GT.0.000001) RATIO=RATIO+SD2/SHX

          GRADX (N_SHFT)=SGX
          GRADY (N_SHFT)=SGY
          GRADZ (N_SHFT)=SGZ
          GRADB (N_SHFT)=SGB
          GRADW (N_SHFT)=SD2
          GRADQ (N_SHFT)=SWT
          GHESSX(N_SHFT)=SHX
          GHESSB(N_SHFT)=SHB
          SDENS1(N_SHFT)=SDN1
          SDENS2(N_SHFT)=SDN2
          IANUMB(N_SHFT)=IOLD
          ISCODE(N_SHFT)=0
          IZMOCC(N_SHFT)=IBOCC_OLD

          SGX  = 0.0
          SGY  = 0.0
          SGZ  = 0.0
          SGB  = 0.0
          SD2  = 0.0
          SWT  = 0.0
          SHX  = 0.0
          SHB  = 0.0
          SDN1 = 0.0
          SDN2 = 0.0
          IBOCC_OLD = IBOCC
          IOLD = IATM
        ENDIF

        IF(IA.EQ.1) THEN
          IOLD      = IATM
          IBOCC_OLD = IBOCC
        ENDIF

        SGX  = SGX+GX
        SGY  = SGY+GY
        SGZ  = SGZ+GZ
        SGB  = SGB+GB
        SWT  = SWT+WT
        SD2  = SD2+D2
        SDN1 = SDN1+DN1
        SDN2 = SDN2+DN2
        SHX  = HX
        SHB  = HB

        IF(IA.EQ.NA) THEN


          N_SHFT = N_SHFT+1    

          IZZ  = IBOCC_OLD/1000
          IT   = IBOCC_OLD-IZZ*1000
          OCC  = IT/10.
          NELC = IZFMFC(IZZ)
          IF(SWT.GT.0.0) THEN
C           SD2 =-SD2/SWT
            SD2 =-(SD2)/3.0
          ENDIF
          SD2 = SD2
C
C         SHB & SHX * OCC
C
C         SHB  = SHB*SCALEF*SCALEF*OCC*OCC*VOL
          SHX  = SHX*SCALEF*SCALEF
          SGX  = SGX*SCALEF
          SGY  = SGY*SCALEF
          SGZ  = SGZ*SCALEF
          SGB  = SGB*SCALEF
          SD2  = SD2*SCALEF
          SDN1 = SDN1*SCALEF
          SDN2 = SDN2*SCALEF
          SWT  = SWT  *SCALEF

          DIAG = SHX

          IF(DIAG.GT.0.000001) THEN
            SHFTX = SGX/DIAG
            SHFTY = SGY/DIAG
            SHFTZ = SGZ/DIAG
            DS2   = SHFTX*SHFTX+SHFTY*SHFTY+SHFTZ*SHFTZ
            DS    = SQRT(DS2)
            DSS2  = SGX*SGX+SGY*SGY+SGZ*SGZ
            DSS   = SQRT(DSS2)
          ELSE
            IF(SD2.LT.-0.0000001.AND.SHX.GT.0.0) THEN 
              SD2 = -1.0
            ELSE
              SD2 = 0.0
            ENDIF
            SHFTX = 0.0
            SHFTX = 0.0
            SHFTX = 0.0
            DS2   = 0.0
            DS    = 0.0
            DSS2  = 0.0
            DSS   = 0.0
          ENDIF
          IF(SWT.GT.0.0) THEN
            DENS_AVER = DENS_AVER+SDN1/SWT
          ENDIF

          SHESSX = SHESSX+SHX
          SHESSB = SHESSB+SHB
          IF(SD2.GT.0.0) SHESSD = SHESSD+SD2
          SHFT_RMS  = SHFT_RMS  + DS2
          SHFT_AVER = SHFT_AVER + DS
          DRV_RMS   = DRV_RMS   + DSS2
          DRV_AVER  = DRV_AVER  + DSS
          HESS_RMS  = HESS_RMS  + DIAG*DIAG
          HESS_AVER = HESS_AVER + DIAG
          IF(DS.GT.SHFT_MAX) SHFT_MAX=DS

          IF(SHX.GT.0.000001) RATIO=RATIO+SD2/SHX

          GRADX (N_SHFT)=SGX
          GRADY (N_SHFT)=SGY
          GRADZ (N_SHFT)=SGZ
          GRADB (N_SHFT)=SGB
          GRADW (N_SHFT)=SD2
          GRADQ (N_SHFT)=SWT
          GHESSX(N_SHFT)=SHX
          GHESSB(N_SHFT)=SHB
          SDENS1(N_SHFT)=SDN1
          SDENS2(N_SHFT)=SDN2
          IANUMB(N_SHFT)=IOLD
          ISCODE(N_SHFT)=0
          IZMOCC(N_SHFT)=IBOCC_OLD

        ENDIF             

      ENDDO

      NA=N_SHFT
C ---
      IF(N_SHFT.GT.0) THEN
        SHFT_AVER = SHFT_AVER/N_SHFT
        SHFT_RMS  = SHFT_RMS/N_SHFT
        SHFT_RMS  = SQRT(SHFT_RMS)
        DRV_RMS   = DRV_RMS/N_SHFT
        DRV_AVER  = DRV_AVER/N_SHFT
        DRV_RMS   = SQRT(DRV_RMS)
        HESS_RMS  = HESS_RMS/N_SHFT
        HESS_AVER = HESS_AVER/N_SHFT
        HESS_RMS  = SQRT(HESS_RMS)
        DENS_AVER = DENS_AVER/N_SHFT
        SHESSX    = SHESSX/N_SHFT
        SHESSB    = SHESSB/N_SHFT
        SHESSD    = SHESSD/N_SHFT
        RATIO     = RATIO/N_SHFT
      ELSE
        SHFT_RMS = 0.0
        SHFT_AVER= 0.0
      ENDIF

      SCALEID = 1.0
      SCALEIH = 1.0

      IF(DRV_RMS.GT.99.9) THEN
        SCALEID = DRV_RMS/10.0
      ENDIF
      IF(HESS_RMS.GT.9.9) THEN
        SCALEIH = (HESS_RMS/1.0)
      ENDIF

      IF(DRV_RMS.LT.0.1) THEN
        SCALEID = (DRV_RMS/10.0)
      ENDIF
      IF(HESS_RMS.LT.0.1) THEN
        SCALEIH = (HESS_RMS/1.0)
      ENDIF
C --------
      CALL ORCRD(M,NIN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
C --------
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.GT.0.AND.NAMEO(1:1).NE.','.AND.NAMEO(1:1).NE.' ') THEN
        NOUT  = 11
        CALL OWCRD(M,NOUT,NAMEO,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
      ELSE
        NOUT  = 0
      ENDIF
C --------
      CALL LENSTR_BL(NAMEE,LEN)
      IF(LEN.GT.0.AND.NAMEE(1:1).NE.','.AND.NAMEE(1:1).NE.' ') THEN
        NOUT1  = 12
        CALL OWCRD(M,NOUT1,NAMEE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
      ELSE
        NOUT1  = 0
      ENDIF
C --------
      IEND  =-1
      IENDW =-1
      IENDW1=-1
      IA=1
C --------
      WRITE(LINE,'('' SIGMA:'',2F12.5,F16.5)') SIGMA,SIGMAD,SCALEID
      CALL MSGDOC(MDOC,LINE)    
      WRITE(LINE,'('' <HESS>:'',2F12.5,F16.5)') SHESSX,SHESSB,SCALEIH
      CALL MSGDOC(MDOC,LINE)    
      WRITE(LINE,'('' <HESSD,RATIO>:'',2F12.5)') SHESSD,RATIO
      CALL MSGDOC(MDOC,LINE)    
      SHIFT_LIM=2.0*SIGMAD

      DENS_AVER=DENS_AVER/SCALEF
      WRITE(CR_LINE,'(''#sigma_do,sigma_diff:'',1X,3G16.5)') 
     *  SIGMA,SIGMAD,DENS_AVER
      MODE=1
      IF(NOUT.GT.0) THEN
        CALL WRCRD(M,NOUT,MODE,IENDW,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT1.GT.0) CLOSE(NOUT1) 
        RETURN
      ENDIF
      IF(NOUT1.GT.0) THEN
        CALL WRCRD(M,NOUT1,MODE,IENDW1,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT.GT.0) CLOSE(NOUT) 
        RETURN
      ENDIF

      WRITE(CR_LINE,'(''#hessian,hessian_diff:'',1X,3G16.5)') 
     * SHESSX,SHESSD,SCALEIH
      MODE=1
      IF(NOUT.GT.0) THEN
        CALL WRCRD(M,NOUT,MODE,IENDW,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT1.GT.0) CLOSE(NOUT1) 
        RETURN
      ENDIF
      IF(NOUT1.GT.0) THEN
        CALL WRCRD(M,NOUT1,MODE,IENDW1,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT.GT.0) CLOSE(NOUT) 
        RETURN
      ENDIF

      WRITE(CR_LINE,'(''#deriv_rms,deriv_aver:'',1X,3G16.5)') 
     *  DRV_RMS,DRV_AVER,SCALEID
      MODE=1
      IF(NOUT.GT.0) THEN
        CALL WRCRD(M,NOUT,MODE,IENDW,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT1.GT.0) CLOSE(NOUT1) 
        RETURN
      ENDIF
      IF(NOUT1.GT.0) THEN
        CALL WRCRD(M,NOUT1,MODE,IENDW1,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT.GT.0) CLOSE(NOUT) 
        RETURN
      ENDIF

      T = SHFT_RMS 
      IF(T.LT.0.000001) T=0.000001
      WRITE(CR_LINE,'(''#scalef,disp_four,shft_rms:'',1X,3G16.5)') 
     *  SCALEF,DISPFR,T
      MODE=1
      IF(NOUT.GT.0) THEN
        CALL WRCRD(M,NOUT,MODE,IENDW,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT1.GT.0) CLOSE(NOUT1) 
        RETURN
      ENDIF
      IF(NOUT1.GT.0) THEN
        CALL WRCRD(M,NOUT1,MODE,IENDW1,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT.GT.0) CLOSE(NOUT) 
        RETURN
      ENDIF

      IF(NOUT.GT.0) THEN
        WRITE(CR_LINE,
     *   '(''#  gradX  gradY  gradZ  Hess  WHXD  /scalef'')') 
        MODE=1
        CALL WRCRD(M,NOUT,MODE,IENDW,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(NIN) 
          IF(NOUT1.GT.0) CLOSE(NOUT1) 
          RETURN
        ENDIF
      ENDIF
      IF(NOUT1.GT.0) THEN
        WRITE(CR_LINE,
     *  '(''#    GRAD  DNS1   DNS2   Hess  WT  /scalef'')') 
        MODE=1
        CALL WRCRD(M,NOUT1,MODE,IENDW1,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT.GT.0) CLOSE(NOUT) 
        RETURN
      ENDIF

 1000 CONTINUE
      IF(IA.GT.NA) GO TO 2000
      INC = ISCODE(IA)
      IF(INC.EQ.0) THEN
        CALL RDCRD(M,NIN,MODE,IEND,IERR)
        IF(IERR.EQ.1) RETURN

        IF(IEND.NE.0) GO TO 2000
      ENDIF

      IF(MODE.EQ.0) THEN    
        ISR=CR_IATOM
         

        IF(CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *     CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *     CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R') THEN
C         CR_IATOLD=IA
          GO TO 1100
        ENDIF
        IF(IANUMB(IA).EQ.ISR.AND.IA.LE.NA) THEN 

            HX       = GHESSX(IA)
            HB       = GHESSB(IA)
            GB       = GRADB (IA)
            D2       = GRADW (IA)

            WT       = GRADQ (IA)
            DNS1     = SDENS1(IA)
            DNS2     = SDENS2(IA)

            IF(WT.GT.0.0) THEN
              DNS1=DNS1/WT
              DNS2=DNS2/WT
            ELSE
              DNS1=0.0
              DNS2=0.0
            ENDIF
           
            DIAG = HX

            IF(DIAG.GT.0.000001) THEN
              SHFTX = GRADX(IA)/DIAG
              SHFTY = GRADY(IA)/DIAG
              SHFTZ = GRADZ(IA)/DIAG
              DS2   = SHFTX*SHFTX+SHFTY*SHFTY+SHFTZ*SHFTZ
              DS2   = SQRT(DS2)
              IF(D2.GT.0.0) THEN
                SHFX  = GRADX(IA)/D2
                SHFY  = GRADY(IA)/D2
                SHFZ  = GRADZ(IA)/D2
                DS2D2 = SHFX*SHFX+SHFY*SHFY+SHFZ*SHFZ
                DS2D2 = SQRT(DS2D2)
              ELSE
                DS2D2=0.0
              ENDIF
              DSS2   = GRADX(IA)*GRADX(IA)+GRADY(IA)*GRADY(IA)+
     *                 GRADZ(IA)*GRADZ(IA)
              DSS    = SQRT(DSS2)
            ELSE
              DS2=0.0
              DSS=0.0
              DS2D2=0.0
            ENDIF

            WHX=HX/SCALEIH
            IF(WHX.GT.999.9) WHX=999.9

            WHXD=GRADW(IA)/SCALEIH
            IF(WHXD.GT.999.9) WHXD=999.9

            GRADXIA = GRADX (IA)
            GRADYIA = GRADY (IA)
            GRADZIA = GRADZ (IA)

C            IF(GMODE.EQ.'D') THEN
C              CR_XYZ(1)= DSS /SCALEF
C              CR_XYZ(2)= DNS1/SCALEF
C              CR_XYZ(3)= DNS2/SCALEF
C              CR_OCC   = WHX /SCALEF
C              CR_BISO  = WT  /SCALEF
C            ELSE
C              CR_XYZ(1)= GRADX (IA)/SCALEF
C              CR_XYZ(2)= GRADY (IA)/SCALEF
C              CR_XYZ(3)= GRADZ (IA)/SCALEF
C              CR_OCC   = WHX       /SCALEF
C              CR_BISO  = WHXD      /SCALEF
C            ENDIF

C            IF(PRINT.EQ.'Y') THEN
C              WRITE(LINE,'(I5,8F8.3)') 
C     *        IA,GRADX(IA),DS2,DS2D2,DSS,HB,HX
C     *        ,D2,wT
C              CALL MSGDOC(MDOC,LINE)    
C            ENDIF

          IA=IA+1
        ELSE
          MODE=1
        ENDIF     

      ELSE

      ENDIF
 1100 CONTINUE
      IF(NOUT.GT.0) THEN
        IF(MODE.EQ.0) THEN
          CR_XYZ(1)= GRADXIA/SCALEID
          CR_XYZ(2)= GRADYIA/SCALEID
          CR_XYZ(3)= GRADZIA/SCALEID
          CR_OCC   = WHX     
          CR_BISO  = WHXD   
        ENDIF
        CALL WRCRD(M,NOUT,MODE,IENDW,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT1.GT.0) CLOSE(NOUT1) 
        RETURN
      ENDIF
      IF(NOUT1.GT.0) THEN
        IF(MODE.EQ.0) THEN
          CR_XYZ(1)= DSS /SCALEID
          CR_XYZ(2)= DNS1/SCALEF
          CR_XYZ(3)= DNS2/SCALEF
          CR_OCC   = WHX 
          CR_BISO  = WT  /SCALEF
        ENDIF
        CALL WRCRD(M,NOUT1,MODE,IENDW1,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CLOSE(NIN) 
        IF(NOUT.GT.0) CLOSE(NOUT) 
        RETURN
      ENDIF
      GO TO 1000
C ----------------------------
 2000 CONTINUE
      WRITE(LINE,'(''N_atoms   :'',I8)') N_SHFT
      CALL MSGDOC(MDOC,LINE)    
      WRITE(LINE,'(''RMS_shift :'',G12.4)') SHFT_RMS
      CALL MSGDOC(MDOC,LINE)    
      WRITE(LINE,'(''<shift>   :'',G12.4)') SHFT_AVER
      CALL MSGDOC(MDOC,LINE)    
      WRITE(LINE,'(''MAX_shift :'',G12.4)') SHFT_MAX
      CALL MSGDOC(MDOC,LINE)    
      WRITE(LINE,'(''RMS_deriv :'',G12.4)') DRV_RMS
      CALL MSGDOC(MDOC,LINE)    
      WRITE(LINE,'(''<deriv>   :'',G12.4)') DRV_AVER
      CALL MSGDOC(MDOC,LINE)    

      CLOSE(NIN)
      IEND=1
      MODE=0     
      IF(NOUT.GT.0) THEN
        CALL WRCRD(MDOC,NOUT,MODE,IEND,IERR)
        CLOSE(NOUT)
      ENDIF
      IF(NOUT1.GT.0) THEN
        CALL WRCRD(MDOC,NOUT1,MODE,IEND,IERR)
        CLOSE(NOUT1)
      ENDIF

      RESULT(1)  =CFVOL
      RESULT(2)  =COEF
      RESULT(3)  =SIGMA
      RESULT(4)  =SIGMAD  
      RESULT(5)  =SCALEF

C     RESULT(6)  =BADD

      RESULT(7)  =SHESSX
      RESULT(8)  =SHESSD
      RESULT(9)  =DRV_RMS
      RESULT(10) =SHFT_RMS
      RESULT(11) =DISPFR

      RETURN
      END

      SUBROUTINE HESS_X(MDOC,BADD
     * ,NCOORD,NCOORM,IBFACT,IZMOCC,IXCC,IYCC,IZCC,ISCODE,IANUMB
     * ,IRECRD,GRADX,GRADY,GRADZ,GRADB,GRADQ,GRADW,GHESSX,GHESSB
     * ,NSYM,ISYM,IPRSYM,IERR)
C-----------------------------------------------------------------------
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C      <<<< HESSIAN >>>> CALC  FOR XYZ
C     PRINCIPLE IS THAT SUMMATION OVER HKL CONVERTED TO 1 DIMENSIONAL
C     INTEGRATION OVER S (SEE EQUATION 62 & 63 (PAPER))
C     ACTUALLY CALCULATES H1(XM,XM)/A1**2 (DENOTED AS HX) WITH OTHER
C     ELEMENTS OF MATRIX OBTAINED FROM SYMMETRY RELATIONS IN PAPER.
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C        (SPACE GROUP GENERAL, MULT BY VOLUME &
C     OCC**2 & SCALE**2  OUTSIDE THIS SUBROUTINE
C-----------------------------------------------------------------------
C------------------------------------------------------
CMS      : IBFACT,IZMOCC,IXCC,IYCC,IZCC
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
C    *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C --- integer*4 version
      INTEGER         IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C ---
      REAL             GRADX(NCOORM),GRADY(NCOORM),GRADZ(NCOORM)
     *                ,GRADB(NCOORM),GRADQ(NCOORM),GRADW(NCOORM)
     *                ,GHESSX(NCOORM),GHESSB(NCOORM)
      INTEGER          NCOORD,NCOORM
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C------------------------------------------------------
      COMMON/COMINF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM,SD1T,SD2T,CFVOL
     *               ,DOBS_AV,DMOD_AV,SCALED,SIGMA,SIGMAD
C------------------------------------------------------
      COMMON/CELL/   A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
     *             ,VOLUME,SCALEF,GMODE,DMODE,POSITIV,PRINT
      CHARACTER     GMODE*1,DMODE*1,POSITIV*1,PRINT*1
      COMMON/DIM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
C --------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMS/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),HESS_A(15),CATOM
      CHARACTER       CATOM(15)*2
C-------------------------------------------------------------
      REAL   BD(50),HD(50)
C------------------------------------------------------------------
      IERR=0
C --- integer*2 version
C     IPACK=10000
C --- integer*4 version
      IPACK=100000
C ---
      NATREC=NCOORD
      COEF=(FLOAT(NX)*FLOAT(NY)*FLOAT(NZ))
      SX=A/NX
      SY=B/NY
      SZ=C/NZ
C
      PI   =4.0*ATAN(1.0)
      PISQ4=4.0*PI*PI
      COSA =COS(ALPHA)
      SINA =SIN(ALPHA)
      COSG =COS(GAMMA)
      SING =SIN(GAMMA)
      COSB =COS(BETA)
      SINB =SIN(BETA)
C      COSZ  DEFINES THE ANGLE BETWEEN C AND CSTAR
      COSZ=SQRT(1.-COSA**2-COSB**2-COSG**2+2.*COSA*COSB*COSG)/SING
      DV=8.0*SX*SY*SZ*COSZ*SING*PI**1.5
C
C  CELL VOLUME
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
      COEF=COEF/VOL
      VOLUME=VOL
C      write(*,*) ' coef,dmax,dv ', coef ,dmax, dv
C --------------------------
      IBDMAX=40
      DO    I=1,20
        BD(I)=I
        HD(I)=0.
      ENDDO
      DO    I=21,IBDMAX
        BD(I)=4*I-60
        HD(I)=0.
      ENDDO
      SMAX=1.0/(DMAX)
      SSQMAX=SMAX*SMAX
      IS=INT(.5+200.*SSQMAX)
      DO    I=1,IS
        SSQ=.005*I-.0025
        S=SQRT(SSQ)
        D1=.0025*(S**(3.))*(8./3.)*PI**3
        DO    J=1,IBDMAX
          HD(J)=HD(J)+D1*EXP(-.25*SSQ*BD(J))
        ENDDO
      ENDDO
      DO    IATREC=1,NATREC
        IATM_P=IRECRD(IATREC)
        IAN   =IANUMB(IATM_P)
        IBOCC =IZMOCC(IATM_P)
        BAT   =IBFACT(IATM_P)/10.0
        SCALE=1.0
        BT=BAT+BADD
        IF(BT.GT.99.0) BT=99.0
        IZZ=IBOCC/1000
        IT =IBOCC-IZZ*1000
        OCC=IT/10.
        IF(OCC.LT.0.0001) THEN
          GHESSB(IATM_P)=0.0
          GHESSX(IATM_P)=0.0
          GO TO 100
        ENDIF
        IF(BT.LT.0.0) THEN
          CALL MSGERR(MDOC,' ERR: B-FACTOR < 0.0 ')
          IERR=1
          RETURN
        ENDIF
        IF(IZZ.LE.0.OR.IZZ.GT.NFMFC) THEN 
          CALL MSGERR(MDOC,' ERR: IDENTIFY FORMFACTORS = ?')
          IERR=1
          RETURN
        ENDIF
        NELC=IZFMFC(IZZ)
        DVOCC=OCC*DV
        HESSX=0.0
        B2 = 2.0*BT
        DO     I=1,5
        DO     J=1,5
          BDD=FMFCB(I,IZZ) + FMFCB(J,IZZ) + B2
          IF(BDD.GE.BD(IBDMAX)) BDD=BD(IBDMAX) -.01
          IF(BDD.LT.BD(1)) BDD=BD(1)
          IF(BDD.LE.BD(20)) THEN
            I1=INT(BDD)
            F1=BDD-I1
          ELSE
            D2=15+0.25*BDD
            I1=INT(D2)
            F1=D2-I1
          ENDIF
          FMC = FMFCA(I,IZZ)*FMFCA(J,IZZ)
          HESSX=HESSX+FMC*((1.-F1)*HD(I1)+F1*HD(I1+1))
        ENDDO
        ENDDO

C        SHX=HESSX*4.0*DMAX*DMAX
        BBADD=BADD
        IF(BBADD.LT.4.0) BBADD=4.0
        SHX=(HESSX*SQRT(BBADD))/2.0

        IF(NELC.EQ.1) SHX=SHX*8.0
        GHESSX(IATM_P)=SHX

        BTT=BAT+(4.0*DMAX*DMAX)+4.0
        SHB = NELC*(((8.0*PI*PI)/BTT)**2.5)*((1.0/(2.0*PI))**1.5)
        IF(NELC.EQ.1) SHB=SHB*8.0
        GHESSB(IATM_P)=SHB

 100    CONTINUE
      ENDDO
      RETURN
      END

      SUBROUTINE HESS_B(MDOC,BADD
     * ,NCOORD,NCOORM,IBFACT,IZMOCC,IXCC,IYCC,IZCC,ISCODE,IANUMB
     * ,IRECRD,GRADX,GRADY,GRADZ,GRADB,GRADQ,GRADW,GHESSX,GHESSB
     * ,NSYM,ISYM,IPRSYM,IERR)
C-----------------------------------------------------------------------
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C      <<< HESSIAN >>> FOR B   (SPACE GROUP GENERAL, MULT BY VOLUME &
C     OCC**2 & SCALE**2  OUTSIDE THIS SUBROUTINE
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C------------------------------------------------------
CMS      : IBFACT,IZMOCC,IXCC,IYCC,IZCC
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
C    *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C --- integer*4 version
      INTEGER        IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
C ---
      REAL             GRADX(NCOORM),GRADY(NCOORM),GRADZ(NCOORM)
     *                ,GRADB(NCOORM),GRADQ(NCOORM),GRADW(NCOORM)
     *                ,GHESSX(NCOORM),GHESSB(NCOORM)
      INTEGER          NCOORD,NCOORM
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C------------------------------------------------------
      COMMON/COMINF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM,SD1T,SD2T,CFVOL
     *               ,DOBS_AV,DMOD_AV,SCALED,SIGMA,SIGMAD
C------------------------------------------------------
      COMMON/CELL/   ACL,BCL,CCL,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
     *             ,VOLUME,SCALEF,GMODE,DMODE,POSITIV,PRINT
      CHARACTER     GMODE*1,DMODE*1,POSITIV*1,PRINT*1
      COMMON/DIM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
C --------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMS/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),HESS_A(15),CATOM
      CHARACTER       CATOM(15)*2
C-------------------------------------------------------------
      REAL*4          BD(50),HD(50)
C-------------------------------------------------------------
      IERR=0
C --- integer*2 version
C     IPACK=10000
C --- integer*4 version
      IPACK=100000
C ---
      NATREC=NCOORD
      COEF=(FLOAT(NX)*FLOAT(NY)*FLOAT(NZ))
      SX=ACL/NX
      SY=BCL/NY
      SZ=CCL/NZ

C
      PI   =4.0*ATAN(1.0)
      PISQ4=4.0*PI*PI
      COSA =COS(ALPHA)
      SINA =SIN(ALPHA)
      COSG =COS(GAMMA)
      SING =SIN(GAMMA)
      COSB =COS(BETA)
      SINB =SIN(BETA)
C      COSZ  DEFINES THE ANGLE BETWEEN C AND CSTAR
      COSZ=SQRT(1.-COSA**2-COSB**2-COSG**2+2.*COSA*COSB*COSG)/SING
      DV=8.0*SX*SY*SZ*COSZ*SING*PI**1.5
C
C  CELL VOLUME
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*ACL*BCL*CCL*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
      COEF=COEF/VOL
      VOLUME=VOL
      IBDMAX=40
      DO    I=1,20
        BD(I)=I
        HD(I)=0.
      ENDDO
      DO    I=21,IBDMAX
        BD(I)=4*I-60
        HD(I)=0.0
      ENDDO
      SMAX=1.0/(DMAX)
      SSQMAX=SMAX*SMAX
      IS=INT(.5+200.*SSQMAX)
      DO    I=1,IS
        SSQ=.005*I-.0025
        S=SQRT(SSQ)
        D1=.0025*(S**(6.))*PI/8.
        DO    J=1,IBDMAX
          HD(J)=HD(J)+D1*EXP(-.25*SSQ*BD(J))
        ENDDO
      ENDDO
      DO    IATREC=1,NATREC
        IATM_P=IRECRD(IATREC)
        IAN   =IANUMB(IATM_P)
        IBOCC =IZMOCC(IATM_P)
        BT    =IBFACT(IATM_P)/10.0
        BT=BT+BADD
        IZZ=IBOCC/1000
        IT =IBOCC-IZZ*1000
        OCC=IT/10.
        IF(OCC.LT.0.0001) THEN
          GHESSB(IATM_P)=0.0
          GO TO 100
        ENDIF
        IF(BT.LT.0.0) THEN
          CALL MSGERR(MDOC,' ERR: B-FACTOR < 0.0 ')
          IERR=1
          RETURN
        ENDIF
        IF(IZZ.LE.0.OR.IZZ.GT.NFMFC) THEN 
          CALL MSGERR(MDOC,' ERR: IDENTIFY FORMFACTORS = ?')
          IERR=1
          RETURN
        ENDIF
        DVOCC=OCC*DV
        SHB = 0.0
        DO     I=1,5
        DO     J=1,5
          BDD=FMFCB(I,IZZ)+FMFCB(J,IZZ)+2.*BT
          IF(BDD.GE.BD(IBDMAX)) BDD=BD(IBDMAX) -.01
          IF(BDD.LT.BD(1)) BDD=BD(1)
          IF(BDD.LE.BD(20)) THEN
            I1=INT(BDD)
            F1=BDD-I1
          ELSE
            D2=15+0.25*BDD
            I1=INT(D2)
            F1=D2-I1
          ENDIF
          CD=FMFCA(I,IZZ)*FMFCA(J,IZZ)
          SHB =SHB + CD*((1.-F1)*HD(I1)+F1*HD(I1+1))
        ENDDO
        ENDDO
C ?
        SHB=SHB*2.0
        
c        GHESSB(IATM_P)=SHB
 100    CONTINUE
      ENDDO
      RETURN
      END
C -I-
      SUBROUTINE GENDEN_ANISO(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,H2OBG,BADD,ANISO
     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C -P- GENDEN  :  generates electron density for the atomic model. 
C                (aniso version of program GENDEN )
C -S-
C
C  Dialog and Batch: 
C
C    FILE_C -  input file of coordinates.
C    FILE_D -  output file of density
C    RESOL  -  <3.0> resolution
C    GRID   -  NX NY NZ /defaults are minimal grid spacing for SF calculation/
C    LIMZ:  -  MIN MAX numbers of Z-section /default are for SF calculation/
C    BADD:  -  <0.0> additional B-factor /default Badd_calc for SF calculation/
C              0 means Badd_calc will used
C    H2O:   -  <0.0> density of solvent
C    ANISO  -  <Y>/N   - N - Biso will used for all atoms')
C    TITLE    - title of output file
C
C  Parameters of subroutine GENDEN: 
C
C      SUBROUTINE GENDEN_ANISO(MDOC,NAMEC,NAMED,TITLE
C     * ,RX,NX,NY,NZ,IZMIN,IZMAX,H2OBG,BADD,ANISO
C     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    MODE   - see above. / character*1 /
C    NAMEC  - name of input file without extention "crd".
C    NAMED  - name of output file of density.
C    RX     -  <3.0> resolution
C    NX,NY,NZ - grid /defaults are minimal grid spacing for SF calculation/
C    BADD    -  <0.0> additional B-factor /default are for SF calculation/
C    H2OBG   -  <0.0> density of solvent
C    ANISO  -  <Y>/N   - N - Biso will used for all atoms')
C    TITLE  -  title of output file, /character*80/
C    IZMIN,IZMAX  -  MIN MAX numbers of Z-section. /if IZMIN=0,IZMAX=-1 
C                    default values for SF calculation will be taken /
C    NCRDMAX - maximal number of atoms.
C    POOL    - real array POOL(MEMORY)
C    MEMORY  - dimension array POOL. 
C              MEMORY = MAPMAX + (NCRDMAX/2)*5 , where MAPMAX - maximal
C                                                size of XY-section ( NX*NY)
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C
C        output information 
C
C      real RESULT(IPRROW)
C
C      NEL   = RESULT(1)  number of electrons
C      SUMFI2= RESULT(2)  sum(Nelectrons**2)
C      BAVER = RESULT(3)  <B>   in the file
C      BMAX  = RESULT(4)   Bmax in the file
C      BMIN  = RESULT(5)   Bmin in the file
C      BAVERW= RESULT(6)   B_water in the file
C      BAVERF= RESULT(7)  <B> / including B from atomic scatt. factor /  
C      SUMDEN= RESULT(8)  sum(DENSITY) =  (sum(D)*volume)/(nx*ny*nz)
C      HH2OBG= RESULT(9)  density in the solvent region which was added.
C      SOLV  = RESULT(10) % of the solvent.
C      BADD  = RESULT(11) additional B-factor which was used.
C -I-
C ----------------------------------------------------------
CMS      : POOL
      REAL             POOL(MEMORY)
      INTEGER*2        ISYM(5,3,IPRSYM)
C---------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),TITLE*(*),ANISO*1
C==================================================================
      REAL RESULT(IPRROW)
C ----------------------------------------
C --- integer*2 version
C     IPRCRD  = (NCRDMAX/2)*5 
C ---
C --- integer*4 version
      IPRCRD  = (NCRDMAX)*14 
C ---
      IPRMAP  = MEMORY-IPRCRD
      IF(IPRMAP.LE.0) THEN
        CALL MSGERR(MDOC,' ERR0R: not memory,')
        CALL MSGERR(MDOC,
     *   '        change parameter MEMORY in main program')
        IERR=1
        RETURN
      ENDIF
C ---
      CALL SGENDEN_ANISO(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,H2OBG,BADD,ANISO
     * ,RESULT,IPRROW,ISYM,IPRSYM,POOL(IPRMAP+1),NCRDMAX
     * ,POOL(1),IPRMAP,IERR)
C ---
      RETURN
      END

      SUBROUTINE SGENDEN_ANISO(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,H2OBG,BADDR,ANISO
     * ,RESULT,IPRROW,ISYM,IPRSYM,ICOORD,NCOORM,X,IPRMAP,IERR)
C ----------------------------------------------------------
      REAL RESULT(IPRROW)
C ----------------------------------------------------------

      COMMON/CELLL/ A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,HH2OBG,ICELL
C ---
      COMMON/DIMM/  DMAX,NNX,NNY,NNZ,IIZMIN,IIZMAX,IHMAX,IKMAX,ILMAX
      COMMON/COM_VOL/ VOL
C ---------------------------------------
C --- integer*2 version
C      INTEGER*2  ICOORD(1)
C --- integer*4 version
      INTEGER  ICOORD(*)
C ---
C      INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C      INTEGER          NCOORD,NCOORM
C --
CMS      : X,ICOORD
c     REAL             X(IPRMAP)
      REAL             X(*)
C --
      INTEGER*2        ISYM(5,3,IPRSYM)
C --------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),TITLE*(*),MODE*1,P1*1,ANISO*1
      CHARACTER LINE*80,STR*80,PATH*1,EXT*3
C==================================================================
      IERR=0
      MT  =10
      MD  =-ABS(MDOC)-1
C ---
      P1   ='N'
      MODE ='A'
      RAD  =0.0
      IF(ANISO.EQ.'n') ANISO='N'
      IF(ANISO.NE.'N') ANISO='Y'
C ---
      CALL ORCRD(MD,MT,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: can not open COORD_FILE')
        GO TO 500
      ENDIF
      CALL C_AT_CR
      CLOSE(MT)
C ---
c?      MT   =11
c?      PATH =' '
c?      EXT  =' '
c?      MD   = -ABS(MDOC)-1
c?      CALL OPENUW(MT,MD,PATH,NAMED,EXT,IERR)
c?      IF(IERR.NE.0) THEN
c?        CALL MSGERR(MDOC,' ERR: OPEN DENS_FILE')
c?        GO TO 500
c?      ENDIF
c?      CLOSE(MT)
C -------------------------------------------
      STR=TITLE
      CALL LENSTR_BL(STR,LEN)
      IF(LEN.LE.0) THEN
        LEN=1
        STR=' '
      ENDIF
      IF(STR(1:3).EQ.',,,') THEN
        STR=' ---'
        LEN=4
      ENDIF
      IF(LEN.GT.60) LEN=60
      TITLE = 'GEN-DEN '//STR(1:LEN)
      LEN=LEN+8
      IF(LEN.LT.68) THEN
        DO I=LEN+1,68
          TITLE(I:I)=' '
        ENDDO
      ENDIF
C ---------------------------------------------
      IF(RX.LE.0.0) RX=3.0 
      DMAX=RX
C ----
      CALL LIMHKL(RX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
      WRITE(LINE,1020) IHMAX,IKMAX,ILMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MD,LINE)
      CALL MSGDOC(MD,
     * 'Defaults are minimal grid spacing for calculation SF')
C ----
      WRITE(LINE,1030) NXMIN,NYMIN,NZMIN
 1030 FORMAT('DEFAULT_GRID: NX,NY,NZ <',I3,',',I3,',',I3,'>') 
      CALL MSGDOC(MD,LINE)
      NNX=NX
      NNY=NY
      NNZ=NZ
      IF(NX.LE.0) NNX=NXMIN
      IF(NY.LE.0) NNY=NYMIN
      IF(NZ.LE.0) NNZ=NZMIN
      NNX   =(NNX/2)*2
      NNY   =(NNY/2)*2
      NNZ   =(NNZ/2)*2
      
      IF(NNX.LT.2*IHMAX+1) 
     * CALL MSGDOC(MDOC,'!!! Warning : Nx < 2Hmax+1')
      IF(NNY.LT.2*IKMAX+1) 
     * CALL MSGDOC(MDOC,'!!! Warning : Ny < 2Kmax+1')
      IF(NNZ.LT.2*ILMAX+1) 
     * CALL MSGDOC(MDOC,'!!! Warning : Nz < 2Lmax+1')
      NXY=NNX*NNY
      IF(NXY.GT.IPRMAP) THEN
        CALL MSGERR(MDOC,
     * ' ERR: not enough memory for one section of dens.')
        WRITE(LINE,'('' NX='',I4,'' NY='',I4,'' MEMORY-SIZE='',I6)')
     *                  NNX,NNY,IPRMAP
        CALL MSGERR(MDOC,LINE)
        WRITE(LINE,'('' must by: NX x NY < '',I6)') IPRMAP
        CALL MSGERR(MDOC,LINE)
        GO TO 500
      ENDIF
C ---
      IIZMIN=0
      IIZMAX=0
      N_SYM=NSYM
      IF(P1.EQ.'Y') N_SYM=1
      CALL SET_LIMZ(N_SYM,ISYM,NNZ,IZMAXD)
      IF(IZMIN.EQ.0.AND.IZMAX.LT.0) THEN
        IIZMIN=0
        IIZMAX=IZMAXD
      ELSE
        IIZMAX=IZMAX
        IIZMIN=IZMIN
        IF(IIZMAX.LT.IIZMIN) THEN
          T=IIZMAX
          IIZMAX=IIZMIN
          IIZMIN=T
        ENDIF
      ENDIF
C ------------------------------------------------
      BADD   = BADDR
      ISPHR  = 0
      ICELL  = 0
      DLIM   = 2.8
      HH2OBG = H2OBG

C     IF(MDOC.GT.0) THEN
        MD=-ABS(MDOC)-1
        WRITE(LINE,*) ' --- GENERATE ATOM  -DENS ---'
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' NX,NY,NZ   :',NNX,NNY,NNZ
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' IZMIN,IZMAX:',IIZMIN,IIZMAX
        CALL MSGDOC(MD,LINE)
C       WRITE(LINE,*) ' ADDITIONAL B-FACTOR :',BADD
C       CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' DENSITY OF SOLVENT :',HH2OBG
        CALL MSGDOC(MD,LINE)
C      ENDIF
C --------------------------------------
C     NCOORM=IPRCRD/14    
      CALL ATSORT_A(MDOC,NAMEC,BAVER,BMAX,BMIN,BAVERW,BAVERF,BADD
     *  ,SIGMAB,NEL,SUMFI2,NANISO
     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
     *  ,ICOORD(8*NCOORM+1)
     *  ,P1,ANISO,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) GO TO 500
      WRITE(LINE,*) 'ADDITIONAL B-FACTOR :',BADD
      CALL MSGDOC(MDOC,LINE)
C ---------------------------------------
      NXY=NNX*NNY
      CALL ATMDEN_A(MDOC,NAMED,TITLE,BADD,SOLV,X,NXY,IPRMAP
     *  ,NCOORD,NCOORM,ICOORD(1),ICOORD(NCOORM+1),ICOORD(2*NCOORM+1)
     *  ,ICOORD(3*NCOORM+1),ICOORD(4*NCOORM+1)
     *  ,ICOORD(5*NCOORM+1),ICOORD(6*NCOORM+1),ICOORD(7*NCOORM+1)
     *  ,ICOORD(8*NCOORM+1)
     *  ,SUMDEN,NSYM,ISYM,IPRSYM,IERR)
C ---------------------------------------
      WRITE(LINE,*) ' DENSITY OF SOLVENT :',HH2OBG
      CALL MSGDOC(MD,LINE)
      NX    = NNX
      NX    = NNY
      NZ    = NNZ
      IZMAX = IIZMAX
      IZMIN = IIZMIN
C     H2OBG = HH2OBG
      RAD   = DLIM

      RESULT(1)=NEL
      RESULT(2)=SUMFI2
      RESULT(3)=BAVER
      RESULT(4)=BMAX
      RESULT(5)=BMIN
      RESULT(6)=BAVERW
      RESULT(7)=BAVERF
      RESULT(8)=SUMDEN
      RESULT(9)=HH2OBG
      RESULT(10)=SOLV
      RESULT(11)=BADD
      RESULT(12)=SIGMAB
      RESULT(13)=NANISO
      RESULT(14)=0.0
      RESULT(15)=0.0
      RESULT(16)=VOL
      RESULT(17)=NSYM

      RETURN

 500  CONTINUE
      IERR=1
      RETURN
      END

      SUBROUTINE ATMDEN_A(MDOC,NAME,TITLE,BADD,SOLV,X,NXY,ISIZE
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *  ,ISCODE,IANUMB,IRECRD,U_ANISO
     *  ,SUMD,NSYM,ISYM,IPRSYM,IERR)
C -----------------------------------------------------
CMS      : X
CMS      : IBFACT,IZMOCC,IXC,IYC,IZC
      REAL             X(NXY,*)
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C --- integer*4 version
      INTEGER          IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)        
      REAL            U_ANISO(6,NCOORM)
C ---
      INTEGER          NCOORD,NCOORM
      CHARACTER        NAME*(*),TITLE*(*)
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C --------------------------------------
      COMMON/COMINFF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM
      COMMON/CELLL/   A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
      COMMON/DIMM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
      COMMON/COM_VOL/ VOL   
C --------------------------------------
      CHARACTER LINE*80
      CHARACTER TYPE*4
C-----------------------------------------------
      IERR=0
      MT=11
      M =99
      MD=-ABS(MDOC)-1
      TYPE='RI  '
      IPRINT=1
      CALL C_CR_WR
      CALL SET_TITLE(MD,A,B,C,ALPHA,BETA,GAMMA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
      CALL OWFILE(MD,MT,NAME,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) RETURN
C ----------------------------------------------
      IZCNT=-999
      IX0=0
      IY0=0
      IZ0=0
      ITR=0
C ----
      SUMRP =0.
      SUMRM =0.
      NDENSP=0
      NDENSM=0
      NZERO =0
      IZ000 =0
      SOLV=0.0
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
C     COEF=COEF/VOL
      COEF=(VOL)/(NX*NY*NZ)
      H2OBG=(H2OBG*COEF)
C -----------------------------------------------------
      IP1  =ISIZE/NXY
      IR   =IZMIN
      IREND=IZMAX
C -----------------------------------------------------
      RESOL=DMAX
      N1=NX
      N2=NY
100   CONTINUE
      IF(IR+IP1.GT.IREND) IP1 =IREND-IR+1
      N3=IP1

      CALL GENDENA(MDOC,X,N1,N2,N3,IR,IZ000,BADD
     *   ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *   ,ISCODE,IANUMB,IRECRD,U_ANISO
     *   ,VOL,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) RETURN

      DO     K=1,N3
        ISEC=IR+K-1

        CALL WDENS(MT,MDOC,IZCNT,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN,
     *             X(1,K),RESOL,IX0,IY0,IZ0,ITR)

        IF(MT.LE.0) RETURN
      ENDDO
      IR=IR+IP1
      IF(IR.LE.IREND) GO TO 100
C-----------------------------------------------------
      SUMR=SUMRP+SUMRM
      NDENS=NZERO+NDENSP+NDENSM
      SUMD=(SUMR*VOL)/(NX*NY*NZ)
      IF(ISPHR.GE.2) THEN
        WRITE(LINE,*) ' SUM-DENS       :',SUMR
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) ' N-POINT-DENS =1:',NDENSP
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) ' N-POINT-ZERO =0:',NZERO
        CALL MSGDOC(MDOC,LINE)
      ELSE IF(ISPHR.LE.1) THEN
        WRITE(LINE,200) NDENS,SUMR,SUMD
        CALL MSGDOC(MDOC,LINE)
        IF(NDENS.GT.0) SOLV=(FLOAT(NZERO)*100.)/FLOAT(NDENS)
        WRITE(LINE,201) NZERO,SOLV
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,202) NDENSP,SUMRP
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,203) NDENSM,SUMRM
        CALL MSGDOC(MDOC,LINE)
 200    FORMAT(
     *    ' N-POINT-DENS         :',I8,' ; SUM-R,SUM_DENS :',2F12.4)
 201    FORMAT(
     *    ' N-POINT-SOLV-DENS, % :',I8,F8.3)
 202    FORMAT(
     *    ' N-POINT-POSITIV-DENS :',I8,' ; SUM-POSITIV-DENS :',F12.4)
 203    FORMAT(
     *    ' N-POINT-NEGATIV-DENS :',I8,' ; SUM-NEGATIV-DENS :',F12.4)
      ENDIF
      RETURN
      END

      SUBROUTINE ATSORT_A(MDOC,NAME,BAVER,BPEAK,BMIN,BAVERW,BAVERF
     *  ,BADD,SIGMAB,NEL,SUMFI2,NANISO
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *  ,ISCODE,IANUMB,IRECRD,U_ANISO
     *  ,P1,ANISO,NSYM,ISYM,IPRSYM,IERR)
C -------------------------
CMS      : IBFACT,IZMOCC,IXC,IYC,IZC
      INTEGER   MDOC,IERR
      CHARACTER NAME*(*),NCS_FLAG*1,P1*1,ANISO*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C --- integer*4 version
      INTEGER        IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)        
      REAL            U_ANISO(6,NCOORM)
C ---
      INTEGER          NCOORD,NCOORM
C ---
C ------------------------------------------------------------
      COMMON/CRDINF/ CR_CELL,CR_SCALE,CR_U,CR_NSPGR,CR_SETT
     *              ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT
     *              ,CR_M_NCS,CR_V_NCS
     *              ,CR_CF1,CR_CF2,CR_TOV
     *              ,CR_NSYM,CR_NCS,CR_MULT_FLAG,CR_MODEL,CR_ISYMOP
     *              ,CR_CD_PDB,CR_NAME_PDB,CR_DATE_PDB,CR_TITLE
     *              ,CR_RESL_PDB,CR_RFAC_PDB
     *              ,CR_SYMOP,CR_SPGR,CR_PDB_REC
     *              ,CR_FLAG_HA,CR_TIME
      REAL      CR_CELL(6)
      REAL      CR_SCALE(3,3)
      REAL      CR_U(3)
      REAL      CR_ORT_TO_FRAC(3,3)
      REAL      CR_FRAC_TO_ORT(3,3)
      REAL      CR_M_NCS(3,3)
      REAL      CR_V_NCS(3)
      REAL      CR_CF1,CR_CF2,CR_TOV
      INTEGER*4 CR_NSPGR
      INTEGER*4 CR_SETT
      INTEGER*4 CR_NSYM
      INTEGER*4 CR_NCS
      INTEGER*4 CR_MULT_FLAG
      INTEGER*4 CR_MODEL
      INTEGER*4 CR_ISYMOP
      CHARACTER CR_CD_PDB*4
      CHARACTER CR_NAME_PDB*40
      CHARACTER CR_DATE_PDB*9
      CHARACTER CR_TITLE*80
      CHARACTER CR_RESL_PDB*40
      CHARACTER CR_RFAC_PDB*40
      CHARACTER CR_SYMOP*24
      CHARACTER CR_SPGR*24
      CHARACTER CR_PDB_REC*6
      CHARACTER CR_FLAG_HA*1
      CHARACTER CR_TIME*20
C ---------------------------
C  CR_CELL(6)         -  Unit cell parameters  
C  CR_SCALE(3,3)      - Matrix_PDB SCALE: from ort. of data entry to fract.
C  CR_U(3)            -   Vector_PDB U    
C  CR_ORT_TO_FRAC(3,3)-
C  CR_FRAC_TO_ORT(3,3)-
C  CR_M_NCS(3,3)      -
C  CR_V_NCS(3)        -
C  CR_NSPGR     -  Space group number
C  CR_SETT      -  Setting number
C  CR_NSYM      -  
C  CR_NCS       -  
C  CR_ISYMOP    -  
C  CR_MULT_FLAG -
C  CR_CD_PDB    -  PDB code
C  CR_NAME_PDB  -  PDB name
C  CR_DATE_PDB  -  PDB creating date
C  CR_TITLE     -  PDB compaund
C  CR_RESL_PDB  -
C  CR_RFAC_PDB  -
C  CR_MODEL     -
C  CR_SYMOP     -
C  CR_SPGR      -  PDB symbilic name of space group
C  CR_PDB_REC   -  PDB name of record
C  CR_FLAG_HA   -
C  CR_TIME      -
C --------------
      COMMON /CRDATM/ CR_XYZ,CR_CSD,CR_BISO,CR_BSD,CR_ANIS
     *               ,CR_ASD,CR_OCC,CR_OSD,CR_UDATA
     *               ,CR_MULT_FACTOR
     *               ,CR_IATOM,CR_IRES,CR_IATOLD,CR_IGROUP
     *               ,CR_ANAME,CR_ASYMB,CR_ATYPE,CR_ALT,CR_CORR
     *               ,CR_BTYPE,CR_RNAME,CR_PNUM
     *               ,CR_RTYPE,CR_TERM,CR_CHAIN,CR_GROUP
     *               ,CR_FSC,CR_FSA,CR_FLAG_USER,CR_LINE
      REAL   CR_XYZ(3) 
      REAL   CR_CSD(3)  
      REAL   CR_BISO 
      REAL   CR_BSD  
      REAL   CR_ANIS(6) 
      REAL   CR_ASD (6) 
      REAL   CR_OCC  
      REAL   CR_OSD  
      REAL   CR_UDATA(6)  
      INTEGER*4 CR_MULT_FACTOR
      INTEGER*4 CR_IATOM   
      INTEGER*4 CR_IRES 
      INTEGER*4 CR_IATOLD  
      INTEGER*4 CR_IGROUP
      CHARACTER CR_ANAME*4  
      CHARACTER CR_ASYMB*4  
      CHARACTER CR_ATYPE*1  
      CHARACTER CR_ALT*1 
      CHARACTER CR_CORR*1  
      CHARACTER CR_BTYPE*1 
      CHARACTER CR_RNAME*3
      CHARACTER CR_PNUM*7
      CHARACTER CR_RTYPE*16
      CHARACTER CR_CHAIN*2
      CHARACTER CR_GROUP*4
      CHARACTER CR_TERM*8
      CHARACTER CR_FSC*1
      CHARACTER CR_FSA*1
      CHARACTER CR_FLAG_USER*1
      CHARACTER CR_LINE*80
C ---------------------------------------
C CR_XYZ   - coordinates.      
C CR_CSD   - sd of coords.
C CR_BISO  - iso.temp.factor       
C CR_BSD   - sd iso.temp.factor       
C CR_ANIS  - aniso.temp.factor  
C CR_ASD   - sd aniso           
C CR_OCC   - occupancy.         
C CR_OSD   - sd occupancy.            
C CR_MULT_FACTOR  - 1, 2=1/2, 3=1/3, 4=1/4, 6=1/6, 8=1/8, 12=1/12 
C CR_IATOM   - global serial number of atom in structure.
C CR_IRES    - serial number of each residue in chain 
C CR_IATOLD  - serial number of atom from the file.
C CR_IGROUP  - serial number of group started from 1.
C CR_ANAME   - atom's name   - 4 chars.           
C CR_ASYMB   - atom's symbol - 4 chars.  / for SF /         
C CR_ATYPE   - atom's type: "M" missing,"R" rebuild,"D" dummy, "U" unknown. 
C CR_ALT     - ID of alternative position.      
C CR_CORR    - ID of correlated alt. positions. 
C CR_BTYPE   - "I" or "." - iso,"A" - aniso,"O" - overal. 
C CR_RNAME   - 3 letters code of residue. 
C CR_PNUM    - chainID + residue's number + insertion code.
C CR_RTYPE   - type of residue: "pept","DNA","RNA,"solv",...
C CR_TERM    - type of terminus of chain: "NH3", "COO", ...
C CR_CHAIN   - name of chain
C CR_GROUP   - name of group
C CR_FSC     - flag of coord's sigma
C CR_FSA     - flag of aniso's sigma
C CR_FLAG_USER -
C CR_LINE      - 
C -------------------------------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMSS/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),CATOM
      CHARACTER       CATOM(15)*2
C ---
      COMMON/DIMM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
      COMMON/CELLL/    A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C -----------------------------------------------------------------
      INTEGER     NCSOP
      REAL        AMNCS(3,3),TRNCS(3)
C------------------------------------------------------------------
      REAL        XA(3),YA(3),XSU(3),XFU(3)
      REAL        TRNS(3,2),XS(3),XF(3),Y(3)
      INTEGER     IPOINT(3)
c     INTEGER     JXXX(200),JYYY(200),JZZZ(200)
C----------------------------------------------------------------
      INTEGER     MODE
      REAL        RLATT(6)
      REAL        ROT(9),TR(3),U(6),UR(6)
      CHARACTER   ATOM*4,CHAR4*4,CHAR2*2,RES3*3
      CHARACTER   STR*80,NCSF*1,GID*4
C==================================================================
      ICOUNT= 0
      NONH  = 0
      NEL   = 0
      SUMFI2= 0
      NFMFC = 0
C --- integer*2 version
C     IPACK =10000
C --- integer*4 version
      IPACK =100000
C ---
      IERR  = 0
      NIN   = 10
      M     = 99
      MD    = -ABS(MDOC)-1
C --------
      CALL ORCRD(MD,NIN,NAME,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      A     = CR_CELL(1)
      B     = CR_CELL(2)
      C     = CR_CELL(3)
      ALPHA = CR_CELL(4)
      BETA  = CR_CELL(5)
      GAMMA = CR_CELL(6)
      CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *                            ,FRTOCR,CRTOFR,IERR)
      ACELL=A
      BCELL=B
      CCELL=C
      AANGL=ALPHA
      BANGL=BETA
      GANGL=GAMMA
      RLATT(1)=ACELL
      RLATT(2)=BCELL
      RLATT(3)=CCELL
      RLATT(4)=AANGL
      RLATT(5)=BANGL
      RLATT(6)=GANGL
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C -----------------------------------------
      NCRSYM=0
      NCS_FLAG='N'
      NCSOP=0
      CALL GET_NCS(MDOC,NCMAX,NCSOP,AMNCS,TRNCS,IERR)
      IF(IERR.NE.0) THEN
        WRITE(STR,
     *  '('' ERR: wrong NCS description'')') 
        CALL MSGERR(MDOC,STR)
        RETURN
      ENDIF
      IF(NCSOP.GT.0) THEN
        IGR=0
        CALL GET_ASYMM(MDOC,NASMAX,NGR,NCH,IGR,ICH,INC,MLT,I_ATM
     *                 ,NCSF,GID,IERR)
        IF(IERR.NE.0) THEN
          WRITE(STR,
     *    '('' ERR: wrong NCS description'')') 
          CALL MSGERR(MDOC,STR)
          RETURN
        ENDIF
        IF(NGR.GT.0) THEN
          DO IGR=1,NGR
            CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            IF(NCSF.EQ.'N'.OR.NCSF.EQ.'n') THEN
              NCS_FLAG='Y'
              GO TO 520
            ENDIF
          ENDDO
        ENDIF
      ENDIF
 520  CONTINUE
      IF(NCS_FLAG.EQ.'Y') THEN
        WRITE(STR,
     *  '(''NUMBER OPERATORS OF NON-CRYST.SYMMETRY:'',I5)') NCSOP
        CALL MSGDOC(MDOC,STR)
        IF(NCSOP.GT.0) THEN
          CALL MSGDOC(MD,' ')
          CALL MSGDOC(MD,'  X-NEW           X-0      TX')
          CALL MSGDOC(MD,'  Y-NEW  = [M] *  Y-0  +   TY')
          CALL MSGDOC(MD,'  Z-NEW           Z-0      TZ')
          CALL MSGDOC(MD,' ')
          CALL MSGDOC(MD,' ORTOGONAL COORDINATE SYSTEM')
          CALL MSGDOC(MD,'  COORDINATES IN ANGSTROMS')
          CALL MSGDOC(MD,' ')
          DO     I=1,NCSOP
            CALL GET_NCS(MD,NCMAX,I,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            WRITE(STR,500) I
            CALL MSGDOC(MD,STR)
  500       FORMAT('  OPERATORS OF NON-CRYST.SYMMETRY :',I5)
            CALL ANGFIX(MD,AMNCS,ALPH,BET,GAMM)
            WRITE(STR,510) (TRNCS(L),L=1,3)
            CALL MSGDOC(MD,STR)
  510       FORMAT(' TRANSLATION VECTOR :',3F10.5,' /ANGSTROM/')
          ENDDO
        ELSE
          WRITE(STR,
     *    '('' ERR: NUMBER OF NCS-OPERATORS:'',I5)') NCSOP
          CALL MSGERR(MDOC,STR)
          IERR=1
          RETURN
        ENDIF
      ENDIF
C--------------------------------------------------
      DLM=DLIM+0.5
      XS(1) =0.
      XS(2) =0.
      XS(3) =0.
      XF(1) =1.
      XF(2) =1.
      XF(3) =1.

      ZFFS  =FLOAT(IZMIN)/FLOAT(NZ)-DLM/C
      ZFFF  =FLOAT(IZMAX)/FLOAT(NZ)+DLM/C

      XSU(1)=DLM/A
      XSU(2)=DLM/B
      XSU(3)=DLM/C
      XFU(1)=1.-DLM/A
      XFU(2)=1.-DLM/B
      XFU(3)=1.-DLM/C
C
      BAVER  = 0.0
      BMIN   = 1.E30
      BPEAK  =-1.E30
      BAVERW = 0.0 
      BAVERF = 0.0
      MATOMW = 0
      SIGMAB = 0.0
      NBATOM = 0
      NANISO = 0
      NINALL = 0
      IATT   = 0
      IAT_IN = 0
      I      = 0
      NSUME  = 0
      NCRSYM = 0
      SCHRG  = 0.0
      CHRGP  = 0.0
      CHRGM  = 0.0
      D1=0.0
      D2=0.0
      D3=0.25/(DMAX*DMAX)
C ===========================================
      IEND=-1
1100  CONTINUE
        IF(NCS_FLAG.EQ.'Y'.AND.NCRSYM.GT.NCSOP) NCRSYM=0
        IF(NCRSYM.NE.0) THEN


        ELSE

          MODE = 0
          CALL RDCRD(M,NIN,MODE,IEND,IERR)
          IF(IERR.EQ.1) RETURN
          IF(IEND.NE.0) GO TO 2000
          IF(MODE.GT.0) GO TO 1000    

          IF(CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *       CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *       CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R')
     *    GO TO 1000
          IAT_IN=IAT_IN+1
        ENDIF
C--------------------------------------------------------

        ATOM=CR_ANAME
        IRES=CR_IRES
        RES3=CR_RNAME
        OCC =CR_OCC
        BT  =CR_BISO

        ISERIAL=CR_IATOM
        IF(CR_MULT_FACTOR.GT.1) THEN
          OCC = OCC / FLOAT(CR_MULT_FACTOR)
        ENDIF

        U(1)=CR_BISO
        U(2)=-1.0
        U(3)=0.0
        U(4)=0.0
        U(5)=0.0
        U(6)=0.0

        IF(ANISO.EQ.'N') CR_BTYPE='I'

        IF(CR_BTYPE.EQ.'A') THEN

          NANISO=NANISO+1

          U(1)=CR_ANIS(1)
          U(2)=CR_ANIS(2)
          U(3)=CR_ANIS(3)
          U(4)=CR_ANIS(4)
          U(5)=CR_ANIS(5)
          U(6)=CR_ANIS(6)

          CALL MDET2(U,DET)
     
          IF(DET.LT.0.0000001) THEN

            WRITE(STR,*) ' WARNING: Determinant(U) =< 0 :',DET
            CALL MSGERR(MDOC,STR)
            WRITE(STR,*) 
     *'          for atom: ',ATOM,', res:',IRES,', CHAIN:',CR_IGROUP
            CALL MSGERR(MDOC,STR)
            WRITE(STR,'(''          U:'',6F9.5)')
     *      U(1),U(2),U(3),U(4),U(5),U(6)
            CALL MSGERR(MDOC,STR)
            WRITE(STR,*) 
     *'          atom will not be used'
            CALL MSGERR(MDOC,STR)

            GO TO 1100

          ENDIF

          CALL UO_TO_B(U,U)

        ENDIF 

        SURF  =CR_BISO
        CHARGE=CR_BISO

        IF(CR_MULT_FACTOR.GT.1) THEN
          OCC = OCC / FLOAT(CR_MULT_FACTOR)
        ENDIF

        RVDW = 1.5
        IF(ISPHR.EQ.1.OR.ISPHR.EQ.4) THEN
          SURF  =CR_OCC
          CHARGE=CR_OCC
          OCC   =1.0
        ENDIF

        IF(ISPHR.EQ.1.AND.CHARGE.EQ.0.0) GO TO 1000
C--------------------------------------------------------
        XA(1)=CR_XYZ(1)
        XA(2)=CR_XYZ(2)
        XA(3)=CR_XYZ(3)


c        WRITE(STR,400) ATOM,IRES,RES3,ICHAIN,
c     *           XA(1),XA(2),XA(3),OCC,BT
c 400    FORMAT(6X,A4,I4,1X,A3,I3,3F10.5,F6.3,F6.1)
c        CALL MSGERR(MDOC,STR)

        IF(NCS_FLAG.EQ.'Y') THEN
          IF(NCRSYM.EQ.0) THEN
            IGR_OLD = CR_IGROUP
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description for chain :'',I5)') 
     *          IGR_OLD
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
              IF(IGOLD.EQ.IGR_OLD.AND.INC.EQ.0) THEN
                ICHAIN=ICHOLD
                NCRSYM=1
                GO TO 410
              ENDIF
            ENDDO
            WRITE(STR,
     *      '('' ERR: wrong NCS description for chain :'',I5)') 
     *      IGR_OLD
            CALL MSGERR(MDOC,STR)
            IERR=1
            RETURN
  410       CONTINUE
          ELSE
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description'')') 
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
c            write(*,*) NCSF,NCRSYM,GID(1:2),CHAIN
              IF((NCSF.EQ.'N'.OR.NCSF.EQ.'n').AND.
     *           INC.EQ.NCRSYM.AND.ICHOLD.EQ.ICHAIN) GO TO 530
            ENDDO
            NCRSYM=NCRSYM+1
            GO TO 1000  
 530        CONTINUE
            CALL GET_NCS(MDOC,NCMAX,INC,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            CALL MVMULT(AMNCS,CR_XYZ,XA)
            XA(1)=XA(1)+TRNCS(1)
            XA(2)=XA(2)+TRNCS(2)
            XA(3)=XA(3)+TRNCS(3)
            NCRSYM=NCRSYM+1
          ENDIF
        ENDIF

        CALL MVMULT(CRTOFR,XA,YA)

c        XA(1)=AMOD(YA(1)/1.,1.)
c        XA(2)=AMOD(YA(2)/1.,1.)
c        XA(3)=AMOD(YA(3)/1.,1.)

        XA(1)=YA(1)
        XA(2)=YA(2)
        XA(3)=YA(3)

C --------------------------------------------------------
        IZZ=1
        CHAR2=CR_ASYMB(1:2)
        CHAR4=CR_ASYMB
 610    CONTINUE
        IF(NFMFC.GT.0) THEN
          DO IM=1,NFMFC
            IF(CHAR2.EQ.CATOM(IM)) THEN
              IZZ=IM
              IZE=IZFMFC(IZZ)
              GO TO 600
            ENDIF
          ENDDO
        ENDIF
        CALL GET_SFA(CHAR4
     *      ,N,NELC,A1,A2,A3,A4,B1,B2,B3,B4,CC,FI,FII,RAD,IERR)
        IF(IERR.NE.0.OR.NFMFC.GE.NFMMAX) THEN
          IF(IERR.NE.0) THEN
            IF(ICOUNT.LT.4) THEN
              WRITE(STR,*) ' ERR: atom"s type "',CHAR4,'" not found'
              CALL MSGERR(MDOC,STR)
              WRITE(STR,
     *        '('' ERR: for atom '',I6,'' name:'',A4,I5,'' '',A3)')
     *        I+1,ATOM,IRES,RES3
              ICOUNT=ICOUNT+1
            ELSE IF(ICOUNT.EQ.4) THEN
              CALL MSGERR(MDOC,'   ... more ...')
              ICOUNT=ICOUNT+1
            ENDIF
            IERR=0
          ELSE IF(NFMFC.GE.NFMMAX) THEN
            IF(ICOUNT.LT.4) THEN
              WRITE(STR,*) ' ERR: too many atom"s type > ',NFMMAX
              CALL MSGERR(MDOC,STR)
              ICOUNT=ICOUNT+1
            ELSE IF(ICOUNT.EQ.4) THEN
              CALL MSGERR(MDOC,'   ... more ...')
              ICOUNT=ICOUNT+1
            ENDIF
          ENDIF
          IF(ICOUNT.LE.4) THEN
            WRITE(STR,*) ' ERR: default type  is "N   "'
            CALL MSGERR(MDOC,STR)
          ENDIF
          CHAR2='N '
          CHAR4='N   '
          GO TO 610
        ENDIF
        NFMFC=NFMFC+1
        IZFMFC(NFMFC)=NELC
        FMFCA(1,NFMFC)=A1
        FMFCB(1,NFMFC)=B1
        FMFCA(2,NFMFC)=A2
        FMFCB(2,NFMFC)=B2
        FMFCA(3,NFMFC)=A3
        FMFCB(3,NFMFC)=B3
        FMFCA(4,NFMFC)=A4
        FMFCB(4,NFMFC)=B4
        FMFCA(5,NFMFC)=CC
        FMFCB(5,NFMFC)=0.0
        CATOM(NFMFC)=CHAR2
        IZZ=NFMFC
        IZE=NELC
        RVDW=RAD
 600    CONTINUE
C ----------------------------------------
        I=I+1
        IF(CR_ASYMB(1:2).NE.'H '.AND.CR_ASYMB(1:2).NE.'D ') THEN
          NONH  = NONH +1
        ENDIF
        NEL=NEL+IZE*OCC
        SUMFI2 = SUMFI2+IZE*IZE*OCC*OCC
C       BT=BT+BADD
        IF(BT.LT.2.0) BT = 2.0
        IF(ISPHR.EQ.3) THEN
          IZR=RVDW*1000.0
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ELSE IF(ISPHR.EQ.4) THEN
          IF(SURF.GT.0.0) THEN
            IZR=RVDW*1000.0
          ELSE
            IZR=DLIM *1000.0
          ENDIF
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ELSE IF(ISPHR.EQ.2) THEN
          IZR=DLIM *1000.0
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ELSE IF(ISPHR.EQ.1) THEN
          BB=BT
          IF(BB.GT.99.0) BB=99.0
          IBB=BB
          IF(ABS(CHARGE).GT.1.50) CHARGE=(ABS(CHARGE)/CHARGE)*1.50
          ICHRG=CHARGE*100.0+160.0
          IZR=ICHRG*100.0+IBB
          SCHRG=SCHRG+CHARGE
          IF(CHARGE.GT.0.0) CHRGP=CHRGP+CHARGE
          IF(CHARGE.LT.0.0) CHRGM=CHRGM+CHARGE
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ELSE
          IF(BT.GT.99.0) BT =99.0
          IZR=BT*10.0
          D2=D2+IZE*IZE*OCC*OCC
          D4=0.0
          DO IGS=1,5
            D4= D4+FMFCA(IGS,IZZ)*EXP(-(BT+FMFCB(IGS,IZZ))*D3)
          ENDDO
          D4= OCC * D4
          D1=D1+D4*D4
          IF(OCC.GT.99.9) OCC=99.9
          IOCC        =OCC*10.0
          INEOCC=IZZ*1000+IOCC
        ENDIF
        IF(ABS(INEOCC).GT.32766.0) 
     *  INEOCC=(ABS(INEOCC)/INEOCC)*32766.0
        IF(ABS(IZR).GT.32600.0) IZR=(ABS(IZR)/IZR)*32600.0
C -----
        IF(OCC.GT.0.0000001) THEN
          BAVER   = BAVER+BT
          SIGMAB  = SIGMAB + BT*BT
          IF(CR_RNAME.NE.'HOH') THEN
            BAVERW = BAVERW +BT 
            MATOMW = MATOMW +1
          ENDIF
          IF(BMIN .GT.BT ) BMIN =BT
          IF(BPEAK.LT.BT ) BPEAK=BT
          NBATOM=NBATOM+1
        ENDIF
C ------------------------------
        JJNS=0
        N_SYM=NSYM
        IF(P1.EQ.'Y') N_SYM=1
        DO     ISM=1,N_SYM
          ROT(1) = ISYM(1,1,ISM)
          ROT(2) = ISYM(2,1,ISM)
          ROT(3) = ISYM(3,1,ISM)
          ROT(4) = ISYM(1,2,ISM)
          ROT(5) = ISYM(2,2,ISM)
          ROT(6) = ISYM(3,2,ISM)
          ROT(7) = ISYM(1,3,ISM)
          ROT(8) = ISYM(2,3,ISM)
          ROT(9) = ISYM(3,3,ISM)
          TR(1)  = ISYM(4,1,ISM)/REAL(ISYM(5,1,ISM))
          TR(2)  = ISYM(4,2,ISM)/REAL(ISYM(5,2,ISM))
          TR(3)  = ISYM(4,3,ISM)/REAL(ISYM(5,3,ISM))

          X =ROT(1)*XA(1 ) +ROT(2)*XA(2) +ROT(3)*XA(3)
     .       + TR(1)
          YY=ROT(4)*XA(1 ) +ROT(5)*XA(2) +ROT(6)*XA(3)
     .       + TR(2)
          Z =ROT(7)*XA(1 ) +ROT(8)*XA(2) +ROT(9)*XA(3)
     .       + TR(3)

          Y(1)=X
          Y(2)=YY
          Y(3)=Z

          DO     J=1,3
21          IF(Y(J).LT.XS(J)) THEN
              Y(J)=Y(J)+1.
              GO TO 21
            ENDIF
22          IF(Y(J).GE.XF(J)) THEN
              Y(J)=Y(J)-1.
              GO TO 22
            ENDIF
            IPOINT(J)=1
            TRNS(J,1)=0.
            IF(Y(J).LE.XSU(J)) THEN
              IPOINT(J)=IPOINT(J)+1
              TRNS(J,2)=1.
            ELSE IF(Y(J).GE.XFU(J)) THEN
              IPOINT(J)=IPOINT(J)+1
              TRNS(J,2)=-1.
            ENDIF
          ENDDO

          INALL=0

          DO     IX=1,IPOINT(1)
            DO     IY=1,IPOINT(2)
              DO     IZ=1,IPOINT(3)
c                DO     JZ=1,3
                  JZ=2
                  ZZZ =Y(3)+TRNS(3,IZ)+FLOAT(JZ-2)

                  IF(ZZZ.GE.ZFFS.AND.ZZZ.LE.ZFFF) THEN

                    IXXX=(Y(1)+TRNS(1,IX))*FLOAT(IPACK)
                    IYYY=(Y(2)+TRNS(2,IY))*FLOAT(IPACK)
                    IZZZ= ZZZ             *FLOAT(IPACK)
                    IATT=IATT+1
                    IF(IX.EQ.1.AND.IY.EQ.1.AND.IZ.EQ.1) INALL=1
                    IF(IATT.GT.NCOORM ) THEN
                      WRITE(STR,*) ' ERR: too many atoms > ',NCOORM
                      CALL MSGERR(MDOC,STR)
                      IERR=1
                      RETURN
                    ENDIF
                    NSUME         = NSUME+IZE
                    IBFACT(IATT)  = IZR
                    IZMOCC(IATT)  = INEOCC
C --- integer*2 version
c                    IF(IXXX.LT.-32766.OR.IXXX.GT.32766.OR.
c     *                 IYYY.LT.-32766.OR.IYYY.GT.32766.OR.
c     *                 IZZZ.LT.-32766.OR.IZZZ.GT.32766) THEN
c                      CALL MSGERR(MDOC,' ERR: !X,Y,Z!(u.c.) > 3.2766')
c                      IERR=1
c                      RETURN
c                    ENDIF
c --------------------
                    IXC(IATT)   =IXXX
                    IYC(IATT)   =IYYY
                    IZC(IATT)   =IZZZ
                    ITRX=TRNS(1,IX)+1.001
                    ITRY=TRNS(2,IY)+1.001
                    ITRZ=TRNS(3,IZ)+1.001
                    ISCODE(IATT)=ISM*100+INC
                    IANUMB(IATT)=0

                    IF(CR_BTYPE.EQ.'A') THEN

                      IANUMB(IATT)=1

                      IF(ISM.GT.1) THEN
                        CALL B_SYM(U,UR,ROT)
                      ELSE
                        CALL MCOPY(U,UR)
                      ENDIF

                      CALL B_TO_UO(Ur,Ur)

                      U_ANISO(1,IATT)=Ur(1)
                      U_ANISO(2,IATT)=Ur(2)
                      U_ANISO(3,IATT)=Ur(3)
                      U_ANISO(4,IATT)=Ur(4)
                      U_ANISO(5,IATT)=Ur(5)
                      U_ANISO(6,IATT)=Ur(6)
                    ENDIF

                    IRECRD(IATT)=IATT        

                    IF(ICELL.EQ.1) THEN
                      INEOCC=ISM*27+ITRX+ITRY*3+ITRZ*9
                      IF(OCC.LE.0.0001) INEOCC=-1
                      IZMOCC(IATT)=INEOCC
                    ENDIF
                  ENDIF

c                ENDDO
              ENDDO
            ENDDO
          ENDDO
        ENDDO
C ------------------------
        NINALL=NINALL+INALL
1000    CONTINUE
      GO TO 1100
C==================================================
 2000 MATOMS =I
      NATOMS =IATT
      IF(NBATOM.GT.0) THEN
        BAVER =BAVER /NBATOM
        SIGMAB=SIGMAB/NBATOM
        SIGMAB=SQRT(ABS(SIGMAB-BAVER*BAVER))
      ELSE
        SIGMAB=0.0
      ENDIF
      IF(MATOMW.GT.0) THEN
        BAVERW=BAVERW/MATOMW
      ENDIF
C ------------------------------------------------------
      M=99
      IF(IATT.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS = 0')
        IERR=1
        CLOSE(NIN)
        RETURN
      ENDIF
      CALL MSGDOC(M,' --- START SORT ---')
C      CALL SORT4(IZC,IATT,IBFACT,IZMOCC,IXC,IYC)
      CALL ISORT1(IZC,IATT,IRECRD)
      CALL MSGDOC(M,' --- END   SORT ---')
C ------------------------------------------------------
      IF(ISPHR.EQ.0) THEN
        D1=SQRT(ABS(D1))
        D2=SQRT(ABS(D2))
        IF(ABS(D3).GT.0.0000000001) THEN
          BAVE=ALOG(D2/D1)/D3
        ELSE
          BAVE=0.0
        ENDIF
        BAVERF = BAVE

        CALL SETBADD(DMAX,BAVE,NX,NY,NZ,BCALC)

        WRITE(STR,'('' Baver/include SF/ :'',F8.3)') BAVERF
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,'('' Badd_in,Badd_calc:'',2F8.3)') BADD,BCALC
        CALL MSGDOC(MDOC,STR)

        BADD_IN = BADD
        IF(BADD.LE.-0.000001) BADD=BCALC        

c        IF(BMIN.GT.10.0) THEN
c          BADD= - BMIN+5.0
c          BAVE_NEW=BAVE+BADD
c          CALL SETBADD(DMAX,BAVE_NEW,NX,NY,NZ,BCALC_NEW)
c          WRITE(STR,'('' Baver/include SF/_NEW :'',F8.3)') BAVE_NEW
c          CALL MSGDOC(MDOC,STR)
c          WRITE(STR,'('' Badd_calc/NEW/:'',F8.3)') BCALC_NEW
c          CALL MSGDOC(MDOC,STR)
c          IF(BADD_IN.LT.0.0) BADD=BCALC_NEW        
c        ENDIF

      ENDIF
      WRITE(STR,430) IAT_IN
      CALL MSGDOC(MDOC,STR)
      IF(NCS_FLAG.EQ.'Y') THEN
        WRITE(STR,434) MATOMS
        CALL MSGDOC(MDOC,STR)
      ENDIF
      IF(MATOMS.NE.NONH) THEN
        WRITE(STR,433) NONH
        CALL MSGDOC(MDOC,STR)
      ENDIF
      WRITE(STR,431) NATOMS
      CALL MSGDOC(MDOC,STR)
      WRITE(STR,432) NINALL
      CALL MSGDOC(MDOC,STR)
 430  FORMAT('ATOMS INPUT                       :',I6)
 433  FORMAT('ATOMS INPUT/non H /               :',I6)
 431  FORMAT('ATOMS INCLUDED IN SORT            :',I6)
 432  FORMAT('ATOMS IN ONCE ONLY                :',I6)
 434  FORMAT('ATOMS INPUT/including NCS-atoms / :',I6)
      IF(ISPHR.EQ.0) THEN
        WRITE(STR,440) BMIN,BPEAK,BAVER
        CALL MSGDOC(MDOC,STR)
 440    FORMAT('MINIMUM B - MAXIMUM B - AVERAGE B:',3F10.4)

        WRITE(STR,'('' B_AVER /without water/:'',F8.3)') BAVERW
        CALL MSGDOC(MDOC,STR)

c        WRITE(STR,442) NSUME
c 442    FORMAT('SUM-ELECTRONS :',I10)
c        CALL MSGDOC(MDOC,STR)
        FAVER=SQRT(ABS(SUMFI2*NSYM))
        WRITE(STR,441) NEL,FAVER
 441    FORMAT('SUM-ELECTRONS /IN MODEL/ :',I10,' <!F!> :',F12.0)
        CALL MSGDOC(MDOC,STR)
        AVERI=SUMFI2*NSYM
        WRITE(STR,443) AVERI
 443    FORMAT('                                  <I> :',F12.0)
        CALL MSGDOC(MDOC,STR)
      ELSE IF(ISPHR.EQ.1) THEN
        WRITE(STR,450) BMIN,BPEAK,BAVE
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,451) SCHRG
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,452) CHRGP
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,453) CHRGM
        CALL MSGDOC(MDOC,STR)
 450    FORMAT('MINIMUM B - MAXIMUM B - AVERAGE B:',3F10.4)
 451    FORMAT('SUM-CHARGES           :',F10.4)
 452    FORMAT('SUM-POSITIV-CHARGES   :',F10.4)
 453    FORMAT('SUM-NEGATIV-CHARGES   :',F10.4)
      ENDIF
      NCOORD=IATT
      IF(NCOORD.EQ.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS =0')
        IERR=1
      ENDIF
      CLOSE(NIN)
      RETURN
      END

      SUBROUTINE GENDENA(MDOC,DEN,N1,N2,N3,R,IATRC1,BADD
     * ,NCOORD,NCOORM,IBFACT,IZMOCC,IXCC,IYCC,IZCC
     * ,ISCODE,IANUMB,IRECRD,U_ANISO
     * ,VOL,NSYM,ISYM,IPRSYM,IERR)
C------------------------------------------------------
CMS      : DEN
CMS      : IBFACT,IZMOCC,IXCC,IYCC,IZCC
      REAL      DEN(N1,N2,N3)
      INTEGER   R,IATRC1
C --- integer*2 version
C     INTEGER*2        IBFACT(NCOORM),IZMOCC(NCOORM)
C    *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
C --- integer*4 version
      INTEGER         IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
      REAL            U_ANISO(6,NCOORM)
C ---
      INTEGER          NCOORD,NCOORM
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C------------------------------------------------------
      COMMON/COMINFF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM
C------------------------------------------------------
      COMMON/CELLL/    A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
      COMMON/DIMM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
C --------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMSs/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),CATOM
      CHARACTER       CATOM(15)*2
C-------------------------------------------------------------
      REAL            BLL(5),CLL(5)
      CHARACTER       BFLAG*1,line*80
      REAL            UO(6),UA(6),U(3,3,5),RM(3,3),DXF(3),DXC(3)
      REAL            BA(6),BO(6)
C------------------------------------------------------------------
      IERR=0
C --- integer*2 version
C     IPACK=10000
C --- integer*4 version
      IPACK=100000
C --- 
      NATREC=NCOORD
      COEF=(FLOAT(NX)*FLOAT(NY)*FLOAT(NZ))
      IF(R.EQ.IZMIN) IATRC1=0
C
      DLIMIT=DLIM*DLIM
      SX=A/NX
      SY=B/NY
      SZ=C/NZ
C
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      TWOPI2=TWOPI*PI
      PISQ4=4.0*PI*PI
      COSA =COS(ALPHA)
      SINA =SIN(ALPHA)
      COSG =COS(GAMMA)
      SING =SIN(GAMMA)
      COSB =COS(BETA)
      SINB =SIN(BETA)
      CSA2 =COSA*2.
      CSB2 =COSB*2.
      CSG2 =COSG*2
C      COSZ  DEFINES THE ANGLE BETWEEN C AND CSTAR
      SYCOSG=SY*COSG
      SXSING=SX*SING
      SYSING=SY*SING
      SZCOSB=SZ*COSB
      SZCOSA=SZ*COSA
      COSZ=SQRT(1.-COSA**2-COSB**2-COSG**2+2.*COSA*COSB*COSG)/SING
      DV=8.0*SX*SY*SZ*COSZ*SING*PI**1.5
C
C  CELL VOLUME
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
      COEF=COEF/VOL
      DO     I3=1,N3
      DO     I2=1,N2
      DO     I1=1,N1
        DEN(I1,I2,I3)=-32001.0
      ENDDO
      ENDDO
      ENDDO
      ITETR=0
      ANGSUM=ABS(ALPHA+BETA+GAMMA-(3.0*PI)/2.)
      IF(ANGSUM.GT.0.01) ITETR=1
      IMON=0
C
C  BEWARE - MONOCLINIC SPACE GROUPS MUST BE TREATED AS HAVING C UNIQUE.
C
      ANGSUM=ABS(BETA+ALPHA-PI/2.)
      IF(ANGSUM.GT.0.01) IMON=1
      DLM= SQRT(DLIMIT)
      IF(IMON.EQ.1) DLM=DLM+0.5

      ZSFG  =FLOAT(R)/NZ     -DLM/C
      ZFFG  =FLOAT(R+N3-1)/NZ+DLM/C
      ZSFNXT=ZFFG-2.*DLM/C
C
      IATREC=IATRC1
C==========================================
1     IATREC=IATREC+1
      IF(IATREC.GT.NATREC) GO TO 400
      
C      IATM_P=IATREC
      IATM_P=IRECRD(IATREC)
      IAN   =IANUMB(IATM_P)
      BFLAG='I'
      IF(IAN.GT.0) BFLAG='A'
      IBOCC=IZMOCC(IATM_P)
      IXIN =IXCC  (IATM_P)
      IYIN =IYCC  (IATM_P)
      IZIN =IZCC  (IATREC)
      Z=IZIN/FLOAT(IPACK)
      ISCD  =ISCODE(IATM_P)
      BAT   =IBFACT(IATM_P)/10.0

      IF(BFLAG.EQ.'A') THEN

        UA(1)=U_ANISO(1,IATM_P)
        UA(2)=U_ANISO(2,IATM_P)
        UA(3)=U_ANISO(3,IATM_P)
        UA(4)=U_ANISO(4,IATM_P)
        UA(5)=U_ANISO(5,IATM_P)
        UA(6)=U_ANISO(6,IATM_P)

        CALL UO_TO_B(UA,BA)

      ENDIF
C
      IF(Z.LT.ZSFNXT) IATRC1=IATREC
      IF(Z.LT.ZSFG)   GO TO 1
      IF(Z.GT.ZFFG)   GO TO 400
C
      SCALE = 1.0
      BT    = BAT+BADD
      IF(BT.GT.99.0) BT=99.0
      IZZ   = IBOCC/1000
      IT    = IBOCC-IZZ*1000
      OCC   = IT/10.


      IF(OCC.LT.0.0001) GO TO 1
      X  =IXIN/FLOAT(IPACK)
      Y  =IYIN/FLOAT(IPACK)
      X1=X *A
      Y1=Y *B
      Z1=Z *C

      IF(BT.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: B-FACTOR < 0.0 ')
        IERR=1
        RETURN
      ENDIF

      IF(IZZ.LE.0.OR.IZZ.GT.NFMFC) THEN 
        CALL MSGERR(MDOC,' ERR: IDENTIFY FORMFACTORS = ?')
        IERR=1
        RETURN
      ENDIF

      DVOCC=OCC*DV*SCALE
      DMAXSQ=DLIMIT

      IM=IZZ
      DO     J=1,5
        BLL(J)=PISQ4/(FMFCB(J,IM)+BT )
        CLL(J)=DVOCC*FMFCA(J,IM)*(FMFCB(J,IM)+BT )**(-1.5)
      ENDDO


      IF(BFLAG.EQ.'A') THEN

        DO J=1,5
          B_EQUIV = FMFCB(J,IM)+BADD
          CALL BISO_TO_B(B_EQUIV,BO)
          CALL ADD_B(BO,BA,BO)
          CALL B_TO_UOM(BO,RM)
          CALL MDET(RM,DET)
          IF(DET.LE.0.001.OR.B_EQUIV.LT.0.001) THEN
            BFLAG='I'
            DO  JJJ=1,5
              BLL(JJJ)=PISQ4/(FMFCB(JJJ,IM)+BT )
              CLL(JJJ)=DVOCC*FMFCA(JJJ,IM)*(FMFCB(JJJ,IM)+BT )**(-1.5)
            ENDDO
            GO TO 2
          ELSE
            t1=(TWOPI2)**(-1.5)
            t2=1./SQRT(DET) 
            CLL(J)=(DVOCC*FMFCA(J,IM)*t1*t2)/8.0 
          ENDIF
          CALL INVERT(RM,U(1,1,J),IERR)
        ENDDO
      ENDIF

 2    CONTINUE

C
      XC=X1/SX
      IXC=NINT(XC)
      YC=Y1/SY
      IYC=NINT(YC)
      ZC=Z1/SZ
      IZC=NINT(ZC)
C
      RRADZ=SQRT(DMAXSQ)/(SZ*COSZ)
      SZL=ZC-RRADZ
      SZU=ZC+RRADZ
      ISZL=INT(SZL+501.)
      ISZU=INT(SZU+500.)
C
C     CALCULATE THE DENSITY AT ALL POINTS TO WHICH ATOM CONTRIBUTES
C     (IE IN SPHERE OF RADIUS RRADZ)
C
      DO     IZ1=ISZL,ISZU
        IZ=IZ1-500
C
C     TEST WHETHER THIS ATOM LIES IN REQUIRED BLOCK OF FOURIER SECTIONS
C
        IZ2=IZ+1-R
        IF(IZ2.GT.N3 .OR. IZ2.LE.0)       GO TO 301
        ZF=FLOAT(IZ)/FLOAT(NZ)
        DZ=IZ*SZ-Z1
        D2=DZ*DZ
        IF(D2.GT.DMAXSQ .AND. ITETR.EQ.1) GO TO 301
        D3=DMAXSQ-DZ*DZ*SINA*SINA
        IF(D3.LE.0.)                      GO TO 301
        RRADY=SQRT(ABS(D3))/SYSING
        ZCOSA=DZ*COSA/SY
        SYL=YC-RRADY-ZCOSA
        SYU=YC+RRADY-ZCOSA
        ISYL=INT(SYL+501.)
        ISYU=INT(SYU+500.)
        DELZ1=2.*DZ
        DZCSA2=DZ*CSA2
        DZCOSB=DZ*COSB
        DO     IY1=ISYL,ISYU
          IY=IY1 - 500
          YF=FLOAT(IY)/FLOAT(NY)
          IY2=IY+1
          IF(IY2.LE.N2.AND.IY2.GE.1) THEN
            DY=IY*SY-Y1
            DYZ=D2+DY*(DZCSA2+DY)
            IF(DYZ.LE.DMAXSQ.OR.IMON.EQ.0) THEN
C
C             FOR GIVEN X AND Y  THE MINIMUM DSQ IS GIVEN
C             FOR DX=-DY*COSG-DZCOSB
C
              DXMIN=-DY*COSG-DZCOSB
              DSQMIN=DYZ-DXMIN**2
              IF(DSQMIN.LT.DMAXSQ) THEN
                DFACT2=-2.*DXMIN
                D4=DMAXSQ-DSQMIN
                DELZ2=DELZ1+DY*CSA2
                DELY1=2.*DY+DZCSA2
                DELY=2.*DY
                RRADX=SQRT(ABS(D4))/SXSING
                XDELTA=DXMIN/SX
                SXL=XC-RRADX + XDELTA
                SXU=XC+RRADX + XDELTA
                ISXL=INT(SXL+501.)
                ISXU=INT(SXU+500.)
                DO     IX1=ISXL,ISXU
                  IX=IX1-500
                  IX2=IX+1
                  XF=FLOAT(IX)/FLOAT(NX)
                  IF(IX2.LE.N1.AND.IX2.GE.1) THEN
                    DX=IX*SX-X1
                    DSQ=DX*(DX+DFACT2) + DYZ
                    IF(DSQ.LE.DMAXSQ) THEN

                      IF(DEN(IX2,IY2,IZ2).LE.-32000.0)
     *                DEN(IX2,IY2,IZ2)=0.0
                      IF(BFLAG.EQ.'I') THEN

                        FAC=0.0
                        DO     J=1,5
                          DSQ1=-DSQ*BLL(J)
                          FAC=FAC+CLL(J)*EXP(DSQ1)
                        ENDDO
                        TEMP=FAC*COEF
                        DEN(IX2,IY2,IZ2)=DEN(IX2,IY2,IZ2)+TEMP

                      ELSE
C
C                       X,Y,Z    - fract.cords of atom
C                       XF,YF,XF - fract.coords of point (IX2,IY2,IZ2)   
C
C  TEMP = 1/8*(TWOPI^2)^(-3/2) * (DETU)^(-1/2) * EXP(-1/2*(DX' * U^(-1) * DX))
C 
C                                              
                        DXF(1)=XF-X
                        DXF(2)=YF-Y
                        DXF(3)=ZF-Z
                        CALL FTOO(DXF,DXC,IERR)
                        FAC=0.0
                        DO     J=1,5
                          QF= U(1,1,J)*DXC(1)*DXC(1)
     *                       +U(2,2,J)*DXC(2)*DXC(2)
     *                       +U(3,3,J)*DXC(3)*DXC(3)
     *                       +2.0*U(1,2,J)*DXC(1)*DXC(2)
     *                       +2.0*U(1,3,J)*DXC(1)*DXC(3)
     *                       +2.0*U(2,3,J)*DXC(2)*DXC(3)
                          TEMP=-QF/2.0
                          FAC=FAC+CLL(J)*EXP(TEMP)
                        ENDDO
                        TEMP=FAC*COEF
                     
c                    if(temp.gt.1.e8) then
c                      write(*,*) '-->',B_EQUIV,temp
c                    endif

                        DEN(IX2,IY2,IZ2)=DEN(IX2,IY2,IZ2)+TEMP

                      ENDIF

                    ENDIF
                  ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDIF
        ENDDO
301     CONTINUE
300     CONTINUE
      ENDDO
      GO TO 1
C -----------------------------------------------
400   CONTINUE

      SUMM=0.0
      SUMP=0.0
      DO     I3=1,N3
        DO     I2=1,N2
        DO     I1=1,N1
          IF(DEN(I1,I2,I3).LE.-32000.0) THEN
            DEN(I1,I2,I3)=H2OBG
            NZERO=NZERO+1
          ELSE IF(DEN(I1,I2,I3).GT.0.0) THEN
            NDENSP=NDENSP+1
            SUMP=SUMP+DEN(I1,I2,I3)
          ELSE IF(DEN(I1,I2,I3).LT.0.0.AND.
     *            DEN(I1,I2,I3).GT.-32000.0) THEN
            NDENSM=NDENSM+1
            SUMM=SUMM+DEN(I1,I2,I3)
          ENDIF
        ENDDO
        ENDDO
      ENDDO
      SUMRP=SUMRP+SUMP
      SUMRM=SUMRM+SUMM
      RETURN
      END


      SUBROUTINE UO_TO_B(UO_ANIS,B_ANIS)
C --------------------------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL UO_ANIS(6),B_ANIS(6)
      REAL A(3,3),R(3,3),S(3,3),G(3,3),GS(3,3)
      REAL FRTOCRT(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C -----------------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      A(1,1)=UO_ANIS(1)
      A(2,2)=UO_ANIS(2)
      A(3,3)=UO_ANIS(3)
      A(1,2)=UO_ANIS(4)
      A(1,3)=UO_ANIS(5)
      A(2,3)=UO_ANIS(6)
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)

C ---
      CALL  MTRANS(FRTOCR,FRTOCRT)

      CALL  MATMLT(A,FRTOCR,S)
      CALL  MATMLT(FRTOCRT,S,R)
C ---
C     U* = G* U G*
C     B  = 2PI^2 U*    
C --
      CALL MATMLT(R,GS,S)
      CALL MATMLT(GS,S,R)


C -----
      B_ANIS(1)=R(1,1)*CONST
      B_ANIS(2)=R(2,2)*CONST
      B_ANIS(3)=R(3,3)*CONST
      B_ANIS(4)=R(1,2)*CONST
      B_ANIS(5)=R(1,3)*CONST
      B_ANIS(6)=R(2,3)*CONST
C ---
      RETURN
      END

      SUBROUTINE ADD_U(UO,UA,S)
      REAL UO(6),UA(6),S(3,3)
C ---------------------------------
      S(1,1)=UO(1)+UA(1)
      S(2,2)=UO(2)+UA(2)
      S(3,3)=UO(3)+UA(3)
      S(1,2)=UO(4)+UA(4)
      S(1,3)=UO(5)+UA(5)
      S(2,3)=UO(6)+UA(6)
      S(2,1)=S(1,2)
      S(3,1)=S(1,3)
      S(3,2)=S(2,3)
      RETURN
      END

      SUBROUTINE ADD_B(UO,UA,S)
      REAL UO(6),UA(6),S(6)
C ---------------------------------
      S(1)=UO(1)+UA(1)
      S(2)=UO(2)+UA(2)
      S(3)=UO(3)+UA(3)
      S(4)=UO(4)+UA(4)
      S(5)=UO(5)+UA(5)
      S(6)=UO(6)+UA(6)
      RETURN
      END

      SUBROUTINE B_TO_UO(B_ANIS,UO_ANIS)
C --------------------------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL UO_ANIS(6),B_ANIS(6)
      REAL A(3,3),R(3,3),S(3,3),G(3,3),GS(3,3)
      REAL CRTOFRT(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C -----------------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      A(1,1)=B_ANIS(1)/CONST
      A(2,2)=B_ANIS(2)/CONST
      A(3,3)=B_ANIS(3)/CONST
      A(1,2)=B_ANIS(4)/CONST
      A(1,3)=B_ANIS(5)/CONST
      A(2,3)=B_ANIS(6)/CONST
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)

C ---
C     U* = B/2PI^2    
C     U  = G  U* G
C --
      CALL MATMLT(A,G,S)
      CALL MATMLT(G,S,R)

      CALL  MTRANS(CRTOFR,CRTOFRT)

      CALL  MATMLT(R,CRTOFR,S)
      CALL  MATMLT(CRTOFRT,S,R)
C ---
      UO_ANIS(1)=R(1,1)
      UO_ANIS(2)=R(2,2)
      UO_ANIS(3)=R(3,3)
      UO_ANIS(4)=R(1,2)
      UO_ANIS(5)=R(1,3)
      UO_ANIS(6)=R(2,3)
C ---
      RETURN
      END

      SUBROUTINE B_TO_UOM(B_ANIS,R)
C --------------------------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL UO_ANIS(6),B_ANIS(6)
      REAL A(3,3),R(3,3),S(3,3),G(3,3),GS(3,3)
      REAL CRTOFRT(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C -----------------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      A(1,1)=B_ANIS(1)/CONST
      A(2,2)=B_ANIS(2)/CONST
      A(3,3)=B_ANIS(3)/CONST
      A(1,2)=B_ANIS(4)/CONST
      A(1,3)=B_ANIS(5)/CONST
      A(2,3)=B_ANIS(6)/CONST
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)

C ---
C     U* = B/2PI^2    
C     U  = G  U* G
C --
      CALL MATMLT(A,G,S)
      CALL MATMLT(G,S,R)

      CALL  MTRANS(CRTOFR,CRTOFRT)

      CALL  MATMLT(R,CRTOFR,S)
      CALL  MATMLT(CRTOFRT,S,R)
C ---
      RETURN
      END

      SUBROUTINE BISO_TO_U(BISO,U_ANIS)
C ------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL BETA(6),U_ANIS(6),CRTOFRT(3,3)
      REAL G(3,3),GS(3,3),BT(3,3),S(3,3),U(3,3),UO(3,3)
C ------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C ------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
C -----------------
      BETA(1)=(GS(1,1)*BISO)/4.0
      BETA(2)=(GS(2,2)*BISO)/4.0
      BETA(3)=(GS(3,3)*BISO)/4.0
      BETA(4)=(GS(1,2)*BISO)/4.0
      BETA(5)=(GS(1,3)*BISO)/4.0
      BETA(6)=(GS(2,3)*BISO)/4.0
C          WRITE(*,*) '  Beta  :',BETA(1),BETA(2),BETA(3)
C     *    ,BETA(4),BETA(5),BETA(6)
C -----------------
      BT(1,1)=BETA(1)/CONST
      BT(2,2)=BETA(2)/CONST
      BT(3,3)=BETA(3)/CONST
      BT(1,2)=BETA(4)/CONST
      BT(1,3)=BETA(5)/CONST
      BT(2,3)=BETA(6)/CONST
      BT(2,1)=BT(1,2)
      BT(3,1)=BT(1,3)
      BT(3,2)=BT(2,3)
C ---
C     U* = B/2PI^2    
C     U  = G  U* G
C --
      CALL MATMLT(BT,G,S)
      CALL MATMLT(G,S,U)
C
C     tensor in cartesian. system Uo = [CtoF]' U [CtoF]
C  
      CALL  MTRANS(CRTOFR,CRTOFRT)

      CALL  MATMLT(U,CRTOFR,S)
      CALL  MATMLT(CRTOFRT,S,UO)
C -----------------------------------------
      U_ANIS(1)=UO(1,1)
      U_ANIS(2)=UO(2,2)
      U_ANIS(3)=UO(3,3)
      U_ANIS(4)=UO(1,2)
      U_ANIS(5)=UO(1,3)
      U_ANIS(6)=UO(2,3)
C ---
      RETURN
      END

      SUBROUTINE BISO_TO_B(BISO,BETA)
C ------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL BETA(6)
      REAL G(3,3),GS(3,3)
C ------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C ------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
C -----------------
      BETA(1)=(GS(1,1)*BISO)/4.0
      BETA(2)=(GS(2,2)*BISO)/4.0
      BETA(3)=(GS(3,3)*BISO)/4.0
      BETA(4)=(GS(1,2)*BISO)/4.0
      BETA(5)=(GS(1,3)*BISO)/4.0
      BETA(6)=(GS(2,3)*BISO)/4.0
C ---    
      RETURN
      END

      SUBROUTINE B_SYM(B,BR,ROT)
      REAL B(6),BR(6),ROT(3,3)
      REAL S(3,3),R(3,3),RT(3,3)
C ---------------------
      S(1,1)=B(1)
      S(2,2)=B(2)
      S(3,3)=B(3)
      S(1,2)=B(4)
      S(1,3)=B(5)
      S(2,3)=B(6)
      S(2,1)=S(1,2)
      S(3,1)=S(1,3)
      S(3,2)=S(2,3)
C -----------------
      CALL  MTRANS(ROT,RT)

      CALL  MATMLT(S,RT,R)
      CALL  MATMLT(ROT,R,S)
C -----------------------------------------
      BR(1)=S(1,1)
      BR(2)=S(2,2)
      BR(3)=S(3,3)
      BR(4)=S(1,2)
      BR(5)=S(1,3)
      BR(6)=S(2,3)
C ------------------
      RETURN
      END

      SUBROUTINE MDET2(A,DET)
C ------------------------------
      REAL A(6)
C ------------------------------
      DET  =  A(1)*(A(2)*A(3) - A(6)*A(6))
     *      - A(4)*(A(4)*A(3) - A(6)*A(5))
     *      + A(5)*(A(4)*A(6) - A(2)*A(5))
C ---
      RETURN
      END

C -I-
      SUBROUTINE ANISOSCL(MDOC,NAMEF,NAMED,NAMEO,RSMIN,RSMAX,SCALE,BOVER
     * ,THRESH,TOP,NCYCL,BOFF,BADD,P1,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C -------------------------------------------------------------------
C -P- ANISOSCL -
C -S-
C      Fnew = Scale*Fold*exp(-(B11a*a*hh +2B12a*b*hk+..)*(1-Ks*exp(-Bsr^2)) 
C
C      Dialog:
C
C  FILE_F:  - input file F_obs.
C  FILE_D:  - input file F_der.
C  RESOL:   - MIN,MAX <from file> - resolution 
C  BOFF:     <256>    - 256 corresponds to RESmin=8A, Boff= 4RES*min^2
C  BADD:      <0>       BOFF and BADD mean :
C                       !F!new = !F!input *EXP(-BADD*RSQ)*(1-EXP(*-BOFF*RSQ)
C  NC:        <5>     - number of cycles 
C  SCALE:     <1>     - initial scale 
C  BOVER:     <0>     - initial B_overall 
C  P1:        <Y>/N   - Y : generate F for P1 space group (for scaling only) 
C  THRESH: <0>        - MIN limit of !F! 
C  TOP:   <without>   - MAX limit of !F! 
C  FILE_O: <anisoscl_fsc> - outpit file of scaled !F! 
C
C  Parameters of subroutine ANISOSCL: 
C
C      SUBROUTINE ANISOSCL(MDOC,NAMEF,NAMED,NAMEO,RSMIN,RSMAX,SCALE,BOVER
C     * ,THRESH,TOP,NCYCL,BOFF,BADD,P1,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C    MDOC    - mode of writting messages to DOC-file
C              0 - only terminal , < - 0 only file, 0 < < 99 - both
C              >= 99 - don't write  
C  NAMEF:  - input file F_obs.
C  NAMED:  - input file F_der.
C  RSMIN:  - MIN,MAX <from file> - resolution 
C  RSMAX:
C  BOFF:     <256>    - 256 corresponds to RESmin=8A, Boff= 4RES*min^2
C  BADD:      <0>       BOFF and BADD mean :
C                       !F!new = !F!input *EXP(-BADD*RSQ)*(1-EXP(*-BOFF*RSQ)
C  NCYCL:     <5>     - number of cycles 
C  SCALE:     <1>     - initial scale 
C  BOVER:     <0>     - initial B_overall 
C  P1:        <Y>/N   - Y : generate F for P1 space group (for scaling only) 
C  THRESH: <0>        - MIN limit of !F!') 
C  TOP:   <without>   - MAX limit of !F!') 
C  NAMEO: <anisoscl_fsc> - outpit file of scaled !F!
C  ISYM    - integer*2 array for cryst.symmetry operators.
C  IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM),
C            max number of cryst. symm. operators.
C  IERR    - output signal of error / = 1 -error , = 0 - OK / 
C
C        output information :
C
C     REAL RESULT(IPRROW,2)
C
C        RESULT( 1,1)=NC    
C        RESULT( 2,1)=Scale    Fnew = Scale*Fold*exp(-(B11a*a*hh +2B12a*b*hk+..)
C        RESULT( 3,1)=Ks              *(1-Ks*exp(-Bsr^2)) 
C        RESULT( 4,1)=Bs
C        RESULT( 5,1)=B11
C        RESULT( 6,1)=B22
C        RESULT( 7,1)=B33
C        RESULT( 8,1)=B12
C        RESULT( 9,1)=B13
C        RESULT(10,1)=B23
C        RESULT(11,1)=RVAL(1) Ratio of Eigen values 
C        RESULT(12,1)=RVAL(2)
C        RESULT(13,1)=RVAL(3)
C        RESULT(14,1)=RFACTOR
C        RESULT(15,1)=CC
C        RESULT(16,1)=NREF
C        RESULT(17,1)=RSMIN
C        RESULT(18,1)=RSMAX
C 
C        RESULT( 1,2)=EVAL(1)
C        RESULT( 2,2)=EVAL(2)   Eigen values
C        RESULT( 3,2)=EVAL(3)
C        RESULT( 4,2)=EVEC(1,1) Eigen vectors
C        RESULT( 5,2)=EVEC(2,1)
C        RESULT( 6,2)=EVEC(3,1)
C        RESULT( 7,2)=EVEC(1,2)
C        RESULT( 8,2)=EVEC(2,2)
C        RESULT( 9,2)=EVEC(3,2)
C        RESULT(10,2)=EVEC(1,3)
C        RESULT(11,2)=EVEC(2,3)
C        RESULT(12,2)=EVEC(3,3)
C -I-
C ----------------------------------------------------------
      PARAMETER (NPAR=9)
C --------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEF*(*),NAMED*(*),NAMEO*(*)
      REAL      RESULT(IPRROW,2)
      INTEGER   IHH(192),IKK(192),ILL(192)
      REAL      FAA(192)
C ---------------------------------------------------------
      INTEGER*4 NUMB,NUMB1,NTOT,NREF
      REAL      RLATT(6),FRTOCR(3,3),CRTOFR(3,3)
      REAL      SK(NPAR),SKN(NPAR),DV(NPAR),V(NPAR),AM(NPAR,NPAR)
      REAL      SHIFTS(NPAR),SK_OLD(NPAR),IFIX(NPAR)
      REAL      CM(3,3),BM(3,3),S11(6),BETA(6),EVAL(3),RVAL(3)
      REAL      EVEC(3,3)
      CHARACTER TTT*80,ITYP*4,NAME*80,ITYPE*4,FNAME*256
      CHARACTER ITF1*4,ITF2*4,TITLE*80,MSG3*1,LINE*80,P1*1
C -----------------------------------------------------------
      IERR  = 0
      MD    =-ABS(MDOC)-1
      M     = 99
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
C -------
C     P1 = 'N'

      IF(P1.EQ.'n') P1 = 'N'
      IF(P1.NE.'N') P1 = 'Y'
C -------
      IF(SCALE.LT.0.0000001) SCALE=1.0
C ---
      DO I=1,IPRROW
        RESULT(I,1) = 0.0
        RESULT(I,2) = 0.0
      ENDDO
C --------------------------------------------
      CALL LENSTR_BL(NAMED,L)
      IF(L.LE.0.OR.NAMED(1:1).EQ.' '.OR.NAMED(1:1).EQ.',') THEN
        MTIN = 0
      ELSE
        MTIN = 10
        ITYP = 'FF  '

        CALL ORFILE(MD,MTIN,NAMED,ITYP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERROR: open input F_scale file')
          RETURN
        ENDIF
        ITF1  = ITYP
        NSYMS = NSYM
        CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RESMIN1,RESMAX1,NX,NY,NZ,IZN,IZM,TTT,IERR)
        CALL C_RD_CR
      ENDIF
C ---
      TITLE = TTT
C ----------------------------------------
      CALL LENSTR_BL(NAMEF,L)
      IF(L.LE.0.OR.NAMEF(1:1).EQ.' '.OR.NAMEF(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong name of input F_test file')
        IERR=1
        RETURN
      ENDIF

      MTNAT = 11
      ITYPE = 'FF  '

      CALL ORFILE(MD,MTNAT,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERROR: open F_test file')
        RETURN
      ENDIF
      NSYMT = NSYM
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN2,RESMAX2,NX,NY,NZ,IZN,IZM,TTT,IERR)
      ITF2 = ITYPE
      IF(MTIN.LE.0) TITLE = TTT
C ---
      CALL FRORTH(A,B,C,AL,BE,GA,FRTOCR,CRTOFR,IERR)
      RLATT(1) = A
      RLATT(2) = B
      RLATT(3) = C
      RLATT(4) = AL
      RLATT(5) = BE
      RLATT(6) = GA
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
c
C----INITIALIZE SCALE FACTORS
      DO    I=1,NPAR
        SK(I)     = 0.0
        SK_OLD(I) = 0.0
        IFIX(I)   = 0
      ENDDO
      SK(7)       = 1.0
      RFACTOR_OLD = 0.0
      FUN_OLD     = 1.0E30
      SK(8)       = 0.75
      SK(9)       = 250.0
C
      IF(MTIN.LE.0) THEN
        SK(8)    = 1.00
        SK(9)    = 100000.0
        IFIX(8)  = 1
        IFIX(9)  = 1
      ENDIF
C ---
C      IF(MTIN.LE.0) THEN

        CALL BISO_TO_B_ASC(SK,BOVER
     *        ,A,B,C,AL,BE,GA     
     *        ,AST,BST,CST,COALST,COBEST,COGAST)

        SK(1) = SK(1)/(AST*AST)          
        SK(2) = SK(2)/(BST*BST)
        SK(3) = SK(3)/(CST*CST)
        SK(4) = SK(4)/(AST*BST)
        SK(5) = SK(5)/(AST*CST)
        SK(6) = SK(6)/(BST*CST)

        SK(7) = SCALE
C ---
        DO I=1,NPAR
          SK_OLD(I) = SK(I)
        ENDDO

C      ENDIF
C ---
      IF(RSMIN.LT.RSMAX) THEN
        T     = RSMIN
        RSMAN = RSMIN
        RSMAX = T
      ENDIF
      IF(RSMIN.LT.1.E-5)   RSMIN = RESMIN2
      IF(RSMAX.LT.1.E-5)   RSMAX = RESMAX2
      IF(RSMIN.GT.RESMIN2) RSMIN = RESMIN2
      IF(RSMAX.LT.RESMAX2) RSMAX = RESMAX2
      IF(MTIN.GT.0) THEN
        IF(RSMIN.GT.RESMIN1) RSMIN = RESMIN1
        IF(RSMAX.LT.RESMAX1) RSMAX = RESMAX1
      ENDIF

      RHMIN = 1.0/RSMIN
      RHMAX = 1.0/RSMAX

      WRITE(LINE,*) ' RESMIN,RESMAX:',RSMIN,RSMAX
      CALL MSGDOC(MDOC,LINE)
C ---
      IF(TOP.LE.0.0) TOP = 1.0E30
      WRITE(LINE,*) ' THRESH,TOP:',THRESH,TOP
      CALL MSGDOC(MDOC,LINE)
C ---
      IF(NCYCL.LE.0) NCYCL = 5
      NC       = 0
      NREF_OLD = 0
      ISTOP    = 0
C
C ---- START OF THE MAIN LOOP
C
      DO    III=1,NCYCL
C ---
        IF(MTIN.GT.0) THEN
          ITYP = 'FF  '
          CALL OPFILE(M,MTIN,NAMED,ITYP,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.GT.0) THEN
            CALL MSGERR(MDOC,' ERROR: RE-OPEN F_FOR_SCALE FILE')
            RETURN
          ENDIF
        ENDIF
        ITYPE = 'FF  '
        CALL OPFILE(M,MTNAT,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERROR: RE-OPEN F_TEST FILE')
          RETURN
        ENDIF
C ---
        Q     = 0.0
        RZDEN = 0.0
        RZNUM = 0.0
        SUMYC = 0.0
        SUMOC = 0.0
        SUMO2 = 0.0
        SUMC2 = 0.0
C
C---CLEAR MATRIX AND VECTOR ELEMENTS
C
        DO    I=1,NPAR
          V(I) = 0.0
          DO    J=1,NPAR
            AM(I,J) = 0.0
          ENDDO
        ENDDO
C ------
        NTOT  = 0
        NREF  = 0
        IEND1 =-1
        IEND  =-1
        NUMB  = 0
        NUMB1 = 0
        JH    = 0
        JK    = 0
        JL    =-1
C --------------------------------------
  200   IF(ITF2.EQ.'FS  ') THEN

          CALL RRD1(MTNAT,IH,IK,IL,FN,FNA,SN,SNA,NUMB,IEND)
          IF(SN .LT.0.000001) SN  = 0.04*FN
          IF(SNA.LT.0.000001) SNA = 0.04*FNA
        ELSE
          CALL RD1(MTNAT,IH,IK,IL,FN,FNA,NUMB,IEND)
          SN  = 0.04*FN
          SNA = 0.04*FNA
        ENDIF

        IF(IEND.GT.0) GO TO 220

        IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
          WT1 = 1./(SN*SN)
          WT2 = 1./(SNA*SNA)
          WT  = WT1+WT2
          FN  = FN*WT1+FNA*WT2
          FN  = FN/WT
          SN  = 1./SQRT(WT)
        ELSE IF(FNA.GT.1.E-6) THEN
          FN  = FNA
          SN  = SNA
        ENDIF

        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 210
        CALL DSTAR_BL(IH,IK,IL,RSQ)
        RHKL = SQRT(RSQ)
        IF(RHKL.LT.RHMIN.OR.RHKL.GT.RHMAX) GO TO 210
        IF(FN.LE.THRESH)  GO TO 210
        IF(TOP.GT.1.0E-8) THEN
          IF(FN.GT.TOP)   GO TO 210
        ENDIF

        IF(MTIN.LE.0) THEN

C          BT    = BOVER/4.0
C          COVER = EXP(-BT*RSQ)
C          FD    = SCALE*COVER          

          FD   = 1.0
          SF   = 0.04*FD
          GO TO 275
        ENDIF

  255   CONTINUE

        IF(IEND1.GT.0) GO TO 220

C        IF(JL-IL) 230,250,210
C  250   IF(JK-IK) 230,260,210
C  260   IF(JH-IH) 230,270,210

        IF(JL.LT.IL) GO TO 230
        IF(JL.GT.IL) GO TO 210
        IF(JK.LT.IK) GO TO 230
        IF(JK.GT.IK) GO TO 210
        IF(JH.LT.IH) GO TO 230
        IF(JH.GT.IH) GO TO 210
        GO TO 270

  230   CONTINUE

        IF(ITF1.EQ.'FS  ') THEN
          CALL RRD2(MTIN,JH,JK,JL,FD,FDA,SF,SFA,NUMB1,IEND1)
          IF(SF .LT.0.000001) SF  = 0.04*FD
          IF(SFA.LT.0.000001) SFA = 0.04*FDA
        ELSE
          CALL RD2(MTIN,JH,JK,JL,FD,FDA,NUMB1,IEND1)
          SF  = 0.04*FD
          SFA = 0.04*FDA
        ENDIF
        IF(IEND1.GT.0) GO TO 220
        GO TO 255

  270   CONTINUE

        IF(FD.GT.1.E-6.AND.FDA.GT.1.E-6) THEN
          WT1 = 1./(SF*SF)
          WT2 = 1./(SFA*SFA)
          WT  = WT1+WT2
          FD  = FD*WT1+FDA*WT2
          FD  = FD/WT
          SF  = 1./SQRT(WT)
        ELSE IF(FDA.GT.1.E-6) THEN
          FD  = FDA
          SF  = SFA
        ENDIF

C ---
 275    CONTINUE

        IHH(1) = IH
        IKK(1) = IK
        ILL(1) = IL
        N      = 1

        IF(P1.EQ.'Y') THEN
          CALL GNR_IND_ANISO(N,IHH,IKK,ILL,NSYM,ISYM)
        ENDIF

        NREF = NREF + 1
         
        DO I_N=1,N
C ---
          LH = IHH(I_N)
          LK = IKK(I_N)
          LL = ILL(I_N)

          IF(BOFF.GT.0.0) THEN
            BT    = BOFF/4.0
            CBOFF = 1.0-EXP(-BT*RSQ)
          ELSE
            CBOFF = 1.0
          ENDIF
          IF(BADD.GT.0.0) THEN
            BT    = BADD/4.0
            CBADD = EXP(-BT*RSQ)
          ELSE
            CBADD = 1.0
          ENDIF

          FD = FD*CBOFF*CBADD
          FN = FN*CBOFF*CBADD

          S1     = AST*LH 
          S2     = BST*LK 
          S3     = CST*LL 

          S11(1) = S1*S1
          S11(2) = S2*S2
          S11(3) = S3*S3
          S11(4) = S1*S2*2.0
          S11(5) = S1*S3*2.0
          S11(6) = S2*S3*2.0

          TEMP = 0.0
          DO I=1,6
            TEMP = TEMP + SK(I)*S11(I)
          ENDDO

          IF(MTIN.LE.0) THEN
            IF(TEMP.LT.0.0) THEN
              TEMP  = 0.0
              ISTOP = 1
            ENDIF
          ENDIF

          EXPB  = EXP(-TEMP)

          BT    = SK(9)/4.0
          BCORR = EXP(-BT*RSQ)
          TCORR = 1.0-SK(8)*BCORR

          YC     = FD
          YO     = FN
          YCEXPB = YC*EXPB
          YC_NEW = SK(7)*YCEXPB*TCORR
      
          DY   = (YO - SK(7) * YCEXPB * TCORR)

          V(7) = V(7) + DY * YCEXPB * TCORR
          V(8) = V(8) - DY * YCEXPB * SK(7) * BCORR
          V(9) = V(9) + DY * YCEXPB * SK(7) * SK(8) * BCORR * (RSQ/4.0)
          
          DO   I=1,6
            V(I) = V(I) - S11(I)*SK(7)*YCEXPB*TCORR*DY
            DO   J=1,I
               AM(I,J) = AM(I,J) 
     *         + S11(I)*S11(J)*YCEXPB*YCEXPB*TCORR*TCORR*SK(7)*SK(7)
            ENDDO
            AM(7,I)  = AM(7,I) 
     *         - S11(I)*SK(7)*YCEXPB*TCORR*YCEXPB*TCORR
            AM(8,I)  = AM(8,I) 
     *         + S11(I)*SK(7)*YCEXPB*TCORR*YCEXPB*SK(7)*BCORR
            AM(9,I)  = AM(9,I) 
     *         - S11(I)*SK(7)*YCEXPB*TCORR*YCEXPB*SK(7)*SK(8)*BCORR
     *         *(RSQ/4.0)
          ENDDO

          AM(7,7) = AM(7,7) + YCEXPB*YCEXPB*TCORR*TCORR 
          AM(8,8) = AM(8,8) + YCEXPB*YCEXPB*BCORR*BCORR*SK(7)*SK(7) 
          AM(9,9) = AM(9,9) + YCEXPB*YCEXPB*BCORR*BCORR*SK(7)*SK(7)
     *              *SK(8)*SK(8)*(RSQ/4.0)*(RSQ/4.0) 

          AM(8,7) = AM(8,7) - YCEXPB*TCORR*YCEXPB*BCORR*SK(7) 
          AM(9,7) = AM(9,7) + YCEXPB*TCORR*YCEXPB*BCORR*SK(7)*SK(8)
     *              *(RSQ/4.0) 
          AM(9,8) = AM(9,8) - YCEXPB*BCORR*SK(7)*SK(8)*(RSQ/4.0)
     *              *YCEXPB*SK(7)*BCORR 

          Q = Q + DY*DY

          IF(I_N.EQ.1) THEN

            NTOT  = NTOT  + N
            RZNUM = RZNUM + ABS(DY)      *N
            RZDEN = RZDEN + ABS(YO)      *N
            SUMC2 = SUMC2 + YC_NEW*YC_NEW*N
            SUMO2 = SUMO2 + YO*YO        *N
            SUMOC = SUMOC + YO*YC_NEW    *N
            SUMYC = SUMYC + YC_NEW       *N

          ENDIF
C ----
        ENDDO
C ----
  210   CONTINUE
        GO TO 200
C --------------------------
  220   CONTINUE

        IF(NTOT.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: number of reflections = 0')
          IF(MTIN.GT.0) CLOSE(MTIN)
          CLOSE(MTNAT)
          IERR=1
          RETURN
        ENDIF

        DO I=1,NPAR-1
          DO J=I+1,NPAR
            AM(I,J) = AM(J,I)
          ENDDO
        ENDDO

        DMAX =-1.0E30          
        DO I=1,NPAR
          IF(ABS(AM(I,I)).GT.DMAX) DMAX = AM(I,I)
        ENDDO
        IF(DMAX.LT.0.00000000001) DMAX =1.0

        TOL = 1.0E-7
        DO   I=1,NPAR         
          IF(ABS(AM(I,I))/DMAX.LE.TOL) THEN
            V(I) = 0.0
            DO    J=1,NPAR
              AM(I,J) = 0.0
              AM(J,I) = 0.0
            ENDDO
          ENDIF  
        ENDDO

C     call ifix()

        DO   I=1,NPAR         
          IF(IFIX(I).GT.0) THEN
            V(I) = 0.0
            DO    J=1,NPAR
              AM(I,J) = 0.0
              AM(J,I) = 0.0
            ENDDO
          ENDIF  
        ENDDO

 
C       CALL MATINV_ASC(AM,V,NPAR,NPAR,IERR)

        CALL SVSOLV(AM,NPAR,NPAR,NPAR,NPAR,V,SHIFTS,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,
     *    ' WARNING: program: "anisoscl" is terminated')
          IF(III.EQ.1) THEN
            IF(MTIN.GT.0) CLOSE(MTIN)
            CLOSE(MTNAT)
            RETURN
          ELSE
            IERR=0   
            GO TO 1000 
          ENDIF
        ENDIF
C -------------------------
        
        IF(MTIN.GT.0) THEN
          CC = (NTOT*SUMOC-RZDEN*SUMYC)/
     *    SQRT(ABS((NTOT*SUMO2-RZDEN*RZDEN)*(NTOT*SUMC2 - SUMYC*SUMYC)))
          WRITE(LINE,'('' CORRELATION COEF:'',F8.5)') CC
          CALL MSGDOC(MDOC,LINE)
          RFACTOR = RZNUM/RZDEN
          WRITE(LINE,'('' R-factor        :'',F8.5)') RFACTOR
          CALL MSGDOC(MDOC,LINE)

          IF(III.GT.1)THEN
            DEL = ABS(Q-FUN_OLD)
            T   = ABS(DEL/Q)
            IF(T.LT.1.E-6) GO TO 1000
          ENDIF

          IF(III.EQ.1.OR.(RFACTOR_OLD.GE.RFACTOR)) THEN
            DO I=1,NPAR
              SK_OLD(I) = SK(I)
            ENDDO 
            RFACTOR_OLD = RFACTOR            
            NC          = III-1
            NREF_OLD    = NREF
          ENDIF

        ELSE

          DO I=1,NPAR
            SK_OLD(I) = SK(I)
          ENDDO 
          NC       = III-1
          NREF_OLD = NREF 
        ENDIF

        WRITE(LINE,'(''Sc,Bold:'',7F10.5)') SK(7),(SK(J),J=1,6)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''Ks,Bs:'',2F16.5)') SK(8),SK(9)
        CALL MSGDOC(MDOC,LINE)

        DO     I=1,NPAR
         SK(I) = SK(I)+(SHIFTS(I))
        ENDDO

c        DO     I=1,NAPR
c         SK(I) = SK(I)+(V(I)/4.0)
c        ENDDO

C       set fix.
C Ks SK(8)     0.1 - 0.9      
C BS SK(9)     70 - 500

        IF(IFIX(8).LE.0) THEN
          IF(SK(8).LT.0.0999) THEN
            SK(8)   = 0.1
            IFIX(8) = 1
          ELSE IF(SK(8).GT.0.899) THEN
            SK(8)   = 0.9
            IFIX(8) = 1
          ENDIF
        ENDIF
        IF(IFIX(9).LE.0) THEN
          IF(SK(9).LT.70.01) THEN
            SK(9)   = 70.0
            IFIX(9) = 1
          ELSE IF(SK(9).GT.499.9) THEN
            SK(9)   = 500.0
            IFIX(9) = 1
          ENDIF
        ENDIF
        
        WRITE(LINE,'(''Sc,Bnew:'',7F10.5)') SK(7),(SK(J),J=1,6)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''Ks,Bs:'',2F16.5)') SK(8),SK(9)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''shift  :'',7F10.5)') SHIFTS(7),(SHIFTS(J),J=1,6)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''        '',2F10.5)') SHIFTS(8),SHIFTS(9)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''FUNCTION VALUE  : '',E14.5)') Q
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(I6,'' reflections'')') NREF
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,' ')
        FUN_OLD = Q

      ENDDO
 290  CONTINUE          
 300  CONTINUE                 

C -------------------------------------------------------
 1000 CONTINUE

C      IF(MTIN.LE.0) THEN
       IF(MTIN.LE.0) CLOSE (MTNAT)

        DO I=1,NPAR
          SK(I) = SK_OLD(I)
        ENDDO

        CALL MSGDOC(MDOC,' --------------------------')
        WRITE(LINE,'('' Scale      :'',2G16.5)') SK(7)
        CALL MSGDOC(MDOC,LINE)

        WRITE(LINE,'('' Ks,Bs      :'',2G16.5)') SK(8),SK(9)
        CALL MSGDOC(MDOC,LINE)

        WRITE(LINE,'('' Beta       :'',6F10.5)') (SK(J),J=1,6)
        CALL MSGDOC(MDOC,LINE)

C        B_EQUIV = 
C     *  (  SK(1)*AST*AST*A*A + SK(2)*BST*BST*B*B + SK(3)*CST*CST*C*C
C     *  +( SK(4)*AST*BST*A*B + SK(5)*AST*CST*A*C + SK(6)*BST*CST*B*C)
C     *  *2.0)/3.0
C        B_EQUIV= B_EQUIV*4.0
C        WRITE(LINE,'('' B-equiv        :'',G16.5)') B_EQUIV
C        CALL MSGDOC(MDOC,LINE)

        SK(1) = SK(1)*AST*AST          
        SK(2) = SK(2)*BST*BST
        SK(3) = SK(3)*CST*CST
        SK(4) = SK(4)*AST*BST
        SK(5) = SK(5)*AST*CST
        SK(6) = SK(6)*BST*CST

        CALL CALC_B_EQUIV_ASC(SK,BISO
     *        ,A,B,C,AL,BE,GA     
     *        ,AST,BST,CST,COALST,COBEST,COGAST)

          WRITE(LINE,'('' B-equiv        :'',G16.5)') BISO
          CALL MSGDOC(MDOC,LINE)

C        CM(1,1)=SK(1)
C        CM(2,2)=SK(2)
C        CM(3,3)=SK(3)
C        CM(1,2)=SK(4)
C        CM(1,3)=SK(5)
C        CM(2,3)=SK(6)
C        CM(2,1)=AM(1,2)
C        CM(3,1)=AM(1,3)
C        CM(3,2)=AM(2,3)      
C        CALL INVERT(CM,BM,IERR)
C        CALL MDET(BM,DET2)
C        CALL MDET2(SK,DET)
C        WRITE(LINE,'('' Det        :'',2G16.5)') DET,DET2
C        CALL MSGDOC(MDOC,LINE)

        CALL SOLV(SK,EVAL,EVEC,FRTOCR,CRTOFR
     *      ,A,B,C,AL,BE,GA     
     *      ,AST,BST,CST,COALST,COBEST,COGAST)

        WRITE(LINE,'('' Eigen values :'',3G16.5)') 
     *  EVAL(1),EVAL(2),EVAL(3)
        CALL MSGDOC(MDOC,LINE)

        EMAX = 1.0E-30
        DO I=1,3  
          IF(ABS(EVAL(I)).GT.EMAX) EMAX = EVAL(I)
        ENDDO
        IF(EMAX.GT.1.0E-5) THEN
          DO I=1,3
            RVAL(I) = ABS(EVAL(I))/EMAX
          ENDDO  
        ELSE
          DO I=1,3
            RVAL(I) = 1.0
            EVAL(I) = 1.0
          ENDDO  
        ENDIF

        WRITE(LINE,'('' Ratio        :'',3G16.5)') 
     *  RVAL(1),RVAL(2),RVAL(3)
        CALL MSGDOC(MDOC,LINE)
C ---
        RESULT( 1,1) = NC
        RESULT( 2,1) = SK_OLD(7)
        RESULT( 3,1) = SK_OLD(8)
        RESULT( 4,1) = SK_OLD(9)
        RESULT( 5,1) = SK_OLD(1)
        RESULT( 6,1) = SK_OLD(2)
        RESULT( 7,1) = SK_OLD(3)
        RESULT( 8,1) = SK_OLD(4)
        RESULT( 9,1) = SK_OLD(5)
        RESULT(10,1) = SK_OLD(6)
        RESULT(11,1) = RVAL(1)
        RESULT(12,1) = RVAL(2)
        RESULT(13,1) = RVAL(3)
        RESULT(14,1) = 0.0
        RESULT(15,1) = 0.0
        RESULT(16,1) = NREF_OLD
        RESULT(17,1) = RSMIN
        RESULT(18,1) = RSMAX

        RESULT( 1,2) = EVAL(1)
        RESULT( 2,2) = EVAL(2)
        RESULT( 3,2) = EVAL(3)
        RESULT( 4,2) = EVEC(1,1)
        RESULT( 5,2) = EVEC(2,1)
        RESULT( 6,2) = EVEC(3,1)
        RESULT( 7,2) = EVEC(1,2)
        RESULT( 8,2) = EVEC(2,2)
        RESULT( 9,2) = EVEC(3,2)
        RESULT(10,2) = EVEC(1,3)
        RESULT(11,2) = EVEC(2,3)
        RESULT(12,2) = EVEC(3,3)

        IF(MTIN.LE.0) RETURN
c      ENDIF
C -------------------------------------------------------
      NREF  = 0
      NREF0 = 0
      SUMFA = 0.0
      SUMF  = 0.0
      FAV   = 0.0
      FAVA  = 0.0
      MTOUT = 13
C -----
      CALL OPFILE(M,MTNAT,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MDOC,' ERROR: RE-OPEN F_TEST FILE')
        RETURN
      ENDIF
C ---
      CALL OPFILE(M,MTIN,NAMED,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MDOC,' ERROR: RE-OPEN F_FOR_SCALE FILE')
        CLOSE(MTNAT)
        RETURN
      ENDIF
C ---
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0.OR.NAMEO(1:1).EQ.','.OR.NAMEO(1:1).EQ.' ') THEN
        NAMEO = 'anisoscl_fsc'
      ENDIF
      CALL C_CR_WR
      CALL SET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RESMIN1,RESMAX1,NX,NY,NZ,IZN,IZM,TTT,IERR)
      CALL OWFILE(MD,MTOUT,NAMEO,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN OUTPUT FILE')
        CLOSE(MTNAT)
        CLOSE(MTIN)
        RETURN
      ENDIF
C ---
      IEND  =-1
      IEND1 =-1
      IEND2 =-1
      NUMB  = 0
      NUMB1 = 0
      NUMB2 = 0
      SD1   = 0.0
      SD2   = 0.0
      NTOT  = 0
      RZDEN = 0.0
      RZNUM = 0.0
      SUMYC = 0.0
      SUMOC = 0.0
      SUMO2 = 0.0
      SUMC2 = 0.0
      JH    = 0
      JK    = 0
      JL    =-1
  400 CONTINUE
C ---
      IF(ITYP.EQ.'F   ') THEN
        CALL RD2(MTIN,IH,IK,IL,FD,FDA,NUMB,IEND)
        SD1 = 0.04*FD
        SD2 = 0.04*FDA
      ELSE
        CALL RRD2(MTIN,IH,IK,IL,FD,FDA,SD1,SD2,NUMB,IEND)
        IF(SD1.LT.0.000001) SD1 = 0.04*FD
        IF(SD2.LT.0.000001) SD2 = 0.04*FDA
      ENDIF

      IF(IEND.EQ.1) GO TO 420

      IF(FD.GT.1.E-6.AND.FDA.GT.1.E-6) THEN
        WT1  = 1./(SD1*SD1)
        WT2  = 1./(SD2*SD2)
        WT   = WT1+WT2
        FMD  = FD*WT1+FDA*WT2
        FMD  = FMD/WT
        SFMD = 1./SQRT(WT)
      ELSE IF(FDA.GT.1.E-6) THEN
        FMD  = FDA
        SFMD = SD2
      ELSE
        FMD  = FD
        SFMD = SD1
      ENDIF

      IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) THEN
        FMOD = FD *SK_OLD(7)
        FAN  = FDA*SK_OLD(7)
        NREF0 = NREF0 + 1
        GO TO 415
      ENDIF

      CALL DSTAR_BL(IH,IK,IL,RSQ)
      RHKL = SQRT(RSQ)

      IF(BOFF.GT.0.0) THEN
        BT    = BOFF/4.0
        CBOFF = 1.0-EXP(-BT*RSQ)
      ELSE
        CBOFF = 1.0
      ENDIF
      IF(BADD.GT.0.0) THEN
        BT    = BADD/4.0
        CBADD = EXP(-BT*RSQ)
      ELSE
        CBADD = 1.0
      ENDIF

 1255 CONTINUE

      IF(IEND2.GT.0) THEN
        FNN =-1.0
        GO TO 1271
      ENDIF

C      IF(JL-IL) 1230,1250,1271
C 1250 IF(JK-IK) 1230,1260,1271
C 1260 IF(JH-IH) 1230,1270,1271

      IF(JL.LT.IL) GO TO 1230
      IF(JL.GT.IL) GO TO 1271
      IF(JK.LT.IK) GO TO 1230
      IF(JK.GT.IK) GO TO 1271
      IF(JH.LT.IH) GO TO 1230
      IF(JH.GT.IH) GO TO 1271
      GO TO 1270

 1230 CONTINUE

      IF(ITYPE.EQ.'FS  ') THEN
        CALL RRD1(MTNAT,JH,JK,JL,FN,FNA,SN,SNA,NUMB2,IEND2)
        IF(SN .LT.0.000001) SN  = 0.04*FN
        IF(SNA.LT.0.000001) SNA = 0.04*FNA
      ELSE
        CALL RD1(MTNAT,JH,JK,JL,FN,FNA,NUMB2,IEND2)
        SN  = 0.04*FN
        SNA = 0.04*FNA
      ENDIF
      
      IF(IEND2.GT.0) THEN
        FNN =-1.0
        GO TO 1271
      ENDIF
      GO TO 1255

 1271 CONTINUE
      FNN =-1.0
      GO TO 1272
 1270 CONTINUE
      FNN = FN
 1272 CONTINUE
C ---
      S1     = AST*IH 
      S2     = BST*IK
      S3     = CST*IL

      S11(1) = S1*S1
      S11(2) = S2*S2
      S11(3) = S3*S3
      S11(4) = S1*S2*2.0
      S11(5) = S1*S3*2.0
      S11(6) = S2*S3*2.0

      TEMP = 0.0
      DO I=1,6
        T    = SK_OLD(I)*S11(I)
        TEMP = TEMP+T
      ENDDO

      EXPB   = EXP(-TEMP)
      X      = SK_OLD(7)*EXPB
      BT     = SK_OLD(9)/4.0
      BCORR  = EXP(-BT*RSQ)
      TCORR  = 1.0-SK_OLD(8)*BCORR
      X      = X*TCORR

      FMOD   = FD   *X
      FAN    = FDA  *X
      SD1    = SD1  *X
      SD2    = SD2  *X


      IF((RHKL.GE.RHMIN.AND.RHKL.LE.RHMAX).AND.FNN.GE.0.0) THEN

        IF(FNN.LE.THRESH)  GO TO 1210
        IF(TOP.GT.1.0E-8) THEN
          IF(FNN.GT.TOP)     GO TO 1210
        ENDIF


        CALL CALC_EPS(N,IH,IK,IL,NSYM,ISYM)

        NTOT = NTOT+N

        FMD = FMD*CBOFF*CBADD
        FNN = FNN*CBOFF*CBADD

        YC = FMD*X
        YO = FNN

        DY = YO-YC  

        RZNUM = RZNUM+ABS(DY) *N
        RZDEN = RZDEN+ABS(YO) *N
        SUMC2 = SUMC2+YC*YC   *N
        SUMO2 = SUMO2+YO*YO   *N
        SUMOC = SUMOC+YO*YC   *N
        SUMYC = SUMYC+YC      *N

      ENDIF

 1210 CONTINUE

C
      IF(FMOD.LE.THRESH.AND.FAN.LE.THRESH) GO TO 410

      IF(FMOD.LE.1.0E-20.AND.FAN.LE.1.0E-20) GO TO 410

      SUMF  = SUMF +FMOD
      SUMFA = SUMFA+FAN

 415  CONTINUE

      NREF = NREF+1

      IF(ITYP.EQ.'F   ') THEN
        CALL WRT(MTOUT,IH,IK,IL,FMOD,FAN,NUMB1,IEND1)
      ELSE
        CALL WWRT(MTOUT,IH,IK,IL,FMOD,FAN,SD1,SD2,NUMB1,IEND1)
      ENDIF
  410 CONTINUE
      GO TO 400
C -------------------------
  420 IEND1 = 2

      NREF = NREF - NREF0

      CALL WRT(MTOUT,IH,IK,IL,FMOD,FAN,NUMB1,IEND1)
      IF(NREF.GT.0) THEN
        FAV  = SUMF/NREF
        FAVA = SUMFA/NREF
      ENDIF

      CALL MSGDOC(MDOC,' --------------------------')
      WRITE(LINE,60) NREF
   60 FORMAT(' Write ',I6,' reflections')
      CALL MSGDOC(MDOC,LINE)
      CLOSE(MTIN)
      CLOSE(MTNAT)
C ---
      CC = (NTOT*SUMOC-RZDEN*SUMYC)/
     *  SQRT(ABS((NTOT*SUMO2-RZDEN*RZDEN)*(NTOT*SUMC2 - SUMYC*SUMYC)))
      WRITE(LINE,'('' CORRELATION COEF:'',F8.5)') CC
      CALL MSGDOC(MDOC,LINE)
      RFACTOR = RZNUM/RZDEN
      WRITE(LINE,'('' R-factor        :'',F8.5)') RFACTOR
      CALL MSGDOC(MDOC,LINE)

      RESULT(14,1) = RFACTOR
      RESULT(15,1) = CC
      RESULT(16,1) = NREF
      IF(NREF.LE.0) RESULT(1,1) = 0.0

C ----
      RETURN
      END 

      SUBROUTINE GNR_IND_ANISO(N,IHH,IKK,ILL,NSYM,ISYM)
C
C     GENERATE H,K,L,F FOR SEMI-SPHERE / L >= 0 /
C
      INTEGER*2 ISYM(5,3,NSYM)
      INTEGER   IHH(192),IKK(192),ILL(192)
C --------------------------------------------
      N   = 1
      IH1 = IHH(1)
      IK1 = IKK(1)
      IL1 = ILL(1)
      IF(NSYM.LE.1) RETURN

      DO     I=2,NSYM
        JH = ISYM(1,1,I)*IH1 +ISYM(1,2,I)*IK1 +ISYM(1,3,I)*IL1
        JK = ISYM(2,1,I)*IH1 +ISYM(2,2,I)*IK1 +ISYM(2,3,I)*IL1
        JL = ISYM(3,1,I)*IH1 +ISYM(3,2,I)*IK1 +ISYM(3,3,I)*IL1
        IF(JL.LT.0) THEN
          JH =-JH
          JK =-JK
          JL =-JL
        ELSE IF(JL.EQ.0) THEN
          IF(JK.LT.0) THEN
            JH =-JH
            JK =-JK
          ELSE IF(JK.EQ.0) THEN
            IF(JH.LT.0) THEN
              JH =-JH
            ENDIF
          ENDIF
        ENDIF
        IF(N.GT.0) THEN
          DO  L=1,N
            IF(IHH(L).EQ.JH.AND.IKK(L).EQ.JK.AND.ILL(L).EQ.JL)GOTO 10
          ENDDO
        ENDIF
        N      = N+1
        IHH(N) = JH
        IKK(N) = JK
        ILL(N) = JL
   10   CONTINUE
      ENDDO
      RETURN
      END



C      SUBROUTINE MDET2(A,DET)
C ------------------------------
C      REAL A(6)
C ------------------------------
C      DET  =  A(1)*(A(2)*A(3) - A(6)*A(6))
C     *      - A(4)*(A(4)*A(3) - A(6)*A(5))
C     *      + A(5)*(A(4)*A(6) - A(2)*A(5))
C ---
C      RETURN
C      END

      SUBROUTINE CALC_B_EQUIV_ASC(BETA,B_EQUIV
     *        ,A,B,C,AANGL,BANGL,GANGL     
     *        ,AST,BST,CST,COALST,COBEST,COGAST)
C ------------------------
      REAL BETA(*)
      REAL G(3,3),GS(3,3),BT(3,3)
C ------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
C ------------------------
      G(1,1)=A*A
      G(2,2)=B*B
      G(3,3)=C*C
      G(1,2)=A*B*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=A*C*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=B*C*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      BT(1,1)=BETA(1)
      BT(2,2)=BETA(2)
      BT(3,3)=BETA(3)
      BT(1,2)=BETA(4)
      BT(1,3)=BETA(5)
      BT(2,3)=BETA(6)
      BT(2,1)=BT(1,2)
      BT(3,1)=BT(1,3)
      BT(3,2)=BT(2,3)
C ---
C      write(*,*)
C      write(*,*) ' g:',g(1,1),g(1,2),g(1,3)
C      write(*,*) ' g:',g(2,1),g(2,2),g(2,3)
C      write(*,*) ' g:',g(3,1),g(3,2),g(3,3)
C -----------------
      SUM=0.0
      DO I=1,3
      DO J=1,3
        SUM=SUM+BT(I,J)*G(I,J)
      ENDDO
      ENDDO     
      B_EQUIV=(SUM*4.0)/3.0
C -----------------
      RETURN
      END

      SUBROUTINE B_TO_U_ACS(B_ANIS,U_ANIS
     *      ,A,B,C,AANGL,BANGL,GANGL     
     *      ,AST,BST,CST,COALST,COBEST,COGAST)
C --------------------------------------------
      REAL U_ANIS(*),B_ANIS(*)
      REAL G(3,3),GS(3,3),U(3,3),BT(3,3),S(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C      CONST=2.0*TWOPI*TWOPI
C -----------------------------------
      G(1,1)=A*A
      G(2,2)=B*B
      G(3,3)=C*C
      G(1,2)=A*B*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=A*C*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=B*C*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      BT(1,1)=B_ANIS(1)/CONST
      BT(2,2)=B_ANIS(2)/CONST
      BT(3,3)=B_ANIS(3)/CONST
      BT(1,2)=B_ANIS(4)/CONST
      BT(1,3)=B_ANIS(5)/CONST
      BT(2,3)=B_ANIS(6)/CONST
      BT(2,1)=BT(1,2)
      BT(3,1)=BT(1,3)
      BT(3,2)=BT(2,3)

C ---
C     U* = B/2PI^2    
C     U  = G  U* G
C --
      CALL MATMLT(BT,G,S)
      CALL MATMLT(G,S,U)
C      REAL X(3,3),Y(3,3),Z(3,3)
C -P- MATMLT - [Z] =[X] [Y]

C -----
      U_ANIS(1)=U(1,1)
      U_ANIS(2)=U(2,2)
      U_ANIS(3)=U(3,3)
      U_ANIS(4)=U(1,2)
      U_ANIS(5)=U(1,3)
      U_ANIS(6)=U(2,3)
C ---
      RETURN
      END

      SUBROUTINE U_TO_B_ASC(U_ANIS,B_ANIS
     *      ,A,B,C,AANGL,BANGL,GANGL     
     *      ,AST,BST,CST,COALST,COBEST,COGAST)
C --------------------------------------------
      REAL U_ANIS(*),B_ANIS(*)
      REAL G(3,3),GS(3,3),U(3,3),BT(3,3),S(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C     CONST=2.0*TWOPI*TWOPI
C -----------------------------------
      G(1,1)=A*A
      G(2,2)=B*B
      G(3,3)=C*C
      G(1,2)=A*B*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=A*C*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=B*C*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C      write(*,*)
C      write(*,*) ' gs:',gs(1,1),gs(1,2),gs(1,3)
C      write(*,*) ' gs:',gs(2,1),gs(2,2),gs(2,3)
C      write(*,*) ' gs:',gs(3,1),gs(3,2),gs(3,3)
C ---
      U(1,1)=U_ANIS(1)
      U(2,2)=U_ANIS(2)
      U(3,3)=U_ANIS(3)
      U(1,2)=U_ANIS(4)
      U(1,3)=U_ANIS(5)
      U(2,3)=U_ANIS(6)
      U(2,1)=U(1,2)
      U(3,1)=U(1,3)
      U(3,2)=U(2,3)
C ---
C     U* = G* U G*
C     B  = 2PI^2 U*    
C --
      CALL MATMLT(U,GS,S)
      CALL MATMLT(GS,S,BT)
C      REAL X(3,3),Y(3,3),Z(3,3)
C -P- MATMLT - [Z] =[X] [Y]

C -----
C      WRITE(*,*) '-U*:',BT(1,1),BT(2,2),BT(3,3)
C     *        ,BT(1,2),BT(1,3),BT(2,3)
      B_ANIS(1)=BT(1,1)*CONST
      B_ANIS(2)=BT(2,2)*CONST
      B_ANIS(3)=BT(3,3)*CONST
      B_ANIS(4)=BT(1,2)*CONST
      B_ANIS(5)=BT(1,3)*CONST
      B_ANIS(6)=BT(2,3)*CONST
C ---
      RETURN
      END

      SUBROUTINE UO_TO_U_ASC(UO_ANIS,U_ANIS,FRTOCR,CRTOFR)
C --------------------------------------------
      REAL UO_ANIS(*),U_ANIS(*)
      REAL A(3,3),R(3,3),S(3,3)
      REAL FRTOCR(3,3),CRTOFR(3,3),FRTOCRT(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C      CONST=2.0*TWOPI*TWOPI
C -----------------------------------
C ---
      A(1,1)=UO_ANIS(1)
      A(2,2)=UO_ANIS(2)
      A(3,3)=UO_ANIS(3)
      A(1,2)=UO_ANIS(4)
      A(1,3)=UO_ANIS(5)
      A(2,3)=UO_ANIS(6)
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)
C      write(*,*)
C      write(*,*) ' ftoc:',FRTOCR(1,1),FRTOCR(1,2),FRTOCR(1,3)
C      write(*,*) ' ftoc:',FRTOCR(2,1),FRTOCR(2,2),FRTOCR(2,3)
C      write(*,*) ' ftoc:',FRTOCR(3,1),FRTOCR(3,2),FRTOCR(3,3)

C ---
      CALL  MTRANS(FRTOCR,FRTOCRT)

      CALL  MATMLT(A,FRTOCR,S)
      CALL  MATMLT(FRTOCRT,S,R)

C -----
      U_ANIS(1)=R(1,1)
      U_ANIS(2)=R(2,2)
      U_ANIS(3)=R(3,3)
      U_ANIS(4)=R(1,2)
      U_ANIS(5)=R(1,3)
      U_ANIS(6)=R(2,3)
C ---
      RETURN
      END


      SUBROUTINE BISO_TO_B_ASC(BETA,BISO
     *        ,A,B,C,AANGL,BANGL,GANGL     
     *        ,AST,BST,CST,COALST,COBEST,COGAST)
C ------------------------
      REAL BETA(*)
      REAL G(3,3),GS(3,3)
C ------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
C ------------------------
      G(1,1)=A*A
      G(2,2)=B*B
      G(3,3)=C*C
      G(1,2)=A*B*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=A*C*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=B*C*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
C -----------------
      BETA(1)=(GS(1,1)*BISO)/4.0
      BETA(2)=(GS(2,2)*BISO)/4.0
      BETA(3)=(GS(3,3)*BISO)/4.0
      BETA(4)=(GS(1,2)*BISO)/4.0
      BETA(5)=(GS(1,3)*BISO)/4.0
      BETA(6)=(GS(2,3)*BISO)/4.0
C -----------------
C      write(*,*)  
C      WRITE(*,*) ' B:',BETA(1),BETA(2),BETA(3),BETA(4)
C     * ,BETA(5),BETA(6)
      RETURN
      END

      SUBROUTINE SOLV(B_ANIS,EVAL,EVEC,FRTOCR,CRTOFR
     *      ,ACELL,BCELL,CCELL,AANGL,BANGL,GANGL     
     *      ,AST,BST,CST,COALST,COBEST,COGAST)
C      SUBROUTINE SOLV(U_ANIS,FRTOCR,CRTOFR
C     *      ,ACELL,BCELL,CCELL,AANGL,BANGL,GANGL     
C     *      ,AST,BST,CST,COALST,COBEST,COGAST)
C ------------------------------------------------------------
      REAL   B_ANIS(*),R(3,3),G(3,3),GS(3,3),BT(3,3)
      REAL   V(3,3),VT(3,3),Y(3)
      REAL   VO(3,3),VOT(3,3),AO(3,3),CRTOFRT(3,3),FRTOCRT(3,3)
      REAL   U_ANIS(6),A(3,3),FRTOCR(3,3),CRTOFR(3,3)
      REAL   S(3,3),X(3),BETA(6)
      REAL   EVAL(3),EVEC(3,3),DISP(3)
      DATA   ZIP/1.0E-5/
      DATA   MM/10/
C ------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C -------------------------------
C      CALL  INVERT(GV,GVI,IERR)
C
C     SUBROUTINE MCOPY(X,Y)      
C -P- MCOPY - [Y] <= [X]
C
C      SUBROUTINE MATMLT(X,Y,Z)
C      REAL X(3,3),Y(3,3),Z(3,3)
C -P- MATMLT - [Z] =[X] [Y]
C
C      SUBROUTINE MTRANS(AM,BM)
C      REAL AM(3,3),BM(3,3)
C
C -P- MTRANS - matrix transposition
C           ! 11 21 31 !            ! 11 12 13 !  
C     AM  = ! 12 22 32 !  --> BM =  ! 21 22 33 !
C           ! 13 23 33 !            ! 31 32 33 !    
C     It is posible to use CALL MTRANS(AM,AM)
C----SET UP THE A MATRIX
C      SUBROUTINE FTOO(X,Y,IERR)
C      SUBROUTINE FTOO(X,Y,IERR)
C      SUBROUTINE OTOF(X,Y,IERR)
C -----------------------------------
C
C metric matrix G in direct space
C
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C -----------------------------------
C
C metric matrix G* in reciprocal space
C
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C -------------------------------------
C  tensor U
C 
C      A(1,1)=U_ANIS(1)
C      A(2,2)=U_ANIS(2)
C      A(3,3)=U_ANIS(3)
C      A(1,2)=U_ANIS(4)
C      A(1,3)=U_ANIS(5)
C      A(2,3)=U_ANIS(6)
C      A(2,1)=A(1,2)
C      A(3,1)=A(1,3)
C      A(3,2)=A(2,3)      
C -------------------------------------
C      write(*,*)
C      write(*,*) ' u:',a(1,1),a(1,2),a(1,3)
C      write(*,*) ' u:',a(2,1),a(2,2),a(2,3)
C      write(*,*) ' u:',a(3,1),a(3,2),a(3,3)
C -------------------------------------
C      CALL U_TO_B(U_ANIS,B_ANIS
C     *      ,ACELL,BCELL,CCELL,AANGL,BANGL,GANGL     
C     *      ,AST,BST,CST,COALST,COBEST,COGAST)

C      write(*,*)  
C      WRITE(*,*) ' B:',B_ANIS(1),B_ANIS(2),B_ANIS(3),B_ANIS(4)
C     * ,B_ANIS(5),B_ANIS(6)
C ---------------------------
C
C   tensor B
C 
      BT(1,1)=B_ANIS(1)
      BT(2,2)=B_ANIS(2)
      BT(3,3)=B_ANIS(3)
      BT(1,2)=B_ANIS(4)
      BT(1,3)=B_ANIS(5)
      BT(2,3)=B_ANIS(6)
      BT(2,1)=BT(1,2)
      BT(3,1)=BT(1,3)
      BT(3,2)=BT(2,3)
C      write(*,*)
C      write(*,*) ' b:',bt(1,1),bt(1,2),bt(1,3)
C      write(*,*) ' b:',bt(2,1),bt(2,2),bt(2,3)
C      write(*,*) ' b:',bt(3,1),bt(3,2),bt(3,3)
C -----------------------------
C   tensor   U* = B/2PI^2    
C
      BT(1,1)=BT(1,1)/CONST
      BT(2,1)=BT(2,1)/CONST
      BT(3,1)=BT(3,1)/CONST
      BT(1,2)=BT(1,2)/CONST
      BT(2,2)=BT(2,2)/CONST
      BT(3,2)=BT(3,2)/CONST
      BT(1,3)=BT(1,3)/CONST
      BT(2,3)=BT(2,3)/CONST
      BT(3,3)=BT(3,3)/CONST
C      write(*,*)
C      write(*,*) ' u*:',bt(1,1),bt(1,2),bt(1,3)
C      write(*,*) ' u*:',bt(2,1),bt(2,2),bt(2,3)
C      write(*,*) ' u*:',bt(3,1),bt(3,2),bt(3,3)
C ------------------------------

C VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C      V(1,1)=-.0393
C      V(1,2)=-.028
C      V(1,3)=-.1515
C
C      V(2,1)=-.0139
C      V(2,2)=-.0866
C      V(2,3)= .0587
C
C      V(3,1)=-.1097
C      V(3,2)= .0210
C      V(3,3)= .0492
C      CALL  MTRANS(V,VT)
C
C      X(1)=-.0393
C      X(2)=-.028
C      X(3)=-.1515
C      CALL FTOO(X,Y,IERR)
C      VO(1,1)=Y(1)
C      VO(1,2)=Y(2)
C      VO(1,3)=Y(3)
C
C      X(1)=-.0139
C      X(2)=-.0866
C      X(3)= .0587
C      CALL FTOO(X,Y,IERR)
C      VO(2,1)=Y(1)
C      VO(2,2)=Y(2)
C      VO(2,3)=Y(3)
C
C      X(1)=-.1097
C      X(2)= .0210
C      X(3)= .0492
C      CALL FTOO(X,Y,IERR)
C      VO(3,1)=Y(1)
C      VO(3,2)=Y(2)
C      VO(3,3)=Y(3)
C      CALL  MTRANS(VO,VOT)
C
C      write(*,*)
C      write(*,*) ' vo:',VO(1,1),VO(1,2),VO(1,3)
C      write(*,*) ' vo:',VO(2,1),VO(2,2),VO(2,3)
C      write(*,*) ' vo:',VO(3,1),VO(3,2),VO(3,3)
C ---
C ok
c      CALL  MATMLT(G,V,GV)
c      CALL  MATMLT(BT,GV,R)
c      CALL  MATMLT(G,R,S)
c      CALL  MATMLT(VT,S,R)
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

C ---------------------------------
C
C     tensor U = G U* G
C
      CALL  MATMLT(BT,G,S)
      CALL  MATMLT(G,S,R)

C      write(*,*)
C      write(*,*) ' u:',r(1,1),r(1,2),r(1,3)
C      write(*,*) ' u:',r(2,1),r(2,2),r(2,3)
C      write(*,*) ' u:',r(3,1),r(3,2),r(3,3)
C -----------------------------
C
C     tensor in cartesian. system Uo = [CtoF]' U [CtoF]
C  
      CALL  MTRANS(CRTOFR,CRTOFRT)

      CALL  MATMLT(R,CRTOFR,S)
      CALL  MATMLT(CRTOFRT,S,A)
C -----------------------------------------

c VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C      CALL  MATMLT(A,VO,S)
C      CALL  MATMLT(VOT,S,AO)
C 
C      write(*,*)
C      write(*,*) ' g:',G(1,1),G(1,2),G(1,3)
C      write(*,*) ' g:',G(2,1),G(2,2),G(2,3)
C      write(*,*) ' g:',G(3,1),G(3,2),G(3,3)
C      write(*,*)
C      write(*,*) ' v:',V(1,1),V(1,2),V(1,3)
C      write(*,*) ' v:',V(2,1),V(2,2),V(2,3)
C      write(*,*) ' v:',V(3,1),V(3,2),V(3,3)
C      write(*,*)
C      write(*,*) ' r:',R(1,1),R(1,2),R(1,3)
C      write(*,*) ' r:',R(2,1),R(2,2),R(2,3)
C      write(*,*) ' r:',R(3,1),R(3,2),R(3,3)
C      write(*,*)
C      write(*,*) ' ao:',AO(1,1),AO(1,2),AO(1,3)
C      write(*,*) ' ao:',AO(2,1),AO(2,2),AO(2,3)
C      write(*,*) ' ao:',AO(3,1),AO(3,2),AO(3,3)
C
C      CALL  MATMLT(R,CRTOFR,S)
C      CALL  MATMLT(CRTOFR,S,R)
C      CALL  MTRANS(R,A)
C      
C      write(*,*)
C      write(*,*) ' r:',R(1,1),R(1,2),R(1,3)
C      write(*,*) ' r:',R(2,1),R(2,2),R(2,3)
C      write(*,*) ' r:',R(3,1),R(3,2),R(3,3)
C
C      CALL  MATMLT(A,FRTOCR,S)
C      CALL  MATMLT(FRTOCR,S,A)
C      CALL  MTRANS(A,A)
C      CALL  MTRANS(A,A)
C
c       CALL  MCOPY(AO,A)
c       CALL  MCOPY(AO,A)
C
c      a(2,1)=0
c      a(3,1)=0
c      a(3,2)=0
c      a(1,2)=0
c      a(1,3)=0
c      a(2,3)=0
C
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


C ----------------------
C      write(*,*) 
C      write(*,*) ' Uo:',a(1,1),a(1,2),a(1,3)
C      write(*,*) ' Uo:',a(2,1),a(2,2),a(2,3)
C      write(*,*) ' Uo:',a(3,1),a(3,2),a(3,3)
C -----------------------------------------------------
C     eigen value : EVAL(i)
C     eigen vector: EVEC(1,i)
C                   EVEC(2,i)
C                   EVEC(3,i)
C                   
      N=3
      CALL  CALCRS(N,A,EVAL,EVEC)

      RETURN

C      write(*,*) 
C      write(*,*) ' E:',eval(1),eval(2),eval(3)
C      write(*,*) 
C      write(*,*) ' e:',evec(1,1),evec(1,2),evec(1,3)
C      write(*,*) ' e:',evec(2,1),evec(2,2),evec(2,3)
C      write(*,*) ' e:',evec(3,1),evec(3,2),evec(3,3)
C
C      t=(eval(1)+eval(2)+eval(3))/(3.0*twopi*pi)
C      write(*,*) ' t:',t      
C      scale=t
C --------------------------
C
C   <u^2>i mean-square displacement along the ith principal axis.
C
C   <u^2>i = Eval(i)/2pi^2 ( in A^2 )
C
C
C      DISP(1)=EVAL(1)
C      DISP(2)=EVAL(2)
C      DISP(3)=EVAL(3)
C
C      write(*,*) 
C      write(*,*) ' D^2:',disp(1),disp(2),disp(3)
C      DISP(1)=SQRT(DISP(1))
C      DISP(2)=SQRT(DISP(2))
C      DISP(3)=SQRT(DISP(3))
C      write(*,*) 
C      write(*,*) ' D:',disp(1),disp(2),disp(3)
C --------------------------
C
C  eigen vectors in ort. system
C
C                                      !  V1(1) V2(1)  V3(1) !
C matrix transformation      VO[3,3] = !  V1(2) V2(2)  V3(2) !
C                                      !  V1(3) V2(3)  V3(3) !
C
C     from standard Ort.system to principial axis
C
C     Up = VO' Uo VO
C
C
C      Y(1)=EVEC(1,1)
C      Y(2)=EVEC(2,1)
C      Y(3)=EVEC(3,1)
C      CALL OTOF(Y,X)
C      WRITE(*,*) 'fr1:',X(1),X(2),X(3)        
C      Y(1)=EVEC(1,2)
C      Y(2)=EVEC(2,2)
C      Y(3)=EVEC(3,2)
C      CALL OTOF(Y,X)
C      WRITE(*,*) 'fr2:',X(1),X(2),X(3)        
C      Y(1)=EVEC(1,3)
C      Y(2)=EVEC(2,3)
C      Y(3)=EVEC(3,3)
C      CALL OTOF(Y,X)
C      WRITE(*,*) 'fr3:',X(1),X(2),X(3)        
C
C
C      VO(1,1)=EVEC(1,1)
C      VO(2,1)=EVEC(2,1)
C      VO(3,1)=EVEC(3,1)
C      VO(1,2)=EVEC(1,2)
C      VO(2,2)=EVEC(2,2)
C      VO(3,2)=EVEC(3,2)
C      VO(1,3)=EVEC(1,3)
C      VO(2,3)=EVEC(2,3)
C      VO(3,3)=EVEC(3,3)
C for blanc
C      CALL  MTRANS(VO,VO)
C      CALL  MTRANS(VO,VOT)
C      write(*,*)
C      write(*,*) ' vo:',VO(1,1),VO(1,2),VO(1,3)
C      write(*,*) ' vo:',VO(2,1),VO(2,2),VO(2,3)
C      write(*,*) ' vo:',VO(3,1),VO(3,2),VO(3,3)
C
C      CALL  MATMLT(A,VO,S)
C      CALL  MATMLT(VOT,S,AO)
C
C      write(*,*)
C      write(*,*) ' Uc:',AO(1,1),AO(1,2),AO(1,3)
C      write(*,*) ' Uc:',AO(2,1),AO(2,2),AO(2,3)
C      write(*,*) ' Uc:',AO(3,1),AO(3,2),AO(3,3)
C     
C
C VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C
C      WRITE(*,*) ' ======================='
C      CALL  INVERT(VO,S,IERR)
C      CALL  MCOPY(S,VO)
C      CALL  MTRANS(VO,VOT)
C
C      CALL  MATMLT(AO,VO,S)
C      CALL  MATMLT(VOT,S,A)
C
C      write(*,*) 
C      write(*,*) ' Uo:',a(1,1),a(1,2),a(1,3)
C      write(*,*) ' Uo:',a(2,1),a(2,2),a(2,3)
C      write(*,*) ' Uo:',a(3,1),a(3,2),a(3,3)
C
C      CALL  MTRANS(FRTOCR,FRTOCRT)
C
C      CALL  MATMLT(A,FRTOCR,S)
C      CALL  MATMLT(FRTOCRT,S,R)
C
C      write(*,*)
C      write(*,*) ' u:',r(1,1),r(1,2),r(1,3)
C      write(*,*) ' u:',r(2,1),r(2,2),r(2,3)
C      write(*,*) ' u:',r(3,1),r(3,2),r(3,3)
C
C      U_ANIS(1)=R(1,1)
C      U_ANIS(2)=R(2,2)
C      U_ANIS(3)=R(3,3)
C      U_ANIS(4)=R(1,2)
C      U_ANIS(5)=R(1,3)
C      U_ANIS(6)=R(2,3)
C
C      U_ANIS(1)=R(1,1)/CONST
C      U_ANIS(2)=R(2,2)/CONST
C      U_ANIS(3)=R(3,3)/CONST
C      U_ANIS(4)=R(1,2)/CONST
C      U_ANIS(5)=R(1,3)/CONST
C      U_ANIS(6)=R(2,3)/CONST
C
C      CALL U_TO_B(U_ANIS,BETA
C     *      ,ACELL,BCELL,CCELL,AANGL,BANGL,GANGL     
C     *      ,AST,BST,CST,COALST,COBEST,COGAST)
C
C      write(*,*)  
C      WRITE(*,*) ' B:',BETA(1),BETA(2),BETA(3),BETA(4)
C     * ,BETA(5),BETA(6)
C
C ===
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C      RETURN

      END

C
C
C
C     ******************************************************************
      SUBROUTINE CALCRS(N,R,EVAL,EVEC)
C     ******************************************************************
C
C     THIS SUBROUTINE CALCULATE EIGENVALUES (EVAL) AND VECTORS (EVEC) OF
C     MATRIX R OF ORDER N 
C 
C     PARAMETERS:
C
C     N     = ON ENTRY, ORDER OF MATRIX R FOR WHICH COMPUTATIONS ARE
C             DONE. UNCHANGED ON EXIT.
C     R     = REAL SYMMETRIC MATRIX OF DIMENSIONS N BY N.
C             UNCHANGED ON EXIT.
C     EVAL  = REAL ARRAY OF PHYSICAL DIMENSION N WHICH, ON EXIT,
C             CONTAINS EIGENVALUES OF R.
C     EVEC  = REAL MATRIX OF DIMENSIONS N BY N, WHOSE COLUMNS CONTAIN,
C             ON EXIT, THE EIGENVECTORS OF R.
C
      IMPLICIT    NONE
      INTEGER     NMAX
      PARAMETER  (NMAX=6)
C
      INTEGER     II,IL,I1,I2,J,K,NROT,IFAIL,N
      REAL        R(N,N),EVAL(N),EVEC(N,N),R2(NMAX)
C
C      IF (N*(N+1)/2.GT.NMAX)
C     &CALL MSGERR('MAXIMUM NUMBER OF ELEMENTS EXCEEDED IN ') //
C     &' CALCRS; CHANGE NMAX')
C
      IL=0
      DO 50 I1=1,N
        DO 50 I2=1,I1
          IL=IL+1
 50       R2(IL)=R(I1,I2)
C
      CALL EIGEN(R2,EVEC,N,0)
C
      K=0
      DO 60 J=1,N
        K=K+J
 60     EVAL(J)=R2(K)
      END
C
C
C
C     ******************************************************************
      SUBROUTINE EIGEN(A, R, N, MV)
C     ******************************************************************
C
C---- SUBROUTINE TO COMPUTE EIGENVALUES & EIGENVECTORS OF A REAL
C---- SYMMETRIC MATRIX, FROM IBM SSP MANUAL (SEE P165).
C---- DESCRIPTION OF PARAMETERS -
C---- A - ORIGINAL MATRIX STORED COLUMNWISE AS UPPER TRIANGLE ONLY,
C---- I.E. "STORAGE MODE" = 1.  EIGENVALUES ARE WRITTEN INTO DIAGONAL
C---- ELEMENTS OF A  I.E.  A(1)  A(3)  A(6)  FOR A 3*3 MATRIX.
C---- R - RESULTANT MATRIX OF EIGENVECTORS STORED COLUMNWISE IN SAME
C---- ORDER AS EIGENVALUES.
C---- N - ORDER OF MATRICES A & R.
C---- MV = 0 TO COMPUTE EIGENVALUES & EIGENVECTORS.
C
C
      IMPLICIT    NONE
      REAL        A(*), R(*)
      INTEGER     N, MV
C
      INTEGER     IQ, J, I, IJ, IA, IND, L, M, MQ, LQ, LM, LL, MM
      INTEGER     ILQ, IMQ, IM, IL, ILR, IMR
      REAL        ANORM, ANRMX, RANGE, THR, X, Y, SINX, SINX2,
     &            COSX, COSX2, SINCS
C
C-- FOR DOUBLE PRECISION
C      DATA RANGE/1D-12/
      DATA RANGE/1E-6/
C
      IF (MV.EQ.0) THEN
        IQ=-N
        DO 20 J=1,N
          IQ=IQ+N
          DO 20 I=1,N
            IJ=IQ+I
            IF (I.EQ.J) THEN
              R(IJ)=1.
            ELSE
              R(IJ)=0.
            ENDIF
20      CONTINUE
      ENDIF
C
C---- INITIAL AND FINAL NORMS (ANORM & ANRMX)
      IA=0
      ANORM=0.
      DO 35 I=1,N
        DO 35 J=1,I
          IA=IA+1
35        IF (J.NE.I) ANORM=ANORM+A(IA)**2
C
      IF (ANORM.LE.0.) GOTO 165
      ANORM=SQRT(2.*ANORM)
      ANRMX=ANORM*RANGE/N
C
C---- INITIALIZE INDICATORS AND COMPUTE THRESHOLD
      IND=0
      THR=ANORM
45    THR=THR/N
50    L=1
55    LQ=L*(L-1)/2
      LL=L+LQ
      M=L+1
      ILQ=N*(L-1)
C
C---- COMPUTE SIN & COS
60    MQ=M*(M-1)/2
      LM=L+MQ
      IF (ABS(A(LM))-THR.LT.0.) GOTO 130
      IND=1
      MM=M+MQ
      X=.5*(A(LL)-A(MM))
      Y=-A(LM)/SQRT(A(LM)**2+X*X)
      IF (ABS(Y).GT.1.0) Y=SIGN(1.0,Y)
      IF (X.LT.0.) Y=-Y
      SINX=Y/SQRT(2.*(1.+(SQRT(1.-Y*Y))))
      SINX2=SINX**2
      COSX=SQRT(1.-SINX2)
      COSX2=COSX**2
      SINCS=SINX*COSX
C
C---- ROTATE L & M COLUMNS
      IMQ=N*(M-1)
      DO 125 I=1,N
        IQ=I*(I-1)/2
        IF (I.NE.L .AND. I.NE.M) THEN
          IF (I.LT.M) THEN
            IM=I+MQ
          ELSE
            IM=M+IQ
          ENDIF
          IF (I.LT.L) THEN
            IL=I+LQ
          ELSE
            IL=L+IQ
          ENDIF
          X=A(IL)*COSX-A(IM)*SINX
          A(IM)=A(IL)*SINX+A(IM)*COSX
          A(IL)=X
        ENDIF
        IF (MV.EQ.0) THEN
          ILR=ILQ+I
          IMR=IMQ+I
          X=R(ILR)*COSX-R(IMR)*SINX
          R(IMR)=R(ILR)*SINX+R(IMR)*COSX
          R(ILR)=X
        ENDIF
125   CONTINUE
C
      X=2.*A(LM)*SINCS
      Y=A(LL)*COSX2+A(MM)*SINX2-X
      X=A(LL)*SINX2+A(MM)*COSX2+X
      A(LM)=(A(LL)-A(MM))*SINCS+A(LM)*(COSX2-SINX2)
      A(LL)=Y
      A(MM)=X
C
C---- TESTS FOR COMPLETION
C---- TEST FOR M = LAST COLUMN
130   IF (M.NE.N) THEN
        M=M+1
        GOTO 60
      ENDIF
C
C---- TEST FOR L =PENULTIMATE COLUMN
      IF (L.NE.N-1) THEN
        L=L+1
        GOTO55
      ENDIF
      IF (IND.EQ.1) THEN
        IND=0
        GOTO50
      ENDIF
C
C---- COMPARE THRESHOLD WITH FINAL NORM
      IF (THR.GT.ANRMX) GOTO 45
165   RETURN
      END

C ===================================
C----linalgebra_block
C Subroutines and functions to deal with problems of linear algebra
C
C  Strange eanough it begins with singular value decomposition.
C  But I need it now.
C
      SUBROUTINE SVDCMP(A,M,N,MP,NP,W,V,IERR)

C----This subroutine makes singular value decomposition
C----as   A = U.W.VT
C----See Press, Flannery, Teukolsky, Vettering  Numerical recipes
C----M and N are physical sizes of matrix MP and NP are logical
C---sizes. M >= N. Otherwise routine will fail
C---Note: Output is VT but not V
C---A will be destroyed and replaced by U
C
      PARAMETER (NMAX = 1000)
      REAL A(MP,NP),W(NP),V(NP,NP),RV1(NMAX)
      CHARACTER LINE*80,CHAR4*4
C
      IERR =0
C      IF(M.LT.N) CALL ERRWRT(1,'SVDMP: M Should be > N')
      IF(M.LT.N) THEN
        MDOC = 0
        CALL MSGERR(MDOC,' ERROR in SVDMP: M Should be > N')
        IERR=1
        RETURN
      ENDIF
      G     = 0.0
      SCALE = 0.0
      ANORM = 0.0
      NCONV = 50
      DO   I=1,N
        L      = I+1
        RV1(I) = SCALE*G
        G      = 0.0
        S      = 0.0
        SCALE  = 0.0
        IF(I.LE.M) THEN
          DO   K=I,M
            SCALE = SCALE+ABS(A(K,I))
          ENDDO
          IF(SCALE.NE.0.0) THEN
            DO    K=I,M
              A(K,I) = A(K,I)/SCALE
              S      = S + A(K,I)*A(K,I)
            ENDDO
            F = A(I,I)
            G = -SIGN(SQRT(S),F)
            H = F*G-S
            A(I,I) = F-G
            DO   J=L,N
              S = 0.0
              DO   K=I,M
                S = S+A(K,I)*A(K,J)
              ENDDO
              F = S/H
              DO    K=I,M
                A(K,J) =A(K,J)+F*A(K,I)
              ENDDO
            ENDDO
            DO   K=I,M
              A(K,I) = SCALE*A(K,I)
            ENDDO
          ENDIF
        ENDIF
        W(I)  = SCALE*G
        G     = 0.0
        S     = 0.0
        SCALE = 0.0
        IF((I.LE.M).AND.(I.NE.N)) THEN
          DO   K=L,N
            SCALE = SCALE+ABS(A(I,K))
          ENDDO
          IF(SCALE.NE.0.0) THEN
            DO   K=L,N
              A(I,K) = A(I,K)/SCALE
              S      = S + A(I,K)*A(I,K)
            ENDDO
            F = A(I,L)
            G = -SIGN(SQRT(S),F)
            H = F*G-S
            A(I,L) = F-G
            DO   K=L,N
              RV1(K) = A(I,K)/H
            ENDDO
            DO   J=L,M
              S = 0.0
              DO   K=L,N
                S = S+A(J,K)*A(I,K)
              ENDDO
              DO   K=L,N
                A(J,K) = A(J,K)+S*RV1(K)
              ENDDO
            ENDDO
            DO    K=L,N
              A(I,K) = SCALE*A(I,K)
            ENDDO
          ENDIF
        ENDIF
        ANORM = MAX(ANORM,(ABS(W(I))+ABS(RV1(I))))
      ENDDO
C
C Accumulation of right hand transformation
C
      DO   I=N,1,-1
        IF(I.LT.N) THEN
          IF(G.NE.0.0) THEN
            DO   J=L,N
C
C   Doulde division to avoid underflow (????
C
              V(J,I) = (A(I,J)/A(I,L))/G
            ENDDO
            DO   J=L,N
              S = 0.0
              DO   K=L,N
                S = S+A(I,K)*V(K,J)
              ENDDO
              DO   K=L,N
                V(K,J) = V(K,J)+S*V(K,I)
              ENDDO
            ENDDO
          ENDIF
          DO   J=L,N
            V(I,J) = 0.0
            V(J,I) = 0.0
          ENDDO
        ENDIF
        V(I,I) = 1.0
        G      = RV1(I)
        L      = I
      ENDDO
C
C Accumulation of left hand transformation
C
      DO    I=min(m,N),1,-1 
        L = I+1
        G = W(I)
        DO  J=L,N
          A(I,J) = 0.0
        ENDDO 
        IF(G.NE.0.0) THEN
          G = 1.0/G
          DO   J=L,N
            S = 0.0
            DO   K=L,M
              S=S+A(K,I)*A(K,J)
            ENDDO
            F = (S/A(I,I))*G
            DO    K=I,M
              A(K,J) = A(K,J)+F*A(K,I)
            ENDDO
          ENDDO 
          DO    J=I,M
            A(J,I) = A(J,I)*G
          ENDDO
        ELSE
          DO    J=I,M
            A(J,I) = 0.0
          ENDDO
        ENDIF
        A(I,I) = A(I,I)+1.0
      ENDDO
C
C  Diagonalisation fo bidiagonal form
C
      DO   K=N,1,-1
C
C  Loop over singular values
C
        DO   ITS=1,30
C
C Loop over iteration. 
C
          DO    L=K,1,-1
C
C  Test for splitting
C
            NM = L-1
            IF((ABS(RV1(L))+ANORM).EQ.ANORM) GOTO 2
            IF((ABS(W(NM))+ANORM).EQ.ANORM) GOTO 1
          ENDDO
 1        C = 0.0
          S = 1.0
          DO   I=L,K
            F = S*RV1(I)
            rv1(i)=c*rv1(i)
            IF((ABS(F)+ANORM).eq.ANORM) goto 2
            G = W(I)
            h = pythag(f,g)
            W(I) = H
            H = 1.0/H
            C = G*H
            S = -F*H
            DO    J=1,M
              Y = A(J,NM)
              Z = A(J,I)
              A(J,NM) = (Y*C)+(Z*S)
              A(J,I)  = -(Y*S)+(Z*C)
            ENDDO
          ENDDO
 2        Z = W(K)
          IF(L.EQ.K) THEN
            IF(Z.LT.0.0) THEN
              W(K) = -Z
              DO   J=1,N
                V(J,K) = -V(J,K)
              ENDDO
            ENDIF
            GOTO 3
          ENDIF
C          IF(ITS.EQ.30) 
C     .        CALL ERRWRT(-1,
C     .         'SVDCMP: No convergence in 30 iterations')
          IF(ITS.EQ.NCONV) THEN
            MDOC = 0
C            WRITE(CHAR4,'(I4)') NCONV
C            LINE = ' ERROR in SVDCMP(rbfft): No convergence in'
C     *             //CHAR4//' iterations'
C            CALL MSGERR(0,
C     *         ' ERROR in SVDCMP: No convergence in 30 iterations')
c            CALL MSGERR(MDOC,
c     *     ' ERROR in SVDCMP: No convergence in 30 iterations')
            IERR=2
            RETURN
          ENDIF
          X = W(L)
          NM= K-1
          Y = W(NM)
          G = RV1(NM)
          H = RV1(K)
          F = ((Y-Z)*(Y+Z)+(G-H)*(G+H))/(2.0*H*Y)
          g = pythag(f,1.0)
c         G = SQRT(F*F+1.0)
          F = ((X-Z)*(X+Z)+H*((Y/(F+SIGN(G,F)))-H))/X
C
C  Next QR transformation
C
          C = 1.0
          S = 1.0
          DO   J=L,NM
            I = J+1
            G = RV1(I)
            Y = W(I)
            H = S*G
            G = C*G
            z = pythag(f,h)
c           Z = SQRT(F*F+H*H)
            RV1(J) = Z
            C = F/Z
            S = H/Z
            F =  X*C+G*S
            G = -X*S+G*C
            H = Y*S
            Y = Y*C
            DO   JJ=1,N
              X = V(JJ,J)
              Z = V(JJ,I)
              V(JJ,J) =  (X*C)+(Z*S)
              V(JJ,I) = -(X*S)+(Z*C)
            ENDDO
            z = pythag(f,h)
c           Z = SQRT(F*F+H*H)
            W(J) = Z
            IF(Z.NE.0.0) THEN
              Z = 1.0/Z
              C = F*Z
              S = H*Z
            ENDIF
            F =  C*G+S*Y
            X = -S*G+C*Y
            DO   JJ=1,M
              Y = A(JJ,J)
              Z = A(JJ,I)
              A(JJ,J) =   (Y*C)+(Z*S)
              A(JJ,I) =  -(Y*S)+(Z*C)
            ENDDO
          ENDDO
          RV1(L) = 0.0
          RV1(K) = F
          W(K)   = X
        ENDDO
 3      CONTINUE
      ENDDO
      RETURN
      END      
C
       function pythag(a,b)
       real a,b,pythag
       real absa, absb
       absa = abs(a)
       absb = abs(b)
       if(absa.gt.absb) then
         pythag = absa*sqrt(1.+(absb/absa)**2)
       else
         if(absb.eq.0.0) then
           pythag = 0.0
         else
           pythag = absb*sqrt(1.+(absa/absb)**2)
         endif
       endif
       return
       end
C

      SUBROUTINE SVDCMP_old(A,M,N,MP,NP,W,V,IERR)

C----This subroutine makes singular value decomposition
C----as   A = U.W.VT
C----See Press, Flannery, Teukolsky, Vettering  Numerical recipes
C----M and N are physical sizes of matrix MP and NP are logical
C---sizes. M >= N. Otherwise routine will fail
C---Note: Output is VT but not V
C---A will be destroyed and replaced by U
C
      PARAMETER (NMAX = 1000)
      REAL A(MP,NP),W(NP),V(NP,NP),RV1(NMAX)
C
C      IF(M.LT.N) CALL ERRWRT(1,'SVDMP: M Should be > N')
      IF(M.LT.N) THEN
C        CALL MSGERR(0,' ERROR in SVDMP: M Should be > N')
        IERR=1
        RETURN
      ENDIF
      G     = 0.0
      SCALE = 0.0
      ANORM = 0.0
      DO   I=1,N
        L      = I+1
        RV1(I) = SCALE*G
        G      = 0.0
        S      = 0.0
        SCALE  = 0.0
        IF(I.LE.M) THEN
          DO   K=I,M
            SCALE = SCALE+ABS(A(K,I))
          ENDDO
          IF(SCALE.NE.0.0) THEN
            DO    K=I,M
              A(K,I) = A(K,I)/SCALE
              S      = S + A(K,I)*A(K,I)
            ENDDO
            F = A(I,I)
            G = -SIGN(SQRT(S),F)
            H = F*G-S
            A(I,I) = F-G
            IF(I.NE.N) THEN
              DO   J=L,N
                S = 0.0
                DO   K=I,M
                  S = S+A(K,I)*A(K,J)
                ENDDO
                F = S/H
                DO    K=I,M
                  A(K,J) =A(K,J)+F*A(K,I)
                ENDDO
              ENDDO
            ENDIF
            DO   K=I,M
              A(K,I) = SCALE*A(K,I)
            ENDDO
          ENDIF
        ENDIF
        W(I)  = SCALE*G
        G     = 0.0
        S     = 0.0
        SCALE = 0.0
        IF((I.LE.M).AND.(I.NE.N)) THEN
          DO   K=L,N
            SCALE = SCALE+ABS(A(I,K))
          ENDDO
          IF(SCALE.NE.0.0) THEN
            DO   K=L,N
              A(I,K) = A(I,K)/SCALE
              S      = S + A(I,K)*A(I,K)
            ENDDO
            F = A(I,L)
            G = -SIGN(SQRT(S),F)
            H = F*G-S
            A(I,L) = F-G
            DO   K=L,N
              RV1(K) = A(I,K)/H
            ENDDO
            IF(I.NE.M) THEN
              DO   J=L,M
                S = 0.0
                DO   K=L,N
                  S = S+A(J,K)*A(I,K)
                ENDDO
                DO   K=L,N
                  A(J,K) = A(J,K)+S*RV1(K)
                ENDDO
              ENDDO
            ENDIF
            DO    K=L,N
              A(I,K) = SCALE*A(I,K)
            ENDDO
          ENDIF
        ENDIF
        ANORM = MAX(ANORM,(ABS(W(I))+ABS(RV1(I))))
      ENDDO
C
C Accumulation of right hand transformation
C
      DO   I=N,1,-1
        IF(I.LT.N) THEN
          IF(G.NE.0.0) THEN
            DO   J=L,N
C
C   Doulde division to avoid underflow (????
C
              V(J,I) = A(I,J)/A(I,L)/G
            ENDDO
            DO   J=L,N
              S = 0.0
              DO   K=L,N
                S = S+A(I,K)*V(K,J)
              ENDDO
              DO   K=L,N
                V(K,J) = V(K,J)+S*V(K,I)
              ENDDO
            ENDDO
          ENDIF
          DO   J=L,N
            V(I,J) = 0.0
            V(J,I) = 0.0
          ENDDO
        ENDIF
        V(I,I) = 1.0
        G      = RV1(I)
        L      = I
      ENDDO
C
C Accumulation of left hand transformation
C
      DO    I=N,1,-1
        L = I+1
        G = W(I)
        IF(I.LT.N) THEN
          DO  J=L,N
            A(I,J) = 0.0
          ENDDO
        ENDIF
        IF(G.NE.0.0) THEN
          G = 1.0/G
          IF(I.NE.N) THEN
            DO   J=L,N
              S = 0.0
              DO   K=L,M
                S=S+A(K,I)*A(K,J)
              ENDDO
              F = (S/A(I,I))*G
              DO    K=I,M
                A(K,J) = A(K,J)+F*A(K,I)
              ENDDO
            ENDDO
          ENDIF
          DO    J=I,M
            A(J,I) = A(J,I)*G
          ENDDO
        ELSE
          DO    J=I,M
            A(J,I) = 0.0
          ENDDO
        ENDIF
        A(I,I) = A(I,I)+1.0
      ENDDO
C
C  Diagonalisation fo bidiagonal form
C
      DO   K=N,1,-1
C
C  Loop over singular values
C
        DO   ITS=1,30
C
C Loop over iteration. 
C
          DO    L=K,1,-1
C
C  Test for splitting
C
            NM = L-1
            IF(ABS(RV1(L))+ANORM.EQ.ANORM) GOTO 2
            IF(ABS(W(NM))+ANORM.EQ.ANORM) GOTO 1
          ENDDO
 1        C = 0.0
          S = 1.0
          DO   I=L,K
            F = S*RV1(I)
            IF(ABS(F)+ANORM.NE.ANORM) THEN
              G = W(I)
              H = SQRT(F*F+G*G)
              W(I) = H
              H = 1.0/H
              C = G*H
              S = -F*H
              DO    J=1,M
                Y = A(J,NM)
                Z = A(J,I)
                A(J,NM) = Y*C+Z*S
                A(J,I)  = -Y*S+Z*C
              ENDDO
            ENDIF
          ENDDO
 2        Z = W(K)
          IF(L.EQ.K) THEN
            IF(Z.LT.0.0) THEN
              W(K) = -Z
              DO   J=1,N
                V(J,K) = -V(J,K)
              ENDDO
            ENDIF
            GOTO 3
          ENDIF
C          IF(ITS.EQ.30) 
C     .        CALL ERRWRT(-1,
C     .         'SVDCMP: No convergence in 30 iterations')
          IF(ITS.EQ.30) THEN
C            CALL MSGERR(0,
C     *         ' ERROR in SVDCMP: No convergence in 30 iterations')
            IERR=1
            RETURN
          ENDIF
          X = W(L)
          NM= K-1
          Y = W(NM)
          G = RV1(NM)
          H = RV1(K)
          F = ((Y-Z)*(Y+Z)+(G-H)*(G+H))/(2.0*H*Y)
          G = SQRT(F*F+1.0)
          F = ((X-Z)*(X+Z)+H*((Y/(F+SIGN(G,F)))-H))/X
C
C  Next QR transformation
C
          C = 1.0
          S = 1.0
          DO   J=L,NM
            I = J+1
            G = RV1(I)
            Y = W(I)
            H = S*G
            G = C*G
            Z = SQRT(F*F+H*H)
            RV1(J) = Z
            C = F/Z
            S = H/Z
            F =  X*C+G*S
            G = -X*S+G*C
            H = Y*S
            Y = Y*C
            DO   JJ=1,N
              X = V(JJ,J)
              Z = V(JJ,I)
              V(JJ,J) =  X*C+Z*S
              V(JJ,I) = -X*S+Z*C
            ENDDO
            Z = SQRT(F*F+H*H)
            W(J) = Z
            IF(Z.NE.0.0) THEN
              Z = 1.0/Z
              C = F*Z
              S = H*Z
            ENDIF
            F =  C*G+S*Y
            X = -S*G+C*Y
            DO   JJ=1,M
              Y = A(JJ,J)
              Z = A(JJ,I)
              A(JJ,J) =   Y*C+Z*S
              A(JJ,I) =  -Y*S+Z*C
            ENDDO
          ENDDO
          RV1(L) = 0.0
          RV1(K) = F
          W(K)   = X
        ENDDO
 3      CONTINUE
      ENDDO
      RETURN
      END      
C
      SUBROUTINE SVBKSB(U,W,V,M,N,MP,NP,B,X)
C
C  Solves AX = B. A should be decomposed by SVDCMP subrouitne
C  A = U.W.VT
C
      PARAMETER (NMAX = 1000)
      REAL U(MP,NP),W(NP),V(NP,NP),B(NP),X(NP),TMP(NMAX)
C
C Calculate Ut.B
C
      DO   J=1,N
        S = 0.0
        IF(W(J).NE.0.0) THEN
          DO   I=1,M
            S = S+U(I,J)*B(I)
          ENDDO
          S = S/W(J)
        ENDIF
        TMP(J) = S
      ENDDO
C
C Multiply by V to get answer
C
      DO   J=1,N
        S = 0.0
        DO   JJ=1,N
          S = S+V(J,JJ)*TMP(JJ)
        ENDDO
        X(J) = S
      ENDDO
      RETURN
      END
C
      SUBROUTINE SVSOLV(A,M,N,MP,NP,B,X,IERR)
C
C   Solve Ax=B by calling singular value decomposition 
C   subroutines
C
C//////      INCLUDE 'const.fh'
      PARAMETER (NMAX = 1000)
      REAL A(MP,NP),B(NP),X(NP),WV(NMAX+NMAX*NMAX)
      DATA TOL/1.0E-7/
      IERR=0
C
C---First call SVDCMP to decompose A = U.W.Vt
C
      CALL SVDCMP(A,M,N,MP,NP,WV(1),WV(NMAX+1),IERR)
      IF(IERR.NE.0) RETURN
C  
C  Now edit W-s
C
      WMAX = 0.0
      DO    I=1,N
        IF(WMAX.LT.WV(I)) WMAX = WV(I)
      ENDDO
      WMIN = WMAX*TOL
      DO   I=1,N
        IF(WV(I).LT.WMIN) THEN
cd          WRITE(LINE,'(A,I5)')
cd     .      ' Singular values for parameter',I
cd          CALL ERRWRT(0,LINE)
          WV(I) = 0.0
        ENDIF
      ENDDO
C
C--Now call SVBKSB to solve equation
C
      CALL SVBKSB(A,WV(1),WV(NMAX+1),M,N,MP,NP,B,X)
      RETURN
      END
C
      SUBROUTINE SVDVAR(V,MA,W,CVM,NCVM)
C
C---Evaluation of covariance matrix after using singular
C---value decomposition. Parameters with singular contribution
C---to matrix will have 0.0 variance.
C
      PARAMETER (NMAX = 1000)
      REAL V(MA,MA),W(MA),CVM(NCVM,NCVM),WTI(NMAX)
C
      DO   I=1,MA
        WTI(I) = 0.0
        IF(W(I).NE.0.0) WTI(I) = 1.0/(W(I)*W(I))
      ENDDO
      DO   I=1,MA
        DO   J=1,I
          SUM = 0.0
          DO    K=1,MA
            SUM = SUM + V(I,K)*V(J,K)*WTI(K)
          ENDDO
          CVM(I,J) = SUM
          CVM(J,I) = SUM
        ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE F2CIF(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
     *        ,CFOM,CFREE,CSIG
     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ----------------------------------------------------
C -P- 
C F2CIF    writes a contents of internal BLANC files: Fobs, Fcalc, Phases 
C          to one output formatted CIFile. The exit from program suite BLANC.
C -S-
C          This program reads contents of files: 
C                 Fobs              or  
C                 Fobs and Fcalc    or
C                 Fobs and Phases   or  
C                 Fobs and Fcalc and Phases
C          and writes to one formatted output file ( format CIF). 
C
C   Dialogue and Batch:
C  
C     FILE_F:  - input file_Fobs  of the modules of structure factors.
C     FILE_C:  - input file_Fcalc of the modules of structure factors.
C     FILE_PH: - input file_Phases.
C     RESOL: MIN,MAX - resolution <default from files>
C     FOM:   <Y>,N   - Y means to write FOM'
C     FREE:  <Y>,N   - Y means to write FREE-flag'
C     SIG:   <Y>,N   - Y means to write sigmas of F'
C     FILE_O: <f2cif.cif> - output_file 
C
C  Parameters of subroutine F2CIF: 
C
C      SUBROUTINE F2CIF(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
C     *        ,CFOM,CFREE,CSIG
C     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C    MDOC   - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    F_NAME:  - input file_Fobs  of the modules of structure factors.
C    F2_NAME: - input file_Fcalc of the modules of structure factors.
C    PH_NAME: - input file_Phases.
C    RESMINR: - resolution <default from files>
C    RESMAXR:  
C    CFOM:  /character*1/ <Y>,N   - Y means to write FOM'
C    CFREE: /character*1/ <Y>,N   - Y means to write FREE-flag'
C    CSIG:  /character*1/ <Y>,N   - Y means to write sigmas of F'
C    FO_NAME:        - output_file /" " means without output/
C    ISYM     - integer*2 array for cryst.symmetry operators.
C    IPRSYM   - dimension of integer*2 array ISYM(5,3,IPRSYM),
C               number of cryst. symm. operators.
C    IERR     - output signal of error / = 1 -error , = 0 - OK / 
C
C    RESULT /real RESULT(IPRROW)/ - array for output information:
C
C    RESULT(1) - 
C    RESULT(2) - 
C -I-
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
      INTEGER*4 MDOC,IERR
      CHARACTER F_NAME*(*),F2_NAME*(*),PH_NAME*(*),FO_NAME*(*),CFOM*1
      CHARACTER STAT*1,CFREE*1,CSIG*1
C ==============================
      REAL      RLATT(6)
      INTEGER*4 MTIN,MTNAT,MTOUT
      CHARACTER ITYPE*4,ITYP*4,ITF1*4,ITF2*4,ITF3*4,ITFW*4
      CHARACTER LINE*80,TTT*80,TTT1*80,TITLE*80,PATH*80,EXT*80
      CHARACTER LINE1*80
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR = 0
C
C     ITYP  ='FF  '  means 'F   ' or 'FS  '
C     ITYP  ='F   '
C     ITYP  ='FS  '
C     ITYP  ='    '  means ALL  
C     ITYP  ='ABCD'
C     ITYP  ='COEF'
C     ITYP  ='PH  '
C     ITYP  ='RI  '
C
C     Subroutine ORFILE returns actual type by ITYP
C

      MT1 = 20
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        IERR=1
        RETURN
      ENDIF
      ITYP = 'FF  '
C
C     ORFILE - 1.open file FNAME 
C              2.reads title of file,return file parameters,fill /COMRDF/.
C                copy file_parameters to /COMRDF/.
C
      CALL ORFILE(MD,MT1,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN FILE-F-1')
        RETURN
      ENDIF
C
C     GET_TITLE - gets information from /COMRDF/
C
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RN,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      ITF1 = ITYP
C
C     for 'COEF':   TITLE(1:4)='FOUR' or 'PATT'
C
C -------------------------------------------------------------
C
C     C_RD_CR - copy parameters from common/COMRDF/ to common/CRYSTL/
C               also using CELL parameters from common/CRYSTL/ calculates
C               reciprocal cell parameters and volume and put its 
C               to common/CRYSTL/
C               
      CALL C_RD_CR
C -------------------------------------------------------------
      MT2   = 21
      ITYPE = 'FF  '
      CALL LENSTR_BL(F2_NAME,LEN)
      IF(LEN.LE.0.OR.F2_NAME(1:1).EQ.' '.OR.F2_NAME(1:1).EQ.',') THEN
        MT2=0
      ELSE
        CALL ORFILE(MD,MT2,F2_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A1,B1,C1,AL1,BE1,GA1
     *  ,DM1,DM2,RN1,RX1,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
        ITF2=ITYPE
      ENDIF
C ------------------
      MT3   = 22
      ITYPE = 'PH  '
      CALL LENSTR_BL(PH_NAME,LEN)
      IF(LEN.LE.0.OR.PH_NAME(1:1).EQ.' '.OR.PH_NAME(1:1).EQ.',') THEN
        MT3=0
      ELSE
        CALL ORFILE(MD,MT3,PH_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-PH')
          CLOSE(MT1)
          IF(MT2.GT.0) CLOSE(MT2)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A2,B2,C2,AL2,BE2,GA2
     *  ,DM1,DM2,RN2,RX2,IDM,IDM,IDM,IDM,IDM,TTT1,IERR)
        ITF3=ITYPE
      ENDIF
C -----------------
      IF(CFOM .EQ.'n') CFOM  = 'N'
      IF(CFOM .NE.'N') CFOM  = 'Y'
      IF(CFREE.EQ.'n') CFREE = 'N'
      IF(CFREE.NE.'N') CFREE = 'Y'
      IF(CSIG .EQ.'n') CSIG  = 'N'
      IF(CSIG .NE.'N') CSIG  = 'Y'
C ---
      RESMIN = RESMINR
      RESMAX = RESMAXR
      IF(RESMIN.LE.0.0)   RESMIN = RN
      IF(RESMAX.LE.0.0)   RESMAX = RX
      IF(RN .LT.RESMIN)   RESMIN = RN
      IF(RX .GT.RESMAX)   RESMAX = RX
      IF(MT2.GT.0) THEN
        IF(RN1.LT.RESMIN)   RESMIN = RN1
        IF(RX1.GT.RESMAX)   RESMAX = RX1
      ENDIF
      IF(MT3.GT.0) THEN
        IF(RN2.LT.RESMIN)   RESMIN = RN2
        IF(RX2.GT.RESMAX)   RESMAX = RX2
      ENDIF
      WRITE(LINE,'(''RESOLUTION MIN,MAX '',2F7.2)') RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      RESMIN = RESMIN + 0.0001
      RESMAX = RESMAX - 0.0001
      RHMIN = 1.0/(RESMIN)
      RHMAX = 1.0/(RESMAX)
C ---------------
      MTOUT = 0
      CALL LENSTR_BL(FO_NAME,LEN)
      IF(LEN.GT.0.AND.FO_NAME(1:1).NE.' '.AND.FO_NAME(1:1).NE.',') THEN
        MTOUT=30


C ---
C       C_CR_WR - copy parameters from common/CRYSTL/ to common/COMWRF/
C
C        CALL C_CR_WR
C ---
C       SET_TITLE - sets information to  /COMWRF/
C 
C        CALL SET_TITLE(MD,A,B,C,
C     *  AL,BE,GA,COEF1,BET1,RESMIN,RESMAX,
C     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
C        ITFW = 'F   '
C
C       OWFILE - 1.open file 
C                2.writes title to file, parameters from common /COMRDF/
C
C        CALL OWFILE(MD,MTOUT,FO_NAME,ITFW,NSYM,ISYM,IPRSYM,IERR)

        PATH  = ' '
        EXT   = ' '      
        CALL OPENFW(MTOUT,MD,PATH,FO_NAME,EXT,IERR)
        IF(IERR.NE.0) THEN
          CLOSE (MT1)
          IF(MT2.GT.0) CLOSE (MT2)
          IF(MT3.GT.0) CLOSE (MT3)
          CALL MSGERR(MDOC,' ERR: OPEN FILE-OUTPUT')
          IERR=1
          RETURN
        ENDIF

        CALL WR_TITLE_CIF(M,MTOUT,ITYP,TITLE
     *   ,MT2,MT3,CSIG,CFOM,CFREE
     *   ,NSYM,ISYM,IPRSYM,IERR)

      ENDIF
C ----------------------------------------------------------
      RLATT(1) = A
      RLATT(2) = B
      RLATT(3) = C
      RLATT(4) = AL
      RLATT(5) = BE
      RLATT(6) = GA
      CALL DSTARF(RLATT,AS,BS,CS,ALS,BES,GAS,VOL)
C ---
C 
C     initialization for CENTR_BL and ANOMSC
C
      CALL INIT_CENTR(NSYM,ISYM)
      CALL ANOMF(M,NSYM,ISYM)
C
C     calc limits H,k,l and grid for RESMAX
C
      RES = RESMAX

      CALL LIMHKL(RES,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
      
      SUMA   = 0.0
      SUMB   = 0.0
      SUMFOM = 0.0
      NTOT   = 0
C ----
      IEND1 =-1
      IEND2 =-1
      IEND3 =-1
      IENDW =-1
      JH    =-200
      JK    =-200
      JL    =-200
      KH    =-200
      KK    =-200
      KL    =-200
      LH    =-200
      LK    =-200
      LL    =-200
C -----------------------------------------
      DO     IL=0,ILMAX
      DO     IK=-IKMAX,IKMAX
      DO     IH=-IHMAX,IHMAX
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 100
        IHP = IH
        IKP = IK
        ILP = IL
C
C        ANOMSC - transforms h,k,l to asymmetrycal part of reciprocal space.
C        output : IH,IK,IL -   indices h,k,l from asymmetrycal part
C                 IANOM    - 0   +h,+k,+l
C                            1   -h,-k,-l
C                 JJSYM    - number operator of symmetry :
C                                 in(h,k,l) -- JJSYM --> out(h,k,l)
C
        CALL ANOMSC(IHP,IKP,ILP,IANOM,JJSYM,NSYM,ISYM)
        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 100

        IF(NSYM.GT.1) THEN
C
C         SYSABS - check systematic absent for h,k,l: 1 - absent, 0 - no.
C
          CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        ELSE
          ICND = 0
        ENDIF
C
C ---   ICND NE 0 systematic absent
C
        IF(ICND.NE.0) GO TO 100
C 
C       DSTAR - gives value of (4pi*sin(theta))/lambda for H,K,L
C
        CALL DSTAR_BL(IH,IK,IL,RSQ)
        RH = SQRT(RSQ)
c        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 100
C ---
C       CENTR_BL - Determine whether a reflection (IH,IK,IL) is centric or not

        CALL CENTR_BL(IH,IK,IL,JCENT)
C
C ---   JCENT = 1 centric reflection, JCENT = 0 acentric reflection
C ---
C ------
  200   CONTINUE
        IMISS1 = 1
        IF(IEND1.GT.0)                    GO TO 110

C        IF(JL-IL) 240,210,300
C  210   IF(JK-IK) 240,220,300
C  220   IF(JH-IH) 240,230,300

        IF((JL-IL).LT.0) THEN
          GO TO 240
        ELSE IF((JL-IL).EQ.0) THEN
          GO TO 210
        ELSE 
          GO TO 100
        ENDIF

 210    IF((JK-IK).LT.0) THEN
          GO TO 240
        ELSE IF((JK-IK).EQ.0) THEN
          GO TO 220
        ELSE 
          GO TO 100
        ENDIF

 220    IF((JH-IH).LT.0) THEN
          GO TO 240
        ELSE IF((JH-IH).EQ.0) THEN
          GO TO 230
        ELSE 
          GO TO 100
        ENDIF

C ------
  240   CONTINUE
C
C        RD1 - read from MT1 ; type of file :"F   ","PH  ","COEF","ALMN"
C        RRD1- read from MT1 ; type of file :"FS  "
C 
        IF(ITF1.EQ.'FS  ') THEN
          CALL RRD1(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
        ELSE
          CALL RD1(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C
C        IF(ITF2.EQ.'COEF') THEN
C          CALL RD1(MT1,JH,JK,JL,FA,FB,KEY1,IEND1)
C        IF(ITF2.EQ.'ABCD') THEN
c          CALL RABCD(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C        IF(ITF2.EQ.'PH  ') THEN
c          CALL RD1(MT1,JH,JK,JL,COSFOM,SINFOM,KEY1,IEND1)
C
C Possible to use:
C          CALL RD(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD2(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD2(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD3(MT1,JH,JK,JL,FN,FNA,NUMB,IEND)
C          CALL RRD3(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD4(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD4(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RABCD1(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C

C         SIG-DUMMY
          SN  = 0.04*FN
          SNA = 0.04*FNA
        ENDIF

        IT1 = KEY1/2        
        IFLAG_FREE = KEY1 - IT1*2 
        IT3  = IT1/2
        IT3  = IT3-IT1*2
C       if IFLAG_FREE = 1 - free reflection
C       use program COPYFL to set "free flag".
        STAT = 'o'
        IF(IFLAG_FREE.EQ.1) STAT = 'f'
        IF(IT3       .EQ.1) STAT = 'r'


 
        IF(MT1.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_1')
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND1.GT.0)                   GO TO 110
        IF(FN.LE.1.E-6.AND.FNA.LE.1.E-6) GO TO 100
        IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
          WT1 = 1./(SN*SN)
          WT2 = 1./(SNA*SNA)
          WT  = WT1+WT2
          FN  = FN*WT1+FNA*WT2
          FN  = FN/WT
          SN  = 1./SQRT(WT)
        ELSE IF(FNA.GT.1.E-6) THEN
          FN = FNA
          SN = SNA
        ENDIF
        GO TO 200

  230   IMISS1 = 0
C ------
  300   CONTINUE
        IMISS2=1
        IF(IEND2.LT.0.AND.MT2.LE.0)                   GO TO 400
        IF(IEND2.GT.0.OR.MT2.LE.0)                    GO TO 110

C        IF(KL-IL) 340,310,400
C  310   IF(KK-IK) 340,320,400
C  320   IF(KH-IH) 340,330,400

        IF((KL-IL).LT.0) THEN
          GO TO 340
        ELSE IF((KL-IL).EQ.0) THEN
          GO TO 310
        ELSE 
          GO TO 100
        ENDIF

 310    IF((KK-IK).LT.0) THEN
          GO TO 340
        ELSE IF((KK-IK).EQ.0) THEN
          GO TO 320
        ELSE 
          GO TO 100
        ENDIF

 320    IF((KH-IH).LT.0) THEN
          GO TO 340
        ELSE IF((KH-IH).EQ.0) THEN
          GO TO 330
        ELSE 
          GO TO 100
        ENDIF

C ------
  340   CONTINUE
        IF(ITF2.EQ.'FS  ') THEN
          CALL RRD2(MT2,KH,KK,KL,FD,FDA,SF,SFA,KEY2,IEND2)
        ELSE
          CALL RD2(MT2,KH,KK,KL,FD,FDA,KEY2,IEND2)
C         SIG-DUMMY
          SF  = 0.04*FD
          SFA = 0.04*FDA
        ENDIF
        IF(MT2.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_2')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND2.GT.0)                   GO TO 110
        IF(FD.LE.1.E-6.AND.FDA.LE.1.E-6) GO TO 100
        IF(FD.GT.1.E-6.AND.FDA.GT.1.E-6) THEN
          WT1 = 1./(SF*SF)
          WT2 = 1./(SFA*SFA)
          WT  = WT1+WT2
          FD  = FD*WT1+FDA*WT2
          FD  = FD/WT
          SF  = 1./SQRT(WT)
        ELSE IF(FDA.GT.1.E-6) THEN
          FD = FDA
          SF = SFA
        ENDIF
        GO TO 300

  330   IMISS2 = 0
C --------------------------------------------
  400   CONTINUE

        IMISS3 = 1
        IF(IEND3.LT.0.AND.MT3.LE.0)                   GO TO 500
        IF(IEND3.GT.0.OR.MT3.LE.0)                    GO TO 110

        IF((LL-IL).LT.0) THEN
          GO TO 440
        ELSE IF((LL-IL).EQ.0) THEN
          GO TO 410
        ELSE 
          GO TO 100
        ENDIF

 410    IF((LK-IK).LT.0) THEN
          GO TO 440
        ELSE IF((LK-IK).EQ.0) THEN
          GO TO 420
        ELSE 
          GO TO 100
        ENDIF

 420    IF((LH-IH).LT.0) THEN
          GO TO 440
        ELSE IF((LH-IH).EQ.0) THEN
          GO TO 430
        ELSE 
          GO TO 100
        ENDIF
C ------
  440   CONTINUE
        CALL RD3(MT3,LH,LK,LL,COSFOM,SINFOM,KEY3,IEND3)
        IF(MT3.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_PH')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND3.GT.0)                   GO TO 110

        TEMP = (COSFOM*COSFOM+SINFOM*SINFOM)
        FOM  = SQRT(TEMP)
C       WRITE(*,*) FOM,TEMP
        IF(FOM.LE.0.00001) GO TO 440
        COPH = COSFOM/FOM
        SIPH = SINFOM/FOM
        IF(ABS(COPH).LT.1.E-5) THEN
          PHI = 90.
          IF(SIPH.LT.0.) PHI = PHI+180.
        ELSE
          PHI = (ATAN(SIPH/COPH))*57.29578
          IF(PHI.LT.0.) THEN
            IF(SIPH.LE.0.) THEN
              PHI = PHI + 360.
            ELSE
              PHI = PHI + 180.
            ENDIF
          ELSE IF(PHI.EQ.0.) THEN
            IF(COPH.LT.0.) PHI = PHI + 180.
          ELSE
            IF(SIPH.LE.0.) PHI = PHI + 180.
          ENDIF
        ENDIF
        IF(ABS(PHI-360.0).LT.0.0001) PHI = 0.0

C       SUMFOM = SUMFOM+FOM

        GO TO 400


  430   IMISS3 = 0
C --------------------------------------------
  500   CONTINUE
C -----------------------------------------------------
C       SUMFOM = SUMFOM+FOM

        NTOT = NTOT+1

C ---
        IF(MTOUT.GT.0) THEN
          IF(CSIG.EQ.'Y') THEN
            WRITE(LINE1,
     *      '(3I4,1X,F12.4,1X,F10.4)') 
     *      IH,IK,IL,FN,SN
          ELSE
            WRITE(LINE1,
     *      '(3I4,1X,F12.4)') 
     *      IH,IK,IL,FN
          ENDIF
          LINE = LINE1
          IF(MT2.GT.0) THEN
            IF(CSIG.EQ.'Y') THEN
              WRITE(LINE1,
     *        '(F12.4,1X,F10.4)') 
     *        FD,SF
            ELSE
              WRITE(LINE1,
     *        '(F12.4)') 
     *        FD
            ENDIF
            CALL LENSTR_BL(LINE ,LEN)
            CALL LENSTR_BL(LINE1,LEN1)
            LINE = LINE(1:LEN)//' '//LINE1(1:LEN1)
          ENDIF
          IF(MT3.GT.0) THEN
            IF(CFOM.EQ.'Y') THEN
              WRITE(LINE1,
     *        '(F8.3,1X,F6.3)') 
     *        PHI,FOM
            ELSE
              WRITE(LINE1,
     *        '(F8.3)') 
     *        PHI
            ENDIF
            CALL LENSTR_BL(LINE ,LEN)
            CALL LENSTR_BL(LINE1,LEN1)
            LINE = LINE(1:LEN)//' '//LINE1(1:LEN1)
          ENDIF
          IF(CFREE.EQ.'Y') THEN
            CALL LENSTR_BL(LINE ,LEN)
            LINE = LINE(1:LEN)//' '//STAT
          ENDIF
          CALL WRTSTR(MTOUT,M,LINE,IERR)
        ENDIF
C ----
 100  CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ---------------------------------------
  110 CONTINUE
      CLOSE (MT1)
      IF(MT2.GT.0) CLOSE (MT2)
      IF(MT3.GT.0) CLOSE (MT3)

      IF(MTOUT.GT.0) THEN
        IF(NTOT.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: number of reflections = 0')
          CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
C ---
        END FILE MTOUT
        CLOSE(MTOUT)
      ENDIF
C ----------------------------------------------
      RESULT(1) = NTOT
      RESULT(2) = RESMIN
      RESULT(3) = RESMAX
C -----------------------------------------------------------
      WRITE(LINE,1000) NTOT
 1000 FORMAT('Number or reflextions = ',I8)
      CALL MSGDOC(MDOC,LINE)
      RETURN
      END

      SUBROUTINE WR_TITLE_CIF(MDOC,IOUT,TYPE,STR
     * ,MT2,MT3,CSIG,CFOM,CFREE
     * ,NSYM,ISYM,NSMAX,IERR)
C ----------------------------------------------------------
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER TYPE*4,STR*(*)
C ------------------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*11,USER_TITLE*80
C -------
      CHARACTER LINE*80,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C ---
      CHARACTER SYMOP*24,CH10*10,CODE*8,TEMPER*5,WAVE*5,CODE_NDB*8
      CHARACTER TITLE*80,CSIG*1,CFOM*1,CFREE*1
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
C --------------------------------
       ICS_CATEGORY   = '_database_PDB.'
       ICS_CD_PDB     = 'code'
       ICS_NAME_PDB   = 'name'
       ICS_DATE_PDB   = 'date'
       ICS_TITLE      = 'compnd'
       ICS_RESL_PDB   = 'remark_resolution'
       ICS_RFAC_PDB   = 'remark_R_factor'
       ICS_MODEL      = 'model'
C
       ICS_CELL(1)    = '_cell.length_a'
       ICS_CELL(2)    = '_cell.length_b'
       ICS_CELL(3)    = '_cell.length_c'
       ICS_CELL(4)    = '_cell.angle_alpha'
       ICS_CELL(5)    = '_cell.angle_beta'
       ICS_CELL(6)    = '_cell.angle_gamma'
C
       ICS_SPGR       = '_symmetry.space_group_name_H-M'
       ICS_NSPGR      = '_symmetry.Int_Tables_number'
       ICS_SETT       = '_symmetry.cell_setting_number'
       ICS_SYMOP      = '_symmetry_equiv.pos_as_xyz'
C
C --------------------------------
      CALL LENSTR_BL(USER_TITLE,LEN)
      IF(LEN.LT.9) THEN 
        TITLE = '?'
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.69) THEN 
        TITLE = USER_TITLE(9:68)
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.74) THEN 
        TITLE = USER_TITLE(9:68)
        WAVE  = USER_TITLE(69:73)
        TEMPER= '?'
      ELSE
        TITLE = USER_TITLE(9:68)
        WAVE  = USER_TITLE(69:73)
        TEMPER= USER_TITLE(74:78)
      ENDIF

      CALL LENSTR_BL(PDB_NAME,LEN)
      IF(LEN.LE.4) THEN
        CODE         ='XXXX    '
        CODE_NDB     ='?'
      ELSE
        IF(LEN.GT.12) LEN=12   
        CODE=PDB_NAME(5:LEN)
        CODE_NDB     = CODE
      ENDIF

      IF(CODE_NDB(1:4).EQ.PDB_CODE.AND.CODE_NDB(5:8).EQ.'    ')
     *  CODE_NDB='?'

      IF(CODE(1:1).EQ.'?'.OR.CODE(1:1).EQ.' '.OR.CODE(1:1).EQ.'.'.OR.
     *   CODE(1:4).EQ.'XXXX') THEN
        CODE    = PDB_CODE//'    '    
        CODE_NDB= '?'
      ENDIF

      CALL LENSTR_BL(CODE,LENCD)

      WRITE(LINE,'(''data_structure_'',A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        CALL LENSTR_BL(ICS_CATEGORY,LENC)
C ---
      WRITE(LINE,
     *'(''_database_2.database_id'',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(PDB_CODE,LEN)
      WRITE(LINE,
     *'(''_database_2.code_PDB   '',2X,A)') PDB_CODE(1:LEN)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      IF(CODE_NDB(1:1).NE.'?') THEN
        WRITE(LINE,
     *'(''_database_2.code_NDB   '',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      WRITE(LINE,'(''_struct_keywords.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(PDB_NAME,LEN)
      IF(LEN.LE.12) THEN
        PDB_NAME(13:13)='?'
        LEN=13
      ENDIF
      IF(LEN.GT.32) LEN=32
      WRITE(LINE,110) PDB_NAME(13:LEN)
  110 FORMAT(       
     * '_struct_keywords.text  ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_struct.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,200) TITLE(1:LEN)
  200 FORMAT(       '_struct.title   ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_database_PDB_rev.num 1'')') 
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL CHNG_DATE(PDB_DATE,CH10)

      WRITE(LINE,'(''_database_PDB_rev.date_original'',2X,A)') 
     * CH10(1:10)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      CALL CHCLOCK(CHAR20)
c      WRITE(LINE,210) CHAR20
c  210 FORMAT(       '_file_creation_date ',2X,'''',A,'''')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      CALL LENSTR_BL(TEMPER,LEN)
      IF(LEN.GT.0.AND.TEMPER(1:1).NE.'.'.AND.TEMPER(1:1).NE.' '.AND.
     *   TEMPER(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn.entry_id             '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,340) TEMPER(1:LEN)
  340   FORMAT('_diffrn.ambient_temperature    ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(WAVE,LEN)
      IF(LEN.GT.0.AND.WAVE(1:1).NE.'.'.AND.WAVE(1:1).NE.' '.AND.
     *   WAVE(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn_radiation.entry_id  '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,350) WAVE(1:LEN)
  350   FORMAT('_diffrn_radiation.wavelength  ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
        AL_CELL=AL_CELL/PI180
        BE_CELL=BE_CELL/PI180
        GA_CELL=GA_CELL/PI180
        WRITE(LINE,'(''_cell.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_a   '',2X,F8.3)') A_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_b   '',2X,F8.3)') B_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_c   '',2X,F8.3)') C_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_alpha'',2X,F8.3)') AL_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_beta '',2X,F8.3)') BE_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_gamma'',2X,F8.3)') GA_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.formula_units_Z  ?'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        WRITE(LINE,'(''_symmetry.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(SP_GROUP,LEN)
        WRITE(LINE,100)  SP_GROUP(1:LEN)
  100   FORMAT('_symmetry.space_group_name_H-M',2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C        WRITE(LINE,400)  NSP_GROUP
C  400   FORMAT('_symmetry.Int_Tables_number   ',2X,I5)
C        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C        WRITE(LINE,500)  N_SETT
C  500   FORMAT('_symmetry.cell_setting_number ',2X,I5)
C        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.pos_as_xyz'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ----------------------------------------
C --- SYM ---
      DO     I=1,NSYM
        LINE=' '
C        LINE(1:3)='SYM'
C        WRITE(CH3,'(I3)') I
C        LINE(4:4)=CH3(3:3)
C        LINE(5:5)=' '
        L=0
        DO J=1,3
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1.0
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I))
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          TR=ABS(TR)
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'
            L=L+2
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3'
            L=L+2
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'
            L=L+2
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF
          DO  K=1,3
            IDG=ISYM(K,J,I)
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO
          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO
        CALL LENSTR_BL(LINE,LEN)
        JL=0
        DO IL=1,LEN
          IF(LINE(IL:IL).NE.' ') THEN
            JL=JL+1
            LINE(JL:JL)=LINE(IL:IL)
          ENDIF
        ENDDO
        LEN=JL
        SYMOP = LINE(1:LEN)
        WRITE(LINE,510)  I,SYMOP(1:LEN)
  510   FORMAT('    ',I3,2X,A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDDO
C -------------------------
      WRITE(LINE,'(''loop_'')')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_h'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_k'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_l'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C -------------------------
      LINE='_refln.F_meas_au'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      IF(CSIG.EQ.'Y') THEN
        LINE='_refln.F_meas_sigma_au'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
      IF(MT2.GT.0) THEN
        LINE='_refln.F_calc'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CSIG.EQ.'Y') THEN
          LINE='_refln.F_sigma'
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
      ENDIF
      IF(MT3.GT.0) THEN
        LINE='_refln.phase_calc'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CFOM.EQ.'Y') THEN
          LINE='_refln.fom'
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
      ENDIF
      IF(CFREE.EQ.'Y') THEN
        LINE='_refln.status'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C -----------------------------------------
      RETURN
      END
